unit CompPhas;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Menus, ExtCtrls, Phasor, Utildef, routines, skemadef, CurrPhas,
  compdef, cmatmul, Buttons, imagodef, Clipbrd, JpgImg;

procedure ShowCompPhasors(ipComp : longint); far; {show currents as phasors}
procedure RemoveCompPhasor(ipComp : longint; info: string);far; {remove the component+phasor}
procedure RemoveCompPhasors;
procedure UpdateCompPhasors;                      {used in skemadef.pas}

type
  TCompPhasorForm = class(TForm)
    ResetBut: TButton;
    DecBut: TButton;
    IncBut: TButton;
    CurrPhasorImg: TImage;
    CurrentLabel: TLabel;
    OnOffPanel: TPanel;
    OnOffBox: TCheckBox;
    DeleteBut: TButton;
    ColorPanel: TPanel;
    ColorImage: TImage;
    CurrMenu: TMainMenu;
    FileItem: TMenuItem;
    BitmapItem: TMenuItem;
    ExitItem: TMenuItem;
    ViewItem: TMenuItem;
    ButItem: TMenuItem;
    PhaseItem: TMenuItem;
    SequenceItem: TMenuItem;
    BothItem: TMenuItem;
    OptionItem: TMenuItem;
    NoMultItem: TMenuItem;
    MultItem: TMenuItem;
    PhasorDialog: TSaveDialog;
    IDImage: TImage;
    CurrEdit: TEdit;
    ResetSeqBut: TButton;
    DecSeqBut: TButton;
    IncSeqBut: TButton;
    CurrSeqLabel: TLabel;
    CurrSeqImage: TImage;
    CurrSeqEdit: TEdit;
    LabelItem: TMenuItem;
    N1: TMenuItem;
    WindingBut: TSpeedButton;
    NormBut: TSpeedButton;
    NormSeqBut: TSpeedButton;
    CopyItem: TMenuItem;
    ClipPopMenu: TPopupMenu;
    BmpItem: TMenuItem;
    WmfItem: TMenuItem;
    CancelItem: TMenuItem;
    procedure FormHide(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ExitItemClick(Sender: TObject);
    procedure ButItemClick(Sender: TObject);
    procedure PhaseItemClick(Sender: TObject);
    procedure SequenceItemClick(Sender: TObject);
    procedure BothItemClick(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure OnOffBoxMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure OnOffBoxMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure DeleteButClick(Sender: TObject);
    procedure ColorImageMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormDeactivate(Sender: TObject);
    procedure CurrPhasorImgMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure CurrPhasorImgMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure CurrPhasorImgMouseMove(Sender: TObject; Shift: TShiftState;
      X, Y: Integer);
    procedure IncButClick(Sender: TObject);
    procedure DecButClick(Sender: TObject);
    procedure ResetButClick(Sender: TObject);
    procedure IncSeqButClick(Sender: TObject);
    procedure DecSeqButClick(Sender: TObject);
    procedure ResetSeqButClick(Sender: TObject);
    procedure CurrSeqImageMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure CurrSeqImageMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure CurrSeqImageMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure BitmapItemClick(Sender: TObject);
    procedure LabelItemClick(Sender: TObject);
    procedure WindingButClick(Sender: TObject);
    procedure NormButClick(Sender: TObject);
    procedure NormSeqButClick(Sender: TObject);
    procedure NoMultItemClick(Sender: TObject);
    procedure MultItemClick(Sender: TObject);
    procedure CopyItemClick(Sender: TObject);
    procedure WmfItemClick(Sender: TObject);
    procedure BmpItemClick(Sender: TObject);
//  procedure JpgItemClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  CompPhasorForm : TCompPhasorForm;
  CurrCGrid      : TPhasorGrid;   {table for the current values, etc. in Phasor.pas}

implementation

uses Imagopas, Twoshort, ImpedCalc, distance, polygon ;

{$R *.DFM}
const
  editmarg = 2;  {margin under and above of the edit box showing cursor position}
  botmarg = 44;  {bottom margin on form (includes menu bar height ?)}
  pActGrid : TpPhasorGrid = nil;

var
  CRwidth  : integer;         {width (and height) of a small color rectangle}
  CRspace  : integer;         {width of space between color rectangles}
  SeqGrid  : TPhasorGrid;     {table for the symm.component values of currents}

procedure GetWindingCurrents(pComp: TpComp; wind: integer;
                             var CurrA,AngleA,CurrB,AngleB,CurrC,AngleC : single);
{get the currents in transformer windings (when connected in delta)
 pComp  pointer to the transformer
 wind   index of the winding (1 = prim, 2 = sec., 3 = tert)
 CurrA, AngleA   magnitude and angle of phase a (phase in degrees)
 CurrB, AngleB   magnitude and angle of phase b (phase in degrees)
 CurrC, AngleC   magnitude and angle of phase c (phase in degrees)}
var
  Iab,Ibc,Ica : complex; {winding currents}
  Iwp,Iwn,Iwz : complex; {pos, neg, zero seq. currents}
  name        : string;
begin
  {read winding sequence currents, saved in elplex}
  pComp^.GetMultix(wind,Iwz.x,Iwz.y,Iwp.x,Iwp.y,Iwn.x,Iwn.y);
  {transform to winding currents }
  SeqToPhase(Iwp,Iwn,Iwz,Iab,Ibc,Ica);            {in twoshort.pas}
  {positive direction of current in YD-trafos must be taken into account}
  pComp^.GetName(name);
  if (name = gTrafoYD) or (name = gIdealYD) then begin {what about 3w-trafo??}
    Iab.x := -Iab.x;
    Iab.y := -Iab.y;
    Ibc.x := -Ibc.x;
    Ibc.y := -Ibc.y;
    Ica.x := -Ica.x;
    Ica.y := -Ica.y;
  end;
  {to magnitude and phase angle (in degrees)}
  CurrA := Cabs(Iab);
  AngleA := Cangle(Iab)*180/pi;
  CurrB := Cabs(Ibc);
  AngleB := Cangle(Ibc)*180/pi;
  CurrC := Cabs(Ica);
  AngleC := Cangle(Ica)*180/pi;
end;

procedure GetCurrents(ipComp: longint; side: integer;
                      var CurrA,AngleA,CurrB,AngleB,CurrC,AngleC : single);
{get the currents of a transformer; either currents in/out, or winding currents
 ipComp  pointer to the trafo
 side    side of the transformer (prim, sec, tert)
 CurrA, AngleA   magnitude and angle of phase a (phase in degrees)
 CurrB, AngleB   magnitude and angle of phase b (phase in degrees)
 CurrC, AngleC   magnitude and angle of phase c (phase in degrees)}
var
  apu   : single;  {temporary}
  coef  : single;  {"normalizing" multiplier}
  Dflag : single;
  indx  : integer; {index for current}
  name  : string;  {name = type of the component}
  pComp : TpComp;  {pointer to the component}
  V1,Va : single;  {primary voltage, another voltage}
begin
  pComp := TpComp(ipComp);
  pComp^.getName(name);                      {name = type of the component}
  {currents in/out or winding currents (for D-windings only, of course)}
  if (not CompPhasorForm.WindingBut.down) then begin  {currents in/out}
//showmessage('get');
    {read currents, in CurrPhas.pas}
    GetCompCurrents(ipComp,side,CurrA,AngleA,CurrB,AngleB,CurrC,AngleC);    {in CurrPhas}
    CurrCGrid.VoltMode_p := PhaseNeutral;    {actually current mode..}
  end else begin                             {winding currents, but only for D-windings}
    if (name = gTrafoDY) and (side = 1) or   {2-winding trafo}
       (name = gTrafoDD) or
       ((name = gTrafoYD) or (name = gIdealYD)) and (side = 2) then begin
      {for YD and DY-trafos only one set of currents saved}
      if (name = gTrafoDD) then indx := side else indx := 1;
      GetWindingCurrents(pComp,indx,CurrA,AngleA,CurrB,AngleB,CurrC,AngleC);
      CurrCGrid.VoltMode_p := PhasePhase;     {actually current mode..}
    end else if (name = gTrafo3W) then begin  {3-winding trafo}
      pComp^.GetPar(g3w_type,apu);            {flag for YYY or YYD-trafo}
      if (apu = 2) and (side = 3) then begin  {only tertiary can be D-connected}
        GetWindingCurrents(pComp,1,CurrA,AngleA,CurrB,AngleB,CurrC,AngleC); {only one set}
        CurrCGrid.VoltMode_p := PhasePhase;   {actually current mode..}
      end else begin
        GetCompCurrents(ipComp,side,CurrA,AngleA,CurrB,AngleB,CurrC,AngleC);
        CurrCGrid.VoltMode_p := PhaseNeutral; {actually current mode..}
      end;
    end else if (name = gAtrafo) then begin
      pComp^.GetPar(gAtrafo_D,Dflag);               {flag for delta}
      if (Dflag <> 0) and (side = 3) then begin
        GetWindingCurrents(pComp,1,CurrA,AngleA,CurrB,AngleB,CurrC,AngleC); {only one set}
        CurrCGrid.VoltMode_p := PhasePhase;         {actually current mode..}
      end else begin
        GetCompCurrents(ipComp,side,CurrA,AngleA,CurrB,AngleB,CurrC,AngleC);
        CurrCGrid.VoltMode_p := PhaseNeutral;       {actually current mode..}
      end;
    end else begin                            {currents in/out for Y windings = winding currents}
      GetCompCurrents(ipComp,side,CurrA,AngleA,CurrB,AngleB,CurrC,AngleC); {in CurrPhas}
      CurrCGrid.VoltMode_p := PhaseNeutral;   {actually current mode..}
    end;
  end;
  {normalized = seen from the primary side?}
  if (CompPhasorForm.NormBut.down) then begin
    if (name = gTrafo3w) then begin             {3-winding trafo}
      if (side = 1) then begin                  {primary side, no normalization needed}
        coef := 1;
      end else begin
        pComp^.GetPar(g3w_V1,V1);                   {primary voltage}
        if (side = 2) then pComp^.getPar(g3w_V2,Va) {secondary voltage...}
        else pComp^.GetPar(g3w_V3,Va);              {..or tertiary voltage}
        if (V1 > 0) then coef := Va/V1 else coef := 1;
      end;
    end else begin                              {2-winding trafo}
      if (side = 1) then begin
        coef := 1;
      end else begin
        pComp^.GetPar(gTrafo_V1,V1);
        pComp^.GetPar(gTrafo_V2,Va);
        if (V1 > 0) then coef := Va/V1 else coef := 1;
      end;
    end;
    CurrA := coef*CurrA;
    CurrB := coef*CurrB;
    CurrC := coef*CurrC;
  end;
end;

procedure ShowCompPhasors(ipComp : longint);
{show the currents of transformers (and other comp?) using phasors,
 and add to the impedance sum, if selected
 if allowed (button down)
 ipComp  pointer to the bus as integer}
var
  added       : boolean;
  curr        : Tmultix; {currents}
  Iab,Ibc,Ica : complex;
  Iwp,Iwn,Iwz : complex;
  ix,iy       : integer; {temporary (coordinates)}
  lbl         : string;  {label of the component}
  name        : string;  {name = type of the component}
  pComp       : TpComp;
begin
  pComp := TpComp(ipComp);
  pComp^.GetName(name);
  if (Imagoo.CompPhasorBut.down) then begin
    pComp^.GetLabel(lbl,ix,iy);
    {get the currents, either in/out, or in windings}
    GetCurrents(ipComp, 1, curr.u,curr.v,curr.w,curr.x,curr.y,curr.z);
    {add to diagram}
    added := CurrCGrid.ShowPhasors(ipComp, cRead, @curr, lbl,'prim');    {add phasor, if possible}
    if (added) then begin                                                {...in phasor.pas}
      SeqGrid.ShowPhasors(ipComp, cCopy,nil,lbl,'prim');   {copy from Curr Grid}
//    pComp^.SetPWR(true);                          {set flag}
    end;
    GetCurrents(ipComp, 2, curr.u,curr.v,curr.w,curr.x,curr.y,curr.z);
    added := CurrCGrid.ShowPhasors(ipComp, cRead, @curr, lbl,'sec.');    {add phasor, if possible}
//if (added) then showmessage('add') else showmessage('not');
    if (added) then begin
      SeqGrid.ShowPhasors(ipComp, cCopy,nil,lbl,'sec.');   {copy from Curr Grid}
//    pComp^.SetPWR(true);                          {set flag}
    end;
    {if 3-winding trafo, get third current}
    if (name = gTrafo3W) or (name = gAtrafo) then begin
      GetCurrents(ipComp, 3, curr.u,curr.v,curr.w,curr.x,curr.y,curr.z);
      {add phasor, if possible}
      added := CurrCGrid.ShowPhasors(ipComp, cRead, @curr, lbl,'tert');
      if (added) then begin
        SeqGrid.ShowPhasors(ipComp, cCopy,nil,lbl,'tert');   {copy from Curr Grid}
      end;
    end;
    CompPhasorForm.CurrEdit.text := '';
  end;
  {parameters to or from impedance sum calculator, but only for 2-w transformers}
  {(3-w trafos in parametr.pas)}
  if (name <> gTrafo3W) and (name <> gIdealYD) then begin
    if ((ImpedCalcForm.AddButton.down) or (ImpedCalcForm.SubButton.down)) and
       (ImpedCalcForm.TrafoRadioBut.checked) then begin
      {YY and DD trafos directly. For YD and DY must check zero seq. impedance}
      if (name = gTrafoYY) or (name = gTrafoDD) or
         (name = gTrafoDY) then begin                      {..and DY-trafos too}
        ImpedCalcForm.PutComp(pComp);                      {pointer to calculator}
      end else begin
        {must select impedance, prim-sec, or prim-tert. Show bottons for selecting}
        Imagoo.Z0Box.left := pComp^.left+pComp^.width+8;
        Imagoo.Z0Box.top := pComp^.top;
        Imagoo.Z0Box.visible := true;
        Imagoo.FiniteBut.tag := ipComp;    {transport the pointer as integer}
        Imagoo.InfBut.tag := ipComp;       {transport the pointer as integer}
        {the impedances are added in ImpedCalcForm.PutComp(pComp), called from..
         ..Imagoo.FiniteButClick or Imagoo.InfButClick}
      end;
    end;
    {draw impedance to graph of distance relays, if compbut down in distance.pas or polyg.pas}
    if (Distrel.CompBut.down) then begin
      Distance.Dist.AddImpedance(pComp);
    end;
    if (Polyrel.CompBut.down) then begin
      Polygon.Poly.AddImpedance(pComp);
    end;
  end;
end;

procedure UpdateCompPhasors;
{update the phasors (after some new calculation), used in skemadef.pas
 Works only with 2-winding trafos, so far}
var
  curr   : Tmultix;   {currents = magnitude and phase (in degrees)}
  ii     : integer;   {index}
  ipComp : longint;   {pointer to the component (trafo), as integer}
  ipC0   : longint;   {old pointer}
  nT     : integer;   {number of trafos (windings) or components?}
  side   : integer;   {trafo side (prim, sec, tert)}
begin
  {read the currents from the trafos in the grid of the graph}
  nT := CurrCGrid.NoOfItems;               {number of trafos}
  if (nT > 0) then begin
    ipC0 := 0;
    side := 1;
    for ii := 1 to nT do begin
      ipComp := CurrCGrid.GetIp(ii);                      {pointer to trafo}
      if (ipComp <> ipC0) then side := 1 else inc(side);  {trafo side, or winding}
      ipC0 := ipComp;
      GetCurrents(ipComp,side,curr.u,curr.v,curr.w,curr.x,curr.y,curr.z);
      CurrCGrid.UpdatePhasors(cRead,@curr,ii);            {update the phasor graphs, in Phasor.pas}
    end;
    SeqGrid.UpdatePhasors(cCopy,nil,0);                   {update also the seq. graph}
  end;
end;

procedure TCompPhasorForm.FormHide(Sender: TObject);
begin
  Imagoo.CompPhasorBut.down := false;
end;

procedure TCompPhasorForm.FormCreate(Sender: TObject);
{set the size etc of the grind and image}
var
  ii      : integer;   {index}
  ipu,ipv : integer;   {temporary}
begin
  {create the grid for the values of the currents (etc)}
  CurrCGrid := TPhasorGrid.create(CompPhasorForm);
  CurrCGrid.parent := CompPhasorForm;
  CurrCGrid.InitializeBasics;
  CurrCGrid.InitializeMore(@OnOffPanel,@ColorPanel,@OnOffBox,@DeleteBut,@CurrPhasorImg,
                          @IDImage,@CurrEdit,@CurrentLabel,@CompPhasorForm,@PhasorDialog,
                          nil,nil);
  CurrCGrid.pSelf_p := @CurrCGrid;
  CurrCGrid.Left := 232;
  CurrCGrid.Top := 24;
  CurrCGrid.name := 'CurrCGrid';
  {create the grid for the values of the sequence currents (etc)}
  SeqGrid := TPhasorGrid.create(CompPhasorForm);
  SeqGrid.parent := CompPhasorForm;
  SeqGrid.InitializeBasics;
  SeqGrid.InitializeMore(@OnOffPanel,@ColorPanel,@OnOffBox,@DeleteBut,@CurrSeqImage,
                          @IDImage,@CurrSeqEdit, @CurrSeqLabel,@CompPhasorForm,@PhasorDialog,
                          @MultItem,@NoMultItem);
  SeqGrid.pSelf_p := @SeqGrid;
  SeqGrid.pOther_p := @CurrCGrid;
  CurrCGrid.pOther_p := @SeqGrid;
  SeqGrid.Left := 232;
  SeqGrid.Top := 288;
  SeqGrid.name := 'SeqGrid';
  {initially curr grid visible}
  CurrCGrid.visible := true;    {calls FormResize, everything must be ready, else error}
  {hide sequence grid and image, etc}
  SeqGrid.visible := false;
  CurrSeqImage.visible := false;
  CurrSeqLabel.visible := false;
  CurrSeqEdit.visible := false;
  ResetSeqBut.visible := false;
  IncSeqBut.visible := false;
  DecSeqBut.visible := false;
  left := Imagoo.width-width-8;   {position of the form wrt the main form}
  {set the (original) size of the form}
  {set the original size of the form}
  CompPhasorForm.width := CurrCGrid.left+CurrCGrid.width+24;
  ipu := CurrCGrid.top+CurrCGrid.height+32;
  ipv := CurrEdit.top+CurrEdit.height+botmarg+2*editmarg;
  if (ipu > ipv) then  CompPhasorForm.height := ipu
  else  CompPhasorForm.height := ipv;
  {initialize the color selection image}
  {PQForm.}ColorInitialize(@ColorImage);  {in utildef}
  {PQForm.}GetCRsize(CRwidth,CRspace);
  ColorPanel.width := ColorImage.width+2*CRspace;
  ColorPanel.height := ColorPanel.width;
  ipu := CurrCGrid.RowHeights[0]+CurrCGrid.RowHeights[1];
  ColorPanel.top := CurrCGrid.top+ipu+2*CurrCGrid.GridLineWidth;
  ColorPanel.left := CurrCGrid.left+CurrCGrid.ColWidths[0]+2*CurrCGrid.GridLineWidth;
  CurrCGrid.unit_p := 'A';
  SeqGrid.unit_p := 'A';
  CurrCGrid.ppActGrid_p := @pActGrid;
  SeqGrid.ppActGrid_p := @pActGrid;
{?}CurrCGrid.VoltMode_p := PhaseNeutral;
{?}SeqGrid.VoltMode_p := PhaseNeutral;
  if (SetComp.VPhasor_dir <>'') then
    PhasorDialog.InitialDir := SetComp.VPhasor_dir;
  CurrEdit.text := '  Click a Transformer';
  {add flag that form created}
  Imagoo.ReadyEdit.text := Imagoo.ReadyEdit.text+'c';
  WindingBut.left := CurrentLabel.left+CurrentLabel.width+48;
end;

procedure TCompPhasorForm.ExitItemClick(Sender: TObject);
begin
  visible := false;
end;

procedure TCompPhasorForm.ButItemClick(Sender: TObject);
begin
ButItem.checked := not ButItem.checked;
  IncBut.visible := ButItem.checked;
  DecBut.visible := ButItem.checked;
  ResetBut.visible := ButItem.checked;
  IncSeqBut.visible := ButItem.checked;
  DecSeqBut.visible := ButItem.checked;
  ResetSeqBut.visible := ButItem.checked;
  CurrEdit.visible := ButItem.checked;
  CurrSeqEdit.visible := ButItem.checked;
end;

procedure TCompPhasorForm.PhaseItemClick(Sender: TObject);
begin
  PhasorDialog.filter := FilterBoth; {can save as .bmp and as *.wmf}
  PhaseItem.checked := true;
  CurrCGrid.view_p := phase;
  SeqGrid.view_p := phase;
  {show all items connected to phase components}
  CurrCGrid.visible := true;
  CurrPhasorImg.visible := true;
  CurrentLabel.visible := true;
  If (ButItem.checked) then begin
    CurrEdit.visible := true;
    ResetBut.visible := true;
    IncBut.visible := true;
    DecBut.visible := true;
  end;
  {hide all connected to sequence components}
  SeqGrid.visible := false;
  CurrSeqImage.visible := false;
  CurrSeqLabel.visible := false;
  CurrSeqEdit.visible := false;
  ResetSeqBut.visible := false;
  IncSeqBut.visible := false;
  DecSeqBut.visible := false;
  {set the height of the form (change, eventually)}
  height := CurrPhasorImg.height+CurrEdit.height+botmarg+2*editmarg;
end;

procedure TCompPhasorForm.SequenceItemClick(Sender: TObject);
begin
  PhasorDialog.filter := FilterBoth; {can save as .bmp and as *.wmf}
  SequenceItem.checked := true;
  CurrCGrid.view_p := seq;
  SeqGrid.view_p := seq;
  {move the sequence items to top}
  CurrSeqImage.top := 0;
  CurrSeqLabel.top := CurrSeqImage.top;
  SeqGrid.top := CurrSeqImage.top+24;
  CurrSeqEdit.top := CurrSeqImage.top+CurrSeqImage.height+editmarg;
  ResetSeqBut.top := CurrSeqImage.top;
  IncSeqBut.top := ResetSeqBut.top;
  DecSeqBut.top := ResetSeqBut.top;
  {show all items connected to sequence components}
  SeqGrid.visible := true;
  CurrSeqImage.visible := true;
  CurrSeqLabel.visible := true;
  CurrSeqLabel.BringToFront;
  If (ButItem.checked) then begin
    CurrSeqEdit.visible := true;
    ResetSeqBut.visible := true;
    IncSeqBut.visible := true;
    DecSeqBut.visible := true;
  end;
  {hide all connected to sequence components}
  CurrCGrid.visible := false;
  CurrPhasorImg.visible := false;
  CurrentLabel.visible := false;
  CurrEdit.visible := false;
  ResetBut.visible := false;
  IncBut.visible := false;
  DecBut.visible := false;
  {set the height of the form (change, eventually)}
  height := CurrSeqImage.height+CurrSeqEdit.height+botmarg+2*editmarg;
end;

procedure TCompPhasorForm.BothItemClick(Sender: TObject);
begin
  PhasorDialog.filter := FilterBmp; {can save only as .bmp}
  BothItem.checked := true;
  CurrCGrid.view_p := both;
  SeqGrid.view_p := both;
  {set the form height, if not already set}
  if not(CurrPhasorImg.visible and CurrSeqImage.visible) then begin
    if (height < Imagoo.height div 2) then height := 2*height-botmarg
    else height := Imagoo.height;
  end;
  {show all items connected to phase components}
  CurrCGrid.visible := true;
  CurrPhasorImg.visible := true;
  CurrentLabel.visible := true;
  If (ButItem.checked) then begin
    CurrEdit.visible := true;
    ResetBut.visible := true;
    IncBut.visible := true;
    DecBut.visible := true;
  end;
  {show all items connected to sequence components}
  SeqGrid.visible := true;
  CurrSeqImage.visible := true;
  CurrSeqLabel.visible := true;
  CurrSeqLabel.BringToFront;
  If (ButItem.checked) then begin
    CurrSeqEdit.visible := true;
    ResetSeqBut.visible := true;
    IncSeqBut.visible := true;
    DecSeqBut.visible := true;
  end;
end;

procedure TCompPhasorForm.FormResize(Sender: TObject);
{resize the images and move the grids etc. correspondingly}
begin
  CurrCGrid.FormResizeUpper(@(CompPhasorForm as TForm));
  SeqGrid.FormResizeLower(@(CompPhasorForm as TForm));
  ResetSeqBut.top := CurrSeqImage.top;
  IncSeqBut.top := ResetSeqBut.top;
  DecSeqBut.top := ResetSeqBut.top;
  WindingBut.left := CurrentLabel.left+CurrentLabel.width+48;
  NormBut.left := CurrPhasorImg.left;
  NormBut.top := CurrPhasorImg.top+CurrPhasorImg.height-NormBut.height;
  NormSeqBut.left := CurrSeqImage.left;
  NormSeqBut.top := CurrSeqImage.top+CurrSeqImage.height-NormSeqBut.height;
end;

procedure TCompPhasorForm.OnOffBoxMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
{complete the change of the status of the show/not flag of the selected variable}
begin
  OnOffPanel.visible := false;
  if (pActGrid <> nil) then begin
    pActGrid^.SetFocus;
    pActGrid^.DrawPhasors;
  end;
end;

procedure TCompPhasorForm.OnOffBoxMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
{change the status of the show/not flag of the selected variable}
begin
  OnOffBox.checked := not OnOffBox.checked;
  if (OnOffBox.checked) and (pActGrid <> nil) then
    pActGrid^.Cells[pActGrid^.actcol_p,pActGrid^.actrow_p] := '1'
  else pActGrid^.Cells[pActGrid^.actcol_p,pActGrid^.actrow_p] := '0';
end;

procedure TCompPhasorForm.DeleteButClick(Sender: TObject);
{delete the "active" component in the list, update phasor graph}
{works only with 2-winding trafos, so far}
const
  row : integer = 1;
var
  apu       : single;
  ii,jj     : integer;
  ipComp    : longint; {pointer to the trafo}
  ipu       : integer;
  ll        : longint; {temporary}
  maxph     : integer; {max. number of phasors = current trafos}
  row1,row2 : integer; {rows corresponding to prim., sec. windings}
begin
  row := tag;                             {row saved in tag in Select_Cell, of phasor.pas}
  {must delete all windings }
  {does row correspond to primary or secondary (or tert.) winding}
  ipu := (row div 4)+1;                   {4 rows for each winding}
  CurrCGrid.GetCompPointer(ipu, ipComp);  {pointer to the trafo}
  if (ipComp <> 0) then begin             {pointer exists}
    maxph := CurrCGrid.GetMaxCT;          {max. number of phasors}
    for ii := 1 to maxph do begin         {scan all}
      jj := maxph-ii+1;                   {backwards}
      CurrCGrid.GetCompPointer(jj, ll);   {pointer to a trafo}
      if (ll = ipComp) then begin         {pointer to this trafo}
        row1 := 4*(jj-1)+1;               {4 rows reserved for each winding}
        CurrCGrid.DelButClick(row1);      {delete phasor}
        SeqGrid.DelButClick(row1);        {delete also seq. phasor}
      end;
    end;
  end;
(*
  {if row/4 even = prim.winding, else sec.winding, for a 2-winding trafo}
  apu := ipu/2.0;
  if ((ipu div 2) = apu) then begin  {primary winding}
    row1 := row;
    row2 := row+4;
  end else begin                     {secondary winding}
    row1 := row-4;
    row2 := row;
  end;
  CurrCGrid.DelButClick(row2);
  CurrCGrid.DelButClick(row1);
  SeqGrid.DelButClick(row2);
  SeqGrid.DelButClick(row1);
*)
end;

procedure RemoveCompPhasor(ipComp : longint; info: string);
{remove (delete) a trafo (or other comp) from the grid of components for phasor display
 ipComp  pointer to the component, as integer
 info    additional information}
var
  row : integer;  {the row of the identifier in the grid}
begin
  if (CurrCGrid.isThere(ipComp,row,info)) then begin
    CurrCGrid.DeleteCTphasor(row);
    CurrCGrid.DeleteCTphasor(row-4);
    SeqGrid.DeleteCTphasor(row);
    SeqGrid.DeleteCTphasor(row-4);
    CurrCGrid.DrawPhasors;
  end;
end;

procedure RemoveCompPhasors;
{clear the grid, tables and phasor picture}
begin
  CurrCGrid.RemoveAllPhasors;
  SeqGrid.RemoveAllPhasors;
  CompPhasorForm.visible := false;
end;

procedure TCompPhasorForm.ColorImageMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
{get color index from X and Y}
begin
  if (pActGrid <> nil) then pActGrid^.ColorImageMouseUp(X,Y);
end;

procedure TCompPhasorForm.FormDeactivate(Sender: TObject);
begin
  OnOffPanel.visible := false;
  DeleteBut.visible := false;
  ColorPanel.visible := false;
end;

procedure TCompPhasorForm.CurrPhasorImgMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
{prepare to move an identifier, if cursor on the identifier}
begin
  {save position etc. for moving the identifier, if cursor on an identifier}
  if (Button = mbLeft) then
    CurrCGrid.StartIdentifierIf(x,y);
end;

procedure TCompPhasorForm.CurrPhasorImgMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
{move the identifier to the mouse-up-point}
begin
  if IDimage.visible then begin
    {move the identifier}
    CurrCGrid.MoveIdentifier(x,y);
    IDimage.visible := false;
  end;  
end;

procedure TCompPhasorForm.CurrPhasorImgMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
  {show the curent corresponding to the cursor position}
  if (CurrCGrid.NoOfItems > 0) then
    CurrCGrid.CursorCurrent(x,y)
  else
    CurrEdit.text := '  Click a transformer';
  {show a rectangle around ID-number, if moving}
  if (IDimage.visible) then begin
    IDimage.left := CurrPhasorImg.left+x-6;
    IDimage.top := CurrPhasorImg.top+y-6;
  end;
end;

procedure TCompPhasorForm.IncButClick(Sender: TObject);
{increase the scale by one step}
begin
  inc(CurrCGrid.modScale_p);
  CurrCGrid.DrawPhasors;
end;

procedure TCompPhasorForm.DecButClick(Sender: TObject);
{decrease the scale by one step}
begin
  if (CurrCGrid.maxScale_p > 1.5) then dec(CurrCGrid.modScale_p);
  CurrCGrid.DrawPhasors;
end;

procedure TCompPhasorForm.ResetButClick(Sender: TObject);
{reset the scale}
begin
  CurrCGrid.modScale_p := 0;
  CurrCGrid.DrawPhasors;
end;

procedure TCompPhasorForm.IncSeqButClick(Sender: TObject);
{increase the scale by one step}
begin
  inc(SeqGrid.modScale_p);
  SeqGrid.DrawPhasors;
end;

procedure TCompPhasorForm.DecSeqButClick(Sender: TObject);
{decrease the scale by one step}
begin
  if (SeqGrid.maxScale_p > 1.5) then dec(SeqGrid.modScale_p);
  SeqGrid.DrawPhasors;
end;

procedure TCompPhasorForm.ResetSeqButClick(Sender: TObject);
{reset the scale}
begin
  SeqGrid.modScale_p := 0;
  SeqGrid.DrawPhasors;
end;

procedure TCompPhasorForm.CurrSeqImageMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
{prepare to move an identifier, if cursor on the identifier}
begin
  {save position etc. for moving the identifier, if cursor on an identifier}
  if (Button = mbLeft) then
    SeqGrid.StartIdentifierIf(x,y);
end;

procedure TCompPhasorForm.CurrSeqImageMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
  {show the current corresponding to the cursor position}
  SeqGrid.CursorCurrent(x,y);
  {show a rectangle around ID-number, if moving}
  if (IDimage.visible) then begin
    IDimage.left := CurrSeqImage.left+x-6;
    IDimage.top := CurrSeqImage.top+y-6;
  end;

end;

procedure TCompPhasorForm.CurrSeqImageMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
{move the identifier to the mouse-up-point}
begin
  if IDimage.visible then begin
    {move the identifier}
    SeqGrid.MoveIdentifier(x,y);
    IDimage.visible := false;
  end;
end;

procedure TCompPhasorForm.BitmapItemClick(Sender: TObject);
{save diagram as bitmap or jpeg-image}
var
  DirName     : string;
  FormImage   : TBitmap;    {for saving the whole form as a bitmap}
begin
  if (PhasorDialog.execute) then begin
    if (PhasorDialog.FilterIndex = 3) then begin  {save as a wmf-file}
      if (PhaseItem.checked) then begin           {draw phasors of phase variables}
        CurrCGrid.DrawWmfDiagram(PhasorDialog.Filename);
      end else if (SequenceItem.checked) then begin {draw sequence variables}
        SeqGrid.DrawWmfDiagram(PhasorDialog.Filename);
      end;
    end else begin                                {save as a bitmap or as a Jpeg}
      FormImage := CompPhasorForm.getFormImage;
      if (PhasorDialog.FilterIndex = 1) then begin {save as a bitmap}
        FormImage.savetofile(PhasorDialog.Filename);
      end else begin                               {save as a jpeg-file}
        SaveJpegImage(@CompPhasorForm, FormImage, PhasorDialog.FileName);  {..in routines.pas}
      end;
      FormImage.free;
    end;
    {save the directory for next time}
    DirName := ExtractFilePath(PhasorDialog.FileName);
    PhasorDialog.InitialDir := DirName;    {save the directory}
  end;

end;

procedure TCompPhasorForm.LabelItemClick(Sender: TObject);
begin
  LabelItem.checked := not LabelItem.checked;
  CurrCGrid.writeID_p := LabelItem.checked;
  SeqGrid.writeID_p := LabelItem.checked;
  CurrCGrid.DrawPhasors;
  SeqGrid.DrawPhasors;
end;

procedure TCompPhasorForm.WindingButClick(Sender: TObject);
begin
  {update identifiers of D-winding currents (A to AB, etc)}
  if (WindingBut.down) then CurrCGrid.WindingCurrentID   {in phasor.pas}
  else CurrCGrid.PhaseNeutralID;
  UpdateCompPhasors;
end;

procedure TCompPhasorForm.NormButClick(Sender: TObject);
begin
  NormSeqBut.down := NormBut.down;
  UpdateCompPhasors;
end;

procedure TCompPhasorForm.NormSeqButClick(Sender: TObject);
begin
  NormBut.down := NormSeqBut.down;
  UpdateCompPhasors;
end;

procedure TCompPhasorForm.NoMultItemClick(Sender: TObject);
begin
  NoMultItem.checked := true;
  SeqGrid.UpdateSeqIdentifiers;
  SeqGrid.UpdatePhasors(cCopy,nil,0);      {in phasor.pas}
  CurrSeqLabel.caption := 'Current Sequence components (I1, I2, I0)';
end;

procedure TCompPhasorForm.MultItemClick(Sender: TObject);
begin
  MultItem.checked := true;
  SeqGrid.UpdateSeqIdentifiers;
  SeqGrid.UpdatePhasors(cCopy,nil,0);
  CurrSeqLabel.caption := 'Current Sequence components (I1, 3I2, 3I0)';
end;

procedure TCompPhasorForm.CopyItemClick(Sender: TObject);
{copy phasors to clipboard as windows metafile}
begin
  ClipPopMenu.popup(left,top);
end;

procedure TCompPhasorForm.WmfItemClick(Sender: TObject);
{copy phasors to clipboard as windows metafile}
var
  FormImage   : TBitmap;         {for saving the form as a bitmap}
  MetaCanvas  : TMetafileCanvas; {canvas for saving graph as*.wmf}
  PhasMetaf   : TMetafile;       {for *.wmf}
begin
  FormImage := CompPhasorForm.getFormImage;          {picture of the form (as bitmap?)}
  PhasMetaf := TMetafile.Create;
  PhasMetaf.width := ClientWidth;                    {size = form size}
  PhasMetaf.height := ClientHeight;
  MetaCanvas := TMetafileCanvas.Create(PhasMetaf,0); {create it's canvas}
  MetaCanvas.draw(0,0,FormImage);                    {copy the image of the form}
  MetaCanvas.free;                                   {free, and move image to metafile}
  Clipboard.assign(PhasMetaf);                       {copy to clipboard}
  FormImage.free;
  PhasMetaf.free;
end;

procedure TCompPhasorForm.BmpItemClick(Sender: TObject);
{copy phasors to clipboard as bitmap}
var
  FormImage   : TBitmap;         {for saving the form as a bitmap}
begin
  FormImage := CompPhasorForm.getFormImage;          {picture of the form (as bitmap?)}
  Clipboard.assign(FormImage);                       {copy to clipboard}
  FormImage.free;
end;
(*
procedure TCompPhasorForm.JpgItemClick(Sender: TObject);
{copy phasors to clipboard as jpeg-image}
{It seems that it is not possible to copy as jpeg image to the clipboard, because
 the clipboard does not support jpg-format}
var
  FormImage   : TBitmap;       {form as a bitmap}
  FormJpeg    : TJpegImage;    {for saving the bitmap as a jpeg-image}
begin
  FormImage := CompPhasorForm.getFormImage;     {picture of the form (as bitmap?)}
  FormJpeg := TJpegImage.create(CompPhasorForm);
  FormJpeg.parent := CompPhasorForm;
  FormJpeg.quality := 100;                      {default = 75, but now the file is larger}
  FormJpeg.picture.bitmap.assign(FormImage);    {copy in jpeg-format}
//Clipboard.assign(FormJpeg);  {does not work??}
  Clipboard.assign(FormJpeg.picture); {works, but copies as bitmap??}
  FormJpeg.free;
  FormImage.free;
end;
*)
end.
