{Put the pointer to the graphical element into some known place, always same place !!}
{ <>  }
unit Equmenu;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Buttons, ExtCtrls, StdCtrls;

type
  TEquationMenuForm = class(TForm)
    ResetBut: TSpeedButton;
    LineBut: TSpeedButton;
    CrossImg: TImage;
    TextBut: TSpeedButton;
    TestEdit: TEdit;
    FontDlg: TFontDialog;
    FontBut: TSpeedButton;
    SaveBut: TButton;
    TestBut: TButton;
    OpenBut: TButton;
    OpenDlg: TOpenDialog;
    SaveDlg: TSaveDialog;
    DummyMemo: TMemo;
    MemoBut: TSpeedButton;
    DelAllBut: TSpeedButton;
    ConstrBut: TButton;
    PowerBut: TSpeedButton;
    StudyEdit: TEdit;
    procedure ResetButClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure LineButClick(Sender: TObject);
    procedure TextButClick(Sender: TObject);
    procedure FontButClick(Sender: TObject);
    procedure FontDlgApply(Sender: TObject; Wnd: Integer);
    procedure TestButClick(Sender: TObject);
    procedure OpenButClick(Sender: TObject);
    procedure SaveButClick(Sender: TObject);
    procedure FormHide(Sender: TObject);
    procedure MemoButClick(Sender: TObject);
    procedure DelAllButClick(Sender: TObject);
    procedure ConstrButClick(Sender: TObject);
    procedure PowerButClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure InitializeGraphic;
    procedure StartDrawing(x,y: integer);
    procedure FinishDrawingWithMouse(x,y: integer);
    procedure DrawWithMouse(x,y: integer);
    procedure PutpMainForm(ipForm, ipBut, ipVarlist, ipEquivList,ipEquivEdit: longint);
    procedure DrawAll;
    procedure DeleteAll;
    procedure MoveAll(dx,dy: integer);
    procedure EditBoxExit(sender: TObject);
    procedure MemoBoxExit(sender: TObject);
    procedure ConstructEquation(var equ: string);
    procedure PutEquationName(name: string);
    procedure GetEquationName(var name: string);
    procedure PutEquation(equ: string);
    procedure GetEquation(var equ: string);
  end;

function WithoutLTspaces(line: string): string;
function WithMultOperator(line: string): string;
procedure GetPartStrings(line: string; ipParts: longint);
function IsInteger(line: string; var kk : integer): boolean;
var
  EquationMenuForm: TEquationMenuForm;

implementation

uses Imagopas, Equation;

{$R *.DFM}

type
  TpCanvas = ^TCanvas;
  TpEdit = ^TEdit;
  TpForm = ^TForm;
  TpList = ^TList;
  TpMemo = ^TMemo;
  TpStringList = ^TStringList;
  TpSpeedButton = ^TSpeedButton;
  TpTextFile = ^TextFile;
type
  TpFont = ^TFont;

type
  TdrawPhase = (wipe, move, up); {wiping, mousemove, mouseup}

{direction of directional elements (triangles, arrows...)}
type
  TQuarter = (north, east, south, west);

{direction of the line: ltrb = from left top to right bottom, etc}
type
  Tlinedir = (ltrb, lbrt,rtlb,rblt);

{define procedure "pointer"}
type
  TpProc = ^TProc;
  TProc = procedure(ipComp : longint);
  TpRecall = ^TRecall;
  TRecall = procedure(var ll: longint; line: string);
  TpSpeedBut = ^TSpeedButton;
  TpComponent = ^TComponent;

{define marker for moving the image }
type
  TpMoveImage = ^TMoveImage;
  TMoveImage = class(TImage)
  procedure MovMouseMove(Sender : TObject; Shift: TShiftState; X,Y: Integer);
  procedure MovMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
  procedure MovMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
public
private
  m_ipGrel : longint;  {pointer to the graph.element}
  m_x0     : integer;  {old x}
  m_y0     : integer;  {old y}
end;

{define marker images}
type
  TpMarkImage = ^TMarkImage;
  TMarkImage = class(TImage)
  procedure MrkMouseMove(Sender : TObject; Shift: TShiftState; X,Y: Integer);
  procedure MrkMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
  procedure MrkMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
public
private
  m_index  : integer;  {index of the marker}
  m_ipGrel : longint;  {pointer to the graph.element}
end;

{define button (for deleting an graphical element)}
type
  TpWorkBut = ^TWorkBut;
  TWorkBut = class(TButton)
  procedure DelButClick(sender: TObject);
  procedure BackButClick(sender: TObject);
public
private
end;


{class for the different shapes (graphic elements), like rectangle, ellipse, line, etc}
type
  TpGraphel = ^TGraphel;
  TGraphel = class(TObject)
private
   e_BrushColor : TColor;    {color of the brush = inside of the element}
   e_PenColor   : Tcolor;    {color of the line}
   e_x1, e_y1   : integer;   {coordinates of one corner}
   e_x2, e_y2   : integer;   {coordinate of opposite corner}
   e_xtx, e_ytx : integer;   {coordinates of the corner where text starts....}
   {..}                      {...and around which text rotates} {Needed (only?) for the text box}
   e_penwidth   : integer;   {size (widht) of the pen}
   e_quarter    : TQuarter;  {direction of directional elements}
   e_OldQuarter : TQuarter;  {old direction (only?) for the text box}
   e_shape      : integer;   {index of the shape}
   e_type       : integer;   {additional definition for the shape}
   e_Toile      : TCanvas;   {canvas on which drawn}
   e_DrawEl     : TProc;     {procedure for drawing the graphic element}
   e_inside     : boolean;   {given point is inside the graphical element}
   e_linedir    : Tlinedir;  {drawing direction of the line (only for the line?)}
   e_text       : string;    {text in element (only for text element?)}
   e_Ctext      : string;    {text copied here for processing}
   e_pFont      : TpFont;    {the font of text (only for text element?)}
   e_temp       : integer;   {diverse: for sorting of lines}
   e_crit       : integer;   {criterium for sorting}
   procedure putFirstXY(x,y: integer);        {save coordinates of first corner}
   procedure putSecondXY(x,y : integer);      {save coordinates of opposite corner}
   procedure putFirstX(x: integer);           {save x-coordinate of first corner}
   procedure putSecondX(x : integer);         {save x-coordinate of opposite corner}
   procedure putTextCornerXY(x,y: integer);   {save coordinates of the corner where text starts}
   procedure getFirstXY(var x,y : integer);   {get the first corner}
   procedure PutShapeIndex(shindx : integer); {save the shape index}
   procedure ClearBrush;
   procedure OppositePenColor;
   procedure PickPenColor;
   procedure CheckCorners(xf,yf,x,y : integer);
   procedure LineDirection(x1,y1,x2,y2: integer);
  {}
public
  {}
end;

{define object for managing the shapes (graphs, figures,..}
type
  TGraphiq = class(TObject)
private
  g_BrushColor : TColor;      {color of the brush = inside of the graphic elements}
  g_DelBut     : TWorkBut;    {button for deleting a gr.element}
  g_Canvas     : TCanvas;     {canvas for text, mostly canvas of main form}
  g_BackBut    : TWorkBut;    {button for moving element to back (under other element(s)}
  g_drawing    : boolean;     {drawing a shape. Set in... reset in ...}
  g_EditBox    : TEdit;       {box for writing/editing text in the main form}
  g_ElList     : TStringList; {list of graphical elements and properties as strings}
  g_EquName    : string;      {name of the equation}
  g_equation   : string;      {equation as a string, ready for parsing (constructed, as ((x+y)^p)/(a+b)}
  g_first      : boolean;     {drawing first shape, when moving the mouse. Set in.., reset in..}
  g_movfirst   : boolean;     {starting to draw rectngle for moving components}
  g_List       : TList;       {list of pointers to the shapes}
  g_LineList   : TList;       {list of lines}
  g_TextList   : TList;       {list of all texts (originally all, some deleted while processing}
  g_TextListA  : TList;       {temporary list of text-elements}
  g_TextListU  : TList;       {temporary list of text-elements}
  g_Inside     : TList;       {list of elements inside given rectangle}
  g_MemoBox    : TMemo;       {box for writing/editing text in the main form on several lines}
  g_MovImg     : TMoveImage;  {marker for moving the graph}
  g_PenColor   : TColor;      {color of the pen (lines) in the shape to be drawn}
  g_penwidth   : integer;     {size of the pen}
  g_quarter    : TQuarter;    {direction of directional elements}
  g_pForm      : TpForm;      {pointer to the form, where shapes drawn}
  g_pGraph     : TpGraphel;   {pointer to the graphic element being worked with (drawn, etc)}
  g_ResButDown : boolean;     {reset button down}
  g_shapeIndex : integer;     {index of the shape to be drawn, 0 = nothing, 1=rectangle, 2=ellips, etc}
  g_type       : integer;     {additional definition for the shape}
  g_pVarList   : TpStringList;{pointer to list of variables in the main form (calling form)}
  g_pEquivList : TpStringList;{list for name-equivalencies in equations and PQ-relays, in the main form}
  g_x1,g_y1    : integer;     {coordinates of point where clicked = started drawing a rectangle}
  g_x2,g_y2    : integer;     {coordinates of opposite corner}
  g_movrec     : boolean;     {true, when drawing a rectangle for moving coponents}
  DrawGraphel  : array[0..7]  of TProc;   {procedures for drawing different shapes}
  InGraphel    : array[0..7]  of TProc;   {procedures for checking, is x,y inside element}
  RecalEl      : array[1..20] of TRecall; {procedures for recalling saved graphs from strings}
  g_pMarkers   : array[0..7]  of longint; {pointers to images as integers}

  constructor Create;
  destructor Destroy; override;
  procedure ResButState(down: boolean);  {copy the state of the reset button}
  procedure PutShapeIndex(indx: integer);
  procedure PutType(stype: integer);
  procedure CreateAndAddGraphicElement(indx: integer);
  procedure FreeGraphicElements;
  procedure FreeMarkers;
  procedure HideMarkers;
  procedure DeleteSelectedElement;
  procedure SendSelectedElementToBack;
  procedure DeleteAll;
public
  procedure initialize;
  procedure putpForm(pForm: TpForm);
  procedure StartDrawing(x,y : integer);
  procedure DrawWithMouse(x,y : integer);
  procedure FinishDrawingWithMouse(x,y : integer);
  procedure CreateEditBox;
  procedure CreateMemoBox;
  procedure CreateMarkers;
  procedure DrawAll;
  procedure MoveAll(dx,dy : integer);
  procedure MoveInsideOnes(dx,dy: integer);
  function  pActiveElementIf: TpGraphel;
  procedure SetElementPenColorIf(col: TColor);
  procedure SetElementPenWidthIf(width: integer);
  procedure SetElementBrushColorIf(col: TColor);
  procedure SetElementQuarterIf(quarter: TQuarter);
  procedure EditBoxExit(sender: TObject);
  procedure MemoBoxExit(sender: TObject);
  procedure EditBoxChange(sender: TObject);
  procedure MemoBoxChange(Sender: TObject);
  function  FontAndWidthOfText(font: TFont; text: string): integer;
  function  WidthOfMemoText(var hh : integer): integer;
  procedure ElementsToList;
  procedure ElementsFromList;
  procedure DeleteElement(pGrel: TpGraphel; indx: integer);
  procedure MemoTextOut(pMemo: TpMemo; xx,yy: integer; pGrel : TpGraphel);
  procedure InsideRectangle(x1,y1,x2,y2: integer; whole: boolean);
  procedure WriteElementsToFile(pOutfile: TpTextFile; flg : string);
  procedure CopyListAndAddCR(TmpList: TStringList);
  procedure CopyInsideToList(GraphList: TList);  {copy pointers to moved graphical elements}
  procedure CopyListToInside(GraphList: TList);
  procedure CopyAllToInsideList;
  procedure CopyTextsAndPointers;
  procedure CopyAndSortLines;
  procedure GetTextAboveAndBelowLine(pLine: TpGraphel);
  procedure CombineTextsAboveAndBelowLine(var comtxt: string);
  procedure CombineTextOfOneRow(var comtxt: string);
  procedure GetEndpoints(pLine: TpGraphel; var xl,xr,yline : integer);
  procedure LineBetween(pLine: TpGraphel; xx,yy: integer; above: boolean; var noline: boolean);
  procedure SortList(GrelList: TList);
  procedure ConstructEquation(var equ: string);
  procedure CollectText(pList : TpList; var txc: string);
end;

var
  Graphic : TGraphiq;
  pCtrlBut : TpSpeedButton;   {button on the main form controlling the visibility of MenuForm}
  pMainForm : TpForm;
  pVarList : TpStringList;
  pEquivList : TpStringList;
  pEquivEdit : TpEdit;
  PartStrings : TStringList;
  TempList : TStringList;
{define a collection of variables, for transoport}
type
  TMulti = record
  pp : longint;
  xx : integer;
  yy : integer;
end;
{and pointer to this type of record}
type
  TpMulti = ^TMulti;
  TpImage = ^TImage;

const
  grid_y = {4}8{16};  {grid spacing in y-direction (must always snap to grid in y-direction)}
  mark_w = 8;  {width of marking square}
  move_w = 25; {widht of square for moving}
  but_w = 16;  {width of button}
  text_w = 6;  {width of the line surrounding a text (not needed?)}
  text_h : integer = 16;   {height of text, updated in TGraphiq.create}
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - procedures - - - - - - - -
procedure BigDelay;
{Long delay for testing that a procedure is called}
var
  ll,kk,mm : longint;
begin
  kk := 0;
  for ll := 1 to 1000000000 do begin
//    for mm := 1 to 2 do begin
      kk := kk+1;
//    end;
  end;
end;

function NearestGrid(Xin:Integer;Half:Boolean):Integer;
{Calculates the nearest grid point for a given integer
 If Half = true, use denser grid = half of default
 Xin      the integer for which the nearest grid point is calculated (in)
 Half     flag for denser grid}
var
  iapu : integer;
  ipu  : integer;
  ng   : integer;
begin
  {normal or denser grid ?}
  if (Half) then iapu := grid_y div 2
  else           iapu := grid_y;
  {because "div" rounds into direction of zero (0), must treat
   pos. and neg. Xin separately}
  if (Xin >= 0) then begin
    ng :=iapu*((Xin+(iapu div 2) ) div iapu);
  end else begin
    {if Xin = iapu div 2 + N*iapu, must round upwards, as is done in the pos.side}
    ipu := (Xin+(iapu div 2)) div iapu;
    if (ipu*iapu-(iapu div 2) = Xin) then ng := ipu*iapu
    else    ng :=iapu*((Xin-(iapu div 2) ) div iapu);
  end;
  NearestGrid := ng;
end;

function WithoutLTspaces(line: string): string;
{remove leading and trailing spaces}
var
  found : boolean;  {non-space character found}
  ii,jj : integer;
  len   : integer;  {length of string}
  last  : integer;  {position of last non-space character}
  txt   : string;   {temporary}
begin
  len := length(line);
  if (len > 1) and (line <> '  ') then begin
    {find last non-space char}
    last := 0;                       {initialize}
    for ii := 1 to len do begin
      jj := len-ii+1;                {from the end, backwards}
      if (line[jj] <> ' ') then begin
        last := jj;
        break;
      end;
    end;
    {not all spaces}
    if (last > 0) then begin
      {copy from first non-space char to end}
      txt := '';
      found := false;
      for ii := 1 to last do begin
        if (line[ii] <> ' ') then begin  {nonspace, but was it first}
          txt := txt+line[ii];
          found := true;
        end else begin
          {include space, if after some non-space char}
          if (found) then txt := txt+line[ii];
        end;
      end;
      WithoutLTspaces := txt;          {copy to output}
    end else begin                    {only spaces}
      WithoutLTspaces := '';
    end;
  end else begin
    if (len = 1) and (line <> ' ') then begin
      WithoutLTspaces := line;
    end else begin
      WithoutLTspaces := '';
    end;
  end;
end;

function WithMultOperator(line: string): string;
{add the (missing) multiplication operator, when the (part-)equation
 has been written without one
 It is assumed that any leading or trailing spaces have been removed.
 Add '*' betwenn two symbols separated by space(s)
 Add '*' between a symbol and a parenthesis 'X(' => 'X*('
         or between opposing parenthese ')(' => ')*(' }
var
  aftsp  : string;    {character immediately after a space}
  befsp  : string;    {character immediately before a space}
  ii     : integer;   {index}
  len    : integer;   {length of lilne}
  prensp : string;    {previous non-space character}
  prev   : string;    {previous non-space character}
  txt    : string;    {temporary}
begin
  len := length(line);
  if (len >= 2) then begin      {copy character by character, add '*' where missing}
    txt := '';
    aftsp := '';
    befsp := '';
    prev := '';
    prensp := '';
    for ii := 1 to len do begin
      if (line[ii] = ' ') then begin                           {a space found}
        if (prev <> '') and (prev <> ' ') then befsp := prev;  {char.before space}
      end else if (line[ii] = '(' ) then begin
        {add '*' if previous (nonspace) char not an operator}
        if (prensp = '+') or (prensp = '-') or (prensp = '*') or
           (prensp = '/') or (prensp = '^') or (prensp = '(') or
           (prensp = '') then txt := txt+line[ii]
        else
          txt := txt+'*'+line[ii];
      end else begin                  {a nonspace character}
        if (prev = ' ') then begin    {previous was a space}
          aftsp := line[ii];          {copy to local}
          {no '*' if an operator before space}
          if (befsp = '+') or (befsp = '-') or (befsp = '*') or
             (befsp = '/') or (befsp = '^') or (befsp = '(') then txt := txt+aftsp
          {no '*' if an operator after space}
          else if (aftsp = '+') or (aftsp = '-') or (aftsp = '*') or
             (aftsp = '/') or (aftsp = '^') or (aftsp = ')' ) then txt := txt+aftsp
          {no operator before or after space, obviously two operands separated by space(s), add '*'}
          else
            txt := txt+'*'+aftsp;
        end else begin                {previous not a space, copy as such}
          txt := txt+line[ii];
        end;
      end;
      if (line[ii] <> ' ') then prensp := line[ii];       {save previous char.}
      prev := line[ii];
    end;
    WithMultOperator := txt;
  end else begin               {no spaces, copy as such}
    WithMultOperator := line;
  end;
end;

procedure InNothing(mm : longint);
{another dummy procedure}
begin
  {do nothing}
end;

procedure AngleTextOut(ACanvas: TCanvas; Angle, X, Y: Integer; Str: string);
var
  LogRec: TLogFont;
  OldFontHandle,
  NewFontHandle: hFont;
begin
  GetObject(ACanvas.Font.Handle, SizeOf(LogRec), Addr(LogRec));
  LogRec.lfEscapement := Angle*10;
  NewFontHandle := CreateFontIndirect(LogRec);
  OldFontHandle := SelectObject(ACanvas.Handle, NewFontHandle);
  ACanvas.TextOut(X, Y, Str);
  NewFontHandle := SelectObject(ACanvas.Handle, OldFontHandle);
  DeleteObject(NewFontHandle);
end;

procedure MultiPar(mm: longint; var pGrel: TpGraphel; var xx,yy,x1,y1,x2,y2 : integer);
{extgract the input parameters, and the coordinates
 mm     pointer to the parameters, as integer
 pGrel  pointer to the graphical element
 xx,yy  coordinates of the cursor (mouse)
 x1,y1  coordinates of one corner limiting the graphical element
 x2,y2  coordinates of the opposite corner}
var
  pMulti : TpMulti;        {pointer to the parameters}
begin
  pMulti := TpMulti(mm);  {pointer to the parameters}
  pGrel := TpGraphel(pMulti^.pp);
  {coordinates}
  xx := pMulti^.xx;
  yy := pMulti^.yy;
  {copy cordinates of the corners to local}
  x1 := pGrel^.e_x1;
  y1 := pGrel^.e_y1;
  x2 := pGrel^.e_x2;
  y2 := pGrel^.e_y2;
end;

procedure GetpMarker(indx : integer; var pMrk : TpMarkImage);
var
  ll : longint;
begin
  ll := Graphic.g_pMarkers[indx];
  pMrk := TpMarkImage(ll);
end;

procedure ShowLineMarkers(pGrel: TpGraphel; x1,y1,x2,y2 : integer);
{place and show markers at both ends of the line
 pGrel  pointer to the graphic element
 x1,y1, x2,y2  coordinates of the endpoints of the line (in arbitrafy order...)}
var
  pMrkL : TpMarkImage; {pointer to left marker}
  pMrkR : TpMarkImage; {pointer to right marker}
  w2    : integer;     {half width of the marker}
  wmi   : integer;     {width of the move-image}
  xf,yf : integer;     {coordinates of first marker }
  xs,ys : integer;     {coordinates of second marker }
  xm,ym : integer;     {coordinates for the move-image}
begin
  w2 := mark_w div 2;  {half width}
  wmi := Graphic.g_MovImg.width;
  {center of markers on the ends of line}
  { 0   1   2
    7       3
    6   5   4}
  if (pGrel^.e_linedir = ltrb) then begin          {line drawn from left top to right bottom}
    GetpMarker(0,pMrkL);  {pointer to first marker}
    GetpMarker(4,pMrkR);  {pointer to second marker}
    xf := x1-w2;
    xs := x2-w2;
    yf := y1-w2;
    ys := y2-w2;
    xm := x1-w2-wmi;
    ym := y1;
  end else if (pGrel^.e_linedir = lbrt) then begin {from left bottom to right top}
    GetpMarker(6,pMrkL);  {pointer to first marker}
    GetpMarker(2,pMrkR);  {pointer to second marker}
    xf := x1-w2;
    xs := x2-w2;
    yf := y1-w2;
    ys := y2-w2;
    xm := x2+w2;
    ym := y2;
  end else if (pGrel^.e_linedir = rtlb) then begin {from right top to left bottom}
    GetpMarker(2,pMrkL);  {pointer to first marker}
    GetpMarker(6,pMrkR);  {pointer to second marker}
    xf := x2-w2;
    xs := x1-w2;
    yf := y2-w2;
    ys := y1-w2;
    xm := x1+w2;
    ym := y1;
  end else if (pGrel^.e_linedir = rblt) then begin {from right bottom to left top}
    GetpMarker(4,pMrkL);  {pointer to first marker}
    GetpMarker(0,pMrkR);  {pointer to second marker}
    xf := x2-w2;
    xs := x1-w2;
    yf := y2-w2;
    ys := y1-w2;
    xm := x2-w2-wmi;
    ym := y2;
  end else begin          {error case, some values}
    xf := x1-w2;
    xs := x2-w2;
    yf := y1-w2;
    ys := y2-w2;
    xm := x1;
    ym := y1;
  end;
  {put the markers to right places, display}
  pMrkL^.left := xf;
  pMrkL^.top := yf;
  pMrkR^.left := xs;
  pMrkR^.top := ys;
  pMrkL^.visible := true;
  pMrkL^.enabled := true;
  pMrkR^.visible := true;
  pMrkR^.enabled := true;
  {the marker for moving the image}
  Graphic.g_MovImg.left := {((x1+x2) div 2)-(move_w div 2)}xm;
  Graphic.g_MovImg.top := {((y1+y2) div 2)-(move_w div 2)}ym;
  Graphic.g_MovImg.visible := true;
  Graphic.g_MovImg.enabled := true;
  {the button for deleting the image}
  Graphic.g_DelBut.left := {xf+w2+4}xm;
  Graphic.g_DelBut.top := {yf+w2+4}ym+wmi;
  Graphic.g_DelBut.visible := true;
  {button for moving the element to back (below other element(s9}
  Graphic.g_BackBut.left := Graphic.g_DelBut.left;
  Graphic.g_BackBut.top := Graphic.g_DelBut.top+Graphic.g_DelBut.height;
//Graphic.g_BackBut.visible := true;
end;

procedure ShowAllMarkers(x1,y1,x2,y2 : integer);
{place and show all markers around the rectangle limiting the element
 x1,y1  coordinates of upper left corner
 x2,y2  coordinates of lower right corner}
var
  ii    : integer;
  ix,iy : integer;      {coordinates}
  pMrk  : TpMarkImage;  {pointer to a marker}
  w2    : integer;      {half width of the marker}
begin
  {from upper left corner clockwise}
  w2 := mark_w div 2;
  GetpMarker(0,pMrk);
  pMrk^.left := x1-w2;
  pMrk^.top := y1-w2;
  {second}
  GetpMarker(1,pMrk);
  pMrk^.left := ((x2+x1) div 2)-w2;
  pMrk^.top := y1-w2;
  {third}
  GetpMarker(2,pMrk);
  pMrk^.left := x2-w2;
  pMrk^.top := y1-w2;
  {fourth}
  GetpMarker(3,pMrk);
  pMrk^.left := x2-w2;
  pMrk^.top := ((y1+y2) div 2)-w2;
  {fifth}
  GetpMarker(4,pMrk);
  pMrk^.left := x2-w2;
  pMrk^.top := y2-w2;
  {sixth}
  GetpMarker(5,pMrk);
  pMrk^.left := ((x1+x2) div 2)-w2;
  pMrk^.top := y2-w2;
  {seventh}
  GetpMarker(6,pMrk);
  pMrk^.left := x1-w2;
  pMrk^.top := y2-w2;
  {eighth}
  GetpMarker(7,pMrk);
  pMrk^.left := x1-w2;
  pMrk^.top := ((y1+y2) div 2)-w2;
  {markers visible}
  for ii := 0 to high(Graphic.g_pMarkers) do begin
    GetpMarker(ii,pMrk);
    pMrk^.visible := true;
    pMrk^.enabled := {true}not graphic.g_movrec;  {not when moving several elements}
  end;
  {show also the marker for moving the graphical element}
  graphic.g_MovImg.left := {ix}x1-w2-graphic.g_MovImg.width;
  graphic.g_MovImg.top := {iy}y1-w2{-graphic.g_MovImg.height};
  graphic.g_MovImg.visible := true;
  graphic.g_MovImg.enabled := true;
  {button for deleting the gr.element}
  Graphic.g_DelBut.left := {x2+w2+4}graphic.g_MovImg.left;
  Graphic.g_DelBut.top := {y1+w2+4}graphic.g_MovImg.top+graphic.g_MovImg.height;
  Graphic.g_DelBut.visible := {true}not graphic.g_movrec;  {not when moving several elements};
  {button for moving the element to back (below other element(s9}
  Graphic.g_BackBut.left := Graphic.g_DelBut.left;
  Graphic.g_BackBut.top := Graphic.g_DelBut.top+Graphic.g_DelBut.height;
//Graphic.g_BackBut.visible := true;
end;

procedure MarkersEnabled(enabled: boolean);
{set markers enabled/not}
var
  ii    : integer;
  pMrk  : TpMarkImage;  {pointer to a marker}
begin
  for ii := 0 to high(graphic.g_pMarkers) do begin
{}
  end;
end;

procedure OnLine(mm : longint);
{find, is the given point (xx, yy) on the given line (with some margins)
 mm  pointer  to the parameters
 mm.pp  pointer to the graphic element
 mm.xx  x-coordinate
 mm.yy  y-coordinate}
var
  inside : boolean;     {x,y is inside the box (rectangle)}
  kk     : single;      {interpolation coefficient}
  kx,ky  : single;      {interpolation coefficients}
  pGrel  : TpGraphel;   {pointer to the graphical element}
  xx,yy  : integer;     {xx,yy  coordinates}
  x1,y1  : integer;     {cordinates of one corner}
  x2,y2  : integer;     {cordinates of the opposite corner}
  xt,yt  : single;      {test-x, test-y}
begin
  {get parameters and corners}
  MultiPar(mm, pGrel, xx,yy,x1,y1,x2,y2);
  {vertical line, horzontal or oblique line ?}
  if (x1 = x2) then begin
  {vertical line ?}
    if (y1 = y2) then begin         {just a point, not reasonable}
      inside := false;
    end else begin
      kk := (yy-y2)/(y1-y2);         {interpolation coefficient}
      inside := (0 < kk) and (kk < 1) and
                (abs(xx-x1) < 5);    {at x1=x2, with some margin}
    end;
  end else if (y1 = y2) then begin
  {horizontal line}
    if (x1 = x2) then begin          {just a point, not reasonable}
      inside := false;
    end else begin
      kk := (xx-x2)/(x1-x2);         {interpolation coefficient}
      inside := (0 < kk) and (kk < 1) and
                (abs(yy-y1) < 5);    {at y1=y2, with some margin}
    end;
  {oblique}
  end else begin
    kx := (xx-x2)/(x1-x2);           {interpolation coefficient for x}
    ky := (yy-y2)/(y1-y2);           {..and for y}
    {oblique, but not so steep, take y as function x}
    if (abs(y1-y2) < abs(x1-x2)) then begin
      kk := (y2-y1)/(x2-x1);           {linear coefficient}
      {test y from linear equation}
      yt := y1+kk*(xx-x1);
      {on line?}
      inside := (0 < kx) and (kx < 1) and (abs(yy-yt) < 5);
    {oblique, but steep. Take x as function of y}
    end else begin
      kk := (x2-x1)/(y2-y1);           {linear coefficient}
      {test y from linear equation}
      xt := x1+kk*(yy-y1);
      {on line?}
      inside := (0 < ky) and (ky < 1) and (abs(xx-xt) < 5);
    end;
  end;
  pGrel^.e_inside := inside;
  {show the markers, if on line}
  if (inside) then ShowLineMarkers(pGrel,x1,y1,x2,y2);
end;

procedure GetCorners(ll: longint;var xu,yu,xr,yr : integer);
{get the coordinates of the upper left and lower right corners of the rectangle
 surrounding the graphical element (needed when drawing with moving mouse)
 ll     pointer to the element as integer
 xu,yu  coordinates of the upper left corner
 xr,yr  coordinates of the lower right corner}
var
  pGrel : TpGraphel;
begin
  pGrel := TpGraphel(ll);
  if (pGrel^.e_x1 < pGrel^.e_x2) then begin
    xu := pGrel^.e_x1;
    xr := pGrel^.e_x2;
  end else begin
    xu := pGrel^.e_x2;
    xr := pGrel^.e_x1;
  end;
  if (pGrel^.e_y1 < pGrel^.e_y2) then begin
    yu := pGrel^.e_y1;
    yr := pGrel^.e_y2;
  end else begin
    yu := pGrel^.e_y2;
    yr := pGrel^.e_y1;
  end;
end;

procedure InTextBox(mm : longint);
{find, is the given point (xx, yy) inside the given box (rectangle)
 mm  pointer  to the parameters
 mm.pp  pointer to the graphic element
 mm.xx  x-coordinate
 mm.yy  y-coordinate}
var
  inside : boolean;     {x,y is inside the box (rectangle)}
  pGrel  : TpGraphel;   {pointer to the graphical element}
  pMrk   : TpMarkImage; {pointer to marker}
  xx,yy  : integer;     {xx,yy  coordinates}
  x1,y1  : integer;     {coordinates of upper left corner}
  x2,y2  : integer;     {coordinates of lower right corner}
begin
  {get parameters and corners}
  MultiPar(mm, pGrel, xx,yy,x1,y1,x2,y2);
  {1 = upper left, 2 = lower right, arranged in FinishDrawing}
  inside := (xx > x1) and (xx < x2) and (yy > y1) and (yy < y2);
  pGrel^.e_inside := inside;
  {if inside, show edit-box for changing the text, and mark the element}
  if (inside) then begin
    Graphic.g_EditBox.top := pGrel^.e_y1;
    Graphic.g_EditBox.left := pGrel^.e_x1;
    Graphic.g_EditBox.width := pGrel^.e_x2-pGrel^.e_x1;
    Graphic.g_EditBox.height := pGrel^.e_y2-pGrel^.e_y1;
    Graphic.g_EditBox.font.assign(pGrel^.e_pFont^);
    Graphic.g_EditBox.text := pGrel^.e_text;
    Graphic.g_EditBox.visible := true;
    Graphic.g_EditBox.tag := longint(pGrel);           {tag = pointer to element as integer}
//  EquationMenuForm.FontBut.visible := true;
    {mark the element, if element selected}
    ShowAllMarkers(x1,y1,x2,y2);
  end;
end;

procedure InMemoBox(mm : longint);
{find, is the given point (xx, yy) inside the given box (rectangle)
 mm  pointer  to the parameters
 mm.pp  pointer to the graphic element
 mm.xx  x-coordinate
 mm.yy  y-coordinate}
var
  inside : boolean;     {x,y is inside the box (rectangle)}
  pGrel  : TpGraphel;   {pointer to the graphical element}
  pMrk   : TpMarkImage; {pointer to marker}
  xx,yy  : integer;     {xx,yy  coordinates}
  x1,y1  : integer;     {coordinates of upper left corner}
  x2,y2  : integer;     {coordinates of lower right corner}
begin
  {get parameters and corners}
  MultiPar(mm, pGrel, xx,yy,x1,y1,x2,y2);
  {1 = upper left, 2 = lower right, arranged in FinishDrawing}
  inside := (xx > x1) and (xx < x2) and (yy > y1) and (yy < y2);
  pGrel^.e_inside := inside;
  {if inside, show memo-box for changing the text, and mark the element}
  if (inside) then begin
    {position and size of memo box depends on the direction of text}
    if (pGrel^.e_quarter = east) then begin
      Graphic.g_MemoBox.top := pGrel^.e_y1;
      Graphic.g_MemoBox.left := pGrel^.e_x1;
      Graphic.g_MemoBox.width := pGrel^.e_x2-pGrel^.e_x1;
      Graphic.g_MemoBox.height := pGrel^.e_y2-pGrel^.e_y1;
    end else if (pGrel^.e_quarter = north) then begin
      Graphic.g_MemoBox.top := pGrel^.e_y2;
      Graphic.g_MemoBox.left := pGrel^.e_x1;
      Graphic.g_MemoBox.width := pGrel^.e_y2-pGrel^.e_y1;
      Graphic.g_MemoBox.height := pGrel^.e_x2-pGrel^.e_x1;
    end else if (pGrel^.e_quarter = west) then begin
      Graphic.g_MemoBox.top := pGrel^.e_y2;
      Graphic.g_MemoBox.left := pGrel^.e_x2;
      Graphic.g_MemoBox.width := pGrel^.e_x2-pGrel^.e_x1;
      Graphic.g_MemoBox.height := pGrel^.e_y2-pGrel^.e_y1;
    end else if (pGrel^.e_quarter = south) then begin
      Graphic.g_MemoBox.top := pGrel^.e_y1;
      Graphic.g_MemoBox.left := pGrel^.e_x2;
      Graphic.g_MemoBox.width := pGrel^.e_y2-pGrel^.e_y1;
      Graphic.g_MemoBox.height := pGrel^.e_x2-pGrel^.e_x1;
    end else begin                                           {error case}
      Graphic.g_MemoBox.top := pGrel^.e_y1;
      Graphic.g_MemoBox.left := pGrel^.e_x1;
      Graphic.g_MemoBox.width := pGrel^.e_x2-pGrel^.e_x1;
      Graphic.g_MemoBox.height := pGrel^.e_y2-pGrel^.e_y1;
    end;
    Graphic.g_MemoBox.font := pGrel^.e_pFont^;
    Graphic.g_MemoBox.text := pGrel^.e_text;
    Graphic.g_MemoBox.visible := true;
    Graphic.g_MemoBox.tag := longint(pGrel);           {tag = pointer to element as integer}
    EquationMenuForm.FontBut.visible := true;
    {mark the element, if element selected}
    ShowAllMarkers(x1,y1,x2,y2);
  end;

end;

procedure DrawNothing(ll : longint);
{dummy procedure
 ll  parameter (not used yet ?!)}
begin
  {do nothing}
end;

procedure DrawLine(ll: longint);
{procedure for drawing a line, horizontal in this case!}
var
  pGrel : TpGraphel;
begin
  pGrel := TpGraphel(ll);
  pGrel^.e_toile.MoveTo(pGrel^.e_x1,pGrel^.e_y1);
  pGrel^.e_toile.LineTo(pGrel^.e_x2,pGrel^.e_y2);
end;

procedure DrawTextBox(ll: longint);
{procedure for drawing a rectangle fow writing text in it}
var
  ii    : integer;
  pGrel : TpGraphel;
  xx,yy : integer;
begin
  pGrel := TpGraphel(ll);
  {when initially drawing with the mouse, draw only a rectangle..}
  if (Graphic.g_drawing) and ((EquationMenuForm.TextBut.down) or
                              (EquationMenuForm.PowerBut.down)) then begin
    pGrel^.e_toile.rectangle(pGrel^.e_x1,pGrel^.e_y1,pGrel^.e_x2,pGrel^.e_y2)
  {but when refreshing, then draw only the text, no rectangle}
  end else begin
    xx := pGrel^.e_x1+2;
    yy := pGrel^.e_y1+2;
    pGrel^.e_toile.font.assign(pGrel^.e_pFont^);
    AngleTextOut(pGrel^.e_toile, 0, xx, yy, pGrel^.e_text);
  end;
end;

procedure DrawMemoBox(ll: longint);
{procedure for drawing a rectangle for writing text in it}
var
  cnt   : integer;      {number of lines}
  hh    : integer;      {height of one line of text}
  dth   : integer;      {distance from line to line in y-direction}
  ii    : integer;
  pGrel : TpGraphel;
  xx,yy : integer;
begin
  pGrel := TpGraphel(ll);
  {when initially drawing with the mouse, draw only a rectangle..}
  if (Graphic.g_drawing) and (EquationMenuForm.MemoBut.down) then begin
    pGrel^.e_toile.rectangle(pGrel^.e_x1,pGrel^.e_y1,pGrel^.e_x2,pGrel^.e_y2);
  {but when refreshing, then draw only the text, no rectangle}
  end else begin
    {write line by line. Must copy text to memo in order to find the lines. Cleared below!!!}
    {...but not if there is not yet text in the gr.element (still writing)}
    if (length(pGrel^.e_text) > 0) then begin
      {use existing memo-component} {EI hyv viel...???}
      EquationMenuForm.DummyMemo.text := pGrel^.e_text;
      EquationMenuForm.DummyMemo.font.assign(pGrel^.e_pFont^);
      {starting point of the the text}
      xx := pGrel^.e_xtx+2;
      yy := pGrel^.e_ytx+2;
      Graphic.MemoTextOut(@EquationMenuForm.DummyMemo,xx,yy,pGrel);
      EquationMenuForm.DummyMemo.text := '';
    end;
  end;
end;

procedure GetPartStrings(line: string; ipParts: longint{TpStringList});
{pick part-strings from line, separated by semicolon(s))
 line    the string with several part-strings
 pParts  string list where the part strings are collected}
var
  ii     : integer;
  len    : integer;      {length of line}
  pParts : TpStringList; {list of the part-strings}
  psp    : boolean;      {previous was a semicolon}
  txt    : string;       {temporary}
begin
  pParts := TpStringList(ipParts);
  pParts^.clear;
  len := length(line);
  if (len > 0) then begin
    txt := '';
    psp := false;
    for ii := 1 to len do begin
      if (line[ii] = ';') then begin   {semicolon? separating part-strings}
        if (psp) then begin            {previous was also a semicolon, do nothing}
          {..}
        end else begin                 {first semicolon after text}
          if (ii = 1) then begin       {first char. may be a semicolon, do nothing}
            {..}
          end else begin
            pParts^.add(txt);          {put text to string list (space = separator)}
            txt := '';
          end;
        end;
        psp := true;                   {this was a semicolon}
      end else begin                   {not a semicolon}
        txt := txt+line[ii];
        psp := false;
      end;
    end;
    {the last part-string, if any, must be added}
    if (txt <> '') then pParts^.add(txt);
  end;
end;

function IsInteger(line: string; var kk : integer): boolean;
{check, does the text in line represent an integer
 line  the text to be studied
 kk    the value of the integer, if line is one}
var
  ii  : integer;  {index}
  int : boolean;  {is/not an integer}
  len : integer;  {length of line}
begin
  len := length(line);
  if (len > 0) then begin
    int := true;                              {initialize}
    for ii := 1 to len do begin
      if ((line[ii] >= '0') and (line[ii] <= '9')) or   {number...}
         ((ii = 1) and (line[ii] = '-'))then begin      {..or a minus sign}
        {ok, do nothing}
      end else begin
        int := false;                         {not integer, error, break}
        break;
      end;
    end;
    {continue, if is integer}
    if (int) then kk := strtoint(line)         {get the integer}
    else kk := 0;                              {just some value}
  end else begin
    int := false;
    kk := 0;
  end;
  IsInteger := int;
end;

{procedures for recalling (recovering?) graphical elements from a string list (from a file) - - - - -}
procedure RecallElement(var ll: longint; line: string);
{create the element
 ll   pointer to the element, as integer
 line index = type of element as string}
var
  indx : integer;  {index = type of the graphical element}
begin
  {proceed only if line represents an integer}
  if (IsInteger(line, indx)) then begin
    Graphic.CreateAndAddGraphicElement(indx);
    ll := longint(Graphic.g_List.last);  {pointer to the new (last) element}
  end else begin                 {no integer, error}
    ll := 0;                     {nil-pointer}
  end;
end;

procedure RecallCoordinates(var ll: longint; line: string);
{recall the coordinates of the rectangle surrounding the graph.element
 The coordinates are packed in one line (one string), as x1;y1;x2;y2
 separated by semicolons
 ll   pointer to the graphical element, as integer
 line the string containing the coordinates}
var
  pGrel       : TpGraphel;  {pointer to the graphical element}
  t1,u1,t2,u2 : string;     {coordinates as strings}
  x1,y1       : integer;    {coordinates of upper left corner}
  x2,y2       : integer;    {coordinates of lower right corner}
begin
  pGrel := TpGraphel(ll);                        {pointer to the graphical element}
  if (pGrel <> nil) then begin                   {continue, if element exists}
    GetPartStrings(line, longint(@PartStrings)); {get the coordinates separately, as stings}
    {there should be 4 coordinates}
    if (PartStrings.count >= 4) then begin
      t1 := PartStrings[0];                   {pick the coordinates as strings}
      u1 := PartStrings[1];
      t2 := PartStrings[2];
      u2 := PartStrings[3];
      {continue, if all strinds represent integers, convert to integers}
      if (IsInteger(t1,x1)) and (IsInteger(u1,y1)) and
         (IsInteger(t2,x2)) and (IsInteger(u2,y2)) then begin
        pGrel^.e_x1 := x1;
        pGrel^.e_y1 := y1;
        pGrel^.e_x2 := x2;
        pGrel^.e_y2 := y2;
      end else begin                          {not integers, errors}
        pGrel^.e_x1 := 0;
        pGrel^.e_y1 := 0;
        pGrel^.e_x2 := 0;
        pGrel^.e_y2 := 0;
      end;
    end else begin                            {not coordinates, some error}
      pGrel^.e_x1 := 0;
      pGrel^.e_y1 := 0;
      pGrel^.e_x2 := 0;
      pGrel^.e_y2 := 0;
    end;
  end;
  {initial guess for start position of text. NOTE this works only, if x1,y1 read first, of course}
  pGrel^.e_xtx := pGrel^.e_x1;
  pGrel^.e_ytx := NearestGrid(pGrel^.e_y1,false);
end;

procedure RecallStartPos(var ll: longint; line: string);
{recall the coordinates of the starting position of text.
 The coordinates are packed in one line (one string), as x1;y1
 separated by semicolon
 ll   pointer to the graphical element, as integer
 line the string containing the coordinates}
var
  pGrel       : TpGraphel;  {pointer to the graphical element}
  t1,u1       : string;     {coordinates as strings}
  x1,y1       : integer;    {coordinates of start position}
begin
  pGrel := TpGraphel(ll);                        {pointer to the graphical element}
  if (pGrel <> nil) then begin                   {continue, if element exists}
    GetPartStrings(line, longint(@PartStrings)); {get the coordinates separately, as stings}
    {there should be 2 coordinates}
    if (PartStrings.count >= 2) then begin
      t1 := PartStrings[0];                   {pick the coordinates as strings}
      u1 := PartStrings[1];
      {continue, if all strinds represent integers, convert to integers}
      if (IsInteger(t1,x1)) and (IsInteger(u1,y1)) then begin
        pGrel^.e_xtx := x1;
        pGrel^.e_ytx := NearestGrid(y1,false);
      end else begin                          {not integers, errors}
        pGrel^.e_xtx := pGrel^.e_x1;
        pGrel^.e_ytx := NearestGrid(pGrel^.e_y1,false);
      end;
    end else begin                            {not coordinates, some error}
        pGrel^.e_xtx := pGrel^.e_x1;
        pGrel^.e_ytx := NearestGrid(pGrel^.e_y1,false);
    end;
  end;
end;

procedure RecallPenColor(var ll: longint; line: string);
{recall and save the color pf the pen
 ll    pointer to the element
 line  the color as string}
var
  ipu   : integer;    {temporary}
  kk    : longint;    {temporary}
  pGrel : TpGraphel;  {pointer to the graphical element}
begin
  pGrel := TpGraphel(ll);                     {pointer to the graphical element}
  if (pGrel <> nil) then begin                {continue, if element exists}
    if (IsInteger(line,ipu)) then begin       {does the line represent an integer}
      kk := strtoint(line);                   {must be longint, if color}
      pGrel^.e_pencolor := TColor(kk);
    end;
  end;
end;

procedure RecallBrushColor(var ll: longint; line: string);
{recall and save the color of the brush (background)
 ll    pointer to the element
 line  the color as string}
var
  ipu   : integer;    {temporary}
  kk    : longint;    {temporary}
  pGrel : TpGraphel;  {pointer to the graphical element}
begin
  pGrel := TpGraphel(ll);                     {pointer to the graphical element}
  if (pGrel <> nil) then begin                {continue, if element exists}
    if (IsInteger(line,ipu)) then begin       {does the line represent an integer}
      kk := strtoint(line);                   {must be longint, if color}
      pGrel^.e_brushcolor := TColor(kk);
    end;
  end;
end;

procedure RecallPenWidth(var ll: longint; line: string);
{recall and save the width the pen
 ll    pointer to the element
 line  the width as string}
var
  ipu   : integer;    {temporary}
  pGrel : TpGraphel;  {pointer to the graphical element}
begin
  pGrel := TpGraphel(ll);                     {pointer to the graphical element}
  if (pGrel <> nil) then begin                {continue, if element exists}
    if (IsInteger(line,ipu)) then begin       {does the line represent an integer}
      pGrel^.e_penwidth := ipu;
    end;
  end;
end;

procedure RecallQuarter(var ll: longint; line: string);
{recall and save the quarter (direction) of directional elements
 ll    pointer to the element
 line  the quarter as string}
var
  ipu   : integer;    {temporary}
  kk    : longint;    {temporary}
  pGrel : TpGraphel;  {pointer to the graphical element}
begin
  pGrel := TpGraphel(ll);                     {pointer to the graphical element}
  if (pGrel <> nil) then begin                {continue, if element exists}
    if (IsInteger(line,ipu)) then begin       {does the line represent an integer}
      kk := strtoint(line);                   {must be longint}
      pGrel^.e_quarter := TQuarter(kk);
    end;
  end;
end;

procedure RecallDirection(var ll: longint; line: string);
{recall and save the drawing direction of lines
 ll    pointer to the element
 line  the direction as string}
var
  ipu   : integer;    {temporary}
  kk    : longint;    {temporary}
  pGrel : TpGraphel;  {pointer to the graphical element}
begin
  pGrel := TpGraphel(ll);                     {pointer to the graphical element}
  if (pGrel <> nil) then begin                {continue, if element exists}
    if (IsInteger(line,ipu)) then begin       {does the line represent an integer}
      kk := strtoint(line);                   {must be longint}
      pGrel^.e_linedir := TLinedir(kk);
    end;
  end;
end;

procedure RecallSubtype(var ll: longint; line: string);
{recall and save the subtype of the element
 ll    pointer to the element
 line  the subtype as string}
var
  ipu   : integer;    {temporary}
  kk    : integer;    {temporary}
  pGrel : TpGraphel;  {pointer to the graphical element}
begin
  pGrel := TpGraphel(ll);                     {pointer to the graphical element}
  if (pGrel <> nil) then begin                {continue, if element exists}
    if (IsInteger(line,ipu)) then begin       {does the line represent an integer}
      kk := strtoint(line);                   {must be longint}
      pGrel^.e_type := kk;
    end;
  end;
end;

procedure RecallText(var ll: longint; line: string);
{recall and save the text of an element
 ll    pointer to the element
 line  the direction as string}
var
  pGrel : TpGraphel;  {pointer to the graphical element}
begin
  pGrel := TpGraphel(ll);                     {pointer to the graphical element}
  if (pGrel <> nil) then begin                {continue, if element exists}
    pGrel^.e_text := line;
  end;
end;

procedure RecallFont(var ll: longint; line: string);
{recall and save the font of a graphical element (text element)
 ll    pointer to the element as integer
 line  a string (line of text) containing the font properties}
var
  cnt   : integer;    {number of part strings = properties}
  fs    : integer;    {font style, coded}
  ipu   : integer;    {temporary}
  kk    : longint;    {temporary}
  npn   : integer;    {number of parts in the font name}
  pGrel : TpGraphel;  {pointer to the graphical element}
  txt   : string;     {temporary}
begin
  pGrel := TpGraphel(ll);                        {pointer to the graphical element}
  if (pGrel <> nil) then begin                   {continue, if element exists}
    GetPartStrings(line, longint(@PartStrings)); {get the properties separately, as stings}
    {there should be 4 properties: name, style (coded), size, color)...}
    {...but the name can have several parts (like 'Bookman Old Style')}
    cnt := PartStrings.count;                 {number of properties}
    if (cnt >= 4) then begin
      {name . . . .}
      pGrel^.e_pFont^.name := PartStrings[0]; {name as such, as first}
      {style . . . .}
      txt := PartStrings[1];                  {style, coded}
      pGrel^.e_pFont^.style := [];            {initialize as regular = empty set}
      {should be an integer}
      if (IsInteger(txt,fs)) then begin
        if (fs = 1) then begin                {bold}
          pGrel^.e_pFont^.style := [fsBold];
        end else if (fs = 2) then begin
          pGrel^.e_pFont^.style := [fsItalic];
        end else if (fs = 3) then begin
          pGrel^.e_pFont^.style := [fsBold,fsItalic];
        end;
      end;
      {size . . . . .}
      txt := PartStrings[2];
      if (IsInteger(txt,ipu)) then pGrel^.e_pFont^.size := ipu;
      {color . . . . .}
      txt := PartStrings[3];
      if (IsInteger(txt,ipu)) then begin
        kk := strtoint(txt);
        pGrel^.e_pFont^.color := TColor(kk);
      end;
    end;
  end;
end;

procedure RecallVariables(var ll: longint; line: string);
{recall the name and value of a variable packed in one line,
 separated by a semicolon, as name;value
 ll   pointer to the graphical element, as integer (not needed here?)
 line the string containing the name and value}
var
  nam : string;  {name of variable}
  val : string;  {value of the variable}
begin
  GetPartStrings(line, longint(@PartStrings));  {get the coordinates separately, as stings}
  {there should be 2 strings}
  if (PartStrings.count >= 2) then begin
    nam := PartStrings[0];                  {pick the name as string}
    val := PartStrings[1];                  {and the value}
    {add to the string list for moving}
    Graphic.g_pVarList.add(nam);
    Graphic.g_pVarList.add(val);
  end;
end;

procedure RecallEquationName(var ll: longint; line: string);
{recall the name of the equaion
ll    pointer to the graphical element, not needed here
line  the string = the name}
begin
  Graphic.g_EquName := line;
end;

procedure RecallEquation(var ll: longint; line: string);
{recall the the equaion
ll    pointer to the graphical element, not needed here
line  the string = the name}
begin
  Graphic.g_Equation := line;
end;

procedure RecallEquivalencies(var ll: longint; line: string);
{recall the the equivalencies between (some) variables in the human readable equation
 and the parameters in the PQrelay.
 ll   pointer to the graphical element, as integer (not needed here?)
 line the string containing the name and value}
const
  cnt : integer = 0;
var
  nam : string;  {name of variable}
  val : string;  {value of the variable}
begin
  inc(cnt); if (cnt > 3) then cnt := 0;
  {save text as such, process separately in EquivEditChange of Graph (or...?)}
  Graphic.g_pEquivList^.add(line);                       {save as such, process separately in...}
  pEquivEdit^.text := TimeToStr(time)+' '+inttostr(cnt); {for onChange in main form}
end;

procedure DummyRecall(var ll: longint; line: string);
begin
  {do nothing...}
end;

constructor TGraphiq.create;
{pForm    pointer to the form, where shapes/graphs drawn
 grIndex  group index for the buttons for selecting the shape}
var
  pBut   : TpSpeedBut;
  But    : TSpeedButton;
  ii     : integer;  {index}
  nn     : integer;  {counter}
begin
  inherited Create;
  g_List := TList.create;          {create list for pointers to the shapes}
  g_LineList := TList.create;      {create list for lines}
  g_TextList := TList.create;      {create list for all texts}
  g_TextListA := TList.create;     {temporary list for texts (above line)}
  g_TextListU := TList.create;     {temporary list for texts (under line)}
  g_Inside := TList.create;
{!  g_pForm := pMainForm;            {pointer to the form, where drawn. pMainForm. ...}
{!  g_pVarList := pVarList;          {pointer to variables in the list}
{!  g_pEquivList := pEquivList;      {for correspondent names in equations and PQ-relays}
  g_PenColor := clBlack;
  g_Penwidth := 2;
  g_BrushColor := clWhite;
  g_quarter := east;              {default (only!)oriention}
  g_pGraph := nil;
{!  g_canvas := pMainForm^.canvas;
  g_movrec := false;
  g_x1 := 0; g_y1 := 0;
  g_x2 := 0; g_y2 := 0;
  {}                              {...must be assigned in the "create" procedure of the main form}
  {procedures for drawing different shapes into an array}
  DrawGraphel[0] := DrawNothing;
  DrawGraphel[1] := DrawNothing;
  DrawGraphel[2] := DrawNothing;
  DrawGraphel[3] := DrawLine;
  DrawGraphel[4] := DrawNothing;
  DrawGraphel[5] := DrawNothing;
  DrawGraphel[6] := DrawTextBox;
  DrawGraphel[7] := DrawMemoBox;
  {procedures for checking, is given point inside shape (graph.element)}
  InGraphel[0] := InNothing;
  InGraphel[1] := InNothing;
  InGraphel[2] := InNothing;
  InGraphel[3] := OnLine;
  InGraphel[4] := InNothing;
  InGraphel[5] := InNothing;
  InGraphel[6] := InTextBox;
  InGraphel[7] := InMemoBox;
  {procedures for recalling saved elements}
  RecalEl[1] := RecallElement;
  RecalEl[2] := RecallCoordinates;
  RecalEl[3] := RecallPenColor;
  RecalEl[4] := RecallBrushColor;
  RecalEl[5] := RecallPenWidth;
  RecalEl[6] := RecallQuarter;
  RecalEl[7] := RecallDirection;
  RecalEl[8] := RecallText;
  RecalEl[9] := RecallFont;
  RecalEl[10] := RecallStartPos;
  RecalEl[11] := RecallSubtype;
  RecalEl[12] := RecallVariables;
  RecalEl[13] := RecallEquationName;
  RecalEl[14] := RecallEquation;
  RecalEl[15] := RecallEquivalencies;
  RecalEl[16] := DummyRecall;
  RecalEl[17] := DummyRecall;
  RecalEl[18] := DummyRecall;
  RecalEl[19] := DummyRecall;
  RecalEl[20] := DummyRecall;
  g_ShapeIndex := 0;
  g_type := 0;
{!  CreateMarkers;                 {the small squares for marking selected element in the main form}
{!  CreateEditBox;                 {edit-component in the main form for editing texts}
{!  CreateMemoBox;                 {memo-component in the main for for editing lines of text}
{!  {copy font to initialize font dialogue}
{!  EquationMenuForm.FontDlg.font.assign(g_EditBox.font);
{!  {find height of text}
{!  EquationMenuForm.Canvas.font.assign(g_EditBox.font);  {use canvas of form...}
{!  text_h := EquationMenuForm.Canvas.textheight('A');    {..to find text height}
  {create list of elements as strings}
  g_ElList := TStringList.create;
  PartStrings := TStringList.create;
end;

destructor TGraphiq.destroy;
var
  ll,kk,mm : longint;
begin
{just testing that this procedure is called... A long delay when closing..}
//  BigDelay;
  {the graphic elements are free'ed first, in TDrawMenuForm.FormDestroy (with FreeGraphicElements)}
  g_List.free;           {free the list of pointers to graphic elements}
  g_Inside.free;
  g_ElList.free;
  g_LineList.free;
  g_TextList.free;
  g_TextListA.free;
  g_TextListU.free;
  inherited Destroy;
end;

procedure TGraphiq.initialize;
{called in ... from InitializeGraphich in PointerEditChange of Equation.pas}
begin
  g_pForm := pMainForm;
  g_canvas := pMainForm^.canvas;
  g_pVarList := pVarList;        {pointer to variables in the list}
  g_pEquivList := pEquivList;    {for correspondent names in equations and PQ-relays}
  CreateMarkers;                 {the small squares for marking selected element in the main form}
  CreateEditBox;                 {edit-component in the main form for editing texts}
  CreateMemoBox;                 {memo-component in the main for for editing lines of text}
  {copy font to initialize font dialogue}
  EquationMenuForm.FontDlg.font.assign(g_EditBox.font);
  {find height of text}
  EquationMenuForm.Canvas.font.assign(g_EditBox.font);  {use canvas of form...}
  text_h := EquationMenuForm.Canvas.textheight('A');    {..to find text height}
end;

procedure TGraphiq.putpForm(pForm: TpForm);
begin
  g_pForm := pForm;
end;

function TGraphiq.pActiveElementIf: TpGraphel;
{get the pointer to the active (clicked) graphical element, if some element is active
 = the "image" for moving the graphic element is visible}
var
  pMrk0 : TpMarkImage;  {pointer to marker of upper left corner}
begin
  {the pointer is saved to the first marker in StartDrawing}
  if (g_MovImg.visible) then begin
    GetpMarker(0,pMrk0);                            {pointer to first marker = upper left corner}
    pActiveElementIf := TpGraphel(pMrk0^.m_ipGrel); {pointer to the selected graph.element..}
    {...}                                           {...saved in TGraphiq.StartDrawing}
  end else if (g_MemoBox.visible) then begin        {editing the text in the memo = element created}
    pActiveElementIf := g_List.last;
  end else begin
    pActiveElementIf := nil;
  end;
end;

procedure TGraphiq.SetElementQuarterIf(quarter: TQuarter);
{set the direction a graphical element, if element selected = active.
 Used, when some of the arrow (direction) buttons in the menu is clicked}
begin
  if (pActiveElementIf <> nil) then begin
    pActiveElementIf^.e_quarter := quarter;
    g_pForm.invalidate;           {drawn in FormPaint of the main form}
  end;
end;

procedure TGraphiq.SetElementPenColorIf(col: TColor);
{set the pen color of a graphical element, if element selected = active.
 Used, when some of the color buttons in the menu}
begin
  if (pActiveElementIf <> nil) then begin
    pActiveElementIf^.e_penColor := col;
    g_pForm.invalidate;           {drawn in FormPaint of the main form}
  end;
end;

procedure TGraphiq.SetElementPenWidthIf(width: integer);
{set the pen width of a graphical element, if element selected = active.
 Used, when some of the color buttons in the menu}
begin
  if (pActiveElementIf <> nil) then begin
    pActiveElementIf^.e_penWidth := width;
    g_pForm.invalidate;           {drawn in FormPaint of the main form}
  end;
end;

procedure TGraphiq.SetElementBrushColorIf(col: TColor);
{set the brush color of a graphical element, if element selected = active.
 Used, when some of the color buttons in the menu}
begin
  if (pActiveElementIf <> nil) then begin
    pActiveElementIf^.e_BrushColor := col;
    g_pForm.invalidate;           {drawn in FormPaint of the main form}
  end;
end;

procedure TGraphiq.SortList(GrelList: TList);
{sort the list of graphical elements according to the e_crit of each element
(Note, e_crit must be prepared first)
 Largest first  (e_temp is used for sorting)
 GrelList  the list of graphical elements}
var
  icor   : integer;   {index of correct position}
  ii,jj  : integer;   {index}
  ips    : integer;   {index of position in study}
  leni   : integer;   {criteria for element ii}
  lenj   : integer;   {criteria for element jj}
  lnot   : integer;   {index of first element that is not in correct position}
  pGrel  : TpGraphel; {pointer to a graphical element}
  pGrelj : TpGraphel; {pointer to a graphical element}
begin
  {sort, largest first. Not many lines, simple method used}
  if (GrelList.count > 1) then begin
    for ii := 0 to GrelList.count-1 do begin
      pGrel := GrelList[ii];                          {pointer to a line}
      leni := pGrel^.e_crit;                          {criterium(?) of element ii}
      {count, how many elements larger than ii}
      for jj := ii+1 to GrelList.count-1 do begin
        pGrelj := GrelList[jj];
        lenj := pGrelj^.e_crit;                       {criterium of line jj}
        if (lenj >= leni) then inc(pGrel^.e_temp)
        else inc(pGrelj^.e_temp);
      end;
    end;
    {arrange, longest first}
    {n-1 exchanges should be enough (?)}
    pGrel := GrelList[0];                       {initialize to first element}
    ips := 0;                                   {initialize frst that is not in position}
    for ii := 0 to GrelList.count-2 do begin
      if (ips <> pGrel^.e_temp) then begin      {not in correct position}
        icor := pGrel^.e_temp;                  {index of correct position}
        GrelList.exchange(ips,icor);            {exchange, [ips] goes to [icor], and vv}
        pGrel := GrelList[ips];
      end else begin                            {is in correct pos, go to next}
        inc(ips);
        pGrel := GrelList[ips];
      end;
    end;
  end;
end;

procedure TGraphiq.CopyTextsAndPointers;
{copy the pointers text-elements from the list of all elements..
 copy texts, remove leading and trailing spaces}
var
  ii      : integer;
  pGrel   : TpGraphel;
  txt,txx : string;
  txy     : string;
begin
  g_TextList.clear;
  if (g_List.count > 0) then begin
    for ii := 0 to g_List.count-1 do begin
      pGrel := g_List[ii];                  {pointer to a graphical element}
      if (pGrel^.e_shape = 6) then begin    {text-element}
        {copy and remove leading and trailing spaces}
        txt := WithoutLTspaces(pGrel^.e_Text);    {copy text for processing}
        {add multiplication '*', if missing between adjacent items}
        txy := WithMultOperator(txt);
        {for powers, must add power operator}
        if (pGrel^.e_type = 1) then txx := '^'+txy
        else txx := txy;
        {after these checks, save the possibly modified string}
        pGrel^.e_Ctext := txx;
        g_TextList.add(pGrel);              {add to list of texts}
        pGrel^.e_temp := 0;                 {initialize}
      end;
    end;
  end;
end;

procedure TGraphiq.CopyAndSortLines;
{copy lines to a separate list. Sort after length}
var
  ii,jj     : integer;
  ipos      : integer;     {index of correct position}
  leni,lenj : integer;     {lengths of lines}
  lnot      : integer;     {first line that is not in correct position, when arranging}
  pGrel     : TpGraphel;   {pointer to a graphical element}
  pGrelj    : TpGraphel;   {pointer to a graphical element}
begin
  g_LineList.clear;
  if (g_List.count > 0) then begin
    for ii := 0 to g_List.count-1 do begin
      pGrel := g_List[ii];                                {pointer to a graphical element}
      if (pGrel^.e_shape = 3) then begin
        g_LineList.add(pGrel); {add to list of lines}
        pGrel^.e_temp := 0;    {initialize}
      end;
    end;
    {sort, longest first. Not many lines, simple method used}
    {put lengths of lines to the position reserved for criterium}
    if (g_LineList.count > 1) then begin
      for ii := 0 to g_LineList.count-1 do begin
        pGrel := g_LineList[ii];                          {pointer to a line}
        pGrel^.e_crit := abs(pGrel^.e_x2-pGrel^.e_x1);    {length of the line}
      end;
      SortList(g_LineList);
    end;
  end;
end;

procedure TGraphiq.GetEndpoints(pLine: TpGraphel; var xl,xr, yline : integer);
{get the x- and y-coordinates of the endpoints of the given horizontal line
 pLine  pointer to the line
 xl,xr  x-coordinate of the left and right ends}
begin
  if (pLine^.e_x1 < pLine^.e_x2) then begin
    xl := pLine^.e_x1;     {x of left end}
    xr := pLine^.e_x2;     {x of right end}
  end else begin
    xl := pLine^.e_x2;
    xr := pLine^.e_x1;
  end;
  yline := pLine^.e_y1;             {y of line}
end;

procedure TGraphiq.LineBetween(pLine: TpGraphel; xx,yy: integer; above: boolean; var noline: boolean);
{check, is there a line between the text and line under study
 pLine  pointer to the line under study
 xx,yy  starting point of the text (upper left corner)
 above  if true, text is above the selected line, else under
 noline true, if there is no line between the text and line}
var
  AU      : integer;    {above or under}
  jj      : integer;    {index}
  pLinej  : TpGraphel;  {pointer to a line}
  xjl,xjr : integer;    {x-coordinates (left, right) of the endpoints of the line jj}
  yj      : integer;    {y-coordinate of a line}
  yline   : integer;    {y-coordinate of the line under study}
begin
  yline := pLine^.e_y1;                            {y coord. of the line}
  if (above) then AU := 1 else AU := -1;
  noline := true;                                  {initialize}
  for jj := 0 to g_LineList.count-1 do begin       {scan (again)all lines}
    pLinej := g_LineList[jj];                      {pointer to some line}
    if (pLinej <> pLine) then begin                {skip the line under study}
      GetEndpoints(pLinej, xjl, xjr, yj);          {get coordinate of the ends of the line}
      {is line under text, and above line under study? or the other way around?}
      if (AU*yj >= AU*yy) and (AU*yj < AU*yline) then begin    {line is in between?}
        {must still check position in x-direction}
        if (xjl <= xx) and (xx <= xjr) then begin  {same x-position as the text}
          noline := false;                         {line is between, text is not counted}
          break;
       end;
     end;
   end;
  end;
end;

procedure TGraphiq.GetTextAboveAndBelowLine(pLine: TpGraphel);
{find the texts that are (immediately) above and under the given line
 pLine  pointer to the line }
var
  ii,jj   : integer;
  noline  : boolean;    {flag: no line(s) between text and given line}
  pGrel   : TpGraphel;  {pointer to graphical element}
  pLinej  : TpGraphel;  {pointer to some line}
  xjl,xjr : integer;    {x-coordinates of the ends of a line}
  yj      : integer;    {y-coordinate of a line}
  xl,xr   : integer;    {x-coordinates of left, right end of line}
  yline   : integer;    {y-coordinate of line}
  xx,yy   : integer;    {position of text (upper left corner = rotation point)}
begin
  g_TextListA.clear;    {initially clear lists of text above and under given line}
  g_TextListU.clear;
  if (pLine <> nil) then begin
    GetEndpoints(pLine, xl, xr, yline);      {get x-coordinate of the ends of the line}
    {scan all elements, select texts, check are they near to the line (over or under)}
    if (g_TextList.count > 0) then begin
      for ii := 0 to g_TextList.count-1 do begin
        pGrel := g_TextList[ii];
        if (pGrel^.e_shape = 6) then begin          {text box}
          xx := pGrel^.e_xtx;                       {position of text box}
          yy := pGrel^.e_ytx;
          {text starts within the width of the line with a small margin}
          if (xx > xl-2) and (xx < xr-8) then begin
            {is text above line. Note, y increases downwards! text_h = height of text}
//showmessage('above '+pGrel^.e_text+'  '+inttostr(yy)+'  '+inttostr(yline)+'  '+inttostr(text_h));
            if  (yy <= yline-text_h) then begin
              {must check that there are no other lines between text and the given line}
              LineBetween(pLine, xx,yy, true{above}, noline);
              {include text, if no line between}
              if (noline) then g_TextListA.add(pGrel);
{pitisik nyt pGrel poistaa tekstiluettelosta?}
            end else if  (yy > yline-grid_y) then begin  {??? yy voi olla hiukan viivan ylpuolella!!??}
            {or is the text below the line}
              {must check that there are no other lines between text and the given line}
              LineBetween(pLine, xx,yy, false{above}, noline);
              {include text, if no line between}
              if (noline) then g_TextListU.add(pGrel);
            end;
          end;
        end;
      end;
    end;
  end;
end;

procedure TGraphiq.CollectText(pList : TpList; var txc: string);
{collect texts in the elements of the list to one string}
var
  cnt      : integer;     {number of items}
  ii       : integer;
  len,lenp : integer;     {length of text}
  ll       : integer;
  pGrel    : TpGraphel;
  txp      : string;      {previous text}
  txt      : string;      {temporary text}
begin
  txc := '';
  txp := '';
  cnt := pList^.count;
  if (cnt > 0) then begin
    for ii := 0 to cnt-1 do begin
      pGrel := pList^[ii];
      {add multiplication symbol (*) if no operators}
      if (ii = 0) then begin               {first element copied as such}
        txc := pGrel^.e_Ctext;
        txp := txc;                        {"previous", needed below}
      end else begin                       {for others, add * if no operator}
        txt := pGrel^.e_Ctext;
        len := length(txt);                {number of char}
        lenp := length(txp);               {number of char. in previous}
        if (len >= 1) then begin
          if (txt[1] = '+') or (txt[1] = '-') or (txt[1] = '*') or
             (txt[1] = '/') or (txt[1] = '^') or (txt[1] = ')') then begin
            txc := txc+txt;                {operator found, copy as such}
          end else begin                   {no operator, must check previous}
            if (lenp >= 1) then begin
              if (txp[lenp] = '+') or (txp[lenp] = '-') or (txp[lenp] = '*') or
                 (txp[lenp] = '/') or (txp[lenp] = '^') then txc := txc+txt
              else txc := txc+'*'+txt;
            end;
          end;
        end;
        txp := txt;                        {new previous}
      end;
    end;
  end;
end;

procedure TGraphiq.CombineTextsAboveAndBelowLine(var comtxt: string);
{texts above and below a given line have been determined.
 Combine the texts to one string (one text row).
 Pointers are in g_TextListA (above) and g_TextListU (under)
 Example: If the texts above are  a b c (three text items),
 and under are d e (two items), then the combined text is
 (abc)/(de)  [Some multiplication symbols (*) must perhaps be added.]
 This text replaces the text "above", the text "under" is deleted
 pLine pointer to the line}
var
  cnt      : integer;     {number of items}
  iau      : integer;
  ii       : integer;
  indx     : integer;     {index of element in list}
  len,lenp : integer;     {length of text}
  ll       : integer;
  pGrel    : TpGraphel;
  pList    : TpList;
  txc      : string;      {combined text}
  txa,txu  : string;      {texts (above, under = below)}
  txp      : string;      {previous text}
  txt      : string;      {temporary text}
begin
  {first, must arrage the texts from left to right}
  for ll := 1 to 2 do begin                        {both lists}
    if (ll = 1) then pList := @g_TextListA else pList := @g_TextListU;
    if (pList^.count > 1) then begin
      {use the text position as the sorting crit.}
      for ii := 0 to pList^.count-1 do begin
        pGrel := pList^[ii];
        pGrel^.e_crit := -pGrel^.e_xtx;             {x of text start. "-" = smallest = leftmost first}
      end;
      SortList(pList^);                             {arrange from left to right}
    end;
  end;
  {collect text pieces, for texts above and below line}
  CollectText(@g_TextListA, txa);
  CollectText(@g_TextListU, txu);
  {combine texts above and under the line}
  comtxt := '(('+txa+')/('+txu+'))';
  {put the combined text to the first element above, remove other elements}
  if (g_TextListA.count > 0) then begin
    pGrel := g_TextListA[0];                         {first element above}
    pGrel^.e_CText := comtxt;
    if (g_TextListA.count > 1) then begin            {more elements? Remove}
      for ii := 1 to g_TextListA.count-1 do begin
        pGrel := g_TextListA[ii];
        indx := g_TextList.indexof(pGrel);           {index in the list of all texts}
        if (indx >= 0) then g_TextList.delete(indx); {remove from the list of all texts}
      end;
    g_TextListA.pack;
    end;
  end;
  {remove all elements under the line from the list of all texts}
  if (g_TextListU.count > 0) then begin
    for ii := 0 to g_TextListU.count-1 do begin
      pGrel := g_TextListU[ii];
      indx := g_TextList.indexof(pGrel);           {index in the list of all texts}
      if (indx >= 0) then g_TextList.delete(indx); {remove from the list of all texts}
    end;
  g_TextListU.pack;
  end;
end;

procedure TGraphiq.CombineTextOfOneRow(var comtxt: string);
{There are several pieces of text on (roughly?) one row, that is
 several text elements, but no lines for division.
 Combine the texts to one string i.e. one text row.
 Some multiplication symbols (*) must perhaps be added.
 The texts are in g_TextList
 comtxt  the combined text}
var
  cnt     : integer;
  ii,jj   : integer;
  indx    : integer;     {index of element in list}
  ll      : integer;
  pGrel   : TpGraphel;
  pList   : TpList;
  txa,txu : string;     {texts}
begin
  {first, must arrage the texts from left to right}
  pList := @g_TextList;
  if (pList^.count > 1) then begin
    {use the text position as the sorting crit.}
    for ii := 0 to pList^.count-1 do begin
      pGrel := pList^[ii];
//showmessage(pGrel^.e_text+'  '+inttostr(pGrel^.e_xtx));
      pGrel^.e_crit := -pGrel^.e_xtx;             {x of text start. "-" = smallest = leftmost first}
    end;
    SortList(pList^);                             {arrange from left to right}
     {collect text pieces}
    CollectText(pList,comtxt);
//showmessage('comb  '+comtxt);
    {comtxt is the only text left. Put it to the first element of text list}
    {...this may be unnecessary...?}
    pGrel := g_TextList[0];
    pGrel^.e_Ctext := comtxt;
    {remove the other texts from the text list}
    cnt := g_TextList.count;
    if (cnt > 1) then begin
      for ii := 1 to cnt-1 do begin
        jj := cnt-ii;
        g_TextList.delete(jj); {remove from the list of all texts}
      end;
      g_TextList.pack;
    end;
  end else begin          {only one text}
    pGrel := g_TextList[0];
    comtxt := pGrel^.e_Ctext;
  end;
end;



procedure TGraphiq.ConstructEquation(var equ: string);
{Construct an equation on one line from the "graphical" equation}
var
  comtxt : string;       {combined text from above and below the line}
  ii     : integer;
  lcount : integer;      {original number of lines}
  pGrel  : TpGraphel;
  pLine  : TpGraphel;    {pointer to a line}
  ntxt   : integer;      {number of string elements}
begin
  equ := '';
  {only if there is something to construct}
  if (g_List.count > 0) then begin
    {find, how many text elements}
    ntxt := 0;
    for ii := 0 to g_List.count-1 do begin
      pGrel := g_List[ii];
      if (pGrel^.e_shape = 6) then inc(ntxt);
    end;
    {continue, if there are texts}
    if (ntxt > 0) then begin
      {copy texts to a separate list}
      CopyTextsAndPointers;
      {collect all lines in one list, in order of decreasing length (longest first)}
      CopyAndSortLines;
      {eliminate the lines one by one by combining the nominator and denominator into one line..
       .. like (nomin)/(denom)}
      lcount := g_LineList.count;
      if (lcount > 1) then begin                    {there are several lines}
        {start with the shortest line = at the end of list}
        while (lcount > 0) do begin
          pLine := g_LineList[lcount-1];            {last line}
          GetTextAboveAndBelowLine(pLine);          {find the texts (immediately) above and below the line}
          CombineTextsAboveAndBelowLine(comtxt);
          {remove the line from the list of lines}
          g_LineList.delete(lcount-1);
          dec(lcount);
        end;
      end else if (g_LineList.count = 1) then begin    {only one line}
        pLine := g_LineList[0];            {last line}
        GetTextAboveAndBelowLine(pLine);          {find the texts (immediately) above and below the line}
        CombineTextsAboveAndBelowLine(comtxt);
        {remove the line from the list of lines}
        g_LineList.delete(0);
      end else begin                                   {no lines}
        CombineTextOfOneRow(comtxt);
      end;
      {everything should now be as separate texts without lines. Combine to one text}
      CombineTextOfOneRow(comtxt);       {TURHA, jos jo tehty edell !!??}
      equ := comtxt;
    end else begin  {no texts, nothing to construct...}
      equ := '';
    end;
  end else begin    {nothing at all}
    equ := '';
  end;
end;

procedure TMarkImage.MrkMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState;
                                X, Y: Integer);
{hide markers, update parameters and redraw the graphical element}
var
  ii    : integer;      {index}
  pGrel : TpGraphel;    {pointer to graphical element}
  pMrk  : TpMarkImage;
  pMrk0 : TpMarkImage;  {pointer to marker of upper left corner}
  pMrk4 : TpMarkImage;  {pointer to marker of lower right corner}
  pMrkf : TpMarkImage;  {pointer to first line marker}
  pMrks : TpMarkImage;  {pointer to second line marker}
  w2    : integer;      {half width of marker}
  x0,y0 : integer;      {coordinates of old first corner}
  x1,y1 : integer;      {coordinates of new first corner}
  x4,y4 : integer;      {coordinate of opposite corner}
  xf,yf : integer;      {coordinates of first line end}
  xs,ys : integer;      {coordinates of second line end}
begin
  GetpMarker(0,pMrk0);                  {pointer to first marker = upper left corner}
  if (pMrk0^.m_ipGrel <> 0) then begin  {is a single element selected?}
    pGrel := TpGraphel(pMrk0^.m_ipGrel);  {pointer to the selected graph.element...}
    {...}                                 {saved in TGraphiq.StartDrawing}
    w2 := mark_w div 2;
    {find and save new coordinates of the corners, or endpoints}
    {LINE differently !!}
    if (pGrel^.e_shape <> 3) then begin     {not a line}
      GetpMarker(0,pMrk0);                  {pointer to first marker = upper left corner}
      GetpMarker(4,pMrk4);                  {lower right corner}
      {find and save new coordinates of upper left corner}
      x0 := pMrk0^.left+w2;
      y0 := pMrk0^.top+w2;
      {find and save new coordinates of lower right corner}
      x4 := pMrk4^.left+w2;
      y4 := pMrk4^.top+w2;
      {rearrange corners, save}
      pGrel^.e_xtx := pGrel^.e_xtx+x0-pGrel^.e_x1;
      pGrel^.e_ytx := NearestGrid(pGrel^.e_ytx+y0-pGrel^.e_y1,false);
      pGrel^.CheckCorners(x0,y0,x4,y4);
      {if text box, move also the edit-component}
      if (pGrel^.e_shape = 6) then begin
        pGrel^.GetFirstXY(x1,y1);         {get the coordinates of the upper left corner}
        graphic.g_EditBox.left := x1;
        graphic.g_EditBox.top := y1;
      end else if (pGrel^.e_shape = 7) then begin  {menu component}
        graphic.g_MemoBox.left := pGrel^.e_xtx;    {not needed? memo box is hidden..}
        graphic.g_MemoBox.top := pGrel^.e_ytx;
      end;
    end else begin                      {is a line}
      {get pointers to markers at the ends of the line, depending on the direction}
      if (pGrel^.e_linedir = ltrb) then begin
        GetpMarker(0,pMrkf);
        GetpMarker(4,pMrks);
      end else if (pGrel^.e_linedir = rtlb) then begin
        GetpMarker(2,pMrkf);
        GetpMarker(6,pMrks);
      end else if (pGrel^.e_linedir = rblt) then begin
        GetpMarker(4,pMrkf);
        GetpMarker(0,pMrks);
      end else if (pGrel^.e_linedir = lbrt) then begin
        GetpMarker(6,pMrkf);
        GetpMarker(2,pMrks);
      end else begin
        {error...}
        GetpMarker(0,pMrkf);
        GetpMarker(4,pMrks);
      end;
      xf := pMrkf^.left+w2;
      yf := pMrkf^.top+w2;
      {find and save new coordinates of endpoints}
      xs := pMrks^.left+w2;
      ys := pMrks^.top+w2;
      {save x and y, if moving line, but only x if stretching}
      if (yf = ys) then begin
        pGrel^.PutFirstXY(xf,yf);
        pGrel^.PutSecondXY(xs,ys);
      end else begin
        pGrel^.PutFirstX(xf);            {only x can change, because always horizontal line}
        pGrel^.PutSecondX(xs);
      end;
      {the direction may have changed: find new "ltrb":s}
      pGrel^.LineDirection(xf,yf,xs,ys);
    end;
  end else begin                         {elements selected within a rectangle}
    {move elements within the rectangle marked by the markers. SNAP to Grid! }
    Graphic.MoveInsideOnes(graphic.g_MovImg.left-graphic.g_MovImg.m_x0,graphic.g_MovImg.top-graphic.g_MovImg.m_y0);
  end;
  {hide the markers}
  Graphic.HideMarkers;
  {hide the edit-box (if visible)}
  if (Graphic.g_EditBox.visible) then EquationMenuForm.EditBoxExit(nil);
  if (Graphic.g_MemoBox.visible) then EquationMenuForm.MemoBoxExit(nil);
  {redraw all graphical elements}
  Graphic.g_pForm.invalidate;           {drawn in FormPaint of the main form}
end;

procedure TMarkImage.MrkMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState;
                                  X, Y: Integer);
begin
//  showmessage(inttostr(m_index));
end;

procedure TMarkImage.MrkMouseMove(Sender: TObject; Shift: TShiftState; X,  Y: Integer);
{actions when moving the mouse on the markers
 0   1   2
 7       3
 6   5   4 }
const
  x0 : array[0..7] of integer = (0,0,0,0,0,0,0,0);
  y0 : array[0..7] of integer = (0,0,0,0,0,0,0,0);
var
  pMrk0 : TpMarkImage;
  pMrk1 : TpMarkImage;
  pMrk2 : TpMarkImage;
  pMrk3 : TpMarkImage;
  pMrk4 : TpMarkImage;
  pMrk5 : TpMarkImage;
  pMrk6 : TpMarkImage;
  pMrk7 : TpMarkImage;
begin
  {move the marker with the mouse}
  if (ssLeft in Shift) then begin        {left button pressed}
    {get pointers to all markers, needed when moving markers}
    GetpMarker(0,pMrk0);           {marker 0}
    GetpMarker(1,pMrk1);           {marker 1}
    GetpMarker(2,pMrk2);           {marker 2}
    GetpMarker(3,pMrk3);           {marker 3}
    GetpMarker(4,pMrk4);           {marker 4}
    GetpMarker(5,pMrk5);           {marker 5}
    GetpMarker(6,pMrk6);           {marker 6}
    GetpMarker(7,pMrk7);           {marker 7}
    {markers at corners can be moved freely, markers on the edges
     can be moded in x- or y- direction only}
    if (m_index = 0) or (m_index = 2) or (m_index = 4) or (m_index = 6) then begin
      left := left+X-x0[m_index];
      top  := top +Y-y0[m_index];
      {move the other points accordingly
        0   1   2
        7       3
        6   5   4 }
      if (m_index = 0) then begin            {upper left corner}
        pMrk1^.top := top;
        pMrk1^.left := (left+pMrk2^.left) div 2;
        pMrk2^.top := top;
        pMrk7^.top := (top+pMrk6^.top) div 2;
        pMrk7^.left := left;
        pMrk6^.left := left;
        pMrk5^.left := pMrk1^.left;
        pMrk3^.top := pMrk7^.top;
      end else if (m_index = 2) then begin   {upper right corner}
        pMrk1^.top := top;
        pMrk1^.left := (left+pMrk0^.left) div 2;
        pMrk0^.top := top;
        pMrk3^.top := (pMrk2^.top+pMrk4^.top) div 2;
        pMrk3^.left := left;
        pMrk4^.left := left;
        pMrk5^.left := pMrk1^.left;
        pMrk7^.top := pMrk3^.top;
      end else if (m_index = 4) then begin   {lower right corner}
        pMrk5^.top := top;
        pMrk5^.left := (left+pMrk6^.left) div 2;
        pMrk6^.top := top;
        pMrk3^.top := (top+pMrk2^.top) div 2;
        pMrk3^.left := left;
        pMrk2^.left := left;
        pMrk1^.left := pMrk5^.left;
        pMrk7^.top := pMrk3^.top;
      end else if (m_index = 6) then begin
        { 0   1   2
          7       3
          6   5   4 }
        pMrk5^.top := top;
        pMrk5^.left := (left+pMrk4^.left) div 2;
        pMrk4^.top := top;
        pMrk7^.top := (top+pMrk0^.top) div 2;
        pMrk7^.left := left;
        pMrk0^.left := left;
        pMrk1^.left := pMrk5^.left;
        pMrk3^.top := pMrk7^.top;
      end else begin
        {..not possible...}
      end;
    end else if (m_index = 3) or (m_index = 7) then begin
      left := left+X-x0[m_index];
      { 0   1   2
        7       3
        6   5   4 }
      if (m_index = 3) then begin          {3 = middle of right edge}
        pMrk2^.left := left;
        pMrk4^.left := left;
        pMrk1^.left := (pMrk0^.left+left) div 2;
        pMrk5^.left := pMrk1^.left;
      end else begin                       {7 = middle of left edge}
        pMrk0^.left := left;
        pMrk6^.left := left;
        pMrk1^.left := (pMrk2^.left+left) div 2;
        pMrk5^.left := pMrk1^.left;
      end;
    end else if (m_index = 1) or (m_index = 5) then begin
      top  := top +Y-y0[m_index];
      if (m_index = 1) then begin          {1 = middle of top edge}
        pMrk0^.top := top;
        pMrk2^.top := top;
        pMrk7^.top := (top+pMrk5^.top) div 2;
        pMrk3^.top := pMrk7^.top;
      end else begin                       {5 = middle of bottom edge}
        pMrk6^.top := top;
        pMrk4^.top := top;
        pMrk7^.top := (top+pMrk1^.top) div 2;
        pMrk3^.top := pMrk7^.top;
      end;
    end else begin
      {..not possible...}
    end;
  end else begin
    x0[m_index] := X;
    y0[m_index] := Y;
  end;
  {move the others accordingly, depending on which marker has been clikced}
end;

procedure TMoveImage.MovMouseMove(Sender : TObject; Shift: TShiftState; X,Y: Integer);
{move the marker}
const
  x0  : integer = 0;    {old coordinates}
  y0  : integer = 0;
var
  pMrk0 : TpMarkImage;
  pMrk1 : TpMarkImage;
  pMrk2 : TpMarkImage;
  pMrk3 : TpMarkImage;
  pMrk4 : TpMarkImage;
  pMrk5 : TpMarkImage;
  pMrk6 : TpMarkImage;
  pMrk7 : TpMarkImage;
begin
  if (ssLeft in Shift) then begin        {left button pressed}
    {get also pointers to the other markers}
    GetpMarker(0,pMrk0);           {marker 0}
    GetpMarker(1,pMrk1);           {marker 1}
    GetpMarker(2,pMrk2);           {marker 2}
    GetpMarker(3,pMrk3);           {marker 3}
    GetpMarker(4,pMrk4);           {marker 4}
    GetpMarker(5,pMrk5);           {marker 5}
    GetpMarker(6,pMrk6);           {marker 6}
    GetpMarker(7,pMrk7);           {marker 7}
    {new position of the move (middle) marker}
    left := left+X-x0;
    top  := top +Y-y0;
    {new positions of the other markers}
    pMrk0^.left := pMrk0^.left+X-x0;
    pMrk0^.top  := pMrk0^.top+Y-y0;
    pMrk1^.left := pMrk1^.left+X-x0;
    pMrk1^.top  := pMrk1^.top+Y-y0;
    pMrk2^.left := pMrk2^.left+X-x0;
    pMrk2^.top  := pMrk2^.top+Y-y0;
    pMrk3^.left := pMrk3^.left+X-x0;
    pMrk3^.top  := pMrk3^.top+Y-y0;
    pMrk4^.left := pMrk4^.left+X-x0;
    pMrk4^.top  := pMrk4^.top+Y-y0;
    pMrk5^.left := pMrk5^.left+X-x0;
    pMrk5^.top  := pMrk5^.top+Y-y0;
    pMrk6^.left := pMrk6^.left+X-x0;
    pMrk6^.top  := pMrk6^.top+Y-y0;
    pMrk7^.left := pMrk7^.left+X-x0;
    pMrk7^.top  := pMrk7^.top+Y-y0;
  end else begin
    x0 := X;
    y0 := Y;
  end;
end;

procedure TMoveImage.MovMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  m_x0 := left;     {save position, needed when moving several elements}
  m_y0 := top;
end;

procedure TMoveImage.MovMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
{move the graph.element to the new position marked by the markers}
var
  pMrk0 : TpMarkImage;                  {pointer to first marker}
begin
  GetpMarker(0,pMrk0);                  {pointer to first marker = upper left corner}
  pMrk0.MrkMouseUp(Sender, Button, Shift, X, Y);
  {move the elements inside the rectangle, if...}
//Graphic.MoveInsideOnes(left-m_x0,top-m_y0);
end;

procedure TWorkBut.DelButClick(sender: TObject);
{delete the selected element}
var
  answer : word;
  indx   : integer;
  pGrel  : TpGraphel;    {pointer to the graphical element}
  pMrk   : TpMarkImage;  {pointer to a marker (for pointer to the element)}
begin
  answer := MessageDlg('Really delete the graphical element?',mtWarning, [mbCancel, mbYes], 0);
  if (answer = mrYes) then begin
    Graphic.DeleteSelectedElement;
    {hide the markers and button(s)}
    Graphic.HideMarkers;
  end;
end;

procedure TWorkBut.BackButClick(sender: TObject);
{send the selected element to back}
begin
  Graphic.SendSelectedElementToBack;
end;

procedure TGraphiq.CreateEditBox;
{create the edit-component in the main form for writing/editing text}
begin
  g_EditBox := TEdit.create(g_pForm^);
  g_EditBox.Parent  := g_pForm^;
  g_EditBox.left := 50;
  g_EditBox.top := 50;
  g_EditBox.width := 32;
  g_EditBox.height := 16;
  g_EditBox.text := '';
  g_EditBox.visible := false;
  g_EditBox.AutoSize := true{false};
  g_EditBox.Ctl3D := false;
  g_EditBox.font.name := 'Arial';
  g_EditBox.font.size := 12;
  g_EditBox.color := clYellow;
  g_EditBox.onExit := EditBoxExit;
  g_EditBox.onChange := EditBoxChange;
//EquationMenuForm.FontDlg.font.assign(g_EditBox.font);  {moved outside}
end;

procedure TGraphiq.CreateMemoBox;
{create the memo-component in the main form for writing/editing text}
begin
  g_MemoBox := TMemo.create(g_pForm^);
  g_MemoBox.Parent  := g_pForm^;
  g_MemoBox.left := 50;
  g_MemoBox.top := 50;
  g_MemoBox.width := 64;
  g_MemoBox.height := 32;
  g_MemoBox.enabled := true;
  g_MemoBox.Ctl3D := false;
  g_MemoBox.font.name := 'Arial';
  g_MemoBox.font.size := 12;
  g_MemoBox.ReadOnly := false;
  g_MemoBox.text := '';
  g_MemoBox.WantReturns := true;
  g_MemoBox.WordWrap := false;
  g_MemoBox.visible := false;
  g_MemoBox.onExit := MemoBoxExit;
  g_MemoBox.onChange := MemoBoxChange;
  EquationMenuForm.FontDlg.font.assign(g_MemoBox.font);
end;

function TGraphiq.FontAndWidthOfText(font: TFont; text: string): integer;
{set the given font to the form, and get the width of the text in the edit box}
begin
  {g_pForm^.canvas}g_Canvas.font.assign(font);
  {get the size of the edit according to the text}
  FontAndWidthOfText := g_Canvas.textwidth(text);
end;

function TGraphiq.WidthOfMemoText(var hh : integer): integer;
{get the max. width and height of the text in the memo box}
var
  cnt : integer;   {number of lines}
  ii  : integer;   {index}
  wl  : integer;   {width of a line}
  wm  : integer;   {max. width of lines}
begin
  cnt := g_MemoBox.lines.count;                 {number of lines}
  g_Canvas.font.assign(g_MemoBox.font);
  if (cnt > 0) then begin                       {there are lines}
//  g_Canvas.font.assign(g_MemoBox.font);
    wm := 0;
    for ii := 0 to cnt-1 do begin
      {get the width of one line in the memo}
      wl := g_Canvas.textwidth(g_MemoBox.lines[ii]);
      if (wl > wm) then wm := wl;               {find max. width}
    end;
    if (wm > 32) then WidthOfMemoText := wm
    else WidthOfMemoText := 32;
    hh := g_Canvas.textheight(g_MemoBox.lines[0]);
  end else begin                                {no lines, set some width}
    WidthOfMemoText := 32;
    hh := g_Canvas.textheight('AA');
//  hh := 20;
  end;
end;

procedure TGraphiq.EditBoxExit(Sender: TObject);
{copy text to canvas, hide box}
var
  indx  : integer;
  ix,iy : integer;    {coordinates}
  pGrel : TpGraphel;  {pointer to graphical text element}
  txw   : integer;    {text width}
  xx,yy : integer;    {coordinates}
begin
  if (g_editBox.visible) then begin
    {there is some text?}
    if (g_EditBox.text <> '') then begin
      xx := g_EditBox.left+2;
      yy := g_EditBox.top+2;
      g_EditBox.visible := false;
      {set font, and get width of text}
      txw := FontAndWidthOfText(g_EditBox.font, g_EditBox.text);
      g_pForm^.canvas.brush.style := bsClear;         {no background color}
      g_pForm^.canvas.textout(xx,yy,g_EditBox.text);  {rewritten in DrawTextBox (?!)}
//    AngleTextOut(g_pForm^.canvas, 0, xx, yy, g_EditBox.text);  {but when ZOOMED or printing!!??}
      {set the size of the edit according to the text}
      g_EditBox.width := txw+16;
      {pointer to gr.element. Saved into tag in TGraphiq.FinishDrawingWithMouse and ... }
      {.. in InTextBox}
      pGrel := TpGraphel(g_EditBox.tag);
{?}   pGrel^.e_text := g_EditBox.text;       {text to element}
      pGrel^.e_pFont^.assign(g_EditBox.font);
      {save the size of the box}
      ix := g_EditBox.left+g_EditBox.width;
      iy := g_EditBox.top+g_EditBox.height;
      pGrel^.putSecondXY(ix,iy);
      g_EditBox.text := '';
      EquationMenuForm.FontBut.visible := false;
    end else begin
      {no text, delete the element}  {may already have been deleted, if was small!}
      pGrel := TpGraphel(g_EditBox.tag);
      indx := g_List.indexof(pGrel);
      if (indx >= 0) then DeleteElement(pGrel,indx);
    end;
  end;
end;

procedure TGraphiq.EditBoxChange(Sender: TObject);
{set the width according to the text}
var
  txw : integer;  {width of text}
begin
  {find the widht of the text, with this font}
  txw := FontAndWidthOfText(g_EditBox.font, g_EditBox.text);
  if (g_EditBox.width < txw+16) then g_EditBox.width := txw+32
  else if (g_EditBox.width > txw+32) then g_EditBox.width := txw+16;
end;

procedure TGraphiq.MemoTextOut(pMemo: TpMemo; xx,yy: integer; pGrel: TpGraphel);
{write the text in the memo to the form. NOTE: Set font first!!
 pMemo  pointer to the memo
 xx,yy  the position of horizontal text (upper left corner)
 pGrel  pointer to the active graphical element}
var
  angle : integer;  {the angle of the text}
  cnt   : integer;  {number of lines}
  hh    : integer;  {height of the text}
  ii    : integer;  {index}
  ix,iy : integer;  {position of text}
  wtx   : integer;  {width of memo text}
begin
  {find the direction (angle) of the text}
  if      (pGrel^.e_quarter = north) then angle := 90
  else if (pGrel^.e_quarter = east) then  angle := 0
  else if (pGrel^.e_quarter = south) then angle := 270
  else if (pGrel^.e_quarter = west) then  angle := 180
  else angle := 0;
  g_Canvas.font.assign(pMemo^.font);       {ei viel hyv...}
  {possibly several lines. Must find height of one line}
  hh := g_Canvas.textheight(pMemo^.text);
  wtx := g_Canvas.textwidth(pMemo^.lines[0]);
  cnt := pMemo^.lines.count;        {number of lines}
  if (cnt > 0) then begin
    for ii := 0 to cnt-1 do begin
      {coordinates depend on direction}
      if (angle = 0) then begin
        ix := xx+6;
        iy := yy+ii*hh;
      end else if (angle = 90) then begin
        ix := xx+ii*hh;
        iy := yy;
      end else if (angle = 180) then begin
        ix := xx+6;
        iy := yy-ii*hh;
      end else if (angle = 270) then begin
        ix := xx-ii*hh;
        iy := yy;
      end else begin
        ix := xx+6;
        iy := yy+ii*hh;
      end;
      {write on the screen}
      AngleTextOut(g_Canvas, angle, ix, iy, pMemo^.lines[ii]);
    end;
    {}
  end;
end;

procedure TGraphiq.MemoBoxExit(Sender: TObject);
{copy text to canvas, hide box}
var
  cx,cy   : integer;    {coordinates of new first corner}
  indx    : integer;
  ix,iy   : integer;    {coordinates}
  ox,oy   : integer;    {coordinates of the new second (opposite) corner}
  pGrel   : TpGraphel;  {pointer to graphical text element}
  txh,txw : integer;    {text height, width}
  xx,yy   : integer;    {coordinates}
begin
  if (g_MemoBox.visible) then begin
    {there is some text?}
    if (g_MemoBox.text <> '') then begin
      {pointer to gr.element. Saved into tag in TGraphiq.FinishDrawingWithMouse and ... }
      {.. in InTextBox}
      pGrel := TpGraphel(g_MemoBox.tag);
      g_MemoBox.visible := false;
      {set font, and get width of text}
      txw := WidthOfMemoText(txh);                    {find the width and height of the text, with this font}
      g_pForm^.canvas.brush.style := bsClear;         {no background color}
      {set the size of the memo according to the text}
      g_MemoBox.width := txw+16;
      g_MemoBox.height := (g_MemoBox.lines.count{+1})*txh+(txh div 2);
{?}   pGrel^.e_text := g_MemoBox.text;                {text to element}
      pGrel^.e_pFont^.assign(g_MemoBox.font);
      {start point of the text}
      xx := pGrel^.e_xtx;
      yy := pGrel^.e_ytx;
      {the second corner depends on the direction}
      if (pGrel^.e_quarter = east) then begin
        cx := xx;                     {first corner as before}
        cy := yy;
        ox := xx+g_MemoBox.width;     {opposite corner}
        oy := yy+g_MemoBox.height;
      end else if (pGrel^.e_quarter = north) then begin
        cx := xx;
        cy := yy-g_MemoBox.width;
        ox := xx+g_MemoBox.height;
        oy := yy;
      end else if (pGrel^.e_quarter = west) then begin
        cx := xx-g_MemoBox.width;
        cy := yy-g_MemoBox.height;
        ox := xx;
        oy := yy;
      end else if (pGrel^.e_quarter = south) then begin
        cx := xx-g_MemoBox.height;
        cy := yy;
        ox := xx;
        oy := yy+g_MemoBox.width;
      end else begin                  {error case...}
        cx := xx;                     {first corner as before}
        cy := yy;
        ox := xx+g_MemoBox.width;     {opposite corner}
        oy := yy+g_MemoBox.height;
      end;
      pGrel^.putFirstXY(cx,cy);
      pGrel^.putSecondXY(ox,oy);
      g_MemoBox.text := '';
      g_MemoBox.lines.clear;
      EquationMenuForm.FontBut.visible := false;
    end else begin
      {no text, delete the element}     {may already have been deleted, if was small!}
      pGrel := TpGraphel(g_MemoBox.tag);
      indx := g_List.indexof(pGrel);
      if (indx >= 0) then DeleteElement(pGrel,indx);
    end;
    g_pForm^.invalidate;
  end;
end;

procedure TGraphiq.MemoBoxChange(Sender: TObject);
{set the width and height according to the text}
var
  apu : single;
  ipu : integer;
  len : integer;  {tength of text}
  txh : integer;  {height of one line}
  txw : integer;  {width of text}
begin
  txw := WidthOfMemoText(txh);       {find the width and height of the text, with this font}
  if (g_MemoBox.width < txw+16) then g_MemoBox.width := txw+32
  else if (g_MemoBox.width > txw+16) then g_MemoBox.width := txw+16;

  {set also the height, it is more complicated}
  if (g_pForm.ActiveControl = g_MemoBox) then begin
    EquationMenuForm.TestEdit.font.assign(g_MemoBox.font);   {copy the font to a hidden edit}
 {tm aiheuttaa ongelmia = vrin InMemoBox'issa...}
    len := length(g_MemoBox.text);
    if (len > 0) then begin
      {add space for one more line, if line feed just added}
      if (g_MemoBox.text[len] = #10) or (g_MemoBox.text[len] = #13) then ipu := 1 else ipu := 0;
      g_MemoBox.height := (g_MemoBox.lines.count+ipu)*txh+(txh div 2);
    end;
  end;
end;

procedure TGraphiq.CreateMarkers;
{create the small squares used to mark the selected graphical element
 The markers are positioned in the corners and in the middle of the edges of
 the rectangle limiting the graphical element
 and numbered like this:
 0   1   2
 7       3
 6   5   4 }
var
  ii   : integer;  {index}
  pMrk : TpMarkImage;  {pointer to the marker}
begin
  {markers around the graphical element, for stretching}
  for ii := 0 to high(g_pMarkers) do begin
    new(pMrk);             {reserve space}
    pMrk^             := TMarkImage.Create(g_pForm^);
    pMrk^.Parent      := g_pForm^;
    pMrk^.align       := alNone;
    pMrk^.left := ii*(mark_w+4);
    pMrk^.top := 0;
    pMrk^.width := mark_w;
    pMrk^.height := mark_w;
    with pMrk^.canvas do begin
      pen.width := 1;
      if (ii = 0) then pen.color := clBlack
      else if (ii = 2) then pen.color := clBlue
      else if (ii = 4) then pen.color := clGreen
      else if (ii = 6) then pen.color := clRed
      else pen.color := clAqua;
      brush.style := bsSolid;
      brush.color := pen.color;
      rectangle(0,0,mark_w,mark_w);
    end;
    pMrk^.visible := false;
    pMrk^.enabled := false;
    g_pMarkers[ii] := longint(pMrk);
    pMrk^.onMouseMove := pMrk^.MrkMouseMove;
    pMrk^.onMouseDown := pMrk^.MrkMouseDown;
    pMrk^.onMouseUp := pMrk^.MrkMouseUp;
    pMrk^.m_index := ii;
  end;
  {marker in the  graphical element, for moving}
  g_MovImg := TMoveImage.Create(g_pForm^);
  g_MovImg.Parent  := g_pForm^;
  g_MovImg.picture.Assign(EquationMenuForm.CrossImg.picture);
  g_MovImg.align := alNone;
  g_MovImg.left := 0;
  g_MovImg.top := 0;
  g_MovImg.width := move_w;
  g_MovImg.height := move_w;
  g_MovImg.visible := false;
  g_MovImg.enabled := false;
  g_MovImg.onMouseMove := g_MovImg.MovMouseMove;
  g_MovImg.onMouseDown := g_MovImg.MovMouseDown;
  g_MovImg.onMouseUp := g_MovImg.MovMouseUp;
  {button for deleting}
  g_DelBut := TWorkBut.create(g_pForm^);
  g_DelBut.Parent  := g_pForm^;
  g_DelBut.align       := alNone;
  g_DelBut.left := 0;
  g_DelBut.top := 0;
  g_DelBut.width := but_w;
  g_DelBut.height := but_w;
  g_DelBut.caption := 'X';
  g_DelBut.hint := 'delete this graphical element';
  g_DelBut.showhint := true;
  g_DelBut.visible := false;
  g_DelBut.onClick := g_DelBut.DelButClick;
  {button for moving element to back}
  g_BackBut := TWorkBut.create(g_pForm^);
  g_BackBut.Parent  := g_pForm^;
  g_BackBut.align       := alNone;
  g_BackBut.left := 0;
  g_BackBut.top := 0;
  g_BackBut.width := but_w;
  g_BackBut.height := but_w;
  g_BackBut.caption := 'v';
  g_BackBut.hint := 'delete this graphical element';
  g_BackBut.showhint := true;
  g_BackBut.visible := false;
  g_BackBut.onClick := g_BackBut.BackButClick;
end;

procedure TGraphiq.DrawAll;
{(re)draw all graphical elements}
var
  ii    : integer;     {index}
  pGrel : TpGraphel;   {pointer to a graphical element}
begin
  if (g_List.count > 0) then begin        {are there elements}
    for ii := 0 to g_List.count-1 do begin
      pGrel := g_List[ii];
      pGrel^.PickPenColor;
      pGrel^.e_DrawEl(longint(pGrel));    {draw the graphic element}
    end;
  end;
end;

procedure TGraphiq.MoveAll(dx,dy: integer);
{move all graphical elements by dx,dy}
var
  ii    : integer;     {index}
  pGrel : TpGraphel;   {pointer to a graphical element}
begin
  if (g_List.count > 0) then begin        {are there elements}
    for ii := 0 to g_List.count-1 do begin
      pGrel := g_List[ii];
      inc(pGrel^.e_x1,dx);
      inc(pGrel^.e_y1,dy);
      inc(pGrel^.e_x2,dx);
      inc(pGrel^.e_y2,dy);
      inc(pGrel^.e_xtx,dx);
      inc(pGrel^.e_ytx,dy);
    end;
  end;
  g_pForm^.invalidate;
end;

procedure TGraphiq.MoveInsideOnes(dx,dy: integer);
{move graphical elements that are inside the given rectangle, move by dx,dy}
var
  ii    : integer;     {index}
  pGrel : TpGraphel;   {pointer to a graphical element}
begin
  if (g_Inside.count > 0) then begin        {are there elements}
    for ii := 0 to g_Inside.count-1 do begin
      pGrel := g_Inside[ii];
      inc(pGrel^.e_x1,dx);
      pGrel^.e_y1 := NearestGrid(pGrel^.e_y1+dy, false);
      inc(pGrel^.e_x2,dx);
      pGrel^.e_y2 := NearestGrid(pGrel^.e_y2+dy, false);
      inc(pGrel^.e_xtx,dx);
      pGrel^.e_ytx := NearestGrid(pGrel^.e_ytx+dy, false);
    end;
  end;
  g_pForm^.invalidate;
end;

procedure TGraphiq.PutShapeIndex(indx: integer);
{save the index of the shape to be drawn, when clicking a shape button
 (rectangle, ellipse, ...
 and additional definition "subtype"}
begin
  if (indx >= 0) and (indx <= 7) then           {BETTER???}
    g_shapeIndex := indx;
end;

procedure TGraphiq.PutType(stype: integer);
{set the subtype of the shape}
begin
  g_type := stype;
end;

procedure TGraphiq.ResButState(down: boolean);  {copy the state of the reset button}
begin
  g_ResButDown := down;  {copy the state}
end;

procedure TGraphiq.StartDrawing(x,y : integer);
{save coordinates etc. when starting drawing a shape at mouse down...
 ...or find if clicking in a graphic element (shape)
 x,y  mouse coordinates}
var
  cnt     : integer;     {number of elements}
  ii,jj   : integer;     {index}
  ll      : longint;
  ManyVar : TMulti;      {for transferring parameters}
  pGrel   : TpGraphel;   {pointer to a graphic element}
  pMrk    : TpMarkImage; {pointer to marker}
  sel     : boolean;     {true, when (at least) one element selected}
begin
  {hide all markers initially}
  HideMarkers;
  {hide the dir-panel (direction of the element), but not for text}
  {exit from editing text in some edit box (if editing)}
  EditBoxExit(nil);
  MemoBoxExit(nil);
  g_movrec := false;                         {not (yet?) a rectangle for moving}
  {starting to draw?}
  if (g_ShapeIndex > 0) then begin           {some button for selecting shape is down}
    CreateAndAddGraphicElement(g_shapeIndex);
    g_pGraph := g_List.last;                 {pointer to the graph.element added last}
    g_pGraph^.putFirstXY(x,y);               {starting point to the element = first corner}
    g_pGraph^.putTextCornerXY(x,y);          {initialize starting point to the element = first corner}
    g_pGraph^.e_Pencolor := g_Pencolor;
    g_pGraph^.e_Brushcolor := g_Brushcolor;
    g_pGraph^.e_penwidth := g_penwidth;
    g_pGraph^.e_quarter := g_quarter;      {direction of directional elements}
    g_pGraph^.e_type := g_type;
    g_drawing := true;                     {set flag for drawing (NEEDED?)}
    g_first := true;                       {drawing first time}
  end else begin
    {check for clicking inside an element}
    ManyVar.xx := x;                       {for transporting coordinates}
    ManyVar.yy := y;
    {check all elements, if there are any}
    sel := false;
    cnt := g_List.count;                        {number of elements}
    if (cnt > 0) then begin                     {there are elements}
      for ii := 1 to cnt do begin
        jj := cnt-ii;                           {backwards, last added checked first}
        pGrel := g_List[jj];                    {pointer to an element}
        ManyVar.pp := longint(pGrel);           {transport pointer as integer}
        ll := longint(@ManyVar);                {transport pointer as integer}
        InGraphel[pGrel^.e_shape](ll);          {is the cursor (mouse) inside this shape}
        if (pGrel^.e_inside) then begin
          sel := true;  {set flag: selected}
          GetpMarker(0,pMrk);
          pMrk^.m_ipGrel := longint(pGrel);     {save pointer to the selected element to FIRST marker}
          break;
        end;
      end;
      {check and select one, if several selected elements}
      {... later ....}
    end;
    {if no element selected, start drawing a rectangle for moving components}
    if (not sel) then begin
      {wipe previous rectangle, if any}
//    if ...
//      g_canvas.pen.mode := pmNot;        {opposite color}
//      g_canvas.brush.style := bsClear;
//      g_canvas.rectangle(g_x1,g_y1,g_x2,g_y2);  {draw the rectangle}
//    end;
      {save starting point, set flags}
      g_x1 := x;
      g_y1 := y;
      {initialize opposite point}
      g_x2 := x;
      g_y2 := y;
      g_movrec := true;         {starting to draw a rectangle for moving}
//    g_movfirst := true;
    end;
  end;
end;

procedure TGraphiq.DrawWithMouse(x,y : integer);
{draw the given shape by dragging with the mouse
 x,y  mouse coordinates}
var
  x1,y1 : integer;   {coordinates of first corner}
  y2    : integer;   {y-coordinate of second corner}
begin
  {draw the selected shape, if drawing}
  if (g_drawing) then begin
    g_pGraph^.GetFirstXY(x1,y1);                 {coord. of first corner, needed for line}
    if (g_pGraph^.e_shape = 3) then begin
      y2 := y1;
    end else begin
      y2 := y;  {horizontal line}
    end;
    g_pGraph^.ClearBrush;                    {do not (yet) fill the shape}
    g_pGraph.OppositePenColor;
    {wipe previous shape, but not on the first time}
    if (g_first) then begin
      g_first := false;                      {reset, no more first time}
      g_pGraph^.putSecondXY(x,y2);           {opposite corner}
      g_pGraph^.e_DrawEl(longint(g_pGraph)); {draw first time}
    end else begin
      {wipe = draw with the opposite color}
      g_pGraph^.e_DrawEl(longint(g_pGraph)); {wipe = draw second time with opposite colors, with old corners}
      {draw new shape at the mouse position}
      g_pGraph^.putSecondXY(x,y2);            {new opposite corner}
      g_pGraph^.e_DrawEl(longint(g_pGraph));  {draw new element, with new opposite corner}
    end;
  end else if (g_movrec) then begin           {drawing a rectangle for moving?}
    g_canvas.pen.width := 1;
    g_canvas.pen.mode := pmNot;               {opposite color}
    g_canvas.brush.style := bsClear;
    {wipe = draw on the previous with opposite color}
    g_canvas.rectangle(g_x1,g_y1,g_x2,g_y2);  {wipe the rectangle}
    {draw a new rectangle}
    g_canvas.rectangle(g_x1,g_y1,x,y);        {draw the rectangle}
    g_x2 := x; g_y2 := y;                     {coordinates of opposite corner}
  end;
end;

procedure TGraphiq.ElementsToList;
{write the elements and their properties to a list, as text (strings),
 needed for saving to file. Remove carriage returns from the text. Otherwise
 writeln and readln do not work properly (when writing/reading to/from file}
var
  fs    : integer;     {font style coded as integer}
  ii,jj : integer;
  len   : integer;     {length of line}
  line  : string;      {one line of text}
  pGrel : TpGraphel;   {pointer to a graphic element}
  tn,ts : string;      {font nime, font size, as strings}
  tt,tc : string;      {font style, font color, as strings}
  txt   : string;      {temporary}
begin
  g_ElList.clear;                                {clear list initially}
  if (g_List.count > 0) then begin               {are there elements}
    {add name of equation}
    g_ElList.add('13');                                {13 = name of equation}
    g_ElList.add(g_EquName);
    {add equation in "computer readable" form}
    g_ElList.add('14');                                {14 = equation in computer readable form}
    g_ElList.add(g_Equation);
    {add variable names and values, if any}
    if (g_pVarList <> nil) and (g_pVarList.count > 0) then begin
      for ii := 0 to g_pVarList.count-1 do begin
        line := g_pVarList^[ii];
        g_ElList.add('12');                            {12 = variable name}
        g_ElList.add(line);
      end;
    end;
    {add equivalencies of names in equations and PQ-relays, if any}
    if (g_pEquivList <> nil) and (g_pEquivList.count > 0) then begin
      for ii := 0 to g_pEquivList.count-1 do begin
        line := g_pEquivList^[ii];
        g_ElList.add('15');                            {15 = equivalence}
        g_ElList.add(line);
      end;
    end;
    {the equation, as graphical elements}
    for ii := 0 to g_List.count-1 do begin       {check each element}
      pGrel := g_List[ii];
      {two lines for each property: 1) a "key" or flag telling, which property, then the property}
      g_ElList.add('1');                         {1 = first property, the index of the shape}
      g_ElList.add(inttostr(pGrel^.e_shape));
      g_ElList.add('2');                         {2 = coordinates}
      g_ElList.add(inttostr(pGrel^.e_x1)+';'+inttostr(pGrel^.e_y1)+';'+
                   inttostr(pGrel^.e_x2)+';'+inttostr(pGrel^.e_y2));
      g_ElList.add('3');                         {3 = pen color}
      g_ElList.add(inttostr(longint(pGrel^.e_PenColor)));
      g_ElList.add('4');                         {4 = brush color}
      g_ElList.add(inttostr(longint(pGrel^.e_BrushColor)));
      g_ElList.add('5');                         {5 = pen width}
      g_ElList.add(inttostr(pGrel^.e_penwidth));
      g_ElList.add('6');                         {6 = direction (of directional elements)}
      g_ElList.add(inttostr(longint(pGrel^.e_quarter)));
      if (pGrel^.e_shape = 3) then begin         {direction of line, only for lines}
        g_ElList.add('7');                       {7 = direction (of directional elements)}
        g_ElList.add(inttostr(longint(pGrel^.e_linedir)));
      end;
      if (pGrel^.e_shape = 6) then begin  {text, only for text boxes}
        g_ElList.add('8');                       {8 = text}
        g_ElList.add(pGrel^.e_text);
      end else if (pGrel^.e_shape = 7) then begin {text from menu boxes}
        g_ElList.add('8');
        {must remove (possible) carriage returns}
        txt := '';
        line := pGrel^.e_text;            {memo-text on one line}
        len := length(line);
        if (len > 0) then begin           {should be}
          {check text, replace line feeds}
          for jj := 1 to len do begin
            if (line[jj] = #13) then {...} else txt := txt+line[jj];  {skip carriage return}
          end;
        end else begin
          txt := '?';
        end;
        g_ElList.add(txt);
      end;
      {font: name, style, size, color. Style can be (regular, bold, italic, bold-italic)..}
      {..but only for the text component}
      if (pGrel^.e_shape = 6) or (pGrel^.e_shape = 7) then begin
        {code the font style}
        fs := 0;
        if (fsBold in (pGrel^.e_pFont^.style)) then fs := 1;
        if (fsItalic in (pGrel^.e_pFont^.style)) then fs := fs+2;
        {all properties as strings}
        tn := pGrel^.e_pFont^.name;                     {font name}
        ts := inttostr(pGrel^.e_pFont^.size);           {font size}
        tt := inttostr(fs);                             {font style, coded}
        tc := inttostr(longint(pGrel^.e_pFont^.color)); {font color}
        line := tn+';'+tt+';'+ts+';'+tc;                {all properties as one string}
        g_ElList.add('9');                              {9 = font}
        g_ElList.add(line);
      end;
      {starting point of text (actually only for memo text)}
      line := inttostr(pGrel^.e_xtx)+';'+inttostr(pGrel^.e_ytx);
      g_ElList.add('10');                              {10 = start position of text}
      g_ElList.add(line);
      {subtype of the element}
      line := inttostr(pGrel^.e_type);
      g_ElList.add('11');                              {11 = subtype of element}
      g_ElList.add(line);
    end;
  end;
end;

procedure TGraphiq.ElementsFromList;
{read the list of elements, and create the graphical elements
 The list contains two rows (items) for each data: identifier and the data}
var
  cnt   : integer;    {number of items (rows)}
  cnt2  : integer;    {count divided by 2}
  ident : integer;    {identifier of data item}
  ii    : integer;    {index}
  line  : string;     {data as string}
  ll    : longint;    {pointer as integer}
begin
  g_pVarList.clear;                           {clear list of variables initially}
  g_pEquivList.clear;                         {clear list of equivalent variables first}
  cnt := g_ElList.count;                      {number of itemrs (rows)}
  if (cnt >= 4) then begin                    {actually, even 4 is too little!}
    cnt2 := cnt div 2;                        {number of items}
    for ii := 0 to cnt2-1 do begin            {each identifier and item}
      line := g_ElList[2*ii];                 {identifier of data}
      if (IsInteger(line,ident)) then begin   {data is an integer = identifier?}
        line := g_ElList[2*ii+1];             {data as string}
        RecalEl[ident](ll,line);              {process the data}
      end;
    end;
  end;
end;

procedure TGraphel.CheckCorners(xf,yf, x,y : integer);
{Check the rectangle surrounding the graphical element.
 Save the coordinates of opposite corners so that the upper left corner
 is saved as first and lower right as second
 xf,yf  coordinates of the old/first corner
 x,y    coordinates of the new corner, taken intially as the second corner}
var
  x1,y1  : integer;                  {coord. of upper left corner}
  x2,y2  : integer;                  {coord. of lower right corner}
begin
  {four possibilites, x first}
  if (xf < x) then begin                  {first x left of new x}
    x1 := xf;
    x2 := x;
  end else begin                          {first x right of new x}
    x1 := x;
    x2 := xf;
  end;
  {next, check y}
  if (yf < y) then begin                  {first y above new y}
    y1 := yf;
    y2 := y;
  end else begin                          {first y below new y}
    y1 := y;
    y2 := yf;
  end;
  putFirstXY(x1,y1);            {upper left corner}
  putSecondXY(x2,y2);           {lower right corner}
end;

procedure TGraphel.LineDirection(x1,y1,x2,y2: integer);
{find the (drawing) direction of the line
 x1,y1  coordinates of the first end
 x2,y2  coordinates of the second end}
begin
  if (x1 <= x2) then begin
    if (y1 <= y2) then begin
      e_linedir := ltrb;
    end else begin
      e_linedir := lbrt;
    end;
  end else begin
    if (y1 < y2) then begin
      e_linedir := rtlb;
    end else begin
      e_linedir := rblt;
    end;
  end;
end;

procedure TGraphiq.FinishDrawingWithMouse(x,y : integer);
{when mouse up, draw the shape in the final form and color
 x,y  mouse coordinates}
var
  hh     : integer;                  {height of text}
  indx   : integer;                  {index of new graphical element}
  pGraph : TPGraphel;                {latest graphic element}
  pMrk   : TpMarkImage;              {pointer to a marker}
  x1,y1  : integer;                  {upper left corner}
  x2,y2  : integer;                  {lower right corner}
  xf,yf  : integer;                  {coord. of first corner (saved first, maybe upper or lower}
begin
  if (g_drawing) then begin          {is drawing a shape}
    {draw the shape in the final form and size}
    {but first, wipe the previous shape}
    g_pGraph.OppositePenColor;
    g_pGraph^.e_DrawEl(longint(g_pGraph));  {wipe = draw second time with opposite colors, with old corners}
    {do not draw very small elements}
    g_pGraph^.GetFirstXY(xf,yf);            {first point = point where drawing started}
    if (abs(x-xf) > 8) or (abs(y-yf) > 8) then begin
      {arrange corners: upper left = first, lower right = second}
      {but not for a line !}
      if (g_pGraph^.e_shape <> 3) then begin    {not a line (USE constants!!??..)}
        g_pGraph^.CheckCorners(xf,yf,x,y);
      end else begin
        {for a line, determine the drawing direction}
        g_pGraph^.LineDirection(xf,yf,x,y);
      end;
      {next, draw the final shape, but not for a text box. Edit-component added below}
      {but not for a text box. BETTER, no numbers!?}
      if (g_pGraph^.e_shape <> 6) and (g_pGraph^.e_shape <> 7) then begin
        g_pGraph^.PickPenColor;                 {pick the selected color for the pen}
        g_pGraph^.e_DrawEl(longint(g_pGraph));  {draw new element, with new opposite corner}
      end;
    end else begin                            {very small element, delete, do not draw}
      pGraph := g_List.last;
      if (pGraph <> nil) then begin
        indx := g_List.indexof(pGraph);        {index of the element in the list}
        if (indx >= 0) then begin              {element is in the list}
          pGraph^.e_pFont^.free;
          dispose(pGraph^.e_pFont);
          pGraph^.free;
          dispose(pGraph);
          g_List.delete(indx);                 {delete the element}
          g_pForm.invalidate;                  {call for redrawing}
          g_EditBox.tag := 0;                  {indicate that deleted...}
          g_MemoBox.tag := 0;                  {..to avoind second delete due to no text}
          g_EditBox.visible := false;          {just to be sure...}
          g_MemoBox.visible := false;
        end;
      end;
      EquationMenuForm.FontBut.visible := false;
    end;
    {if drawing box for text, show edit-component for the text}
    if (g_pGraph <> nil) then begin
      if (g_pGraph^.e_shape = 6) then begin
        GetCorners(longint(g_pGraph), x1,y1,x2,y2);  {corners of the box (upper left, lower right)}
        {different font for power}
        if (g_pGraph^.e_type = 1) then begin
          EquationMenuForm.FontDlg.font.size := {12}10;
          EquationMenuForm.FontDlg.font.color := clBlue;
        end else begin
          EquationMenuForm.FontDlg.font.size := {16}14;
          EquationMenuForm.FontDlg.font.color := clBlack;
        end;
        g_EditBox.font.assign(EquationMenuForm.FontDlg.font);
        g_MemoBox.font.assign(EquationMenuForm.FontDlg.font);
        g_EditBox.left := x1;
        g_EditBox.top := NearestGrid(y1,false);
        g_EditBox.width := x2-x1;              {initial width, may be changed later. Height set automatically}
        g_EditBox.visible := true;
        g_pForm^.ActiveControl := g_EditBox;
        g_EditBox.tag := longint(g_pGraph);    {save pointer to element into tag}
      {memo-component for text}
      end else if (g_pGraph^.e_shape = 7) then begin
        GetCorners(longint(g_pGraph), x1,y1,x2,y2);  {corners of the box (upper left, lower right)}
        g_MemoBox.font.assign(EquationMenuForm.FontDlg.font);
        g_MemoBox.left := x1;
        g_MemoBox.top := y1;
        g_MemoBox.width := x2-x1;              {initial width, may be changed later. Height set automatically}
        {height...}
        WidthOfMemoText(hh);                   {find the height of text with the memo-font}
        g_MemoBox.height := hh+8;
        g_MemoBox.visible := true;
        g_pForm^.ActiveControl := g_MemoBox;
        g_MemoBox.tag := longint(g_pGraph);    {save pointer to element into tag}
      end;
    end;
    EquationMenuForm.ResetButClick(nil);
    g_drawing := false;                        {stop drawing, was set in mousedown}
  end else if (g_movrec) then begin            {drawing rectangle for moving}
    {wipe the rectangle, not needed any more}
    g_canvas.pen.width := 1;
    g_canvas.pen.mode := pmNot;               {opposite color}
    g_canvas.brush.style := bsClear;
    {wipe = draw on the previous with opposite color}
    g_canvas.rectangle(g_x1,g_y1,g_x2,g_y2);  {wipe the rectangle}
    {too small rectangles neglected, probably not moving elememts}
    if (abs(graphic.g_x1-graphic.g_x2) > 12) and
       (abs(graphic.g_y1-graphic.g_y2) > 12) then begin
      ShowAllMarkers(g_x1,g_y1,g_x2,g_y2);
      GetpMarker(0,pMrk);
      pMrk^.m_ipGrel := 0;                       {no element selected}
    end;
    g_movrec := false;
    {find elements that are inside the rectangle}
    InsideRectangle(g_x1,g_y1,g_x2,g_y2, false);
  end;
end;

procedure TGraphiq.CreateAndAddGraphicElement(indx: integer);
{create graphic element as an object, add to list of gr.elements
 indx  index of the type (shape) of the element}
var
  cnt    : integer;    {number of elements}
  pGraph : TpGraphel;  {temporary pointer to element}
begin
  new(pGraph);                           {reserve space for the element}
  pGraph^ := TGraphel.Create;            {create the component as an object}
  pGraph^.e_shape := indx;               {type of the element}
  {initialize some parameters, may be changed later}
  pGraph^.e_Toile := g_pForm^.Canvas;    {canvas on which drawn}
  pGraph^.e_Toile.pen.style := psSolid;
  pGraph^.e_Toile.pen.width := 1;
  pGraph^.e_Pencolor := clBlack;
  pGraph^.e_Brushcolor := clWhite;
  pGraph^.e_penwidth := 1;
  pGraph^.e_quarter := north;            {direction of directional elements}
  pGraph^.PutShapeIndex(indx);           {save the index of the element}
  pGraph^.e_DrawEl := DrawGraphel[indx]; {procedure for drawing}
  new(pGraph^.e_pFont);
  pGraph^.e_pFont^ := TFont.create;
  pGraph^.e_pFont^.assign(g_EditBox.font);
  {..}
  g_List.add(pGraph);                    {add to list of elements}
end;

procedure TGraphiq.DeleteElement(pGrel: TpGraphel; indx: integer);
{delete an graphical element
 pGrel  pointer to the element
 indx   index of the element in the list}
begin
  if (pGrel <> nil) and (indx = g_List.indexof(pGrel)) then begin
    {for a text box, hide also the edit-component}
    if (pGrel^.e_shape = 6) then begin
      g_EditBox.text := '';
      g_EditBox.visible := false;
      EquationMenuForm.FontBut.visible := false;
    end else if (pGrel^.e_shape = 7) then begin
      g_MemoBox.text := '';
      g_MemoBox.visible := false;
      EquationMenuForm.FontBut.visible := false;
    end;
    pGrel^.e_pFont^.free;
    dispose(pGrel^.e_pFont);
    pGrel^.free;
    dispose(pGrel);
    g_List.delete(indx);                 {delete the element}
  end;
end;

procedure TGraphiq.DeleteSelectedElement;
{delete the selected graphical element}
var
  indx  : integer;
  pGrel : TpGraphel;    {pointer to the graphical element}
  pMrk  : TpMarkImage;  {pointer to a marker (for pointer to the element)}
begin
  GetpMarker(0,pMrk);                      {pointer to first marker}
  pGrel := TpGraphel(pMrk^.m_ipGrel);      {pointer to the gr.element...}
  {...}                                    {...saved in TGraphiq.StartDrawing}
  if (pGrel <> nil) then begin
    indx := g_List.indexof(pGrel);         {index of the element in the list}
    if (indx >= 0) then begin              {element is in the list}
      DeleteElement(pGrel, indx);
      g_pForm.invalidate;                  {call for redrawing}
    end;
  end;
  {hide the markers and button(s)}
  HideMarkers;
end;

procedure TGraphiq.SendSelectedElementToBack;
{delete the selected graphical element}
var
  indx  : integer;
  pGrel : TpGraphel;    {pointer to the graphical element}
  pMrk  : TpMarkImage;  {pointer to a marker (for pointer to the element)}
begin
  GetpMarker(0,pMrk);                      {pointer to first marker}
  pGrel := TpGraphel(pMrk^.m_ipGrel);      {pointer to the gr.element...}
  {...}                                    {...saved in TGraphiq.StartDrawing}
  if (pGrel <> nil) then begin
    indx := g_List.indexof(pGrel);         {index of the element in the list}
    if (indx >= 0) then begin              {element is in the list}
      g_List.move(indx,0);                 {0=first element, bottom}
      g_pForm.invalidate;                  {call for redrawing}
    end;
  end;
  {hide the markers and button(s)}
  HideMarkers;
end;

procedure TGraphiq.DeleteAll;
{deltet all graphical elements}
var
  cnt   : integer;    {number of elements}
  ii    : integer;
  jj    : integer;
  pGrel : TpGraphel;  {pointer to the element to be deleted}
begin
  cnt := g_List.count;      {number of elements}
  if (cnt > 0) then begin
    for ii := 1 to cnt do begin
      jj := cnt-ii;         {backwards}
      pGrel := g_List[jj];
      DeleteElement(pGrel,jj);
    end;
    g_pForm.invalidate;                  {call for redrawing}
  end;
end;

procedure TGraphiq.FreeGraphicElements;
{free the graphic elements (shapes) as objects}
var
  ii,jj  : integer;     {index}
  ng     : integer;     {number of graphic elements}
  pGraph : TpGraphel;   {pointer to an element}
begin
  ng := g_List.count;  {number of elements}
  if (ng > 0) then begin
    for ii := 1 to ng do begin
      jj := ng-ii;                  {backwards}
      pGraph := g_List[jj];         {element to be deleted}
      pGraph^.e_pFont^.free;
      dispose(pGraph^.e_pFont);
      pGraph^.free;                 {destroy = free the element}
      dispose(pGraph);              {release reserved space (?)}
    end;
  end;
  g_List.clear;
end;

procedure TGraphiq.HideMarkers;
{hide the markers and button(s) marking the selected graphich element}
var
  ii   : integer;        {index}
  pMrk : TpMarkImage;  {pointer to a marker}
begin
  {hide the markers}
  for ii := 0 to high(g_pMarkers) do begin
    GetpMarker(ii,pMrk);
    pMrk^.visible := false;
  end;
  g_MovImg.visible := false;
  g_DelBut.visible := false;
  g_BackBut.visible := false;
end;

procedure TGraphiq.InsideRectangle(x1,y1,x2,y2: integer; whole: boolean);
{collect those elements that are inside the given rectangle
 x1,y1,x2,y2  coordinates of opposite corners of hte rectangle
 whole        if true, the whole element must be inside, else only the midpoint}
var
  pGrel   : TpGraphel; {pointer to graphical element}
  ii      : integer;
  xlr,ylr : integer;   {coordinates of the lower right corner of the rectangle}
  xm,ym   : integer;   {coordinates of the midpoint}
  xr,yr   : integer;   {lower right corner of an element}
  xu,yu   : integer;   {upper left corner of an element}
  xul,yul : integer;   {coordinates of the upper left corner of the rectangle}
begin
  {find/arrange coordinates of the rectangle}
  if (x1 < x2) then begin
    if (y1 < y2) then begin
      xul := x1; yul := y1; xlr := x2; ylr := y2;
    end else if (y2 < y1) then begin
      xul := x1; yul := y2; xlr := x2; ylr := y2;
    end else begin    {same y, no rectangle}
      xul := 0; yul := 0; xlr := 0; ylr := 0;
    end;
  end else if (x2 < x1) then begin
    if (y1 < y2) then begin
      xul := x2; yul := y1; xlr := x1; ylr := y2;
    end else if (y2 < y1) then begin
      xul := x2; yul := y2; xlr := x1; ylr := y1;
    end else begin    {same y, no rectangle}
      xul := 0; yul := 0; xlr := 0; ylr := 0;
    end;
  end else begin      {same x, no rectangle}
    xul := 0; yul := 0; xlr := 0; ylr := 0;
  end;
  {collect elements that are inside the given rectangle}
  g_Inside.clear;                            {clear list of elements inside}
  if (g_List.count > 0) then begin           {are there elements}
    for ii := 0 to g_List.count-1 do begin
      pGrel := g_List[ii];
      GetCorners(longint(pGrel), xu,yu,xr,yr);
      {whole element inside?}
      if (whole) then begin
        if (xul < xu) and (xr < xlr) and
           (yul < yu) and (yr < ylr) then g_Inside.add(pGrel);  {add to list, if inside}
      end else begin                 {only midpoint inside}
        xm := (xu+xr) div 2;         {midpoint}
        ym := (yu+yr) div 2;
        if (xul < xm) and (xm < xlr) and
           (yul < ym) and (ym < ylr) then g_Inside.add(pGrel);  {add to list, if midpoint inside}
      end;
    end;
  end;
end;

procedure TGraphiq.FreeMarkers;
{free the small squares (images) used to mark seleted element
 and the box for editing texts}
var
  ii   : integer;
  ll   : longint;
  pMrk : TpMarkImage;
begin
  for ii := 0 to high(g_pMarkers) do begin
    ll := g_pMarkers[ii];
    pMrk := TpMarkImage(ll);
    pMrk^.free;
    dispose(pMrk);
  end;
  g_MovImg.free;
  g_EditBox.free;
  g_MemoBox.free;
end;

procedure TGraphiq.WriteElementsToFile(pOutfile: TpTextFile; flg : string);
{write the data for all elements to the given file. A special character can be
 added to the beginning of each line.
 The carriage returns are removed from rows of text (they must be added back, when
 reading the file)
 The Outfile must be ready to accept the writing: It must be assigned and rewritten
 The Outfile must be closed after writing. It is not done here!
 Outfile  the text file, where written
 flg      a special character that can be added to the beginning of the line}
var
  ii,jj    : integer;
  len      : integer;      {length of line}
  line     : string;       {one line of text}
  next     : boolean;      {next row contains data}
  txt      : string;       {temporary}
begin
  next := false;
  for ii := 0 to Graphic.g_ElList.count-1 do begin
    line := flg+Graphic.g_ElList[ii];
    {must replace line feeds with some special character}
    if (ii div 2) = (ii/2.0) then begin   {even row = flag or identifier of the data row}
      next := (line = '8');               {next row is text}
      txt := line;
    end else begin                        {odd row, contains data}
      if (next) then  begin               {process the text}
        txt := '';
        len := length(line);
        if (len > 0) then begin           {should be}
          {check text, replace line feeds}
          for jj := 1 to len do begin
            if (line[jj] = #13) then {...} else txt := txt+line[jj];  {skip carriage return}
          end;
        end else begin
          txt := '?';
        end;
      end else begin
        txt := line;
      end;
      next := false;
    end;
    writeln(pOutfile^,txt);
  end;
end;

procedure TGraphiq.CopyListAndAddCR(TmpList: TStringList);
{copy descriptions of elements to g_ElList from a temporary list (as read from a file).
 Add the missing carriage returns (CR) from text-lines}
var
  ii,kk    : integer;  {index}
  len      : integer;  {length of line}
  line     : string;   {one line of text}
  lno      : integer;  {line number}
  next     : boolean;
  txt      : string;
begin
  Graphic.g_ElList.clear;
  if (TmpList.count > 0) then begin
    next := false;
    lno := 0;                                  {initialize, first line}
    for kk := 0 to TmpList.count-1 do begin
      line := TmpList[kk];                     {copy one line}
      if (next) then begin                     {text on this line}
        {add the possibly missing carriage returns}
        len := length(line);
        if (len > 0) then begin                {should be}
          txt := '';
          for ii := 1 to len do begin
            if (line[ii] = #10) then txt := txt+#13;  {if line feed, add carriage return}
            txt := txt+line[ii];
          end;
        end else begin
          txt := '?';
        end;
      end else begin
        txt := line;
      end;
      Graphic.g_ElList.add(txt);
      next := (line = '8') and ((lno div 2) = (lno/2.0)); {next text, and even row}
      inc(lno);                                {line number}
    end;
  end;
end;

procedure TGraphiq.CopyInsideToList(GraphList: TList);
{copy pointers to graphical elements that are inside given rectangle to the given list}
var
  ii : integer;
begin
  GraphList.clear;
  if (g_Inside.count > 0) then  begin
    for ii := 0 to g_Inside.count-1 do begin
      GraphList.add(g_Inside[ii]);
    end;
  end;
end;

procedure TGraphiq.CopyListToInside(GraphList: TList);
{copy given list to list of graphical elements that are inside given rectangle
 Needed in redo, maybe}
var
  ii : integer;
begin
  g_Inside.clear;
  if (GraphList.count > 0) then  begin
    for ii := 0 to GraphList.count-1 do begin
      g_Inside.add(GraphList[ii]);
    end;
  end;
end;

procedure TGraphiq.CopyAllToInsideList;
{copy all elements to list of elements inside a given rectangle.
 Needed when moving all}
var
  ii : integer;
begin
  g_Inside.clear;
  if (g_List.count > 0) then  begin
    for ii := 0 to g_List.count-1 do begin
      g_Inside.add(g_List[ii]);
    end;
  end;
end;

procedure TGraphel.putFirstXY(x,y: integer);
{save coordinates of first corner}
begin
  e_x1 := x;
  e_y1 := NearestGrid(y,false);
end;

procedure TGraphel.putFirstX(x: integer);
{save coordinates of first corner}
begin
  e_x1 := x;
end;

procedure TGraphel.getFirstXY(var x,y : integer);   {get the first corner}
begin
  x := e_x1;
  y := e_y1;
end;

procedure TGraphel.putSecondXY(x,y : integer);
{save coordinates of opposite corner}
begin
  e_x2 := x;
  e_y2 := NearestGrid(y,false);
end;

procedure TGraphel.putSecondX(x : integer);
{save coordinates of opposite corner}
begin
  e_x2 := x;
end;

procedure TGraphel.putTextCornerXY(x,y: integer);
{save coordinates of first corner}
begin
  e_xtx := x;
  e_ytx := NearestGrid(y,false);
end;

procedure TGraphel.PutShapeIndex(shindx : integer);
{save the shape index}
begin
  e_shape := shindx;
end;

procedure TGraphel.ClearBrush;
{set the brush of the canvas to clear = no-fill}
begin
   e_toile.brush.style:=bsClear;  {do not fill the shape}
end;

procedure TGraphel.OppositePenColor;
{opposite of existing color, so that the shape is wiped or can be wiped}
begin
  e_Toile.pen.mode := pmNot;
end;

procedure TGraphel.PickPenColor;
{pick the pen color selected earlier, but first,
 set the pen mode to copy (pick) the color}
begin
  {box for text differently}
  if (e_shape = 6) or (e_shape = 7) then begin  {text box (BETTER!!??)}
    e_Toile.pen.color := {clGray}clRed;
{?} e_Toile.pen.style := psDot;
    e_Toile.pen.width := 1;
    e_Toile.pen.mode := pmCopy;
    e_Toile.brush.style := bsClear;
  end else begin                         {"normal"/"proper" graphical element}
    e_Toile.pen.color := e_Pencolor;     {get color, selected when gr.element created}
    e_Toile.brush.color := e_BrushColor; {color of the inside of the element}
    if (e_BrushColor = clWhite) then e_Toile.Brush.style := bsClear
    else e_Toile.Brush.style := bsSolid;
    e_Toile.pen.mode := pmCopy;          {use the defined color of the pen}
    {dashed line possible only when pen width = 1. "0" = dashed line}
    if (e_penwidth > 0) then begin
      e_Toile.pen.width := e_penwidth;   {size (width) of the pen}
      e_Toile.pen.style := psSolid;
    end else begin
      e_Toile.pen.width := 1;            {size (width) of the pen}
      e_Toile.pen.style := psDash;
    end;
  end;
end;

procedure TEquationMenuForm.DrawAll;
begin
  Graphic.DrawAll;
end;

procedure TEquationMenuForm.DeleteAll;
begin
  Graphic.DeleteAll;
end;

procedure TEquationMenuForm.DelAllButClick(Sender: TObject);
{delete the all elements}
var
  answer : word;
begin
  answer := MessageDlg('Really delete ALL graphical elements?',mtWarning, [mbCancel, mbYes], 0);
  if (answer = mrYes) then begin
    answer := MessageDlg('Once more: Really delete ALL graphical elements?',mtWarning, [mbCancel, mbYes], 0);
    if (answer = mrYes) then begin
      Graphic.DeleteAll;
      {hide the markers and button(s)}
      Graphic.HideMarkers;
    end;
  end;
end;

procedure TEquationMenuForm.MoveAll(dx,dy: integer);
begin
  Graphic.MoveAll(dx,dy);
end;

procedure TEquationMenuForm.EditBoxExit(sender: TObject);
begin
  Graphic.EditBoxExit(sender);
end;

procedure TEquationMenuForm.MemoBoxExit(sender: TObject);
begin
  Graphic.MemoBoxExit(sender);
end;

procedure TEquationMenuForm.PutpMainForm(ipForm, ipBut, ipVarlist, ipEquivList,ipEquivedit: longint);
begin
  pMainForm := TpForm(ipForm);
  pCtrlBut := TpSpeedButton(ipBut);
  pVarList := TpStringList(ipVarlist);
  pEquivList := TpStringList(ipEquivList);
  pEquivEdit := TpEdit(ipEquivEdit);
end;

procedure TEquationMenuForm.InitializeGraphic;
begin
  top := pMainForm.top+64;
  Graphic.Initialize;
end;  

procedure TEquationMenuForm.StartDrawing(x,y: integer);
begin
  Graphic.StartDrawing(x,y);
end;

procedure TEquationMenuForm.FinishDrawingWithMouse(x,y: integer);
begin
  Graphic.FinishDrawingWithMouse(x,y);
end;

procedure TEquationMenuForm.DrawWithMouse(x,y: integer);
begin
  Graphic.DrawWithMouse(x,y);
end;

procedure TEquationMenuForm.ResetButClick(Sender: TObject);
begin
  ResetBut.down := true;
  Graphic.PutShapeIndex(0);
  Graphic.PutType(0);           {reset subtype}
  if (sender <> nil) and ((sender as TComponent).name = 'ResetBut') then begin
    FontBut.visible := false;
  end;
end;

procedure TEquationMenuForm.LineButClick(Sender: TObject);
begin
  Graphic.PutShapeIndex(3);        {use constants...!!??}
  Graphic.PutType(0);              {reset subtype}
  FontBut.visible := false;
end;

procedure TEquationMenuForm.TextButClick(Sender: TObject);
begin
  Graphic.PutShapeIndex(6);
  Graphic.PutType(0);           {reset subtype}
//FontBut.visible := true;   {needed? maybe not ??}
end;

procedure TEquationMenuForm.MemoButClick(Sender: TObject);
begin
  Graphic.PutShapeIndex(7);
  Graphic.PutType(0);           {reset subtype}
  {text probably in the right way, initially}
  FontBut.visible := true;
end;

procedure TEquationMenuForm.PowerButClick(Sender: TObject);
begin
  Graphic.PutShapeIndex(6);
  Graphic.PutType(1);           {set subtype to "power", that is A^x}
end;

procedure TEquationMenuForm.FormCreate(Sender: TObject);
begin
  {create the object for managing the shapes}
//pMainForm := @EquationForm;
  Graphic := TGraphiq.create;
  OpenDlg.InitialDir := ExtractFilePath(paramstr(0));   {directory where this program is}
  SaveDlg.InitialDir := OpenDlg.InitialDir;
  TempList := TStringList.create;
//top := pMainForm.top+64;
  {- - - - - }
  {add flag that this form has been created. Needed to set pointers, which can be
   done first when this form exists}
  EquationForm.PointerEdit.text := 'created';   {must be the same text as in PointerEditChange}
  {- - - - - - - - - - - - - - -}
  {add flag that form created}
  Imagoo.ReadyEdit.text := Imagoo.ReadyEdit.text+'e';
end;

procedure TEquationMenuForm.FormDestroy(Sender: TObject);
begin
  {free the graphic elements}
  Graphic.FreeGraphicElements;
  Graphic.FreeMarkers;
  Graphic.free;
  PartStrings.free;
  TempList.free;
end;

procedure TEquationMenuForm.FontButClick(Sender: TObject);
begin
  FontDlg.font.assign(Graphic.g_MemoBox.font);
  if (FontDlg.execute) then begin
    Graphic.g_EditBox.font.assign(FontDlg.font);
    Graphic.g_MemoBox.font.assign(FontDlg.font);
  end;
end;

procedure TEquationMenuForm.FontDlgApply(Sender: TObject; Wnd: Integer);
begin
  Graphic.g_EditBox.font := FontDlg.font;
  Graphic.g_MemoBox.font := FontDlg.font;
end;

procedure TEquationMenuForm.TestButClick(Sender: TObject);
var
  ii : integer;
begin
  TestEdit.text := WithMultOperator(StudyEdit.text);
end;

procedure TEquationMenuForm.OpenButClick(Sender: TObject);
{read the elements from a file, draw}
var
  FileName : string;   {name of the file from which names read (with directory)}
  ii       : integer;  {index}
  InFile   : TextFile; {file from which read}
  len      : integer;  {length of line}
  line     : string;   {one line of text}
  lno      : integer;  {line number}
  next     : boolean;
  txt      : string;
begin
  if (OpenDlg.execute) then begin
    FileName := OpenDlg.FileName;

    if (FileExists(FileName)) then begin
      {open and read lines}
      AssignFile(InFile,FileName);        {open the file}
      Reset(InFile);
      TempList.clear;
      while not(EOF(InFile)) do begin
        readln(Infile,line);              {read one line}
        TempList.add(line);               {put to temporary list, process later}
      end;
      CloseFile(InFile);
    end;

    {process...}
    Graphic.CopyListAndAddCR(TempList);   {copy to local, add missing carriage returns}
    Graphic.ElementsFromList;

    Graphic.g_pForm.invalidate;           {drawn in FormPaint of the main form}
  end;
end;

procedure TEquationMenuForm.SaveButClick(Sender: TObject);
{save the graphs (definitions) to a text file}
var
  FileName : string;       {name of the file where written}
  ii       : integer;
  Outfile  : TextFile;     {file where written}
begin
  if (SaveDlg.execute) then begin
    Graphic.ElementsToList;                     {write the elements+parameters to list, as strings}
    {write the list to file}
    if (Graphic.g_ElList.count >=4) then begin  {there is something in the list}
      FileName := SaveDlg.filename;             {name of file, where written}
      AssignFile(Outfile, filename);            {open the given file,BUT ERRORS ?}
      rewrite(outfile);
      {write the text}
      for ii := 0 to Graphic.g_ElList.count-1 do writeln(outfile,Graphic.g_ElList[ii]);
      CloseFile(Outfile);
    end;
  end;
end;

procedure TEquationMenuForm.FormHide(Sender: TObject);
begin
  pCtrlBut^.down := false;
end;

procedure TEquationMenuForm.ConstructEquation(var equ: string);
{construct an equation of one line from the "graphic" equation}
begin
  Graphic.ConstructEquation(equ);
end;

procedure TEquationMenuForm.ConstrButClick(Sender: TObject);
var
  equ    : string;      {the constructed equation}
begin
  Graphic.ConstructEquation(equ);
  TestEdit.text := equ;
end;

procedure TEquationMenuForm.PutEquationName(name: string);
begin
  Graphic.g_EquName := name;
end;

procedure TEquationMenuForm.GetEquationName(var name: string);
begin
  name := Graphic.g_EquName;
end;

procedure TEquationMenuForm.PutEquation(equ: string);
{put the equation in computer readable form, on one line}
begin
  Graphic.g_Equation := equ;
end;

procedure TEquationMenuForm.GetEquation(var equ: string);
begin
  equ := Graphic.g_Equation;
end;

end.
