{Put the pointer to the graphical element into some known place, always same place !!}
unit drawmenu;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Buttons, ExtCtrls, StdCtrls;

type
  TDrawMenuForm = class(TForm)
    ResetBut: TSpeedButton;
    RectBut: TSpeedButton;
    EllipBut: TSpeedButton;
    LineBut: TSpeedButton;
    CrossImg: TImage;
    ColorPanel: TPanel;
    BlackBut: TSpeedButton;
    RedBut: TSpeedButton;
    GreyBut: TSpeedButton;
    GreenBut: TSpeedButton;
    BlueBut: TSpeedButton;
    YellowBut: TSpeedButton;
    LimeBut: TSpeedButton;
    AquaBut: TSpeedButton;
    FuchsiaBut: TSpeedButton;
    LinePanel: TPanel;
    Line1But: TSpeedButton;
    Line2But: TSpeedButton;
    Line3But: TSpeedButton;
    Line4But: TSpeedButton;
    Line5But: TSpeedButton;
    Line6But: TSpeedButton;
    PenColorPanel: TPanel;
    BlackLineBut: TSpeedButton;
    LineGreyBut: TSpeedButton;
    LineRedBut: TSpeedButton;
    LineGreenBut: TSpeedButton;
    LineBlueBut: TSpeedButton;
    LineYellowBut: TSpeedButton;
    LineLimeBut: TSpeedButton;
    LineAquaBut: TSpeedButton;
    LineFuchsiaBut: TSpeedButton;
    WhiteBut: TSpeedButton;
    TriangleBut: TSpeedButton;
    DirPanel: TPanel;
    NorthBut: TSpeedButton;
    EastBut: TSpeedButton;
    SouthBut: TSpeedButton;
    WestBut: TSpeedButton;
    ArrowBut: TSpeedButton;
    TextBut: TSpeedButton;
    TestEdit: TEdit;
    FontDlg: TFontDialog;
    FontBut: TSpeedButton;
    SaveBut: TButton;
    TestBut: TButton;
    OpenBut: TButton;
    OpenDlg: TOpenDialog;
    SaveDlg: TSaveDialog;
    Line0But: TSpeedButton;
    DummyMemo: TMemo;
    MemoBut: TSpeedButton;
    HideBut: TSpeedButton;
    DelAllBut: TSpeedButton;
    NoteBut: TSpeedButton;
    NoteMemo: TMemo;
    PasteBut: TButton;
    procedure ResetButClick(Sender: TObject);
    procedure RectButClick(Sender: TObject);
    procedure EllipButClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure LineButClick(Sender: TObject);
    procedure BlackButClick(Sender: TObject);
    procedure GreyButClick(Sender: TObject);
    procedure RedButClick(Sender: TObject);
    procedure GreenButClick(Sender: TObject);
    procedure BlueButClick(Sender: TObject);
    procedure YellowButClick(Sender: TObject);
    procedure LimeButClick(Sender: TObject);
    procedure AquaButClick(Sender: TObject);
    procedure FuchsiaButClick(Sender: TObject);
    procedure Line0ButClick(Sender: TObject);
    procedure Line1ButClick(Sender: TObject);
    procedure Line2ButClick(Sender: TObject);
    procedure Line3ButClick(Sender: TObject);
    procedure Line4ButClick(Sender: TObject);
    procedure Line5ButClick(Sender: TObject);
    procedure Line6ButClick(Sender: TObject);
    procedure BlackLineButClick(Sender: TObject);
    procedure LineGreyButClick(Sender: TObject);
    procedure LineRedButClick(Sender: TObject);
    procedure LineGreenButClick(Sender: TObject);
    procedure LineBlueButClick(Sender: TObject);
    procedure LineYellowButClick(Sender: TObject);
    procedure LineLimeButClick(Sender: TObject);
    procedure LineAquaButClick(Sender: TObject);
    procedure LineFuchsiaButClick(Sender: TObject);
    procedure WhiteButClick(Sender: TObject);
    procedure TriangleButClick(Sender: TObject);
    procedure NorthButClick(Sender: TObject);
    procedure EastButClick(Sender: TObject);
    procedure SouthButClick(Sender: TObject);
    procedure WestButClick(Sender: TObject);
    procedure ArrowButClick(Sender: TObject);
    procedure TextButClick(Sender: TObject);
    procedure FontButClick(Sender: TObject);
    procedure FontDlgApply(Sender: TObject; Wnd: Integer);
    procedure TestButClick(Sender: TObject);
    procedure OpenButClick(Sender: TObject);
    procedure SaveButClick(Sender: TObject);
    procedure FormHide(Sender: TObject);
    procedure MemoButClick(Sender: TObject);
    procedure HideButClick(Sender: TObject);
    procedure DelAllButClick(Sender: TObject);
    procedure NoteButClick(Sender: TObject);
    procedure PasteButClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure StartDrawing(x,y: integer);
    procedure FinishDrawingWithMouse(x,y: integer);
    procedure DrawWithMouse(x,y: integer);
    procedure PutpMainForm(ipForm, ipBut: longint);
    procedure DrawAll;
    procedure DeleteAll;
    procedure MoveAll(dx,dy: integer);
    procedure MoveInsideOnes(dx,dy: integer);
    procedure MoveInList(List: TList; dx,dy : integer);
    procedure SketchOnCanvas(Toile: TCanvas; xc,yc, cw,ch: integer);
    procedure EditBoxExit(sender: TObject);
    procedure MemoBoxExit(sender: TObject);
    procedure InsideRectangle(x1,y1,x2,y2: integer);
    procedure ResetCanvas;
    procedure SetCanvas(Toile: TCanvas);
    procedure ProcessExternalList(TmpList : TStringList);
    procedure ElementsToExternalList(TmpList: TStringList);
    procedure CopyInsideToList(GraphList: TList);  {copy pointers to moved graphical elements}
    procedure CopyListToInside(GraphList: TList);
    procedure CopyAllToInsideList;
//  procedure EditBoxChange(sender: TObject);
  end;

function IsInteger(line: string; var kk : integer): boolean;
procedure GetPartStrings(line: string; ipParts: longint);

var
  DrawMenuForm: TDrawMenuForm;

implementation

uses Imagopas;

//uses graph;

{$R *.DFM}

type
  TpCanvas = ^TCanvas;
  TpForm = ^TForm;
  TpMemo = ^TMemo;
  TpStringList = ^TStringList;
  TpSpeedButton = ^TSpeedButton;
  TpTextFile = ^TextFile;
type
  TpFont = ^TFont;

type
  TdrawPhase = (wipe, move, up); {wiping, mousemove, mouseup}

{direction of directional elements (triangles, arrows...)}
type
  TQuarter = (north, east, south, west);

{direction of the line: ltrb = from left top to right bottom, etc}
type
  Tlinedir = (ltrb, lbrt,rtlb,rblt);

{define procedure "pointer"}
type
  TpProc = ^TProc;
  TProc = procedure(ipComp : longint);
  TpRecall = ^TRecall;
  TRecall = procedure(var ll: longint; line: string);
  TpSpeedBut = ^TSpeedButton;
  TpComponent = ^TComponent;

{define marker for moving the image }
type
  TpMoveImage = ^TMoveImage;
  TMoveImage = class(TImage)
  procedure MovMouseMove(Sender : TObject; Shift: TShiftState; X,Y: Integer);
  procedure MovMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
  procedure MovMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
public
private
  m_ipGrel : longint;  {pointer to the graph.element}
end;

{define marker images}
type
  TpMarkImage = ^TMarkImage;
  TMarkImage = class(TImage)
  procedure MrkMouseMove(Sender : TObject; Shift: TShiftState; X,Y: Integer);
  procedure MrkMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
  procedure MrkMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
public
private
  m_index  : integer;  {index of the marker}
  m_ipGrel : longint;  {pointer to the graph.element}
end;

{define button (for deleting an graphical element)}
type
  TpWorkBut = ^TWorkBut;
  TWorkBut = class(TButton)
  procedure DelButClick(sender: TObject);
  procedure BackButClick(sender: TObject);
  procedure CopyButClick(sender: TObject);
public
private
end;


{class for the different shapes (graphic elements), like rectangle, ellipse, line, etc}
type
  TpGraphel = ^TGraphel;
  TGraphel = class(TObject)
private
   e_BrushColor : TColor;    {color of the brush = inside of the element}
   e_PenColor   : Tcolor;    {color of the line}
   e_x1, e_y1   : integer;   {coordinates of one corner}
   e_x2, e_y2   : integer;   {coordinate of opposite corner}
   e_xtx, e_ytx : integer;   {coordinates of the corner where text starts....}
   {..}                      {...and around which text rotates} {Needed (only?) for the text box}
   e_penwidth   : integer;   {size (widht) of the pen}
   e_quarter    : TQuarter;  {direction of directional elements}
   e_OldQuarter : TQuarter;  {old direction (only?) for the text box}
   e_shape      : integer;   {index of the shape}
   e_Toile      : TCanvas;   {canvas on which drawn}
   e_DrawEl     : TProc;     {procedure for drawing the graphic element}
   e_inside     : boolean;   {given point is inside the graphical element}
   e_linedir    : Tlinedir;  {drawing direction of the line (only for the line?)}
   e_text       : string;    {text in element (only for text element?)}
   e_pFont      : TpFont;    {the font of text (only for text element?)}
   procedure putFirstXY(x,y: integer);        {save coordinates of first corner}
   procedure putSecondXY(x,y : integer; call: string);      {save coordinates of opposite corner}
   procedure putTextCornerXY(x,y: integer);   {save coordinates of the corner where text starts}
// procedure putOldSecondXY(x,y : integer);   {save coordinates of opposite corner}
   procedure getFirstXY(var x,y : integer);   {get the first corner}
   procedure PutShapeIndex(shindx : integer); {save the shape index}
   procedure ClearBrush;
   procedure OppositePenColor;
   procedure PickPenColor;
   procedure CheckCorners(xf,yf,x,y : integer);
   procedure LineDirection(x1,y1,x2,y2: integer);
  {}
public
  {}
end;

{define object for managing the shapes (graphs, figures,..}
type
  TGraphiq = class(TObject)
private
  g_BrushColor : TColor;      {color of the brush = inside of the graphic elements}
  g_CopyBut    : TWorkBut;    {button for copying an element}
  g_DelBut     : TWorkBut;    {button for deleting a gr.element}
  g_Canvas     : TCanvas;     {canvas for text, mostly canvas of main form}
  g_BackBut    : TWorkBut;    {button for moving element to back (under other element(s)}
  g_drawing    : boolean;     {drawing a shape. Set in... reset in ...}
  g_EditBox    : TEdit;       {box for writing/editing text in the main form}
  g_ElList     : TStringList; {list of graphical elements and properties as strings}
  g_CopyList   : TStringList; {local clipboard for copying elements}
  g_first      : boolean;     {drawing first shape, when moving the mouse. Set in.., reset in..}
  g_List       : TList;       {list of pointers to the shapes}
  g_Inside     : TList;       {list of elements inside given rectangle}
  g_MemoBox    : TMemo;       {box for writing/editing text in the main form on several lines}
  g_MovImg     : TMoveImage;  {marker for moving the graph}
  g_PenColor   : TColor;      {color of the pen (lines) in the shape to be drawn}
  g_penwidth   : integer;     {size of the pen}
  g_quarter    : TQuarter;    {direction of directional elements}
  g_pForm      : TpForm;      {pointer to the form, where shapes drawn}
  g_pGraph     : TpGraphel;   {pointer to the graphic element being worked with (drawn, etc)}
  g_ResButDown : boolean;     {reset button down}
  g_shapeIndex : integer;     {index of the shape to be drawn, 0 = nothing, 1=rectangle, 2=ellips, etc}
  DrawGraphel  : array[0..7]  of TProc;   {procedures for drawing different shapes}
  InGraphel    : array[0..7]  of TProc;   {procedures for checking, is x,y inside element}
  RecalEl      : array[1..11] of TRecall; {procedures for recalling saved graphs from strings}
  g_pMarkers   : array[0..7]  of longint; {pointers to images as integers}

  constructor Create;
//destructor Destroy; override;
  procedure FreeLists;
  procedure ResButState(down: boolean);  {copy the state of the reset button}
  procedure PutShapeIndex(indx: integer);
  procedure CreateAndAddGraphicElement(indx: integer);
  procedure FreeGraphicElements;
  procedure FreeMarkers;
  procedure HideMarkers;
  procedure HideDirPanel;
  procedure DeleteSelectedElement;
  procedure SendSelectedElementToBack;
  procedure CopySelectedElementToClipboard;
  procedure DeleteAll;
public
  procedure putpForm(pForm: TpForm);
  procedure StartDrawing(x,y : integer);
  procedure DrawWithMouse(x,y : integer);
  procedure FinishDrawingWithMouse(x,y : integer);
  procedure CreateEditBox;
  procedure CreateMemoBox;
  procedure CreateMarkers;
  procedure DrawAll;
  procedure MoveAll(dx,dy : integer);
  procedure MoveInsideOnes(dx,dy : integer);
  procedure MoveInList(List: TList; dx,dy : integer);
  procedure SketchOnCanvas(Toile: TCanvas; xc,yc, cw,ch: integer);
  function  pActiveElementIf: TpGraphel;
  procedure SetElementPenColorIf(col: TColor);
  procedure SetElementPenWidthIf(width: integer);
  procedure SetElementBrushColorIf(col: TColor);
  procedure SetElementQuarterIf(quarter: TQuarter);
  procedure EditBoxExit(sender: TObject);
  procedure MemoBoxExit(sender: TObject);
  procedure EditBoxChange(sender: TObject);
  procedure MemoBoxChange(Sender: TObject);
  function  FontAndWidthOfText(font: TFont; text: string): integer;
  function  WidthOfMemoText(var hh : integer): integer;
  procedure ElementsToList;
  procedure ElementsFromList(ElList:TstringList);
  procedure OneElementToList(pGrel: TpGraphel; ElList: TStringList; dx : integer);
  procedure DeleteElement(pGrel: TpGraphel; indx: integer);
  procedure MemoTextOut(pMemo: TpMemo; xx,yy: integer; pGrel : TpGraphel);
  procedure InsideRectangle(x1,y1,x2,y2: integer);
  procedure ResetCanvas;
  procedure SetCanvas(Toile: TCanvas);
  procedure WriteElementsToFile(pOutfile: TpTextFile; flg : string);
  procedure CopyListAndAddCR(TmpList: TStringList);
  procedure CopyInsideToList(GraphList: TList);  {copy pointers to moved graphical elements}
  procedure CopyListToInside(GraphList: TList);
  procedure CopyAllToInsideList;
end;

var
  Graphic : TGraphiq;
  pCtrlBut : TpSpeedButton;   {button on the main form controlling the visibility of MenuForm}
  pMainForm : TpForm;
  PartStrings : TStringList;
  TempList : TStringList;
{define a collection of variables, for transoport}
type
  TMulti = record
  pp : longint;
  xx : integer;
  yy : integer;
end;
{and pointer to this type of record}
type
  TpMulti = ^TMulti;
  TpImage = ^TImage;

const
  mark_w = 8;  {width of marking square}
  move_w = 25; {widht of square for moving}
  but_w = 16;  {width of button}
  text_w = 6;  {width of the line surrounding a text}
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - procedures - - - - - - - -
procedure BigDelay;
{Long delay for testing that a procedure is called}
var
  ll,kk,mm : longint;
begin
  kk := 0;
  for ll := 1 to 1000000000 do begin
    for mm := 1 to 2 do begin
      kk := kk+1;
    end;
  end;

end;

procedure InNothing(mm : longint);
{another dummy procedure}
begin
  {do nothing}
end;

procedure AngleTextOut(ACanvas: TCanvas; Angle, X, Y: Integer; Str: string);
var
  LogRec: TLogFont;
  OldFontHandle,
  NewFontHandle: hFont;
begin
  GetObject(ACanvas.Font.Handle, SizeOf(LogRec), Addr(LogRec));
  LogRec.lfEscapement := Angle*10;
  NewFontHandle := CreateFontIndirect(LogRec);
  OldFontHandle := SelectObject(ACanvas.Handle, NewFontHandle);
  ACanvas.TextOut(X, Y, Str);
  NewFontHandle := SelectObject(ACanvas.Handle, OldFontHandle);
  DeleteObject(NewFontHandle);
end;



procedure MultiPar(mm: longint; var pGrel: TpGraphel; var xx,yy,x1,y1,x2,y2 : integer);
{extgract the input parameters, and the coordinates
 mm     pointer to the parameters, as integer
 pGrel  pointer to the graphical element
 xx,yy  coordinates of the cursor (mouse)
 x1,y1  coordinates of one corner limiting the graphical element
 x2,y2  coordinates of the opposite corner}
var
  pMulti : TpMulti;        {pointer to the parameters}
begin
  pMulti := TpMulti(mm);  {pointer to the parameters}
  pGrel := TpGraphel(pMulti^.pp);
  {coordinates}
  xx := pMulti^.xx;
  yy := pMulti^.yy;
  {copy cordinates of the corners to local}
  x1 := pGrel^.e_x1;
  y1 := pGrel^.e_y1;
  x2 := pGrel^.e_x2;
  y2 := pGrel^.e_y2;
end;

procedure GetpMarker(indx : integer; var pMrk : TpMarkImage);
var
  ll : longint;
begin
  ll := Graphic.g_pMarkers[indx];
  pMrk := TpMarkImage(ll);
end;

procedure ShowLineMarkers(pGrel: TpGraphel; x1,y1,x2,y2 : integer);
{place and show markers at both ends of the line
 pGrel  pointer to the graphic element
 x1,y1, x2,y2  coordinates of the endpoints of the line (in arbitrafy order...)}
var
  pMrkL : TpMarkImage; {pointer to left marker}
  pMrkR : TpMarkImage; {pointer to right marker}
  w2    : integer;     {half width of the marker}
  wmi   : integer;     {width of the move-image}
  xf,yf : integer;     {coordinates of first marker }
  xs,ys : integer;     {coordinates of second marker }
  xm,ym : integer;     {coordinates for the move-image}
begin
  w2 := mark_w div 2;  {half width}
  wmi := Graphic.g_MovImg.width;
  {center of markers on the ends of line}
  { 0   1   2
    7       3
    6   5   4}
  if (pGrel^.e_linedir = ltrb) then begin          {line drawn from left top to right bottom}
    GetpMarker(0,pMrkL);  {pointer to first marker}
    GetpMarker(4,pMrkR);  {pointer to second marker}
    xf := x1-w2;
    xs := x2-w2;
    yf := y1-w2;
    ys := y2-w2;
    xm := x1-w2-wmi;
    ym := y1;
  end else if (pGrel^.e_linedir = lbrt) then begin {from left bottom to right top}
    GetpMarker(6,pMrkL);  {pointer to first marker}
    GetpMarker(2,pMrkR);  {pointer to second marker}
    xf := x1-w2;
    xs := x2-w2;
    yf := y1-w2;
    ys := y2-w2;
    xm := x2+w2;
    ym := y2;
  end else if (pGrel^.e_linedir = rtlb) then begin {from right top to left bottom}
    GetpMarker(2,pMrkL);  {pointer to first marker}
    GetpMarker(6,pMrkR);  {pointer to second marker}
    xf := x2-w2;
    xs := x1-w2;
    yf := y2-w2;
    ys := y1-w2;
    xm := x1+w2;
    ym := y1;
  end else if (pGrel^.e_linedir = rblt) then begin {from right bottom to left top}
    GetpMarker(4,pMrkL);  {pointer to first marker}
    GetpMarker(0,pMrkR);  {pointer to second marker}
    xf := x2-w2;
    xs := x1-w2;
    yf := y2-w2;
    ys := y1-w2;
    xm := x2-w2-wmi;
    ym := y2;
  end else begin          {error case, some values}
    xf := x1-w2;
    xs := x2-w2;
    yf := y1-w2;
    ys := y2-w2;
    xm := x1;
    ym := y1;
  end;
  {put the markers to right places, display}
  pMrkL^.left := xf;
  pMrkL^.top := yf;
  pMrkR^.left := xs;
  pMrkR^.top := ys;
  pMrkL^.visible := true;
  pMrkL^.enabled := true;
  pMrkR^.visible := true;
  pMrkR^.enabled := true;
  {the marker for moving the image}
  Graphic.g_MovImg.left := {((x1+x2) div 2)-(move_w div 2)}xm;
  Graphic.g_MovImg.top := {((y1+y2) div 2)-(move_w div 2)}ym;
  Graphic.g_MovImg.visible := true;
  Graphic.g_MovImg.enabled := true;
  {the button for deleting the image}
  Graphic.g_DelBut.left := {xf+w2+4}xm;
  Graphic.g_DelBut.top := {yf+w2+4}ym+wmi;
  Graphic.g_DelBut.visible := true;
  {button for moving the element to back (below other element(s9}
  Graphic.g_BackBut.left := Graphic.g_DelBut.left;
  Graphic.g_BackBut.top := Graphic.g_DelBut.top+Graphic.g_DelBut.height;
  Graphic.g_BackBut.visible := true;
  {button for copying the element }
  Graphic.g_CopyBut.left := Graphic.g_DelBut.left;
  Graphic.g_CopyBut.top := Graphic.g_BackBut.top+Graphic.g_BackBut.height;
  Graphic.g_CopyBut.visible := true;
end;

procedure ShowAllMarkers(x1,y1,x2,y2 : integer);
{place and show all markers around the rectangle limiting the element
 x1,y1  coordinates of upper left corner
 x2,y2  coordinates of lower right corner}
var
  ii    : integer;
  ix,iy : integer;      {coordinates}
  pMrk  : TpMarkImage;  {pointer to a marker}
  w2    : integer;      {half width of the marker}
begin
  {from upper left corner clockwise}
  w2 := mark_w div 2;
  GetpMarker(0,pMrk);
  pMrk^.left := x1-w2;
  pMrk^.top := y1-w2;
  {second}
  GetpMarker(1,pMrk);
  pMrk^.left := ((x2+x1) div 2)-w2;
  pMrk^.top := y1-w2;
  {third}
  GetpMarker(2,pMrk);
  pMrk^.left := x2-w2;
  pMrk^.top := y1-w2;
  {fourth}
  GetpMarker(3,pMrk);
  pMrk^.left := x2-w2;
  pMrk^.top := ((y1+y2) div 2)-w2;
  {fifth}
  GetpMarker(4,pMrk);
  pMrk^.left := x2-w2;
  pMrk^.top := y2-w2;
  {sixth}
  GetpMarker(5,pMrk);
  pMrk^.left := ((x1+x2) div 2)-w2;
  pMrk^.top := y2-w2;
  {seventh}
  GetpMarker(6,pMrk);
  pMrk^.left := x1-w2;
  pMrk^.top := y2-w2;
  {eighth}
  GetpMarker(7,pMrk);
  pMrk^.left := x1-w2;
  pMrk^.top := ((y1+y2) div 2)-w2;
  {markers visible}
  for ii := 0 to high(Graphic.g_pMarkers) do begin
    GetpMarker(ii,pMrk);
    pMrk^.visible := true;
    pMrk^.enabled := true;
  end;
  {show also the marker for moving the graphical element}
//ix := ((x1+x2) div 2)-(move_w div 2);
//iy := ((y1+y2) div 2)-(move_w div 2);
  graphic.g_MovImg.left := {ix}x1-w2-graphic.g_MovImg.width;
  graphic.g_MovImg.top := {iy}y1-w2{-graphic.g_MovImg.height};
  graphic.g_MovImg.visible := true;
  graphic.g_MovImg.enabled := true;
  {button for deleting the gr.element}
  Graphic.g_DelBut.left := {x2+w2+4}graphic.g_MovImg.left;
  Graphic.g_DelBut.top := {y1+w2+4}graphic.g_MovImg.top+graphic.g_MovImg.height;
  Graphic.g_DelBut.visible := true;
  {button for moving the element to back (below other element(s9}
  Graphic.g_BackBut.left := Graphic.g_DelBut.left;
  Graphic.g_BackBut.top := Graphic.g_DelBut.top+Graphic.g_DelBut.height;
  Graphic.g_BackBut.visible := true;
  {button for copying the element }
  Graphic.g_CopyBut.left := Graphic.g_DelBut.left;
  Graphic.g_CopyBut.top := Graphic.g_BackBut.top+Graphic.g_BackBut.height;
  Graphic.g_CopyBut.visible := true;
end;

procedure InBox(mm : longint);
{find, is the given point (xx, yy) inside the given box (rectangle)
 mm  pointer  to the parameters
 mm.pp  pointer to the graphic element
 mm.xx  x-coordinate
 mm.yy  y-coordinate}
var
  inside : boolean;     {x,y is inside the box (rectangle)}
  pGrel  : TpGraphel;   {pointer to the graphical element}
  xx,yy  : integer;     {xx,yy  coordinates}
  x1,y1  : integer;     {coordinates of upper left corner}
  x2,y2  : integer;     {coordinates of lower right corner}
begin
  {get parameters and corners}
  MultiPar(mm, pGrel, xx,yy,x1,y1,x2,y2);
  {1 = upper left, 2 = lower right, arranged in FinishDrawing}
  inside := (xx > x1) and (xx < x2) and (yy > y1) and (yy < y2);
  pGrel^.e_inside := inside;
  {mark the element, if element selected}
  if (inside) then ShowAllMarkers(x1,y1,x2,y2)
end;

procedure InOval(mm : longint);
{find, is the given point (xx, yy) inside the given ellipse (oval element)
 mm  pointer  to the parameters
 mm.pp  pointer to the graphic element
 mm.xx  x-coordinate
 mm.yy  y-coordinate}
var
  apu,apv : single;      {temporary}
  cc      : single;      {distance from focal points squared}
  dd      : single;      {distance between the focal points squared}
  inside  : boolean;     {x,y is inside the box (rectangle)}
  pGrel   : TpGraphel;   {pointer to the graphical element}
  sd      : single;      {sum of distances to focal point}
  xf1,yf1 : single;      {one focal point}
  xf2,yf2 : single;      {the other focal point}
  xx,yy   : integer;     {xx,yy  coordinates}
  x1,y1   : integer;     {cordinates of one corner limiting the ellipse}
  x2,y2   : integer;     {cordinates of the opposite corner}
begin
  {get parameters and corners}
  MultiPar(mm, pGrel, xx,yy,x1,y1,x2,y2);
  {check, is (xx,yy) inside the ellipse (graphical element)}
  {vertical or horizontal ellipse?}
  if (abs(x2-x1) > abs(y2-y1)) then begin         {horizontal ellipse}
    apu := (x1-x2)*(x1-x2);                       {2*long axis squared (4*a*a)}
    apv := (y1-y2)*(y1-y2);                       {2*short axis squared}
    if (apu >= apv) then                          {reasonable axes}
      dd := apu-apv else dd := 0;                 {distance between focal points squared}
    xf1 := 0.5*(x1+x2)-0.5*sqrt(dd);              {x of first focal point}
    xf2 := 0.5*(x1+x2)+0.5*sqrt(dd);              {x of second focal point}
    yf1 := 0.5*(y1+y2);                           {y of first focal point}
    yf2 := yf1;                                   {y of second focal point}
    cc := abs(x2-x1);                             {sum of distances}
  end else begin                                  {vertical ellipse}
    apu := (y1-y2)*(y1-y2);                       {2*long axis squared (4*a*a)}
    apv := (x1-x2)*(x1-x2);                       {2*short axis squared}
    if (apu >= apv) then                          {reasonable axes}
      dd := apu-apv else dd := 0;                 {distance between focal points squared}
    yf1 := 0.5*(y1+y2)-0.5*sqrt(dd);              {y of first focal point}
    yf2 := 0.5*(y1+y2)+0.5*sqrt(dd);              {y of second focal point}
    xf1 := 0.5*(x1+x2);                           {x of first focal point}
    xf2 := xf1;                                   {x of second focal point}
    cc := abs(y2-y1);                             {sum of distances}
  end;
  {sum of distances to the focal points from x,y}
  apu := (xx-xf1)*(xx-xf1)+(yy-yf1)*(yy-yf1);
  apv := (xx-xf2)*(xx-xf2)+(yy-yf2)*(yy-yf2);
  sd := sqrt(apu)+sqrt(apv);
  {inside ellipse?}
  pGrel^.e_inside := (sd < cc);
  if (pGrel^.e_inside) then ShowAllMarkers(x1,y1,x2,y2)
end;

procedure OnLine(mm : longint);
{find, is the given point (xx, yy) on the given line (with some margins)
 mm  pointer  to the parameters
 mm.pp  pointer to the graphic element
 mm.xx  x-coordinate
 mm.yy  y-coordinate}
var
  inside : boolean;     {x,y is inside the box (rectangle)}
  kk     : single;      {interpolation coefficient}
  kx,ky  : single;      {interpolation coefficients}
  pGrel  : TpGraphel;   {pointer to the graphical element}
  xx,yy  : integer;     {xx,yy  coordinates}
  x1,y1  : integer;     {cordinates of one corner}
  x2,y2  : integer;     {cordinates of the opposite corner}
  xt,yt  : single;      {test-x, test-y}
begin
  {get parameters and corners}
  MultiPar(mm, pGrel, xx,yy,x1,y1,x2,y2);
  {vertical line, horzontal or oblique line ?}
  if (x1 = x2) then begin
  {vertical line ?}
    if (y1 = y2) then begin         {just a point, not reasonable}
      inside := false;
    end else begin
      kk := (yy-y2)/(y1-y2);         {interpolation coefficient}
      inside := (0 < kk) and (kk < 1) and
                (abs(xx-x1) < 5);    {at x1=x2, with some margin}
    end;
  end else if (y1 = y2) then begin
  {horizontal line}
    if (x1 = x2) then begin          {just a point, not reasonable}
      inside := false;
    end else begin
      kk := (xx-x2)/(x1-x2);         {interpolation coefficient}
      inside := (0 < kk) and (kk < 1) and
                (abs(yy-y1) < 5);    {at y1=y2, with some margin}
    end;
  {oblique}
  end else begin
    kx := (xx-x2)/(x1-x2);           {interpolation coefficient for x}
    ky := (yy-y2)/(y1-y2);           {..and for y}
    {oblique, but not so steep, take y as function x}
    if (abs(y1-y2) < abs(x1-x2)) then begin
      kk := (y2-y1)/(x2-x1);           {linear coefficient}
      {test y from linear equation}
      yt := y1+kk*(xx-x1);
      {on line?}
      inside := (0 < kx) and (kx < 1) and (abs(yy-yt) < 5);
    {oblique, but steep. Take x as function of y}
    end else begin
      kk := (x2-x1)/(y2-y1);           {linear coefficient}
      {test y from linear equation}
      xt := x1+kk*(yy-y1);
      {on line?}
      inside := (0 < ky) and (ky < 1) and (abs(xx-xt) < 5);
    end;
  end;
  pGrel^.e_inside := inside;
  {show the markers, if on line}
  if (inside) then ShowLineMarkers(pGrel,x1,y1,x2,y2);
end;

function InsideTriangle(bb,hh, b1,b2, h1,h2 : integer): boolean;
{true, when the point (bb,hh) is inside of the equilateral triangle, when
 the base is between points (b1,h1) and (b2,h1),
 and the top is in point [(b1+b2)/2,h2]
 b1 and b2 are the coordinates in the axis that is parallel with the base
 and h1, h2 are the coordinates in the axis that is perpendicular to the base
 (that is b is x or y, and h is y or x)}
var
  bl,br : single; {point on the side of the triangle}
  kk    : single;
begin
  if (h2 <> h1) then begin
    kk := (hh-h2)/(h1-h2);
    {first point on the side of the triangle at height hh}
    bl := kk*((b2-b1) div 2)+b1;
    {point on the other side}
    br := b2-kk*((b2-b1) div 2);
    InsideTriangle := (hh > h1) and (h2 > hh) and (bl < bb) and (bb < br);
  end else begin
    InsideTriangle := false;
  end;
end;

procedure InTriangle(mm : longint);
{find, is the given point (xx, yy) inside the given equilateral triangle
 mm  pointer  to the parameters
 mm.pp  pointer to the graphic element
 mm.xx  x-coordinate
 mm.yy  y-coordinate}
var
  inside : boolean;     {x,y is inside the triangle}
  kk     : single;      {ratio}
  pGrel  : TpGraphel;   {pointer to the graphical element}
  xx,yy  : integer;     {xx,yy  coordinates}
  x1,y1  : integer;     {coordinates of upper left corner}
  x2,y2  : integer;     {coordinates of lower right corner}
begin
  {get parameters and corners}
  MultiPar(mm, pGrel, xx,yy,x1,y1,x2,y2);
  {1 = upper left, 2 = lower right, arranged in FinishDrawing}
  if (pGrel^.e_quarter = north) then
    inside := InsideTriangle(xx,yy,x1,x2,y1,y2)
  else if (pGrel^.e_quarter = west) then
    inside := InsideTriangle(yy,xx,y1,y2,x1,x2)
  else if (pGrel^.e_quarter = south) then
    inside := InsideTriangle(xx,-yy,x1,x2,-y2,-y1)
  else if (pGrel^.e_quarter = east) then
    inside := InsideTriangle(yy,-xx,y1,y2,-x2,-x1)
  else
    inside := false;
  pGrel^.e_inside := inside;
  {mark the element, if element selected}
  if (inside) then begin
    ShowAllMarkers(x1,y1,x2,y2);
    DrawMenuForm.DirPanel.visible := true;
  end;
end;

function InsideArrow(bb,hh, b1,b2, h1,h2 : integer): boolean;
{true, when the point (bb,hh) is inside of the arrow, when
 the base is on the line between (b1,h2) and (b2,h2), and the
 tip of the arrow is in point [(b1+b2)/2,h1]
 b1 and b2 are the coordinates in the axis that is parallel with the base
 and h1, h2 are the coordinates in the axis that is perpendicular to the base
 (that is b is x or y, and h is y or x)
 NOTE the function is not exact, the tip-part of the arrow is not considered properly}
begin
  InsideArrow := false;
end;

procedure ArrowPoints(xu,yu,xr,yr: integer; var x1,y1,x2,y2,x3,y3,x4,y4,x5,y5,x6,y6,x7,y7 : integer);
{define the seven corners of an arrow, when the rectangle surrounding it is given
 xu,yu  coordinates of upper left corner
 xr.yr  coordinates of lower right corner
 x1,y1  coordinates of the tip of the arrow
 x2,y2  next corner, clock-wise}
begin
  x1 := (xu+xr) div 2;
  y1 := yu;
  x2 := xr;
  y2 := yu+((yr-yu)div 4);
  x3 := xr-((xr-xu) div 4);
  y3 := y2;
  x4 := x3;
  y4 := yr;
  x5 := xu+((xr-xu) div 4);
  y5 := yr;
  x6 := x5;
  y6 := y2;
  x7 := xu;
  y7 := y2;
end;

procedure GetCorners(ll: longint;var xu,yu,xr,yr : integer);
{get the coordinates of the upper left and lower right corners of the rectangle
 surrounding the graphical element (needed when drawing with moving mouse)
 ll     pointer to the element as integer
 xu,yu  coordinates of the upper left corner
 xr,yr  coordinates of the lower right corner}
var
  pGrel : TpGraphel;
begin
  pGrel := TpGraphel(ll);
  if (pGrel^.e_x1 < pGrel^.e_x2) then begin
    xu := pGrel^.e_x1;
    xr := pGrel^.e_x2;
  end else begin
    xu := pGrel^.e_x2;
    xr := pGrel^.e_x1;
  end;
  if (pGrel^.e_y1 < pGrel^.e_y2) then begin
    yu := pGrel^.e_y1;
    yr := pGrel^.e_y2;
  end else begin
    yu := pGrel^.e_y2;
    yr := pGrel^.e_y1;
  end;
end;

procedure GetArrowPoints(ll : longint; var x1,y1,x2,y2,x3,y3,x4,y4,x5,y5,x6,y6,x7,y7: integer);
{get the points definding the arrow. 1 = tip, then clockwise
 ll  pointer to the graphical element, as integer}
var
  pGrel : TpGraphel;
  xr,yr : integer;   {coordinates of lower right corner of the rectangle around the arrow}
  xu,yu : integer;   {coordinates of upper left corner of the rectangle around the arrow}
begin
  {get the upper left and lower right corners}
  GetCorners(ll, xu,yu,xr,yr);
  pGrel := TpGraphel(ll);
  if (pGrel^.e_quarter = north) then begin         {pointing upwards (north)}
    ArrowPoints(xu,yu,xr,yr, x1,y1,x2,y2,x3,y3,x4,y4,x5,y5,x6,y6,x7,y7);
  end else if (pGrel^.e_quarter = west) then begin {pointing to the right (east)}
    ArrowPoints(yu,xu,yr,xr, y1,x1,y2,x2,y3,x3,y4,x4,y5,x5,y6,x6,y7,x7);
  end else if (pGrel^.e_quarter = south) then begin {pointing downwards (south)}
    ArrowPoints(xr,yr,xu,yu, x1,y1,x2,y2,x3,y3,x4,y4,x5,y5,x6,y6,x7,y7);
  end else if (pGrel^.e_quarter = east) then begin {pointing left (west)}
    ArrowPoints(yr,xr,yu,xu, y1,x1,y2,x2,y3,x3,y4,x4,y5,x5,y6,x6,y7,x7);
  end else begin                            {not possible, error}
    y1 := pGrel^.e_y1;
    y2 := pGrel^.e_y1;
    y3 := pGrel^.e_y2;
  end;
end;

procedure InArrow(mm : longint);
{find, is the given point (xx, yy) (approximately!) inside the given arrow
 (base at bottom)
 mm  pointer  to the parameters
 mm.pp  pointer to the graphic element
 mm.xx  x-coordinate
 mm.yy  y-coordinate}
var
  inside : boolean;     {x,y is inside the arrow}
  ll     : longint;
  pGrel  : TpGraphel;   {pointer to the graphical element}
  sx,sy  : integer;     {lengths of the sides of the "body"}
  xa,ya  : integer;
  xb,yb  : integer;
  xx,yy  : integer;     {xx,yy  coordinates}
  xu,yu  : integer;     {one point on the side of the arrow tip}
  xv,yv  : integer;     {a point on the other side of the arrow tip}
  x1,y1  : integer;     {first point on the arrow = the tip of the arrow}
  x2,y2  : integer;
  x3,y3  : integer;
  x4,y4  : integer;
  x5,y5  : integer;
  x6,y6  : integer;
  x7,y7  : integer;
begin
  {get parameters and corners}
  {1 = upper left, 2 = lower right, arranged in FinishDrawing}
  MultiPar(mm, pGrel, xx,yy,xa,ya,xb,yb);
  {get points defining the arrow. 1 = tip, then clockwise}
  ll := longint(pGrel);
  GetArrowPoints(ll, x1,y1,x2,y2,x3,y3,x4,y4,x5,y5,x6,y6,x7,y7);
  {for simplicity, consider only  the "body" of the arrow}
  {points on the sides of the arrow tip}
  xu := (x1+x2) div 2;
  yu := (y1+y2) div 2;
  xv := (x1+x7) div 2;
  yv := (y1+y7) div 2;
  {consider only rectangle u-4-5-v}
  if (pGrel^.e_quarter = north) or (pGrel^.e_quarter = south) then begin {vertical}
    sx := abs(x4-x5);
    sy := abs(yu-y4);
  end else begin  {horizontal}
    sx := abs(xu-x4);
    sy := abs(y4-y5);
  end;
  {inside, if distances to edges smaller than sides}
  inside := (abs(xx-x4) < sx) and (abs(xx-xv) < sx) and
            (abs(yy-y4) < sy) and (abs(yy-yv) < sy);
  pGrel^.e_inside := inside;
  {mark the element, if element selected}
  if (inside) then begin
    ShowAllMarkers(xa,ya,xb,yb);
    DrawMenuForm.DirPanel.visible := true;
  end;
end;

procedure InTextBox(mm : longint);
{find, is the given point (xx, yy) inside the given box (rectangle)
 mm  pointer  to the parameters
 mm.pp  pointer to the graphic element
 mm.xx  x-coordinate
 mm.yy  y-coordinate}
var
  inside : boolean;     {x,y is inside the box (rectangle)}
  pGrel  : TpGraphel;   {pointer to the graphical element}
  pMrk   : TpMarkImage; {pointer to marker}
  xx,yy  : integer;     {xx,yy  coordinates}
  x1,y1  : integer;     {coordinates of upper left corner}
  x2,y2  : integer;     {coordinates of lower right corner}
begin
  {get parameters and corners}
  MultiPar(mm, pGrel, xx,yy,x1,y1,x2,y2);
  {1 = upper left, 2 = lower right, arranged in FinishDrawing}
  inside := (xx > x1) and (xx < x2) and (yy > y1) and (yy < y2);
  pGrel^.e_inside := inside;
  {if inside, show edit-box for changing the text, and mark the element}
  if (inside) then begin
    Graphic.g_EditBox.top := pGrel^.e_y1;
    Graphic.g_EditBox.left := pGrel^.e_x1;
    Graphic.g_EditBox.width := pGrel^.e_x2-pGrel^.e_x1;
    Graphic.g_EditBox.height := pGrel^.e_y2-pGrel^.e_y1;
    Graphic.g_EditBox.font.assign(pGrel^.e_pFont^);
    Graphic.g_EditBox.text := pGrel^.e_text;
    Graphic.g_EditBox.visible := true;
    Graphic.g_EditBox.tag := longint(pGrel);           {tag = pointer to element as integer}
    DrawMenuForm.FontBut.visible := true;
    {mark the element, if element selected}
    ShowAllMarkers(x1,y1,x2,y2);
    {move the marker for moving so that it is visible}
//  pMrk := TpMarkImage(Graphic.g_pMarkers[0]);        {pointer to first marker}
//  Graphic.g_MovImg.left := pMrk^.left-(move_w div 2)-2;
//  Graphic.g_MovImg.top := pMrk^.top-(move_w div 2)-2;
  end;
end;

procedure InMemoBox(mm : longint);
{find, is the given point (xx, yy) inside the given box (rectangle)
 mm  pointer  to the parameters
 mm.pp  pointer to the graphic element
 mm.xx  x-coordinate
 mm.yy  y-coordinate}
var
  inside : boolean;     {x,y is inside the box (rectangle)}
  pGrel  : TpGraphel;   {pointer to the graphical element}
  pMrk   : TpMarkImage; {pointer to marker}
  xx,yy  : integer;     {xx,yy  coordinates}
  x1,y1  : integer;     {coordinates of upper left corner}
  x2,y2  : integer;     {coordinates of lower right corner}
begin
  {get parameters and corners}
  MultiPar(mm, pGrel, xx,yy,x1,y1,x2,y2);
  {1 = upper left, 2 = lower right, arranged in FinishDrawing}
  inside := (xx > x1) and (xx < x2) and (yy > y1) and (yy < y2);
  pGrel^.e_inside := inside;
  {if inside, show memo-box for changing the text, and mark the element}
  if (inside) then begin
    {position and size of memo box depends on the direction of text}
    if (pGrel^.e_quarter = east) then begin
      Graphic.g_MemoBox.top := pGrel^.e_y1;
      Graphic.g_MemoBox.left := pGrel^.e_x1;
      Graphic.g_MemoBox.width := pGrel^.e_x2-pGrel^.e_x1;
      Graphic.g_MemoBox.height := pGrel^.e_y2-pGrel^.e_y1;
    end else if (pGrel^.e_quarter = north) then begin
      Graphic.g_MemoBox.top := pGrel^.e_y2;
      Graphic.g_MemoBox.left := pGrel^.e_x1;
      Graphic.g_MemoBox.width := pGrel^.e_y2-pGrel^.e_y1;
      Graphic.g_MemoBox.height := pGrel^.e_x2-pGrel^.e_x1;
    end else if (pGrel^.e_quarter = west) then begin
      Graphic.g_MemoBox.top := pGrel^.e_y2;
      Graphic.g_MemoBox.left := pGrel^.e_x2;
      Graphic.g_MemoBox.width := pGrel^.e_x2-pGrel^.e_x1;
      Graphic.g_MemoBox.height := pGrel^.e_y2-pGrel^.e_y1;
    end else if (pGrel^.e_quarter = south) then begin
      Graphic.g_MemoBox.top := pGrel^.e_y1;
      Graphic.g_MemoBox.left := pGrel^.e_x2;
      Graphic.g_MemoBox.width := pGrel^.e_y2-pGrel^.e_y1;
      Graphic.g_MemoBox.height := pGrel^.e_x2-pGrel^.e_x1;
    end else begin                                           {error case}
      Graphic.g_MemoBox.top := pGrel^.e_y1;
      Graphic.g_MemoBox.left := pGrel^.e_x1;
      Graphic.g_MemoBox.width := pGrel^.e_x2-pGrel^.e_x1;
      Graphic.g_MemoBox.height := pGrel^.e_y2-pGrel^.e_y1;
    end;
//  Graphic.g_MemoBox.font.assign(pGrel^.e_pFont^);
Graphic.g_MemoBox.font := pGrel^.e_pFont^;
    Graphic.g_MemoBox.text := pGrel^.e_text;
    Graphic.g_MemoBox.visible := true;
    Graphic.g_MemoBox.tag := longint(pGrel);           {tag = pointer to element as integer}
    DrawMenuForm.FontBut.visible := true;
    {mark the element, if element selected}
    ShowAllMarkers(x1,y1,x2,y2);
    {move the marker for moving so that it is visible}
//  pMrk := TpMarkImage(Graphic.g_pMarkers[0]);        {pointer to first marker}
//  Graphic.g_MovImg.left := pMrk^.left-(move_w div 2)-2;
//  Graphic.g_MovImg.top := pMrk^.top-(move_w div 2)-2;
    DrawMenuForm.DirPanel.visible := true;             {show the direction-buttons}
  end;

end;

procedure DrawNothing(ll : longint);
{dummy procedure
 ll  parameter (not used yet ?!)}
begin
  {do nothing}
end;

procedure DrawBox(ll: longint);
{procedure for drawing a rectangle}
var
  pGrel : TpGraphel;
begin
  pGrel := TpGraphel(ll);
  pGrel^.e_toile.rectangle(pGrel^.e_x1,pGrel^.e_y1,pGrel^.e_x2,pGrel^.e_y2);
end;

procedure DrawOval(ll: longint);
{procedure for drawing an ellipse}
var
  pGrel : TpGraphel;
begin
  pGrel := TpGraphel(ll);
  pGrel^.e_toile.ellipse(pGrel^.e_x1,pGrel^.e_y1,pGrel^.e_x2,pGrel^.e_y2);
end;

procedure DrawLine(ll: longint);
{procedure for drawing a line}
var
  pGrel : TpGraphel;
begin
  pGrel := TpGraphel(ll);
  pGrel^.e_toile.MoveTo(pGrel^.e_x1,pGrel^.e_y1);
  pGrel^.e_toile.LineTo(pGrel^.e_x2,pGrel^.e_y2);
end;

procedure DrawTriangle(ll: longint);
{procedure for drawing an equilateral triangle}
var
  pGrel : TpGraphel;
  xr,yr : integer;   {lower right corner}
  xu,yu : integer;   {upper left corner}
  x1,y1 : integer;
  x2,y2 : integer;
  x3,y3 : integer;
begin
  {get the upper left and lower right corners}
  GetCorners(ll, xu,yu,xr,yr);
  pGrel := TpGraphel(ll);
  if (pGrel^.e_quarter = north) then begin         {pointing upwards (north)}
    x1 := xu;
    x2 := xr;
    x3 := (xu+xr) div 2;
    y1 := yr;
    y2 := yr;
    y3 := yu;
  end else if (pGrel^.e_quarter = east) then begin {pointing to the right (east)}
    x1 := xu;
    x2 := x1;
    x3 := xr;
    y1 := yu;
    y2 := yr;
    y3 := (y1+y2) div 2;
  end else if (pGrel^.e_quarter = south) then begin {pointing downwards (south)}
    x1 := xu;
    x2 := xr;
    x3 := (x1+x2) div 2;
    y1 := yu;
    y2 := y1;
    y3 := yr;
  end else if (pGrel^.e_quarter = west) then begin {pointing left (west)}
    x1 := xr;
    x2 := x1;
    x3 := xu;
    y1 := yu;
    y2 := yr;
    y3 := (y1+y2) div 2;
  end else begin                            {not possible, error}
    x1 := 0; x2 := 0; x3 := 0;
    y1 := 0; y2 := 0; y3 := 0;
  end;
  pGrel^.e_toile.Polygon([Point(x1,y1), Point(x2,y2), Point(x3,y3)]);
end;
      
procedure DrawArrow(ll: longint);
{procedure for drawing a thick arrow}
var
  pGrel : TpGraphel;
  x1,y1 : integer;   {first point on the arrow = the arrow point}
  x2,y2 : integer;
  x3,y3 : integer;
  x4,y4 : integer;
  x5,y5 : integer;
  x6,y6 : integer;
  x7,y7 : integer;
begin
  pGrel := TpGraphel(ll);
  {get the points defining the arrow = the corners}
  GetArrowPoints(ll, x1,y1,x2,y2,x3,y3,x4,y4,x5,y5,x6,y6,x7,y7);
  {draw the arrow, as a polygon}
  pGrel^.e_toile.Polygon([Point(x1,y1), Point(x2,y2), Point(x3,y3), Point(x4,y4),
                          Point(x5,y5), Point(x6,y6), Point(x7,y7)]);
end;

procedure DrawTextBox(ll: longint);
{procedure for drawing a rectangle fow writing text in it}
var
  ii    : integer;
  pGrel : TpGraphel;
  xx,yy : integer;
begin
  pGrel := TpGraphel(ll);
  {when initially drawing with the mouse, draw only a rectangle..}
  if (Graphic.g_drawing) and (DrawMenuForm.TextBut.down) then begin
    pGrel^.e_toile.rectangle(pGrel^.e_x1,pGrel^.e_y1,pGrel^.e_x2,pGrel^.e_y2)
  {but when refreshing, then draw only the text, no rectangle}
  end else begin
    xx := pGrel^.e_x1+2;
    yy := pGrel^.e_y1+2;
    pGrel^.e_toile.font.assign(pGrel^.e_pFont^);
//  pGrel^.e_toile.textout(xx,yy,pGrel^.e_text);
    AngleTextOut(pGrel^.e_toile, 0, xx, yy, pGrel^.e_text);
  end;
end;

procedure DrawMemoBox(ll: longint);
{procedure for drawing a rectangle for writing text in it}
var
  cnt   : integer;      {number of lines}
  hh    : integer;      {height of one line of text}
  dth   : integer;      {distance from line to line in y-direction}
  ii    : integer;
  pGrel : TpGraphel;
  xx,yy : integer;
begin
  pGrel := TpGraphel(ll);
  {when initially drawing with the mouse, draw only a rectangle..}
  if (Graphic.g_drawing) and (DrawMenuForm.MemoBut.down) then begin
    pGrel^.e_toile.rectangle(pGrel^.e_x1,pGrel^.e_y1,pGrel^.e_x2,pGrel^.e_y2);
  {but when refreshing, then draw only the text, no rectangle}
  end else begin
    {write line by line. Must copy text to memo in order to find the lines. Cleared below!!!}
    {...but not if there is not yet text in the gr.element (still writing)}
    if (length(pGrel^.e_text) > 0) then begin
      {use existing memo-component} {EI hyv viel...???}
      DrawMenuForm.DummyMemo.text := pGrel^.e_text;
      DrawMenuForm.DummyMemo.font.assign(pGrel^.e_pFont^);
      {starting point of the the text}
      xx := pGrel^.e_xtx+2;
      yy := pGrel^.e_ytx+2;
(*
      {position of text depends on direction of writing}
      if (pGrel^.e_OldQuarter = east) then begin   {to right, as normal text}
        xx := pGrel^.e_x10+2;
        yy := pGrel^.e_y10+2;
      end else if (pGrel^.e_Oldquarter = north) then begin  {vertically up}
        xx := pGrel^.e_x10+2;
        yy := pGrel^.e_y20;
      end else if (pGrel^.e_Oldquarter = west) then begin   {to left, upside down}
        xx := pGrel^.e_x20+2;
        yy := pGrel^.e_y20+2;
      end else if (pGrel^.e_Oldquarter = south) then begin  {vertically down}
        xx := pGrel^.e_x20+2;
        yy := pGrel^.e_y10+2;
      end else begin                                     {error}
        xx := pGrel^.e_x10+2;
        yy := pGrel^.e_y10+2;
      end;
*)
//xx := Graphic.g_MemoBox.left;
//yy := Graphic.g_MemoBox.top;
      Graphic.MemoTextOut(@DrawMenuForm.DummyMemo,xx,yy,pGrel);

//ShowAllMarkers(pGrel^.e_x1,pGrel^.e_y1,pGrel^.e_x2,pGrel^.e_y2);
      DrawMenuForm.DummyMemo.text := '';
    end;
  end;
end;

procedure GetPartStrings(line: string; ipParts: longint);
{pick part-strings from line, separated by semicolon(s))
 line    the string with several part-strings
 pParts  string list where the part strings are collected}
var
  ii     : integer;
  len    : integer;      {length of line}
  pParts : TpStringList; {words = strings separated from a line}
  psp    : boolean;      {previous was a semicolon}
  txt    : string;       {temporary}
begin
  pParts := TpStringList(ipParts);
  pParts^.clear;
  len := length(line);
  if (len > 0) then begin
    txt := '';
    psp := false;
    for ii := 1 to len do begin
      if (line[ii] = ';') then begin   {semicolon? separating part-strings}
        if (psp) then begin            {previous was also a semicolon, do nothing}
          {..}
        end else begin                 {first semicolon after text}
          if (ii = 1) then begin       {first char. may be a semicolon, do nothing}
            {..}
          end else begin
            pParts^.add(txt);          {put text to string list (space = separator)}
            txt := '';
          end;
        end;
        psp := true;                   {this was a semicolon}
      end else begin                   {not a space}
        txt := txt+line[ii];
        psp := false;
      end;
    end;
    {the last part-string, if any, must be added}
    if (txt <> '') then pParts^.add(txt);
  end;
end;

function IsInteger(line: string; var kk : integer): boolean;
{check, does the text in line represent an integer
 line  the text to be studied
 kk    the value of the integer, if line is one}
var
  ii  : integer;  {index}
  int : boolean;  {is/not an integer}
  len : integer;  {length of line}
begin
  len := length(line);
  if (len > 0) then begin
    int := true;                              {initialize}
    for ii := 1 to len do begin
      if ((line[ii] >= '0') and (line[ii] <= '9')) or   {number...}
         ((ii = 1) and (line[ii] = '-'))then begin      {..or a minus sign}
        {ok, do nothing}
      end else begin
        int := false;                         {not integer, error, break}
        break;
      end;
    end;
    {continue, if is integer}
    if (int) then kk := strtoint(line)         {get the integer}
    else kk := 0;                              {just some value}
  end else begin
    int := false;
    kk := 0;
  end;
  IsInteger := int;
end;

{procedures for recalling (recovering?) graphical elements from a string list (from a file) - - - - -}
procedure RecallElement(var ll: longint; line: string);
{create the element
 ll   pointer to the element, as integer
 line index = type of element as string}
var
  indx : integer;  {index = type of the graphical element}
begin
  {proceed only if line represents an integer}
  if (IsInteger(line, indx)) then begin
    Graphic.CreateAndAddGraphicElement(indx);
    ll := longint(Graphic.g_List.last);  {pointer to the new (last) element}
  end else begin                 {no integer, error}
    ll := 0;                     {nil-pointer}
  end;
end;

procedure RecallCoordinates(var ll: longint; line: string);
{recall the coordinates of the rectangle surrounding the graph.element
 The coordinates are packed in one line (one string), as x1;y1;x2;y2
 separated by semicolons
 ll   pointer to the graphical element, as integer
 line the string containing the coordinates}
var
  pGrel       : TpGraphel;  {pointer to the graphical element}
  t1,u1,t2,u2 : string;     {coordinates as strings}
  x1,y1       : integer;    {coordinates of upper left corner}
  x2,y2       : integer;    {coordinates of lower right corner}
begin
  pGrel := TpGraphel(ll);                        {pointer to the graphical element}
  if (pGrel <> nil) then begin                   {continue, if element exists}
    GetPartStrings(line, longint(@PartStrings)); {get the coordinates separately, as stings}
    {there should be 4 coordinates}
    if (PartStrings.count >= 4) then begin
      t1 := PartStrings[0];                   {pick the coordinates as strings}
      u1 := PartStrings[1];
      t2 := PartStrings[2];
      u2 := PartStrings[3];
      {continue, if all strinds represent integers, convert to integers}
      if (IsInteger(t1,x1)) and (IsInteger(u1,y1)) and
         (IsInteger(t2,x2)) and (IsInteger(u2,y2)) then begin
        pGrel^.e_x1 := x1;
        pGrel^.e_y1 := y1;
        pGrel^.e_x2 := x2;
        pGrel^.e_y2 := y2;
      end else begin                          {not integers, errors}
        pGrel^.e_x1 := 0;
        pGrel^.e_y1 := 0;
        pGrel^.e_x2 := 0;
        pGrel^.e_y2 := 0;
      end;
    end else begin                            {not coordinates, some error}
      pGrel^.e_x1 := 0;
      pGrel^.e_y1 := 0;
      pGrel^.e_x2 := 0;
      pGrel^.e_y2 := 0;
    end;
  end;
  {initial guess for start position of text. NOTE this works only, if x1,y1 read first, of course}
  pGrel^.e_xtx := pGrel^.e_x1;
  pGrel^.e_ytx := pGrel^.e_y1;
end;

procedure RecallStartPos(var ll: longint; line: string);
{recall the coordinates of the starting position of text.
 The coordinates are packed in one line (one string), as x1;y1
 separated by spaces
 ll   pointer to the graphical element, as integer
 line the string containing the coordinates}
var
  pGrel       : TpGraphel;  {pointer to the graphical element}
  t1,u1       : string;     {coordinates as strings}
  x1,y1       : integer;    {coordinates of start position}
begin
  pGrel := TpGraphel(ll);                        {pointer to the graphical element}
  if (pGrel <> nil) then begin                   {continue, if element exists}
    GetPartStrings(line, longint(@PartStrings)); {get the coordinates separately, as stings}
    {there should be 2 coordinates}
    if (PartStrings.count >= 2) then begin
      t1 := PartStrings[0];                   {pick the coordinates as strings}
      u1 := PartStrings[1];
      {continue, if all strinds represent integers, convert to integers}
      if (IsInteger(t1,x1)) and (IsInteger(u1,y1)) then begin
        pGrel^.e_xtx := x1;
        pGrel^.e_ytx := y1;
      end else begin                          {not integers, errors}
        pGrel^.e_xtx := pGrel^.e_x1;
        pGrel^.e_ytx := pGrel^.e_y1;
      end;
    end else begin                            {not coordinates, some error}
        pGrel^.e_xtx := pGrel^.e_x1;
        pGrel^.e_ytx := pGrel^.e_y1;
    end;
  end;
end;

procedure RecallPenColor(var ll: longint; line: string);
{recall and save the color pf the pen
 ll    pointer to the element
 line  the color as string}
var
  ipu   : integer;    {temporary}
  kk    : longint;    {temporary}
  pGrel : TpGraphel;  {pointer to the graphical element}
begin
  pGrel := TpGraphel(ll);                     {pointer to the graphical element}
  if (pGrel <> nil) then begin                {continue, if element exists}
    if (IsInteger(line,ipu)) then begin       {does the line represent an integer}
      kk := strtoint(line);                   {must be longint, if color}
      pGrel^.e_pencolor := TColor(kk);
    end;
  end;
end;

procedure RecallBrushColor(var ll: longint; line: string);
{recall and save the color of the brush (background)
 ll    pointer to the element
 line  the color as string}
var
  ipu   : integer;    {temporary}
  kk    : longint;    {temporary}
  pGrel : TpGraphel;  {pointer to the graphical element}
begin
  pGrel := TpGraphel(ll);                     {pointer to the graphical element}
  if (pGrel <> nil) then begin                {continue, if element exists}
    if (IsInteger(line,ipu)) then begin       {does the line represent an integer}
      kk := strtoint(line);                   {must be longint, if color}
      pGrel^.e_brushcolor := TColor(kk);
    end;
  end;
end;

procedure RecallPenWidth(var ll: longint; line: string);
{recall and save the width the pen
 ll    pointer to the element
 line  the width as string}
var
  ipu   : integer;    {temporary}
  pGrel : TpGraphel;  {pointer to the graphical element}
begin
  pGrel := TpGraphel(ll);                     {pointer to the graphical element}
  if (pGrel <> nil) then begin                {continue, if element exists}
    if (IsInteger(line,ipu)) then begin       {does the line represent an integer}
      pGrel^.e_penwidth := ipu;
    end;
  end;
end;

procedure RecallQuarter(var ll: longint; line: string);
{recall and save the quarter (direction) of directional elements
 ll    pointer to the element
 line  the quarter as string}
var
  ipu   : integer;    {temporary}
  kk    : longint;    {temporary}
  pGrel : TpGraphel;  {pointer to the graphical element}
begin
  pGrel := TpGraphel(ll);                     {pointer to the graphical element}
  if (pGrel <> nil) then begin                {continue, if element exists}
    if (IsInteger(line,ipu)) then begin       {does the line represent an integer}
      kk := strtoint(line);                   {must be longint}
      pGrel^.e_quarter := TQuarter(kk);
    end;
  end;
end;

procedure RecallDirection(var ll: longint; line: string);
{recall and save the drawing direction of lines
 ll    pointer to the element
 line  the direction as string}
var
  ipu   : integer;    {temporary}
  kk    : longint;    {temporary}
  pGrel : TpGraphel;  {pointer to the graphical element}
begin
  pGrel := TpGraphel(ll);                     {pointer to the graphical element}
  if (pGrel <> nil) then begin                {continue, if element exists}
    if (IsInteger(line,ipu)) then begin       {does the line represent an integer}
      kk := strtoint(line);                   {must be longint}
      pGrel^.e_linedir := TLinedir(kk);
    end;
  end;
end;

procedure RecallText(var ll: longint; line: string);
{recall and save the text of an element
 ll    pointer to the element
 line  the direction as string}
var
  pGrel : TpGraphel;  {pointer to the graphical element}
begin
  pGrel := TpGraphel(ll);                     {pointer to the graphical element}
  if (pGrel <> nil) then begin                {continue, if element exists}
    pGrel^.e_text := line;
  end;
end;

procedure RecallFont(var ll: longint; line: string);
{recall and save the font of a graphical element (text element)
 ll    pointer to the element as integer
 line  a string (line of text) containing the font properties}
var
  cnt   : integer;    {number of part strings = properties}
  fs    : integer;    {font style, coded}
  ipu   : integer;    {temporary}
  kk    : longint;    {temporary}
  npn   : integer;    {number of parts in the font name}
  pGrel : TpGraphel;  {pointer to the graphical element}
  txt   : string;     {temporary}
begin
  pGrel := TpGraphel(ll);                        {pointer to the graphical element}
  if (pGrel <> nil) then begin                   {continue, if element exists}
    GetPartStrings(line, longint(@PartStrings)); {get the properties separately, as stings}
    {there should be 4 properties: name, style (coded), size, color)...}
    {...but the name can have several parts (like 'Bookman Old Style')}
    cnt := PartStrings.count;                 {number of properties}
    if (cnt >= 4) then begin
      {name . . . .}
      pGrel^.e_pFont^.name := PartStrings[0]; {name as such, as first}
      {style . . . .}
      txt := PartStrings[1];                  {style, coded}
      pGrel^.e_pFont^.style := [];            {initialize as regular = empty set}
      {should be an integer}
      if (IsInteger(txt,fs)) then begin
        if (fs = 1) then begin                {bold}
          pGrel^.e_pFont^.style := [fsBold];
        end else if (fs = 2) then begin
          pGrel^.e_pFont^.style := [fsItalic];
        end else if (fs = 3) then begin
          pGrel^.e_pFont^.style := [fsBold,fsItalic];
        end;
      end;
      {size . . . . .}
      txt := PartStrings[2];
      if (IsInteger(txt,ipu)) then pGrel^.e_pFont^.size := ipu;
      {color . . . . .}
      txt := PartStrings[3];
      if (IsInteger(txt,ipu)) then begin
        kk := strtoint(txt);
        pGrel^.e_pFont^.color := TColor(kk);
      end;
    end;
  end;
end;

procedure DummyRecall(var ll: longint; line: string);
begin
  {do nothing...}
end;

constructor TGraphiq.create;
{pForm    pointer to the form, where shapes/graphs drawn
 grIndex  group index for the buttons for selecting the shape}
var
  pBut   : TpSpeedBut;
  But    : TSpeedButton;
  ii     : integer;  {index}
  nn     : integer;  {counter}
begin
//showmessage('graphiq create');
  inherited Create;
  g_List := TList.create;         {create list for pointers to the shapes}
  g_Inside := TList.create;
  g_pForm := pMainForm;           {pointer to the form, where drawn. pMainForm. ...}
  g_PenColor := clBlack;
  g_Penwidth := 1;
  g_BrushColor := clWhite;
  g_quarter := north;             {default oriention}
  g_pGraph := nil;
  g_canvas := pMainForm^.canvas;
  {}                              {...must be assigned in the "create" procedure of the main form}
  {procedures for drawing different shapes into an array}
  DrawGraphel[0] := DrawNothing;
  DrawGraphel[1] := DrawBox;
  DrawGraphel[2] := DrawOval;
  DrawGraphel[3] := DrawLine;
  DrawGraphel[4] := DrawTriangle;
  DrawGraphel[5] := DrawArrow;
  DrawGraphel[6] := DrawTextBox;
  DrawGraphel[7] := DrawMemoBox;
  {procedures for checking, is given point inside shape (graph.element)}
  InGraphel[0] := InNothing;
  InGraphel[1] := InBox;
  InGraphel[2] := InOval;
  InGraphel[3] := OnLine;
  InGraphel[4] := InTriangle;
  InGraphel[5] := InArrow;
  InGraphel[6] := InTextBox;
  InGraphel[7] := InMemoBox;
  {procedures for recalling saved elements}
  RecalEl[1] := RecallElement;
  RecalEl[2] := RecallCoordinates;
  RecalEl[3] := RecallPenColor;
  RecalEl[4] := RecallBrushColor;
  RecalEl[5] := RecallPenWidth;
  RecalEl[6] := RecallQuarter;
  RecalEl[7] := RecallDirection;
  RecalEl[8] := RecallText;
  RecalEl[9] := RecallFont;
  RecalEl[10] := RecallStartPos;
  RecalEl[11] := DummyRecall;
  g_ShapeIndex := 0;
  CreateMarkers;                 {the small squares for marking selected element in the main form}
  CreateEditBox;                 {edit-component in the main form for editing texts}
  CreateMemoBox;                 {memo-component in the main for for editing lines of text}
  {create list of elements as strings}
  g_ElList := TStringList.create;
  g_CopyList := TStringList.create;    {"clipboard"}
  PartStrings := TStringList.create;
end;

(*
destructor TGraphiq.destroy;
var
  ll,kk,mm : longint;
begin
{just testing that this procedure is called... A long delay when closing..}
  BigDelay;
  {the graphic elements are free'ed first, in TDrawMenuForm.FormDestroy (with FreeGraphicElements)}
//  g_List.free;           {free the list of pointers to graphic elements}
//  g_Inside.free;
//  g_ElList.free;
{free the graphic elements}
Graphic.FreeGraphicElements;
Graphic.FreeMarkers;
Graphic.FreeLists;
PartStrings.free;
TempList.free;
Graphic.free;
  inherited Destroy;
end;
*)

procedure TGraphiq.FreeLists;
begin
  {the graphic elements are free'ed first, in TDrawMenuForm.FormDestroy (with FreeGraphicElements)}
  g_List.free;           {free the list of pointers to graphic elements}
  g_Inside.free;
  g_ElList.free;
  g_CopyList.free;
end;

procedure TGraphiq.putpForm(pForm: TpForm);
begin
  g_pForm := pForm;
end;

function TGraphiq.pActiveElementIf: TpGraphel;
{get the pointer to the active (clicked) graphical element, if some element is active
 = the "image" for moving the graphick element is visible}
var
  pMrk0 : TpMarkImage;  {pointer to marker of upper left corner}
begin
  {the pointer is saved to the first marker in StartDrawing}
  if (g_MovImg.visible) then begin
    GetpMarker(0,pMrk0);                            {pointer to first marker = upper left corner}
    pActiveElementIf := TpGraphel(pMrk0^.m_ipGrel); {pointer to the selected graph.element..}
    {...}                                           {...saved in TGraphiq.StartDrawing}
  end else if (g_MemoBox.visible) then begin        {editing the text in the memo = element created}
    pActiveElementIf := g_List.last;
  end else begin
    pActiveElementIf := nil;
  end;
end;

procedure TGraphiq.SetElementQuarterIf(quarter: TQuarter);
{set the direction a graphical element, if element selected = active.
 Used, when some of the arrow (direction) buttons in the menu is clicked}
begin
  if (pActiveElementIf <> nil) then begin
    pActiveElementIf^.e_quarter := quarter;
    g_pForm.invalidate;           {drawn in FormPaint of the main form}
  end;
end;

procedure TGraphiq.SetElementPenColorIf(col: TColor);
{set the pen color of a graphical element, if element selected = active.
 Used, when some of the color buttons in the menu}
begin
  if (pActiveElementIf <> nil) then begin
    pActiveElementIf^.e_penColor := col;
    g_pForm.invalidate;           {drawn in FormPaint of the main form}
  end;
end;

procedure TGraphiq.SetElementPenWidthIf(width: integer);
{set the pen width of a graphical element, if element selected = active.
 Used, when some of the color buttons in the menu}
begin
  if (pActiveElementIf <> nil) then begin
    pActiveElementIf^.e_penWidth := width;
    g_pForm.invalidate;           {drawn in FormPaint of the main form}
  end;
end;

procedure TGraphiq.SetElementBrushColorIf(col: TColor);
{set the brush color of a graphical element, if element selected = active.
 Used, when some of the color buttons in the menu}
begin
  if (pActiveElementIf <> nil) then begin
//    if (col = clWhite) then pActiveElementif^.e_brushstyle := bsClear  {do not fill the shape}
//    else pActivEelementif^.brush.style:=bsSolid;
    pActiveElementIf^.e_BrushColor := col;
    g_pForm.invalidate;           {drawn in FormPaint of the main form}
  end;
end;

procedure TMarkImage.MrkMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState;
                                X, Y: Integer);
{hide markers, update parameters and redraw the graphical element}
var
  ii    : integer;      {index}
  pGrel : TpGraphel;    {pointer to graphical element}
  pMrk  : TpMarkImage;
  pMrk0 : TpMarkImage;  {pointer to marker of upper left corner}
  pMrk4 : TpMarkImage;  {pointer to marker of lower right corner}
  pMrkf : TpMarkImage;  {pointer to first line marker}
  pMrks : TpMarkImage;  {pointer to second line marker}
  w2    : integer;      {half width of marker}
  x0,y0 : integer;      {coordinates of old first corner}
  x1,y1 : integer;      {coordinates of new first corner}
  x4,y4 : integer;      {coordinate of opposite corner}
  xf,yf : integer;      {coordinates of first line end}
  xs,ys : integer;      {coordinates of second line end}
begin
  GetpMarker(0,pMrk0);                  {pointer to first marker = upper left corner}
  pGrel := TpGraphel(pMrk0^.m_ipGrel);  {pointer to the selected graph.element...}
  {...}                                 {saved in TGraphiq.StartDrawing}
  w2 := mark_w div 2;
  {find and save new coordinates of the corners, or endpoints}
  {LINE differently !!}
  if (pGrel^.e_shape <> 3) then begin     {not a line}
    GetpMarker(0,pMrk0);                  {pointer to first marker = upper left corner}
    GetpMarker(4,pMrk4);                  {lower right corner}
    {find and save new coordinates of upper left corner}
    x0 := pMrk0^.left+w2;
    y0 := pMrk0^.top+w2;
    {find and save new coordinates of lower right corner}
    x4 := pMrk4^.left+w2;
    y4 := pMrk4^.top+w2;
    {rearrange corners, save}
    pGrel^.e_xtx := pGrel^.e_xtx+x0-pGrel^.e_x1;
    pGrel^.e_ytx := pGrel^.e_ytx+y0-pGrel^.e_y1;
    pGrel^.CheckCorners(x0,y0,x4,y4);
    {if text box, move also the edit-component}
    if (pGrel^.e_shape = 6) then begin
      pGrel^.GetFirstXY(x1,y1);         {get the coordinates of the upper left corner}
      graphic.g_EditBox.left := x1;
      graphic.g_EditBox.top := y1;
    end else if (pGrel^.e_shape = 7) then begin  {menu component}
//    pGrel^.GetFirstXY(x1,y1);         {get the coordinates of the upper left corner}
//    graphic.g_MemoBox.left := x1;
//    graphic.g_MemoBox.top := y1;
      graphic.g_MemoBox.left := pGrel^.e_xtx;    {not needed? memo box is hidden..}
      graphic.g_MemoBox.top := pGrel^.e_ytx;
    end;
  end else begin                      {is a line}
    {get pointers to markers at the ends of the line, depending on the direction}
    if (pGrel^.e_linedir = ltrb) then begin
      GetpMarker(0,pMrkf);
      GetpMarker(4,pMrks);
    end else if (pGrel^.e_linedir = rtlb) then begin
      GetpMarker(2,pMrkf);
      GetpMarker(6,pMrks);
    end else if (pGrel^.e_linedir = rblt) then begin
      GetpMarker(4,pMrkf);
      GetpMarker(0,pMrks);
    end else if (pGrel^.e_linedir = lbrt) then begin
      GetpMarker(6,pMrkf);
      GetpMarker(2,pMrks);
    end else begin
      {error...}
      GetpMarker(0,pMrkf);
      GetpMarker(4,pMrks);
    end;
    xf := pMrkf^.left+w2;
    yf := pMrkf^.top+w2;
    {find and save new coordinates of endpoints}
    xs := pMrks^.left+w2;
    ys := pMrks^.top+w2;
    pGrel^.PutFirstXY(xf,yf);
    pGrel^.PutSecondXY(xs,ys,'MrkMouseUp');
    {the direction may have changed: find new "ltrb":s}
    pGrel^.LineDirection(xf,yf,xs,ys);
  end;
  {hide the markers}
  Graphic.HideMarkers;
  Graphic.HideDirPanel;
  {hide the edit-box (if visible)}
  if (Graphic.g_EditBox.visible) then DrawMenuForm.EditBoxExit(nil);
  if (Graphic.g_MemoBox.visible) then DrawMenuForm.MemoBoxExit(nil);
  {redraw all graphical elements}
  Graphic.g_pForm.invalidate;           {drawn in FormPaint of the main form}
end;

procedure TMarkImage.MrkMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState;
                                  X, Y: Integer);
begin
//  showmessage(inttostr(m_index));
end;

procedure TMarkImage.MrkMouseMove(Sender: TObject; Shift: TShiftState; X,  Y: Integer);
{actions when moving the mouse on the markers
 0   1   2
 7       3
 6   5   4 }
const
  x0 : array[0..7] of integer = (0,0,0,0,0,0,0,0);
  y0 : array[0..7] of integer = (0,0,0,0,0,0,0,0);
var
  pMrk0 : TpMarkImage;
  pMrk1 : TpMarkImage;
  pMrk2 : TpMarkImage;
  pMrk3 : TpMarkImage;
  pMrk4 : TpMarkImage;
  pMrk5 : TpMarkImage;
  pMrk6 : TpMarkImage;
  pMrk7 : TpMarkImage;
begin
  {move the marker with the mouse}
  if (ssLeft in Shift) then begin        {left button pressed}
    {get pointers to all markers, needed when moving markers}
    GetpMarker(0,pMrk0);           {marker 0}
    GetpMarker(1,pMrk1);           {marker 1}
    GetpMarker(2,pMrk2);           {marker 2}
    GetpMarker(3,pMrk3);           {marker 3}
    GetpMarker(4,pMrk4);           {marker 4}
    GetpMarker(5,pMrk5);           {marker 5}
    GetpMarker(6,pMrk6);           {marker 6}
    GetpMarker(7,pMrk7);           {marker 7}
    {markers at corners can be moved freely, markers on the edges
     can be moded in x- or y- direction only}
    if (m_index = 0) or (m_index = 2) or (m_index = 4) or (m_index = 6) then begin
      left := left+X-x0[m_index];
      top  := top +Y-y0[m_index];
      {move the other points accordingly
        0   1   2
        7       3
        6   5   4 }
      if (m_index = 0) then begin            {upper left corner}
        pMrk1^.top := top;
        pMrk1^.left := (left+pMrk2^.left) div 2;
        pMrk2^.top := top;
        pMrk7^.top := (top+pMrk6^.top) div 2;
        pMrk7^.left := left;
        pMrk6^.left := left;
        pMrk5^.left := pMrk1^.left;
        pMrk3^.top := pMrk7^.top;
      end else if (m_index = 2) then begin   {upper right corner}
        pMrk1^.top := top;
        pMrk1^.left := (left+pMrk0^.left) div 2;
        pMrk0^.top := top;
        pMrk3^.top := (pMrk2^.top+pMrk4^.top) div 2;
        pMrk3^.left := left;
        pMrk4^.left := left;
        pMrk5^.left := pMrk1^.left;
        pMrk7^.top := pMrk3^.top;
      end else if (m_index = 4) then begin   {lower right corner}
        pMrk5^.top := top;
        pMrk5^.left := (left+pMrk6^.left) div 2;
        pMrk6^.top := top;
        pMrk3^.top := (top+pMrk2^.top) div 2;
        pMrk3^.left := left;
        pMrk2^.left := left;
        pMrk1^.left := pMrk5^.left;
        pMrk7^.top := pMrk3^.top;
      end else if (m_index = 6) then begin
        { 0   1   2
          7       3
          6   5   4 }
        pMrk5^.top := top;
        pMrk5^.left := (left+pMrk4^.left) div 2;
        pMrk4^.top := top;
        pMrk7^.top := (top+pMrk0^.top) div 2;
        pMrk7^.left := left;
        pMrk0^.left := left;
        pMrk1^.left := pMrk5^.left;
        pMrk3^.top := pMrk7^.top;
      end else begin
        {..not possible...}
      end;
    end else if (m_index = 3) or (m_index = 7) then begin
      left := left+X-x0[m_index];
      { 0   1   2
        7       3
        6   5   4 }
      if (m_index = 3) then begin          {3 = middle of right edge}
        pMrk2^.left := left;
        pMrk4^.left := left;
        pMrk1^.left := (pMrk0^.left+left) div 2;
        pMrk5^.left := pMrk1^.left;
      end else begin                       {7 = middle of left edge}
        pMrk0^.left := left;
        pMrk6^.left := left;
        pMrk1^.left := (pMrk2^.left+left) div 2;
        pMrk5^.left := pMrk1^.left;
      end;
    end else if (m_index = 1) or (m_index = 5) then begin
      top  := top +Y-y0[m_index];
      if (m_index = 1) then begin          {1 = middle of top edge}
        pMrk0^.top := top;
        pMrk2^.top := top;
        pMrk7^.top := (top+pMrk5^.top) div 2;
        pMrk3^.top := pMrk7^.top;
      end else begin                       {5 = middle of bottom edge}
        pMrk6^.top := top;
        pMrk4^.top := top;
        pMrk7^.top := (top+pMrk1^.top) div 2;
        pMrk3^.top := pMrk7^.top;
      end;
    end else begin
      {..not possible...}
    end;
  end else begin
    x0[m_index] := X;
    y0[m_index] := Y;
  end;
  {move the others accordingly, depending on which marker has been clikced}
end;

procedure TMoveImage.MovMouseMove(Sender : TObject; Shift: TShiftState; X,Y: Integer);
{move the marker}
const
  x0  : integer = 0;    {old coordinates}
  y0  : integer = 0;
var
  pMrk0 : TpMarkImage;
  pMrk1 : TpMarkImage;
  pMrk2 : TpMarkImage;
  pMrk3 : TpMarkImage;
  pMrk4 : TpMarkImage;
  pMrk5 : TpMarkImage;
  pMrk6 : TpMarkImage;
  pMrk7 : TpMarkImage;
begin
  if (ssLeft in Shift) then begin        {left button pressed}
    {get also pointers to the other markers}
    GetpMarker(0,pMrk0);           {marker 0}
    GetpMarker(1,pMrk1);           {marker 1}
    GetpMarker(2,pMrk2);           {marker 2}
    GetpMarker(3,pMrk3);           {marker 3}
    GetpMarker(4,pMrk4);           {marker 4}
    GetpMarker(5,pMrk5);           {marker 5}
    GetpMarker(6,pMrk6);           {marker 6}
    GetpMarker(7,pMrk7);           {marker 7}
    {new position of the move (middle) marker}
    left := left+X-x0;
    top  := top +Y-y0;
    {new positions of the other markers}
    pMrk0^.left := pMrk0^.left+X-x0;
    pMrk0^.top  := pMrk0^.top+Y-y0;
    pMrk1^.left := pMrk1^.left+X-x0;
    pMrk1^.top  := pMrk1^.top+Y-y0;
    pMrk2^.left := pMrk2^.left+X-x0;
    pMrk2^.top  := pMrk2^.top+Y-y0;
    pMrk3^.left := pMrk3^.left+X-x0;
    pMrk3^.top  := pMrk3^.top+Y-y0;
    pMrk4^.left := pMrk4^.left+X-x0;
    pMrk4^.top  := pMrk4^.top+Y-y0;
    pMrk5^.left := pMrk5^.left+X-x0;
    pMrk5^.top  := pMrk5^.top+Y-y0;
    pMrk6^.left := pMrk6^.left+X-x0;
    pMrk6^.top  := pMrk6^.top+Y-y0;
    pMrk7^.left := pMrk7^.left+X-x0;
    pMrk7^.top  := pMrk7^.top+Y-y0;
  end else begin
    x0 := X;
    y0 := Y;
  end;
end;

procedure TMoveImage.MovMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  {..}
end;

procedure TMoveImage.MovMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
{move the graph.element to the new position marked by the markers}
var
  pMrk0 : TpMarkImage;                  {pointer to first marker}
begin
  GetpMarker(0,pMrk0);                  {pointer to first marker = upper left corner}
  pMrk0.MrkMouseUp(Sender, Button, Shift, X, Y);
end;

procedure TWorkBut.DelButClick(sender: TObject);
{delete the selected element}
var
  answer : word;
  indx   : integer;
  pGrel  : TpGraphel;    {pointer to the graphical element}
  pMrk   : TpMarkImage;  {pointer to a marker (for pointer to the element)}
begin
  answer := MessageDlg('Really delete the graphical element?',mtWarning, [mbCancel, mbYes], 0);
  if (answer = mrYes) then begin
    Graphic.DeleteSelectedElement;
    {hide the markers and button(s)}
    Graphic.HideMarkers;
    Graphic.HideDirPanel;
  end;
end;

procedure TWorkBut.BackButClick(sender: TObject);
{send the selected element to back}
begin
  Graphic.SendSelectedElementToBack;
end;

procedure TWorkBut.CopyButClick(sender: TObject);
{write gr.element parameters to LOCAL clipboard for pasting (copying)}
begin
  Graphic.CopySelectedElementToClipboard;
end;

procedure TGraphiq.CreateEditBox;
{create the edit-component in the main form for writing/editing text}
begin
  g_EditBox := TEdit.create(g_pForm^);
  g_EditBox.Parent  := g_pForm^;
  g_EditBox.left := 50;
  g_EditBox.top := 50;
  g_EditBox.width := 32;
  g_EditBox.height := 16;
  g_EditBox.text := '';
  g_EditBox.visible := false;
  g_EditBox.AutoSize := true{false};
  g_EditBox.Ctl3D := false;
  g_EditBox.font.name := 'Arial';
  g_EditBox.font.size := 12;
  g_EditBox.color := clYellow;
  g_EditBox.onExit := EditBoxExit;
  g_EditBox.onChange := EditBoxChange;
  DrawMenuForm.FontDlg.font.assign(g_EditBox.font);
end;  

procedure TGraphiq.CreateMemoBox;
{create the memo-component in the main form for writing/editing text}
begin
  g_MemoBox := TMemo.create(g_pForm^);
  g_MemoBox.Parent  := g_pForm^;
  g_MemoBox.left := 50;
  g_MemoBox.top := 50;
  g_MemoBox.width := 64;
  g_MemoBox.height := 32;
  g_MemoBox.enabled := true;
  g_MemoBox.Ctl3D := false;
  g_MemoBox.font.name := 'Arial';
  g_MemoBox.font.size := 12;
  g_MemoBox.ReadOnly := false;
  g_MemoBox.text := '';
  g_MemoBox.WantReturns := true;
  g_MemoBox.WordWrap := false;
  g_MemoBox.visible := false;
  g_MemoBox.onExit := MemoBoxExit;
  g_MemoBox.onChange := MemoBoxChange;
  DrawMenuForm.FontDlg.font.assign(g_MemoBox.font);
end;

function TGraphiq.FontAndWidthOfText(font: TFont; text: string): integer;
{set the given font to the form, and get the width of the text in the edit box}
begin
  {g_pForm^.canvas}g_Canvas.font.assign(font);
  {get the size of the edit according to the text}
  FontAndWidthOfText := g_Canvas.textwidth(text);
end;

function TGraphiq.WidthOfMemoText(var hh : integer): integer;
{get the max. width and height of the text in the memo box}
var
  cnt : integer;   {number of lines}
  ii  : integer;   {index}
  wl  : integer;   {width of a line}
  wm  : integer;   {max. width of lines}
begin
  cnt := g_MemoBox.lines.count;                 {number of lines}
  g_Canvas.font.assign(g_MemoBox.font);
  if (cnt > 0) then begin                       {there are lines}
    wm := 0;
    for ii := 0 to cnt-1 do begin
      {get the width of one line in the memo}
      wl := g_Canvas.textwidth(g_MemoBox.lines[ii]);
      if (wl > wm) then wm := wl;               {find max. width}
    end;
    if (wm > 32) then WidthOfMemoText := wm
    else WidthOfMemoText := 32;
//  hh := g_Canvas.textheight(g_MemoBox.lines[0]); {Not so: lines[0] may be low (Line Feed?)}
    hh := g_Canvas.textheight('AA');
  end else begin                                {no lines, set some width}
    WidthOfMemoText := 32;
    hh := g_Canvas.textheight('AA');
  end;
end;

procedure TGraphiq.EditBoxExit(Sender: TObject);
{copy text to canvas, hide box}
var
  indx  : integer;
  ix,iy : integer;    {coordinates}
  pGrel : TpGraphel;  {pointer to graphical text element}
  txw   : integer;    {text width}
  xx,yy : integer;    {coordinates}
begin
  if (g_editBox.visible) then begin
    {there is some text?}
    if (g_EditBox.text <> '') then begin
      xx := g_EditBox.left+2;
      yy := g_EditBox.top+2;
      g_EditBox.visible := false;
      {set font, and get width of text}
      txw := FontAndWidthOfText(g_EditBox.font, g_EditBox.text);
      g_pForm^.canvas.brush.style := bsClear;         {no background color}
//    g_pForm^.canvas.textout(xx,yy,g_EditBox.text);  {rewritten in DrawTextBox (?!)}
      AngleTextOut(g_pForm^.canvas, 0, xx, yy, g_EditBox.text);  {but when ZOOMED or printing!!??}
      {set the size of the edit according to the text}
      g_EditBox.width := txw+16;
      {pointer to gr.element. Saved into tag in TGraphiq.FinishDrawingWithMouse and ... }
      {.. in InTextBox}
      pGrel := TpGraphel(g_EditBox.tag);
{?}   pGrel^.e_text := g_EditBox.text;       {text to element}
      pGrel^.e_pFont^.assign(g_EditBox.font);
      {save the size of the box}
      ix := g_EditBox.left+g_EditBox.width;
      iy := g_EditBox.top+g_EditBox.height;
      pGrel^.putSecondXY(ix,iy,'EditBoxExit');
      g_EditBox.text := '';
      DrawMenuForm.FontBut.visible := false;
    end else begin
      {no text, delete the element}  {may already have been deleted, if was small!}
      pGrel := TpGraphel(g_EditBox.tag);
      indx := g_List.indexof(pGrel);
//      if (indx >= 0) then DeleteElement(pGrel,indx);
    end;
  end;
end;

procedure TGraphiq.EditBoxChange(Sender: TObject);
{set the width according to the text}
var
  txw : integer;  {width of text}
begin
  {find the widht of the text, with this font}
  txw := FontAndWidthOfText(g_EditBox.font, g_EditBox.text);
  if (g_EditBox.width < txw+16) then g_EditBox.width := txw+32;
end;

procedure TGraphiq.MemoTextOut(pMemo: TpMemo; xx,yy: integer; pGrel: TpGraphel);
{write the text in the memo to the form. NOTE: Set font first!!
 pMemo  pointer to the memo
 xx,yy  the position of horizontal text (upper left corner)
 pGrel  pointer to the active graphical element}
var
  angle : integer;  {the angle of the text}
  cnt   : integer;  {number of lines}
  hh    : integer;  {height of the text}
  ii    : integer;  {index}
  ix,iy : integer;  {position of text}
  wtx   : integer;  {width of memo text}
begin
  {find the direction (angle) of the text}
  if      (pGrel^.e_quarter = north) then angle := 90
  else if (pGrel^.e_quarter = east) then  angle := 0
  else if (pGrel^.e_quarter = south) then angle := 270
  else if (pGrel^.e_quarter = west) then  angle := 180
  else angle := 0;
  g_Canvas.font.assign(pMemo^.font);       {ei viel hyv...}
  {possibly several lines. Must find height of one line}
  hh := g_Canvas.textheight(pMemo^.text);
  wtx := g_Canvas.textwidth(pMemo^.lines[0]);
  cnt := pMemo^.lines.count;        {number of lines}
  if (cnt > 0) then begin
    for ii := 0 to cnt-1 do begin
      {coordinates depend on direction}
      if (angle = 0) then begin
        ix := xx+6;
        iy := yy+ii*hh;
      end else if (angle = 90) then begin
        ix := xx+ii*hh;
        iy := yy;
      end else if (angle = 180) then begin
        ix := xx-6;
        iy := yy-ii*hh;
      end else if (angle = 270) then begin
        ix := xx-ii*hh;
        iy := yy;
      end else begin
        ix := xx+6;
        iy := yy+ii*hh;
      end;
      {write on the screen}
      AngleTextOut(g_Canvas, angle, ix, iy, pMemo^.lines[ii]);
    end;
    {}
  end;
end;

procedure TGraphiq.MemoBoxExit(Sender: TObject);
{copy text to canvas, hide box}
var
  cx,cy   : integer;    {coordinates of new first corner}
  indx    : integer;
  ix,iy   : integer;    {coordinates}
  ox,oy   : integer;    {coordinates of the new second (opposite) corner}
  pGrel   : TpGraphel;  {pointer to graphical text element}
  txh,txw : integer;    {text height, width}
  xx,yy   : integer;    {coordinates}
begin
  if (g_MemoBox.visible) then begin
    {there is some text?}
    if (g_MemoBox.text <> '') then begin
      {pointer to gr.element. Saved into tag in TGraphiq.FinishDrawingWithMouse and ... }
      {.. in InTextBox}
      pGrel := TpGraphel(g_MemoBox.tag);
//    xx := g_MemoBox.left{+2};
//    yy := g_MemoBox.top{+2};
      g_MemoBox.visible := false;
      {set font, and get width of text}
      txw := WidthOfMemoText(txh);                    {find the width and height of the text, with this font}
      g_pForm^.canvas.brush.style := bsClear;         {no background color}
//    MemoTextOut(@g_MemoBox, xx,yy, pGrel);          {text out also in DrawMemoBox (!?)} {Use invalidate, below}
      {set the size of the memo according to the text}
      g_MemoBox.width := txw+16;
      g_MemoBox.height := (g_MemoBox.lines.count{+1})*txh+(txh div 2);
{?}   pGrel^.e_text := g_MemoBox.text;                {text to element}
      pGrel^.e_pFont^.assign(g_MemoBox.font);
      {if just created, save the size (and position) of the text = initialize the old corner}
//    if (pGrel^.e_x20 < -30000) or (pGrel^.e_x20 < -30000) then begin
//      ix := g_MemoBox.left+g_MemoBox.width;         {as if the text was horizontal}
//      iy := g_MemoBox.top+g_MemoBox.height;
//      pGrel^.PutOldSecondXY(ix,iy);
//      pGrel^.e_OldQuarter := east;                  {as if the text was horizontal}
//    end;
      {start point of the text}
      xx := pGrel^.e_xtx;
      yy := pGrel^.e_ytx;
(*
      {start point of the text depends on the old direction} {MUTTA jos teksti siirretty...?}
      if (pGrel^.e_OldQuarter = east) then begin
        xx := pGrel^.e_x10;
        yy := pGrel^.e_y10;
      end else if (pGrel^.e_OldQuarter = north) then begin
        xx := pGrel^.e_x10;
        yy := pGrel^.e_y20;
      end else if (pGrel^.e_OldQuarter = west) then begin
        xx := pGrel^.e_x20;
        yy := pGrel^.e_y20;
      end else if (pGrel^.e_OldQuarter = south) then begin
        xx := pGrel^.e_x20;
        yy := pGrel^.e_y10;
      end else begin
        xx := pGrel^.e_x10;
        yy := pGrel^.e_y10;
      end;
*)
      {the second corner depends on the direction}
      if (pGrel^.e_quarter = east) then begin
        cx := xx;                     {first corner as before}
        cy := yy;
        ox := xx+g_MemoBox.width;     {opposite corner}
        oy := yy+g_MemoBox.height;
      end else if (pGrel^.e_quarter = north) then begin
        cx := xx;
        cy := yy-g_MemoBox.width;
        ox := xx+g_MemoBox.height;
        oy := yy;
      end else if (pGrel^.e_quarter = west) then begin
        cx := xx-g_MemoBox.width;
        cy := yy-g_MemoBox.height;
        ox := xx;
        oy := yy;
      end else if (pGrel^.e_quarter = south) then begin
        cx := xx-g_MemoBox.height;
        cy := yy;
        ox := xx;
        oy := yy+g_MemoBox.width;
      end else begin                  {error case...}
        cx := xx;                     {first corner as before}
        cy := yy;
        ox := xx+g_MemoBox.width;     {opposite corner}
        oy := yy+g_MemoBox.height;
      end;
      pGrel^.putFirstXY(cx,cy);
      pGrel^.putSecondXY(ox,oy,'MemoBoxExit');
      g_MemoBox.text := '';
      g_MemoBox.lines.clear;
      DrawMenuForm.FontBut.visible := false;
    end else begin
      {no text, delete the element}     {may already have been deleted, if was small!}
      pGrel := TpGraphel(g_MemoBox.tag);
      indx := g_List.indexof(pGrel);
      if (indx >= 0) then DeleteElement(pGrel,indx);
    end;
    g_pForm^.invalidate;
  end;
end;

procedure TGraphiq.MemoBoxChange(Sender: TObject);
{set the width and height according to the text}
var
  apu : single;
  ipu : integer;
  len : integer;  {tength of text}
  txh : integer;  {height of one line}
  txw : integer;  {width of text}
begin
  txw := WidthOfMemoText(txh);       {find the width and height of the text, with this font}
  if (g_MemoBox.width < txw+16) then g_MemoBox.width := txw+32
  else if (g_MemoBox.width > txw+16) then g_MemoBox.width := txw+16;
  {set also the height, it is more complicated}
  if (g_pForm.ActiveControl = g_MemoBox) then begin
    DrawMenuForm.TestEdit.font.assign(g_MemoBox.font);   {copy the font to a hidden edit}
 {tm aiheuttaa ongelmia = vrin InMemoBox'issa...}
    len := length(g_MemoBox.text);
    if (len > 0) then begin
      {add space for one more line, if line feed just added}
      if (g_MemoBox.text[len] = #10) or (g_MemoBox.text[len] = #13) then ipu := 1 else ipu := 0;
      g_MemoBox.height := (g_MemoBox.lines.count+ipu)*txh+(txh div 2);
    end;
  end;
end;

procedure TGraphiq.CreateMarkers;
{create the small squares used to mark the selected graphical element
 The markers are positioned in the corners and in the middle of the edges of
 the rectangle limiting the graphical element
 and numbered like this:
 0   1   2
 7       3
 6   5   4 }
var
  ii   : integer;  {index}
  pMrk : TpMarkImage;  {pointer to the marker}
begin
  {markers around the graphical element, for stretching}
  for ii := 0 to high(g_pMarkers) do begin
    new(pMrk);             {reserve space}
    pMrk^             := TMarkImage.Create(g_pForm^);
    pMrk^.Parent      := g_pForm^;
    pMrk^.align       := alNone;
    pMrk^.left := ii*(mark_w+4);
    pMrk^.top := 0;
    pMrk^.width := mark_w;
    pMrk^.height := mark_w;
    with pMrk^.canvas do begin
      pen.width := 1;
      if (ii = 0) then pen.color := clBlack
      else if (ii = 2) then pen.color := clBlue
      else if (ii = 4) then pen.color := clGreen
      else if (ii = 6) then pen.color := clRed
      else pen.color := clAqua;
      brush.style := bsSolid;
      brush.color := pen.color;
      rectangle(0,0,mark_w,mark_w);
    end;
    pMrk^.visible := false;
    pMrk^.enabled := false;
    g_pMarkers[ii] := longint(pMrk);
    pMrk^.onMouseMove := pMrk^.MrkMouseMove;
    pMrk^.onMouseDown := pMrk^.MrkMouseDown;
    pMrk^.onMouseUp := pMrk^.MrkMouseUp;
    pMrk^.m_index := ii;
  end;
  {marker in the  graphical element, for moving}
  g_MovImg := TMoveImage.Create(g_pForm^);
  g_MovImg.Parent  := g_pForm^;
  g_MovImg.picture.Assign(DrawMenuForm.CrossImg.picture);
  g_MovImg.align := alNone;
  g_MovImg.left := 0;
  g_MovImg.top := 0;
  g_MovImg.width := move_w;
  g_MovImg.height := move_w;
  g_MovImg.visible := false;
  g_MovImg.enabled := false;
  g_MovImg.onMouseMove := g_MovImg.MovMouseMove;
  g_MovImg.onMouseDown := g_MovImg.MovMouseDown;
  g_MovImg.onMouseUp := g_MovImg.MovMouseUp;
  {button for deleting}
  g_DelBut := TWorkBut.create(g_pForm^);
  g_DelBut.Parent  := g_pForm^;
  g_DelBut.align       := alNone;
  g_DelBut.left := 0;
  g_DelBut.top := 0;
  g_DelBut.width := but_w;
  g_DelBut.height := but_w;
  g_DelBut.caption := 'X';
  g_DelBut.hint := 'delete this graphical element';
  g_DelBut.showhint := true;
  g_DelBut.visible := false;
  g_DelBut.onClick := g_DelBut.DelButClick;
  {button for moving element to back}
  g_BackBut := TWorkBut.create(g_pForm^);
  g_BackBut.Parent  := g_pForm^;
  g_BackBut.align       := alNone;
  g_BackBut.left := 0;
  g_BackBut.top := 0;
  g_BackBut.width := but_w;
  g_BackBut.height := but_w;
  g_BackBut.caption := 'v';
  g_BackBut.hint := 'move to back';
  g_BackBut.showhint := true;
  g_BackBut.visible := false;
  g_BackBut.onClick := g_BackBut.BackButClick;
  {button for copying element}
  g_CopyBut := TWorkBut.create(g_pForm^);
  g_CopyBut.Parent  := g_pForm^;
  g_CopyBut.align       := alNone;
  g_CopyBut.left := 0;
  g_CopyBut.top := 0;
  g_CopyBut.width := but_w;
  g_CopyBut.height := but_w;
  g_CopyBut.caption := 'c';
  g_CopyBut.hint := 'copy to local clipboard';
  g_CopyBut.showhint := true;
  g_CopyBut.visible := false;
  g_CopyBut.onClick := g_CopyBut.CopyButClick;
end;

procedure TGraphiq.DrawAll;
{(re)draw all graphical elements}
var
  ii    : integer;     {index}
  pGrel : TpGraphel;   {pointer to a graphical element}
begin
  if (not DrawMenuForm.HideBut.down) then begin
    if (g_List.count > 0) then begin        {are there elements}
      for ii := 0 to g_List.count-1 do begin
        pGrel := g_List[ii];
        pGrel^.PickPenColor;
//    if (pGrel^.e_shape <> 6) then
        pGrel^.e_DrawEl(longint(pGrel));    {draw the graphic element}
      end;
    end;
  end;
end;

procedure TGraphiq.MoveAll(dx,dy: integer);
{move all graphical elements by dx,dy}
var
  ii    : integer;     {index}
  pGrel : TpGraphel;   {pointer to a graphical element}
begin
  if (g_List.count > 0) then begin        {are there elements}
    for ii := 0 to g_List.count-1 do begin
      pGrel := g_List[ii];
      inc(pGrel^.e_x1,dx);
      inc(pGrel^.e_y1,dy);
      inc(pGrel^.e_x2,dx);
      inc(pGrel^.e_y2,dy);
      inc(pGrel^.e_xtx,dx);
      inc(pGrel^.e_ytx,dy);
    end;
  end;
  g_pForm^.invalidate;
end;

procedure TGraphiq.MoveInsideOnes(dx,dy: integer);
{move graphical elements that are inside the given rectangle, move by dx,dy}
var
  ii    : integer;     {index}
  pGrel : TpGraphel;   {pointer to a graphical element}
begin
  if (g_Inside.count > 0) then begin        {are there elements}
    for ii := 0 to g_Inside.count-1 do begin
      pGrel := g_Inside[ii];
      inc(pGrel^.e_x1,dx);
      inc(pGrel^.e_y1,dy);
      inc(pGrel^.e_x2,dx);
      inc(pGrel^.e_y2,dy);
      inc(pGrel^.e_xtx,dx);
      inc(pGrel^.e_ytx,dy);
    end;
  end;
  g_pForm^.invalidate;
end;

procedure TGraphiq.MoveInList(List: TList; dx,dy : integer);
{move the graphical elements in the given list (if they exist)
 pList  pointer to the list
 dx,dy  movement}
var
  ii    : integer;     {index}
  pGrel : TpGraphel;   {pointer to a graphical element}
begin
  if (List.count > 0) then begin                  {are there elements}
    for ii := 0 to List.count-1 do begin
      pGrel := List[ii];
      if (g_List.indexOf(pGrel) >= 0) then begin  {element exists}
        inc(pGrel^.e_x1,dx);
        inc(pGrel^.e_y1,dy);
        inc(pGrel^.e_x2,dx);
        inc(pGrel^.e_y2,dy);
        inc(pGrel^.e_xtx,dx);
        inc(pGrel^.e_ytx,dy);
      end;
    end;
  end;
  g_pForm^.invalidate;
end;

procedure TGraphiq.SketchOnCanvas(Toile: TCanvas; xc,yc, cw,ch: integer);
{draw rectangles around the graphical elements on the given canvas
 The idea: a picture covers the elements. Draw the rectangles on the picture
           in order to show the positions of the elements
 Toile  the canvas
 xc,yc  the position of the upper left corner of the canvas on its form
 cw,ch  width and height of the canvas (actually of the picture)}
var
  ii    : integer;     {index}
  pGrel : TpGraphel;   {pointer to a graphical element}
begin
  if (g_List.count > 0) then begin        {are there elements}
    for ii := 0 to g_List.count-1 do begin
      pGrel := g_List[ii];
      {draw rectangle, if element completely inside the canvas}
      if (pGrel^.e_x1 >= xc) and (pGrel^.e_x2 <= xc+cw) and
        (pGrel^.e_y1 >= yc) and (pGrel^.e_y2 <= yc+ch) then begin
        Toile.Brush.style := bsClear;
        Toile.Pen.width := 1;
        Toile.Pen.color := clGray;
        Toile.rectangle(pGrel^.e_x1-xc,pGrel^.e_y1-yc,pGrel^.e_x2-xc,pGrel^.e_y2-yc);
      end;
    end;
  end;
end;

procedure TGraphiq.ResetCanvas;
{reset the canvas to the canvas of the main form}
var
  ii    : integer;     {index}
  pGrel : TpGraphel;   {pointer to a graphical element}
begin
  if (g_List.count > 0) then begin        {are there elements}
    for ii := 0 to g_List.count-1 do begin
      pGrel := g_List[ii];
      pGrel^.e_Toile := g_pForm^.Canvas;
    end;
  end;
  g_Canvas := g_pForm^.Canvas;
end;

procedure TGraphiq.SetCanvas(Toile: TCanvas);
{set the canvas to the given canvas}
var
  ii    : integer;     {index}
  pGrel : TpGraphel;   {pointer to a graphical element}
begin
  if (g_List.count > 0) then begin        {are there elements}
    for ii := 0 to g_List.count-1 do begin
      pGrel := g_List[ii];
      pGrel^.e_Toile := Toile;
    end;
  end;
  g_Canvas := Toile;
end;

procedure TGraphiq.PutShapeIndex(indx: integer);
{save the index of the shape to be drawn, when clicking a shape button
 (rectangle, ellipse, ...}
begin
  if (indx >= 0) and (indx <= 7) then           {BETTER???}
    g_shapeIndex := indx;
end;

procedure TGraphiq.ResButState(down: boolean);  {copy the state of the reset button}
begin
  g_ResButDown := down;  {copy the state}
end;

procedure TGraphiq.StartDrawing(x,y : integer);
{save coordinates etc. when starting drawing a shape at mouse down...
 ...or find if clicking in a graphic element (shape)
 x,y  mouse coordinates}
var
  cnt     : integer;     {number of elements}
  ii,jj   : integer;     {index}
  ll      : longint;
  ManyVar : TMulti;      {for transferring parameters}
  pGrel   : TpGraphel;   {pointer to a graphic element}
  pMrk    : TpMarkImage; {pointer to marker}
  sel     : boolean;     {true, when (at least) one element selected}
begin
  {hide all markers initially}
  HideMarkers;
  {hide the dir-panel (direction of the element), but not for text}
  if (g_ShapeIndex <> 7) then HideDirPanel;
  {exit from editing text in some edit box (if editing)}
  EditBoxExit(nil);
  MemoBoxExit(nil);
//BigDelay;
  {starting to draw?}
  if (g_ShapeIndex > 0) then begin           {some button for selecting shape is down}
    CreateAndAddGraphicElement(g_shapeIndex);
    g_pGraph := g_List.last;                 {pointer to the graph.element added last}
    g_pGraph^.putFirstXY(x,y);               {starting point to the element = first corner}
    g_pGraph^.putTextCornerXY(x,y);          {initialize starting point to the element = first corner}
//  g_pGraph^.putOldSecondXY(-32000,-32000); {large negative as a flag: "this is not yet initialized"}
    g_pGraph^.e_Pencolor := g_Pencolor;
    g_pGraph^.e_Brushcolor := g_Brushcolor;
    g_pGraph^.e_penwidth := g_penwidth;
    g_pGraph^.e_quarter := g_quarter;      {direction of directional elements}
    g_drawing := true;                     {set flag for drawing (NEEDED?)}
    g_first := true;                       {drawing first time}
  end else begin
    {check for clicking inside an element}
    ManyVar.xx := x;                       {for transporting coordinates}
    ManyVar.yy := y;
    {check all elements, if there are any}
    sel := false;
    cnt := g_List.count;                        {number of elements}
    if (cnt > 0) then begin                     {there are elements}
      for ii := 1 to cnt do begin
        jj := cnt-ii;                           {backwards, last added checked first}
        pGrel := g_List[jj];                    {pointer to an element}
        ManyVar.pp := longint(pGrel);           {transport pointer as integer}
        ll := longint(@ManyVar);                {transport pointer as integer}
        InGraphel[pGrel^.e_shape](ll);          {is the cursor (mouse) inside this shape}
//showmessage('ingraph');
        if (pGrel^.e_inside) then begin
          sel := true;  {set flag: selected}
          GetpMarker(0,pMrk);
          pMrk^.m_ipGrel := longint(pGrel);     {save pointer to the selected element to FIRST marker}
          break;
        end;
      end;
      {check and select one, if several selected elements}
      {... later ....}
    end;
  end;
end;

procedure TGraphiq.DrawWithMouse(x,y : integer);
{draw the given shape by dragging with the mouse
 x,y  mouse coordinates}
begin
  {draw the selected shape, if drawing}
  if (g_drawing) then begin
    g_pGraph^.ClearBrush;                    {do not (yet) fill the shape}
    g_pGraph.OppositePenColor;
    {wipe previous shape, but not on the first time}
    if (g_first) then begin
      g_first := false;                      {reset, no more first time}
      g_pGraph^.putSecondXY(x,y,'DrawWithMouse1');            {opposite corner}
      g_pGraph^.e_DrawEl(longint(g_pGraph)); {draw first time}
    end else begin
      {wipe = draw with the opposite color}
      g_pGraph^.e_DrawEl(longint(g_pGraph)); {wipe = draw second time with opposite colors, with old corners}
      {draw new shape at the mouse position}
      g_pGraph^.putSecondXY(x,y,'DrawWithMouse2');            {new opposite corner}
      g_pGraph^.e_DrawEl(longint(g_pGraph)); {draw new element, with new opposite corner}
    end;
  end;
end;

procedure TGraphiq.OneElementToList(pGrel: TpGraphel; ElList: TStringList; dx: integer);
{write the defining parameters of one graphical element to the given list
 (index of the shape, coordinates, etc...)
 pGrel   pointer to the (one) graphic element
 ElList  the list to which data written
 dx      optional shift (move) in x-direction, for copying}
var
  fs    : integer;     {font style coded as integer}
  jj    : integer;
  len   : integer;     {length of line}
  line  : string;      {one line of text}
  tn,ts : string;      {font nime, font size, as strings}
  tt,tc : string;      {font style, font color, as strings}
  txt   : string;      {temporary}
begin
  {two lines for each property: 1) a "key" or flag telling, which property, then the property}
  ElList.add('1');                         {1 = first property, the index of the shape}
  ElList.add(inttostr(pGrel^.e_shape));
  ElList.add('2');                         {2 = coordinates}
  ElList.add(inttostr(pGrel^.e_x1+dx)+';'+inttostr(pGrel^.e_y1)+';'+
             inttostr(pGrel^.e_x2+dx)+';'+inttostr(pGrel^.e_y2));
  ElList.add('3');                         {3 = pen color}
  ElList.add(inttostr(longint(pGrel^.e_PenColor)));
  ElList.add('4');                         {4 = brush color}
  ElList.add(inttostr(longint(pGrel^.e_BrushColor)));
  ElList.add('5');                         {5 = pen width}
  ElList.add(inttostr(pGrel^.e_penwidth));
  ElList.add('6');                         {6 = direction (of directional elements)}
  ElList.add(inttostr(longint(pGrel^.e_quarter)));
  if (pGrel^.e_shape = 3) then begin         {direction of line, only for lines}
    ElList.add('7');                       {7 = direction (of directional elements)}
    ElList.add(inttostr(longint(pGrel^.e_linedir)));
  end;
  if (pGrel^.e_shape = 6) then begin  {text, only for text boxes}
    ElList.add('8');                       {8 = text}
    ElList.add(pGrel^.e_text);
  end else if (pGrel^.e_shape = 7) then begin {text from menu boxes}
    ElList.add('8');
    {must remove (possible) carriage returns}
    txt := '';
    line := pGrel^.e_text;            {memo-text on one line}
    len := length(line);
    if (len > 0) then begin           {should be}
      {check text, replace line feeds}
      for jj := 1 to len do begin
        if (line[jj] = #13) then {...} else txt := txt+line[jj];  {skip carriage return}
      end;
    end else begin
      txt := '?';
    end;
    ElList.add(txt);
  end;
  {font: name, style, size, color. Style can be (regular, bold, italic, bold-italic)..}
  {..but only for the text component}
  if (pGrel^.e_shape = 6) or (pGrel^.e_shape = 7) then begin
    {code the font style}
    fs := 0;
    if (fsBold in (pGrel^.e_pFont^.style)) then fs := 1;
    if (fsItalic in (pGrel^.e_pFont^.style)) then fs := fs+2;
    {all properties as strings}
    tn := pGrel^.e_pFont^.name;                     {font name}
    ts := inttostr(pGrel^.e_pFont^.size);           {font size}
    tt := inttostr(fs);                             {font style, coded}
    tc := inttostr(longint(pGrel^.e_pFont^.color)); {font color}
    line := tn+';'+tt+';'+ts+';'+tc;                {all properties as one string}
    ElList.add('9');                                {9 = font}
    ElList.add(line);
  end;
end;

procedure TGraphiq.ElementsToList;
{write the elements and their properties to a list, as text (strings),
 needed for saving to file. Remove carriage returns from the text. Otherwise
 writeln and readln do not work properly (when writing/reading to/from file}
var
  fs    : integer;     {font style coded as integer}
  ii,jj : integer;
  len   : integer;     {length of line}
  line  : string;      {one line of text}
  pGrel : TpGraphel;   {pointer to a graphic element}
  tn,ts : string;      {font nime, font size, as strings}
  tt,tc : string;      {font style, font color, as strings}
  txt   : string;      {temporary}
begin
  g_ElList.clear;                                {clear list initially}
  if (g_List.count > 0) then begin               {are there elements}
    for ii := 0 to g_List.count-1 do begin       {check each element}
      pGrel := g_List[ii];
      OneElementToList(pGrel, g_ElList,0);       {write one element to list}
//for jj := 0 to g_ElList.count-1 do showmessage(g_ElList[jj]);
(*
      {two lines for each property: 1) a "key" or flag telling, which property, then the property}
      g_ElList.add('1');                         {1 = first property, the index of the shape}
      g_ElList.add(inttostr(pGrel^.e_shape));
      g_ElList.add('2');                         {2 = coordinates}
      g_ElList.add(inttostr(pGrel^.e_x1)+';'+inttostr(pGrel^.e_y1)+';'+
                   inttostr(pGrel^.e_x2)+';'+inttostr(pGrel^.e_y2));
      g_ElList.add('3');                         {3 = pen color}
      g_ElList.add(inttostr(longint(pGrel^.e_PenColor)));
      g_ElList.add('4');                         {4 = brush color}
      g_ElList.add(inttostr(longint(pGrel^.e_BrushColor)));
      g_ElList.add('5');                         {5 = pen width}
      g_ElList.add(inttostr(pGrel^.e_penwidth));
      g_ElList.add('6');                         {6 = direction (of directional elements)}
      g_ElList.add(inttostr(longint(pGrel^.e_quarter)));
      if (pGrel^.e_shape = 3) then begin         {direction of line, only for lines}
        g_ElList.add('7');                       {7 = direction (of directional elements)}
        g_ElList.add(inttostr(longint(pGrel^.e_linedir)));
      end;
      if (pGrel^.e_shape = 6) then begin  {text, only for text boxes}
        g_ElList.add('8');                       {8 = text}
        g_ElList.add(pGrel^.e_text);
      end else if (pGrel^.e_shape = 7) then begin {text from menu boxes}
        g_ElList.add('8');
        {must remove (possible) carriage returns}
        txt := '';
        line := pGrel^.e_text;            {memo-text on one line}
        len := length(line);
        if (len > 0) then begin           {should be}
          {check text, replace line feeds}
          for jj := 1 to len do begin
            if (line[jj] = #13) then {...} else txt := txt+line[jj];  {skip carriage return}
          end;
        end else begin
          txt := '?';
        end;
        g_ElList.add(txt);
      end;
      {font: name, style, size, color. Style can be (regular, bold, italic, bold-italic)..}
      {..but only for the text component}
      if (pGrel^.e_shape = 6) or (pGrel^.e_shape = 7) then begin
        {code the font style}
        fs := 0;
        if (fsBold in (pGrel^.e_pFont^.style)) then fs := 1;
        if (fsItalic in (pGrel^.e_pFont^.style)) then fs := fs+2;
        {all properties as strings}
        tn := pGrel^.e_pFont^.name;                     {font name}
        ts := inttostr(pGrel^.e_pFont^.size);           {font size}
        tt := inttostr(fs);                             {font style, coded}
        tc := inttostr(longint(pGrel^.e_pFont^.color)); {font color}
        line := tn+';'+tt+';'+ts+';'+tc;                {all properties as one string}
        g_ElList.add('9');                              {9 = font}
        g_ElList.add(line);
      end;
*)
      {starting point of text (actually only for memo text)}
      line := inttostr(pGrel^.e_xtx)+';'+inttostr(pGrel^.e_ytx);
      g_ElList.add('10');                              {10 = start position of text}
      g_ElList.add(line);
    end;
  end;
end;

procedure TGraphiq.ElementsFromList(ElList: TStringlist);
{read the list of elements, and create the graphical elements
 The list contains two rows (items) for each data: identifier and the data
 ElList  list of data defining the graph.elements}
var
  cnt   : integer;    {number of items (rows)}
  cnt2  : integer;    {count divided by 2}
  ident : integer;    {identifier of data item}
  ii    : integer;    {index}
  line  : string;     {data as string}
  ll    : longint;    {pointer as integer}
begin
  cnt := ElList.count;                        {number of items (rows)}
  if (cnt >= 4) then begin                    {actually, even 4 is too little!}
    cnt2 := cnt div 2;                        {number of items}
    for ii := 0 to cnt2-1 do begin            {each identifier and item}
      line := ElList[2*ii];                   {identifier of data}
      if (IsInteger(line,ident)) then begin   {data is an integer = identifier?}
        line := ElList[2*ii+1];               {data as string}
        RecalEl[ident](ll,line);              {process the data}
      end;
    end;
  end;
end;

procedure TDrawMenuForm.PasteButClick(Sender: TObject);
{read element definitions/data from the copy-list, draw to form}
begin
  Graphic.ElementsFromList(Graphic.g_CopyList);
  Graphic.g_pForm.invalidate;           {drawn in FormPaint of the main form}
end;
(*
procedure TGraphiq.ElementsFromList;
{read the list of elements, and create the graphical elements
 The list contains two rows (items) for each data: identifier and the data}
var
  cnt   : integer;    {number of items (rows)}
  cnt2  : integer;    {count divided by 2}
  ident : integer;    {identifier of data item}
  ii    : integer;    {index}
  line  : string;     {data as string}
  ll    : longint;    {pointer as integer}
begin
  cnt := g_ElList.count;                      {number of items (rows)}
  if (cnt >= 4) then begin                    {actually, even 4 is too little!}
    cnt2 := cnt div 2;                        {number of items}
    for ii := 0 to cnt2-1 do begin            {each identifier and item}
      line := g_ElList[2*ii];                 {identifier of data}
      if (IsInteger(line,ident)) then begin   {data is an integer = identifier?}
        line := g_ElList[2*ii+1];             {data as string}
        RecalEl[ident](ll,line);              {process the data}
      end;
    end;
  end;
end;
*)

procedure TGraphel.CheckCorners(xf,yf, x,y : integer);
{Check the rectangle surrounding the graphical element.
 Save the coordinates of opposite corners so that the upper left corner
 is saved as first and lower right as second
 xf,yf  coordinates of the old/first corner
 x,y    coordinates of the new corner, taken intially as the second corner}
var
  x1,y1  : integer;                  {coord. of upper left corner}
  x2,y2  : integer;                  {coord. of lower right corner}
begin
  {four possibilites, x first}
  if (xf < x) then begin                  {first x left of new x}
    x1 := xf;
    x2 := x;
  end else begin                          {first x right of new x}
    x1 := x;
    x2 := xf;
  end;
  {next, check y}
  if (yf < y) then begin                  {first y above new y}
    y1 := yf;
    y2 := y;
  end else begin                          {first y below new y}
    y1 := y;
    y2 := yf;
  end;
  putFirstXY(x1,y1);                      {upper left corner}
  putSecondXY(x2,y2,'CheckCorners');      {lower right corner}
end;

procedure TGraphel.LineDirection(x1,y1,x2,y2: integer);
{find the (drawing) direction of the line
 x1,y1  coordinates of the first end
 x2,y2  coordinates of the second end}
begin
  if (x1 <= x2) then begin
    if (y1 <= y2) then begin
      e_linedir := ltrb;
    end else begin
      e_linedir := lbrt;
    end;
  end else begin
    if (y1 < y2) then begin
      e_linedir := rtlb;
    end else begin
      e_linedir := rblt;
    end;
  end;
end;

procedure TGraphiq.FinishDrawingWithMouse(x,y : integer);
{when mouse up, draw the shape in the final form and color
 x,y  mouse coordinates}
var
  hh     : integer;                  {height of text}
  indx   : integer;                  {index of new graphical element}
//pFont : TpFont;
  pGraph : TPGraphel;                {latest graphic element}
  x1,y1  : integer;                  {upper left corner}
  x2,y2  : integer;                  {lower right corner}
  xf,yf  : integer;                  {coord. of first corner (saved first, maybe upper or lower}
begin
  if (g_drawing) then begin          {is drawing a shape}
    {draw the shape in the final form and size}
    {but first, wipe the previous shape}
    g_pGraph.OppositePenColor;
    g_pGraph^.e_DrawEl(longint(g_pGraph));  {wipe = draw second time with opposite colors, with old corners}
    {do not draw very small elements}
    g_pGraph^.GetFirstXY(xf,yf);            {first point = point where drawing started}
    if (abs(x-xf) > 8) or (abs(y-yf) > 8) then begin
      {arrange corners: upper left = first, lower right = second}
      {but not for a line !}
      if (g_pGraph^.e_shape <> 3) then begin    {not a line (USE constants!!??..)}
        g_pGraph^.CheckCorners(xf,yf,x,y);
      end else begin
        {for a line, determine the drawing direction}
        g_pGraph^.LineDirection(xf,yf,x,y);
      end;
      {next, draw the final shape, but not for a text box. Edit-component added below}
      {but not for a text box. BETTER, no numbers!?}
      if (g_pGraph^.e_shape <> 6) and (g_pGraph^.e_shape <> 7) then begin
        g_pGraph^.PickPenColor;                 {pick the selected color for the pen}
        g_pGraph^.e_DrawEl(longint(g_pGraph));  {draw new element, with new opposite corner}
      end;
    end else begin                            {very small element, delete, do not draw}
      pGraph := g_List.last;
      if (pGraph <> nil) then begin
        indx := g_List.indexof(pGraph);        {index of the element in the list}
        if (indx >= 0) then begin              {element is in the list}
          pGraph^.e_pFont^.free;
          dispose(pGraph^.e_pFont);
          pGraph^.free;
          dispose(pGraph);
          g_List.delete(indx);                 {delete the element}
          g_pForm.invalidate;                  {call for redrawing}
          g_EditBox.tag := 0;                  {indicate that deleted...}
          g_MemoBox.tag := 0;                  {..to avoind second delete due to no text}
          g_EditBox.visible := false;          {just to be sure...}
          g_MemoBox.visible := false;
        end;
      end;
      DrawMenuForm.FontBut.visible := false;
      HideDirPanel;
    end;
    {if drawing box for text, show edit-component for the text}
    if (g_pGraph <> nil) then begin
      if (g_pGraph^.e_shape = 6) then begin
        GetCorners(longint(g_pGraph), x1,y1,x2,y2);  {corners of the box (upper left, lower right)}
        g_EditBox.font.assign(DrawMenuForm.FontDlg.font);
        g_MemoBox.font.assign(DrawMenuForm.FontDlg.font);
        g_EditBox.left := x1;
        g_EditBox.top := y1;
        g_EditBox.width := x2-x1;              {initial width, may be changed later. Height set automatically}
        g_EditBox.visible := true;
        g_pForm^.ActiveControl := g_EditBox;
        g_EditBox.tag := longint(g_pGraph);    {save pointer to element into tag}
      {memo-component for text}
      end else if (g_pGraph^.e_shape = 7) then begin
        GetCorners(longint(g_pGraph), x1,y1,x2,y2);  {corners of the box (upper left, lower right)}
        g_MemoBox.font.assign(DrawMenuForm.FontDlg.font);
        g_MemoBox.left := x1;
        g_MemoBox.top := y1;
        g_MemoBox.width := x2-x1;              {initial width, may be changed later. Height set automatically}
        {height...}
        WidthOfMemoText(hh);                   {find the height of text with the memo-font}
        g_MemoBox.height := hh+8;
        g_MemoBox.visible := true;
        g_pForm^.ActiveControl := g_MemoBox;
        g_MemoBox.tag := longint(g_pGraph);    {save pointer to element into tag}
      end;
    end;
    DrawMenuForm.ResetButClick(nil);
    g_drawing := false;                        {stop drawing, was set in mousedown}
  end;
//DrawMenuForm.ResetButClick(nil);
end;

procedure TGraphiq.CreateAndAddGraphicElement(indx: integer);
{create graphic element as an object, add to list of gr.elements
 indx  index of the type (shape) of the element}
var
  cnt    : integer;    {number of elements}
  pGraph : TpGraphel;  {temporary pointer to element}
begin
  new(pGraph);                           {reserve space for the element}
  pGraph^ := TGraphel.Create;            {create the component as an object}
  pGraph^.e_shape := indx;               {type of the element}
  {initialize some parameters, may be changed later}
  pGraph^.e_Toile := g_pForm^.Canvas;    {canvas on which drawn}
  pGraph^.e_Toile.pen.style := psSolid;
  pGraph^.e_Toile.pen.width := 1;
  pGraph^.e_Pencolor := clBlack;
  pGraph^.e_Brushcolor := clWhite;
  pGraph^.e_penwidth := 1;
  pGraph^.e_quarter := north;            {direction of directional elements}
  pGraph^.PutShapeIndex(indx);           {save the index of the element}
  pGraph^.e_DrawEl := DrawGraphel[indx]; {procedure for drawing}
  new(pGraph^.e_pFont);
  pGraph^.e_pFont^ := TFont.create;
  pGraph^.e_pFont^.assign(g_EditBox.font);
  {..}
  g_List.add(pGraph);                    {add to list of elements}
//  {move new elements to the beginning of the list}
//  cnt := g_List.count;
//  if (cnt > 1) then begin
//    g_List.move(cnt-1,0);                {move last to first}
//  end;
end;

procedure TGraphiq.DeleteElement(pGrel: TpGraphel; indx: integer);
{delete an graphical element
 pGrel  pointer to the element
 indx   index of the element in the list}
begin
  if (pGrel <> nil) and (indx = g_List.indexof(pGrel)) then begin
    {for a text box, hide also the edit-component}
    if (pGrel^.e_shape = 6) then begin
      g_EditBox.text := '';
      g_EditBox.visible := false;
      DrawMenuForm.FontBut.visible := false;
    end else if (pGrel^.e_shape = 7) then begin
      g_MemoBox.text := '';
      g_MemoBox.visible := false;
      DrawMenuForm.FontBut.visible := false;
    end;
    pGrel^.e_pFont^.free;
    dispose(pGrel^.e_pFont);
    pGrel^.free;
    dispose(pGrel);
    g_List.delete(indx);                 {delete the element}
  end;
end;

procedure TGraphiq.DeleteSelectedElement;
{delete the selected graphical element}
var
  indx  : integer;
  pGrel : TpGraphel;    {pointer to the graphical element}
  pMrk  : TpMarkImage;  {pointer to a marker (for pointer to the element)}
begin
  GetpMarker(0,pMrk);                      {pointer to first marker}
  pGrel := TpGraphel(pMrk^.m_ipGrel);      {pointer to the gr.element...}
  {...}                                    {...saved in TGraphiq.StartDrawing}
  if (pGrel <> nil) then begin
    indx := g_List.indexof(pGrel);         {index of the element in the list}
    if (indx >= 0) then begin              {element is in the list}
      DeleteElement(pGrel, indx);
      g_pForm.invalidate;                  {call for redrawing}
    end;
  end;
  {hide the markers and button(s)}
  HideMarkers;
  HideDirPanel;
end;

procedure TGraphiq.SendSelectedElementToBack;
{delete the selected graphical element}
var
  indx  : integer;
  pGrel : TpGraphel;    {pointer to the graphical element}
  pMrk  : TpMarkImage;  {pointer to a marker (for pointer to the element)}
begin
  GetpMarker(0,pMrk);                      {pointer to first marker}
  pGrel := TpGraphel(pMrk^.m_ipGrel);      {pointer to the gr.element...}
  {...}                                    {...saved in TGraphiq.StartDrawing}
  if (pGrel <> nil) then begin
    indx := g_List.indexof(pGrel);         {index of the element in the list}
    if (indx >= 0) then begin              {element is in the list}
      g_List.move(indx,0);                 {0=first element, bottom}
      g_pForm.invalidate;                  {call for redrawing}
    end;
  end;
  {hide the markers and button(s)}
  HideMarkers;
  HideDirPanel;
end;

procedure TGraphiq.CopySelectedElementToClipboard;
{copy the definition/data of the selected graphical element to LOCAL clickboard}
var
  ii    : integer;
  indx  : integer;
  pGrel : TpGraphel;    {pointer to the graphical element}
  pMrk  : TpMarkImage;  {pointer to a marker (for pointer to the element)}
begin
  GetpMarker(0,pMrk);                      {pointer to first marker}
  pGrel := TpGraphel(pMrk^.m_ipGrel);      {pointer to the gr.element...}
  {...}                                    {...saved in TGraphiq.StartDrawing}
  if (pGrel <> nil) then begin
    indx := g_List.indexof(pGrel);         {index of the element in the list}
    if (indx >= 0) then begin              {element is in the list}
      g_CopyList.clear;                    {clear clipboard first}
      OneElementToList(pGrel,g_CopyList,32);  {definition/data to clipboard = string list}
//    g_pForm.invalidate;                  {call for redrawing}
    end;
  end;
  {hide the markers and button(s)}
  HideMarkers;
  HideDirPanel;
//for ii := 0 to g_CopyList.count-1 do showmessage(g_CopyList[ii]);
end;

procedure TGraphiq.DeleteAll;
{deltet all graphical elements}
var
  cnt   : integer;    {number of elements}
  ii    : integer;
  jj    : integer;
  pGrel : TpGraphel;  {pointer to the element to be deleted}
begin
  cnt := g_List.count;      {number of elements}
  if (cnt > 0) then begin
    for ii := 1 to cnt do begin
      jj := cnt-ii;         {backwards}
      pGrel := g_List[jj];
      DeleteElement(pGrel,jj);
    end;
    g_pForm.invalidate;                  {call for redrawing}
  end;
end;

procedure TGraphiq.FreeGraphicElements;
{free the graphic elements (shapes) as objects}
var
  ii,jj  : integer;     {index}
  ng     : integer;     {number of graphic elements}
  pGraph : TpGraphel;   {pointer to an element}
begin
//BigDelay;            {test that this procedure is called with a long delay}
  ng := g_List.count;  {number of elements}
  if (ng > 0) then begin
    for ii := 1 to ng do begin
      jj := ng-ii;                  {backwards}
      pGraph := g_List[jj];         {element to be deleted}
      pGraph^.e_pFont^.free;
      dispose(pGraph^.e_pFont);
      pGraph^.free;                 {destroy = free the element}
      dispose(pGraph);              {release reserved space (?)}
    end;
  end;
  g_List.clear;
end;

procedure TGraphiq.HideMarkers;
{hide the markers and button(s) marking the selected graphich element}
var
  ii   : integer;      {index}
  pMrk : TpMarkImage;  {pointer to a marker}
begin
  {hide the markers}
  for ii := 0 to high(g_pMarkers) do begin
    GetpMarker(ii,pMrk);
    pMrk^.visible := false;
  end;
  g_MovImg.visible := false;
  g_DelBut.visible := false;
  g_BackBut.visible := false;
  g_CopyBut.visible := false;
//DrawMenuForm.DirPanel.visible := false;   {separately...}
end;

procedure TGraphiq.HideDirPanel;
begin
  DrawMenuForm.DirPanel.visible := false;
end;

procedure TGraphiq.InsideRectangle(x1,y1,x2,y2: integer);
{collect those elements that are inside the given rectangle
 x1,y1,x2,y2  coordinates of opposite corners of hte rectangle}
var
  pGrel   : TpGraphel; {pointer to graphical element}
  ii      : integer;
  xlr,ylr : integer;   {coordinates of the lower right corner}
  xr,yr   : integer;   {lower right corner of an element}
  xu,yu   : integer;   {upper left corner of an element}
  xul,yul : integer;   {coordinates of the upper left corner}
begin
  {find/arrange coordinates of the rectangle}
  if (x1 < x2) then begin
    if (y1 < y2) then begin
      xul := x1; yul := y1; xlr := x2; ylr := y2;
    end else if (y2 < y1) then begin
      xul := x1; yul := y2; xlr := x2; ylr := y2;
    end else begin    {same y, no rectangle}
      xul := 0; yul := 0; xlr := 0; ylr := 0;
    end;
  end else if (x2 < x1) then begin
    if (y1 < y2) then begin
      xul := x2; yul := y1; xlr := x1; ylr := y2;
    end else if (y2 < y1) then begin
      xul := x2; yul := y2; xlr := x1; ylr := y1;
    end else begin    {same y, no rectangle}
      xul := 0; yul := 0; xlr := 0; ylr := 0;
    end;
  end else begin      {same x, no rectangle}
    xul := 0; yul := 0; xlr := 0; ylr := 0;
  end;
  {collect elements that are inside the given rectangle}
  g_Inside.clear;                            {clear list of elements inside}
  if (g_List.count > 0) then begin           {are there elements}
    for ii := 0 to g_List.count-1 do begin
      pGrel := g_List[ii];
      GetCorners(longint(pGrel), xu,yu,xr,yr);
      if (xul < xu) and (xr < xlr) and
         (yul < yu) and (yr < ylr) then g_Inside.add(pGrel);  {add to list, if inside}
    end;
  end;
end;

procedure TGraphiq.FreeMarkers;
{free the small squares (images) used to mark seleted element
 and the box for editing texts}
var
  ii   : integer;
  ll   : longint;
  pMrk : TpMarkImage;
begin
  for ii := 0 to high(g_pMarkers) do begin
    ll := g_pMarkers[ii];
    pMrk := TpMarkImage(ll);
    pMrk^.free;
    dispose(pMrk);
  end;
  g_MovImg.free;
  g_EditBox.free;
  g_MemoBox.free;
end;

procedure TGraphiq.WriteElementsToFile(pOutfile: TpTextFile; flg : string);
{write the data for all elements to the given file. A special character can be
 added to the beginning of each line.
 The carriage returns are removed from rows of text (they must be added back, when
 reading the file)
 The Outfile must be ready to accept the writing: It must be assigned and rewritten
 The Outfile must be closed after writing. It is not done here!
 Outfile  the text file, where written
 flg      a special character that can be added to the beginning of the line}
var
  ii,jj    : integer;
  len      : integer;      {length of line}
  line     : string;       {one line of text}
  next     : boolean;      {next row contains data}
  txt      : string;       {temporary}
begin
  next := false;
  for ii := 0 to Graphic.g_ElList.count-1 do begin
    line := flg+Graphic.g_ElList[ii];
    {must replace line feeds with some special character}
    if (ii div 2) = (ii/2.0) then begin   {even row = flag or identifier of the data row}
      next := (line = '8');               {next row is text}
      txt := line;
    end else begin                        {odd row, contains data}
      if (next) then  begin               {process the text}
        txt := '';
        len := length(line);
        if (len > 0) then begin           {should be}
          {check text, replace line feeds}
          for jj := 1 to len do begin
            if (line[jj] = #13) then {...} else txt := txt+line[jj];  {skip carriage return}
          end;
        end else begin
          txt := '?';
        end;
      end else begin
        txt := line;
      end;
      next := false;
    end;
    writeln(pOutfile^,txt);
  end;
end;

procedure TGraphiq.CopyListAndAddCR(TmpList: TStringList);
{copy descriptions of elements to g_ElList from a temporary list (as read from a file).
 Add the missing carriage returns (CR) from text-lines}
var
  ii,kk    : integer;  {index}
  len      : integer;  {length of line}
  line     : string;   {one line of text}
  lno      : integer;  {line number}
  next     : boolean;
  txt      : string;
begin
  Graphic.g_ElList.clear;
  if (TmpList.count > 0) then begin
    next := false;
    lno := 0;                                  {initialize, first line}
    for kk := 0 to TmpList.count-1 do begin
      line := TmpList[kk];               {copy one line}
      if (next) then begin                     {text on this line}
        {add the possibly missing carriage returns}
        len := length(line);
        if (len > 0) then begin                {should be}
          txt := '';
          for ii := 1 to len do begin
            if (line[ii] = #10) then txt := txt+#13;  {if line feed, add carriage return}
            txt := txt+line[ii];
          end;
        end else begin
          txt := '?';
        end;
      end else begin
        txt := line;
      end;
      Graphic.g_ElList.add(txt);
      next := (line = '8') and ((lno div 2) = (lno/2.0)); {next text, and even row}
      inc(lno);                                {line number}
    end;
  end;
end;

procedure TGraphiq.CopyInsideToList(GraphList: TList);
{copy pointers to graphical elements that are inside given rectangle to the given list}
var
  ii : integer;
begin
  GraphList.clear;
  if (g_Inside.count > 0) then  begin
    for ii := 0 to g_Inside.count-1 do begin
      GraphList.add(g_Inside[ii]);
    end;
  end;
end;

procedure TGraphiq.CopyListToInside(GraphList: TList);
{copy given list to list of graphical elements that are inside given rectangle
 Needed in redo, maybe}
var
  ii : integer;
begin
  g_Inside.clear;
  if (GraphList.count > 0) then  begin
    for ii := 0 to GraphList.count-1 do begin
      g_Inside.add(GraphList[ii]);
    end;
  end;
end;

procedure TGraphiq.CopyAllToInsideList;
{copy all elements to list of elements inside a given rectangle.
 Needed when moving all}
var
  ii : integer;
begin
  g_Inside.clear;
  if (g_List.count > 0) then  begin
    for ii := 0 to g_List.count-1 do begin
      g_Inside.add(g_List[ii]);
    end;
  end;
end;

procedure TGraphel.putFirstXY(x,y: integer);
{save coordinates of first corner}
begin
  e_x1 := x;
  e_y1 := y;
end;

procedure TGraphel.getFirstXY(var x,y : integer);   {get the first corner}
begin
  x := e_x1;
  y := e_y1;
end;

procedure TGraphel.putSecondXY(x,y : integer; call: string);
{save coordinates of opposite corner}
begin
  e_x2 := x;
  e_y2 := y;
end;

procedure TGraphel.putTextCornerXY(x,y: integer);
{save coordinates of first corner}
begin
  e_xtx := x;
  e_ytx := y;
end;

procedure TGraphel.PutShapeIndex(shindx : integer);
{save the shape index}
begin
  e_shape := shindx;
end;

procedure TGraphel.ClearBrush;
{set the brush of the canvas to clear = no-fill}
begin
   e_toile.brush.style:=bsClear;  {do not fill the shape}
end;

procedure TGraphel.OppositePenColor;
{opposite of existing color, so that the shape is wiped or can be wiped}
begin
  e_Toile.pen.mode := pmNot;
end;

procedure TGraphel.PickPenColor;
{pick the pen color selected earlier, but first,
 set the pen mode to copy (pick) the color}
begin
  {box for text differently}
  if (e_shape = 6) or (e_shape = 7) then begin  {text box (BETTER!!??)}
    e_Toile.pen.color := {clGray}clRed;
{?} e_Toile.pen.style := psDot;
    e_Toile.pen.width := 1;
    e_Toile.pen.mode := pmCopy;
    e_Toile.brush.style := bsClear;
  end else begin                         {"normal"/"proper" graphical element}
    e_Toile.pen.color := e_Pencolor;     {get color, selected when gr.element created}
    e_Toile.brush.color := e_BrushColor; {color of the inside of the element}
    if (e_BrushColor = clWhite) then e_Toile.Brush.style := bsClear
    else e_Toile.Brush.style := bsSolid;
    e_Toile.pen.mode := pmCopy;          {use the defined color of the pen}
    {dashed line possible only when pen width = 1. "0" = dashed line}
    if (e_penwidth > 0) then begin
      e_Toile.pen.width := e_penwidth;   {size (width) of the pen}
      e_Toile.pen.style := psSolid;
    end else begin
      e_Toile.pen.width := 1;            {size (width) of the pen}
      e_Toile.pen.style := psDash;
    end;
  end;
end;

procedure TDrawMenuForm.DrawAll;
begin
  Graphic.DrawAll;
end;

procedure TDrawMenuForm.DeleteAll;
begin
  Graphic.DeleteAll;
end;

procedure TDrawMenuForm.DelAllButClick(Sender: TObject);
{delete the all elements}
var
  answer : word;
begin
  answer := MessageDlg('Really delete ALL graphical elements?',mtWarning, [mbCancel, mbYes], 0);
  if (answer = mrYes) then begin
    answer := MessageDlg('Once more: Really delete ALL graphical elements?',mtWarning, [mbCancel, mbYes], 0);
    if (answer = mrYes) then begin
      Graphic.DeleteAll;
      {hide the markers and button(s)}
      Graphic.HideMarkers;
      Graphic.HideDirPanel;
    end;  
  end;
end;

procedure TDrawMenuForm.MoveAll(dx,dy: integer);
begin
  Graphic.MoveAll(dx,dy);
end;

procedure TDrawMenuForm.MoveInsideOnes(dx,dy: integer);
begin
  Graphic.MoveInsideOnes(dx,dy);
end;

procedure TDrawMenuForm.MoveInList(List: TList; dx,dy : integer);
begin
  Graphic.MoveInList(List,dx,dy);
end;

procedure TDrawMenuForm.SketchOnCanvas(Toile: TCanvas; xc,yc, cw,ch: integer);
{draw rectangles around the graphical elements on the given canvas
 The idea: a picture covers the elements. Draw the rectangles on the picture
           in order to show the positions of the elements
 Toile  the canvas
 xc,yc  the position of the upper left corner of the canvas on its form
 cw,ch  width and height of the canvas (actually of the picture)}
begin
  Graphic.SketchOnCanvas(Toile, xc,yc, cw,ch);
end;

procedure TDrawMenuForm.EditBoxExit(sender: TObject);
begin
  Graphic.EditBoxExit(sender);
end;

procedure TDrawMenuForm.MemoBoxExit(sender: TObject);
begin
  Graphic.MemoBoxExit(sender);
end;

procedure TDrawMenuForm.PutpMainForm(ipForm, ipBut: longint);
begin
  pMainForm := TpForm(ipForm);
  pCtrlBut := TpSpeedButton(ipBut);
end;

procedure TDrawMenuForm.StartDrawing(x,y: integer);
begin
  Graphic.StartDrawing(x,y);
end;

procedure TDrawMenuForm.FinishDrawingWithMouse(x,y: integer);
begin
  Graphic.FinishDrawingWithMouse(x,y);
end;

procedure TDrawMenuForm.DrawWithMouse(x,y: integer);
begin
  Graphic.DrawWithMouse(x,y);
end;

procedure TDrawMenuForm.ResetButClick(Sender: TObject);
begin
  ResetBut.down := true;
  Graphic.PutShapeIndex(0);
//DirPanel.visible := false;
  if (sender <> nil) and ((sender as TComponent).name = 'ResetBut') then begin
    FontBut.visible := false;
    Graphic.HideDirPanel;
  end;      
end;

procedure TDrawMenuForm.RectButClick(Sender: TObject);
begin
  Graphic.PutShapeIndex(1);
  DirPanel.visible := false;
  FontBut.visible := false;
end;

procedure TDrawMenuForm.EllipButClick(Sender: TObject);
begin
  Graphic.PutShapeIndex(2);
EditBoxExit(nil);
  DirPanel.visible := false;
  FontBut.visible := false;
end;

procedure TDrawMenuForm.LineButClick(Sender: TObject);
begin
  Graphic.PutShapeIndex(3);        {use constants...!!??}
  DirPanel.visible := false;
  FontBut.visible := false;
end;

procedure TDrawMenuForm.TriangleButClick(Sender: TObject);
begin
  Graphic.PutShapeIndex(4);
  DirPanel.visible := true;
  FontBut.visible := false;
end;

procedure TDrawMenuForm.ArrowButClick(Sender: TObject);
begin
  Graphic.PutShapeIndex(5);
  DirPanel.visible := true;
  FontBut.visible := false;
end;

procedure TDrawMenuForm.TextButClick(Sender: TObject);
begin
  Graphic.PutShapeIndex(6);
  DirPanel.visible := false;
//{?}  FontDlg.execute;
  FontBut.visible := true;
end;

procedure TDrawMenuForm.MemoButClick(Sender: TObject);
begin
  Graphic.PutShapeIndex(7);
  {text probably in the right way, initially}
  if not(DrawMenuForm.EastBut.down) then begin
    DrawMenuForm.EastButClick(nil);
    DrawMenuForm.EastBut.down := true;
  end;  
  DirPanel.visible := true;
  FontBut.visible := true;
end;

procedure TDrawMenuForm.FormCreate(Sender: TObject);
begin
  {create the object for managing the shapes}
//showmessage('form create'+'  '+(Sender as TComponent).name);
  Graphic := TGraphiq.create;
  OpenDlg.InitialDir := ExtractFilePath(paramstr(0));   {directory where this program is}
  SaveDlg.InitialDir := OpenDlg.InitialDir;
  TempList := TStringList.create;
  {add the warning about fonts}
  NoteMemo.left := 2;
  NoteMemo.top := 2;
  NoteMemo.width := 200;
  NoteMemo.height := 60;
  NoteMemo.lines.add('Please note: Vertical or upside-down text is not possible with some fonts!');
  NoteMemo.lines.add('That is, the direction buttons ( ^ > v < ) do not work for these fonts');
  {- - - - - - - - - - - - - - -}
  {add flag that form created}
  Imagoo.ReadyEdit.text := Imagoo.ReadyEdit.text+'d';
end;

procedure TDrawMenuForm.FormDestroy(Sender: TObject);
{...}
begin
//Bigdelay;
  {free the graphic elements}
  Graphic.FreeGraphicElements;
  Graphic.FreeMarkers;
  Graphic.FreeLists;
  PartStrings.free;
  TempList.free;
  Graphic.free;
end;

procedure TDrawMenuForm.BlackButClick(Sender: TObject);
begin
  Graphic.g_Brushcolor := clBlack;
  {change the color of the selected graphical element, if any}
  Graphic.SetElementBrushColorIf(clBlack);
end;

procedure TDrawMenuForm.GreyButClick(Sender: TObject);
begin
  Graphic.g_Brushcolor := clGray;
  {change the color of the selected graphical element, if any}
  Graphic.SetElementBrushColorIf(clGray);
end;

procedure TDrawMenuForm.RedButClick(Sender: TObject);
begin
  Graphic.g_Brushcolor := clRed;
  {change the color of the selected graphical element, if any}
  Graphic.SetElementBrushColorIf(clRed);
end;

procedure TDrawMenuForm.GreenButClick(Sender: TObject);
begin
  Graphic.g_Brushcolor := clGreen;
  {change the color of the selected graphical element, if any}
  Graphic.SetElementBrushColorIf(clGreen);
end;

procedure TDrawMenuForm.BlueButClick(Sender: TObject);
begin
  Graphic.g_Brushcolor := clBlue;
  {change the color of the selected graphical element, if any}
  Graphic.SetElementBrushColorIf(clBlue);
end;

procedure TDrawMenuForm.YellowButClick(Sender: TObject);
begin
  Graphic.g_Brushcolor := clYellow;
  {change the color of the selected graphical element, if any}
  Graphic.SetElementBrushColorIf(clYellow);
end;

procedure TDrawMenuForm.LimeButClick(Sender: TObject);
begin
  Graphic.g_Brushcolor := clLime;
  {change the color of the selected graphical element, if any}
  Graphic.SetElementBrushColorIf(clLime);
end;

procedure TDrawMenuForm.AquaButClick(Sender: TObject);
begin
  Graphic.g_Brushcolor := clAqua;
  {change the color of the selected graphical element, if any}
  Graphic.SetElementBrushColorIf(clAqua);
end;

procedure TDrawMenuForm.FuchsiaButClick(Sender: TObject);
begin
  Graphic.g_Brushcolor := clFuchsia;
  {change the color of the selected graphical element, if any}
  Graphic.SetElementBrushColorIf(clFuchsia);
end;

procedure TDrawMenuForm.WhiteButClick(Sender: TObject);
begin
  Graphic.g_BrushColor := clWhite;
  {change the color of the selected graphical element, if any}
  Graphic.SetElementBrushColorIf(clWhite);
end;

procedure TDrawMenuForm.Line0ButClick(Sender: TObject);
begin
  Graphic.g_penwidth := 0;
  {change the pen width of the selected graphical element, if any}
  Graphic.SetElementPenWidthIf(0);
end;

procedure TDrawMenuForm.Line1ButClick(Sender: TObject);
begin
  Graphic.g_penwidth := 1;
  {change the pen width of the selected graphical element, if any}
  Graphic.SetElementPenWidthIf(1);
end;

procedure TDrawMenuForm.Line2ButClick(Sender: TObject);
begin
  Graphic.g_penwidth := 2;
  {change the pen width of the selected graphical element, if any}
  Graphic.SetElementPenWidthIf(2);
end;

procedure TDrawMenuForm.Line3ButClick(Sender: TObject);
begin
  Graphic.g_penwidth := 3;
  {change the pen width of the selected graphical element, if any}
  Graphic.SetElementPenWidthIf(3);
end;

procedure TDrawMenuForm.Line4ButClick(Sender: TObject);
begin
  Graphic.g_penwidth := 4;
  {change the pen width of the selected graphical element, if any}
  Graphic.SetElementPenWidthIf(4);
end;

procedure TDrawMenuForm.Line5ButClick(Sender: TObject);
begin
  Graphic.g_penwidth := 5;
  {change the pen width of the selected graphical element, if any}
  Graphic.SetElementPenWidthIf(5);
end;

procedure TDrawMenuForm.Line6ButClick(Sender: TObject);
begin
  Graphic.g_penwidth := 6;
  {change the pen width of the selected graphical element, if any}
  Graphic.SetElementPenWidthIf(6);
end;

procedure TDrawMenuForm.BlackLineButClick(Sender: TObject);
begin
  Graphic.g_PenColor := clBlack;
  {change the color of the selected graphical element, if any}
  Graphic.SetElementPenColorIf(clBlack);
end;

procedure TDrawMenuForm.LineGreyButClick(Sender: TObject);
begin
  Graphic.g_PenColor := clGray;
  {change the color of the selected graphical element, if any}
  Graphic.SetElementPenColorIf(clGray);
end;

procedure TDrawMenuForm.LineRedButClick(Sender: TObject);
begin
  Graphic.g_PenColor := clRed;
  {change the color of the selected graphical element, if any}
  Graphic.SetElementPenColorIf(clRed);
end;

procedure TDrawMenuForm.LineGreenButClick(Sender: TObject);
begin
  Graphic.g_PenColor := clGreen;
  {change the color of the selected graphical element, if any}
  Graphic.SetElementPenColorIf(clGreen);
end;

procedure TDrawMenuForm.LineBlueButClick(Sender: TObject);
begin
  Graphic.g_PenColor := clBlue;
  {change the color of the selected graphical element, if any}
  Graphic.SetElementPenColorIf(clBlue);
end;

procedure TDrawMenuForm.LineYellowButClick(Sender: TObject);
begin
  Graphic.g_PenColor := clYellow;
  {change the color of the selected graphical element, if any}
  Graphic.SetElementPenColorIf(clYellow);
end;

procedure TDrawMenuForm.LineLimeButClick(Sender: TObject);
begin
  Graphic.g_PenColor := clLime;
  {change the color of the selected graphical element, if any}
  Graphic.SetElementPenColorIf(clLime);
end;

procedure TDrawMenuForm.LineAquaButClick(Sender: TObject);
begin
  Graphic.g_PenColor := clAqua;
  {change the color of the selected graphical element, if any}
  Graphic.SetElementPenColorIf(clAqua);
end;

procedure TDrawMenuForm.LineFuchsiaButClick(Sender: TObject);
begin
  Graphic.g_PenColor := clFuchsia;
  {change the color of the selected graphical element, if any}
  Graphic.SetElementPenColorIf(clFuchsia);
end;

procedure TDrawMenuForm.NorthButClick(Sender: TObject);
begin
  Graphic.g_quarter := north;
  {change the direction of the element, if any active}
  Graphic.SetElementQuarterIf(north);
end;

procedure TDrawMenuForm.EastButClick(Sender: TObject);
begin
  Graphic.g_quarter := east;
  {change the direction of the element, if any active}
  Graphic.SetElementQuarterIf(east);
end;

procedure TDrawMenuForm.SouthButClick(Sender: TObject);
begin
  Graphic.g_quarter := south;
  {change the direction of the element, if any active}
  Graphic.SetElementQuarterIf(south);
end;

procedure TDrawMenuForm.WestButClick(Sender: TObject);
begin
  Graphic.g_quarter := west;
  {change the direction of the element, if any active}
  Graphic.SetElementQuarterIf(west);
end;

procedure TDrawMenuForm.FontButClick(Sender: TObject);
begin
  FontDlg.font.assign(Graphic.g_MemoBox.font);
  if (FontDlg.execute) then begin
    Graphic.g_EditBox.font.assign(FontDlg.font);
    Graphic.g_MemoBox.font.assign(FontDlg.font);
  end;
end;

procedure TDrawMenuForm.FontDlgApply(Sender: TObject; Wnd: Integer);
begin
  Graphic.g_EditBox.font := FontDlg.font;
  Graphic.g_MemoBox.font := FontDlg.font;
end;

procedure TDrawMenuForm.TestButClick(Sender: TObject);
var
  ii : integer;
begin
(*
  GetPartStrings(TestEdit.text, @PartStrings);
  TestMemo.clear;
  if (PartStrings.count > 0) then begin
    for ii := 0 to PartStrings.count-1 do begin
      TestMemo.lines.add(PartStrings[ii]);
    end;
  end;
*)
end;

procedure TDrawMenuForm.OpenButClick(Sender: TObject);
{read the elements from a file, draw}
var
  FileName : string;   {name of the file from which names read (with directory)}
  ii       : integer;  {index}
  InFile   : TextFile; {file from which read}
  len      : integer;  {length of line}
  line     : string;   {one line of text}
  lno      : integer;  {line number}
  next     : boolean;
  txt      : string;
begin
  if (OpenDlg.execute) then begin
    FileName := OpenDlg.FileName;
    if (FileExists(FileName)) then begin
      {open and read lines}
      AssignFile(InFile,FileName);        {open the file}
      Reset(InFile);
      TempList.clear;
      while not(EOF(InFile)) do begin
        readln(Infile,line);              {read one line}
        TempList.add(line);               {put to temporary list, process later}
      end;
      CloseFile(InFile);
    end;
    {process...}
    Graphic.CopyListAndAddCR(TempList);   {copy to local, add missing carriage returns}
    Graphic.ElementsFromList(Graphic.g_ElList);
    Graphic.g_pForm.invalidate;           {drawn in FormPaint of the main form}
  end;
end;

procedure TDrawMenuForm.SaveButClick(Sender: TObject);
{save the graphs (definitions) to a text file}
var
  FileName : string;       {name of the file where written}
  ii       : integer;
  Outfile  : TextFile;     {file where written}
begin
  if (SaveDlg.execute) then begin
    Graphic.ElementsToList;                     {write the elements+parameters to list, as strings}
    {write the list to file}
    if (Graphic.g_ElList.count >=4) then begin  {there is something in the list}
      FileName := SaveDlg.filename;             {name of file, where written}
      AssignFile(Outfile, filename);            {open the given file,BUT ERRORS ?}
      rewrite(outfile);
      {write the text}
      for ii := 0 to Graphic.g_ElList.count-1 do writeln(outfile,Graphic.g_ElList[ii]);
      CloseFile(Outfile);
    end;
  end;
end;

procedure TDrawMenuForm.FormHide(Sender: TObject);
begin
  pCtrlBut^.down := false;
end;

(*
procedure TDrawMenuForm.DummyMemoTextOut(xx,yy: integer);
{write the text in the memo to the form. NOTE: Set font first!!
 xx,yy  the position of the text (upper left corner)}
var
  cnt : integer;  {number of lines}
  hh  : integer;  {height of the text}
  ii  : integer;  {index}
begin
  {possibly several lines. Must find height of one line}
  hh := canvas.textheight(DummyMemo.text);
  cnt := DummyMemo.lines.count;        {number of lines}
  if (cnt > 0) then begin
    for ii := 0 to cnt-1 do begin
      Graphic.g_pForm^.canvas.textout(xx+4,yy+ii*hh,DummyMemo.lines[ii]);
    end;
  end;
end;
*)

procedure TDrawMenuForm.HideButClick(Sender: TObject);
{hide/show the graphics. Showing depends on the state of the HideBut.
 Checking of the state is done in DrawAll}
begin
  Graphic.g_pForm^.invalidate;
end;

procedure TDrawMenuForm.InsideRectangle(x1,y1,x2,y2: integer);
begin
  Graphic.InsideRectangle(x1,y1,x2,y2);
end;

procedure TDrawMenuForm.SetCanvas(Toile: TCanvas);
begin
  Graphic.SetCanvas(Toile);
end;

procedure TDrawMenuForm.ResetCanvas;
begin
  Graphic.ResetCanvas;
end;

procedure TDrawMenuForm.ProcessExternalList(TmpList : TStringList);
{When a list of elements has been externally read from a file, it must be
 processed in order to display the elements}
begin
  {process...}
  Graphic.CopyListAndAddCR(TmpList);            {copy to local, add missing carriage returns}
  Graphic.ElementsFromList(Graphic.g_ElList);   {generate list of elements with properties}
  Graphic.g_pForm.invalidate;                   {drawn in FormPaint of the main form}
end;

procedure TDrawMenuForm.ElementsToExternalList(TmpList: TStringList);
{copy and process elements to a string list for saving to file
 Process: properties of elements as texts,
          remove carriage returns from texts of memoboxes}
var
  ii : integer;
begin
  Graphic.ElementsToList;       {elements to local list}
  TmpList.clear;
  if (Graphic.g_ElList.count > 0) then begin
    for ii := 0 to Graphic.g_ElList.count-1 do begin
      TmpList.add(Graphic.g_ElList[ii]);
    end;
  end;
end;

procedure TDrawMenuForm.NoteButClick(Sender: TObject);
begin
  if (NoteBut.down) then begin
    NoteMemo.visible := true;
    NoteMemo.BringToFront;
  end else begin
    NoteMemo.visible := false;
  end;
end;

procedure TDrawMenuForm.CopyInsideToList(GraphList: TList);
{copy pointers to moved graphical elements to given list}
begin
  Graphic.CopyInsideToList(GraphList);  {copy pointers to moved graphical elements}
end;

procedure TDrawMenuForm.CopyListToInside(GraphList: TList);
{copy pointers from given list to list of graphical elements inside given rectangle
 Needed in redo (I think...)}
begin
  Graphic.CopyListToInside(GraphList);  {copy pointers to moved graphical elements}
end;

procedure TDrawMenuForm.CopyAllToInsideList;
{copy all elements to list of elements inside given rectangle.
 Needed when moving all}
begin
  Graphic.CopyAllToInsideList;  {copy pointers}
end;

end.
