 {the .tag of the form contains the pointer to the relay}
unit CopyGroup;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Skemadef, Utildef, Skemproc, Imagodef, Distance, Polygon,
  Buttons, ExtCtrls;

type
  TCopyGroupForm = class(TForm)
    ParamBox: TCheckBox;
    TextBox: TCheckBox;
    ToLabel: TLabel;
    WhatLabel: TLabel;
    CancelBut: TButton;
    HelpMemo: TMemo;
    Group1But: TRadioButton;
    Group2But: TRadioButton;
    Group3But: TRadioButton;
    Group4But: TRadioButton;
    Group5But: TRadioButton;
    Group6But: TRadioButton;
    CloseBut: TButton;
    HintBut: TSpeedButton;
    OKBut: TSpeedButton;
    OKTImer: TTimer;
    procedure FormHide(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Group1ButClick(Sender: TObject);
    procedure Group2ButClick(Sender: TObject);
    procedure Group3ButClick(Sender: TObject);
    procedure Group4ButClick(Sender: TObject);
    procedure Group5ButClick(Sender: TObject);
    procedure Group6ButClick(Sender: TObject);
    procedure CancelButClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure CloseButClick(Sender: TObject);
    function  CopyOvercurrentRelayParamGroup: boolean;
    function  CopyDistanceRelayParamGroup: boolean;
    procedure HintButClick(Sender: TObject);
    procedure OKButClick(Sender: TObject);
    procedure OKTImerTimer(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private declarations }
    iCopyGrp_c : integer;       {index of group to where was copied}
    igrp_c     : integer;       {index of group to where will be copied}
    InfoBack   : TStringList;   {saves info for cancel}
    pOldPar_c  : pSingle;       {for saving parameter for "cancel"}
    nOldPar_c  : integer;       {number of parameters}
    CopyPar_c  : boolean;       {true, if parameters copied}
    CopyDesc_c : boolean;       {true, when copying descriptions}
    ParStr_c   : string;        {for saving param. of distance relay, for cancel}
    OldStr_c   : array[1..gReCurv] of string;  {for saving current-time points, for cancel}
  public
    { Public declarations }
  end;

var
  CopyGroupForm: TCopyGroupForm;

implementation

uses PQRelay, Recloser, userdef, Imagopas;

{$R *.DFM}

function TCopyGroupForm.CopyDistanceRelayParamGroup: boolean;
{copy the parameters of the present (displayed) parameter group to the
 given group, for distance relays}
var
  done   : boolean;  {true, when copying successful}
  igrp   : integer;  {index of the parameter group}
  name   : string;   {name = type of the component}
  pComp  : TpComp;   {pointer to the relay}
  pDist  : TpDist;   {pointer to the object for operations with distance relays}
  strpar : string;   {parameters in one string}
begin
  if (igrp_c > 0) and (igrp_c <= gParSet) then begin {reasonable index to where copied}
    pComp := TpComp(tag);                           {pointer saved in tag, in TPQForm.CopyItemClick of PQrelay.pas}
    pComp^.GetName(name);                           {name = type of the relay}
    if (name = gMeasZ) then pDist := @Distance.Dist {Mho-distance relay}
    else pDist := @Polygon.Poly;                    {polygonal = quadrilateral relay}
    {move displayed parameters to param. of the component, and to the group}
    pDist^.FromGridToParam(nil);   {but CANCEL?!... ... .. .. ... ... ... ... }
    pDist^.FromGridToParamGroup;
    pComp^.GetStringPar(ParStr_c,igrp_c);  {save for cancel}
    igrp := pDist^.ParamGroupIndex;        {index of the group}
    pComp^.GetStringPar(strpar,igrp);      {get the parameters as a string from the present group}
    pComp^.PutStringPar(strpar,igrp_c);    {save the parameters as a string to the new group}
    iCopyGrp_c := igrp_c;                  {save the index of the new group for "cancel"}
    CopyPar_c := true;                     {flag for copying done}
    done := true;
  end else begin
    done := false;
  end;
  CopyDistanceRelayParamGroup := done;
end;

function TCopyGroupForm.CopyOvercurrentRelayParamGroup: boolean;
{copy the parameters of the present (displayed) parameter group to the
 given group, for overcurrent relays = PGQ-, electromech, recloser, user def. relays}
var
  done   : boolean;     {true, if copying successful}
  igrp   : integer;     {the present group}
  ii     : integer;
  indx   : integer;     {index of info-line}
  line   : string;      {one line (string)}
  name   : string;      {name = type of the relay}
  npar   : integer;     {number of parameters}
  pComp  : TpComp;
  pGCalc : TpGridCalc;  {pointer to the object for grid operations}
  pList  : TpList;      {pointer to list of parameter groups}
  pPar   : pSingle;     {pointer to parameters}
  pPar0  : pSingle;     {pointer to old parameters}
begin
  pComp := TpComp(tag);                       {pointer saved in tag, in TPQForm.CopyItemClick of PQrelay.pas}
  pComp^.GetName(name);                       {name = type of the relay}
  {two different objects for calculations, according to the relay type}
  if (name = gPQRel) or (name = gEMRel) then pGCalc := @PQRelay.GridCalc {PGQ or electromech}
  else pGcalc := Recloser.pRCGridCalc;        {recloser or user defined}
  pComp^.GetNpar(npar);                       {number of parameters}
  {only "proper" parameters}
  if (name = gUDrel) then nOldPar_c := npar-(gUD_2-gUD_1)*gReCurv else nOldPar_c := npar;
  GetMem(pOldpar_c,nOldPar_c*Sizeof(single)); {memory for saving parameters for "cancel"}
  {the whole copy operation, if reasonable group}
  if (igrp_c > 0) and (igrp_c <= gParSet) then begin {reasonable index to where copied}
    {copy, if selected}
    if (ParamBox.checked) or (TextBox.checked) then begin  {copy something}
      {save parameters for "cancel", if will be copied}
      if (ParamBox.checked) then begin
        {copy temporarily, for eventual "cancel"}
        pComp^.GetpList(pList);
        pPar0 := pList^.items[igrp_c-1];          {pointer to first old parameter}
        pPar := pOldPar_c;                        {pointer to temp.storage}
        for ii := 1 to nOldPar_c do begin
          pPar^:= pPar0^;
          inc(pPar);
          inc(pPar0);
        end;
        {save also char.curves, if user defined relay}
        if (name = gUDrel) then begin
          for ii := 1 to gReCurv do begin
            OldStr_c[ii] := pComp^.pParStr_s^[igrp_c][ii];
          end;
        end;
      end;
      {save descriptions for "cancel", if will be copied}
      if (TextBox.checked) then begin
        pGCalc^.StoreDescriptions(igrp_c);       {save present descriptions for cancel}
      end;
      {then the actual copying}
      pGCalc^.FromGridToParamGroup(igrp_c,ParamBox.checked,TextBox.checked);
      {if user defined relay, copy the curves = current-time points}
      if (name = gUDrel) and (ParamBox.checked) then begin
        igrp := pGCalc.ParamGroupIndex;
        for ii := 1 to gReCurv do begin          {all curves in the relay}
          pComp^.pParStr_s^[igrp_c][ii] := pComp^.pParStr_s^[igrp][ii];
        end;
      end;
      {if user defined or recloser relay, copy also the info}
      if (name = gUDrel) or (name = gRCrel) or (name = gPQrel) then begin
        igrp := pGCalc.ParamGroupIndex;                    {index of the "from" param.group}
        InfoBack.clear;
        for ii := 1 to gReCurv do begin
          indx := RecloserForm.InfoIndex(igrp_c, ii);      {index of the target info}
          {info to be overwritten, save for possible "cancel"}
          line := pComp^.GetInfoLine(RecloserForm.InfoIndex(igrp_c,ii));
          InfoBack.add(line);                              {save for cancel}
          {info of this module in this group}
          line := pComp^.GetInfoLine(RecloserForm.InfoIndex(igrp,ii));
          pComp^.ReplaceInfoLine(indx,line);               {copy = overwrite old}
        end;
      end;
      iCopyGrp_c := igrp_c;                      {save the group for "cancel"}
      {save copying flags, for eventual cancel-operation}
      CopyPar_c := ParamBox.checked;
      CopyDesc_c := TextBox.checked;
      done := true;
    end else begin
      done := false;
    end;
  end else begin
    done := false;
  end;
  CopyOvercurrentRelayParamGroup := done;
end;

procedure TCopyGroupForm.FormHide(Sender: TObject);
begin
  FreeMem(pOldpar_c,nOldPar_c*Sizeof(single));
  pOldpar_c := nil;
end;

procedure TCopyGroupForm.FormCreate(Sender: TObject);
var
  ii : integer;
begin
  pOldpar_c := nil;
  for ii := 1 to gReCurv do begin
    OldStr_c[ii] := '';
  end;
  InfoBack := TStringList.create;
  {add flag that form created}
  Imagoo.ReadyEdit.text := Imagoo.ReadyEdit.text+'K';
end;

procedure TCopyGroupForm.Group1ButClick(Sender: TObject);
begin
  igrp_c := 1;      {index of group where copied}
end;

procedure TCopyGroupForm.Group2ButClick(Sender: TObject);
begin
  igrp_c := 2;
end;

procedure TCopyGroupForm.Group3ButClick(Sender: TObject);
begin
  igrp_c := 3;
end;

procedure TCopyGroupForm.Group4ButClick(Sender: TObject);
begin
  igrp_c := 4;
end;

procedure TCopyGroupForm.Group5ButClick(Sender: TObject);
begin
  igrp_c := 5;
end;

procedure TCopyGroupForm.Group6ButClick(Sender: TObject);
begin
  igrp_c := 6;
end;

procedure TCopyGroupForm.CancelButClick(Sender: TObject);
{cancel the latest copying}
var
  cnt    : integer;    {number of items}
  igrp   : integer;    {index of the visible parameter group}
  ii     : integer;
  line   : string;     {temporary}
  name   : string;     {name = type of the component}
  pComp  : TpComp;
  pDist  : TpDist;     {object for operations of distance relay}
  pGcalc : TpGridCalc; {pointer to the object for grid operations}
  pList  : TpList;     {pointer to list of parameter groups}
  pPar   : pSingle;    {pointer to the parameters in the selected group}
  pPar0  : pSingle;    {pointer to old parameters}
  rr     : integer;    {index of relay module}
begin
  {cancel copying, if copied, else close form . . .}
  if (CopyPar_c) or (CopyDesc_c) then begin     {copied}
    pComp := TpComp(tag);                       {pointer saved in tag}
    pComp^.GetName(name);                       {name = type of the relay}
    {overcurrent relay, or distance relay...}
    if (name = gPQRel) or (name = gEMRel) or (name = gRCrel) or (name = gUDrel) then begin
      {two different objects for calculations, according to the relay type}
      if (name = gPQRel) or (name = gEMRel) then pGCalc := @PQRelay.GridCalc {PGQ or electromech}
      else pGcalc := Recloser.pRCGridCalc;        {recloser or user defined}
      if (iCopyGrp_c > 0) and (iCopyGrp_c <= gParSet) then begin {reasonable index to where copied}
        if (CopyPar_c) then begin                 {cancel only, if parameters copied}
          {fetch param saved for "cancel"}
          pComp^.GetpList(pList);
          pPar0 := pList^.items[iCopyGrp_c-1];      {pointer to first parameter}
          pPar := pOldPar_c;                        {pointer to temp.storage}
          for ii := 1 to nOldPar_c do begin
            pPar0^:= pPar^;
            inc(pPar);
            inc(pPar0);
          end;
          {if user defined relay, recall also the curves}
          if (name = gUDrel) then begin
            for ii := 1 to gReCurv do begin
              pComp^.pParStr_s^[iCopyGrp_c][ii] := OldStr_c[ii];
            end;
          end;
          {if user defined or recloser relay, recall the info}
          if (name = gUDrel) or (name =gRCrel) or (name = gPQrel) then begin
            cnt := InfoBack.count;
            if (cnt >= gReCurv) then begin            {there is some data}
              for ii := 1 to gReCurv do begin
                line := InfoBack[ii-1];               {index starts from 0}
                pComp^.ReplaceInfoLine(RecloserForm.InfoIndex(igrp_c,ii),line);
              end;
            end;
          end;
        end;
        {recall also descriptions, if saved...?}
        if (CopyDesc_c) then begin
          pGCalc.RecallDescriptions(iCopyGrp_c);
        end;
        {display also, if this group visible}
        igrp := pGCalc.ParamGroupIndex;
        if (igrp = iCopyGrp_c) then begin
          pGCalc.ParamFromSetOrCompToGrid(pComp, igrp);
          pGCalc.DescriptionsFromParamGroup(igrp);
          {if user defined relay, move also the current-time points}
          if (name = gUDrel) then begin
            FromGroupToCurrTime(pComp, igrp);
            {and display, if form visible}
            if (CharForm.visible) then begin
              rr := pGCalc^.GetActCol;         {index of module = column}
              ParamToCharGrid(pComp, rr);
            end;
          end;
          RelayShowIf(tag);       {update also the graph, if visible, in Skemproc.pas}
        end;
      end;
    end else if (name = gMeasZ) or (name = gPolyg) then begin  {distance relay}
      pComp^.PutStringPar(ParStr_c,iCopyGrp_c);                {return the parameters}
      {display, if this group visible}
      if (name = gMeasZ) then pDist := @Distance.Dist {Mho-distance relay}
      else pDist := @Polygon.Poly;                    {polygonal = quadrilateral relay}
      pDist^.FromParamGroupToGrid(iCopyGrp_c);
      pDist^.FromGridToParam(nil);                    {parameters to the component}
      {redraw the characteristics, if visible}
//    if (name = gMeasZ) then DrawAllMhoChar(pComp,pDist^.pDistChar^.canvas)
      {if (name = gMeasZ) then} pDist^.DrawRelays(pDist^.pDistChar^.canvas,'CancelButClick')
//    else DrawAllPolyChar(pComp,pDist^.pDistChar^.canvas,'CancelButClick');
    end;
    CopyPar_c := false;
    CopyDesc_c := false;
  end else begin                {if not copied, close the form}
    CopyGroupForm.visible := false;
  end;
end;

procedure TCopyGroupForm.FormShow(Sender: TObject);
begin
//  CancelBut.enabled := false;
end;

procedure TCopyGroupForm.CloseButClick(Sender: TObject);
begin
  CopyGroupForm.visible := false;
  CopyPar_c := false;
  CopyDesc_c := false;
end;

procedure TCopyGroupForm.HintButClick(Sender: TObject);
begin
  HelpMemo.visible := HintBut.down;
end;

procedure TCopyGroupForm.OKButClick(Sender: TObject);
var
  done   : boolean;     {true, if copying successful}
  name   : string;      {name = type of the relay}
  pComp  : TpComp;
begin
  pComp := TpComp(tag);                       {pointer saved in tag, in TPQForm.CopyItemClick of PQrelay.pas}
  pComp^.GetName(name);                       {name = type of the relay}
  done := false;                              {initialize}
  if (name = gPQRel) or (name = gEMRel) or                   {overcurrent relay}
     (name = gRCRel) or (name = gUDRel) then begin
    done := CopyOvercurrentRelayParamGroup;
  end else if (name = gMeasZ) or (name = gPolyg) then begin  {distance relay}
    done := CopyDistanceRelayParamGroup;
  end;
  if (done) then begin
    OKBut.font.color := clBlack;
    OKBut.caption := 'copied';
  end else begin
    OKBut.caption := 'error';
    OKBut.font.color := clRed;
  end;
  OKTimer.enabled := true;
end;

procedure TCopyGroupForm.OKTImerTimer(Sender: TObject);
begin
  OKTimer.enabled := false;
  OKBut.font.color := clBlue;
  OKBut.caption := 'OK';
end;

procedure TCopyGroupForm.FormDestroy(Sender: TObject);
begin
  InfoBack.free;
end;

end.
