unit ImpedCalc;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls, Buttons, Routines, Compdef, Utildef, Skemadef, Imagodef,
  ExtCtrls, nodes;

type
  TImpedCalcForm = class(TForm)
    ImpedCalcPage: TPageControl;
    SumSheet: TTabSheet;
    AnalyzeSheet: TTabSheet;
    R1Edit: TEdit;
    X1Edit: TEdit;
    TabSheet1: TTabSheet;
    R0Edit: TEdit;
    X0Edit: TEdit;
    OhmLabel: TLabel;
    BEdit: TEdit;
    perOhmLabel: TLabel;
    AddButton: TSpeedButton;
    LengthEdit: TEdit;
    ResetBut: TButton;
    Z1Edit: TEdit;
    Z0Edit: TEdit;
    CopyButton: TSpeedButton;
    SubButton: TSpeedButton;
    LogEdit: TRichEdit;
    CloseBut: TButton;
    LogBut: TSpeedButton;
    FactorEdit: TEdit;
    MultLabel: TLabel;
    TotalLabel: TLabel;
    ArrowLabel: TLabel;
    ResultEdit: TEdit;
    VarCombox: TComboBox;
    CalcBut: TButton;
    EqLabel: TLabel;
    LabelEdit: TEdit;
    R1fEdit: TEdit;
    X1fEdit: TEdit;
    R0fEdit: TEdit;
    X0fEdit: TEdit;
    Z1fEdit: TEdit;
    Z0fEdit: TEdit;
    LenfEdit: TEdit;
    BfEdit: TEdit;
    perOhmfLabel: TLabel;
    OhmfLabel: TLabel;
    FractLabel: TLabel;
    LineImg: TImage;
    ClickLabel: TLabel;
    MultiLabel: TLabel;
    HelpBut: TButton;
    HelpPanel: TPanel;
    SumLabel: TLabel;
    SumMemo: TMemo;
    SumMemo2: TMemo;
    AddEdit: TEdit;
    SubEdit: TEdit;
    CopyEdit: TEdit;
    AnalyzeLabel: TLabel;
    AnalyzeMemo: TMemo;
    AnalyzeImg: TImage;
    ExampleEdit: TMemo;
    XButton: TButton;
    k0rifEdit: TEdit;
    k0mpfEdit: TEdit;
    k0riEdit: TEdit;
    k0mpEdit: TEdit;
    ResetABut: TButton;
    LineTrafoPanel: TPanel;
    LineRadioBut: TRadioButton;
    TrafoRadioBut: TRadioButton;
    TrafoImg: TImage;
    WarnBut: TSpeedButton;
    TrHelpPanel: TPanel;
    TrSumLabel: TLabel;
    TrSumMemo: TMemo;
    TrSumMemo2: TMemo;
    TrAddEdit: TEdit;
    TrSubEdit: TEdit;
    TrXButton: TButton;
    Note1Memo: TMemo;
    Note2Memo: TMemo;
    procedure FormCreate(Sender: TObject);
    procedure ResetButClick(Sender: TObject);
    procedure CloseButClick(Sender: TObject);
    procedure LogButClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ImpedCalcPageChange(Sender: TObject);
    procedure CalcButClick(Sender: TObject);
    procedure HelpButClick(Sender: TObject);
    procedure XButtonClick(Sender: TObject);
    procedure ResetAButClick(Sender: TObject);
    procedure TrafoRadioButClick(Sender: TObject);
    procedure LineRadioButClick(Sender: TObject);
    procedure WarnButClick(Sender: TObject);
    procedure FormHide(Sender: TObject);
    procedure TrXButtonClick(Sender: TObject);
  private
    { Private declarations }
    Rp     : single;  {pos.seq. resistance/km of one tr.line}
    Xp     : single;
    Rz     : single;
    Xz     : single;
    Sp     : single;
    km     : single;
    Vnom   : single;
    Vref   : single;  {impedances transformed to this voltage, when transformers}
    SumRp  : single;  {total pos.seq. resistance of tr.lines}
    SumXp  : single;
    SumRz  : single;
    SumXz  : single;
    SumSp  : single;
    Sumkm  : single;
    pSumRp : pSingle;  {total pos.seq. resistance of tr.lines}
    pSumXp : pSingle;
    pSumRz : pSingle;
    pSumXz : pSingle;
    pSumSp : pSingle;
    pSumkm : pSingle;
    CLabel : string;  {label = identifier of the component}
    CList  : TList;   {list of pointers to selected components}
    pLComp : TpComp;  {pointer to latest component}
    w3pair : integer; {12 = prim-sec., 13 = prim-tert, 23 = sec-tert imped. in 3wtrafo}
    FiniteNotInfinite: boolean; {use given (finite) zero sec.impedance, not infinite}
  public
    procedure PutComp(pComp: TpComp);
    procedure ParamToLog;
    procedure GetParam(var R1,X1,R0,X0,Ss,len: single);
    procedure UpdateSums(oper: string);
    procedure PutLabel(lbl: string);
    procedure SetLabelLength(inlbl: string; var utlbl: string; nc : integer);
    procedure UpdateFraction(movedgr: boolean);
    procedure DisplayFractions(iline: integer; s1 : single);
//  procedure PutSecOrTert(SecNot3: boolean);
    procedure Putw3pair(w3p: integer);
    procedure PutFiniteNotInfinite(FiNotInf: boolean);
    { Public declarations }
  end;

var
  ImpedCalcForm: TImpedCalcForm;

implementation

uses Imagopas, elplex;

{$R *.DFM}

const
  LogCaption =
  '         .           R            X           R0           X0            S           km ';
{  <        ><           ><           ><           ><           ><           ><           >'}
  SelRow : integer = 0; {counts characters}
  SelLen : integer = 0; {length of selected section}
  Linex  : integer = 0;
  Liney  : integer = 0;
  Trafox : integer = 0;
  Trafoy : integer = 0;

procedure TImpedCalcForm.PutComp(pComp: TpComp);
{add selected component to the list of components, copy pointer to local
 Called in SendTrLineData of Skemproc.pas, when component clicked}
var
  apu,apv : single;    {temporary}
  ic      : integer;   {index}
  ipSet   : longint;   {pointer to the common}
  ix,iy   : integer;   {coordinates of the label}
  ll      : longint;   {temporary}
  name    : string;
  npr     : single;    {number of parallel lines}
  pSet    : TpCompSet; {pointer to the common}
  trafo   : boolean;   {component is transformer}
  V1      : single;    {prim.voltage of trafo (or sec.V), or voltage level of line}
  Vp,Vs,Vt: single;    {prim., sec., tert voltage of trafo}
begin
  pComp^.GetipSet(ipSet);            {pointer to the common, as integer}
  pSet := TpCompSet(ipSet);
  {solve the voltages, for impedance transformation, but with zero currents}
  if (TrafoRadioBut.checked) then begin             {only when transformers included}
    if (SumRp+SumXp+SumRz+SumXz+SumSp+Sumkm = 0) or
       (Imagoo.SolvedProb.hint <> gImpedSumText) then begin
      pSet^.Imped_Sum := true;         {set flag for the calculations}
      pSet^.pTo_Comp := pComp;         {save for voltage calculation, needed in SolveNet of elplex.pas}
      SolveNet(ipSet,false,Normal);
      pSet^.Imped_Sum := false;        {reset flag}
    end;
  end;
  pLComp := pComp;
  trafo := isTrafo(pComp);          {in Nodes.pas}
  pComp^.GetName(name);             {name = type of the component}
  {number of parallel components}
  if (trafo) then begin
    if      (name = gTrafoYY) then pComp^.GetPar(gYY_parall,npr)
    else if (name = gTrafoYD) then pComp^.GetPar(gYD_parall,npr)
    else if (name = gTrafoDY) then pComp^.GetPar(gDY_parall,npr)
    else if (name = gTrafoDD) then pComp^.GetPar(gDD_parall,npr)
    else npr := 1;                    {3-winding trafo}
  end else begin                      {transmission line}
    pComp^.GetPar(gTrLiS_paral,npr);
  end;
  {get calculated voltage, real and imag.parts}
  {if 3-w trafo, and sec-tert impedance, use sec. voltage, else primary}
  if (name = gTrafo3w) and (w3pair = 23) then begin
    pComp^.GetVar(3,apu);     {secondary voltage}
    pComp^.GetVar(4,apv);
  end else begin
    pComp^.GetVar(1,apu);
    pComp^.GetVar(2,apv);
  end;  
  V1 := sqrt(apu*apu+apv*apv);
  if (npr <= 0) then npr := 1;
  {get parameters}
  pComp^.GetLabel(Clabel,ix,iy);
  if (trafo) then begin                          {transformer}
    if (name = gTrafo3w) then begin
      {for 3-winding trafo must select Z12 or Z13 or Z23}
      if (w3pair = 12) then begin                {use 1-2 impedance}
        pComp^.GetPar(g3W_R1,apu);               {resistance of prim.winding}
        pComp^.GetPar(g3W_R2,apv);               {resistance of sec.winding}
        pComp^.GetPar(g3W_V1,Vp);                {prim.voltage}
        pComp^.GetPar(g3W_V2,Vs);                {sec.voltage}
        if (Vp > 0) and (Vs > 0) then
          Rp := apu+apv*Vp*Vp/(Vs*Vs) else Rp := apu;
        pComp^.GetPar(g3W_X1,Xp);                {prim-sec. reactance}
        pComp^.GetPar(g3W_zpp12,apu);            {Z0/Z1}
        Rz := apu*Rp;
        Xz := apu*Xp;
      end else if (w3pair = 13) then begin       {use 1-3 impedance}
        pComp^.GetPar(g3W_R1,apu);               {resistance of prim.winding}
        pComp^.GetPar(g3W_R3,apv);               {resistance of tert.winding}
        pComp^.GetPar(g3W_V1,Vp);                {prim.voltage}
        pComp^.GetPar(g3W_V3,Vt);                {tert.voltage}
        if (Vp > 0) and (Vt > 0) then
          Rp := apu+apv*Vp*Vp/(Vt*Vt) else Rp := apu;
        pComp^.GetPar(g3W_X3,Xp);                {prim-tert. impedance}
        {for zero seq. impedance, must check YYY or YYD trafo, and....?}
        pComp^.GetPar(g3W_type,apu);
        if (apu = 2) then begin                  {YYD-trafo, large Z0, (for simplicity?)}
          Rz := 1e6;
          Xz := 1e6;
        end else begin                           {YYY-trafo}
          pComp^.GetPar(g3W_zpp13,apu);          {Z0/Z1}
          Rz := apu*Rp;
          Xz := apu*Xp;
        end;
      end else if (w3pair = 23) then begin       {use 2-3 impedance}
        pComp^.GetPar(g3W_R2,apu);               {resistance of sec.winding}
        pComp^.GetPar(g3W_R3,apv);               {resistance of tert.winding}
        pComp^.GetPar(g3W_V2,Vs);                {sec.voltage}
        pComp^.GetPar(g3W_V3,Vt);                {tert.voltage}
        if (Vs > 0) and (Vt > 0) then
          Rp := apu+apv*Vs*Vs/(Vt*Vt) else Rp := apu;
        pComp^.GetPar(g3W_X2,Xp);                {sec-tert. impedance}
        {for zero seq. impedance, must check YYY or YYD trafo, and....?}
        pComp^.GetPar(g3W_type,apu);
        if (apu = 2) then begin                  {YYD-trafo, large Z0, (for simplicity?)}
          Rz := 1e6;
          Xz := 1e6;
        end else begin                           {YYY-trafo}
          pComp^.GetPar(g3W_zpp23,apu);          {Z0/Z1}
          Rz := apu*Rp;
          Xz := apu*Xp;
        end;
      end else begin                             {error, do nothing}
        {...}
      end;
    end else begin
      pComp^.GetPar(gTrafo_R1,Rp);  Rp := Rp/npr;
      pComp^.GetPar(gTrafo_X ,Xp);  Xp := Xp/npr;
      if (name = gTrafoYY) then begin
        pComp^.GetPar(gTrafo_R0,Rz); Rz := Rz/npr;
        pComp^.GetPar(gTrafo_X0,Xz); Xz := Xz/npr;
      end else if (name = gTrafoYD) {or (name = gTrafoDY)} then begin
        {for YD (and DY?) must check, is the zero seq. impedance used = fault is
         assumed to be on the Y-side, or is infinite Z0-impedance used =
         fault is assumed to be on the D-side. For DY-trafo, the impedance should
         (perhaps) be transformed to the sec. side, if finite impedance is used..?}
        if (FiniteNotInfinite) then begin
          pComp^.GetPar(gTrafo_R0,Rz); Rz := Rz/npr;
          pComp^.GetPar(gTrafo_X0,Xz); Xz := Xz/npr;
        end else begin
          Rz := 1e6;
          Xz := 1e6;
        end;
      end else if (name = gTrafoDY) then begin  {very large also for DY, ?}
        Rz := 1e6;
        Xz := 1e6;
      end else if (name = gTrafoDD) then begin
        Rz := 1e6;
        Xz := 1e6;
      end else begin
        Rz := 1e6;
        Xz := 1e6;
      end;
    end;
    Sp := 0;
    km := 1;                                    {1, because multiplier}
  end else begin                                {transmission line}
    pComp^.GetPar(gTrLiS_R,Rp);  Rp := Rp/npr;
    pComp^.GetPar(gTrLiS_X,Xp);  Xp := Xp/npr;
    pComp^.GetPar(gTrLiS_R0,Rz); Rz := Rz/npr;
    pComp^.GetPar(gTrLiS_X0,Xz); Xz := Xz/npr;
    pComp^.GetPar(gTrLiS_S,Sp);  Sp := Sp*npr;
    pComp^.GetPar(gTrLiS_len,km);
  end;
  Vnom := V1;                                    {nominal voltage level}
  {if adding, add component to list, else remove; Update sums}
  if (AddButton.down) then begin
    {a component can be added only once!}
    if (CList.IndexOf(pComp) < 0) then begin     {not found in the list}
      CList.add(pComp);
      ParamToLog;                                {show parameters in the log}
      UpdateSums('add');
    end else begin                               {show warning}
      ClickLabel.visible := false;
      LineImg.visible := false;
      TrafoImg.visible := false;
      MultiLabel.visible := false;
      WarnBut.visible := true;
    end;
  end else if (SubButton.down) then begin
    {when subtracting, remove from list, if it is there}
    ic := CList.IndexOf(pComp);    {index in the list}
    if (ic >= 0) then begin
      ParamToLog;                  {show parameters in the log}
      CList.delete(ic);
      CList.pack;                  {pack = remove empty items}
      UpdateSums('sub');           {subtract the contribution of this comp.}
    end else begin
      {not in the list, do nothing}
    end;
  end;
end;

procedure TImpedCalcForm.ParamToLog;
{write the parameters to log}
var
  line : string;
  txt  : string;  {temporary}
begin
  {write param to log}
  {check and adjust the label}
  SetLabelLength(Clabel,line,10);
  EngFormat5(Rp,txt,false);                 {in routines.pas}
  line := line+txt;
  EngFormat5(Xp,txt,false);
  line := line+txt;
  EngFormat5(Rz,txt,false);
  line := line+txt;
  EngFormat5(Xz,txt,false);
  line := line+txt;
  EngFormat5(Sp,txt,false);
  line := line+txt;
  EngFormat5(km,txt,false);
  line := line+txt;
  {add parameters to log}
  if (LogEdit.visible) then begin
    ImpedCalcForm.show;        {must show the form, and ....}
    ActiveControl := LogEdit;  {...set edit to active, so that the last row is shown!?}
  end;
  LogEdit.lines.add(line);
  SelLen := length(line);

end;

procedure TImpedCalcForm.PutLabel(lbl: string);
{copy label to local}
begin
  Clabel := lbl;
end;

procedure TImpedCalcForm.SetLabelLength(inlbl: string; var utlbl: string; nc : integer);
{set the length of a string to given value: add spaces, or chop
 inlbl   string to be adjusted
 utlbl   the adjusted string
 nc      number of char}
var
  ii  : integer;
  len : integer;   {length of the string}
begin
  if (nc > 0) then begin
    len := length(inlbl);
    if (len < nc) then begin    {too short, add spaces to front}
      utlbl := '';
      for ii := 1 to nc-len do utlbl := utlbl+' ';
      utlbl := utlbl+inlbl;
    end else if (len = nc) then begin
      utlbl := inlbl;
    end else begin              {too long, chop off}
      utlbl := '';
      for ii := 1 to nc do utlbl := utlbl+inlbl[ii];
    end;
  end else begin
    utlbl := inlbl;
  end;
end;

procedure TImpedCalcForm.GetParam(var R1,X1,R0,X0,Ss,len: single);
{copy the sum of parameters of tr.line (to a tr.line)
 called in SendTrLineData of Skemproc.pas}
begin
  if (Sumkm > 0) then begin
    R1 := SumRp/Sumkm;
    X1 := SumXp/Sumkm;
    R0 := SumRz/Sumkm;
    X0 := SumXz/Sumkm;
    Ss := SumSp/Sumkm;
    len := Sumkm;
  end else begin
    R1 := 0;
    X1 := 0;
    R0 := 0;
    X0 := 0;
    Ss := 0;
    len := 0;
  end;
end;

procedure DisplayImped(pR1Ed,pX1Ed,pR0Ed,pX0Ed,pBEd,pZ1Ed,pZ0Ed,pLenEd,pk0rEd,pk0pEd: TpEdit;
                       Rp,Xp,Rz,Xz,Bp,len: single; lentxt: string);
{display R,X, etc in the edit boxes
 pR1Ed,... pointers to the edit-components
 R1,...    the values to be displayed
 lentxt    text to be written at the length-edit}
var
  apu,apv : single;   {temporary}
  cpu,cpv : complex;  {temporary}
  f0,f1   : single;   {phase angle}
  k0      : complex;  {(Z0-Z1)/3Z1, for distance relay}
  txt,txx : string;   {temporary}
  txy,txz : string;   {temporary}
  Z1,Z0   : single;   {impedance}
begin
  EngFormat5(Rp,txt,true);               {in routines.pas}
  pR1Ed^.text := 'R = '+txt;
  EngFormat5(Xp,txt,true);               {in routines.pas}
  pX1Ed^.text := 'X = '+txt;
  EngFormat5(Rz,txt,true);               {in routines.pas}
  pR0Ed^.text := 'R0 = '+txt;
  EngFormat5(Xz,txt,true);               {in routines.pas}
  pX0Ed^.text := 'X0 = '+txt;
  EngFormat5(Bp,txt,true);               {in routines.pas}
  pBEd^.text := 'B = '+txt;
  EngFormat5(len,txt,true);               {in routines.pas}
  pLenEd^.text := lentxt+' length = '+txt+' km';
  {display impedances also in polar form}
  Z1 := Cabs(cplx(Rp,Xp));
  f1 := Cangle(cplx(Rp,Xp));
  Z0 := Cabs(cplx(Rz,Xz));
  f0 := Cangle(cplx(Rz,Xz));
  EngFormat5(Z1,txt,true);
  EngFormat5(f1*180/pi,txx,true);
  EngFormat5(Z0,txy,true);
  EngFormat5(f0*180/pi,txz,true);
  pZ1Ed^.text := '|Z| = '+txt+'  '+'ذ= '+txx;
  pZ0Ed^.text := '|Z0| = '+txy+'  '+'0= '+txz;
  {display the k0 in rect. and polar forms}
  cpu := cplx(Rp,Xp);    {pos.seq. impedance }
  cpv := cplx(Rz,Xz);    {zero seq.impedance}
  if (cpu.x <> 0) and (cpu.y <> 0) then
    k0 := Cdiv(Csub(cpv,cpu),Crmult(3,cpu))
  else                   {cannot divide by zero}
    k0 := cplx(0,0);     {just some value?}
  {display in rect.form}
  EngFormat5(k0.x,txt,true);               {in routines.pas}
  EngFormat5(k0.y,txx,true);
  if (k0.y >= 0) then txx := '+'+txx;      {in routines.pas}
  pk0rEd^.text := 'k0 = '+txt+txx+'j';
  {display in polar form}
  apu := Cabs(k0);
  apv := Cangle(k0);
  EngFormat5(apu,txt,true);
  EngFormat5(apv*180/pi,txx,true);
  pk0pEd^.text := '|k0| = '+txt+'  '+'ذ= '+txx;
end;

procedure TImpedCalcForm.UpdateSums(oper: string);
{add or subtract the new tr.line to/from the sum
 oper  if 'add' then add, if 'sub' then subtract}
var
  f1,f0   : single;   {phase}
  sgn     : single;   {sign, + or -}
  trf     : single;   {multiplier for transforming impedance to Vref}
  txt,txx : string;   {temporary}
  txy,txz : string;
  Z1,Z0   : single;   {magnitude}
begin
  {if also transformers, must transform impedances to reference voltage level}
  if (TrafoRadioBut.checked) then begin
    {reference voltage level taken from the first component}
    {Vnom, Rp, etc have been read in PutComp (this unit) called by SendTrLineData
     inSkemproc.pas (for transmission lines), by ShowCompPhasors in CompPhas.pas
     (for 2-w transformers), and .. (for 3-w transformers)}
    if (SumRp+SumXp+SumRz+SumXz+SumSp+Sumkm = 0) then Vref := Vnom;
    if (Vref > 0) and (Vnom > 0) then trf := Vref*Vref/(Vnom*Vnom)
    else trf := 1;
  end else begin
    trf := 1;
  end;
  if (km > 0) then begin
    if (oper = 'add') then sgn := 1 else sgn := -1;
    SumRp := SumRp+sgn*km*Rp*trf;
    SumXp := SumXp+sgn*km*Xp*trf;
    SumRz := SumRz+sgn*km*RZ*trf;
    SumXz := SumXz+sgn*km*Xz*trf;
    SumSp := SumSp+sgn*km*Sp;    {not needed, if transformers..}
    Sumkm := Sumkm+sgn*km;       {..but included, for simplicity}
    {display}
    DisplayImped(@R1Edit,@X1Edit,@R0Edit,@X0Edit,@BEdit,@Z1Edit,@Z0Edit,@LengthEdit,
                 @k0riEdit,@k0mpEdit,SumRp,SumXp,SumRz,SumXz,SumSp,Sumkm,'Total');
    {change text color in the log, if subtraction}
    if (oper = 'sub') then begin
      LogEdit.SelStart := SelRow;              {start of selected text}
      LogEdit.SelLength := SelLen;             {length of selected text}
      LogEdit.SelAttributes.color := clRed;
      LogEdit.SelLength := 0;                  {remove selection = highlighting}
    end;
    SelRow := SelRow+SelLen+2;                 {update start position of next line}
  end;
end;

procedure TImpedCalcForm.DisplayFractions(iLine: integer; s1 : single);
{display the sum of resistance, reactance etc of the lines up to the
 line giving the desired fraction of total resistance or reactance, or...
 iline   index of last line included
 s1      the fraction of the last line included}
var
  apu,apv : single;   {temporary}
  ii      : integer;  {index}
  len     : single;   {length of one line}
  lenf    : single;   {length fraction}
  pComp   : TpComp;   {pointer to components}
  Sf      : single;   {susceptance fraction}
  Z1f,Z0f : complex;  {impedance fraction}
begin
  lenf := 0;
  Sf := 0;
  Z1f := cplx(0,0);
  Z0f := cplx(0,0);
  if (iLine >= 0) and (CList.count > 0) then begin
    for ii := 0 to iLine do begin
      pComp := CList.items[ii];              {pointer to a line}
      {not for transformers}
      if (isTrafo(pComp)) then begin
        Z1f := cplx(0,0);
        Z0f := cplx(0,0);
        Sf := 0;
        lenf := 0;
      end else begin
        {get length, adjust, if only fraction}
        pComp^.GetPar(gTrLiS_len,len);         {length of line}
        if (ii = iLine) then len := len*s1;    {fraction of this line}
        {positive seq. impedance}
        pComp^.GetPar(gTrLiS_R,apu);
        pComp^.GetPar(gTrLiS_X,apv);
        Z1f.x := Z1f.x+len*apu;
        Z1f.y := Z1f.y+len*apv;
        {zero seq. impedance}
        pComp^.GetPar(gTrLiS_R0,apu);
        pComp^.GetPar(gTrLiS_X0,apv);
        Z0f.x := Z0f.x+len*apu;
        Z0f.y := Z0f.y+len*apv;
        {susceptance}
        pComp^.GetPar(gTrLiS_S,apu);
        Sf := Sf+len*apu;
        {length}
        lenf := lenf+len;
      end;
    end;
    {display the impedances (but not for trafos)}
    DisplayImped(@R1fEdit,@X1fEdit,@R0fEdit,@X0fEdit,@BfEdit,@Z1fEdit,@Z0fEdit,@LenfEdit,
                 @k0rifEdit,@k0mpfEdit,Z1f.x,Z1f.y,Z0f.x,Z0f.y,Sf,lenf,'Partial');
  end else begin
    {no lines, or error in idex}
  end;
end;

//procedure TImpedCalcForm.PutSecOrTert(SecNot3: boolean);
//{put the value of flag for using 1-2 or 1-3 impedance in 3w-trafos
// true = use 1-2 impedance, fale = use 1-3 impedance}
//begin
// SecNotTert := SecNot3;
//end;

procedure TImpedCalcForm.Putw3pair(w3p: integer);
{put the value of flag for using 1-2 or 1-3 or 2-3 impedance in 3w-trafos
 12 = use 1-2 impedance, 13 = use 1-3 impedance, 23 = use 2-3 impedance}
begin
  if (w3p = 12) or (w3p = 13) or (w3p = 23) then
    w3pair := w3p
  else
    w3pair := 12;       {error case, just some value}
end;


procedure TImpedCalcForm.PutFiniteNotInfinite(FiNotInf: boolean);
{put the flag for using the given, finite zero seq. impedance for YD or DY transformers,
 not an (almost) infinite value
 true = use finite impedance, false = use infinite impedance}
begin
  FiniteNotInfinite := FiNotInf;
end;   

procedure TImpedCalcForm.UpdateFraction(movedgr: boolean);
{calculate which factor of which line gives the desired total fraction of R,X,...
 of the sum
 movedgr  if true, move diagram so that the "selected" line is in the middle}
const
  {first parameter}
  ParIndex1 : array[0..7] of integer =
              (gTrLiS_R,  gTrLiS_X,  gTrLiS_R, gTrLiS_R0,
               gTrLiS_X0, gTrLiS_R0, gTrLiS_S, gTrLiS_len);
  {second parameter, needed only for impedances}
  ParIndex2 : array[0..7] of integer =
              (-1,  -1,  gTrLiS_X, -1, -1, gTrLiS_X0, -1, -1);
var
  aa,bb,cc    : single;    {coefficients}
  apu,apv,apw : single;    {temporary}
  cpu,cpv     : complex;   {temporry}
  csum        : complex;   {sum of parameters*length, as complex (formally)}
  cx,cy       : integer;   {coordinates of the center of the diagram}
  dx,dy       : integer;   {distance to move to the center}
  err         : integer;   {error flag}
  highli      : boolean;   {filtered components highlighted}
  ii,jj       : integer;   {index}
  ipar1,ipar2 : integer;   {parameter indices}
  ipu         : integer;   {temporary}
  ix,iy       : integer;   {coordinates}
  fra         : single;    {fraction}
  lbl         : string;    {label}
  len         : single;    {length}
  lenfra      : single;    {fraction of length = output}
  ll          : longint;   {temporary}
  moved       : boolean;   {component really moved}
  npr         : single;    {number of parallel lines}
  par         : complex;   {parameter*length of one component}
  par1,par2   : single;    {parameter (/length)}
  parfra      : single;    {parameter*fraction of the sum}
  parsum      : single;    {sum of parameters*length}
  pComp       : TpComp;    {pointer to a line}
  pSet        : TpCompSet; {pointer to the common}
  s1,s2,s3,s4 : string;    {temporary}
  txt         : string;    {temporary}
begin
  txt := FactorEdit.text;
  {get the fraction}
  ValuesFromLine(txt, 1, false, ipu, fra, apu, apv, apw, s1,s2,s3,s4,err);
  if (err = 0) then begin                    {parameter found}
    if (fra >= 0) and (fra <= 1) then begin  {reasonable value}
      {determine, which variable considered}
      ii := VarComBox.ItemIndex ;          {index of the selected variable}
      ipar1 := ParIndex1[ii];              {index of the parameter}
      ipar2 := ParIndex2[ii];              {second index, only for impedances}
      {find the corresponding parameter sum}
      if      (ipar1 = gTrLiS_R)   then apu := SumRp
      else if (ipar1 = gTrLiS_X)   then apu := SumXp
      else if (ipar1 = gTrLiS_R0)  then apu := SumRz
      else if (ipar1 = gTrLiS_X0)  then apu := SumXz
      else if (ipar1 = gTrLiS_S)   then apu := SumSp
      else if (ipar1 = gTrLiS_len) then apu := Sumkm
      else apu := 0;
      {for impedances need second variable}
      if      (ipar2 = gTrLiS_X)   then apv := SumXp
      else if (ipar2 = gTrLiS_X0)  then apv := SumXz
      else apv := -1;
      {given fraction of the sum of parameters, differently for impedances}
      if (apu >= 0) and (apv >= 0) then parfra := fra*sqrt(apu*apu+apv*apv)
      else parfra := fra*apu;
      {scan components, get parameters, sum, until fraction reached}
      if (CList.count > 0) then begin      {components selected}
        csum := cplx(0,0);                 {initialize}
        for jj := 0 to CList.count-1 do begin
          pComp := CList.items[jj];
          pComp^.GetPar(gTrLiS_paral,npr);    {number of parallel lines}
          if (npr <= 0) then npr := 1;
          pComp^.GetPar(gTrLiS_len,len);      {length of the line}
          if (ipar1 <> gTrLiS_len) then begin
            pComp^.GetPar(ipar1,par1);        {first parameter}
            if (ipar1 <> gTrLiS_S) then par1 := par1/npr
            else par1 := par1*npr;            {parallel lines}
          end else begin
            par1 := 1;                        {for length}
          end;
          if (ipar2 > 0) then begin
            pComp^.GetPar(ipar2,par2);     {second parameter, if needed}
            par2 := par2/npr;              {parallel lines}
          end else begin
            par2 := 0;                     {only one needed for the other par.}
          end;
          {sum, multiply with length, unless par is length}
          par := Crmult(len,cplx(par1,par2));
          csum := Cadd(par,csum);
          parsum := Cabs(csum);            {magnitude}
          {fraction of the sum reached? Compare with parfra}
          if (parsum >= parfra) then begin
            pComp^.GetLabel(lbl,ix,iy);    {label of the component at the fraction}
            if (ipar2 < 0) then begin      {scalar(R,X, or length), not impedance}
              apu := parsum-parfra;
              if (par.x > 0) and (len > 0) then lenfra := 1-apu/(par1*len)
              else lenfra := 0;
            end else begin                 {complex = impedance}
              aa := Cabs(par)*Cabs(par);
              cpu := Cmult(csum,Conj(par));
              bb := 2*cpu.x;
              cc := Cabs(csum)*Cabs(csum)-parfra*parfra;
              if (aa <> 0) then begin
                apu := bb*bb-4*aa*cc;
                if (apu > 0) then begin
                  apv := (-bb+sqrt(apu))/(2*aa);
                  lenfra := 1+apv;
                end else begin
                  lenfra := 0;
                end;
              end else begin
                if (bb <> 0) then begin
                  apu := -cc/bb;
                  lenfra := 1-apu;
                end else begin
                  lenfra := 0;
                end;
              end;
            end;
            {show the result}
            LabelEdit.text := lbl;           {show the label of the component}
            txt := format('%7.5f',[lenfra]);
            ResultEdit.text := txt;
            DisplayFractions(jj,lenfra);     {display R,X, etc up to s1 of line jj}
            {move the diagram so that the selected line is in the middle}
            if (movedgr) then begin
              pComp^.GetipSet(ll);
              pSet := TpCompSet(ll);           {pointer to the common}
              cx := imagoo.width div 2;        {coordinates of the center of the schema}
              cy := (imagoo.height div 2)-32;
              dx := cx-pComp.left;             {distance to center, in x-direction}
              dy := cy-pComp.top;
              pSet^.CompListMove(pSet^.pCompList,dx,dy, false, highli, moved);
              if (moved) then begin  {save for undo}
                pSet^.move_ddx := dx;
                pSet^.move_ddy := dy;
                pSet^.SaveForUndo(MoveAll);
              end;
              {mark the component}
              Imagoo.square.left := pComp^.left;
              Imagoo.square.top := pComp^.top;
              Imagoo.square.visible := true;
              imagoo.invalidate;               {paint the form}
            end;  
            break;                           {solution found, stop}
          end;
        end;
      end;
      FactorEdit.color := clWhite;
    end else begin                           {too small or too large}
      FactorEdit.color := clYellow;          {give warning}
      Imagoo.square.visible := false;
    end;
  end else begin                             {some error in parameter value}
    FactorEdit.color := clYellow;
    Imagoo.square.visible := false;
  end;

end;

procedure TImpedCalcForm.FormCreate(Sender: TObject);
var
  ii : integer;
begin
  {initialize sums}
  SumRp  := 0;
  SumXp  := 0;
  SumRz  := 0;
  SumXz  := 0;
  SumSp  := 0;
  Sumkm  := 0;
  Vref := 1;
  Vnom := 1;
  Clabel := '';
  LogEdit.lines.clear;
  LogEdit.lines.add(LogCaption);
  LogEdit.font.size := 7;
  SelRow := length(LogCaption)+2;   {2 = CR + LF}
  LogButClick(nil);                {initially, hide the log edit}
  CList := TList.Create;
  {initialize item index for calculation of the R or X or.. fraction}
  for ii := 0 to VarComBox.DropDownCount-1 do begin
    if (VarComBox.Items[ii] = VarComBox.text) then begin
      VarComBox.itemindex := ii;
      break;
    end;
  end;
  {hide the help-texts initially}
  ImpedCalcForm.height := HelpBut.top+HelpBut.height+28;
  {add flag that form created}
  Imagoo.ReadyEdit.text := Imagoo.ReadyEdit.text+'i';
  {save positions of icons}
  linex := LineImg.left;
  liney := LineImg.top;
  trafox := TrafoImg.left;
  trafoy := TrafoImg.top;
  {prepare the warning button}
  WarnBut.caption := 'A component only once! (OK)';
  WarnBut.width := 170;
  WarnBut.left := ClickLabel.left;
  WarnBut.top := ClickLabel.top;
  {position the form}
  left := imagoo.width-width;
  top := imagoo.top+32;
  w3pair := 12;
  FiniteNotInfinite := true;
end;

procedure TImpedCalcForm.ResetButClick(Sender: TObject);
{clear sums}
begin
  SumRp := 0;
  SumXp := 0;
  SumRz := 0;
  SumXz := 0;
  SumSp := 0;
  Sumkm := 0;
  R1Edit.text := 'R = 0';
  X1Edit.text := 'X = 0';
  R0Edit.text := 'R0 = 0';
  X0Edit.text := 'X0 = 0';
  BEdit.text := 'B = 0';
  LengthEdit.text := 'Total length = 0';
  Z1Edit.text := '|Z| = 0';
  Z0Edit.text := '|Z0| = 0';
  k0riEdit.text := 'k0 = 0';
  k0mpEdit.text := 'k0 = 0';
  LogEdit.clear;
  LogEdit.lines.add(LogCaption);
  SelRow := length(LogCaption)+2;   {2 = CR + LF}
  CList.clear;
  {clear also the analyze sheet}
  ResetAButClick(nil);
end;

procedure TImpedCalcForm.CloseButClick(Sender: TObject);
begin
  ImpedCalcForm.visible := false;
end;

procedure TImpedCalcForm.LogButClick(Sender: TObject);
{show/hide the edit for logging data}
begin
  if (LogBut.down) then begin
    LogEdit.visible := true;
    ImpedCalcForm.width := ImpedCalcPage.width+LogEdit.width+16;
  end else begin
    LogEdit.visible := false;
    ImpedCalcForm.width := ImpedCalcPage.width+8;
  end;
end;

procedure TImpedCalcForm.FormDestroy(Sender: TObject);
begin
  CList.clear;
  CList.free;
end;

procedure TImpedCalcForm.ImpedCalcPageChange(Sender: TObject);
{find the tr.line and the fraction giving the total fraction}
begin
  if (ImpedCalcPage.ActivePage = AnalyzeSheet) then begin
    UpdateFraction(false);        {update, but do not move diagram}
  end;
  AddButton.down := false;
  SubButton.down := false;
  CopyButton.down := false;
end;

procedure TImpedCalcForm.CalcButClick(Sender: TObject);
begin
  UpdateFraction(true);           {update and move diagram}
end;

procedure TImpedCalcForm.HelpButClick(Sender: TObject);
{show the help-texts}
begin
  if (LineRadioBut.checked) then begin      {summing tr.lines}
    if (not HelpPanel.visible) then begin
      TrHelpPanel.visible := false;         {hide the other help, just to be sure}
      ImpedCalcForm.height := HelpPanel.top+HelpPanel.height+28;
      HelpPanel.visible := true;
//  end else begin
//    ImpedCalcForm.height := HelpBut.top+HelpBut.height+28;
//    HelpPanel.visible := false;
    end;
  end else begin                            {summing tr.lines and transformers}
    if (not TrHelpPanel.visible) then begin
      HelpPanel.visible := false;           {hide the other help. just to be sure}
      ImpedCalcForm.height := HelpPanel.top+HelpPanel.height+28;
      TrHelpPanel.left := HelpPanel.left;
      TrHelpPanel.visible := true;
//  end else begin
//    ImpedCalcForm.height := HelpBut.top+HelpBut.height+28;
//    TrHelpPanel.visible := false;
    end;

  end;
end;

procedure TImpedCalcForm.XButtonClick(Sender: TObject);
begin
//HelpButClick(nil);
  ImpedCalcForm.height := HelpBut.top+HelpBut.height+28;
  HelpPanel.visible := false;
  TrHelpPanel.visible := false;
end;

procedure TImpedCalcForm.ResetAButClick(Sender: TObject);
begin
  R1fEdit.text := 'R = 0';
  X1fEdit.text := 'X = 0';
  R0fEdit.text := 'R0 = 0';
  X0fEdit.text := 'X0 = 0';
  BfEdit.text := 'B = 0';
  LenfEdit.text := 'Partial length = 0';
  Z1fEdit.text := '|Z| = 0';
  Z0fEdit.text := '|Z0| = 0';
  ResultEdit.text := '0';
  LabelEdit.text := '....';
  k0rifEdit.text := 'k0 = 0';
  k0mpfEdit.text := 'k0 = 0';
  Imagoo.square.visible := false;
end;

procedure TImpedCalcForm.TrafoRadioButClick(Sender: TObject);
{replace line image with trafo image}
begin
//TrafoImg.left := Linex;
//TrafoImg.top := Liney;
//LineImg.left := Trafox;
//LineImg.top := Trafoy;
  TrafoImg.visible := true;
//LineImg.visible := false;
  ImpedCalcPage.ActivePage := SumSheet;
  {hide items related to lines}
  AnalyzeSheet.TabVisible := false;
  LengthEdit.visible := false;
  BEdit.visible := false;
  PerOhmLabel.visible := false;
  k0riEdit.visible := false;
  k0mpEdit.visible := false;
  CopyButton.visible := false;
  {show the "correct" help memo}
  if (HelpPanel.visible) then HelpButClick(sender);
end;

procedure TImpedCalcForm.LineRadioButClick(Sender: TObject);
begin
//TrafoImg.left := Trafox;
//TrafoImg.top := Trafoy;
//LineImg.left := Linex;
//LineImg.top := Liney;
  TrafoImg.visible := false;
//LineImg.visible := true;
  {show items related to lines}
  AnalyzeSheet.TabVisible := true;
  LengthEdit.visible := true;
  BEdit.visible := true;
  PerOhmLabel.visible := true;
  k0riEdit.visible := true;
  k0mpEdit.visible := true;
  CopyButton.visible := true;
  {show the "correct" help-memo}
  if (TrHelpPanel.visible) then HelpButClick(sender);
end;

procedure TImpedCalcForm.WarnButClick(Sender: TObject);
begin
  ClickLabel.visible := true;
  LineImg.visible := true;
  TrafoImg.visible := true;
  MultiLabel.visible := true;
  WarnBut.visible := false;
end;

procedure TImpedCalcForm.FormHide(Sender: TObject);
{find the tr.line and the fraction giving the total fraction}
begin
  if (ImpedCalcPage.ActivePage = AnalyzeSheet) then begin
    UpdateFraction(false);        {update, but do not move diagram}
  end;
  AddButton.down := false;
  SubButton.down := false;
  CopyButton.down := false;

end;

procedure TImpedCalcForm.TrXButtonClick(Sender: TObject);
begin
  XButtonClick(Sender);
end;

end.
