unit Mxedit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, Menus, StdCtrls,utildef, Buttons, ExtCtrls, Matrix, UAlnEdit,ShellApi;

const
  mVect = 6;               {number of vectors}
  mMatrString = 25;        {dimension of array for saving matrices - 1}
  LightViolet = $00FF80FF; {color of the coefficient boxes}
  LightViolet2 = $00FFA0FF;
  LightViolet3 = $00FFC0FF;
  LightViolet4 = $00FFE0FF;
  LightGreen   = $00CCFFCC;
type
  TMatrStrArr  = array[0..mMatrString] of string;   {for saving matrices}
  TpMatrStrArr = ^TMatrStrArr;
  TIndex6 = array[1..6] of integer;
const
  ColIndex : TIndex6 = (0,2,3,5,6,8);  {indices of matrix columns in use (not the angle symbol)}
type
  TMxEditForm = class(TForm)
    VxGrid: TStringGrid;
    VyGrid: TStringGrid;
    VzGrid: TStringGrid;
    VuGrid: TStringGrid;
    VvGrid: TStringGrid;
    VwGrid: TStringGrid;
    MxedMenu: TMainMenu;
    FileMenu: TMenuItem;
    ExitItem: TMenuItem;
    VectorItem: TMenuItem;
    VeditLabel: TLabel;
    VeditGrid: TStringGrid;
    VectorBox: TComboBox;
    StoreBut: TSpeedButton;
    RadioButU: TRadioButton;
    RadioButV: TRadioButton;
    RadioButW: TRadioButton;
    RadioButX: TRadioButton;
    RadioButY: TRadioButton;
    RadioButZ: TRadioButton;
    Topshape: TShape;
    SaveBox: TComboBox;
    SaveBut: TSpeedButton;
    LastOperImg: TImage;
    RaMult1: TLabel;
    RaMult2: TLabel;
    RaLab1: TLabel;
    RaLab2: TLabel;
    RaLine: TShape;
    RaLab3: TLabel;
    RaLab4: TLabel;
    RaLab5: TLabel;
    RaLab6: TLabel;
    RaCalcBut: TSpeedButton;
    RaEdit11: TAlignEdit;
    RaEdit12: TAlignEdit;
    RaEdit21: TAlignEdit;
    RaEdit22: TAlignEdit;
    RaResEdit: TAlignEdit;
    CheckGrid: TStringGrid;
    FillBut: TButton;
    UndoBut: TSpeedButton;
    NegBut: TSpeedButton;
    ConjBut: TSpeedButton;
    CheckButA: TButton;
    DelVectBut: TSpeedButton;
    DelScalBut: TSpeedButton;
    MatrGrid: TStringGrid;
    StoreEdit: TEdit;
    StoreMatrBut: TButton;
    DelMatrBut: TSpeedButton;
    MatrixBox: TComboBox;
    ErrEdit: TEdit;
    RecallBut: TButton;
    RcMult1: TLabel;
    RcMult2: TLabel;
    RgLab1: TLabel;
    RgLab2: TLabel;
    RcLine: TShape;
    RgLab3: TLabel;
    RgEdit11: TAlignEdit;
    RgEdit12: TAlignEdit;
    RgEdit21: TAlignEdit;
    RgEdit22: TAlignEdit;
    DelMatBut: TButton;
    StoreOKbut: TSpeedButton;
    PhasorBut: TSpeedButton;
    ViewMenu: TMenuItem;
    PhasorItem: TMenuItem;
    SaveItem: TMenuItem;
    OpenItem: TMenuItem;
    LineItem: TMenuItem;
    SaveFormDlg: TSaveDialog;
    ExportFormItem: TMenuItem;
    NumberItem: TMenuItem;
    DelMatScalBut: TSpeedButton;
    NotesItem: TMenuItem;
    ButtonItem: TMenuItem;
    HelpItem: TMenuItem;
    HelpTopics: TMenuItem;
{   procedure ClearEditVector;}
{   procedure CopyToEdit;}
    procedure ShowSelectedVector(iv: integer);
    procedure ClearMatrix;
    procedure ConstrMatrices;
    { - - }
    procedure FormCreate(Sender: TObject);
    procedure ExitItemClick(Sender: TObject);
    procedure VectorItemClick(Sender: TObject);
    procedure FormHide(Sender: TObject);
    procedure VxGridDrawCell(Sender: TObject; Col, Row: Longint;
      Rect: TRect; State: TGridDrawState);
    procedure VxGridSelectCell(Sender: TObject; Col, Row: Longint;
      var CanSelect: Boolean);
    procedure VeditGridDrawCell(Sender: TObject; Col, Row: Longint;
      Rect: TRect; State: TGridDrawState);
    procedure VeditGridSelectCell(Sender: TObject; Col, Row: Longint;
      var CanSelect: Boolean);
    procedure VyGridSelectCell(Sender: TObject; Col, Row: Longint;
      var CanSelect: Boolean);
    procedure VzGridSelectCell(Sender: TObject; Col, Row: Longint;
      var CanSelect: Boolean);
    procedure VuGridSelectCell(Sender: TObject; Col, Row: Longint;
      var CanSelect: Boolean);
    procedure VvGridSelectCell(Sender: TObject; Col, Row: Longint;
      var CanSelect: Boolean);
    procedure VwGridSelectCell(Sender: TObject; Col, Row: Longint;
      var CanSelect: Boolean);
    procedure VyGridDrawCell(Sender: TObject; Col, Row: Longint;
      Rect: TRect; State: TGridDrawState);
    procedure VzGridDrawCell(Sender: TObject; Col, Row: Longint;
      Rect: TRect; State: TGridDrawState);
    procedure VuGridDrawCell(Sender: TObject; Col, Row: Longint;
      Rect: TRect; State: TGridDrawState);
    procedure VvGridDrawCell(Sender: TObject; Col, Row: Longint;
      Rect: TRect; State: TGridDrawState);
    procedure VwGridDrawCell(Sender: TObject; Col, Row: Longint;
      Rect: TRect; State: TGridDrawState);
    procedure VectorBoxClick(Sender: TObject);
    procedure StoreButClick(Sender: TObject);
    procedure RadioButUClick(Sender: TObject);
    procedure RadioButVClick(Sender: TObject);
    procedure RadioButWClick(Sender: TObject);
    procedure RadioButXClick(Sender: TObject);
    procedure RadioButYClick(Sender: TObject);
    procedure RadioButZClick(Sender: TObject);
    procedure SaveButClick(Sender: TObject);
    procedure FillButClick(Sender: TObject);
    procedure UndoButClick(Sender: TObject);
    procedure RaCalcButClick(Sender: TObject);
    procedure NegButClick(Sender: TObject);
    procedure ConjButClick(Sender: TObject);
    procedure CheckButAMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure CheckButAMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure DelVectButClick(Sender: TObject);
    procedure DelScalButClick(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure MatrGridDrawCell(Sender: TObject; Col, Row: Longint;
      Rect: TRect; State: TGridDrawState);
    procedure MatrGridSelectCell(Sender: TObject; Col, Row: Longint;
      var CanSelect: Boolean);
    procedure FormDestroy(Sender: TObject);
    procedure StoreEditEnter(Sender: TObject);
    procedure StoreEditExit(Sender: TObject);
    procedure StoreMatrButClick(Sender: TObject);
    procedure DelMatrButClick(Sender: TObject);
    procedure MatrGridKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure RecallButClick(Sender: TObject);
    procedure MatrixBoxClick(Sender: TObject);
    procedure DelMatButClick(Sender: TObject);
    procedure StoreOKbutClick(Sender: TObject);
    procedure RgEdit11KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure RgEdit12KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure RgEdit21KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure RgEdit22KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure PhasorButClick(Sender: TObject);
    procedure PhasorItemClick(Sender: TObject);
    procedure SaveItemClick(Sender: TObject);
    procedure OpenItemClick(Sender: TObject);
    procedure ExportFormItemClick(Sender: TObject);
    procedure NumberItemClick(Sender: TObject);
    procedure DelMatScalButClick(Sender: TObject);
    procedure NotesItemClick(Sender: TObject);
    procedure ButtonItemClick(Sender: TObject);
    procedure HelpTopicsClick(Sender: TObject);
  private
    { Private declarations }
    Vx_top      : integer;     {position of the visible vector}
    Vx_left     : integer;
    Combo_index : integer;     {index selected in the vector combo box (for saving)}
    Matr_Undo   : TMatrStrArr; {for saving a deleted matrix for undo}
{   procedure CreateParams(var Params: TCreateParams); override;}
  public
    { Public declarations }
    Matr_List  : TList;                     {list of pointers to the matrices}
    Fix_Div    : array[0..12] of string;    {the divisors of the fixed matrices}
    pFix_Matr  : array[0..12] of TpM3x3;    {array of pointers to the fixed matrices}
    Rx_text    : array[1..mVect] of char;   {index of the coefficient}
    Vx_text    : array[1..mVect] of string; {captions of the vectors}
    Vx_color   : array[1..mVect] of Tcolor; {colors of the captions}
  end;

var
  MxEditForm : TMxEditForm;
  Mx_Calc    : TMatrCalc;    {for calculations with the vectors and matrices}

implementation

uses phasor, numbers, Notes;

var
  Vect_lbl : array[1..nVect] of string;

{uses matrix;}

{$R *.DFM}
(*
procedure TMxEditForm.CreateParams(var Params: TCreateParams);
{this is needed in order to keep forms always on top
 (fsStayOnTop does not work, when two or more forms)}
begin
  inherited CreateParams(Params);
  with Params do begin
    ExStyle := ExStyle or WS_EX_TOPMOST;
    WndParent := GetDesktopwindow;
  end;
end;
*)

procedure TMxEditForm.FormCreate(Sender: TObject);
var
  ExeFile  : string;       {name of this *.exe file, without the extension}
  ExeName  : string;       {name of this *.exe-file, with the extension}
  FileName : string;       {name of .ini file}
  ii       : integer;
  IniFile  : TextFile;     {initialization file}
  ipu      : integer;
  line     : string;       {one line from the *.ini file}
  pArr     : TpMatrStrArr; {temporary pointer for saving the matrix}
begin
  {same size and position as the main form}
  height := MatrForm.height;
  left := MatrForm.left;
  top := MatrForm.top;
  {position of the visible vector}
  Vx_top  := VxGrid.top;              {position of the visible vector}
  Vx_left := VxGrid.left;
  {initialize the captions for the edit vector}
  Vx_text[1] := '[Vu]';
  Vx_text[2] := '[Vv]';
  Vx_text[3] := '[Vw]';
  Vx_text[4] := '[Vx]';
  Vx_text[5] := '[Vy]';
  Vx_text[6] := '[Vz]';
  {initialize the subscript of the coefficient}
  Rx_text[1] := 'u';
  Rx_text[2] := 'v';
  Rx_text[3] := 'w';
  Rx_text[4] := 'x';
  Rx_text[5] := 'y';
  Rx_text[6] := 'z';
  {initialize colors of the caption of hte edit vector}
  Vx_color[1] := clBlue;
  Vx_color[2] := clFuchsia;
  Vx_color[3] := clWhite;
  Vx_color[4] := clGreen;
  Vx_color[5] := clYellow;
  Vx_color[6] := clTeal;
  {labels of vectors, for phasors}
  Vect_lbl[1] := 'Vu';
  Vect_lbl[2] := 'Vv';
  Vect_lbl[3] := 'Vw';
  Vect_lbl[4] := 'Vx';
  Vect_lbl[5] := 'Vy';
  Vect_lbl[6] := 'Vz';
  {initialize pointers to vectors in this unit for operations in the main unit}
  Matr_Calc.PutpMgrid(@VuGrid, @VvGrid, @VwGrid, @VxGrid, @VyGrid, @VzGrid);
  {define and initialize the object for calculations etc in this sheet - - - - - -}
  Mx_calc := TMatrCalc.create;   {creatr object for operations}
  Mx_Calc.initialize(@LastOperImg);
  Mx_Calc.SetSheet(matr);        {define sheet type}
  {pointers of the coefficients to the arrays, the same coefficients for all ??}
  Mx_Calc.PutR11(@RaEdit11,@RaEdit11,@RaEdit11,@RaEdit11,@RaEdit11,@RgEdit11);
  Mx_Calc.PutR12(@RaEdit12,@RaEdit12,@RaEdit12,@RaEdit12,@RaEdit12,@RgEdit12);
  Mx_Calc.PutR21(@RaEdit21,@RaEdit21,@RaEdit21,@RaEdit21,@RaEdit21,@RgEdit21);
  Mx_Calc.PutR22(@RaEdit22,@RaEdit22,@RaEdit22,@RaEdit22,@RaEdit22,@RgEdit22);
  Mx_Calc.PutRes(@RaResEdit,@RaResEdit,@RaResEdit,@RaResEdit,@RaResEdit,@RaResEdit);
  Mx_Calc.PutpGrid(@VuGrid,@VvGrid,@VwGrid,@VxGrid,@VyGrid,@VzGrid,@CheckGrid);
  Mx_Calc.PutpMatr(@MatrGrid);
  Mx_Calc.PutForm(@MxEditForm);
  Mx_Calc.PutpErrEd(@ErrEdit);  
  {initialize pointers to vectors in the main unit for operations in this unit}
  Mx_Calc.PutpMgrid(@MatrForm.VaGrid, @MatrForm.VbGrid, @MatrForm.VcGrid,
                    @MatrForm.VdGrid, @MatrForm.VeGrid, @MatrForm.VfGrid);
  {pointers to vectors in matrix edit form done in Mxedit.pas}
  Mx_Calc.PutAddEdit(nil{@AddAngleEdit});  {not needed}
  Mx_Calc.ClearAll;                        {clear initially}
  { }
  Combo_index := 1;  {just some value ??, a proper initialization needed?}
  {initialize radio-index of the vectors}
  if      (RadioButU.checked) then ipu := 1
  else if (RadioButV.checked) then ipu := 2
  else if (RadioButW.checked) then ipu := 3
  else if (RadioButX.checked) then ipu := 4
  else if (RadioButY.checked) then ipu := 5
  else if (RadioButZ.checked) then ipu := 6
  else begin  {no button checked}
    RadioButU.checked := true;
    ipu := 1;
  end;
  Mx_Calc.PutVectIndex(ipu);
  {set texts and colors accordingly}
  VeditLabel.caption := Vx_text[ipu];
{ VeditLabel.color := Vx_color[ipu];}
  {colors}
//RadioButU.color := Vx_color[1];
//RadioButV.color := Vx_color[2];
//RadioButW.color := Vx_color[3];
//RadioButX.color := Vx_color[4];
//RadioButY.color := Vx_color[5];
//RadioButZ.color := Vx_color[6];
  RaEdit11.color := LightViolet3;
  RaEdit12.color := LightViolet3;
  RaEdit21.color := LightViolet3;
  RaEdit22.color := LightViolet3;
  RaResEdit.color := LightViolet4;
  RgEdit11.color := LightGreen;
  RgEdit12.color := LightGreen;
  RgEdit21.color := LightGreen;
  RgEdit22.color := LightGreen;
  {list of pointers for saving of the matrices}
  Matr_List := TList.create;
  {initialize the matrix}
  ClearMatrix;
  {construct pointers to the fixed matrices}
  ConstrMatrices;
  RecallButClick(sender);      {initialize to matrix M0}
  {read the saved matrices, if they exist - - - - - - - - - }
  {find the name of the *.ini-file}
  ExeName := ExtractFileName(paramStr(0));
  ExeFile := ChangeFileExt(ExeName, '');   {remove the extension}
  FileName := ExtractFilePath(paramStr(0)) + ExeFile+'.ini';
  {open it, if it exists}
  if FileExists(FileName) then begin
    AssignFile(IniFile,FileName);
    Reset(IniFile);                      {open the file}
    try
      {read the matrices, if any}
      while not(EOF(IniFile)) do begin
        readln(IniFile,line);
        if (line = '!') then begin    {there are matrices}
          new(pArr);                  {create array for the matrix}
          readln(IniFile,line);       {read the name of the matrix}
          pArr^[0] := line;
          MatrixBox.items.add(line);  {add name to the list (menu) of names}
          for ii := 1 to high(pArr^) do begin
            readln(IniFile,line);
            pArr^[ii] := line;
          end;
          Matr_List.add(pArr);        {add pointer to list of pointers}
        end else if (line = '#') then begin   {initial directories}
          readln(IniFile,line);
          MatrForm.SaveFormDlg.InitialDir := line;
          readln(IniFile,line);
          MxEditForm.SaveFormDlg.InitialDir := line;
          readln(IniFile,line);
          MatrForm.NumbersInitialDir := line;  {save temporarily, move later to dialog}
          readln(IniFile,line);
          MatrForm.PhasorsInitialDir := line;
          readln(IniFile,line);
          MatrForm.NotesInitialDir := line;          
        end;
      end;
    finally
      CloseFile(IniFile);
    end;
    MatrForm.SelectMatrBox.items := MatrixBox.items;  {copy the matrix menu}
  end;
end;

procedure TMxEditForm.ClearMatrix;
var
  ii,jj,kk : integer;
begin
  for ii := 0 to 2 do begin
    for jj := 1 to 6 do begin
      kk := ColIndex[jj];          {excludes columns with the angle symbol}
      MatrGrid.cells[kk,ii] := '0';
    end;
  end;
end;

procedure TMxEditForm.ExitItemClick(Sender: TObject);
begin
  MatrForm.close; {carries out FormClose, terminates application}
end;

procedure TMxEditForm.VectorItemClick(Sender: TObject);
{hide this matrix form, show the vector form}
begin
  {save and clear phasor display, to give space for phasors in the matrix sheet}
  Mx_Calc.SavePhasors;
  CurrGrid.RemoveAllPhasors;         {initially, clear all phasors}
  SeqGrid.RemoveAllPhasors;
  CurrPhasorForm.visible := false;
  {hide this matrix sheet}
  MxEditForm.visible := false;
  {matr form visible in the same position as this}
  MatrForm.top := top;
  MatrForm.left := left;
  MatrForm.visible := true;
  {restore the phasors of the vector sheet}
  Matr_Calc.RestorePhasors;
end;

procedure TMxEditForm.FormHide(Sender: TObject);
begin
  {when this form hides, the main form must become visible..}
  MatrForm.visible := true;
  {..and be in the same position as this}
  MatrForm.top := top;
  MatrForm.left := left;
end;

procedure TMxEditForm.VxGridDrawCell(Sender: TObject; Col, Row: Longint;
  Rect: TRect; State: TGridDrawState);
begin
  MatrForm.DrawCell(@VxGrid, Col, Row, Rect, State);
end;

procedure TMxEditForm.VxGridSelectCell(Sender: TObject; Col, Row: Longint;
  var CanSelect: Boolean);
begin
  MatrForm.SelectCell(@VxGrid, Col, Row, CanSelect);
end;

procedure TMxEditForm.VeditGridDrawCell(Sender: TObject; Col, Row: Longint;
  Rect: TRect; State: TGridDrawState);
{draw the symbol of an angle}
begin
  if (col = 1) then begin     {middle column}
    CheckGrid.canvas.font.size := 10;
    CheckGrid.canvas.font.name := 'symbol';
    CheckGrid.canvas.TextOut(rect.left,rect.top,' ');
  end;
end;

procedure TMxEditForm.VeditGridSelectCell(Sender: TObject; Col,
  Row: Longint; var CanSelect: Boolean);
begin
//  MatrForm.SelectCell(@VeditGrid, Col, Row, CanSelect);
end;

procedure TMxEditForm.VyGridSelectCell(Sender: TObject; Col, Row: Longint;
  var CanSelect: Boolean);
begin
  MatrForm.SelectCell(@VyGrid, Col, Row, CanSelect);
end;

procedure TMxEditForm.VzGridSelectCell(Sender: TObject; Col, Row: Longint;
  var CanSelect: Boolean);
begin
  MatrForm.SelectCell(@VzGrid, Col, Row, CanSelect);
end;

procedure TMxEditForm.VuGridSelectCell(Sender: TObject; Col, Row: Longint;
  var CanSelect: Boolean);
begin
  MatrForm.SelectCell(@VuGrid, Col, Row, CanSelect);
end;

procedure TMxEditForm.VvGridSelectCell(Sender: TObject; Col, Row: Longint;
  var CanSelect: Boolean);
begin
  MatrForm.SelectCell(@VvGrid, Col, Row, CanSelect);
end;

procedure TMxEditForm.VwGridSelectCell(Sender: TObject; Col, Row: Longint;
  var CanSelect: Boolean);
begin
  MatrForm.SelectCell(@VwGrid, Col, Row, CanSelect);
end;

procedure TMxEditForm.VyGridDrawCell(Sender: TObject; Col, Row: Longint;
  Rect: TRect; State: TGridDrawState);
begin
  MatrForm.DrawCell(@VyGrid, Col, Row, Rect, State);
end;

procedure TMxEditForm.VzGridDrawCell(Sender: TObject; Col, Row: Longint;
  Rect: TRect; State: TGridDrawState);
begin
  MatrForm.DrawCell(@VzGrid, Col, Row, Rect, State);
end;

procedure TMxEditForm.VuGridDrawCell(Sender: TObject; Col, Row: Longint;
  Rect: TRect; State: TGridDrawState);
begin
  MatrForm.DrawCell(@VuGrid, Col, Row, Rect, State);
end;

procedure TMxEditForm.VvGridDrawCell(Sender: TObject; Col, Row: Longint;
  Rect: TRect; State: TGridDrawState);
begin
  MatrForm.DrawCell(@VvGrid, Col, Row, Rect, State);
end;

procedure TMxEditForm.VwGridDrawCell(Sender: TObject; Col, Row: Longint;
  Rect: TRect; State: TGridDrawState);
begin
  MatrForm.DrawCell(@VwGrid, Col, Row, Rect, State);
end;

procedure TMxEditForm.VectorBoxClick(Sender: TObject);
{copy the selected vector to the edit vector}
var
  abc   : char;     {one character defining the vector}
  ii,jj : integer;  {indixes}
  ll    : longint;  {temporary}
begin
  abc := VectorBox.text[3];     {the third char. identifies the vector}
  ll := ord(abc)-116;           {index of the vector, 1..6}
  if (ll > 0) and (ll <= mVect) then begin  {reasonable index}
    ii := ll;
//    {copy the vector to the edit vector} {not so, after all?}
//    for jj := 0 to 2 do begin
//      VeditGrid.cells[0,jj] := pVx_grid[ii]^.cells[0,jj];
//      VeditGrid.cells[2,jj] := pVx_grid[ii]^.cells[2,jj];
//    end;
//    {change the caption and color accordingly }
//    VeditLabel.caption := Vx_text[ii];
//    VeditLabel.color := Vx_color[ii];
//    StoreBut.font.color := Vx_color[ii];
    Combo_Index := ii;          {save the index}
  end;
end;

procedure TMxEditForm.StoreButClick(Sender: TObject);
{save the edit vector to the vector indicated in the combo box}
var
  ii,jj : integer;
begin
//  if (Combo_Index > 0) and (Combo_Index <= mVect) then begin
//    ii := Combo_Index;
//    for jj := 0 to 2 do begin
//      pVx_grid[ii]^.cells[0,jj] := VeditGrid.cells[0,jj];
//      pVx_grid[ii]^.cells[2,jj] := VeditGrid.cells[2,jj];
//    end;
//  end;
end;
(*
procedure TMxEditForm.CopyToEdit;
{copy the selected vector to the edit vector}
var
  ii,jj : integer;
begin
  if (rx_vect > 0) and (rx_vect <= mVect) then begin
    ii := rx_vect;
    for jj := 0 to 2 do begin
      VeditGrid.cells[0,jj] := pVx_grid[ii]^.cells[0,jj];
      VeditGrid.cells[2,jj] := pVx_grid[ii]^.cells[2,jj];
    end;
    {change the caption and color accordingly }
    VeditLabel.caption := Vx_text[ii];
    VeditLabel.color := Vx_color[ii];
  end;
end;
*)
procedure TMxEditForm.ShowSelectedVector(iv: integer);
{move the selected vector to the middle, and make it visible
 iv  index of the vector}
begin
  if (iv > 0) and (iv <= mVect) then begin
    Mx_Calc.HideVector;                     {hide the present vector}
    {update index, move and show the new selected vector}
    Mx_Calc.MoveAndShowVector(iv,Vx_left,Vx_top);
(*
    pVx_grid[rx_vect]^.visible := false;    {hide the present vector}
    rx_vect := iv;                          {update index of visible vector}
    pVx_grid[rx_vect]^.top := Vx_top;       {move to the middle (may already be there?)}
    pVx_grid[rx_vect]^.left := Vx_left;
    pVx_grid[rx_vect]^.visible := true;     {show the new vector}
*)
    VeditLabel.caption := Vx_text[iv];      {caption = identifier of the vector}
//  VeditLabel.color := Vx_color[iv];       {color = color of the vector}
    RaLab2.caption := Rx_text[iv];          {subxript of the coefficient}
    RaLab5.caption := Rx_text[iv];          {subxript of the coefficient}
  end;
end;

procedure TMxEditForm.RadioButUClick(Sender: TObject);
begin
  ShowSelectedVector(1);
{ rx_Vect := 1;  {update index of selected vector}
{ CopyToEdit;    {copy the selected vector to the edit vector}
end;

procedure TMxEditForm.RadioButVClick(Sender: TObject);
begin
  ShowSelectedVector(2);
{ rx_Vect := 2;  {update index of selected vector}
{ CopyToEdit;    {copy the selected vector to the edit vector}
end;

procedure TMxEditForm.RadioButWClick(Sender: TObject);
begin
  ShowSelectedVector(3);
{ rx_Vect := 3;  {update index of selected vector}
{ CopyToEdit;    {copy the selected vector to the edit vector}
end;

procedure TMxEditForm.RadioButXClick(Sender: TObject);
begin
  ShowSelectedVector(4);
{ rx_Vect := 4;  {update index of selected vector}
{ CopyToEdit;    {copy the selected vector to the edit vector}
end;

procedure TMxEditForm.RadioButYClick(Sender: TObject);
begin
  ShowSelectedVector(5);
{ rx_Vect := 5;  {update index of selected vector}
{ CopyToEdit;    {copy the selected vector to the edit vector}
end;

procedure TMxEditForm.RadioButZClick(Sender: TObject);
begin
  ShowSelectedVector(6);
{ rx_Vect := 6;  {update index of selected vector}
{ CopyToEdit;    {copy the selected vector to the edit vector}
end;

procedure TMxEditForm.SaveButClick(Sender: TObject);
{copy the selected vector to the vector indicated by the SaveBox}
var
  abc   : char;         {identifying character}
  err   : integer;      {error flag}
begin
  abc := SaveBox.text[3]; {the third char. identifies the vector}
  Mx_Calc.SaveButClick(abc, SaveBut, err);
  if (err = 0) then begin
  MatrForm.UpdatePhasors;
//  if (CurrPhasorForm.visible) then CurrPhasorForm.BringToFront;
  end;
end;

procedure TMxEditForm.FillButClick(Sender: TObject);
{fill all fields with some values}
var
  ii,jj : integer;
begin
  Mx_calc.SaveState;                {save for undo}
  {scalars first}
  RaEdit11.text := '11';
  RaEdit12.text := '22';
  RaEdit21.text := '33';
  RaEdit22.text := '44';
  RaResEdit.text := '55';
  {then the vectors}
  for ii := 1 to mVect do begin
      Mx_Calc.PutVect(ii,inttostr(ii*10),inttostr(ii*10+2),inttostr(ii*10+3),
                        inttostr(ii*20),inttostr(ii*20+124),inttostr(ii*20+246));
  end;
  MatrForm.UpdatePhasors;
  if (CurrPhasorForm.visible) then CurrPhasorForm.BringToFront;  
end;

procedure TMxEditForm.UndoButClick(Sender: TObject);
{"undo" the previous operation}
var
  ii    : integer;
  ix,iy : integer;      {thought position of the image for the last operation}
  pArr  : TpMatrStrArr; {temporary pointer for saving the matrix}
begin
  {first, check, was a matrix deleted with the DelMatBut-button, with the caption "delete"
   next to the drop down menu for matrices(not the DelMatrBut, with the caption "Matrix X".
   Compare position and dimensions of the delete button}
  ix:= DelMatBut.left-marg;    {for the delte button, get...}
  iy := DelMatBut.top-marg;    {..position of the image marking the last operation}
  if (ix = LastOperImg.left) and (iy = LastOperImg.top) then begin
    {matrix deleted last, try to recover it}
    new(pArr);                          {create array for the matrix}
    MatrixBox.items.add(Matr_Undo[0]);  {add name to the list (menu) of names}
    for ii := 0 to high(pArr^) do begin
      pArr^[ii] := Matr_Undo[ii];
    end;
    Matr_List.add(pArr);                             {add pointer to list of pointers}
    MatrForm.SelectMatrBox.items := MatrixBox.items; {copy the matrix menu}
  end else begin
    {no deleted matrix, some other operation}
    Mx_Calc.UndoLastOper;
  end;
  Mx_Calc.BeforeLastOper;   {mark the operation before the last operation}
  MatrForm.UpdatePhasors;
//if (CurrPhasorForm.visible) then CurrPhasorForm.BringToFront;
end;

procedure TMxEditForm.RaCalcButClick(Sender: TObject);
{calculate the coefficient r., and multiply the selected vector V. with it}
var
  err  : boolean;
  indx : integer;
begin
  Mx_Calc.GetVectIndex(indx);
  Mx_Calc.CalcButClick(@raEdit11,@raEdit12,@raEdit21,@raEdit22,@raResEdit,indx,err);
  if (not err) then begin
    Mx_Calc.MarkLastOperation(RaCalcBut.Left,RaCalcBut.Top,RaCalcBut.Width,RaCalcBut.Height);
    MatrForm.UpdatePhasors;
    if (CurrPhasorForm.visible) then CurrPhasorForm.BringToFront;
  end;
end;

procedure TMxEditForm.NegButClick(Sender: TObject);
{change the sign of the selected vector}
begin
  Mx_Calc.NegButClick(NegBut);
  MatrForm.UpdatePhasors;
  if (CurrPhasorForm.visible) then CurrPhasorForm.BringToFront;
end;

procedure TMxEditForm.ConjButClick(Sender: TObject);
{calculate the complex conjugate of the selected vector}
begin
  Mx_Calc.ConjButClick(ConjBut);
  MatrForm.UpdatePhasors;
  if (CurrPhasorForm.visible) then CurrPhasorForm.BringToFront;
end;

procedure TMxEditForm.CheckButAMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  CheckGrid.visible := true;
  CheckGrid.BringToFront;
end;

procedure TMxEditForm.CheckButAMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  CheckGrid.visible := false;
end;

procedure TMxEditForm.DelVectButClick(Sender: TObject);
{clear the selected vector}
var
  ii : integer;  {index}
begin
  Mx_calc.SaveState;                {save for undo}
  Mx_Calc.ClearVect;                {clear the selected vector}
  Mx_Calc.MarkLastOperation(DelVectBut.Left,DelVectBut.Top,DelVectBut.Width,DelVectBut.Height);
  MatrForm.UpdatePhasors;
//if (CurrPhasorForm.visible) then CurrPhasorForm.BringToFront;

end;

procedure TMxEditForm.DelScalButClick(Sender: TObject);
begin
  Mx_calc.SaveState;                {save for undo}
  Mx_Calc.ClearScalar;              {clear the coeff. of the selected vector}
  Mx_Calc.MarkLastOperation(DelScalBut.Left,DelScalBut.Top,DelScalBut.Width,DelScalBut.Height);
end;

procedure TMxEditForm.FormKeyPress(Sender: TObject; var Key: Char);
{allow only numbers (and some other char's)}
begin
  MatrForm.FormKeyPress(Sender, Key);
  {hide the error indicator (if visible)}
  ErrEdit.visible := false;
  ErrEdit.left := 0;
  ErrEdit.top := 0;  
end;

procedure TMxEditForm.MatrGridDrawCell(Sender: TObject; Col, Row: Longint;
  Rect: TRect; State: TGridDrawState);
{draw the angle symbol in the narrow columns}
begin
  if (col = 1) or (col = 4) or (col = 7) then begin     {small column}
    MatrGrid.canvas.font.size := 10;
    MatrGrid.canvas.font.name := 'symbol';
    MatrGrid.canvas.TextOut(rect.left,rect.top,' ');   {the symbol of an angle}
  end else if (col = 2) or (col = 5) then begin
    {thick, dark lines between the columns}
    MatrGrid.canvas.pen.color := clBlack;
    MatrGrid.canvas.pen.width := 2;
    MatrGrid.canvas.moveto(rect.right,rect.top);
    MatrGrid.canvas.lineto(rect.right,rect.bottom);
  end;
end;

procedure TMxEditForm.MatrGridSelectCell(Sender: TObject; Col,
  Row: Longint; var CanSelect: Boolean);
{the small columns (with the angle symbol) cannot be edited}
begin
  {the small columns (with the angle symbol) cannot be edited}
  if (col = 1) or (col = 4) or (col = 7) then begin
    MatrGrid.options := MatrGrid.options-[goEditing,goAlwaysShowEditor];
  end else begin
    MatrGrid.options := MatrGrid.options+[goEditing,goAlwaysShowEditor];
  end;
end;

procedure TMxEditForm.FormDestroy(Sender: TObject);
var
  ii : integer;
begin
{ ShellExecute(Handle, 'open', 'c:\imago\imagopro.exe', nil, nil, SW_SHOWNORMAL) ;}
  {free the memory from the saved matrices}
  if (Matr_List.count > 0) then begin
    for ii := 0 to Matr_List.count-1 do begin
      if (Matr_List.items[ii] <> nil) then dispose(Matr_List.items[ii]);
    end;
  end;
  MxEditForm.Matr_List.free;
end;

procedure TMxEditForm.StoreEditEnter(Sender: TObject);
{no key-preview when entering name of the matrix}
begin
  KeyPreview := false;
end;

procedure TMxEditForm.StoreEditExit(Sender: TObject);
{reset key preview, for entering numbers}
begin
  KeyPreview := true;
end;

procedure TMxEditForm.StoreMatrButClick(Sender: TObject);
const
  pmxarr : TpMatrStrArr = nil;  {pointer to array for saving the matrix}
  m_ind  : integer = 1;         {index for matrices without names}
var
  apu,apv   : double;    {temporary}
  apw,apx   : double;    {temporary}
  canadd    : boolean;   {matrix can be stored by adding}
  caninsert : boolean;   {matrix can be stored by inserting}
  er1,er2   : integer;   {error flags}
  er3,er4   : integer;   {error flags}
  err       : integer;   {error flag}
  ertot     : integer;   {total error flag}
  ia        : integer;   {index in the array for storing}
  ierr      : integer;   {index of the error}
  i1,j1     : integer;   {indices}
  ii,jj,kk  : integer;   {indices}
  iinsert   : integer;   {index for inserting}
  ipu,ipv   : integer;   {temporary}
  len       : integer;   {length of text}
  pArr      : TpMatrStrArr; {temporary pointer for saving the matrix}
  r11,r12   : double;    {multipliers}
  r21,r22   : double;    {divisors}
  sp        : boolean;   {name contains only spaces}
  txt       : string;    {temporary}
begin
  {check the entries of the matrix before storing}
  err := 0;
  for ii := 0 to 2 do begin
    for jj := 1 to 6 do begin
      kk := ColIndex[jj];                  {excludes columns with the angle symbol}
      txt := MatrGrid.cells[kk,ii];
      if (txt <> '') then begin            {empty is taken as zero}
        Mx_Calc.ValuesFromLine(txt, 1, ipu, apu, apv, apw, apx, err,ierr);
        if (err <> 0) then begin
          {calculate position of the erroneous cell}
          ipu := MatrGrid.left;
          if (jj > 1) then begin
            for i1 := 0 to kk-1 do ipu := ipu+MatrGrid.ColWidths[i1]+MatrGrid.GridLineWidth;
          end;
          {indicate the error with a colored line}
          {(Use TEdit, because bringtofront does not work for images or shapes over a grid !?)}
          ErrEdit.left := ipu;
          ErrEdit.top := MatrGrid.top+(ii+1)*(MatrGrid.defaultrowheight+MatrGrid.GridLineWidth)-2;
          ErrEdit.width := MatrGrid.ColWidths[kk];
          ErrEdit.visible := true;
          ErrEdit.BringToFront;
          break;
        end;
      end;
    end;
    if (ErrEdit.visible) then break;
  end;
  {check also the multipliers and divisors}
  Mx_Calc.CoeffFromEdit(@RgEdit11,@RgEdit12,@RgEdit21,@RgEdit22,
                        r11, r12, r21, r22, er1, er2, er3, er4);
  {mark edits with errors}
  if (er1 <> 0) then RgEdit11.color := clYellow else RgEdit11.color := LightGreen;
  if (er2 <> 0) then RgEdit12.color := clYellow else RgEdit12.color := LightGreen;
  if (er3 <> 0) then RgEdit21.color := clYellow else RgEdit21.color := LightGreen;
  if (er4 <> 0) then RgEdit22.color := clYellow else RgEdit22.color := LightGreen;
  {continue only, if no errors}
  ertot := err+er1+er2+er3+er4;   {total error}
  {add only, if no errors}
  if (ertot = 0) then begin
    {check name of the matrix}
    len := length(StoreEdit.text);
    sp := true;                   {initialize}
    if (len > 0) then begin
      for ii := 1 to len do begin
        if (StoreEdit.text[ii] <> ' ') then begin  {a non-space character found}
          sp := false;
          break;
        end;
      end;
    end;
    {if no label, or only spaces, generate a name}
    if (len = 0) or (sp) then begin
      inc(m_ind);
      StoreEdit.text := '[A'+inttostr(m_ind)+']';
    end;
    {check, does the matrix name already exist}
    if (Matr_List.count > 0) then begin
      for ii := 0 to Matr_List.count-1 do begin
        pArr := Matr_List.items[ii];     {pointer to a saved matrix}
        {check label of the matrix}
        if (pArr[0] = StoreEdit.text) then begin
          canadd := false;                 {cannot add with the same name}
          if MessageDlg(StoreEdit.text+' exists, overwrite?',
                        mtWarning, [mbYes, mbNo], 0) = mrYes then
            caninsert := true
          else
            caninsert := false;
          iinsert := ii;                 {save index}
          break;                         {one same label suffices}
        end else begin
          canadd := true;
        end;
      end;
    end else begin                       {empty list, so far}
      canadd := true;
      caninsert := false;
    end;
    {continue, if adding or inserting possible}
    if (canadd) or (caninsert) then begin
      {add or insert on an existing matrix}
      if (canadd) then new(pmxarr)            {create array. It is disposed (of) in FormDestroy}
      else pmxarr := Matr_List.items[iinsert];  {write over an existing matrix}
      {now, store the nonempty text}
      pmxarr[0] := StoreEdit.text;  {name of the array to the first position}
      {store the matrix, row by row}
      ia := 1;
      for ii := 0 to 2 do begin
        for jj := 1 to 6 do begin
          kk := ColIndex[jj];                  {excludes columns with the angle symbol}
          pmxarr[ia] := MatrGrid.cells[kk,ii];
          inc(ia);
        end;
      end;
      {write the coefficients}
      pmxarr[ia] := RgEdit11.text;
      inc(ia);
      pmxarr[ia] := RgEdit12.text;
      inc(ia);
      pmxarr[ia] := RgEdit21.text;
      inc(ia);
      pmxarr[ia] := RgEdit22.text;
      inc(ia);
      {if adding, add the pointer to the list of matrix pointers}
      if (canadd) then begin
        Matr_List.add(pmxarr);
        {add the name to the drop down menu}
        MatrixBox.items.add(StoreEdit.text);
        {change also the number of items shown, unless large}
        if (MatrixBox.items.count <= 16) then
          MatrixBox.DropDownCount := MatrixBox.items.count
        else
          MatrixBox.DropDownCount := 16;
      end;
      StoreOKbut.visible := true;
    end;
    MatrForm.SelectMatrBox.items := MatrixBox.items;
  end else begin
{   ErrShape.BringToFront;}
  end;
end;

procedure TMxEditForm.DelMatrButClick(Sender: TObject);
begin
  Mx_calc.SaveState;                {save for undo}
  ClearMatrix;
  Mx_Calc.MarkLastOperation(DelMatrBut.Left ,DelMatrBut.Top,
                            DelMatrBut.Width,DelMatrBut.Height);
end;

procedure TMxEditForm.MatrGridKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  {hide the error indicator}
  ErrEdit.visible := false;
  ErrEdit.left := 0;
  ErrEdit.top := 0;
  StoreOKbut.visible := false;
end;

procedure TMxEditForm.RecallButClick(Sender: TObject);
{recall the selected matrix}
var
  dpu      : double;        {temporary}
  ia       : integer;       {index in the array}
  ii,jj,kk : integer;       {indices}
  ip       : integer;       {index of the selected matrix}
  ipu      : integer;       {temporary}
  parr     : TpMatrStrArr;  {pointer to array of a saved matrix}
  pFix     : TpM3x3;        {pointer to one fixed matrix}
begin
  {find the index of the selected matrix}
  ip := MatrixBox.Items.IndexOf(MatrixBox.text);  {from 0 to no of matrices-1}
  if (ip > 12) then begin              {the thirteed first matrices are fixed}
    parr := Matr_list.items[ip-13];    {pointer to the array for storing the matrix}
    {read the saved matrix to the displayed matrix}
    StoreEdit.text := parr[0];         {title, or caption}
    ia := 1;
    for ii := 0 to 2 do begin
      for jj := 1 to 6 do begin
        kk := ColIndex[jj];                  {excludes columns with the angle symbol}
        MatrGrid.cells[kk,ii] := parr[ia];   {read the entries to the matrix}
        inc(ia);
      end;
    end;
    {read the coefficients}
    RgEdit11.text := parr[ia];
    inc(ia);
    RgEdit12.text := parr[ia];
    inc(ia);
    RgEdit21.text := parr[ia];
    inc(ia);
    RgEdit22.text := parr[ia];
    inc(ia);
  end else begin                             {fixed matrices}
    StoreEdit.text := '[M'+inttostr(ip)+'a]';{title, or caption, not exactly the same as the original}
    pFix := pFix_Matr[ip];                   {pointer to the selected fixed matrix}
    for ii := 0 to 2 do begin
      for jj := 0 to 2 do begin
        kk := 3*jj;
        dpu := pFix^[ii*3+jj];
        ipu := round(dpu);
        MatrGrid.cells[kk,ii] := inttostr(ipu); {magnitude}
        MatrGrid.cells[kk+2,ii] := '0';         {angle, always 0}
      end;
    end;
    {the coefficients of the fixed matrices}
    RgEdit11.text := '';
    RgEdit12.text := '1';
    RgEdit21.text := '';
    RgEdit22.text := Fix_Div[ip];   {three, or sqrt(three)}
  end;
end;

procedure TMxEditForm.ConstrMatrices;
{construct pointer to the fixed matrices}
begin
  pFix_Matr[0]  := @m00;
  pFix_Matr[1]  := @m01;
  pFix_Matr[2]  := @m02;
  pFix_Matr[3]  := @m03;
  pFix_Matr[4]  := @m04;
  pFix_Matr[5]  := @m05;
  pFix_Matr[6]  := @m06;
  pFix_Matr[7]  := @m07;
  pFix_Matr[8]  := @m08;
  pFix_Matr[9]  := @m09;
  pFix_Matr[10] := @m10;
  pFix_Matr[11] := @m11;
  pFix_Matr[12] := @m12;
  {the divisors}
  Fix_div[ 0] := '';
  Fix_div[ 1] := '1.732050808';
  Fix_div[ 2] := '3';
  Fix_div[ 3] := '1.732050808';
  Fix_div[ 4] := '3';
  Fix_div[ 5] := '1.732050808';
  Fix_div[ 6] := '3';
  Fix_div[ 7] := '1.732050808';
  Fix_div[ 8] := '3';
  Fix_div[ 9] := '1.732050808';
  Fix_div[10] := '3';
  Fix_div[11] := '1.732050808';
  Fix_div[12] := '3';
end;

procedure TMxEditForm.MatrixBoxClick(Sender: TObject);
begin
  RecallButClick(sender);   {recall the selected matrix}
end;

procedure TMxEditForm.DelMatButClick(Sender: TObject);
{delete the selected matrix, if it is not a fixed matrix}
var
  ii       : integer;       {index}
  ip       : integer;       {index of the selected matrix}
  parr     : TpMatrStrArr;  {pointer to array of a saved matrix}
begin
  {find the index of the selected matrix}
  ip := MatrixBox.Items.IndexOf(MatrixBox.text);  {from 0 to no of matrices-1}
  if (ip > 12) then begin              {the thirteen first matrices are fixed}
    {save for an undo}
    parr := Matr_list.items[ip-13];
    for ii := 0 to high(parr^) do begin
      Matr_Undo[ii] := parr^[ii];
    end;
    Mx_calc.SaveState;                {save for undo}
    {remove the matrix everywhere}
    dispose(Matr_list.items[ip-13]);   {pointer to the array for storing the matrix}
    Matr_list.items[ip-13] := nil;
    Matr_List.pack;
    MatrixBox.Items.delete(ip);
    MatrForm.SelectMatrBox.items := MatrixBox.items;  {copy the matrix menu}
    MatrixBox.text := '[M0]';            {recall the identity matrix}
    RecallButClick(sender);
    Mx_Calc.MarkLastOperation(DelMatBut.Left,DelMatBut.Top,DelMatBut.Width,DelMatBut.Height);    
  end;
end;

procedure TMxEditForm.StoreOKbutClick(Sender: TObject);
begin
  StoreOKbut.visible := false;
end;

procedure TMxEditForm.RgEdit11KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  StoreOKbut.visible := false;
end;

procedure TMxEditForm.RgEdit12KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  StoreOKbut.visible := false;
end;

procedure TMxEditForm.RgEdit21KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  StoreOKbut.visible := false;
end;

procedure TMxEditForm.RgEdit22KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  StoreOKbut.visible := false;
end;

procedure TMxEditForm.PhasorButClick(Sender: TObject);
{add the selected vector to the phasor display}
var
  Curr    : TMultix;    {currents in one variable}
  ertot   : integer;
  rdVect  : integer;    {index of the selected vector}
  era     : array[0..2] of integer;  {error flag for phase angle}
  erm     : array[0..2] of integer;  {error flag for magnitude}
  Vangl   : array[0..2] of double;   {phase angle}
  Vmagn   : array[0..2] of double;   {magnitudes of the vector}
begin
  Mx_Calc.GetVectIndex(rdVect);
  Mx_Calc.CurrToMultix(curr, rdVect, ertot);  {copy currents from vector }
  if (ertot = 0) and (CurrPhasorForm.visible) then begin
    CurrGrid.ShowPhasors(rdVect, cRead, @Curr,Vect_lbl[rdVect]);
    SeqGrid.ShowPhasors(rdVect,cCopy,nil,Vect_lbl[rdVect]);
    CurrPhasorForm.BringToFront;
  end;
  {just to be sure, update all phasors}
  MatrForm.UpdatePhasors;
end;

procedure TMxEditForm.PhasorItemClick(Sender: TObject);
const
  top0 : integer = -1;
var
  dir0,dir1: string;   {initial directories}  
begin
  CurrPhasorForm.visible := not CurrPhasorForm.visible;
  {set initial position}
  if (CurrPhasorForm.visible) and (top0 < 0) then begin
    CurrPhasorForm.top := top;   {same top as the main form}
    top0 := top;
  end;
  {set the initial directory, if not yet done}
  CurrGrid.GetInitDir(dir0,dir1);   {original and present initial directories}
  if (dir0 = dir1) and (MatrForm.PhasorsInitialDir <> '') then
    CurrGrid.PutInitDir(MatrForm.PhasorsInitialDir);
end;

procedure TMxEditForm.SaveItemClick(Sender: TObject);
begin
  MatrForm.SaveItemClick(sender);  {same as in the matrform}
end;

procedure TMxEditForm.OpenItemClick(Sender: TObject);
begin
  MatrForm.OpenItemClick(sender);
end;

procedure TMxEditForm.ExportFormItemClick(Sender: TObject);
begin
  Mx_Calc.SaveSheet(@SaveFormDlg);
end;

procedure TMxEditForm.NumberItemClick(Sender: TObject);
begin
  NumberForm.visible := true;
end;

procedure TMxEditForm.DelMatScalButClick(Sender: TObject);
{delete the coefficients of the matrix}
begin
  Mx_calc.SaveState;                {save for undo}
  RgEdit11.text := '';              {clear the coeff. of the matrix}
  RgEdit12.text := '';
  RgEdit21.text := '';
  RgEdit22.text := '';
  Mx_Calc.MarkLastOperation(DelMatScalBut.Left ,DelMatScalBut.Top,
                            DelMatScalBut.Width,DelMatScalBut.Height);
end;

procedure TMxEditForm.NotesItemClick(Sender: TObject);
begin
  NotesForm.visible := true;
end;

procedure TMxEditForm.ButtonItemClick(Sender: TObject);
begin
  ButtonItem.checked := not ButtonItem.checked;
  FillBut.visible := ButtonItem.checked;
  CheckButA.visible := ButtonItem.checked; 
end;

procedure TMxEditForm.HelpTopicsClick(Sender: TObject);
begin
  Application.HelpCommand(HELP_FINDER, 0);
end;

end.
