unit PQHelp;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, Utildef, Buttons, StdCtrls;

type
  TPQHelpForm = class(TForm)
    Group1Img: TImage;
    Group2Img: TImage;
    Group3Img: TImage;
    Group4Img: TImage;
    Group5Img: TImage;
    Group6Img: TImage;
    Group7Img: TImage;
    Group8Img: TImage;
    Group9Img: TImage;
    Group10Img: TImage;
    Group11Img: TImage;
    Group1But: TSpeedButton;
    Group2But: TSpeedButton;
    Group3But: TSpeedButton;
    Group4But: TSpeedButton;
    Group5But: TSpeedButton;
    Group6But: TSpeedButton;
    Group7But: TSpeedButton;
    Group8But: TSpeedButton;
    Group9But: TSpeedButton;
    Group10But: TSpeedButton;
    Group11But: TSpeedButton;
    RangeEdit: TEdit;
    procedure FormCreate(Sender: TObject);
    procedure Group1ButClick(Sender: TObject);
    procedure Group2ButClick(Sender: TObject);
    procedure Group3ButClick(Sender: TObject);
    procedure Group4ButClick(Sender: TObject);
    procedure Group5ButClick(Sender: TObject);
    procedure Group6ButClick(Sender: TObject);
    procedure Group7ButClick(Sender: TObject);
    procedure Group8ButClick(Sender: TObject);
    procedure Group9ButClick(Sender: TObject);
    procedure Group10ButClick(Sender: TObject);
    procedure Group11ButClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private declarations }
    procedure ShowImage(img : integer);
  public
    { Public declarations }
  end;

var
  PQHelpForm: TPQHelpForm;

implementation

{$R *.DFM}

const
  nImg = 11;  {number of images}
  {ranges of time multipliers of the different relays}
  tmr1  = 'time multiplier (TD) range: 0.01 - 100  ( B in the parameter window)';
  tmr2  = 'time multiplier (TD) range: 0.5 - 100  ( B in the parameter window)';
  tmr3  = 'time multiplier (n) range: 0.5 - 100  ( B in the parameter window)';
  tmr4  = 'multiplier (M) range: 0.01 - 100  ( B in the parameter window)';
  tmr5  = 'multiplier (M) range: 0.01 - 100  ( B in the parameter window)';
  tmr6  = 'time multiplier (TD) range: 0.05 - 100  ( B in the parameter window)';
  tmr7  = 'time multiplier (TD) range: 0.01 - 100  ( B in the parameter window)';
  tmr8  = 'time multiplier (D) range: 0.0 - 100  ( B in the parameter window)';
  tmr9  = 'time multiplier (TM) range: 0.01 - 100  ( B in the parameter window)';
  tmr10 = 'time multiplier (TM) range: 0.01 - 100  ( B in the parameter window)';
  tmr11 = 'time multiplier (Curve_Multiplier) range: 1 - 100  ( B in the parameter window)';

var
  pGroupImg : array[1..nImg] of TpImage;
  pGroupBut : array[1..nImg] of TpSpeedBut;
  tmr : array[1..nImg] of string;

procedure TPQHelpForm.FormCreate(Sender: TObject);
{size and place the images}
var
  ii : integer;
begin
  Group1Img.width := 330;
  Group1Img.height := 328;
  Group2Img.width := 351;
  Group2Img.height := 300;
  Group3Img.width := 418;
  Group3Img.height := 385;
  Group4Img.width := 496;
  Group4Img.height := 317;
  Group5Img.width := 471;
  Group5Img.height := 320;
  Group6Img.width := 526;
  Group6Img.height := 356;
  Group7Img.width := 399;
  Group7Img.height := 330;
  Group8Img.width := 443;
  Group8Img.height := 407;
  Group9Img.width := 417;
  Group9Img.height := 309;
  Group10Img.width := 312;
  Group10Img.height := 280;
  Group11Img.width := 557;
  Group11Img.height := 154;
  {pointers to images}
  pGroupImg[1] := @Group1Img;
  pGroupImg[2] := @Group2Img;
  pGroupImg[3] := @Group3Img;
  pGroupImg[4] := @Group4Img;
  pGroupImg[5] := @Group5Img;
  pGroupImg[6] := @Group6Img;
  pGroupImg[7] := @Group7Img;
  pGroupImg[8] := @Group8Img;
  pGroupImg[9] := @Group9Img;
  pGroupImg[10] := @Group10Img;
  pGroupImg[11] := @Group11Img;
  {pointers to buttons}
  pGroupBut[1] := @Group1But;
  pGroupBut[2] := @Group2But;
  pGroupBut[3] := @Group3But;
  pGroupBut[4] := @Group4But;
  pGroupBut[5] := @Group5But;
  pGroupBut[6] := @Group6But;
  pGroupBut[7] := @Group7But;
  pGroupBut[8] := @Group8But;
  pGroupBut[9] := @Group9But;
  pGroupBut[10] := @Group10But;
  pGroupBut[11] := @Group11But;
  {texts for the multiplier ranges}
  tmr[1] := tmr1;
  tmr[2] := tmr2;
  tmr[3] := tmr3;
  tmr[4] := tmr4;
  tmr[5] := tmr5;
  tmr[6] := tmr6;
  tmr[7] := tmr7;
  tmr[8] := tmr8;
  tmr[9] := tmr9;
  tmr[10] := tmr10;
  tmr[11] := tmr11;
  {put the images to sampe place}
  for ii := 1 to nImg do begin
    pGroupImg[ii]^.left := 96;
    pGroupImg[ii]^.top := 8;
  end;
end;

procedure TPQHelpForm.ShowImage(img : integer);
{display given image
 img  index of the image}
var
  ii : integer;
begin
  for ii := 1 to nImg do begin
    pGroupImg[ii]^.visible := false;
  end;
  refresh;
  pGroupImg[img]^.visible := true;
  RangeEdit.top := pGroupImg[img]^.top+pGroupImg[img]^.height+8;
  RangeEdit.left := pGroupImg[img]^.left;
  RangeEdit.text := tmr[img];
  RangeEdit.visible := (RangeEdit.text <> '');
  ActiveControl := nil;
end;


procedure TPQHelpForm.Group1ButClick(Sender: TObject);
begin
  ShowImage(1);
end;

procedure TPQHelpForm.Group2ButClick(Sender: TObject);
begin
  ShowImage(2);
end;

procedure TPQHelpForm.Group3ButClick(Sender: TObject);
begin
  ShowImage(3);
end;

procedure TPQHelpForm.Group4ButClick(Sender: TObject);
begin
  ShowImage(4);
end;

procedure TPQHelpForm.Group5ButClick(Sender: TObject);
begin
  ShowImage(5);
end;

procedure TPQHelpForm.Group6ButClick(Sender: TObject);
begin
  ShowImage(6);
end;

procedure TPQHelpForm.Group7ButClick(Sender: TObject);
begin
  ShowImage(7);
end;

procedure TPQHelpForm.Group8ButClick(Sender: TObject);
begin
  ShowImage(8);
end;

procedure TPQHelpForm.Group9ButClick(Sender: TObject);
begin
  ShowImage(9);
end;

procedure TPQHelpForm.Group10ButClick(Sender: TObject);
begin
    ShowImage(10);
end;

procedure TPQHelpForm.Group11ButClick(Sender: TObject);
begin
  ShowImage(11);
end;

procedure TPQHelpForm.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
  idown : integer;     {index of the button that is down}
  ii    : integer;     {index}
begin
  {find, which button down}
  idown := -1;
  for ii := 1 to nImg do begin
    if (pGroupBut[ii]^.down) then begin
      idown := ii;
      break;
    end;
  end;
  {press next or previous button down, if enter-key, or up- or down arrow key pressed}
  if (key = 13) or (key = 38) or (key = 40) then begin   {enter, up-, down-arrow}
    if (idown > 0) then begin    {some button was down}
      if (key = 13) or (key = 40) then begin             {enter or down-arrow}
        if (idown < nImg) then begin                     {not the last button}
          pGroupBut[idown+1]^.down := true;
          ShowImage(idown+1);
        end else begin                                   {last button, jump to first}
          pGroupBut[1]^.down := true;
          ShowImage(1);
        end;
      end else if (key = 38) then begin                  {up-arrow}
        if (idown > 1) then begin                        {not the first button}
          pGroupBut[idown-1]^.down := true;
          ShowImage(idown-1);
        end;
      end else begin
        {for other keys, do nothing}
      end;
    end else begin               {no button was down, show first image}
      pGroupBut[1]^.down := true;
      ShowImage(1);
    end;
  end;
end;

end.
