{CharForm pointterilla, ei nimell !?}
unit PQRelay;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, Skemadef, Utildef, Routines, StdCtrls, ExtCtrls, Skemproc, Menus,
  Buttons,Imagodef,Relcurr, Spin, elmech, ReclData, emtp;

procedure PQRelayShow  (ipComp: longint); far; {show parameters and graph }
procedure PQRelayPar   (ipComp: longint); far; {show parameters at creation}
procedure PQRelayHide  (ipComp: longint); far; {hide parameters and graph}
procedure PQParamHide  (ipComp: longint); far; {hide parameters}
procedure SavePQRelay(pPQrel : TpComp);        {save active relay}
{procedure PQRelayHideIf(ipComp: longint; Sender : TObject); {hide parameters and graph,if...}
function  GetActPQ : TpComp;
procedure GetPQText(group, curve : integer; var text : string);  {for the parameter report}
procedure GetEMText(group, curve : integer; var text : string);
function  GetRelayType: string;

type
  TPQForm = class(TForm)
    ValueGrid: TStringGrid;
    OKButton: TButton;
    ImagePanel: TPanel;
    ColorImage: TImage;
    CancelBut: TButton;
    ApplyBut: TButton;
    HintBut: TButton;
    LabelGrid: TStringGrid;
    GroupPanel: TPanel;
    GroupImage: TImage;
    CurvePanel: TPanel;
    CurveImage: TImage;
    PGQmenu: TMainMenu;
    OptionMenu: TMenuItem;
    ColorItem: TMenuItem;
    FileMenu: TMenuItem;
    ExitItem: TMenuItem;
    DescrMemo: TMemo;
    ViewMenu: TMenuItem;
    NotesItem: TMenuItem;
    PlaneMenu: TMenuItem;
    PhaseItem: TMenuItem;
    NegSeqItem: TMenuItem;
    EMGroupImg: TImage;
    EMCurveImg: TImage;
    TimeSpinBut: TSpinButton;
    ParamItem: TMenuItem;
    SaveItem: TMenuItem;
    SaveDlg: TSaveDialog;
    procedure FormCreate(Sender: TObject);
    procedure FormDeactivate(Sender: TObject);
    procedure ValueGridSelectCell(Sender: TObject; Col, Row: Longint;
      var CanSelect: Boolean);
    procedure ValueGridDrawCell(Sender: TObject; Col, Row: Longint;
      Rect: TRect; State: TGridDrawState);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ColorImageMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure OKButtonClick(Sender: TObject);
    procedure CancelButClick(Sender: TObject);
    procedure ApplyButClick(Sender: TObject);
    procedure LabelGridSelectCell(Sender: TObject; Col, Row: Longint;
      var CanSelect: Boolean);
    procedure LabelGridDrawCell(Sender: TObject; Col, Row: Longint;
      Rect: TRect; State: TGridDrawState);
    procedure ValueGridKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure LabelGridKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure HintButClick(Sender: TObject);
    procedure LabelGridEnter(Sender: TObject);
    procedure ValueGridEnter(Sender: TObject);
    procedure GroupImageMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
{!} procedure CurvePanelTexts;
    procedure EMCurveTexts;
    procedure CurveImageMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ValueGridKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ColorItemClick(Sender: TObject);
    procedure ExitItemClick(Sender: TObject);
    procedure NotesItemClick(Sender: TObject);
    procedure DescrMemoMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure PhaseItemClick(Sender: TObject);
    procedure NegSeqItemClick(Sender: TObject);
    procedure GreyOutCells(col1,col2,row1,row2 : integer);
    procedure GetTestRows(var ctrow, ttrow,rcrow : integer);
    procedure FormHide(Sender: TObject);
    procedure ColorInitialize(pImage : TpImage);
    procedure GetCRsize(var CRw,CRs : integer);
    procedure EMGroupImgMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure EMCurveImgMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure TimeSpinButDownClick(Sender: TObject);
    procedure TimeSpinButUpClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ParamItemClick(Sender: TObject);
    procedure SaveItemClick(Sender: TObject);
  private
    { Private declarations }
  public
{    d_p  : char;   {decimal point}
    { Public declarations }
  end;

var
  PQForm: TPQForm;
  d_p  : char;   {decimal point}

type
  TRowIndex = record
  Row51       : integer;
  GroupRow    : integer;
  TimeC1C2Row : integer;   {caption 'C1' or 'C2' (rc) }
  CurveRow    : integer;   {row for curve parameter}
  IssRow      : integer;
  FactRow     : integer;
  MultRow     : integer;
  TimeModRow  : integer;   {caption for time modifier (rc)}
  TimeMultRow : integer;   {time multiplier (rc)}
  TimeAddRow  : integer;   {added time term (rc)}
  TimeMinRow  : integer;   {min.response time (rc)}
  Row50       : integer;
  I1row       : integer;  {row for the current of first def.time relay}
  t1row       : integer;
  I2row       : integer;
  t2row       : integer;
  CommonRow   : integer;
  {15}
  {16}
  Zrow        : integer;  {row for the line impedance}
  fiiRow      : integer;  {row for the angle of line impedance}
  {19}
  {20}
  ColorRow    : integer;  {row for color parameter}
  {22}
  CurrRow     : integer;  {row for the title of the test current}
  CurrTestRow : integer;  {row for the test current}
  TimeTestRow : integer;  {row for the test time}
  RelCurrRow  : integer;  {row for the relative current}
end;

type
  TColIndex = record
  ColP  : integer;
  ColP2 : integer;    {phase column for the "second" relay of a recloser relay}
  ColG  : integer;
  ColG2 : integer;
  ColQ  : integer;
  ColQ2 : integer;
end;

{define an object type for diverse procedures with the string grid containing the parameters}
type
  TpGridCalc = ^TGridCalc;
  TGridCalc = class(TObject)

  procedure initialize(pForm: TpForm; pGrid, pLabel: TpGrid;
                       pDescr : TpMemo;
                       pEMCurve,pPQCurve,pEMGroup,pPQGroup: TpImage;
                       pHiLit,pPhase,pNegSeq,pNtItem : TpMenuItem;
                       pClrPanel, pCrvPanel, pGrpPanel: TpPanel;
                       pTimeSpin: TpSpinBut;
                       pOK,pCancel,pApply,pHint: TpButton;
                       RowInd : TRowIndex;
                       ColInd : TColIndex);
  procedure SetRelayType(RelTyp: string);
  procedure Col0Captions(row: integer; rect: TRect);
  procedure ColPCaptions(row: integer; rect: TRect);
  procedure ColGCaptions(row: integer; rect: TRect);
  procedure ColQCaptions(row: integer; rect: TRect);
  procedure ColorColorCells(col,row: integer; rect: TRect);
  procedure CopyLineImpedance(row: integer; rect: TRect);
  procedure ValueGridSelectCell( Col, Row: Longint);
  procedure FormDeactivate(Sender: TObject);
  procedure ParamToGrid(pComp : TpComp);
  procedure RelayShow(ipComp : longint);
  procedure RelayPar (ipComp: longint);
  procedure RelayHideIf(ipComp : longint; Sender : TObject);
  procedure CheckRelayType(pComp : TpComp);
  procedure RelayHide(ipComp : longint);
  procedure ColorImageMouseUp(X, Y: Integer);
  procedure OKButtonClick(Sender: TObject);
  procedure CancelButClick(Sender: TObject);
  procedure ApplyButClick(Sender: TObject);
  procedure LabelGridSelectCell(Row: Longint);
  procedure ValueGridKeyUp(var Key: Word);
  procedure HintButClick(Sender: TObject);
  function  GetCurveCol: integer;
  procedure GreyOutCells(col1,col2,row1,row2: integer);
  function  GetpAct: TpComp;
  function  GetpGrid: TpGrid;
  function  GetActCol: integer;
  function  GetActRow: integer;
private
  ActCol_c    : integer;      {column of the active cell of value grid}
  ActRow_c    : integer;      {row of the active cell of the value grid}
  LabActRow_c : integer;      {row of the active cell of the label grid}
  pAct_c      : TpComp;       {pointer to the active relay}
  pApply_c    : TpButton;     {pointer to the apply-button}
  pCancel_c   : TpButton;     {pointer to cancel button}
  pDescr_c    : TpMemo;       {pointer to the memo for additional notes}
  pEMCurve_c  : TpImage;      {pointer for selecting electromech.group}
  pEMGroup_c  : TpImage;      {pointer for selecting electromech. group}
  pForm_c     : TpForm;       {pointer to the form of the parameters}
  pPQCurve_c  : TpImage;      {pointer for selecting PGQ-curve}
  pPQGroup_c  : TpImage;      {pointer for selecting PGQ-group}
  pHiLit_c    : TpMenuItem;   {pointer for selecting highlight/not the selected cell}
  pGrid_c     : TpGrid;       {pointer to the string grid}
  pLabel_c    : TpGrid;       {pointer to the label grid}
  pClrPanel_c : TpPanel;      {panel for the color menu}
  pCrvPanel_c : TpPanel;      {panel for the curve menu}
  pGrpPanel_c : TpPanel;      {panel for group menu}
  pNegSeq_c   : TpMenuItem;   {pointer for selecting neg.sequence plane}
  pPhase_c    : TpMenuItem;   {pointer for selecting phase plane}
  pNtItem_c   : TpMenuItem;   {pointer for displaying the notes}
  pTimeSpin_c : TpSpinBut;    {pointer to the spin button for setting the time multiplier}
  pOKBut_c    : TpButton;     {pointer to OK-button}
  pHint_c     : TpButton;      {pointer to Hint-button}
  RelTyp_c    : string;       {the type of the relay: PGQ, electromech, recloser}
  ColInd_c    : TColIndex;    {fixed indices of columns}
  RowInd_c    : TRowIndex;    {fixed indices of rows}
  ColorCol_c  : integer;      {column of color cell}
  CurveCol_c  : integer;      {column of curve cell}
  GroupCol_c  : integer;      {column of group cell}
  BackPar_c   : array[1..150] of string;  {large enough for recloser relay}
public

end;

implementation

uses
  Imagopas, recloser, userdef{, userdef};


const
  FirstTime : boolean = true;
  RelayType : string = 'PQ';  {flag for the active relay type, PGQ or electromech. Initialize here}
{ ValActCol : integer = 1;    {active column in the value grid}
{ ValActRow : integer = 1;  }
{ LabActRow : integer = 1;}
  Zflag     : boolean = true; {flag for updating line impedance}
  ColP = 1;         {column for P-relay in grid for parameter values}
  ColG = 2;
  ColQ = 3;
{ ColorCol : integer = 1;  {index of the column when selecting colors}
  GroupCol : integer = 1;  {index of the column when selecting groups}
  CurveCol : integer = 1;  {index of the column when selecting curves}
  {indices for rows - - - - - - -}
  Row51       = 0;   {row for title of type 51-element}
  GroupRow    = 1;   {row for group parameter (pq)}
  CurveRow    = 2;   {row for curve parameter}
  IssRow      = 3;
  FactRow     = 4;
  MultRow     = 5;   {time multiplier row (pq)}
  Row50       = 6;
  I1row       = 7;   {rof for the current of first def.time relay}
  t1row       = 8;
  I2row       = 9;
  t2row       = 10;
  CommonRow   = 11;
  {12}
  {13}
  Zrow        = 14;  {row for the line impedance}
  fiiRow      = 15;  {row for the angle of line impedance}
  {16}
  {17}
  ColorRow    = 18;  {row for color parameter}
  {19}
  CurrRow     = 20;  {row for the title of the test current}
  CurrTestRow = 21;  {row for the test current}
  TimeTestRow = 22;  {row for the test time}
  RelCurrRow  = 23;  {row for the relative current}


  {dimensions - - - - -}
  FirstWidth = 154; {width of first column}
  CRwidth = 16;     {width (and height) of a small color rectangle}
  CRspace = 4;      {width of space between color rectangles}
  GIwidth = 72;     {width of the image for selecting the group}
  GImarg = 4;       {margin of the group image}
  GIlinesp = 16;    {line spacing}
  CrIwidth = 96;    {width of image for selecting curves}
var
  GridCalc : TGridCalc;  {object for procedures with the grid}
{ pActPQ   : TpComp;     {pointer to active PGQ-relay}
  pGrid    : TpGrid;     {pointer to the grid with parameter values}
  Row_Ind  : TRowIndex;
  Col_Ind  : TColIndex;
{ BackPar  : array[1..69] of string; {save parameters here for retrieval at "cancel"}
{$R *.DFM}

function  GetRelayType: string;
begin
  GetRelayType := RelayType;
end;  

procedure TGridCalc.initialize(pForm: TpForm;pGrid, pLabel: TpGrid;
                               pDescr: TpMemo;
                               pEMCurve,pPQCurve,pEMGroup,pPQGroup: TpImage;
                               pHiLit, pPhase,pNegSeq,pNtItem: TpMenuItem;
                               pClrPanel, pCrvPanel, pGrpPanel: TpPanel;
                               pTimeSpin: TpSpinBut;
                               pOK,pCancel,pApply,pHint : TpButton;
                               RowInd : TRowIndex;
                               ColInd : TColIndex);
begin
  pForm_c := pForm;
  pGrid_c := pGrid;       {pointer to the grid with the parameters}
  pLabel_c := pLabel;
  pDescr_c := pDescr;
  pEMCurve_c := pEMCurve;
  pPQCurve_c := pPQCurve;
  pEMGroup_c := pEMGroup;
  pPQGroup_c := pPQGroup;
  pHiLit_c   := pHiLit;     {highlight/not the selected cell}
  pNegSeq_c  := pNegSeq;
  pNtItem_c := pNtItem;
  pPhase_c   := pPhase;
  pClrPanel_c := pClrPanel;
  pCrvPanel_c := pCrvPanel;
  pGrpPanel_c := pGrpPanel;
  pTimeSpin_c := pTimeSpin;
  pOKBut_c := pOK;
  pApply_c := pApply;
  pCancel_c := pCancel;
  pHint_c := pHint;
  RowInd_c := RowInd;     {fixed indices for the rows}
  ColInd_c := ColInd;
  pAct_c := nil;
  ActRow_c := 2;
  ActCol_c := 1;
end;

procedure TGridCalc.SetRelayType(RelTyp: string);
{set (force) the relay type}
begin
  RelTyp_c := RelTyp;
end;

procedure TGridCalc.Col0Captions(row: integer; rect: TRect);
{write the captions to column 0
 row    row number in the grid (first = 0)
 rect   rectangle defining the cell}
begin
  pGrid_c^.canvas.font.style := [fsBold];
  pGrid_c^.canvas.font.name := 'Arial';
  pGrid_c^.canvas.font.size := 8;
  pGrid_c^.canvas.font.color := clBlack;
  pGrid_c^.canvas.brush.style := bsSolid;
  if (row = RowInd_c.Row51) then begin
    pGrid_c^.canvas.TextOut(2+rect.left,rect.top,'Curve Time Element (51)');
  end else if (row = RowInd_c.Row50) then begin
    pGrid_c^.canvas.TextOut(2+rect.left,rect.top,'Definite Time Element (50)');
  end else if (row = RowInd_c.CommonRow) then begin
    pGrid_c^.canvas.TextOut(2+rect.left,rect.top,'Common');
  end else if (row = RowInd_c.CurrRow) then begin
    pGrid_c^.canvas.TextOut(2+rect.left,rect.top,'Activation test')
  end else if (row = RowInd_c.TimeModRow) and
    ((RelTyp_c = 'RC') or (RelTyp_c = 'UD')) then begin
    pGrid_c^.canvas.TextOut(2+rect.left,rect.top,'Curve modifiers t" = B t+C')
  end;
end;

procedure TGridCalc.ColPCaptions(row: integer; rect: TRect);
{write the captions in the P-column (for the phase relay)
 row    row number in the grid (first = 0)
 rect   rectangle defining the cell}
const
  offs = 11;
begin
  pGrid_c^.canvas.font.color := clRed;
  pGrid_c^.canvas.font.style := [fsBold];
  if (row = RowInd_c.Row51) then begin
    pGrid_c^.canvas.TextOut(offs+rect.left,rect.top,'51P ');
  end else if (row = RowInd_c.Row50) and ((RelTyp_c = 'PQ') or (RelTyp_c = 'EM')) then begin
    pGrid_c^.canvas.pen.color := clBtnFace;
    pGrid_c^.canvas.brush.color := clBtnFace;
    pGrid_c^.canvas.rectangle(rect.left,rect.top,rect.left+
                 pGrid_c^.DefaultColWidth,rect.top+pGrid_c^.DefaultRowHeight);
    pGrid_c^.canvas.TextOut(offs+rect.left,rect.top,'50P');
  end else if (row = RowInd_c.CommonRow) then begin
    pGrid_c^.canvas.pen.color := clBtnFace{clRed};
    pGrid_c^.canvas.brush.color := clBtnFace{clRed};
    pGrid_c^.canvas.rectangle(rect.left,rect.top,rect.left+
                 pGrid_c^.DefaultColWidth,rect.top+pGrid_c^.DefaultRowHeight);
  end else if (row = RowInd_c.CurrTestRow) or (row = RowInd_c.TimeTestRow) or
              (row = RowInd_c.RelCurrRow) then begin
    {test not available if not in phase plane}
    if (Imagoo.RelCharBut.down and not pPhase_c^.checked) then begin
      pGrid_c^.canvas.pen.color := clBtnFace;
      pGrid_c^.canvas.brush.color := clBtnFace;
      pGrid_c^.canvas.rectangle(rect.left,rect.top,rect.left+
                    pGrid_c^.DefaultColWidth,rect.top+pGrid_c^.DefaultRowHeight);
    end;
  end;
end;

procedure TGridCalc.ColGCaptions(row: integer; rect: TRect);
{write the captions in the G-column (for the ground relay)
 row    row number in the grid (first = 0)
 rect   rectangle defining the cell}
const
  offs = 11;
begin
  pGrid_c^.canvas.font.color := clGreen;
  pGrid_c^.canvas.font.style := [fsBold];
  if (row = RowInd_c.Row51) then begin
    pGrid_c^.canvas.TextOut(offs+rect.left,rect.top,'51G ');
  end else if (row = RowInd_c.Row50) and ((RelTyp_c = 'PQ') or (RelTyp_c = 'EM')) then begin
    pGrid_c^.canvas.pen.color := clBtnFace;
    pGrid_c^.canvas.brush.color := clBtnFace;
    pGrid_c^.canvas.rectangle(rect.left,rect.top,rect.left+
                 pGrid_c^.DefaultColWidth,rect.top+pGrid_c^.DefaultRowHeight);
    pGrid_c^.canvas.TextOut(offs+rect.left,rect.top,'50G');
  end else if (row = RowInd_c.CommonRow) then begin
    pGrid_c^.canvas.pen.color := clBtnFace;
    pGrid_c^.canvas.brush.color := clBtnFace;
    pGrid_c^.canvas.rectangle(rect.left,rect.top,rect.left+
                 pGrid_c^.DefaultColWidth,rect.top+pGrid_c^.DefaultRowHeight);
  end else if (row = RowInd_c.CurrTestRow) or (row = RowInd_c.TimeTestRow) or
              (row = RowInd_c.RelCurrRow) then begin
    {test not available if not in phase plane}
    if (Imagoo.RelCharBut.down and not pPhase_c^.checked) then begin
      pGrid_c^.canvas.pen.color := clBtnFace;
      pGrid_c^.canvas.brush.color := clBtnFace;
      pGrid_c^.canvas.rectangle(rect.left,rect.top,rect.left+
                    pGrid_c^.DefaultColWidth,rect.top+pGrid_c^.DefaultRowHeight);
    end;
  end;
end;

procedure TGridCalc.ColQCaptions(row: integer; rect: TRect);
{write the captions in the Q-column (for the sequence relay)
 row    row number in the grid (first = 0)
 rect   rectangle defining the cell}
const
  offs = 11;
var
  ipu  : integer;  {temporary}
  text : string;  {temporary}
begin
  pGrid_c^.canvas.font.color := clBlue;
  pGrid_c^.canvas.font.style := [fsBold];
  if (row = RowInd_c.Row51) then begin
    if (RelTyp_c = 'PQ') or (RelTyp_c = 'EM') then begin
      text := '51Q(3I';
      ipu := pGrid_c^.canvas.TextWidth(text);
      text := text+'  )';
      pGrid_c^.canvas.TextOut(offs+rect.left,rect.top,text);
      pGrid_c^.canvas.Font.Size := 7;
      pGrid_c^.canvas.TextOut(offs+rect.left+ipu,rect.top+4,'2');
    end else if (RelTyp_c = 'RC') or (RelTyp_c = 'UD') then begin
      pGrid_c^.canvas.TextOut(offs+rect.left,rect.top,'51Q ');
    end;
  end else if (row = RowInd_c.Row50) and ((RelTyp_c = 'PQ') or (RelTyp_c = 'EM')) then begin
    pGrid_c^.canvas.pen.color := clBtnFace;
    pGrid_c^.canvas.brush.color := clBtnFace;
    pGrid_c^.canvas.rectangle(rect.left,rect.top,rect.left+
                 pGrid_c^.DefaultColWidth,rect.top+pGrid_c^.DefaultRowHeight);
    text := '50Q(3I';
    ipu := pGrid_c^.canvas.TextWidth(text);
    text := text+'  )';
    pGrid_c^.canvas.TextOut(offs+rect.left,rect.top,text);
    pGrid_c^.canvas.Font.Size := 7;
    pGrid_c^.canvas.TextOut(offs+rect.left+ipu,rect.top+4,'2');  {as a subscript}
  end else if (row = RowInd_c.CommonRow) then begin
    pGrid_c^.canvas.pen.color := clBtnFace;
    pGrid_c^.canvas.brush.color := clBtnFace;
    pGrid_c^.canvas.rectangle(rect.left,rect.top,rect.left+
                 pGrid_c^.DefaultColWidth,rect.top+pGrid_c^.DefaultRowHeight);
  end else if (row = RowInd_c.CurrTestRow) or (row = RowInd_c.TimeTestRow) or
              (row = RowInd_c.RelCurrRow) then begin
    {test not available if not in neg.seq.plane}
    if (Imagoo.RelCharBut.down and not pNegSeq_c^.checked) then begin
      pGrid_c^.canvas.pen.color := clBtnFace;
      pGrid_c^.canvas.brush.color := clBtnFace;
      pGrid_c^.canvas.rectangle(rect.left,rect.top,rect.left+
                    pGrid_c^.DefaultColWidth,rect.top+pGrid_c^.DefaultRowHeight);
    end;
  end;
end;

procedure TGridCalc.ColorColorCells(col,row: integer; rect: TRect);
{color the cells defining line color
 col    colon number (first = 0)
 row    row number in the grid (first = 0)
 rect   rectangle defining the cell}
var
  iclr : integer;  {color index}
  ix   : integer;  {x-coordinate}
  text : string;
begin
  if (row = RowInd_c.ColorRow) and (col >= 1) then begin
      text := pGrid_c^.cells[col,row];
      iclr := strtoint(text);
      if (iclr < 1) then iclr := 1;
      if (iclr > 16) then iclr := 16;
      pGrid_c^.canvas.pen.color := gColor[iclr];
      pGrid_c^.canvas.brush.color := gColor[iclr];
      {a square indicates the color}
      ix := rect.left+pGrid_c^.DefaultColWidth-2*pGrid_c^.DefaultRowHeight;
      pGrid_c^.canvas.rectangle(ix,rect.top,rect.left+pGrid_c^.DefaultColWidth-
                              pGrid_c^.DefaultRowHeight,rect.top+pGrid_c^.DefaultRowHeight);
  end;
end;

procedure TGridCalc.CopyLineImpedance(row: integer; rect: TRect);
{same line impedance and phase for all relay types. Grey out cell
 and copy line impedance and phase
 row    row number in the grid (first = 0)
 rect   rectangle defining the cell}
var
  text : string;  {temporary}
begin
  pGrid_c^.canvas.pen.color := clBtnFace;
  pGrid_c^.canvas.brush.color := clBtnFace;
  pGrid_c^.canvas.rectangle(rect.left,rect.top,rect.left+
               pGrid_c^.DefaultColWidth,rect.top+pGrid_c^.DefaultRowHeight);
  {copy the impedance or phase from column 1 to other columns}
  text := pGrid_c^.cells[1,row];
  pGrid_c^.canvas.font.name := 'arial';
  pGrid_c^.canvas.font.size := 8;
  pGrid_c^.canvas.font.color := clBlack;
  pGrid_c^.canvas.font.style := [];
  pGrid_c^.canvas.TextOut(4+rect.left,rect.top+2,text);
end;
    
procedure TGridCalc.ValueGridSelectCell( Col, Row: Longint);
const
  first : boolean = true;  {flag for the first selection of the user def.curve}
var
  ipu,ipv : integer;  {temporary}
  ix      : integer;  {x-coordinate}
begin
  ActCol_c := col;
  ActRow_c := row;
  {mark (highlight) the selected cell, or not}
  if not (pHiLit_c^.checked) then begin
    {send an "enter"-key press, to select the cell (remove the color)}
    keybd_event(VK_SHIFT, 0, 0, 0);
    keybd_event(13, 0, 0, 0);
    keybd_event(VK_SHIFT, 0, KEYEVENTF_KEYUP, 0);
  end;
  {must not enter the "title"-cells, or the cell with parameters from a menu}
  if (row = RowInd_c.Row51) or (row = RowInd_c.Row50) or (row = RowInd_c.TimeModRow) or
     (row = RowInd_c.CommonRow) or (row = RowInd_c.ColorRow) or
     (row = RowInd_c.GroupRow) or (row = RowInd_c.CurveRow) or (row = RowInd_c.CurrRow) or
     (((row = RowInd_c.Zrow ) or (row = RowInd_c.fiirow)) and
      ((col = ColInd_c.ColG ) or (col = ColInd_c.ColQ ) or
       (col = ColInd_c.ColG2) or (col = ColInd_c.ColQ2) or (col = ColInd_c.ColP2))) or
     (((row = RowInd_c.CurrTestRow) or (row = RowInd_c.TimeTestRow) or (row = RowInd_c.RelCurrRow)) and
       ((col = ColInd_c.ColQ) or (col = ColInd_c.ColQ2)) and
       (Imagoo.RelCharBut.down) and (not pNegSeq_c^.checked)) or
     (((row = RowInd_c.CurrTestRow) or (row = RowInd_c.TimeTestRow) or (row = RowInd_c.RelCurrRow)) and
      ((col = ColInd_c.ColP) or (col = ColInd_c.ColP2) or
       (col = ColInd_c.ColG) or (col = ColInd_c.ColG2))and
      (Imagoo.RelCharBut.down) and (not pPhase_c^.checked)) or
     ((row = RowInd_c.MultRow) and (RelTyp_c = 'EM'))
      then begin
    pGrid_c^.options := pGrid_c^.options-[goEditing,goAlwaysShowEditor];
  end else begin
    pGrid_c^.options := pGrid_c^.options+[goEditing,goAlwaysShowEditor];
  end;
  {show the color dialogue, when entering the color cells}
  if (row = RowInd_c.ColorRow) then begin
    ipu := col*pGrid_c^.ColWidths[1];  {must copy to local, else "external exception"}
    ix := pGrid_c^.left+pGrid_c^.ColWidths[0]+ipu;
    pClrPanel_c^.left := ix-pClrPanel_c^.width;
    pClrPanel_c^.bringtofront;
    pClrPanel_c^.visible := true;
{!} {ColorCol := col;             {save the column for entering the parameter}
    ColorCol_c := col;
    if (pGrpPanel_c <> nil) then pGrpPanel_c^.visible := false;
    pCrvPanel_c^.visible := false;
    CharForm.visible := false;
  end else if (row = RowInd_c.GroupRow) then begin
    {show the group image according to the relay type}
    if (RelTyp_c = 'PQ') then begin
      pPQGroup_c^.visible := true;       {PGQ-relay}
      pEMGroup_c^.visible := false;      {not an electromechanical relay}
    end else if (RelTyp_c = 'EM') then begin
      pPQGroup_c^.visible := false;      {not a PGQ-relay}
      pEMGroup_c^.visible := true;       {electromechanical}
    end else begin
      pPQGroup_c^.visible := false;      {not a PGQ-relay}
      pEMGroup_c^.visible := false;      {electromechanical}
    end;
    ipu := (col-1)*pGrid_c^.DefaultColWidth;    {must copy to temporary, else "external exception"}
    ix := pGrid_c^.left+pGrid_c^.ColWidths[0]+ipu-CRwidth-8;
    pGrpPanel_c^.left := ix;
    pGrpPanel_c^.bringtofront;
    pGrpPanel_c^.visible := true;
{!} GroupCol := col;             {save the column for entering the parameter}
    GroupCol_c := col;
    pClrPanel_c^.visible := false;
    pCrvPanel_c^.visible := false;
    CharForm.visible := false;
    pTimeSpin_c^.visible := false;
  end else if (row = RowInd_c.CurveRow) then begin
{!} CurveCol := col;             {save the column for entering the parameter,needed in selectcell}
    CurveCol_c := col;
    if (RelTyp_c = 'PQ') then begin
{PQform pois!}  PQForm.CurvePanelTexts;
      pPQCurve_c^.visible := true;
      pEMCurve_c^.visible := false;
    end else if (RelTyp_c = 'EM') then begin
{PQform pois!}      PQForm.EMCurveTexts;
      pPQCurve_c^.visible := false;
      pEMCurve_c^.visible := true;
    end else begin
      if (pPQCurve_c <> nil) then pPQCurve_c^.visible := false;
      if (pEMCurve_c <> nil) then pEMCurve_c^.visible := false;
    end;
    ipu := col*pGrid_c^.ColWidths[1];    {must copy to temporary, otherwise an "external exception"}
    ix := pGrid_c^.left+pGrid_c^.ColWidths[0]+ipu;
    pCrvPanel_c^.left := ix-pCrvPanel_c^.width+4;
    pCrvPanel_c^.bringtofront;
    if (RelTyp_c <> 'UD') then pCrvPanel_c^.visible := true; {not needed for user defined relay}
    {if recloser relay with a user defined curve, show also the curve-definition form}
    if (RelTyp_c = 'UD') then begin          {user defined recloser relay}
      if (pAct_c <> nil) then begin        {reasonable component (relay)}
        ParamToCharGrid(pAct_c, col);      {show params. for the user defined char}
        StoreUDParam(pAct_c, Col);         {store the param. for an eventual "cancel"}
        if (first) then first := false else  {do not show the very first time,..}
          CharForm.visible := true;          {..just after starting the program}
      end;
    end else begin
      CharForm.visible := false;
    end;
    pClrPanel_c^.visible := false;
    if (pGrpPanel_c <> nil) then pGrpPanel_c^.visible := false;
    if (pTimeSpin_c <> nil) then pTimeSpin_c^.visible := false;
  end else if (row = RowInd_c.MultRow) then begin  {time multiplier, show the spin button...}
    if (RelTyp_c = 'EM') then begin      {..but only for electromech.relays}
      ix := pGrid_c^.left+FirstWidth+col*pGrid_c^.DefaultColWidth-CRwidth;
      pTimeSpin_c^.left := ix;
      pTimeSpin_c^.visible := true;
    end else begin
      pTimeSpin_c^.visible := false;
    end;
    pCrvPanel_c^.visible := false;
    pClrPanel_c^.visible := false;
    pGrpPanel_c^.visible := false;
    CharForm.visible := false;
  end else begin
    pClrPanel_c^.visible := false;
    if (pGrpPanel_c <> nil) then pGrpPanel_c^.visible := false;
    pCrvPanel_c^.visible := false;
    if (pTimeSpin_c <> nil) then pTimeSpin_c^.visible := false;
    CharForm.visible := false;
  end;
end;

procedure TGridCalc.FormDeactivate(Sender: TObject);
{read parameters, hide form after non-fault calculations}
var
  apu,apv : single;    {temporary}
  apw,apx : single;    {temporary}
  cnt     : integer;   {number of lines}
  col     : integer;   {column}
  errc    : integer;   {error flag}
  inHelp  : boolean;   {mouse is in the help memo}
  ii,jj,i : integer;   {indices}
  ipu     : integer;   {temporary}
  ipComp  : longint;   {pointer as iteger}
  ipSet   : longint;   {pointer to the common as integer}
  kk      : integer;   {temporary}
  line    : string;    {temporary}
  ll      : longint;
  npar    : integer;   {no of parameters}
  oldval  : single;    {old value of parameter}
  pComp   : TpComp;
  pHelp   : TpMemo;    {pointer to the help-memo}
  pMod    : TpelComp;  {pointer to the model component}
{ pSet    : TpCompSet; {pointer to the common}
  st1,st2 : string;    {temporary}
  st3,st4 : string;    {temporary}
  xy,xysc : TPoint;
begin
  {check first that the help-memo was not clicked}
  if (pAct_c <> nil) then begin
    pAct_c^.GetpMod(pMod);    {pointer to the model component}
    pMod^.GetpHelp(pHelp);                      {pointer to the help memo}
    if (pHelp <> nil) then begin
      if (pHelp^.visible) then begin
        GetCursorPos(xysc);       {mouse position in screen coordinates}
        xy := Imagoo.ScreentoClient(xysc);  {position in coord. of imagoo-form}
        if (xy.x >= pHelp^.left) and (xy.x <= pHelp^.left+pHelp^.width) and
           (xy.y >= pHelp^.top ) and (xy.y <= pHelp^.top+pHelp^.height) then
           inHelp := true
        else inHelp := false;
      end else begin
        inHelp := false;
      end;
    end else begin
      inHelp := false;
    end;
  end else begin
    inHelp := false;
  end;
  {must not do this, when deleting, copying or when clicking the help memo}
  if (not appl_close) and (not inHelp) and
     (not SetComp.copy_click) then begin
    pComp := pAct_c;
    if (pComp <> nil) then begin
      pComp^.GetipSet(ipSet);
{      pSet := TpCompSet(ipSet);}
      {parameters from grid to component}
      pComp^.GetNpar(npar);
      for ii := pGrid_c^.FixedRows to pGrid_c^.RowCount-pGrid_c^.FixedRows do begin
        for jj := pGrid_c^.FixedCols to pGrid_c^.ColCount-pGrid_c^.FixedCols do begin
          i := (ii-pGrid_c^.FixedRows)*(pGrid_c^.ColCount-pGrid_c^.FixedCols)+
               (jj-pGrid_c^.FixedCols+1);
          if (i > npar) then break;      {all parameters included}
          if (Sender = pCancel_c^) then begin
            line := BackPar_c[i];          {restore old values}
            pGrid_c^.Cells[jj,ii] := line;
          end else begin
            line := pGrid_c^.Cells[jj,ii];
          end;
          {save for next (eventual) "cancel"}
          ValuesFromLine(line,1,kk, apu,apv,apw,apx,st1,st2,st3,st4,errc); {one parameter a time}
          {set error flag, it is checked and reset in TCompSet.FormMouseDown}
          if (errc <> 0) then begin
            SetComp.err_cs := 1;
          end else begin
            pComp^.getpar(i,oldval);       {get the old value, for comparisons}
            pComp^.putpar(i,apu);          {save the parameter to the component}
            if (oldval <> apu) then SetComp.IsChanged := true; {flag the change}
          end;
        end;
      end;
      {save the identifications = descriptions. NOTE a recloser has more descriptions}
      if (RelTyp_c = 'RC') or (RelTyp_c = 'UD') then col := 2 else col := 1;
      pComp^.PutDescrP(7,pLabel_c^.cells[col,0],pLabel_c^.cells[col,1],pLabel_c^.cells[col,2]);
      if (RelTyp_c = 'RC') or (RelTyp_c = 'UD') then ipu := 1  {a recloser relay has more descriptions}
      else ipu := 0;
      pComp^.PutDescrG(7,pLabel_c^.cells[col,3+ipu],pLabel_c^.cells[col,4+ipu],pLabel_c^.cells[col,5+ipu]);
      if (RelTyp_c = 'RC') or (RelTyp_c = 'UD') then ipu := 2  {a recloser relay has more descriptions}
      else ipu := 0;
      pComp^.PutDescrQ(7,pLabel_c^.cells[col,6+ipu],pLabel_c^.cells[col,7+ipu],pLabel_c^.cells[col,8+ipu]);
      if (RelTyp_c = 'RC') or (RelTyp_c = 'UD') then   {a recloser relay has more descriptions}
        pComp^.PutDescr4(7,pLabel_c^.cells[col,3],pLabel_c^.cells[col,7],pLabel_c^.cells[col,11]);
      {copy additional descriptions from memo}
      pComp^.pDescr_s^.Clear;
      cnt := pDescr_c^.lines.count;     {no of rows}
      if (cnt > 0) then begin           {there is something}
        for ii := 0 to cnt-1 do begin   {index starts from 0}
          line := pDescr_c^.lines[ii];
          pComp^.pDescr_s^.add(line);
        end;
      end;
      pDescr_c^.clear;                  {clear also the memo (for the next component)}
      if (not Imagoo.RelCharBut.down) then begin {do not hide, if in coord.graph. mode}
        {hide also the memo}
        pNtItem_c^.checked := false;
        pDescr_c^.visible := false;
        {hide the form}
        ll := longint(pComp);
        RelayHideIf(ll,Sender);
        pComp^.GetipSet(ipSet);
        if (Sender <> pApply_c^) then unmark(ipset); {copy-paste works, when no unmark here}
      end else begin
        ipComp := longint(pComp);
        RelayShowIf(ipComp);              {update graphics, if visible}
      end;
    end;
    if (pTimeSpin_c <> nil) then pTimeSpin_c^.visible := false;
  end else begin
  {}
  end;
end;

procedure TGridCalc.ParamToGrid(pComp : TpComp);
{show the parameters of the component on the grid}
var
  apu     : single;    {temporary}
  col     : integer;   {column}
  i,ii,jj : integer;   {indices}
{ ipSet   : longint;   {pointer to common, as integer}
  ipu     : integer;   {temporary}
  npar    : integer;   {no of parameters}
{ pArr    : pSingle;   {pointer to the parameters (for tests)}
{ pRearr  : TpRearr;   {pointer to the record for the parameters (for test)}
{ pSet    : TpCompSet; {pointer to common}
  txt     : string;    {temporary text}
  txa,txb : string;    {temporary}
begin
  pComp^.GetNpar(npar);              {no of parameters}
  {test..., show parameters}
{ pComp^.GetpPar(pRearr);            {pointer to the record for parameters}
{ pRearr^.GetPtr(pArr);              {pointer to the parameters}
{ ii := npar div 6;                  {arrange in rows}
{ ShowRmat1(pArr,ii,6);              {show the parameters}
  {endtest..}
{ ipu := (pGrid_c^.RowCount-pGrid_c^.FixedRows)*(pGrid_c^.ColCount-pGrid_c^.FixedCols);}
{ if (ipu >= npar) then begin}         {this check is not needed, I think ???}
    for ii := pGrid_c^.FixedRows to pGrid_c^.RowCount-pGrid_c^.FixedRows do begin
      for jj := pGrid_c^.FixedCols to pGrid_c^.ColCount-pGrid_c^.FixedCols do begin
        i := (ii-pGrid_c^.FixedRows)*(pGrid_c^.ColCount-pGrid_c^.FixedCols)+
             (jj-pGrid_c^.FixedCols+1);
        if (i > npar) then break;      {all parameters included}
        pComp^.Getpar(i,apu);          {get value of parameter i}
        if ((ii = RowInd_c.GroupRow) or (ii = RowInd_c.CurveRow) or (ii = RowInd_c.ColorRow)) and
           (apu = 0) then apu := 1;    {zero not reasonable for group, curve or color}
        RemoveSpaces(apu,txt);         {format, and remove spaces, in routines.pas}
        pGrid_c^.Cells[jj,ii] := txt;  {parameter to grid}
        BackPar_c[i] := txt;           {save param. for "cancel"}
      end;
    end;
{ end;}
  {show the identifications = descriptions}
  if (RelTyp_c = 'RC') or (RelTyp_c = 'UD') then col := 2 else col := 1;
  pComp^.GetDescrP(txt,txa,txb);
  pLabel_c^.cells[col,0] := txt;
  pLabel_c^.cells[col,1] := txa;
  pLabel_c^.cells[col,2] := txb;
  pComp^.GetDescrG(txt,txa,txb);
  if (RelTyp_c = 'RC') or (RelTyp_c = 'UD') then ipu := 1 {a recloser relay has more descriptions}
  else ipu := 0;
  pLabel_c^.cells[col,3+ipu] := txt;
  pLabel_c^.cells[col,4+ipu] := txa;
  pLabel_c^.cells[col,5+ipu] := txb;
  pComp^.GetDescrQ(txt,txa,txb);
  if (RelTyp_c = 'RC') or (RelTyp_c = 'UD') then ipu := 2
  else ipu := 0;
  pLabel_c^.cells[col,6+ipu] := txt;
  pLabel_c^.cells[col,7+ipu] := txa;
  pLabel_c^.cells[col,8+ipu] := txb;
  if (RelTyp_c = 'RC') or (RelTyp_c = 'UD') then begin   {a recloser relay has more descriptions}
    pComp^.GetDescr4(txt,txa,txb);
    pLabel_c^.cells[col,3] := txt;
    pLabel_c^.cells[col,7] := txa;
    pLabel_c^.cells[col,11] := txb;
  end;
end;

procedure TGridCalc.CheckRelayType(pComp : TpComp);
{find the type of the relay, PGA or electromechanical}
var
  name : string;
begin
  pComp^.GetName(name);
  if      (name = gPQRel) then RelayType := 'PQ'  {PGQ-relay}
  else if (name = gEMRel) then RelayType := 'EM'  {electromech.relay}
  else if (name = gRCRel) then RelayType := 'RC'  {recloser relay}
  else if (name = gUDRel) then RelayType := 'UD'  {user defined recloser relay}
  else RelayType := 'other';
  SetRelayType(RelayType);
end;

procedure TGridCalc.RelayPar (ipComp: longint);
{show parameters at creation}
var
  ipSet   : longint;   {pointer to common, as integer}
  ix,iy   : integer;   {coordinates}
  lbl     : string;    {label of the component}
  pComp   : TpComp;    {pointer to the component}
  pSet    : TpCompSet; {pointer to common}
begin
  if (ipComp <> 0) then begin
    pComp := TpComp(ipComp);
    CheckRelayType(pComp);            {set flag for PGQ or electromech. relay}
    pComp^.GetipSet(ipSet);
    pSet := TpCompSet(ipSet);
    pAct_c := pComp;
    if (pSet^.create_comp) then begin
      {show  parameters on the grid in the form}
      ParamToGrid(pComp);
      pComp^.GetLabel(lbl,ix,iy);
      pForm_c^.caption := '  '+lbl;
      pForm_c^.visible := true;
    end;
    CTResultImage(ipComp);                  {create image to display act.times}
    new(pComp^.pDescr_s);
    pComp^.pDescr_s^ := TStringList.Create; {create list for additional descriptions}
  end;
end;

procedure TGridCalc.RelayShow(ipComp : longint);
{show the form for the PGQ-relays, with parameters and graphics}
var
  cnt   : integer;      {no of lines}
  i,j   : integer;      {temporary}
  ii    : integer;      {index}
  ipSet : longint;      {pointer to the common, as integer}
  lbl   : string;       {label of the component}
  line  : string;       {temporary string}
{ name  : string;       {name (type) of the relay}
  pComp : TpComp;       {pointer to relay}
  pSet  : TpCompSet;    {pointer to the "common"}
begin
  pComp := TpComp(ipComp);
  pComp^.GetipSet(ipSet);
  pAct_c := pComp;
  pSet := TpCompSet(ipSet); {pointer to the common}
  CheckRelayType(pComp);    {check relay type: PGQ or electromechanical}
  {only curves of electromech. and recloser relays can be saved}
{ if (RelayType = 'EM') then PQForm.SaveItem.visible := true
  else PQForm.SaveItem.visible := false;}
  if (RelayType = 'RC') then RecloserForm.SaveItem.visible := true
  else RecloserForm.SaveItem.visible := false;
  {after a short circuit calculation, show the graph}
  if (pSet^.appl_op = 6 ) or (pSet^.appl_op = 7 )
  or (pSet^.appl_op = 8 ) or (pSet^.appl_op = 11) then Relay_Show(pComp);
{  pAct_c := pComp;   moved above, else error}
  {show the parameter form}
  pComp^.GetLabel(lbl,i,j);
  pForm_c^.caption := '  '+lbl;
  {show parameters in the grid on the form}
  ParamToGrid(pComp);
  {copy additional descriptions to memo}
  pDescr_c^.Clear;
  cnt := pComp^.pDescr_s^.count;    {no of rows}
  if (cnt > 0) then begin           {there is something}
    for ii := 0 to cnt-1 do begin   {index starts from 0}
      line := pComp^.pDescr_s^[ii];
      pDescr_c^.lines.add(line);
    end;
    pDescr_c^.SelStart := 0;
  end;
  if (pGrpPanel_c <> nil) then pGrpPanel_c^.visible := false; {do not yet show group and curve menu}
  pCrvPanel_c^.visible := false;
  pClrPanel_c^.visible := false;
  pForm_c^.visible := true;
  pForm_c^.ActiveControl := nil; {focus to main form, for the case of delete-key pressed}
end;

procedure TGridCalc.RelayHideIf(ipComp : longint; Sender : TObject);
{hide the form for the relays, with parameters and graphics
 but not after fault calculations, or at 'apply' button}
var
  ipSet : longint;   {pointer to the common as integer}
  pComp : TpComp;    {pointer to the relay}
  pSet  : TpCompSet; {pointer to the common}
begin
  pComp := TpComp(ipComp);            {pointer to the relay}
  if (pComp^.var2_s <> 3) then pAct_c := nil; {relay no more active, if not apply-button}
  pComp^.GetipSet(ipSet);             {get pointer to the set, as integer}
  pSet := TpCompSet(ipSet);           {pointer to the set, from integer}
  if (sender = nil) then begin
    {pForm_c^.visible := false; }
  end else begin
    if (Sender <> pApply_c^) and (Sender <> pCrvPanel_c^) and
       ((Sender as TControl).name <> 'ApplyBut') and
       {CancelButton on the CharForm, for used defined characteristics}
       ((Sender as TControl).name <> 'CancelButton') and
       {OKButton on the CharForm, for used defined characteristics}
       ((Sender as TControl).name <> 'OKButton')
    then pForm_c^.visible := false;
  end;
  RelayShowIf(ipComp);              {update graphics, if visible}  
(*
  if (pSet^.appl_op = 6 ) or (pSet^.appl_op = 7 )
  or (pSet^.appl_op = 8 ) or (pSet^.appl_op = 11) then begin
  {nothing special, so far} {temporarily, hide the form}
{showmessage((sender as Tcontrol).name);}
    if (Sender <> pApply_c^) and (Sender <> pCrvPanel_c^) and
       ((Sender as TControl).name <> 'ApplyBut') then pForm_c^.visible := false;
    RelayShowIf(ipComp);              {update graphics, if visible}
  end else begin
    {hide the form, but not if apply button pressed}
    if (Sender <> pApply_c^) and (Sender <> pCrvPanel_c^) and
       ((sender <> nil) and ((Sender as TControl).Parent.name <> 'CharForm')) then pForm_c^.visible := false;
  end;
*)
end;

procedure TGridCalc.RelayHide(ipComp : longint);
{hide the form for the relays, with parameters and graphics}
var
  ll     : longint;  {pointer as integer}
  pComp  : TpComp;   {pointer to the relay}
{ pCurrT : TpComp;   {pointer to the connected current trafo}
begin
  HideRelayCurr(ipComp);     {hide the form with the char.curves, if connected, in Skemproc.pas}
  pAct_c := nil;
  if (pGrpPanel_c <> nil) then pGrpPanel_c^.visible := false;
  pCrvPanel_c^.visible := false;
  pClrPanel_c^.visible := false;
  pForm_c^.visible := false;
  {clear eventual activation times at the connected current trafo}
  pComp := TpComp(ipComp);
  pComp^.GetipComp(ll);                   {get pointer to the trafo, as integer}
  if (ll <> 0) then begin
    ClearCTactivation(ll);                {clear activation data}
{   pCurrT := TpComp(ll);                 {pointer to the trafo of the group}
{   pCurrT^.PutDescrP(7,'','','');        {see also GroupActivation in Shortcmp}
{   pCurrT^.PutDescrG(1,'','','');}
{   pCurrT^.PutDescrQ(7,'','','');}
  end;
end;

procedure TGridCalc.ColorImageMouseUp(X, Y: Integer);
{get color index from X and Y}
var
  ii,jj,kk : integer;
begin
  ii := (X div (CRwidth+CRspace))+1;
  jj := (Y div (CRwidth+CRspace))+1;
  kk := (ii-1)*4+jj;                 {color index}
  pGrid_c^.cells[ColorCol_c,RowInd_c.ColorRow] := inttostr(kk);
  pClrPanel_c^.visible := false;
end;

procedure TGridCalc.OKButtonClick(Sender: TObject);
var
  ipSet : longint;
begin
  if (pAct_c <> nil) then pAct_c^.var2_s := 1;     {flag for the button}
  FormDeactivate(sender);      {save the parameters, recalculate impedances, etc}
  ipSet := longint(@SetComp);
  if not (Imagoo.RelCharBut.down) then unmark(ipSet);
end;

procedure TGridCalc.CancelButClick(Sender: TObject);
var
  ipSet : longint;
begin
  if (pAct_c <> nil) then pAct_c^.var2_s := 2; {flag for the button}
  FormDeactivate(sender);                      {restore old parameters}
  ipSet := longint(@SetComp);
  if not (Imagoo.RelCharBut.down) then unmark(ipSet);
end;

procedure TGridCalc.ApplyButClick(Sender: TObject);
begin
  if (pAct_c <> nil) then pAct_c^.var2_s := 3; {flag for the button}
  FormDeactivate(sender);                      {restore old parameters}
end;

procedure TGridCalc.HintButClick(Sender: TObject);
{display the help-memo}
var
  pHelp : TpMemo;     {pointer to the help-memo}
  pMod  : TpElComp;   {pointer to the model component}
begin
  if (pAct_c <> nil) then begin
    pAct_c^.GetpMod(pMod);
    pMod^.GetpHelp(pHelp);
    if (pHelp <> nil) then begin
      pHelp.top := 200;
      pHelp.left := 100;
      pHelp.width := 450;
      pHelp.height := 300;
      pHelp.visible := true;
    end;
  end;
end;

function  TGridCalc.GetCurveCol: integer;
begin
  GetCurveCol := CurveCol_c;
end;

function  TGridCalc.GetpAct: TpComp;
begin
  GetpAct := pAct_c;
end;

function  TGridCalc.GetpGrid: TpGrid;
begin
  GetpGrid := pGrid_c;
end;

function  TGridCalc.GetActCol: integer;
begin
  GetActCol := ActCol_c;
end;

function  TGridCalc.GetActRow: integer;
begin
  GetActRow :=ActRow_c;
end;  

procedure TGridCalc.LabelGridSelectCell(Row: Longint);
begin
  LabActRow_c := row;
  {send an "enter"-key press, to select the cell (remove the color), if such an option}
  if not (pHiLit_c^.checked) then begin
    keybd_event(VK_SHIFT, 0, 0, 0);
    keybd_event(13, 0, 0, 0);
    keybd_event(VK_SHIFT, 0, KEYEVENTF_KEYUP, 0);
  end;
end;

procedure TGridCalc.ValueGridKeyUp(var Key: Word);
const
  CalcTime : boolean = true;  {test: calculate time for given current}
var
  actime  : single;   {calculated activation time}
  apu,apv : single;   {temporary}
  apw,apx : single;   {temporary}
  atime   : single;   {test activation time}
  bb,cc   : single;   {time multiplier and adder}
  curr    : single;   {test current}
  curratt : single;   {current at given time}
  curreal : single;   {real current (not rerative)}
  curve   : integer;  {inv.time curve within a group}
  defcurr : single;   {current at given time for def.time modules}
  deftime : single;   {activation time of def.time relays}
  errc    : integer;  {error flag}
  fact    : single;   {pickup factor for inv.time relay}
  group   : integer;  {group of inv.time curves}
  idp     : word;     {decimal point as word (integer)}
  ii      : integer;  {index}
  Imin    : single;   {the smaller act.current of the def.time relays}
  invcurr : single;   {currant at given time for inv.time module}
  InvTime : single;   {activation time of inv.time relay}
  isPQ    : boolean;  {true, when PGQ-relay, else electromech.relay}
  Iss     : single;   {ref.current = current parameter of inv.time relay}
  I1,I2   : single;   {activation currents of def.time relays}
  kk      : integer;  {temporary}
  ktm     : single;   {time multiplier of inv.time relay}
  len     : integer;  {length of text}
  line    : string;   {temporary}
  name    : string;   {name (type) of the relay}
  rltcurr : single;   {relative current as input}
  relcurr : single;   {relative current = current/pick-up current (or equiv.), output}
  st1,st2 : string;   {temporary}
  st3,st4 : string;   {temporary}
  text    : string;   {temporary}
{ tmin    : single;   {the act.time of the def.time relay with the smaller act.cur}
  tmax    : single;
  t1,t2   : single;   {activation times of def.time relays}
begin
  {check decimal point}
  if (key = 190) or (key = 188) then begin   {'.' or ',' assumed to be decimal point}
    if (d_p = #190) then idp := 190 else idp := 188;   {decimal point as word (integer)}
    if (key <> idp) then begin                         {not correct decimal point}
      text := pGrid_c^.cells[ActCol_c,ActRow_c];
      len := length(text);
      line := '';
      if (len > 1) then begin
        for ii := 1 to len do begin
          if (text[ii] = '.') or (text[ii] = ',') then line := line+d_p
          else line := line+text[ii];
        end;
      end;
      pGrid_c^.cells[ActCol_c,ActRow_c] := line;
      {send an "enter"-key press, to select the cell (remove the color)}
      keybd_event(VK_SHIFT, 0, 0, 0);
      keybd_event(13, 0, 0, 0);
      keybd_event(VK_SHIFT, 0, KEYEVENTF_KEYUP, 0);
    end;  
  end;
  pAct_c^.GetName(name);
{!}isPQ := (name = gPQRel);      {is it PGQ-relay, or an electromech.relay}
  {copy the impedance from the first column to columns 2 and 3}
  if (ActRow_c = RowInd_c.Zrow) or (ActRow_c = RowInd_c.fiiRow) then begin
    if (ActCol_c = 1) then begin
      text := pGrid_c^.cells[1,ActRow_c];  {impedance in first column}
      for ii := 2 to pGrid_c^.ColCount-1 do begin
        pGrid_c^.cells[ii,ActRow_c] := text;
      end;
    end;
  {calculate activation time for given current, when current or parameters change}
  end else if (ActRow_c = RowInd_c.CurrTestRow) or                           {current}
              (ActRow_c = RowInd_c.TimeTestRow) or                           {time}
              (ActRow_c = RowInd_c.RelCurrRow)  or                           {relative current}
              (ActRow_c = RowInd_c.GroupRow ) or
              (ActRow_c = RowInd_c.CurveRow ) or
              (ActRow_c = RowInd_c.TimeMultRow) or (ActRow_c = RowInd_c.TimeAddRow) or
              (ActRow_c = RowInd_c.IssRow) or (ActRow_c = RowInd_c.MultRow) or       {inv.time relay}
              (ActRow_c = RowInd_c.I1Row ) or (ActRow_c = RowInd_c.t1Row) or         {def.time relay 1}
              (ActRow_c = RowInd_c.I2Row ) or (ActRow_c = RowInd_c.t2Row) then begin {def.time relay 2}
    {change, eventually the variable to be calculated: time or current}
    if (ActRow_c = RowInd_c.CurrTestRow) then CalcTime := true
    else if (ActRow_c = RowInd_c.TimeTestRow) then CalcTime := false
    else if (ActRow_c = RowInd_c.RelCurrRow) then CalcTime := true
    else {no change};
    line := pGrid_c^.Cells[ActCol_c,RowInd_c.CurrTestRow];      {test current}
    if (length(line) > 0) then  begin
      ValuesFromLine(line,1,kk, apu,apv,apw,apx,st1,st2,st3,st4,errc);   {actually, only one parameter}
      if (errc = 0) then curreal := apu else curreal := -1;
    end else begin
      curreal := -1;
    end;
    line := pGrid_c^.Cells[ActCol_c,RowInd_c.TimeTestRow];      {test time}
    if (length(line) > 0) then begin
      ValuesFromLine(line,1,kk, apu,apv,apw,apx,st1,st2,st3,st4,errc);   {actually, only one parameter}
      if (errc = 0) then atime := apu else atime := -1;
    end else begin
      atime := -1;
    end;
    line := pGrid_c^.Cells[ActCol_c,RowInd_c.RelCurrRow];       {relative (test) current}
    if (length(line) > 0) then  begin
      ValuesFromLine(line,1,kk, apu,apv,apw,apx,st1,st2,st3,st4,errc);   {actually, only one parameter}
      if (errc = 0) then rltcurr := apu else rltcurr := -1;
    end else begin
      rltcurr := -1;
    end;
    {current and time parameters of first definite time relay}
    line := pGrid_c.Cells[ActCol_c,RowInd_c.I1Row];        {current parameter of first relay}
    ValuesFromLine(line,1,kk, apu,apv,apw,apx,st1,st2,st3,st4,errc); {extract numerical value}
    if (errc = 0) then I1 := apu else I1 := 0;
    line := pGrid_c^.Cells[ActCol_c,RowInd_c.t1Row];        {time parameter of first relay}
    ValuesFromLine(line,1,kk, apu,apv,apw,apx,st1,st2,st3,st4,errc); {extract numerical value}
    if (errc = 0) then t1 := apu else t1 := 0;
    {current and time parameters of second definite time relay}
    line := pGrid_c^.Cells[ActCol_c,RowInd_c.I2Row];        {current parameter of second relay}
    ValuesFromLine(line,1,kk, apu,apv,apw,apx,st1,st2,st3,st4,errc); {extract numerical value}
    if (errc = 0) then I2 := apu else I2 := 0;
    line := pGrid_c^.Cells[ActCol_c,RowInd_c.t2Row];        {time parameter of second relay}
    ValuesFromLine(line,1,kk, apu,apv,apw,apx,st1,st2,st3,st4,errc); {extract numerical value of time}
    if (errc = 0) then t2 := apu else t2 := 0;
    {parameters of the inverse time module}
    line := pGrid_c^.Cells[ActCol_c,RowInd_c.CurveRow];     {curve within the group}
    ValuesFromLine(line,1,kk, apu,apv,apw,apx,st1,st2,st3,st4,errc); {extract numerical value}
    if (errc = 0) then curve := round(apu) else curve := 0;
    line := pGrid_c^.Cells[ActCol_c,RowInd_c.IssRow];       {current parameter}
    ValuesFromLine(line,1,kk, apu,apv,apw,apx,st1,st2,st3,st4,errc); {extract numerical value}
    if (errc = 0) then Iss := apu else Iss := 0;
    line := pGrid_c^.Cells[ActCol_c,RowInd_c.FactRow];      {pickup factor}
    ValuesFromLine(line,1,kk, apu,apv,apw,apx,st1,st2,st3,st4,errc); {extract numerical value }
    if (errc = 0) then fact := apu else fact := 0;
    {some parameters are different for different types of relays}
    if (RelTyp_c = 'PQ') or (RelTyp_c = 'EM') then begin    {PGQ- or electromechanical relay}
      line := pGrid_c^.Cells[ActCol_c,RowInd_c.GroupRow];     {group of curves}
      ValuesFromLine(line,1,kk, apu,apv,apw,apx,st1,st2,st3,st4,errc); {extract numerical value}
      if (errc = 0) then group := round(apu) else group := 0;
      line := pGrid_c^.Cells[ActCol_c,RowInd_c.MultRow];      {time multiplier}
      ValuesFromLine(line,1,kk, apu,apv,apw,apx,st1,st2,st3,st4,errc); {extract numerical value}
      if (errc = 0) then ktm := apu else ktm := 0;
      bb := 0;
      cc := 0;
    end else if (RelTyp_c = 'RC') or (RelTyp_c = 'UD') then begin                   {recloser relay}
      line := pGrid_c^.Cells[ActCol_c,RowInd_c.TimeMultRow];  {time multiplier}
      ValuesFromLine(line,1,kk, apu,apv,apw,apx,st1,st2,st3,st4,errc); {extract numerical value}
      if (errc = 0) then bb := apu else bb := 0;
      line := pGrid_c^.Cells[ActCol_c,RowInd_c.TimeAddRow];  {time multiplier}
      ValuesFromLine(line,1,kk, apu,apv,apw,apx,st1,st2,st3,st4,errc); {extract numerical value}
      if (errc = 0) then cc := apu else cc := 0;
      group := 0;
      ktm := 0;
    end else begin                                           {unknown relay, error}
      bb := 0;
      cc := 0;
      group := 0;
      ktm := 0;
    end;
    {calculate}
    curratt := -1;   {initialize, to keep compiler quiet}
    actime := -1;
    Imin := -1;
{    tmin := -1;}
    relcurr := 0;
    {real or relative current given?}
    if      (ActRow_c = RowInd_c.CurrTestRow) then curr := curreal      {current}
    else if (ActRow_c = RowInd_c.RelCurrRow)  then curr := Iss*rltcurr  {relative current}
    else                                         curr := curreal;     {time given}
    if (CalcTime) then begin                       {current given, calculate time}
      if (curr > 0) then begin
        {check activation of definite time relays}
        if (I1 > 0) and (t1 > 0) then begin
          if (I2 > 0) and (T2 > 0) then begin      {both modules in use}
            if (I1 > I2) then begin                {check larger first}
              Imin := I2;                          {save smaller act.cur for the inv.relay}
{             tmin := t2;}
              if (curr >= I1) then begin
                deftime := t1;
              end else begin
                if (curr >= I2) then begin
                  deftime := t2;
                end else begin
                  deftime := -1;                {negative value as a flag}
                end;
              end;
            end else begin                     {I2 is larger}
              Imin := I1;
{             tmin := t1;}
              if (curr >= I2) then begin
                deftime := t2;
              end else begin
                if (curr >= I1) then begin
                  deftime := t1;
                end else begin
                  deftime := -1;                {-1 as a flag}
                end;
              end;
            end;
          end else begin                       {only I1 in use}
            Imin := I1;
{           tmin := t1;}
            if (curr >= I1) then deftime := t1 else deftime := -1;
          end;
        end else if (I2 > 0) and (t2 > 0) then begin  {only I2 in use}
          Imin := I2;
{         tmin := t2;}
          if (curr >= I2) then deftime := t2 else deftime := -1;
        end else begin                         {no def.time relay in use}
          Imin := 0;
{         tmin := 0;}
          deftime := -1;
        end;
      end else begin                           {error in current parameter}
        deftime := -1;
      end;
      if (RelTyp_c = 'UD') then begin          {user defined recloser relay}
        GetUDCurrOrTime(pAct_c, ActCol_c, Iss, bb,cc, 'time', InvTime, curr);
        if (Iss > 0) then relcurr := curr/Iss else relcurr := -1;
      end else if (RelTyp_c = 'RC') then begin {"normal" recloser relay}
        RCTimeOrCurr(curve, Iss, bb, cc, 'time', curr, InvTime);  {in ReclData}
        if (Iss > 0) then relcurr := curr/Iss else relcurr := -1;
      end else begin                           {PGQ- or electromech.relay}
        {activation time of the inv.time relay, if reasonable parameters}
        if (group > 0) and (curve > 0) and (Iss > 0) and
           (fact > 0) and (ktm > 0) then begin
           if (isPQ) then         {PGQ-relay}
             PQTimeOrCurr(Iss,ktm,fact,group,curve,'time',curr,InvTime) {in Relcurr.pas}
           else                   {electromech. relay}
             EMTimeOrCurr(Iss,ktm,group,curve,'time',curr,InvTime); {in Relcurr.pas}
           relcurr := curr/Iss;
        end else begin
          InvTime := -1;
        end;
      end;
      {select the activation time}
      if (Imin > 0) then begin
        if (curr < Imin) then actime := InvTime
        else actime := deftime;
      end else begin
        actime := InvTime;
      end;
    end else begin       {calculate current for given time - - - - - - - - - -}
      if (I1 > 0) and (t1 > 0) then  begin
        if (I2 > 0) and (t2 > 0) then begin       {both modules in use}
          if (t1 < t2) then begin
            tmax := t2;
            if (atime < t1) then defcurr := -1    {no solution}
            else if (atime < t2) then defcurr := I1
            else defcurr := I2;
          end else begin
            tmax := t1;
            if (atime < t2) then defcurr := -1    {no solution}
            else if (atime < t1) then defcurr := I2
            else defcurr := I1;
          end;
        end else begin
          tmax := t1;                     {only I1, t1-module in use}
          if (atime < t1) then defcurr := -1
          else defcurr := I1;
        end;
      end else begin
        if (I2 > 0) and (t2 > 0)  then begin      {only I2, t2 module in use}
          tmax := t2;
          if (atime < t2) then defcurr := -1
          else defcurr := I2;
        end else begin                            {no def.time module in use}
          tmax := -1;
          defcurr := -1;
        end;
      end;
      {current for given time of the inv.time relay, if reasonable parameters}
      if (RelTyp_c = 'UD') then begin             {user defined recloser relay}
        GetUDCurrOrTime(pAct_c, ActCol_c, Iss, bb, cc, 'curr', atime, invcurr);
      end else if (RelTyp_c = 'RC') then begin    {"normal" recloser relay}
        RCTimeOrCurr(curve, Iss, bb, cc, 'curr', invcurr, atime);  {in ReclData}
      end else begin                              {PGQ- or electromechanical relay}
        if (group > 0) and (curve > 0) and (Iss > 0) and
           (fact > 0) and (ktm > 0) then begin
          if (tmax > 0) then begin
            if (atime < tmax) then begin
              invcurr := -1;
            end else begin
              if (isPQ) then     {PGQ-relay}
                PQTimeOrCurr(Iss,ktm,fact,group,curve,'curr',invcurr,atime) {in Relcurr.pas}
              else               {electromech.relay}
                EMTimeOrCurr(Iss,ktm,group,curve,'curr',invcurr,atime); {in Relcurr.pas}
{             relcurr := invcurr/Iss;}
            end;
          end else begin
            if (isPQ) then       {PGQ-relay}
            PQTimeOrCurr(Iss,ktm,fact,group,curve,'curr',invcurr,atime) {in Relcurr.pas}
            else                 {electromech.relay}
              EMTimeOrCurr(Iss,ktm,group,curve,'curr',invcurr,atime); {in Relcurr.pas}
{           relcurr := invcurr/Iss;}
          end;
        end else begin
          invcurr := -1;
        end;
      end;
      {select the current from inv.time module and def.time module}
      if (invcurr > 0) and (defcurr > 0) then begin
        if (invcurr < defcurr) then curratt := invcurr else curratt := defcurr;
      end else if (defcurr > 0) then begin
        curratt := defcurr;
      end else if (invcurr > 0) then begin
        curratt := invcurr;
      end else begin
        curratt := -1;
      end;
      if (Iss > 0) then relcurr := curratt/Iss
      else relcurr := -1;
    end;
    {display the calculated value of current or time}
    if (CalcTime) then begin                         {time calculated}
      if (actime > 0) {and (actime < gMaxTime)} then {maximum time in utildef.pas}
{       RemoveSpaces(actime,line)                    {format, and remove spaces, in routines.pas}
        line := ThreeDecimals(actime)
      else line := ' ';                              {not activated}
      pGrid_c^.Cells[ActCol_c,RowInd_c.TimeTestRow] := line;
    end else begin                                   {current calculated}
      if (curratt > 0) then begin{RemoveSpaces(curratt,line) {in routines.pas}
        {line := TwoDecimalsAtMost(curratt)}
        line := SixCharOneDecimal(curratt);
        for ii := 1 to length(line) do begin
          if (line[ii] = '.') or (line[ii] = ',') then line[ii] := d_p;
        end;
      end else line := ' ';
      pGrid_c^.Cells[ActCol_c,RowInd_c.CurrTestRow] := line;
    end;
    {display the relative current, if real current or time given}
    if (ActRow_c = RowInd_c.CurrTestRow) or (ActRow_c = RowInd_c.TimeTestRow) then begin
      {RemoveSpaces(relcurr,line);}
      if (relcurr > 0) then line := ThreeDecimals(relcurr) else line := ' ';
      pGrid_c^.Cells[ActCol_c,RowInd_c.RelCurrRow] := line;
    end else if (ActRow_c = RowInd_c.RelCurrRow) then begin {relative current given, display real current}
      {RemoveSpaces(curr,line);}
      line := SixCharOneDecimal(curr);
      for ii := 1 to length(line) do begin
        if (line[ii] = '.') or (line[ii] = ',') then line[ii] := d_p;
      end;
      pGrid_c^.Cells[ActCol_c,RowInd_c.CurrTestRow] := line;
    end else begin         {some parameter-row active}
      {updated above}
    end;
  end;
end;

procedure TGridCalc.GreyOutCells(col1,col2,row1,row2: integer);
{"grey out" the cells from col1, row1 to col2,row2}
var
  col   : integer;  {column index}
  ix,iy : integer;  {coordinates of upper corner of the cells}
  row   : integer;  {row index}
begin
  if (col1 >= 0) and (col2 >= col1) and (col2 < pGrid_c^.ColCount) and
     (row1 >= 0) and (row2 >= row1) and (row2 < pGrid_c^.RowCount) then begin
    pGrid_c^.canvas.pen.color := clBtnFace;
    pGrid_c^.canvas.brush.color := clBtnFace;
    for col := col1 to col2 do begin
      for row := row1 to row2 do begin
        ix := pGrid_c^.ColWidths[0]+(col-1)*(pGrid_c^.ColWidths[col])+col*pGrid_c^.GridLineWidth;
        iy := row*(pGrid_c^.DefaultRowHeight+pGrid_c^.GridLineWidth);
        pGrid_c^.canvas.rectangle(ix,iy,ix+pGrid_c^.ColWidths[col],
                                  iy+pGrid_c^.DefaultRowHeight);
      end;
    end;
  end;
end;

(*
procedure ParamToGrid(pComp : TpComp);
{show the parameters of the component on the grid}
var
  apu     : single;    {temporary}
  i,ii,jj : integer;   {indices}
  ipSet   : longint;   {pointer to common, as integer}
  ipu     : integer;   {temporary}
  npar    : integer;   {no of parameters}
  pSet    : TpCompSet; {pointer to common}
  txt     : string;    {temporary text}
  txa,txb : string;    {temporary}
begin
  pComp^.GetNpar(npar);              {no of parameters}
  ipu := (pGrid^.RowCount-pGrid^.FixedRows)*(pGrid^.ColCount-pGrid^.FixedCols);
  if (ipu >= npar) then begin
    for ii := pGrid^.FixedRows to pGrid^.RowCount-pGrid^.FixedRows do begin
      for jj := pGrid^.FixedCols to pGrid^.ColCount-pGrid^.FixedCols do begin
        i := (ii-pGrid^.FixedRows)*(pGrid^.ColCount-pGrid^.FixedCols)+
             (jj-pGrid^.FixedCols+1);
        if (i > npar) then break;      {all parameters included}
        pComp^.Getpar(i,apu);          {get value of parameter i}
        if ((ii = GroupRow) or (ii = CurveRow) or (ii = ColorRow)) and
           (apu = 0) then apu := 1;    {zero not reasonable for group, curve or color}
        RemoveSpaces(apu,txt);         {format, and remove spaces, in routines.pas}
        pGrid^.Cells[jj,ii] := txt;    {parameter to grid}
        GridCalc.BackPar_c[i] := txt;  {save param. for "cancel"}
      end;
    end;
  end;
  {show the identifications = descriptions}
  pComp^.GetDescrP(txt,txa,txb);
  PQForm.LabelGrid.cells[1,0] := txt;
  PQForm.LabelGrid.cells[1,1] := txa;
  PQForm.LabelGrid.cells[1,2] := txb;
  pComp^.GetDescrG(txt,txa,txb);
  PQForm.LabelGrid.cells[1,3] := txt;
  PQForm.LabelGrid.cells[1,4] := txa;
  PQForm.LabelGrid.cells[1,5] := txb;
  pComp^.GetDescrQ(txt,txa,txb);
  PQForm.LabelGrid.cells[1,6] := txt;
  PQForm.LabelGrid.cells[1,7] := txa;
  PQForm.LabelGrid.cells[1,8] := txb;
end;
*)
procedure PQRelayShow(ipComp : longint);
{show the form for the PGQ-relays, with parameters and graphics}
begin
  GridCalc.RelayShow(ipComp);
(*
var
  cnt   : integer;      {no of lines}
  i,j   : integer;      {temporary}
  ii    : integer;      {index}
  ipSet : longint;      {pointer to the common, as integer}
  lbl   : string;       {label of the component}
  line  : string;       {temporary string}
  name  : string;       {name (type) of the relay}
  pComp : TpComp;       {pointer to relay}
  pSet  : TpCompSet;    {pointer to the "common"}
begin
  pComp := TpComp(ipComp);
  pComp^.GetipSet(ipSet);
  pSet := TpCompSet(ipSet); {pointer to the common}
  CheckRelayType(pComp); {check relay type: PGQ or electromechanical}
  {after a short circuit calculation, show the graph}
  if (pSet^.appl_op = 6 ) or (pSet^.appl_op = 7 )
  or (pSet^.appl_op = 8 ) or (pSet^.appl_op = 11) then Relay_Show(pComp);
 {pActPQ := pComp;          {save pointer to active relay}
  GridCalc.pAct_c := pComp;
  {show the parameter form}
  pComp^.GetLabel(lbl,i,j);
  PQForm.caption := '  '+lbl;
  {show parameters in the grid on the form}
  GridCalc.ParamToGrid(pComp);
  {copy additional descriptions to memo}
  {PQForm.DescrMemo.Lines}GridCalc.pDescr_c^.Clear;
  cnt := pComp^.pDescr_s^.count;    {no of rows}
  if (cnt > 0) then begin           {there is something}
    for ii := 0 to cnt-1 do begin   {index starts from 0}
      line := pComp^.pDescr_s^[ii];
      {PQForm.DescrMemo}GridCalc.pDescr_c^.lines.add(line);
    end;
    {PQForm.DescrMemo}GridCalc.pDescr_c^.SelStart := 0;
  end;
  {PQForm.GroupPanel}GridCalc.pGrpPanel_c^.visible := false; {do not yet show group and curve menu}
  {PQForm.CurvePanel}GridCalc.pCrvPanel_c^.visible := false;
  {PQForm.ImagePanel}GridCalc.pClrPanel_c^.visible := false;
  {PQForm}GridCalc.pForm_c^.visible := true;
  {PQForm}GridCalc.pForm_c^.ActiveControl := nil; {focus to main form, for the case of delete-key pressed}
*)
end;

(*
procedure PQRelayHideIf(ipComp : longint; Sender : TObject);
{hide the form for the PGQ-relays, with parameters and graphics
 but not after fault calculations, or at 'apply' button}
var
  ipSet : longint;   {pointer to the common as integer}
  pComp : TpComp;    {pointer to the relay}
  pSet  : TpCompSet; {pointer to the common}
begin
  pComp := TpComp(ipComp);            {pointer to the relay}
  if (pComp^.var2_s <> 3) then GridCalc.pAct_c := nil; {relay no more active, if not apply-button}
  pComp^.GetipSet(ipSet);             {get pointer to the set, as integer}
  pSet := TpCompSet(ipSet);           {pointer to the set, from integer}
  if (pSet^.appl_op = 6 ) or (pSet^.appl_op = 7 )
  or (pSet^.appl_op = 8 ) or (pSet^.appl_op = 11) then begin
  {nothing special, so far} {temporarily, hide the form}
    if (Sender <> PQForm.ApplyBut){(pComp^.var2_s <> 3)} then PQForm.visible := false;
    RelayShowIf(ipComp);              {update graphics, if visible}
  end else begin
    {hide the form, but not if apply button pressed}
    if (Sender <> PQForm.ApplyBut){(pComp^.var2_s <> 3)} then PQForm.visible := false;
  end;
end;
*)
procedure SavePQRelay(pPQrel : TpComp);
{save active relay}
begin
{ pActPQ := pPQrel;}
  GridCalc.pAct_c := pPQrel;
end;

function GetActPQ : TpComp;
{get pointer to the active PQ-relay}
begin
{ GetActPQ := pActPQ;}
  GetActPQ := GridCalc.pAct_c;
end;

procedure PQRelayHide(ipComp : longint);
{hide the form for the PGQ-relays, with parameters and graphics}
begin
  GridCalc.RelayHide(ipComp);
(*
var
  pComp  : TpComp;   {pointer to the relay}
begin
{ pComp := TpComp(ipComp);   {pointer to the relay}
  HideRelayCurr(ipComp);     {hide the form with the char.curves, if connected, in Skemproc.pas}
{ pActPQ := nil;             {relay no more active}
  GridCalc.pAct_c := nil;
  PQForm.GroupPanel.visible := false;
  PQForm.CurvePanel.visible := false;
  PQForm.ImagePanel.visible := false;
  PQForm.visible := false;
*)  
end;

procedure PQParamHide(ipComp : longint);
{hide the parameter form, when minimized (but only then!)}
begin
  if (PQForm.WindowState = wsMinimized) then PQForm.visible := false;
end;

procedure PQRelayPar (ipComp: longint);
{show parameters at creation}
begin
  GridCalc.RelayPar(ipComp);
end;
(*
var
  ipSet   : longint;   {pointer to common, as integer}
  pComp   : TpComp;    {pointer to the component}
  pSet    : TpCompSet; {pointer to common}
begin
  if (ipComp <> 0) then begin
    pComp := TpComp(ipComp);
    CheckRelayType(pComp);            {set flag for PGQ or electromech. relay}
    pComp^.GetipSet(ipSet);
    pSet := TpCompSet(ipSet);
{   pActPQ := pComp;                  {save pointer to active relay}
    GridCalc.pAct_c := pComp;
    if (pSet^.create_comp) then begin
      {show  parameters on the grid in the form}
      GridCalc.ParamToGrid(pComp);
      PQForm.visible := true;
    end;
    CTResultImage(ipComp);                  {create image to display act.times}
    new(pComp^.pDescr_s);
    pComp^.pDescr_s^ := TStringList.Create; {create list for additional descriptions}
  end;
end;
*)

procedure TPQForm.GetCRsize(var CRw,CRs : integer);
{needed in phasor.pas}
begin
  CRw := CRwidth;
  CRs := CRspace;
end;

procedure TPQForm.ColorInitialize(pImage : TpImage);
{draw colors in the image for selecting the colors, etc
 pImage  pointer to the image}
var
  ii,jj,kk : integer;
  ix,iy    : integer;
begin
  pImage^.width := 4*CRwidth+5*CRspace;
  pImage^.height := pImage^.width;
  pImage^.top := CRspace;
  pImage^.left := CRspace;
  {a rectangle around the whole image}
  pImage^.canvas.pen.color := clBlack;
  pImage^.canvas.brush.style := bsClear;
  pImage^.canvas.rectangle(0,0,pImage^.width,pImage^.height);
  {the color rectangles}
  pImage^.canvas.brush.style := bsSolid;
  for ii := 1 to 4 do begin
    for jj := 1 to 4 do begin
      kk := (ii-1)*4+jj;        {color index}
      ix := CRspace+(ii-1)*(CRwidth+CRspace);
      iy := CRspace+(jj-1)*(CRwidth+CRspace);
      pImage^.canvas.pen.color := gColor[kk];
      pImage^.canvas.brush.color := gColor[kk];
      pImage^.canvas.rectangle(ix,iy,ix+CRwidth,iy+CRwidth);
    end;
  end;
end;

procedure TPQForm.FormCreate(Sender: TObject);
var
  ipu      : integer;  {temporary}
  ii,jj,kk : integer;  {indices}
  ix,iy    : integer;  {coordinates}
begin
  DecimalPoint(d_p);
  left := 0;           {put initially in the upper left corner}
  top := 0;
  {row indices}
  Row_Ind.Row51       := Row51;       {row for title of type 51-element}
  Row_Ind.GroupRow    := GroupRow;    {row for group parameter (pq)}
  Row_Ind.TimeC1C2Row := -1;          {does not exist}
  Row_Ind.CurveRow    := CurveRow;    {row for curve parameter}
  Row_Ind.IssRow      := IssRow;
  Row_Ind.FactRow     := FactRow;
  Row_Ind.MultRow     := MultRow;     {time multiplier row (pq)}
  Row_Ind.TimeModRow  := -1;
  Row_Ind.TimeMultRow := -1;
  Row_Ind.TimeAddRow  := -1;
  Row_Ind.TimeMinRow  := -1;
  Row_Ind.Row50       := Row50;
  Row_Ind.I1row       := I1Row;       {row for the current of first def.time relay}
  Row_Ind.t1row       := t1Row;
  Row_Ind.I2row       := I2Row;
  Row_Ind.t2row       := t2Row;
  Row_Ind.CommonRow   := CommonRow;
  Row_Ind.Zrow        := Zrow;        {row for the line impedance}
  Row_Ind.fiiRow      := fiiRow;      {row for the angle of line impedance}
  Row_Ind.ColorRow    := ColorRow;    {row for color parameter}
  Row_Ind.CurrRow     := CurrRow;     {row for the title of the test current}
  Row_Ind.CurrTestRow := CurrTestRow; {row for the test current}
  Row_Ind.TimeTestRow := TimeTestRow; {row for the test time}
  Row_Ind.RelCurrRow  := RelCurrRow;  {row for the relative current}
  {column indices}
  Col_Ind.ColP := ColP;
  Col_Ind.ColG := ColG;
  Col_Ind.ColQ := ColQ;
  Col_Ind.ColP2 := -1;   {does not exist for a PGQ- or EM-relay}
  Col_Ind.ColG2 := -1;
  Col_Ind.ColQ2 := -1;
  {texts for the parameters}
  with ValueGrid do begin
    cells[0, 0] := '';
    cells[0, 1] := '  Group'{ (1...6)'};
    cells[0, 2] := '  Curve'{ (1..5  ..5  ..9  ..4  ..4 ..4)'};
    cells[0, 3] := '  Set current value (Is) [A]';
    cells[0, 4] := '  Factor (n)';
    cells[0, 5] := '  Time multiplier';
    cells[0, 6] := '';
    cells[0, 7] := '  Pickup Def 1 [A]';
    cells[0, 8] := '  Delay Def 1[s]';
    cells[0, 9] := '  Pickup Def 2 [A]';
    cells[0,10] := '  Delay Def 2 [s]';
    cells[0,11] := '';
    cells[0,12] := '  Max current [A]';
    cells[0,13] := '  Directional  (0 = no)';
    cells[0,14] := '  | Z line| (ohms)';
    cells[0,15] := '   line ()';
    cells[0,16] := '  Show curve  (0 = no)';
    cells[0,17] := '  Line thickness  (0...4)';
    cells[0,18] := '  Color';
    cells[0,19] := '  Spare';
    cells[0,20] := '';
    cells[0,21] := '  current (calculate time)';
    cells[0,22] := '  time (calculate current)';
    cells[0,23] := '  multiples of p.u. current';
  end;
{ pActPQ := nil;  later...               {no active relay yet}

  {position, size etc of the label grid}
  LabelGrid.ColWidths[0] := FirstWidth;
  LabelGrid.width := FirstWidth+LabelGrid.DefaultColWidth+3;
  LabelGrid.height := LabelGrid.RowCount*(LabelGrid.DefaultRowHeight+
                      LabelGrid.GridLineWidth)+LabelGrid.GridLineWidth;
  LabelGrid.ColWidths[0] := 40;
  LabelGrid.ColWidths[1] := LabelGrid.width-LabelGrid.ColWidths[0]-3*LabelGrid.GridLineWidth;
  {position, size, etc of the parameter value grid}
  pGrid := @ValueGrid;                {pointer to the grid with parameter values}
  pGrid^.top := LabelGrid.top{+LabelGrid.height};
  pGrid^.ColWidths[0] := FirstWidth;  {texts need more space}
  {set the width of other columns to default, just to be sure}
  for ii := pGrid^.FixedCols to pGrid^.ColCount-1 do begin
    pGrid^.ColWidths[ii] := pGrid^.DefaultColWidth;
  end;
  {adjust the width = total widht of cells }
  pGrid^.width := FirstWidth+(pGrid^.ColCount-pGrid^.FixedCols)*
                (pGrid^.DefaultColWidth+pGrid^.GridLineWidth)+
                 2*pGrid^.GridLineWidth;
  {adjust the height}
  pGrid^.height := pGrid^.RowCount*(pGrid^.DefaultRowHeight+pGrid^.GridLineWidth)+
                   pGrid^.GridLineWidth+1;
  GridCalc := TGridCalc.Create;           {create object for procedures - - - - - - -}
  GridCalc.initialize(@PQForm,pGrid,@LabelGrid,@DescrMemo,
                      @EMCurveImg,@CurveImage,@EMGroupImg,@GroupImage,
                      @ColorItem,@PhaseItem,@NegSeqItem,@NotesItem,
                      @ImagePanel,@CurvePanel,@GroupPanel,
                      @TimeSpinBut,
                      @OKButton,@CancelBut,@ApplyBut,@HintBut,Row_Ind,Col_Ind);
  {positions of the buttons}
  OKButton.top := pGrid^.top+pGrid^.height+8;
  CancelBut.top := OKButton.top;
  ApplyBut.top := OKButton.top;
  HintBut.top := OKButton.top;
  {set the height of the form}
  ii := PQForm.height-PQForm.Clientheight;
  PQForm.height := OKButton.top+OKButton.height+ii+8;
  {prepare image for selecting the colors}
  ColorInitialize(@ColorImage);
  {size and initial position of the color panel}
  ImagePanel.width := ColorImage.width+2*CRspace;
  ImagePanel.height := ImagePanel.width;
  ImagePanel.top := ColorRow*(pGrid^.DefaultRowHeight+pGrid^.GridLineWidth)
                    +ValueGrid.top-ImagePanel.width;
  ImagePanel.left := FirstWidth+ValueGrid.left;
  {prepare image and its background panel for selecting the group of curves}
  GroupImage.width := GIwidth;
  GroupImage.height := 6*GIlinesp;
  GroupImage.top := GImarg;
  GroupImage.left := GImarg;
  GroupPanel.width := GroupImage.width+2*GImarg;
  GroupPanel.height := GroupImage.height+2*GImarg;
  GroupPanel.top := (GroupRow+1)*(pGrid^.DefaultRowHeight+pGrid^.GridLineWidth)
                    +ValueGrid.top{-GroupPanel.height};
  GroupPanel.left := FirstWidth+ValueGrid.left;
  with GroupImage.canvas do begin
    font.name := 'arial';
    font.size := 8;
    font.color := clBlack;
    textout(1,GImarg,           'IEC');
    textout(1,GImarg+  GIlinesp,'IEEE C37.112');
    textout(1,GImarg+2*GIlinesp,'ABB');
    textout(1,GImarg+3*GIlinesp,'ANSI');
    textout(1,GImarg+4*GIlinesp,'IAC');
    textout(1,GImarg+5*GIlinesp,'MIC');
  end;
  {prepare image for selecting the group for the electromechanical relay}
  EMGroupImg.width := GIwidth;
  EMGroupImg.height := 4*GIlinesp;
  EMGroupImg.top := GImarg;
  EMGroupImg.left := GImarg;
  with EMGroupImg.canvas do begin
    font.name := 'arial';
    font.size := 8;
    font.color := clBlack;
    textout(1,GImarg,           'General Electr.');
    textout(1,GImarg+  GIlinesp,'Mitsubishi');
    textout(1,GImarg+2*GIlinesp,'Westinghouse');
    textout(1,GImarg+3*GIlinesp,'English Electr.');
  end;
  {prepare image and its background panel for selecting the curve within a group}
  CurveImage.width := CrIwidth;
  CurveImage.height := 9*GIlinesp;
  CurveImage.top := GImarg;
  CurveImage.left := GImarg;
  CurveImage.picture := nil;
  EMCurveImg.width := CrIwidth;
  EMCurveImg.height := 8*GIlinesp;
  EMCurveImg.top := GImarg;
  EMCurveImg.left := GImarg;
  CurveImage.picture := nil;
  CurvePanel.width := CurveImage.width+2*GImarg;
  CurvePanel.height := CurveImage.height+2*GImarg;
  CurvePanel.top := (CurveRow+1)*(pGrid^.DefaultRowHeight+pGrid^.GridLineWidth)
                    +ValueGrid.top{-GroupPanel.height};
  CurvePanel.left := FirstWidth+ValueGrid.left;
  {initialize the memo for descriptions}
  DescrMemo.top := LabelGrid.top+10;
  DescrMemo.left := LabelGrid.left+10;
  DescrMemo.width := LabelGrid.width-20;
  DescrMemo.height := LabelGrid.height-20;
  {set the position of the spin button for time multiplier}
  ipu := (TimeSpinBut.height-ValueGrid.DefaultRowHeight) div 2;
  TimeSpinBut.top := ValueGrid.top+MultRow*(ValueGrid.DefaultRowHeight+
                                            ValueGrid.GridLineWidth)-ipu;
end;

procedure TPQForm.FormDeactivate(Sender: TObject);
{read parameters, hide form after non-fault calculations}
(*
var
  apu,apv : single;    {temporary}
  apw,apx : single;    {temporary}
  cnt     : integer;   {number of lines}
  errc    : integer;   {error flag}
  inHelp  : boolean;   {mouse is in the help memo}
  ii,jj,i : integer;   {indices}
  ipComp  : longint;   {pointer as iteger}
  ipSet   : longint;   {pointer to the common as integer}
  kk      : integer;   {temporary}
  line    : string;    {temporary}
  ll      : longint;
  npar    : integer;   {no of parameters}
  oldval  : single;    {old value of parameter}
  pComp   : TpComp;
  pHelp   : TpMemo;    {pointer to the help-memo}
  pMod    : TpelComp;  {pointer to the model component}
  pSet    : TpCompSet; {pointer to the common}
  st1,st2 : string;    {temporary}
  st3,st4 : string;    {temporary}
  xy,xysc : TPoint;
*)
begin
  GridCalc.FormDeactivate(sender);
(*
  {when in coordination graphics, can be closed only with the OKbutton or CanceButton}
{ if (not Imagoo.RelCharBut.down) or
     ((Imagoo.RelCharBut.down) and
      (((Sender as TControl).name = OKButton.name) or
       ((Sender as TControl).name = CancelBut.name))) then begin}
  {check first that the help-memo was not clicked}
  if ({pActPQ}GridCalc.pAct_c <> nil) then begin
    {pActPQ^}GridCalc.pAct_c^.GetpMod(pMod);       {pointer to the model component}
    pMod^.GetpHelp(pHelp);       {pointer to the help memo}
    if (pHelp <> nil) then begin
      if (pHelp^.visible) then begin
        GetCursorPos(xysc);       {mouse position in screen coordinates}
        xy := Imagoo.ScreentoClient(xysc);  {position in coord. of imagoo-form}
        if (xy.x >= pHelp^.left) and (xy.x <= pHelp^.left+pHelp^.width) and
           (xy.y >= pHelp^.top ) and (xy.y <= pHelp^.top+pHelp^.height) then
           inHelp := true
        else inHelp := false;
      end else begin
        inHelp := false;
      end;
    end else begin
      inHelp := false;
    end;
  end else begin
    inHelp := false;
  end;
  {must not do this, when deleting, copying or when clicking the help memo}
  if (not appl_close) and (not inHelp) and
     (not SetComp.copy_click) then begin
    pComp := {pActPQ}GridCalc.pAct_c;
    if (pComp <> nil) then begin
      pComp^.GetipSet(ipSet);
      pSet := TpCompSet(ipSet);
      {parameters from grid to component}
      pComp^.GetNpar(npar);
      for ii := pGrid^.FixedRows to pGrid^.RowCount-pGrid^.FixedRows do begin
        for jj := pGrid^.FixedCols to pGrid^.ColCount-pGrid^.FixedCols do begin
          i := (ii-pGrid^.FixedRows)*(pGrid^.ColCount-pGrid^.FixedCols)+
               (jj-pGrid^.FixedCols+1);
          if (i > npar) then break;      {all parameters included}
          if (Sender = CancelBut) then begin
            line := BackPar[i];          {restore old values}
            pGrid^.Cells[jj,ii] := line;
          end else begin
            line := pGrid^.Cells[jj,ii];
          end;
          {save for next (eventual) "cancel"}
{not yet  if (Sender <> ApplyBut) then MhoGrid.Cells[2,i-1] := line;}
          ValuesFromLine(line,1,kk, apu,apv,apw,apx,st1,st2,st3,st4,errc); {one parameter a time}
          {set error flag, it is checked and reset in TCompSet.FormMouseDown}
          if (errc <> 0) then begin
            SetComp.err_cs := 1;
          end else begin
            pComp^.getpar(i,oldval);       {get the old value, for comparisons}
            pComp^.putpar(i,apu);          {save the parameter to the component}
            if (oldval <> apu) then SetComp.IsChanged := true; {flag the change}
          end;
        end;
      end;
      {save the identifications = descriptions}
      pComp^.PutDescrP(7,LabelGrid.cells[1,0],LabelGrid.cells[1,1],LabelGrid.cells[1,2]);
      pComp^.PutDescrG(7,LabelGrid.cells[1,3],LabelGrid.cells[1,4],LabelGrid.cells[1,5]);
      pComp^.PutDescrQ(7,LabelGrid.cells[1,6],LabelGrid.cells[1,7],LabelGrid.cells[1,8]);
      {copy additional descriptions from memo}
      pComp^.pDescr_s^.Clear;
      cnt := DescrMemo.lines.count;     {no of rows}
      if (cnt > 0) then begin           {there is something}
        for ii := 0 to cnt-1 do begin   {index starts from 0}
          line := DescrMemo.lines[ii];
          pComp^.pDescr_s^.add(line);
        end;
      end;
      if (not Imagoo.RelCharBut.down) then begin {do not hide, if in coord.graph. mode}
        {hide also the memo}
        NotesItem.checked := false;
        DescrMemo.visible := false;
        {hide the form}
        ll := longint(pComp);
        PQRelayHideIf(ll,Sender);
        pComp^.GetipSet(ipSet);
        if (Sender <> ApplyBut) then unmark(ipset); {copy-paste works, when no unmark here}
      end else begin
        ipComp := longint(pComp);
        RelayShowIf(ipComp);              {update graphics, if visible}
      end;
    end;
  end else begin
{   if (inHelp) then PQForm.SetFocus;  {return focus, so that deactivate works next time}
{ end;}
  end;
*)
end;

procedure TPQForm.CurvePanelTexts;
{write the texts to the image on the curve panel, set the size of the panel and image}
var
  ii   : integer;
  text : string;  {temporary}
begin
  text := ValueGrid.cells[CurveCol,GroupRow];
  ii := strtoint(text);                   {group}
  if (ii <= 1) then begin
    CurveImage.picture := nil;            {clear initially}
    CurveImage.height := 5*GIlinesp;
    with CurveImage.canvas do begin
      font.name := 'arial';
      font.size := 8;
      font.color := clBlue;
      textout(1,GImarg,           'standard inv.');
      textout(1,GImarg+  GIlinesp,'very inverse');
      textout(1,GImarg+2*GIlinesp,'Extremely inv.');
      textout(1,GImarg+3*GIlinesp,'Long-time inv.');
      textout(1,GImarg+4*GIlinesp,'Short-time inv.');
    end;
  end else if (ii = 2) then begin
    CurveImage.picture := nil;            {clear initially}
    CurveImage.height := 5*GIlinesp;
    with CurveImage.canvas do begin
      font.name := 'arial';
      font.size := 8;
      font.color := clBlue;
      textout(1,GImarg,           'moderately inv.');
      textout(1,GImarg+  GIlinesp,'inverse');
      textout(1,GImarg+2*GIlinesp,'very inverse');
      textout(1,GImarg+3*GIlinesp,'extremely inv.');
      textout(1,GImarg+4*GIlinesp,'Short-time inv.');
    end;
  end else if (ii = 3) then begin
    CurveImage.picture := nil;            {clear initially}
    CurveImage.height := 9*GIlinesp;
    with CurveImage.canvas do begin
      font.name := 'arial';
      font.size := 8;
      font.color := clBlue;
      textout(1,GImarg,           'extremely inv.');
      textout(1,GImarg+  GIlinesp,'very inverse');
      textout(1,GImarg+2*GIlinesp,'inverse');
      textout(1,GImarg+3*GIlinesp,'short-time inv.');
      textout(1,GImarg+4*GIlinesp,'Short-time ext.inv.');
      textout(1,GImarg+5*GIlinesp,'long-time ext.inv.');
      textout(1,GImarg+6*GIlinesp,'long-time very inv.');
      textout(1,GImarg+7*GIlinesp,'long-time inverse');
      textout(1,GImarg+8*GIlinesp,'recloser curve #8');
    end;
  end else if (ii = 4) then begin
    CurveImage.picture := nil;            {clear initially}
    CurveImage.height := 4*GIlinesp;
    with CurveImage.canvas do begin
      font.name := 'arial';
      font.size := 8;
      font.color := clBlue;
      textout(1,GImarg,           'ANSI extremely inv.');
      textout(1,GImarg+  GIlinesp,'ANSI very inverse');
      textout(1,GImarg+2*GIlinesp,'ANSI normally inv.');
      textout(1,GImarg+3*GIlinesp,'ANSI moderat. inv.');
    end;
  end else if (ii = 5) then begin
    CurveImage.picture := nil;            {clear initially}
    CurveImage.height := 4*GIlinesp;
    with CurveImage.canvas do begin
      font.name := 'arial';
      font.size := 8;
      font.color := clBlue;
      textout(1,GImarg,           'extremely inv.');
      textout(1,GImarg+  GIlinesp,'very inverse');
      textout(1,GImarg+2*GIlinesp,'inverse');
      textout(1,GImarg+3*GIlinesp,'short inverse');
    end;
  end else begin
    CurveImage.picture := nil;            {clear initially}
    CurveImage.height := 4*GIlinesp;
    with CurveImage.canvas do begin
      font.name := 'arial';
      font.size := 8;
      font.color := clBlue;
      textout(1,GImarg,           'BS142 inverse');
      textout(1,GImarg+  GIlinesp,'inverse');
      textout(1,GImarg+2*GIlinesp,'veryinverse');
      textout(1,GImarg+3*GIlinesp,'extremely inv.');
    end;
  end;
  CurvePanel.height := CurveImage.height+2*GImarg;
end;

procedure TPQForm.EMCurveTexts;
{write the texts to the image on the curve panel of the
 electromechanical relay, set the size of the panel and image}
var
  ii   : integer;
  text : string;  {temporary}
begin
  text := ValueGrid.cells[CurveCol,GroupRow];
  ii := strtoint(text);                   {group}
  if (ii <= 1) then begin
    EMCurveImg.picture := nil;            {clear initially}
    EMCurveImg.height := 8*GIlinesp;
    with EMCurveImg.canvas do begin
      font.name := 'arial';
      font.size := 8;
      font.color := clBlue;
      textout(1,GImarg,           'IAC 11');
      textout(1,GImarg+  GIlinesp,'IAC 51');
      textout(1,GImarg+2*GIlinesp,'IAC 53');
      textout(1,GImarg+3*GIlinesp,'IAC 77');
      textout(1,GImarg+4*GIlinesp,'IFC 51');
      textout(1,GImarg+5*GIlinesp,'IFC 53');
      textout(1,GImarg+6*GIlinesp,'IFC 77');
      textout(1,GImarg+7*GIlinesp,'SFC 153');
{     textout(1,GImarg+8*GIlinesp,'SFC 154');}
    end;
  end else if (ii = 2) then begin
    EMCurveImg.picture := nil;            {clear initially}
    EMCurveImg.height := GIlinesp;
    with EMCurveImg.canvas do begin
      font.name := 'arial';
      font.size := 8;
      font.color := clBlue;
      textout(1,GImarg,           'CO-9M ');
    end;
  end else if (ii = 3) then begin
    EMCurveImg.picture := nil;            {clear initially}
    EMCurveImg.height := GIlinesp;
    with EMCurveImg.canvas do begin
      font.name := 'arial';
      font.size := 8;
      font.color := clBlue;
      textout(1,GImarg,           'CO-9W ');
    end;
  end else begin
    EMCurveImg.picture := nil;            {clear initially}
    EMCurveImg.height := 3*GIlinesp;
    with EMCurveImg.canvas do begin
      font.name := 'arial';
      font.size := 8;
      font.color := clBlue;
      textout(1,GImarg,           'CDG 11/21');
      textout(1,GImarg+  GIlinesp,'CDG 13/23');
      textout(1,GImarg+2*GIlinesp,'CDG 14/24');
    end;
  end;
  CurvePanel.height := EMCurveImg.height+2*GImarg;
end;

procedure TPQForm.ValueGridSelectCell(Sender: TObject; Col, Row: Longint;
  var CanSelect: Boolean);
{var
  ix   : integer;  {x-coordinate}
begin
  GridCalc.ValueGridSelectCell( Col, Row);
end;

procedure GetPQText(group, curve : integer; var text : string);
{get the text for the curve to be displayed in the grid for PGQ-relays.
 It depends on the group
 group  index for the group of curves
 curve  index for the curve within the group
 text   the text}
const
 grp1 : array[1..5] of string = ('standard','very','extrem.','long-time','short-time');
 grp2 : array[1..5] of string = ('moderat.','inverse','very','extrem.','short-time');
 grp3 : array[1..9] of string = ('extrem.','very','inverse','short-time',
                                 's-t extr.','l-t extr.','l-t very',
                                 'long-time','recl. #8');
 grp4 : array[1..4] of string = ('extrem.','very','normally','moderat.');
 grp5 : array[1..4] of string = ('extrem.','very','inverse','short-time');
 grp6 : array[1..4] of string = ('BS inv.','inverse','very','extrem.');
begin
  if (group < 1) then begin
    text := '?';
  end else if (group = 1) then begin
    if (curve >=1) and (curve <= 5) then text := grp1[curve]
    else text := '?';
  end else if (group = 2) then begin
    if (curve >=1) and (curve <= 5) then text := grp2[curve]
    else text := '?';
  end else if (group = 3) then begin
    if (curve >=1) and (curve <= 9) then text := grp3[curve]
    else text := '?';
  end else if (group = 4) then begin
    if (curve >=1) and (curve <= 4) then text := grp4[curve]
    else text := '?';
  end else if (group = 5) then begin
    if (curve >=1) and (curve <= 4) then text := grp5[curve]
    else text := '?';
  end else if (group = 6) then begin
    if (curve >=1) and (curve <= 4) then text := grp6[curve]
    else text := '?';
  end else begin
    text := '?';
  end;
end;

procedure GetEMText(group, curve : integer; var text : string);
{get the text for the curve to be displayed in the grid for the electromech.relay.
 It depends on the group
 group  index for the group of curves
 curve  index for the curve within the group
 text   the text}
const
 grp1 : array[1..8] of string = ('IAC 11','IAC 51','IAC 53' ,'IAC 77' ,'IFC 51',
                                 'IFC 53','IFC 77','SFC 153'{,'SFC 154'});
 grp2 : array[1..1] of string = ('CO-9M ');
 grp3 : array[1..1] of string = ('CO-9W ');
 grp4 : array[1..3] of string = ('CDG 11/21','CDG 13/23','CDG 14/24');
begin
  if (group < 1) then begin
    text := '?';
  end else if (group = 1) then begin
    if (curve >=1) and (curve <= 8) then text := grp1[curve]
    else text := '?';
  end else if (group = 2) then begin
    if (curve >=1) and (curve <= 1) then text := grp2[curve]
    else text := '?';
  end else if (group = 3) then begin
    if (curve >=1) and (curve <= 1) then text := grp3[curve]
    else text := '?';
  end else if (group = 4) then begin
    if (curve >=1) and (curve <= 3) then text := grp4[curve]
    else text := '?';
  end else begin
    text := '?';
  end;
end;

procedure GetMainPar(col : integer; var gr,cr,tm  : single; var err : integer);
{get the  group, curve and time multiplier for the relay
 by reading from the value grid, and changing text to number
 col the column
 gr  the group
 cr  the curve
 tm  the time multiplier
 err an error flag}
var
  e1,e2,e3 : integer; {error flags}
  txt      : string;  {temporary}
begin
  txt := PQForm.ValueGrid.cells[col,GroupRow];       {get group index}
  chkfloat(txt,e1);
  if (e1 = 0) then gr := strtofloat(txt) else gr := 1;
  txt := PQForm.ValueGrid.cells[col,CurveRow];       {get curve index}
  chkfloat(txt,e2);
  if (e2 = 0) then cr := strtofloat(txt) else cr := 1;
  txt := PQForm.ValueGrid.cells[col,MultRow];        {get curve index}
  chkfloat(txt,e3);                                  {is it a proper floating point}
  if (e3 = 0) then tm := strtofloat(txt) else tm := 0.5;
  err := e1+10*e2+100*e3;
end;

procedure TPQForm.ValueGridDrawCell(Sender: TObject; Col, Row: Longint;
  Rect: TRect; State: TGridDrawState);
{draw the titles for the cells, etc}
const
  offs = 12;
var
{ clr      : integer;   {color index}
  cr,gr    : single;    {curve,group}
  crc,grc  : integer;   {checked curve, group}
  err      : integer;   {error flag}
{ iclr     : integer;   {color index}
{ ipu      : integer;   {temporary}
  ii,jj    : integer;   {index}
{ ix       : integer;   {coordinates}
  text     : string;    {temporary}
  tm,tmc   : single;    {time multiplier}
begin
  {first column}
  if (col = 0) then begin       {captions to column 0}
    GridCalc.Col0Captions(row,rect);
  end else if (col = ColP) then begin
    GridCalc.ColPCaptions(row,rect);
  end else if (col = ColG) then begin
    GridCalc.ColGCaptions(row, rect);
  end else if (col = ColQ) then begin
    GridCalc.ColQCaptions(row, rect);
  end;
  {color the cells defining line color}
  GridCalc.ColorColorCells(col,row, rect);
  {text for the group of curves}
  if (row = GroupRow) and (col >= 1) then begin
    text := ValueGrid.cells[col,row];
    ii := strtoint(text);
    {different groups for PGQ and electromechanical relays}
    if (RelayType = 'PQ') then begin               {PGQ-relay}
      if      (ii <= 1) then text := 'IEC'
      else if (ii  = 2) then text := 'IEEE C37.'
      else if (ii  = 3) then text := 'ABB'
      else if (ii  = 4) then text := 'ANSI'
      else if (ii  = 5) then text := 'IAC'
      else if (ii  = 6) then text := 'MIC'
      else text := '?';
    end else if (RelayType = 'EM') then begin      {electromech.relay}
      if      (ii <= 1) then text := 'Gen. El.'
      else if (ii  = 2) then text := 'Mitsub.'
      else if (ii  = 3) then text := 'Westingh.'
      else if (ii  = 4) then text := 'Engl. El.'
      else text := '?';
    end else begin
      text := '';
    end;
    pGrid^.canvas.font.name := 'arial';
    pGrid^.canvas.font.size := 8;
    if (text <> '?') then pGrid^.canvas.font.color := clBlack
    else pGrid^.canvas.font.color := clRed;
    pGrid^.canvas.font.style := [];
    pGrid^.canvas.TextOut(16+rect.left,rect.top+2,text);
  {text for the curves}
  end else if (row = CurveRow) and (col >= 1) then begin {text for the curves}
    text := ValueGrid.cells[col,GroupRow];               {get group index}
    ii := strtoint(text);
    text := ValueGrid.cells[col,row];                    {get curve index}
    jj := strtoint(text);
    if (RelayType = 'PQ') then GetPQText(ii,jj,text)     {get text for these indices}
    else if (RelayType = 'EM') then GetEMText(ii,jj,text)
    else GetPQText(0,0,text);                            {error, get '?'}
    pGrid^.canvas.font.name := 'arial';
    pGrid^.canvas.font.size := 8;
    if (text = '?') then pGrid^.canvas.font.color := clRed
    else pGrid^.canvas.font.color := clBlack;
    pGrid^.canvas.font.style := [];
    pGrid^.canvas.TextOut(16+rect.left,rect.top+2,text);
  {check time multiplier for electromech.relays}
  end else if (row = MultRow) and (col >=1) then begin
    if (RelayType = 'EM') then begin
      GetMainPar(col, gr,cr,tm, err);
      if (err = 0) then begin                 {parameters are OK}
        CheckGroupAndCurve(tm , gr , cr, tmc,grc, crc);
        {mark the time multiplier, if not correct parameters}
        if (tm <> tmc) or (gr <> grc) or (cr <> crc) then begin
          pGrid^.canvas.font.name := 'arial';
          pGrid^.canvas.font.size := 8;
          pGrid^.canvas.font.color := clRed;
          pGrid^.canvas.font.style := [];
          pGrid^.canvas.TextOut(16+rect.left,rect.top+2,'?');
        end;
      end;
    end;
  {same line impedance on all columns, grey-out columns 2 and 3}
  end else if ((row = Zrow  ) or (row = fiiRow)) and ((col = ColG) or (col = ColQ)) then begin
    GridCalc.CopyLineImpedance(row, rect);
  {title (caption) of the test current}
  end else if (row = CurrRow) and (col > 0) then begin
    pGrid^.canvas.pen.color := clBtnFace;
    pGrid^.canvas.brush.color := clBtnFace;
    pGrid^.canvas.rectangle(rect.left,rect.top,rect.left+
           pGrid^.DefaultColWidth,rect.top+pGrid^.DefaultRowHeight);
  end;
end;

procedure TPQForm.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  {eventual "delete component" must be handled here, because the form has focus}
  if (SetComp.pActComp <> nil) then begin     {some component active}
    if (key = 46) then begin                  {delete-key}
      SetComp.FormKeyDown(Key, Shift);        {delete the component}
    end;
  end;
end;

procedure TPQForm.ColorImageMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
{get color index from X and Y}
begin
  GridCalc.ColorImageMouseUp(X, Y);
end;
(*
var
  ii,jj,kk : integer;
begin
  ii := (X div (CRwidth+CRspace))+1;
  jj := (Y div (CRwidth+CRspace))+1;
  kk := (ii-1)*4+jj;                 {color index}
  ValueGrid.cells[ColorCol,ColorRow] := inttostr(kk);
  ImagePanel.visible := false;
end;
*)
procedure TPQForm.OKButtonClick(Sender: TObject);
{accept parameters, hide the form (if..)}
begin
  GridCalc.OKButtonClick(Sender);
end;
(*
var
  ipSet : longint;
begin
  if ({pActPQ}GridCalc.pAct_c <> nil) then {pActPQ^}GridCalc.pAct_c^.var2_s := 1;     {flag for the button}
  FormDeactivate(sender);   {save the parameters, recalculate impedances, etc}
  ipSet := longint(@SetComp);
  if not (Imagoo.RelCharBut.down) then unmark(ipSet);
end;
*)
procedure TPQForm.CancelButClick(Sender: TObject);
{do not accept parameters, return old, if apply-button has been used}
begin
  GridCalc.CancelButClick(Sender);
end;
(*
var
  ipSet : longint;
begin
  if ({pActPQ}GridCalc.pAct_c <> nil) then {pActPQ^}GridCalc.pAct_c^.var2_s := 2; {flag for the button}
  FormDeactivate(sender);                      {restore old parameters}
  ipSet := longint(@SetComp);
  if not (Imagoo.RelCharBut.down) then unmark(ipSet);
end;
*)
procedure TPQForm.ApplyButClick(Sender: TObject);
{apply the parameters, but do not yet accept}
begin
  GridCalc.ApplyButClick(Sender);
end;
(*
begin
  if ({pActPQ}GridCalc.pAct_c <> nil) then {pActPQ^}GridCalc.pAct_c^.var2_s := 3; {flag for the button}
  FormDeactivate(sender);                      {restore old parameters}
end;
*)

procedure TPQForm.LabelGridSelectCell(Sender: TObject; Col, Row: Longint;
  var CanSelect: Boolean);
begin
  GridCalc.LabelGridSelectCell(Row);
end;
(*
  LabActRow := row;
  {send an "enter"-key press, to select the cell (remove the color), if such an option}
  if not (ColorItem.checked) then begin
    keybd_event(VK_SHIFT, 0, 0, 0);
    keybd_event(13, 0, 0, 0);
    keybd_event(VK_SHIFT, 0, KEYEVENTF_KEYUP, 0);
  end;
end;
*)
procedure TPQForm.LabelGridDrawCell(Sender: TObject; Col, Row: Longint;
  Rect: TRect; State: TGridDrawState);
{write fixed texts, using different colors}
const
  offs = 4;
begin
  LabelGrid.canvas.font.style := [fsBold];
  LabelGrid.canvas.font.name := 'Arial';
  LabelGrid.canvas.font.size := 8;
  if (col = 0) then begin
    if (row <= 2) then begin
      LabelGrid.canvas.font.color := clRed;
      if      (row = 0) then LabelGrid.canvas.TextOut(offs+rect.left,rect.top,'ID P(1)')
      else if (row = 1) then LabelGrid.canvas.TextOut(offs+rect.left,rect.top,'ID P(2)')
      else if (row = 2) then LabelGrid.canvas.TextOut(offs+rect.left,rect.top,'ID P(3)');
    end else if (row <= 5) then begin
      LabelGrid.canvas.font.color := clGreen;
      if      (row = 3) then LabelGrid.canvas.TextOut(offs+rect.left,rect.top,'ID G(1)')
      else if (row = 4) then LabelGrid.canvas.TextOut(offs+rect.left,rect.top,'ID G(2)')
      else if (row = 5) then LabelGrid.canvas.TextOut(offs+rect.left,rect.top,'ID G(3)');
    end else if (row <= 8) then begin
      LabelGrid.canvas.font.color := clBlue;
      if      (row = 6) then LabelGrid.canvas.TextOut(offs+rect.left,rect.top,'ID Q(1)')
      else if (row = 7) then LabelGrid.canvas.TextOut(offs+rect.left,rect.top,'ID Q(2)')
      else if (row = 8) then LabelGrid.canvas.TextOut(offs+rect.left,rect.top,'ID Q(3)');
    end;
  end;
end;

procedure TPQForm.ValueGridKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
{when up in the uppermost cell, move to the label grid}
begin
  if ( GridCalc.ActRow_c <= 1) and (key = 38) then begin  {if up-key, move to the label grid}
{   ActiveControl := LabelGrid;    no more}
  end;
end;

procedure TPQForm.LabelGridKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  {if down-key, move to the value grid}
  if (GridCalc.LabActRow_c = LabelGrid.RowCount-1) and (key = 40) then begin
{   ActiveControl := ValueGrid;  no more}
  end;
end;

procedure TPQForm.HintButClick(Sender: TObject);
{display the help-memo}
begin
  GridCalc.HintButClick(Sender);
end;  
(*
var
  pHelp : TpMemo;     {poointer to the help-memo}
  pMod  : TpElComp;   {pointer to the model component}
begin
  if ({pActPQ}GridCalc.pAct_c <> nil) then begin
    {pActPQ^}GridCalc.pAct_c^.GetpMod(pMod);
    pMod^.GetpHelp(pHelp);
    if (pHelp <> nil) then begin
      pHelp.top := 200;
      pHelp.left := 100;
      pHelp.width := 450;
      pHelp.height := 300{670};
      pHelp.visible := true;
    end;
  end;
end;
*)

procedure TPQForm.LabelGridEnter(Sender: TObject);
begin
  GroupPanel.visible := false;
  ImagePanel.visible := false;
  FirstTime := true;
end;

procedure TPQForm.ValueGridEnter(Sender: TObject);
var
cs : boolean;
{is this really necessary ? 28.3.2005}
begin
  {must select cell, because it does not work first time, for some reason}
  if (FirstTime) then begin
    ValueGridSelectCell(Sender,GridCalc.ActCol_c,GridCalc.ActRow_c, cs);
    FirstTime := false;
  end;
end;

procedure TPQForm.GroupImageMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  jj : integer;   {index for the group}
  ww : word;
begin
  jj := ((Y-GImarg) div GIlinesp)+1;    {index of group}
  ValueGrid.cells[GroupCol,GroupRow] := inttostr(jj);
  GroupPanel.visible := false;
  {if curve changes, must recalculate act.time for test current}
  ww := 13;                             {just some value}
  ValueGridKeyUp(Sender, ww , Shift);
end;

procedure TPQForm.CurveImageMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  jj : integer;   {index for the group}
  ww : word;
begin
  jj := ((Y-GImarg) div GIlinesp)+1;    {index of curve}
  ValueGrid.cells[CurveCol,CurveRow] := inttostr(jj);
  CurvePanel.visible := false;
  {if curve changes, must recalculate act.time for test current}
  ww := 13;                             {just some value}
  ValueGridKeyUp(Sender, ww , Shift);
end;

procedure TPQForm.ValueGridKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  GridCalc.ValueGridKeyUp(Key);
end;

procedure TPQForm.ColorItemClick(Sender: TObject);
begin
  ColorItem.checked := not ColorItem.checked;
end;

procedure TPQForm.ExitItemClick(Sender: TObject);
begin
  visible := false;
end;

procedure TPQForm.NotesItemClick(Sender: TObject);
{show/not the memo for notes}
begin
  NotesItem.checked := not NotesItem.checked;
  DescrMemo.visible := NotesItem.checked;
  GroupPanel.visible := false;
  CurvePanel.visible := false;
  ImagePanel.visible := false;
end;

procedure TPQForm.DescrMemoMouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
{move the memo for notes}  
const
  x0  : integer = 0;    {old coordinates}
  y0  : integer = 0;
begin
  if (ssLeft in Shift) then begin        {left button pressed}
    DescrMemo.left := DescrMemo.left+X-x0;
    DescrMemo.top  := DescrMemo.top +Y-y0;
  end else begin
    x0 := X;
    y0 := Y;
  end;

end;

procedure TPQForm.FormKeyPress(Sender: TObject; var Key: Char);
begin
  {check decimal point for value grid}
(*
  if (ActiveControl.name = 'ValueGrid') then begin
    if (key = '.') or (key = ',') then begin
      if (key <> d_p) then key := d_p;
    end;
  end;
cannot do in this way, because if keypreview is true, the delte does not work !?*)
end;

procedure TPQForm.PhaseItemClick(Sender: TObject);
var
  col,row : integer;
{ Rect    : TRect; }
begin
  if not(PhaseItem.checked) then begin
    PhaseItem.checked := true;
    NegSeqItem.checked := false;
    PlaneMenu.caption := 'PHASE PLANE';
    {copy the state to the relaycurr-form}
    if (sender = PhaseItem) then begin
      RelayCurr.PhaseItem_rcClick(sender);
      RecloserForm.PhaseItemClick(sender);
      {change also the curves}
      if (GridCalc.pAct_c <> nil) then Relay_Show(GridCalc.pAct_c);
    end;
    {grey out some of the test inputs, depending on the plane}
{   ValueGridDrawCell(Sender, 3, CurrTestRow, Rect,[gdFixed]); WHY IS this here, is it needed?}
    {"grey out" of the test inputs of the neg.seq.relays}
    GridCalc.GreyOutCells(3,3,CurrTestRow,RelCurrRow);
    { remove "the grey out" from the phase and ground relays}
    for col := 1 to 2 do begin
      row := CurrTestRow;
      pGrid^.cells[col,row  ] := '0';
      pGrid^.cells[col,row+1] := '0';
      pGrid^.cells[col,row+2] := '0';
    end;
  end;
end;

procedure TPQForm.GetTestRows(var ctrow, ttrow, rcrow : integer);
{get the row numbers for the test current input and time input}
begin
  ctrow := CurrTestRow;
  ttrow := TimeTestRow;
  rcrow :=RelCurrRow;
end;

procedure TPQForm.GreyOutCells(col1,col2,row1,row2: integer);
{"grey out" the cells from col1, row1 to col2,row2}
var
  col   : integer;  {column index}
  ix,iy : integer;  {coordinates of upper corner of the cells}
  row   : integer;  {row index}
begin
  if (col1 >= 0) and (col2 >= col1) and (col2 < pGrid^.ColCount) and
     (row1 >= 0) and (row2 >= row1) and (row2 < pGrid^.RowCount) then begin
    pGrid^.canvas.pen.color := clBtnFace;
    pGrid^.canvas.brush.color := clBtnFace;
    for col := col1 to col2 do begin
      for row := row1 to row2 do begin
        ix := FirstWidth+(col-1)*(pGrid^.DefaultColWidth)+col*pGrid^.GridLineWidth;
        iy := row*(pGrid^.DefaultRowHeight+pGrid^.GridLineWidth);
        pGrid^.canvas.rectangle(ix,iy,ix+pGrid^.DefaultColWidth,
                                  iy+pGrid^.DefaultRowHeight);
      end;
    end;
  end;
end;

procedure TPQForm.NegSeqItemClick(Sender: TObject);
var
  col, row : integer;
{ ix,iy    : integer;  {x,y coord of the cell (let, top)}
begin
  if not(NegSeqItem.checked) then begin
    PhaseItem.checked := false;
    NegSeqItem.checked := true;
    PlaneMenu.caption := 'NEGATIVE SEQUENCE PLANE';
    {copy to form of curves, and recloser form}
    if (sender = NegSeqItem) then begin
      RelayCurr.NegSeqItem_rcClick(sender);
      RecloserForm.NegSeqItemClick(sender);
      {change also the curves}
      if (GridCalc.pAct_c <> nil) then Relay_Show(GridCalc.pAct_c);
    end;
    (*
    RelayCurr.PlaneMenu.caption := 'NEGATIVE SEQUENCE PLANE';
    RelayCurr.PhaseItem_rc.checked := false;
    RelayCurr.NegSeqItem_rc.checked := true;
    RecloserForm.PlaneMenu.caption := 'NEGATIVE SEQUENCE PLANE';
    RecloserForm.PhaseItem.checked := false;
    RecloserForm.NegSeqItem.checked := true;
    if (GridCalc.pAct_c <> nil) then Relay_Show(GridCalc.pAct_c);
    *)
    {"grey out" of the test inputs of the phase and ground relays}
    GridCalc.GreyOutCells(1,2,CurrTestRow,RelCurrRow);
    { remove "the grey out" from the neg.seq. relay}
    col := 3;
    row := CurrTestRow;
    pGrid^.cells[col,row  ] := '0';
    pGrid^.cells[col,row+1] := '0';
    pGrid^.cells[col,row+2] := '0';
  end;
end;

procedure TPQForm.FormHide(Sender: TObject);
{unmasrk component, when PQ form changed to not visible,
 but not when closing the whole program}
var
  ipSet : longint;
begin
  if ({pActPQ}GridCalc.pAct_c <> nil) and (not {SetComp.}appl_close) then begin
    {pActPQ^}GridCalc.pAct_c^.GetipSet(ipSet);
    unmark(ipSet);
  end;
  TimeSpinBut.visible := false;
end;

procedure TPQForm.EMGroupImgMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  GroupImageMouseUp(Sender, Button, Shift, X, Y);
end;



procedure TPQForm.EMCurveImgMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  CurveImageMouseUp(Sender, Button, Shift, X, Y);
end;

procedure ChangeTimeMultiplier(upordown : single);
{change the time multiplier of an electromech.relay up or down by one step
 upordown  if > 0, change up, else down}
var
  apu     : single;   {temporary}
  cr,gr   : single;   {curve, group}
  crc,grc : integer;  {checked curve, group}
  err     : integer;  {error flag}
  first   : single;   {the first (smallest) time multiplier}
  ii      : integer;
  ipu     : integer;  {temporary}
  len     : integer;  {length of string}
  ntm     : integer;  {the number of char. = number of time multipliers}
  last    : single;   {the last (largest) time multiplier}
  step    : single;   {step time multiplier}
  tm      : single;   {time multiplier}
  tmc     : single;   {checked time multiplier}
  txt,txx : string;   {temporary}
begin
  GetMainPar(GridCalc.ActCol_c, gr,cr,tm, err);              {get group, curve, time multiplier}
  if (err = 0) then begin                            {managed to read parameters}
    CheckGroupAndCurve(tm , gr , cr, tmc, grc, crc); {check the main parameters}
    GetEMtmPar(grc, step, first, ntm);               {parameters for the time multiplier}
    apu := first+(ntm-1)*step;
    ipu := round(100.0*apu);
    last := ipu/100.0;
    if (upordown <= 0) then begin                 {change down}
      {set to max. value, if too large}
      if (tmc > last) then tmc := last            {too large}
      else if (tmc > first) then tmc := tmc-step  {reasonable}
      else tmc := first;                          {too small}
    end else begin                                {change up}
      if (tmc < first) then tmc := first
      else if (tmc < last) then tmc := tmc+step
      else tmc := last;
    end;
    {write with two decimals}
    ipu:= round(100*tmc);
    txt := inttostr(ipu);
    len := length(txt);
    txx := '';
    if (len >= 3) then begin
      for ii := 1 to len-2 do txx := txx+txt[ii];   {integer part}
      txx := txx+{PQForm.}d_p;                      {add decimal point}
      for ii := len-1 to len do txx := txx+txt[ii]; {decimal part}
    end else begin
      txx := '0'+{PQForm.}d_p+txt;                  {0,05 or 0.50, should be}
    end;
    PQForm.ValueGrid.cells[GridCalc.ActCol_c,MultRow] := txx;        {value to grid}
  end else begin
    {some error, do nothing, so far ?}
  end;
end;

procedure TPQForm.TimeSpinButDownClick(Sender: TObject);
{decrease the time multiplier by one step (0.5 or 0.05)}
const
  key : word = 0;
begin
  ChangeTimeMultiplier(-1);
  ValueGridKeyUp(Sender,key,[]);
end;

procedure TPQForm.TimeSpinButUpClick(Sender: TObject);
const
  key : word = 0;
begin
  ChangeTimeMultiplier(1);
  ValueGridKeyUp(Sender,key,[]);
end;

procedure TPQForm.FormDestroy(Sender: TObject);
begin
  GridCalc.free;     {free the object for procedures}
end;

procedure TPQForm.ParamItemClick(Sender: TObject);
begin
if (ParamItem.checked) then begin
    ParamItem.checked := false;
    ParamItem.caption := 'Show parameters';
    ValueGrid.visible := false;
    LabelGrid.visible := true;
    CurvePanel.visible := false;
    ImagePanel.visible := false;
    GroupPanel.visible := false;
  end else begin
    ParamItem.checked := true;
    ParamItem.caption := 'Show texts';
    ValueGrid.visible := true;
    LabelGrid.visible := false;
  end;
end;

procedure TPQForm.SaveItemClick(Sender: TObject);
{save the data for the selected curve to file}
var
  apu,apv : single;    {temporary}
  DirName : string;    {name of directory wher the file is}
  curr1st : single;    {value of the first current in the array}
  curve   : single;    {index of curve}
  fact    : single;    {pickup factor}
  group   : single;    {index of group}
  iCurve  : integer;   {index for the curve}
  iGroup  : integer;   {index for the group}
  ii,jj   : integer;   {index}
  i,j,k   : integer;   {dummy integers}
  Imax    : single;    {maximum current}
  Iss     : single;    {set current (starting current)}
  ktm     : single;    {time multiplier}
  nEntr   : integer;   {number of entries (elements)}
  Ni      : integer;   {max. number of points(-1)}
  offs    : integer;   {offset, 0 or 1, depending on the value of the first current}
  Outfile : TextFile;  {file where written}
  pChar   : pSingle;   {pointer to the data}
  pComp   : TpComp;    {pointer to the relay}
  rr      : integer;   {index of relay module}
  Timult  : single;    {time multiplier}
  txt     : string;    {temporary}
begin
  if (SaveDlg.execute) then begin
    if (GridCalc.RelTyp_c = 'EM') then begin
      {find group and curve}
      txt := GridCalc.pGrid_c^.Cells[GridCalc.ActCol_c,GridCalc.RowInd_c.GroupRow];
      iGroup := strtoint(txt);            {index of the group}
      txt := GridCalc.pGrid_c^.Cells[GridCalc.ActCol_c,GridCalc.RowInd_c.CurveRow];
      iCurve := strtoint(txt);            {index of the curve}
      {find time multiplier}
      txt := GridCalc.pGrid_c^.Cells[GridCalc.ActCol_c,GridCalc.RowInd_c.MultRow];
      Timult := strtofloat(txt);          {time multiplier}
      {get pointer to the data and number of items}
      GetEMChar(iGroup, iCurve, Timult, pChar, curr1st, nEntr );
      offs := round(curr1st)-1;           {offset, 0 or 1}
      {make preparations for writing}
      DirName := '';                                {initialize}
      DirName := ExtractFileDir(SaveDlg.filename);  {get directory}
      {if reasonable directory name found, save it for next time}
      if (length(DirName) >=2) then SaveDlg.InitialDir := DirName;
      try
        AssignFile(Outfile, SaveDlg.filename);      {open the given file,BUT ERRORS ?}
        rewrite(outfile);
        for ii := 1 to nEntr do begin
          {current, first current may not be an integer}
          if (ii = 1) then txt := TwoDecimalsAtMost(curr1st) else txt := inttostr(ii+offs);
          txt := txt+'  '+format('%8.6f',[pChar^]);  {add time}
          writeln(outfile,txt);
          inc(pChar);
        end;
      finally
        closefile(outfile);
      end;
    end else if (GridCalc.RelTyp_c = 'PQ') then begin     {PGQ-relay}
      rr := GridCalc.GetActCol;               {index of relay module = column}
      if (rr > 0) and (rr <= 3) then begin    {reasonable indes (should be)}
        {get the parameters of the curve}
        pComp := GetActPQ;                    {pointer to the relay}
        pComp^.GetPar(gPQ_Iset[rr],Iss);      {set current}
        if (Iss <= 0) then Iss := 1;
        pComp^.GetPar(gPQ_Tmult[rr],ktm);     {get the time multiplier}
        if (ktm <= 0) then ktm := 1;
        pComp^.GetPar(gPQ_fact[rr],fact);     {pickup factor}
        if (fact < 1) then fact := 1;
        pComp^.GetPar(gPQ_group[rr],group);   {index of group of curves}
        pComp^.GetPar(gPQ_curve[rr],curve);   {index of curve within group}
        pComp^.GetPar(gPQ_Imax[rr],Imax);     {max.current}
        {calculate several points on the curve, do not draw!}
        RelayCharact.DrawInvTimeChar(Iss,ktm,fact,0,0,group,curve,gPQrel,Imax,i,j,k,nil);
        {save the calculated points to file}
        Ni := high(RelayCharact.CurrArr);     {number of points}
        {make preparations for writing}
        DirName := '';                                {initialize}
        DirName := ExtractFileDir(SaveDlg.filename);  {get directory}
        {if reasonable directory name found, save it for next time}
        if (length(DirName) >=2) then SaveDlg.InitialDir := DirName;
        try
          AssignFile(Outfile, SaveDlg.filename);       {open the given file}
          rewrite(outfile);
          for ii := 1 to Ni do begin
            jj := Ni-ii+1;                             {start from the end = smallest current}
            apu := RelayCharact.CurrArr[jj]/Iss;           {current}
            apv := RelayCharact.TimeArr[jj]/ktm;           {time}
            if (apu > 0) and (apv > 0) then begin
              txt := format('%8.2f',[apu])+'  '+format('%8.4f',[apv]);
              writeln(outfile,txt);
            end;
          end;
        finally
          closefile(outfile);
        end;
      end;
    end;
  end;
end;

end.
