unit Paramrep;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, StdCtrls, ComCtrls, Tabnotbk, ExtCtrls, Tab, Utildef, Skemadef,
  Imagodef, Routines, Buttons, Earthflt, shortcir, printers,PQrelay, polygon,
  recloser;

type
  TParamForm = class(TForm)
    TetMenu: TMainMenu;
    FileMenu: TMenuItem;
    PageItem: TMenuItem;
    PrintItem: TMenuItem;
    SaveItem: TMenuItem;
    N1: TMenuItem;
    ExitItem: TMenuItem;
    EditItem: TMenuItem;
    TabItem: TMenuItem;
    DelItem: TMenuItem;
    ButPanel: TPanel;
    Params: TTabbedNotebook;
    ParamMemo: TMemo;
    SourceBut: TSpeedButton;
    TrafoBut: TSpeedButton;
    RelayBut: TSpeedButton;
    DistBut: TSpeedButton;
    ImpedBut: TSpeedButton;
    MotorBut: TSpeedButton;
    LoadBut: TSpeedButton;
    TabEdit: TEdit;
    SaveDi: TSaveDialog;
    HelpBut: TSpeedButton;
    PrintDi: TPrintDialog;
    PQRelayBut: TSpeedButton;
    BusBut: TSpeedButton;
    NumberBut: TSpeedButton;
    PolyBut: TSpeedButton;
    RCrelayBut: TSpeedButton;
    FilterBut: TSpeedButton;
    LabelBut: TSpeedButton;
    N2: TMenuItem;
    DelAllItem: TMenuItem;
    CTBut: TSpeedButton;
    GroupBut: TSpeedButton;
    procedure ExitItemClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure PageItemClick(Sender: TObject);
    procedure FormClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormDestroy(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure TabItemClick(Sender: TObject);
    procedure TabEditExit(Sender: TObject);
    procedure TabEditKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ParamMemoClick(Sender: TObject);
    procedure SaveItemClick(Sender: TObject);
    procedure DelItemClick(Sender: TObject);
    procedure PrintItemClick(Sender: TObject);
    procedure DelAllItemClick(Sender: TObject);
    procedure GroupButClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

const
  flagval = 0.00390625;   {value used as a flag}
var
  ParamForm: TParamForm;
  MemoPntrArr : array[1..maxmem] of TpRichEdit;  {maxmem defined in tab.pas}

implementation

uses Imagopas, distance, nodes;

{$R *.DFM}

procedure TParamForm.ExitItemClick(Sender: TObject);
 begin
  ParamForm.visible := false;
  Imagoo.ParamView.checked := false;
end;

procedure TParamForm.FormCreate(Sender: TObject);
{initialize the form position etc.}
var
  ii : integer;  {index}
begin
  {initialize the memos}
  for ii := 1 to maxmem do begin     {clear pointers to memos initially}
    MemoPntrArr[ii] := nil;
  end;
  MemoPntrArr[1] := @ParamMemo;      {the first memo must be there}
  MemoPntrArr[1]^.width := FormWidth-20; {width of (all) memos}
  ParamForm.left := FormLeft;        {put the form to the upper left corner}
  ParamForm.top := FormTop;
  ParamForm.width := FormWidth;
  Params.width := FormWidth-10;           {initial width of the notebook}
  SaveDi.InitialDir := Imagoo.ParIniDir;  {saved in imagoo.create}
  {add flag that form created}
  Imagoo.ReadyEdit.text := Imagoo.ReadyEdit.text+'P';
end;

procedure longname(name : string; var nam1, nam2 : string);
{divides a "long" string into two parts
 name   the string to be checked
 nam1   first part of the name
 nam2   eventual second part of the name
 Note: if name is too long, the rest is omitted}
const
  namlen = 10;    {length of one part of the string}
var
  ii  : integer;  {index}
  len : integer;  {length of the name}
begin
  len := length(name);
  nam1 := '';   {initialize}
  nam2 := '';
  if (len = 0) then begin
    for ii := 1 to namlen do begin
      nam1 := nam1+' ';
      nam2 := nam2+' ';
    end;
  end else if (len < namlen) then begin
    for ii := 1 to namlen-len do nam1 := nam1+' ';  {left-fill with spaces}
    for ii := 1 to len do nam1 := nam1+name[ii];    {copy the name}
    for ii := 1 to namlen do nam2 := nam2+' ';
  end else if (len = namlen) then begin
    nam1 := name;                                   {copy as such}
    for ii := 1 to namlen do nam2 := nam2+' ';
  end else if (len < 2*namlen) then begin
    for ii := 1 to namlen do nam1 := nam1+name[ii];
    for ii := namlen+1 to len do nam2 := nam2+name[ii];
    for ii := 1 to 2*namlen-len do nam2 := nam2+' ';{right-fill with spaces}
  end else begin
    for ii := 1 to namlen do nam1 := nam1+name[ii];
    for ii := namlen+1 to 2*namlen do nam2 := nam2+name[ii];
  end;
end;

procedure WriteRelayParam(pMemo : TpRichEdit; namar, typar : array of string;
                         pParam : pSingle; icomp, mcomp,maxpar: integer);
{write the parameters of relays to memo
 pMemo  pointer to the memo
 namar  array of names (ID:s) of current trafos
 typar  array of the type of the (eventual) inverse time relay
 pPar   pointer to the array with the data
 icomp  no of components whose parameters are written
 mcomp  dim of par.array = max no of components
 maxpar max.no of parameters}
var
  apu,apv   : single;    {temporary}
  ii        : integer;   {index}
  jj,kk     : integer;   {index}
  line1     : string;    {one line of text, for first parameter}
  line2     : string;    {one line of text, for second param.}
  pPar1     : pSingle;   {local pointer to the first parameters}
  pPar2     : pSingle;   {local pointer to the second parameter}
  txt1,txt2 : string;    {temporary text}
  text      : string;    {temporary text}
begin
  if (icomp > 0) then begin
    pMemo^.Lines.Add(' ');                 {one empty line}
    {names of current trafos}
    line1 := 'curr. trafo ';
    for ii := 1 to icomp do begin
      longname(namar[ii-1],txt1,txt2);
      line1 := line1+'  '+txt1;
      {neglect the second part of the line, names of CT*s are short, I think}
    end;
    pMemo^.Lines.Add(line1);                 {write the names}
    {write parameters, if allowed}
    if (not ParamForm.LabelBut.down) then begin
      pPar1 := pParam;
      pPar2 := pParam; inc(pPar2,mcomp);       {pointer to second parameter}
      for kk := 1 to maxpar div 2 do begin
        if (kk = 1) then begin                 {inverse time relays first}
          line1 := 'inv.time Is:';
          line2 := 'inv.time  k:';
        end else begin
          line1 := 'def.time I0:';
          line2 := 'def.time  t:';
        end;
        {(eventual) relays have two parameters}
        for jj := 1 to icomp do begin
          apu := pPar1^;                       {first parameter}
          inc(pPar1);
          apv := pPar2^;                       {second parameter}
          inc(pPar2);
          {use a special value to indicate that there is no relay component}
          if (apu <> flagval) or (apv <> flagval) then begin
            line1 := line1+' '+format('%10.4g',[apu]);
            line2 := line2+' '+format('%10.4g',[apv]);
          end else begin
            line1 := line1+' '+'         -';   {obviously no inv.time relay}
            line2 := line2+' '+'         -';
          end;
          if (kk = 1) then text := typar[jj-1] else text := ' ';
          line1 := line1+text;  {indicate type of inv.time relay}
          line2 := line2+text;  {indicate type of inv.time relay}
        end;
        pMemo^.Lines.Add(line1);
        pMemo^.Lines.Add(line2);
        pMemo^.Lines.Add(' ');            {one empty line between relay modules}
        inc(pPar1,mcomp+mcomp-icomp);     {pointer to first parameter}
        inc(pPar2,mcomp+mcomp-icomp);     {pointer to second parameter}
      end;
    end;
  end;
end;

procedure AddRelayPar(pMemo : TpRichEdit; title : string);
{write the relay  parameters to the memo
 pMemo  pointer to the memo
 title  the title for the parameters}
const
  mpar = 20;     {max no of parameters}
  mcomp = 6;     {max no of components handled in one run}
var
  apu      : single;     {temporary}
  bpu      : boolean;    {temporary}
  Chlab    : string;     {checked label (eventual filter flag removed)}
  CTList   : TList;      {list of pointers to current trafos}
  cx,cy    : integer;    {cooridnates of current trafo node}
  err      : integer;    {error flag}
  found    : boolean;    {true, when a relay found}
  icomp    : integer;    {counter for relay (modules)}
  ii,jj,kk : integer;    {indices}
  ipar     : integer;    {counter for parameters}
  ix,iy    : integer;    {label coordinates}
  jcomp    : integer;    {counts components}
  lab      : string;     {label of a component}
  len      : integer;    {length of string}
  line     : string;     {one line text}
  maxpar   : integer;    {max. no of parameters}
  name     : string;     {name of a component}
  nCT      : integer;    {no of current trafos}
  nRel     : integer;    {no of relays}
  pComp    : TpComp;     {pointer to a component}
  pCT      : TpComp;     {pointer to a current trafo}
  pDefT    : TpComp;     {pointer to a definite time relay}
  pHelp    : TpMemo;     {pointer to memo with help text}
  pRelay   : TpComp;     {pointer to a relay module}
  pSet     : TpCompSet;  {pointer to the "common"}
  RCList   : TList;      {list of pointers to relays connected to a current trafo}
  ReList   : TList;      {list of pointers to relays}
  rlab     : string;     {label of a relay}
  rx1,ry1  : integer;    {coordinates of relay node}
  rx2,ry2  : integer;    {coordinates of relay node}
  wrpar    : boolean;    {write parameters}
  namar    : array[1..mcomp] of string;           {names of current transformers}
  parar    : array[1..mpar,1..mcomp] of single;   {array for parameters}
  typar    : array[1..mpar] of string;            {array for inverse time relay types}
begin
  pSet := TpCompSet(ipSetG);       {pointer to the "common"}
  ReList := TList.create;          {create list for relay pointers}
  CTList := TList.create;          {create list for current trafos}
  RCList := TList.create;          {create list for connected relays}
  icomp := 0;
  ipar := 0;
  maxpar := 0;                     {initialize max.no of parameters}
  pComp := nil;                    {initialize pointer to comp.}
  err := 0;
  jcomp := 0;
  {construct lists of relays and current trafos}
  while (err = 0) do begin                  {scan all components}
    pSet^.NextComp(pComp, err,jcomp,false); {pointer to next component}
    if (err = 0) then begin                 {no errors, else no more components}
      pComp^.GetName(name);                 {name of the component}
      if (name = gRelay) or IsInvTimeRelay(name) then begin {(in shortcir.pas)}
        ReList.add(pComp);            {a relay found, add to list}
//      pComp^.longint_s := 0;        {initialize}
      end else if (name = gCurrT) or (name = gSumCT) or (name = gSpecCT) then begin
        CTList.add(pComp);
//      pComp^.longint_s := 0;        {initialize}
      end;
    end;
  end;
  {find relays connected to current trafos}
  nCT := CTList.count;             {no of current trafos}
  nRel := ReList.count;            {no of relays (modules)}
  pRelay := nil;
  if (nCT > 0) and (nRel > 0) then begin
    if (ParamForm.HelpBut.down) then begin   {hint to be written}
      pMemo^.lines.add(' ');                 {one empty line}
      pMemo^.lines.add('Definite time relay');
      pMemo^.lines.add('The relay reacts, if the current is larger than  I0');
      pMemo^.lines.add('for a period longer than  t');
      pMemo^.lines.add(' ');
      pMemo^.lines.add('Inverse time relay');
      pMemo^.lines.add('The Operating time is calculated from');
      pMemo^.lines.add(' ');
      pMemo^.lines.add('          k b            ');
      pMemo^.lines.add(' t =  ---------------    ');
      pMemo^.lines.add('                a        ');
      pMemo^.lines.add('      ( I / Is )  - 1    ');
      pMemo^.lines.add(' ');
      pMemo^.lines.add(' Is = set current value, amperes');
      pMemo^.lines.add(' k  = time multiplier');
      pMemo^.lines.add(' I is the current through the connected current trafo');
      pMemo^.lines.add(' ');
      pMemo^.lines.add(' normal inverse:    a = 0.02,  b =   0.14');
      pMemo^.lines.add(' very inverse:      a = 1.0,   b =  13.5 ');
      pMemo^.lines.add(' extremely inverse: a = 2.0,   b =  80.0 ');
      pMemo^.lines.add(' long time inverse: a = 1.0,   b = 120.0 ');

    end;
    pMemo^.Lines.Add(' ');         {one empty line}
    pMemo^.Lines.Add('  '+title);  {title = component type}
    for ii := 1 to mcomp do begin
      for jj := 1 to mpar do parar[jj,ii] := flagval;  {initially value used as a flag}
      typar[ii] := ' ';            {initialize type of inverse time relay}
    end;
    {check all current trafos - - - - - - - - - - - - - - - -}
    for ii := 0 to nCT-1 do begin  {all current trafos}
      RCList.clear;
      pCT := CTList[ii];
      pCT^.getNxy(3,cx,cy);        {coordinates of output node}
      {search for a relay connected to this current trafo}
      for jj := 0 to nRel-1 do begin
        pRelay := ReList[jj];
        pRelay^.getNxy(1,rx1,ry1);   {coordinates of input node}
        if (cx = rx1) and (cy = ry1) then begin  {relay found}
          RCList.add(pRelay);        {add to list of connected relays}
          break;
        end;
      end;
      if (RCList.count > 0) and (pRelay <> nil) then begin  {continue, if found a relay}
        {search other relay modules connected to this relay module}
        found := true;
        while found do begin
          found := false;                     {not found yet}
          pRelay^.getNxy(2,rx2,ry2);          {coordinates of output node}
          for jj := 0 to nRel-1 do begin
            pComp := ReList[jj];
            pComp^.getNxy(1,rx1,ry1);         {coordinates of input node}
            if (rx2 = rx1) and (ry2 = ry1) then begin  {relay found}
              RCList.add(pComp);              {save pointer, as integer}
              found := true;
              pRelay := pComp;                {for next round}
              break;
            end;
          end;
        end;
      end;
      {continue only if no filtering, or filtering and at least one relay module selected}
      wrpar := false;                         {initialize, to keep compiler hapy}
      if (RCList.count > 0) then begin
        if (not ParamForm.FilterBut.down) then begin
          wrpar := true;                      {no filtering, param.of all relays written}
        end else begin                        {filtering, check filtering flag}
          wrpar := false;
          for jj := 0 to RCList.count-1 do begin
            pRelay := RCList[jj];
            pRelay^.GetLabel(rlab,ix,iy);     {label of the relay module}
            len := length(rlab);
            wrpar := wrpar or ((len > 0) and (rlab[len] = gFiltChar)); {is filter char?}
          end;
        end;
      end;
      {fill table with parameters, if there are relays, and writing of parameters allowed}
      if (RCList.count > 0) and (wrpar) then begin
        inc(icomp);                {increment counter for curr.trafos only if relays}
        pCT^.GetLabel(lab,ix,iy);  {label (ID) of the current transformer}
        RemoveFilterFlag(lab, Chlab, bpu);    {remove eventual filtering flag}
        namar[icomp] := Chlab;                {save the (checked) label}
        {first, find inverse time relay modules}
        for jj := 0 to RCList.count-1 do begin
          pRelay := RCList[jj];
          pRelay^.GetName(name);              {name of the component}
          if IsInvTimeRelay(name) then begin  {(in shortcir.pas)}
            pRelay^.GetPar(1,apu);
            parar[1,icomp] := apu;
            pRelay^.GetPar(2,apu);
            parar[2,icomp] := apu;
            if (maxpar < ipar) then maxpar := ipar;
            {save the type of the relay}
            if      (name = gRelay_inv  ) then typar[icomp] := 'n'  {normal inverse}
            else if (name = gRelay_vinv ) then typar[icomp] := 'v'  {very inverse}
            else if (name = gRelay_einv ) then typar[icomp] := 'x'  {extremely inverse}
            else if (name = gRelay_ltinv) then typar[icomp] := 't'; {long time inverse}
            break;                            {only one inverse time relay allowed}
          end;
        end;
        {next, find definite time relay modules}
        ipar := 2;
        for jj := 0 to RCList.count-1 do begin
          pRelay := RCList[jj];
          pRelay^.GetName(name);              {name of the component}
          if (name = gRelay) then begin       {def.time relay}
            inc(ipar,2);
            if (ipar <= mpar) then begin
              pRelay^.GetPar(1,apu);
              parar[ipar-1,icomp] := apu;
              pRelay^.GetPar(2,apu);
              parar[ipar,icomp] := apu;
              if (maxpar < ipar) then maxpar := ipar;
            end;
          end;
        end;
      end;
      {write, if array full}
      if (icomp >= mcomp) then begin
        WriteRelayParam(pMemo,namar, typar, @parar, icomp, mcomp, maxpar);
        icomp := 0;                                   {clear, for next components}
        maxpar := 0;
        {clear parameters, for next round}
        for kk := 1 to mcomp do begin
          for jj := 1 to mpar do parar[jj,kk] := flagval; {initially value used as a flag}
          typar[kk] := ' ';                               {type of inv.time relay}
        end;
      end;
    end;
    {write any remaining components}
    if (icomp > 0) then begin
      WriteRelayParam(pMemo,namar, typar, @parar, icomp, mcomp, maxpar);
    end;
  end;
  ReList.free;
  CTList.free;
  RCList.free;
end;

procedure PQParamLines(pMemo : TpRichEdit; namar,labar,typar : array of string;
                        pParar : pSingle; npar, imod, mmod,lenmax : integer;
                        reltyp : array of string; grpar: array of string);
{write parameters of PQ- and electromech. relays to memo
 pMemo   pointer to the memo where written
 namar   array of parameter names
 labar   array of component labels (names)
 pParar  pointer to the array of parameters
 npar    no of parameters
 imod    no of modules
 mmod    first dim. of parar = total no of relay modules
 lenmax  max.length of parameter name
 reltyp  name (type) of the relay, PGQ-relay, or electromech.relay
 grpar   index of the parameter group, as strings}
const
   grouptext : array[1..5] of string =            {group names, 10 char.long}
   ('       IEC',' IEEE C37.','       ABB','      ANSI','       IAC');
   EMgrouptx : array[1..4] of string =
   ('   Gen.El.','   Mitsub.','     West.','   Engl.El');
var
  apu       : single;    {temporary}
  ii,jj,kk  : integer;   {index}
  len       : integer;   {length of text}
  iline     : integer;   {line counter}
  kline     : integer;   {line group counter}
  lab       : string;    {name (label) of a component}
  lab1,lab2 : string;    {name (label) of the component divided into two parts}
  line      : string;    {temporary line, to be written to memo}
  pPar      : pSingle;   {local pointer to the array of parameters}
  text      : string;    {temporary line}
  txa,txb   : string;    {temporary}
  txt,txx   : string;    {temporary}
  group     : array[1..6] of integer;
  nline     : array[1..5] of integer;      {no of lines in groups}
begin
  nline[1] := 2;
  nline[2] := 3;
  nline[3] := 4;
  nline[4] := 4;
  nline[5] := 4;
  kline := 1;
  pPar := pParar;
  pMemo^.Lines.Add(' ');                   {one empty line}
  line := 'label ->';
  txa  := '        ';
  txb  := 'Group   ';
  text := '        ';
  txt  := 'type -> ';
  if (lenmax > length(line)) then begin
    for ii := 1 to lenmax-length(line) do begin
      line := line+' ';
      txa  := txa+' ';
      txb  := txb+' ';
      text := text+' ';
      txt  := txt+' ';
    end;
  end;
  {add labels}
  for ii := 1 to imod do begin    {labels of the components}
    lab := labar[ii-1];
    longname(lab,lab1,lab2);      {divide (eventually) into two}
    line := line+' '+lab1;
    text := text+' '+lab2;
    txb := txb+' '+'   '+grpar[ii-1];
  end;
  pMemo^.Lines.Add(line);
  pMemo^.Lines.Add(text);
  pMemo^.Lines.Add(txb);
  {add types or relay modules}
  for ii := 1 to imod do begin    {types of the modules}
    lab := typar[ii-1];
    longname(lab,lab1,lab2);      {format (and divide into two)}
    txt := txt+' '+lab1;
  end;
  pMemo^.Lines.Add(txt);
  {write parameters, if allowed}
  if (not ParamForm.LabelBut.down) then begin
    pMemo^.Lines.Add(' ');
    {then the parameters - - - - - - - - - - - - - - - - - - - - - - }
    iline := 0;
    {curve groups as texts  - - - -}
    line := namar[0];                        {name first = 'group'}
    for jj := 1 to imod do begin
      apu := pPar^;                          {index of group}
      inc(pPar);
      kk := round(apu);
      group[jj] := kk;                       {save group, for curve, next}
      if (reltyp[jj-1] = gPQRel) then begin
        if (kk > 0) and (kk <= high(grouptext)) then line := line+' '+grouptext[kk]
      end else if (reltyp[jj-1] = gEMRel) then begin
        if (kk > 0) and (kk <= high(EMgrouptx)) then line := line+' '+EMgrouptx[kk]
      end else begin
        line := line+' '+'         ?';
      end;
    end;
    inc(pPar,mmod-imod);
    pMemo^.Lines.Add(line);                  {write name of the group}
    inc(iline);
    {curves as texts - - - - - }
    line := namar[1];                        {name first}
    for jj := 1 to imod do begin
      apu := pPar^;                          {index of group}
      inc(pPar);
      kk := round(apu);
      if (reltyp[jj-1] = gPQRel) then GetPQText(group[jj], kk, text,txx)
      else GetEMText(group[jj], kk, text);
      len := length(text);
      if (len < 10) then begin                {adjust length}
        txt := '';
        for ii := 1 to 10-len do txt := txt+' ';
        txt := txt+text;
      end;
      line := line+' '+txt;
    end;
    inc(pPar,mmod-imod);
    pMemo^.Lines.Add(line);                {write name of the curve}
    inc(iline);
    if (iline >= nline[kline]) then begin
      pMemo^.Lines.Add(' ');               {empty lines, for easier reading}
      iline := 0;
      inc(kline);                          {next group of lines}
    end;
    {the actual parameters}
    for ii := 3 to npar do begin
      line := namar[ii-1];                   {name first}
      for jj := 1 to imod do begin
        apu := pPar^;                        {parameter, array dim : mcomp,mpar}
        inc(pPar);
        line := line+' '+format('%10.4g',[apu]);
      end;
      inc(pPar,mmod-imod);
      pMemo^.Lines.Add(line);                {write parameter name+values}
      inc(iline);
      if (iline >= nline[kline]) then begin
        pMemo^.Lines.Add(' ');               {empty lines, for easier reading}
        iline := 0;
        inc(kline);                          {next group of lines}
      end;
    end;
    pMemo^.Lines.Add(' ');                   {another empty line}
  end;
end;

procedure RCParamLines(pMemo : TpRichEdit; namar,labar,typar,grpar : array of string;
                        pParar : pSingle; npar, mmod,lenmax : integer);
{write parameters of recloser relays to memo
 pMemo   pointer to the memo where written
 namar   array of parameter names
 labar   array of component labels (names)
 typar   type of relay module (phase,ground,neg.seq)
 pParar  pointer to the array of parameters
 npar    no of parameters
 mmod    first dim. of parar = total no of relay modules
 lenmax  max.length of parameter name}
var
  apu       : single;    {temporary}
  ii,jj,kk  : integer;   {index}
  len       : integer;   {length of text}
  iline     : integer;   {line counter}
  kline     : integer;   {line group counter}
  lab       : string;    {name (label) of a component}
  lab1,lab2 : string;    {name (label) of the component divided into two parts}
  line      : string;    {temporary line, to be written to memo}
  pPar      : pSingle;   {local pointer to the array of parameters}
  text      : string;    {temporary line}
  txb       : string;    {temporary}
  txt       : string;    {temporary}
  group     : array[1..6] of integer;
  nline     : array[1..5] of integer;      {no of lines in groups}
begin
  nline[1] := 6;
  nline[2] := 4;
  nline[3] := 4;
  nline[4] := 4;
  nline[5] := 2;
  kline := 1;
  pPar := pParar;
  pMemo^.Lines.Add(' ');                   {one empty line}
  line := 'label ->';
  text := '        ';
  txt  := 'type -> ';
  txb  := 'Group   ';
  if (lenmax > length(line)) then begin
    for ii := 1 to lenmax-length(line) do begin
      line := line+' ';
      text := text+' ';
      txt := txt+' ';
      txb  := txb+' ';      
    end;
  end;
  {add labels}
  for ii := 1 to mmod do begin    {labels of the components}
    lab := labar[ii-1];
    longname(lab,lab1,lab2);      {divide (eventually) into two}
    line := line+' '+lab1;
    text := text+' '+lab2;
    txb := txb+' '+'   '+grpar[ii-1];
  end;
  pMemo^.Lines.Add(line);
  pMemo^.Lines.Add(text);
  pMemo^.Lines.Add(txb);
  {add types or relay modules}
  for ii := 1 to mmod do begin    {types of the modules}
    lab := typar[ii-1];
    longname(lab,lab1,lab2);      {format (and divide into two)}
    txt := txt+' '+lab1;
  end;
  pMemo^.Lines.Add(txt);
  pMemo^.Lines.Add(' ');
  {then the parameters, if allowed - - - - - - - - - - - - - - - - - - - - - - }
if (not ParamForm.LabelBut.down) then begin
  iline := 0;
  {curves - - - - - - }
  line := namar[0];                        {name first}
  for jj := 1 to mmod do begin
    apu := pPar^;                          {index of group}
    inc(pPar);
    kk := round(apu);
    line := line+' '+'    '+getCIname(kk){format('%10.0g',[apu])};
  end;
  pMemo^.Lines.Add(line);                  {the curve}
  inc(iline);
  if (iline >= nline[kline]) then begin
    pMemo^.Lines.Add(' ');                 {empty lines, for easier reading}
    iline := 0;
    inc(kline);                            {next group of lines}
  end;
  {the actual parameters}
  for ii := 2 to npar do begin
    line := namar[ii-1];                   {name first}
    for jj := 1 to mmod do begin
      apu := pPar^;                        {parameter, array dim : mcomp,mpar}
      inc(pPar);
      line := line+' '+format('%10.4g',[apu]);
    end;
    pMemo^.Lines.Add(line);                {write parameter name+values}
    inc(iline);
    if (iline >= nline[kline]) then begin
      pMemo^.Lines.Add(' ');               {empty lines, for easier reading}
      iline := 0;
      inc(kline);                          {next group of lines}
    end;
  end;
  pMemo^.Lines.Add(' ');                   {another empty line}
end;
end;

procedure AddPGQRelayPar(pMemo : TpRichEdit; title : string);
{write the parameters of the PGQ-relays to the memo
 pMemo  pointer to the memo
 title  the title for the parameters}
const
  mcomp = 2;  {max.no of components in array }
  mmod  = 6;  {max no of relay modules = 3*mcomp}
  mpar = 19;  {max no of parameters = dim. of array}
var
  AorM      : char;      {auto or manual mode}
  apu       : single;    {temporary}
  Chlab     : string;    {checked label}
  err       : integer;   {error flag}
  first     : boolean;   {first component of given type}
  icomp     : integer;   {component index}
  igrp      : integer;   {index of parameter group}
  ii,jj,kk  : integer;   {index}
  ipu       : integer;   {temporary}
  isFilt    : boolean;   {selected (filtered)}
  ix,iy     : integer;   {temporary}
  istrt,iend: integer;   {indices for start and end of search for par.names}
  jcomp     : integer;   {counts components}
  jgrp,kgrp : integer;   {indices for parameter group}
  lab       : string;    {name (label) of a component}
  lenmax    : integer;   {max. length of name}
  name      : string;    {name (type) of a component}
  namline   : string;    {line with the parameter names}
  ngrp      : integer;   {number of groups of parameters}
  npar      : integer;   {no of parameters}
  pComp     : TpComp;    {pointer to a component}
  pHelp     : TpMemo;    {pointer to the help memo}
  pMod      : TpElComp;  {pointer to the model component}
  pSet      : TpCompSet; {pointer to the "common"}
{ Rg,Xg     : single;    {the earthing impedance (in series)}
  rr        : integer;   {index}
  txt       : string;    {temporary}
  wout      : string;    {temporary}
  grpar     : array [1..mmod] of string;         {array for parameter group indices}
  labar     : array [1..mmod] of string;         {array of component labels}
  namar     : array [1..mpar] of string;         {array for parameter names}
  parar     : array [1..mpar,1..mmod] of single; {array for parameters}
  reltyp    : array [1..mmod] of string;         {name (type) of the relay}
  typar     : array [1..mmod] of string;         {type of relay}
begin
  pSet := TpCompSet(ipSetG);                   {pointer to the "common"}
  {names of parameters}
  namar[ 1] := 'Curve group   ';
  namar[ 2] := 'Curve         ';
  namar[ 3] := 'Set current   ';
  namar[ 4] := 'Factor        ';
  namar[ 5] := 'Time mult.    ';
  namar[ 6] := 'Pickup curr. 1';
  namar[ 7] := 'Delay 1       ';
  namar[ 8] := 'Pickup curr. 2';
  namar[ 9] := 'Delay 2       ';
  namar[10] := 'Pickup curr. 3';
  namar[11] := 'Delay 3       ';
  namar[12] := 'Pickup curr. 4';
  namar[13] := 'Delay 4       ';
  namar[14] := 'Max. current  ';
  namar[15] := 'Directional   ';
  namar[16] := 'Z line        ';
  namar[17] := ' line        ';
  npar := 17{13};
  lenmax := length(namar[13]);   {all names have the same length}
  {types of relay modules}
  typar[1] := 'phase';
  typar[2] := 'ground';
  typar[3] := 'neg.seq';
  typar[4] := 'phase';
  typar[5] := 'ground';
  typar[6] := 'neg.seq';
  {initialize arrays for parameters etc}
  for ii := 1 to mmod do begin
    for jj := 1 to mpar do begin
      parar[jj,ii] := 0;
    end;
    reltyp[ii] := '';
  end;
  {scan all components, look for the given type}
  pComp := nil;                    {initialize pointer to comp.}
  err := 0;
  first := true;                   {initialize flag for first component of given type}
  icomp := 0;
  jcomp := 0;
  igrp := 1;                       {initialize, to keep the computer happy}
  while (err = 0) do begin                  {scan all components}
    pSet^.NextComp(pComp, err,jcomp,false); {pointer to next component}
    if (err = 0) then begin                 {no errors, else no more components}
      pComp^.GetName(name);                 {name of the component}
      if (name = gPQRel) or (name = gEMRel) then begin {is it a PQ-relay, or electromech.rel}
        {write either only the parameters in use, or parameters of all groups}
        if (ParamForm.GroupBut.down) then ngrp := gParSet else ngrp := 1;
        for jgrp := 1 to ngrp do begin
          pComp^.GetLabel(lab,ix,iy);{get label of the component}
          {get index for the parameter group}
          IndexForGroupIndex(longint(pComp),ipu,AorM);  {for the parameter group}
          pComp^.getPar(ipu,apu);
          if (apu > 0) then igrp := round(apu) else igrp := 1; {parameter group}
          {write the index, and label it active or alternative}
          if (ParamForm.GroupBut.down) then begin  {all groups written}
            if (jgrp = igrp) then
              txt := inttostr(jgrp)+'(act.)'
            else
              txt := inttostr(jgrp)+'(alt.)';
          end else begin                           {only the active group = present param.written}
            txt := inttostr(igrp)+'(act.)';
          end;
          {check filtering, remove eventual filtering flag in any case}
          RemoveFilterFlag(lab, ChLab, isFilt);
          if (not ParamForm.FilterBut.down) or
             (ParamForm.FilterBut.down and isFilt) then begin
            inc(icomp);                     {index of this component}
            grpar[(icomp-1)*3+1] := txt;    {same param.group for phase..}
            grpar[(icomp-1)*3+2] := txt;    {..ground and ..}
            grpar[(icomp-1)*3+3] := txt;    {.. neg.seq modules}
            labar[(icomp-1)*3+1] := Chlab;  {same label for phase..}
            labar[(icomp-1)*3+2] := Chlab;  {..ground and ..}
            labar[(icomp-1)*3+3] := Chlab;  {.. neg.seq modules}
            reltyp[(icomp-1)*3+1] := name;  {same name (type) for phase..}
            reltyp[(icomp-1)*3+2] := name;  {..ground and ..}
            reltyp[(icomp-1)*3+3] := name;  {.. neg.seq modules}
            pComp^.GetpMod(pMod);           {pointer to the model component}
            namline := pMod^.ParNam;        {line with parameter names}
            if (npar <= mpar) then begin    {array large enough}
              if (first) then begin         {parameter names only once}
                pMod^.GetpHelp(pHelp);      {pointer to the help memo}
                {copy the help memo, if so desired}
                if (pHelp <> nil) and (ParamForm.HelpBut.down) then begin             {there is a help memo}
                  pMemo^.lines.Add(' ');
                  for kk := 0 to pHelp^.lines.count do begin
                    pMemo^.Lines.Add(pHelp^.lines[kk]);  {copy the lines from the help memo}
                  end;
                end;
                {title only if there are components of this type}
                pMemo^.Lines.Add(' ');        {one empty line}
                pMemo^.Lines.Add('  '+title); {title = component type}
                first := false;             {no more first component}
              end;
              {get parameters. If group index = 0, read "proper" parameters, else from the group}
              if (ParamForm.GroupBut.down) then kgrp := jgrp else kgrp := 0;
              for rr := 1 to 3 do begin
                pComp^.GetParOfParGroup(gPQ_Group[rr],kgrp,apu);
                parar[ 1,(icomp-1)*3+rr] := apu;
                pComp^.GetParOfParGroup(gPQ_Curve[rr],kgrp,apu);
                parar[ 2,(icomp-1)*3+rr] := apu;
                pComp^.GetParOfParGroup(gPQ_Iset[rr],kgrp,apu);
                parar[ 3,(icomp-1)*3+rr] := apu;
                pComp^.GetParOfParGroup(gPQ_Fact[rr],kgrp,apu);
                parar[ 4,(icomp-1)*3+rr] := apu;
                pComp^.GetParOfParGroup(gPQ_Tmult[rr],kgrp,apu);
                parar[ 5,(icomp-1)*3+rr] := apu;
                pComp^.GetParOfParGroup(gPQ_I1[rr],kgrp,apu);
                parar[ 6,(icomp-1)*3+rr] := apu;
                pComp^.GetParOfParGroup(gPQ_t1[rr],kgrp,apu);
                parar[ 7,(icomp-1)*3+rr] := apu;
                pComp^.GetParOfParGroup(gPQ_I2[rr],kgrp,apu);
                parar[ 8,(icomp-1)*3+rr] := apu;
                pComp^.GetParOfParGroup(gPQ_t2[rr],kgrp,apu);
                parar[ 9,(icomp-1)*3+rr] := apu;
                pComp^.GetParOfParGroup(gPQ_I3[rr],kgrp,apu);
                parar[10,(icomp-1)*3+rr] := apu;
                pComp^.GetParOfParGroup(gPQ_t3[rr],kgrp,apu);
                parar[11,(icomp-1)*3+rr] := apu;
                pComp^.GetParOfParGroup(gPQ_I4[rr],kgrp,apu);
                parar[12,(icomp-1)*3+rr] := apu;
                pComp^.GetParOfParGroup(gPQ_t4[rr],kgrp,apu);
                parar[13,(icomp-1)*3+rr] := apu;
                pComp^.GetParOfParGroup(gPQ_Imax[rr],kgrp,apu);
                parar[14,(icomp-1)*3+rr] := apu;
                pComp^.GetParOfParGroup(gPQ_dir[rr],kgrp,apu);
                parar[15,(icomp-1)*3+rr] := apu;
                pComp^.GetParOfParGroup(gPQ_Z[rr],kgrp,apu);
                parar[16,(icomp-1)*3+rr] := apu;
                pComp^.GetParOfParGroup(gPQ_angle[rr],kgrp,apu);
                parar[17,(icomp-1)*3+rr] := apu;
              end;
            end;
          end;
          {if parameter array full, write parameters}
          if (icomp >= mcomp) then begin
            PQParamLines(pMemo, namar, labar, typar,@parar[1,1],
                         npar, icomp*3, mmod,lenmax,reltyp,grpar);
            icomp := 0;    {reset}
          end;
        end;
      end;
    end;
  end;
  {if there still were relays, write parameters}
  if (icomp > 0) then begin
    PQParamLines(pMemo, namar, labar, typar, @parar[1,1],
                 npar, icomp*3, mmod,lenmax,reltyp,grpar);
  end;
end;

procedure AddRecloserPar(pMemo : TpRichEdit; title : string);
{write the parameters of the electromechanical-relays to the memo
 pMemo  pointer to the memo
 title  the title for the parameters}
const
  mmod  = 6;  {no of relay modules }
  mpar = 19;  {no of parameters = dim. of array}
var
  AorM      : char;      {automatic or manual mode}
  apu       : single;    {temporary}
  Chlab     : string;    {checked label}
  err       : integer;   {error flag}
  first     : boolean;   {first component of given type}
  icomp     : integer;   {component index}
  igrp      : integer;   {index for parameter group}
  ii,jj,kk  : integer;   {index}
  ipu       : integer;   {temporary}
  isFilt    : boolean;   {component is selected("filtered") for the report}
  ix,iy     : integer;   {temporary}
  istrt,iend: integer;   {indices for start and end of search for par.names}
  jcomp     : integer;   {counts components}
  jgrp,kgrp : integer;   {indices for parameter group}
  lab       : string;    {name (label) of a component}
  lenmax    : integer;   {max. length of name}
  name      : string;    {name (type) of a component}
  ngrp      : integer;   {number of groups of parameters}
{ namline   : string;    {line with the parameter names}
  npar      : integer;   {no of parameters}
  pComp     : TpComp;    {pointer to a component}
  pHelp     : TpMemo;    {pointer to the help memo}
  pMod      : TpElComp;  {pointer to the model component}
  pSet      : TpCompSet; {pointer to the "common"}
  Rg,Xg     : single;    {the earthing impedance (in series)}
  rr        : integer;   {index}
  txt       : string;    {temporary}
  wout      : string;    {temporary}
  grpar     : array [1..mmod] of string;         {array for parameter group indices}
  labar     : array [1..mmod] of string;         {array of component labels}
  namar     : array [1..mpar] of string;         {array for parameter names}
  typar     : array [1..mmod] of string;         {type of relay}
  parar     : array [1..mpar,1..mmod] of single; {array for parameters}
begin
  pSet := TpCompSet(ipSetG);                     {pointer to the "common"}
  {names of parameters}
  namar[ 1] := 'Curve         ';
  namar[ 2] := 'Set current   ';
  namar[ 3] := 'Factor        ';
  namar[ 4] := 'Time mult.    ';
  namar[ 5] := 'Time adder    ';
  namar[ 6] := 'Min. time     ';
  namar[ 7] := 'Pickup curr. 1';
  namar[ 8] := 'Delay 1       ';
  namar[ 9] := 'Pickup curr. 2';
  namar[10] := 'Delay 2       ';
  namar[11] := 'Pickup curr. 3';
  namar[12] := 'Delay 3       ';
  namar[13] := 'Pickup curr. 4';
  namar[14] := 'Delay 4       ';
  namar[15] := 'Max. current  ';
  namar[16] := 'Directional   ';
  namar[17] := 'Z line        ';
  namar[18] := ' line        ';
  npar := 18{14};
  lenmax := length(namar[14]);   {all names have the same length}
  {types of relay modules}
  typar[1] := 'phase 1';
  typar[2] := 'phase 2';
  typar[3] := 'ground 1';
  typar[4] := 'ground 2';
  typar[5] := 'neg.seq.1';
  typar[6] := 'neg.seq.2';
  {scan all components, look for the given type}
  pComp := nil;                    {initialize pointer to comp.}
  err := 0;
  first := true;                   {initialize flag for first component of given type}
  icomp := 0;
  jcomp := 0;
  while (err = 0) do begin                  {scan all components}
    pSet^.NextComp(pComp, err,jcomp,false); {pointer to next component}
    if (err = 0) then begin                 {no errors, else no more components}
      pComp^.GetName(name);                 {name of the component}
      if (name = gRCRel) or (name = gUDRel) then begin {is it a recloser or user defined relay}
        {write either only the parameters in use, or parameters of all groups}
        if (ParamForm.GroupBut.down) then ngrp := gParSet else ngrp := 1;
        for jgrp := 1 to ngrp do begin
          pComp^.GetLabel(lab,ix,iy);{get label of the component}
          IndexForGroupIndex(longint(pComp),ipu,AorM);  {for the parameter group}
          pComp^.getPar(ipu,apu);
          if (apu > 0) then igrp := round(apu) else igrp := 1; {parameter group}
          {write the index, and label it active or alternative}
          if (ParamForm.GroupBut.down) then begin  {all groups written}
            if (jgrp = igrp) then
              txt := inttostr(jgrp)+'(act.)'
            else
              txt := inttostr(jgrp)+'(alt.)';
          end else begin                           {only the active group = present param.written}
            txt := inttostr(igrp)+'(act.)';
          end;
          {check filtering, remove eventual filtering flag in any case}
          RemoveFilterFlag(lab, ChLab, isFilt);
          if (not ParamForm.FilterBut.down) or
             (ParamForm.FilterBut.down and isFilt) then begin
            inc(icomp);                {index of this component}
            for ii := 1 to mmod do labar[ii] := Chlab;  {same label for phase, ground and neg.seq modules}
            for ii := 1 to mmod do grpar[ii] := txt;  {same group for phase, ground and neg.seq modules}
            pComp^.GetpMod(pMod);      {pointer to the model component}
{           namline := pMod^.ParNam;   {line with parameter names}
            if (npar <= mpar) then begin  {array large enough}
              if (first) then begin        {parameter names only once}
                pMod^.GetpHelp(pHelp);     {pointer to the help memo}
                {copy the help memo, if so desired}
                if (pHelp <> nil) and (ParamForm.HelpBut.down) then begin             {there is a help memo}
                  pMemo^.lines.Add(' ');
                  for kk := 0 to pHelp^.lines.count do begin
                    pMemo^.Lines.Add(pHelp^.lines[kk]);  {copy the lines from the help memo}
                  end;
                end;
                {title only if there are components of this type}
                pMemo^.Lines.Add(' ');        {one empty line}
                pMemo^.Lines.Add('  '+title); {title = component type}
                first := false;             {no more first component}
              end;
              {get parameters. If group index = 0, read "proper" parameters, else from the group}
              if (ParamForm.GroupBut.down) then kgrp := jgrp else kgrp := 0;
              for rr := 1 to mmod do begin
                pComp^.GetParOfParGroup(gRC_Curve[rr],kgrp,apu);
                parar[ 1,rr] := apu;
                pComp^.GetParOfParGroup(gRC_Iset[rr],kgrp,apu);
                parar[ 2,rr] := apu;
                pComp^.GetParOfParGroup(gRC_Fact[rr],kgrp,apu);
                parar[ 3,rr] := apu;
                pComp^.GetParOfParGroup(gRC_Tmult[rr],kgrp,apu);
                parar[ 4,rr] := apu;
                pComp^.GetParOfParGroup(gRC_Tadd[rr],kgrp,apu);
                parar[ 5,rr] := apu;
                pComp^.GetParOfParGroup(gRC_Tmin[rr],kgrp,apu);
                parar[ 6,rr] := apu;
                pComp^.GetParOfParGroup(gRC_I1[rr],kgrp,apu);
                parar[ 7,rr] := apu;
                pComp^.GetParOfParGroup(gRC_t1[rr],kgrp,apu);
                parar[ 8,rr] := apu;
                pComp^.GetParOfParGroup(gRC_I2[rr],kgrp,apu);
                parar[ 9,rr] := apu;
                pComp^.GetParOfParGroup(gRC_t2[rr],kgrp,apu);
                parar[10,rr] := apu;
                pComp^.GetParOfParGroup(gRC_I3[rr],kgrp,apu);
                parar[11,rr] := apu;
                pComp^.GetParOfParGroup(gRC_t3[rr],kgrp,apu);
                parar[12,rr] := apu;
                pComp^.GetParOfParGroup(gRC_I4[rr],kgrp,apu);
                parar[13,rr] := apu;
                pComp^.GetParOfParGroup(gRC_t4[rr],kgrp,apu);
                parar[14,rr] := apu;
                pComp^.GetParOfParGroup(gRC_Imax[rr],kgrp,apu);
                parar[15,rr] := apu;
                pComp^.GetParOfParGroup(gRC_dir[rr],kgrp,apu);
                parar[16,rr] := apu;
                pComp^.GetParOfParGroup(gRC_Z[rr],kgrp,apu);
                parar[17,rr] := apu;
                pComp^.GetParOfParGroup(gRC_angle[rr],kgrp,apu);
                parar[18,rr] := apu;
              end;
            end;
            {write parameters}
            RCParamLines(pMemo, namar, labar, typar,grpar,@parar[1,1], npar, mmod,lenmax);
          end;
        end;
      end;
    end;
  end;

end;

procedure AddParamLines(pMemo : TpRichEdit; name : string; namar,labar,grpar : array of string;
                        pParar : pSingle; npar, icomp, mcomp,lenmax : integer);
{write parameters of components to memo
 pMemo   pointer to the memo where written
 name    name (type) of the component
 namar   array of parameter names
 labar   array of component labels (names)
 grpar   array of parameter group index (for distance relays)
 pParar  pointer to the array of parameters
 npar    no of parameters
 icomp   no of components
 mcomp   first dim. of parar
 lenmax  max.length of parameter name}
var
  apu       : single;    {temporary}
  ii,jj     : integer;   {index}
  iline     : integer;   {line counter}
  lab       : string;    {name (label) of a component}
  lab1,lab2 : string;    {name (label) of the component divided into two parts}
  line      : string;    {temporary line, to be written to memo}
  pPar      : pSingle;   {local pointer to the array of parameters}
  text      : string;    {temporary line}
  txt       : string;    {temporary line}
begin
  pPar := pParar;
  if (not ParamForm.LabelBut.down) then pMemo^.Lines.Add(' '); {one empty line}
  line := 'lbl';
  text := '   ';
  if (name = gMeasZ) or (name = gPolyg) then txt  := 'group' else txt := '';
  if (lenmax > 1) then begin
    for ii := 1 to lenmax-1 do begin
      line := line+' ';
      text := text+' ';
      txt := txt+' ';
    end;
  end;
  for ii := 1 to icomp do begin            {labels of the components}
    lab := labar[ii-1];
    longname(lab,lab1,lab2);               {divide (eventually) into two}
    line := line+' '+lab1;
    text := text+' '+lab2;
    {group for distance relays}
    if (name = gMeasZ) or (name = gPolyg) then
      txt := txt+' '+'   '+grpar[ii-1];
  end;
  pMemo^.Lines.Add(line);
  pMemo^.Lines.Add(text);
  if (name = gMeasZ) or (name = gPolyg) then pMemo^.Lines.Add(txt);
  {then the parameters, but only if allowed}
  if (not ParamForm.LabelBut.down) then begin
    if (name = gMeasZ) then iline := 1 else iline := 0;  {first, 3 lines in dist.relays}
    for ii := 1 to npar do begin
      line := namar[ii-1];                   {parameter name first}
      {not all parameters written for distance and polyg. relays}
      for jj := 1 to icomp do begin
        apu := pPar^;                        {parameter, array dim : mcomp,mpar}
        inc(pPar);
        line := line+' '+format('%10.4g',[apu]);
      end;
      inc(pPar,mcomp-icomp);
      {not all parameters shown for distance and polygonal relays}
      if (not ((name = gMeasZ) and (DistHiddenRow(ii-1)))) and
         (not ((name = gPolyg) and (PolyHiddenRow(ii-1)))) then begin
        pMemo^.Lines.Add(line);                {write parameter name+values}
        inc(iline);
      end;
      if (iline >= 4) then begin
        pMemo^.Lines.Add(' '); {empty lines, for easier reading}
        iline := 0;
      end;
    end;
    pMemo^.Lines.Add(' '); {another empty line}
  end;
end;

procedure GenEarth(pComp : TpComp; var Rg,Xg : single);
{find the earthing impedance of a generator
 pComp   pointer to the generator
 Rg,Xg   the earthing resistance and impedance, in series}
const
  BigRes = 1.0e6;    {large resistance, instead of infinite}
var
  pImped : TpComp;   {pointer to the earthing impedance}
  xs,ys  : integer;  {coordinates of the neutral point}
begin
  {find the impedance from neutral (star) to ground, if any}
  pComp^.getNxy(3,xs,ys);          {coordinates of neutral point}
  FindZg(ipSetG, xs,ys, pImped);
  if (pImped <> nil) then begin    {impedance found}
    pImped^.GetPar(gGrImped_R,Rg); {grounding resistance}
    pImped^.GetPar(gGrImped_X,Xg); {grounding reactance}
  end else begin
    Rg := BigRes;                  {must have some resistance}
    Xg := BigRes;
  end;
end;

procedure WriteBusVoltages(pMemo : TpRichEdit);
{write the voltages of buses to the report}
const
  lenmax = 22;       {max.length of label}
var
  Chlab  : string;    {checked label}
  err    : integer;   {error flag}
  ii     : integer;
  iline  : integer;   {counts lines}
  isFilt : boolean;   {component is filtered (selected)}
  ix,iy  : integer;   {coordinates of the label}
  jcomp  : integer;   {counts components}
  lbl    : string;    {label of the component}
  line   : string;    {one line of text}
  name   : string;    {name (type) of a component}
  pComp  : TpCOmp;    {pointer to a bus}
  pSet   : TpCompSet; {pointer to the common}
  Volt   : single;    {voltage of a bus}
begin
  pSet := TpCompSet(ipSetG);       {pointer to the "common"}
  pMemo^.Lines.Add(' ');           {one empty line}
  pMemo^.Lines.Add('Nominal voltages of buses');
  pMemo^.Lines.Add(' ');
  pComp := nil;                    {initialize pointer to comp.}
  err := 0;
  jcomp := 0;
  iline := 0;
  while (err = 0) do begin                  {scan all components}
    pSet^.NextComp(pComp, err,jcomp,false); {pointer to next component}
    if (err = 0) then begin                 {no errors, else no more components}
      pComp^.GetName(name);                 {name of the component}
      if (name = gBus) then begin           {is it a bus}
        pComp^.GetLabel(lbl,ix,iy);{get label of the component}
        {check filtering, remove eventual filtering flag in any case}
        RemoveFilterFlag(lbl, ChLab, isFilt);
        if (not ParamForm.FilterBut.down) or
           (ParamForm.FilterBut.down and isFilt) then begin
          {add spaces to the label, for equal length}
          if (lenmax > length(Chlab)) then begin
            for ii := 1 to lenmax-length(Chlab) do Chlab := Chlab+' ';
          end;
          pComp^.GetVoltLev(Volt);   {voltage level of the bus}
          line := Chlab+'  '+format('%8.0f',[Volt])+'V';
          pMemo^.Lines.Add(line);    {vrite the label and voltage}
          inc(iline);
          if (iline >= 4) then begin
            pMemo^.Lines.Add(' ');   {extra line for easier reading}
            iline := 0;
          end;
        end;
      end;
    end;
  end;
end;

procedure WriteNumbersOfComponents(pMemo : TpRichEdit);
{write the no of different components in the diagram}
const
  lenmax = 25;       {max.length of component name}
var
  err     : integer;    {error flag}
  found   : boolean;    {component type found}
  ii,jj   : integer;
  iline   : integer;    {line counter}
  jcomp   : integer;    {counts components}
  line    : string;     {temporary text}
  modnam  : string;     {name of a model component}
  name    : string;     {name (type) of the component}
  nAlw    : integer;    {no of "always" model-components}
  nComp   : integer;    {total number of components}
  nDown   : integer;    {no of "down" model-components}
  pComp   : TpComp;     {pointer to a component}
  pMod    : TpElComp;   {pointer to a model component}
  pSet    : TpCompSet;  {pointer to the "common"}
  wbus    : boolean;    {flag: bus written}
  wbreak  : boolean;    {flag: breaker written}
  wbreak2 : boolean;    {flag: breaker-2 written}
  wrelay  : boolean;    {relay written}
  writeflg: boolean;    {write, if true}
  wwire   : boolean;    {flag: wire written}
begin
  pSet := TpCompSet(ipSetG);       {pointer to the "common"}
  nAlw := pSet^.AlwMod.count;
  nDown := pSet^.DownMod.count;
  nComp := 0;
  {initialize counters. Consider only "down" and "always" component}
  for ii := 0 to nAlw-1 do begin
    pMod := pSet^.AlwMod.items[ii];
    pMod^.int1_m := 0;             {use temp.variable as counter}
{   pMod^.GetComNam(modnam);}
  end;
  for ii := 0 to nDown-1 do begin
    pMod := pSet^.DownMod.items[ii];
    pMod^.int1_m := 0;             {use temp.variable as counter}
  end;
  pComp := nil;                    {initialize pointer to comp.}
  err := 0;
  jcomp := 0;
  while (err = 0) do begin                  {scan all components}
    pSet^.NextComp(pComp, err,jcomp,false); {pointer to next component}
    if (err = 0) then begin                 {no errors, else no more components}
      pComp^.GetName(name);                 {name of the component}
      {check type}
      found := false;
      {check first "down" components}
      for ii := 0 to nDown-1 do begin
        pMod := pSet^.DownMod.items[ii];
        pMod^.GetComNam(modnam);
        if (modnam = name) then begin
          inc(pMod^.int1_m);
          inc(nComp);
          found := true;
          break;
        end;
      end;
      {then, check "always" components, if necessary}
      if (not found) then begin
        for ii := 0 to nAlw-1 do begin
          pMod := pSet^.AlwMod.items[ii];
          pMod^.GetComNam(modnam);
          if (modnam = name) then begin
            inc(pMod^.int1_m);
            inc(nComp);
            found := true;
            break;
          end;
        end;
      end;
    end;
  end;
  {list no of components- - - - - - - - - - - - - - - - - - - - - - -}
  pMemo^.Lines.Add(' ');        {one empty line}
  pMemo^.Lines.Add('Numbers of components - - - - - ');
  pMemo^.Lines.Add(' ');
  iline := 0;
  for ii := 0 to nDown-1 do begin
    pMod := pSet^.DownMod.items[ii];
    pMod^.GetComNam(modnam);
    {add spaces to the name, for equal length}
    if (lenmax > length(modnam)) then begin
      for jj := 1 to lenmax-length(modnam) do modnam := modnam+' ';
    end;
    line := modnam+' '+format('%5d',[pMod^.int1_m]);
    pMemo^.Lines.Add(line);     {name and no of comp.}
    {an empty line now and then, for clarity}
    inc(iline);
    if (iline >= 4) then begin
      pMemo^.Lines.Add(' ');
      iline := 0;
    end;
  end;
  {bus, breaker, wire, def.time relay appear several times, write only once}
  wbus := false;
  wbreak := false;
  wbreak2 := false;
  wwire := false;
  wrelay := false;
  for ii := 0 to nAlw-1 do begin
    pMod := pSet^.AlwMod.items[ii];
    pMod^.GetComNam(modnam);
    {check components that appear several times}
    if (modnam = gBus) then begin
      if (wbus) then begin   {bus already written}
        writeflg := false;
      end else begin
        writeflg := true;
        wbus := true;
      end;
    end else if (modnam = gBrkr) then begin
      if (wBreak) then begin  {breaker already written}
        writeflg := false;
      end else begin
        writeflg := true;
        wBreak := true;
      end;
    end else if (modnam = gSymbol) then begin
      if (wBreak2) then begin  {breaker already written}
        writeflg := false;
      end else begin
        writeflg := true;
        wBreak2 := true;
      end;
    end else if (modnam = gWire) then begin
      if (wwire) then begin   {wire already written}
        writeflg := false;
      end else begin
        writeflg := true;
        wwire := true;
      end;
    end else if (modnam = gRelay) then begin
      if (wrelay) then begin   {def.time relay already written}
        writeflg := false;
      end else begin
        writeflg := true;
        wrelay := true;
      end;
    end else begin
      writeflg := true;      {all other components are written}
    end;
    {write, if not yet written}
    if (writeflg) then begin
      {add spaces to the name, for equal length}
      if (lenmax > length(modnam)) then begin
        for jj := 1 to lenmax-length(modnam) do modnam := modnam+' ';
      end;
      line := modnam+' '+format('%5d',[pMod^.int1_m]);
      pMemo^.Lines.Add(line);     {name and no of comp.}
      {an empty line now and then, for clarity}
      inc(iline);
      if (iline >= 4) then begin
        pMemo^.Lines.Add(' ');
        iline := 0;
      end;
    end;
  end;
  {total number of components}
  pMemo^.Lines.add(' ');          {one empty line}
  pMemo^.Lines.Add('Total no. of components   '+format('%5d',[nComp]));
end;

procedure WriteCurrTrafos(pMemo : TpRichEdit; Cname, title : string);
{write the labels of current transforers to memo (there are no parameters)
 pMemo   pointer to the meme where written
 Cname   name (type) of the component
 title   title for the parameters}
var
  apu       : single;    {temporary}
  bpu       : boolean;   {temporary}
  Chlab     : string;    {checked label}
  err       : integer;   {error flag}
  first     : boolean;   {flag for first component}
  ix,iy     : integer;   {temporary}
  jcomp     : integer;   {counts components}
  lab       : string;    {name (label) of a component}
  len       : integer;   {length of string}
  name      : string;    {name (type) of a component}
  namline   : string;    {line with the parameter names}
  pComp     : TpComp;    {pointer to a component}
  pMod      : TpElComp;  {pointer to the model component}
  pSet      : TpCompSet; {pointer to the "common"}
  wrpar     : boolean;   {write/not the parameters}
begin
  pSet := TpCompSet(ipSetG);                   {pointer to the "common"}
  {scan all components, look for the given type}
  pComp := nil;                    {initialize pointer to comp.}
  err := 0;
  jcomp := 0;
  first := true;
  while (err = 0) do begin                  {scan all components}
    pSet^.NextComp(pComp, err,jcomp,false); {pointer to next component}
    if (err = 0) then begin                 {no errors, else no more components}
      pComp^.GetName(name);                 {name of the component}
      if (name = Cname) then begin  {is it a component of given type}
        pComp^.GetLabel(lab,ix,iy);{get label of the component}
        {continue, if no filter, or filter in use and component selected}
        len := length(lab);
        if (len > 0) then begin
          wrpar := (not ParamForm.FilterBut.down) or
                   (ParamForm.FilterBut.down and (lab[len] = gFiltChar));
        end else begin
          wrpar := not ParamForm.FilterBut.down;
        end;
        if (wrpar) then begin              {write parameters, if no filtering, or filt. +selected}
          if (first) then begin            {writing first component}
            pMemo^.Lines.Add(' ');
            pMemo^.Lines.Add(title);       {title for curr.trafos}
            first := false;
          end;  
          RemoveFilterFlag(lab,ChLab,bpu); {remove eventual filter flag from the label}
          pMemo^.Lines.Add(Chlab);         {write to report}
        end;
      end;
    end;
  end;
end;

procedure FromGroupToParamArr(pComp: TpComp; var parar: array of single; igrp : integer);
{for distance relays, move parameters from a parameter group to parameter array
 The parameters in the parameter groups are saved as strings
 (which must be converted to numbers, and later back to strings !?
 pComp  pointer to the relay
 parar  array for the parameters
 igrp   index of the group
 icomp  index of the component (in writing the report)}
var
  apu  : single;   {temporary}
  errc : integer;  {error flag}
  ii   : integer;  {index}
  len  : integer;  {length of string}
  line : string;   {one line of text = one string}
  npar : integer;  {number of parameters}
  st1  : string;   {temporary}
  txt  : string;   {temporary text}
begin
  pComp^.GetStringPar(line,igrp);     {parameters as a string}
  len := length(line);
  pComp^.GetNpar(npar);               {get no of parameters}
  if (len > 0) then begin             {there are some data}
    for ii := 1 to npar do begin
      ExtractParam(ii,';',line,st1);  {in routines.pas}
      chkfloat(st1,errc,txt);         {checked string to txt}
      if (errc = 0) then begin        {reasonable value}
        apu := strtofloat(txt);       {change to numeric}
      end else begin
        apu := 0;
      end;
      parar[ii-1] := apu;             {in subroutines, index starts at 0 !?}
    end;
  end else begin                      {data missing, fill with zeroes}
    for ii := 1 to npar do begin
      parar[ii-1] := 0;
    end;
  end;
end;

procedure WriteParam(pMemo : TpRichEdit; Cname, title : string);
{write the parameters of one component type to memo
 pMemo   pointer to the meme where written
 Cname   name (type) of the component
 title   title for the parameters}
const
  mcomp = 6;  {max.no of components in array = dim of array}
  mpar = 80{70{32};  {max no of parameters = dim. of array}
  gprar: array[1..mpar] of single =
  (0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
   0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
   0,0,0,0,0,0,0,0,0,0);
var
  AorM      : char;      {auto or manual mode}
  apu       : single;    {temporary}
  bpu       : boolean;   {temporary}
  Chlab     : string;    {checked label}
  err       : integer;   {error flag}
  first     : boolean;   {first component of given type}
  icomp     : integer;   {component index}
  igrp      : integer;   {index for parameter group}
  ii,jj,kk  : integer;   {index}
  ipu       : integer;   {temporary}
  ix,iy     : integer;   {temporary}
  istrt,iend: integer;   {indices for start and end of search for par.names}
  jcomp     : integer;   {counts components}
  jgrp      : integer;   {indices for parameter group}
  lab       : string;    {name (label) of a component}
  len       : integer;   {length of string}
  lenmax    : integer;   {max. length of name}
  name      : string;    {name (type) of a component}
  namline   : string;    {line with the parameter names}
  nbas      : integer;   {number of basic parameters}
  ndipar    : integer;   {number of parameters displayed}
  ngrp      : integer;   {number of parameter groups displayed}
  npar      : integer;   {no of parameters}
  npar1     : integer;   {total no of parameters (for generators)}
  pComp     : TpComp;    {pointer to a component}
  pHelp     : TpMemo;    {pointer to the help memo}
  pMod      : TpElComp;  {pointer to the model component}
  pSet      : TpCompSet; {pointer to the "common"}
  Rg,Xg     : single;    {the earthing impedance (in series)}
  wout      : string;    {temporary}
  wrpar     : boolean;   {write/not the parameters}
  grpar     : array [1..mcomp] of string;          {array of param.group index}
  labar     : array [1..mcomp] of string;          {array of component labels}
  namar     : array [1..mpar] of string;           {array for parameter names}
  parar     : array [1..mpar,1..mcomp] of single;  {array for parameters}

begin
  pSet := TpCompSet(ipSetG);                   {pointer to the "common"}
  {initialize arrays for parameters etc}
  for ii := 1 to mComp do grpar[ii] := '';
  for ii := 1 to mpar do namar[ii] := '';  {initialize array for parameter names}
  for ii := 1 to mComp do begin
    for jj := 1 to mpar do begin
      parar[jj,ii] := 0;
    end;
  end;
{ pMemo^.Lines.Add(' '); {one empty line}
  {scan all components, look for the given type}
  pComp := nil;                    {initialize pointer to comp.}
  err := 0;
  jcomp := 0;
  first := true;                   {initialize flag for first component of given type}
  icomp := 0;
  lenmax := 1;                         {should have some initial value}
  npar1 := 0;                          {initialize, to satisfy compiler !}
  while (err = 0) do begin             {scan all components}
    pSet^.NextComp(pComp, err,jcomp,false);  {pointer to next component}
    if (err = 0) then begin            {no errors, else no more components}
      pComp^.GetName(name);            {name of the component}
      if (name = Cname) then begin     {is it a component of given type}
        {2-w transformers display only basic parameters}
        pComp^.GetNpar(npar);          {get no of parameters}
        if (isTrafo(pComp) and not (pComp^.hint = gTrafo3W)) then begin
          pComp^.GetnBasPar(nbas);     {number of basic parameters}
          ndipar := nbas;
        end else begin
          ndipar := npar;              {others display all parameters}
        end;
        {distance relays may also write parameters from the param.group}
        if ((name = gMeasZ) or (name = gPolyg)) and (ParamForm.GroupBut.down) then
          ngrp := gParSet else ngrp := 1;
        for jgrp := 1 to ngrp do begin      {one or more sets of parameters}
          pComp^.GetLabel(lab,ix,iy);       {get label of the component}
          {continue, if no filter, or filter in use and component selected}
          len := length(lab);
          if (len > 0) then begin
            wrpar := (not ParamForm.FilterBut.down) or
                     (ParamForm.FilterBut.down and (lab[len] = gFiltChar));
          end else begin
            wrpar := not ParamForm.FilterBut.down;
          end;
          if (wrpar) then inc(icomp);          {index of this component, if comp. included}
          {parameter group for distance relays}
          if (name = gMeasZ) or (name = gPolyg) then begin
            IndexForGroupIndex(longint(pComp),ipu,AorM);  {for the parameter group}
            pComp^.getPar(ipu,apu);
            if (apu > 0) then igrp := round(apu) else igrp := 1; {parameter group}
            if (ParamForm.GroupBut.down) then begin
              if (igrp = jgrp) then grpar[icomp] := inttostr(igrp)+'(act.)'
              else  grpar[icomp] := inttostr(jgrp)+'(alt.)';
            end else begin
              grpar[icomp] := inttostr(igrp)+'(act.)';
            end;
          end;
          {filtering?... ...}
          if (wrpar) then begin              {write parameters, if no filtering, or filt. +selected}
            RemoveFilterFlag(lab,ChLab,bpu); {remove eventual filter flag from the label}
            labar[icomp] := Chlab;
            pComp^.GetpMod(pMod);      {pointer to the model component}
            namline := pMod^.ParNam;   {line with parameter names}
//above     pComp^.GetNpar(npar);      {get no of parameters}
            if (name = gGen) then begin
              npar1 := npar+2;
              GenEarth(pComp,Rg,Xg);   {earthing impedance of generator}
            {for transmission lines, show only "main" parameters}
            end else if (name = gTrLiS) then begin
{tr.line!!!}  npar1 := 11;
              {add number of parallel lines (??)}
              pComp^.Getpar(gTrliS_paral,apu);
              if (apu > 1) then begin
                ipu := round(apu);
                labar[icomp] := labar[icomp]+'*'+inttostr(ipu);
              end;
            end else begin
              if (isTrafo(pComp) and not (pComp^.hint = gTrafo3W)) then
                npar1 := ndipar+4      {basic parameters + ampaicty limits}
              else npar1 := npar;
              Rg := 0; Xg := 0;        {just some value}
            end;
            if (npar1 <= mpar) then begin  {array large enough}
              if (first) then begin        {parameter names only once}
                pMod^.GetpHelp(pHelp);     {pointer to the help memo}
                {copy the help memo, if so desired}
                if (pHelp <> nil) and (ParamForm.HelpBut.down) then begin             {there is a help memo}
                  pMemo^.lines.Add(' ');
                  for kk := 0 to pHelp^.lines.count do begin
                    pMemo^.Lines.Add(pHelp^.lines[kk]);  {copy the lines from the help memo}
                  end;
                end;
                {title, but only if there are components of this type}
                pMemo^.Lines.Add(' ');        {one empty line}
                pMemo^.Lines.Add('  '+title); {title = component type}
                {extract parameter names}
                istrt := 1;
                iend := 0;
                lenmax := 0;
                if (name = gMeasZ) then begin    {distance relays differently}
                  for ii := 1 to npar do begin
                    namar[ii] := Distrel.MhoGrid.cells[0,ii-1];
                    if (length(namar[ii]) > lenmax) then lenmax := length(namar[ii]);
                  end;
                end else if (name = gPolyg) then begin    {distance relays differently}
                  for ii := 1 to npar do begin
                    namar[ii] := Polyrel.PolyGrid.cells[0,ii-1];
                    if (length(namar[ii]) > lenmax) then lenmax := length(namar[ii]);
                  end;
                end else if (name = gTrLiS) then begin
                  {transmission lines, parameter names defined in LineParam.pas}
                  namar[1] := 'R1'; namar[2] := 'B'; namar[3] := 'X1'; namar[4] := 'length';
                  namar[5] := 'R0'; namar[6] := 'X0'; namar[7] := 's1'; namar[8] := 'A1';
                  namar[9] := 'A2'; namar[10] := 'A3'; namar[11] := 'A4';
                  lenmax := 6;
                end else begin
                  if ({npar}ndipar > 0) then begin        {or npar1 ?}
                    for ii := 1 to {npar}ndipar do begin
                      FindWord(namline, istrt, wout, iend); {find name of a parameter}
                      if (length(wout) > lenmax) then lenmax := length(wout);
                      namar[ii] := wout;
                      istrt := iend;                    {start next here}
                    end;
                  end;
                end;
                if (name = gGen) then begin         {generator: add earthing impedance}
                  namar[npar+1] := 'Rg';
                  namar[npar+2] := 'Xg';
                end;
                {ampacity limits for 2w-transformers}
                if (isTrafo(pComp) and not (pComp^.hint = gTrafo3W)) then begin
                  namar[ndipar+1] := 'A1';
                  namar[ndipar+2] := 'A2';
                  namar[ndipar+3] := 'A3';
                  namar[ndipar+4] := 'A4';
                end;
                {add spaces to get same length for all parameter names}
                if (npar1 > 0) then begin
                  for ii := 1 to npar1 do begin
                    for jj := length(namar[ii])+1 to lenmax+2 do begin
                      namar[ii] := namar[ii]+' ';
                    end;
                  end;
                end;
              end;
              {get parameters}
              {distance relays may read parameters from the param.group}
              if ((name = gMeasZ) or (name = gPolyg)) and (ParamForm.GroupBut.down) then begin
                FromGroupToParamArr(pComp, gprar,jgrp);
                  for ii := 1 to npar do begin
                    parar[ii,icomp] := gprar[ii];
                  end;
              end else begin                          {parameters normally, from the component}
                if ({npar}ndipar > 0) then begin
                  for ii := 1 to {npar}ndipar do begin
                    pComp^.GetPar(ii,apu);            {get value of parameter ii}
                    parar[ii,icomp] := apu;
                  end;
                end;
                if (name = gGen) then begin           {generator: add Rg, Xg}
                  parar[npar+1,icomp] := Rg;
                  parar[npar+2,icomp] := Xg;
                end;
                if (isTrafo(pComp) and not (pComp^.hint = gTrafo3W)) then begin {2w-trafo}
                  pComp^.GetPar(gTrafo_A1,apu);
                  parar[ndipar+1,icomp] := apu;
                  pComp^.GetPar(gTrafo_A2,apu);
                  parar[ndipar+2,icomp] := apu;
                  pComp^.GetPar(gTrafo_A3,apu);
                  parar[ndipar+3,icomp] := apu;
                  pComp^.GetPar(gTrafo_A4,apu);
                  parar[ndipar+4,icomp] := apu;
                end;
              end;
            end;
            first := false;             {no more first component}
          end;
          {if parameter array full, write parameters}
          if (icomp >= mcomp) then begin
            if (npar1 > 0) then begin
              AddParamLines(pMemo, Cname,namar, labar, grpar, @parar[1,1], npar1, icomp, mcomp,lenmax);
            end;
            icomp := 0;    {reset}
          end;
        end;
      end;
    end;
  end;
  {if there still were components, write parameters}
  if (icomp > 0) and (npar1 > 0) then begin
    AddParamLines(pMemo, Cname, namar, labar, grpar, @parar[1,1], npar1, icomp, mcomp,lenmax);
  end;
end;


procedure TParamForm.PageItemClick(Sender: TObject);
{create new page, write parameters defined by the buttons}
var
  np, npo   : integer;   {no of pages, old no of pages}
begin
  npo := Params.Pages.Count;                   {old number of pages}
  if (Params.Pages.Count < maxmem) then begin {not full yet}
    np := npo+1;                               {one more page}
    new(MemoPntrArr[np]);                     {start creating new memo}
    MemoPntrArr[np]^ := {TMemo}TRichEdit.Create(Params); {create the new memo}
    {ii :=} Params.Pages.AddObject(inttostr(np),MemoPntrArr[np]^); {new page to notebook}

    MemoPntrArr[np]^.Parent := (Params.Pages.Objects
                  [Params.Pages.IndexOf(inttostr(np))]) as TTabPage;
    MemoPntrArr[np]^.Align := alNone;
    MemoPntrArr[np]^.Alignment := taLeftJustify;
    MemoPntrArr[np]^.BorderStyle := bsNone;
    MemoPntrArr[np]^.color := clWhite;
    MemoPntrArr[np]^.Ctl3D := false;
    MemoPntrArr[np]^.width := Params.width-20{FormWidth-20}; {may be changed later}
    MemoPntrArr[np]^.height := ClientHeight-56;
    MemoPntrArr[np]^.font.name := 'Courier';
    MemoPntrArr[np]^.font.size := 10;
    MemoPntrArr[np]^.MaxLength := 1000000;
    MemoPntrArr[np]^.Name := 'A'+inttostr(np);
    MemoPntrArr[np]^.Lines.clear;
    MemoPntrArr[np]^.ScrollBars := ssBoth;
    MemoPntrArr[np]^.WordWrap := false;
    MemoPntrArr[np]^.visible := true;
    MemoPntrArr[np]^.enabled := true;
    MemoPntrArr[np]^.OnEnter := ParamMemo.OnClick;  {same click as others}
    {add date and time to the memo}
    MemoPntrArr[np]^.Lines.add(' ');  {one empty line}
    ShortDateFormat := 'd.m.yyyy';     {set the format for the date}
    MemoPntrArr[np]^.Lines.Add('      '+DateToStr(Date)+'   '+TimeToStr(Time));
    MemoPntrArr[np]^.Lines.Add('      Title: '+Imagoo.NetTitle.text);
    MemoPntrArr[np]^.Lines.Add('      Comments: ');
    {write parameters of the selected component types}
    if (SourceBut.down) then begin
      WriteParam(MemoPntrArr[np], gGen,'Generators');
      WriteParam(MemoPntrArr[np], gFeed,'Feeders');
    end;
    if (TrafoBut.down) then begin
      WriteParam(MemoPntrArr[np], gTrafoYY,'Transformers YY');
      WriteParam(MemoPntrArr[np], gTrafoYD,'Transformers YD');
      WriteParam(MemoPntrArr[np], gTrafoDY,'Transformers DY');
      WriteParam(MemoPntrArr[np], gTrafoDD,'Transformers DD');
    end;
    if (RelayBut.down) then begin
      AddRelayPar(MemoPntrArr[np],
      'Overcurrent relays (n=normal-, v=very-, x=extremely-, t=long time inverse)');
    end;
    if (DistBut.down) then begin     {distance relays}
      WriteParam(MemoPntrArr[np], gMeasZ,'Mho-distance relays ');
    end;
    if (PolyBut.down) then begin     {distance relays}
      WriteParam(MemoPntrArr[np], gPolyg,'Polygon-distance relays ');
    end;
    if (PQRelayBut.down) then begin
      AddPGQRelayPar(MemoPntrArr[np], 'Phase-, Ground-, Neg.Seq. relays');
    end;
    if (RCRelayBut.down) then begin
      AddRecloserPar(MemoPntrArr[np], 'Recloser relays');
    end;
    if (ImpedBut.down) then begin     {impedances, capacitors, lines}
      WriteParam(MemoPntrArr[np], gImped,'Impedances');
      WriteParam(MemoPntrArr[np], gCap,'Capacitors');
      WriteParam(MemoPntrArr[np], gTrliS,'Transmission lines');
    end;
    if (MotorBut.down) then begin     {motors}
      WriteParam(MemoPntrArr[np], gAsmot,'Asynchronous motors');
      WriteParam(MemoPntrArr[np], gSmot,'Synchronous motors');
    end;
    if (LoadBut.down) then begin     {Loads}
      WriteParam(MemoPntrArr[np], gLoad,'Loads');                {normal loads}
      WriteParam(MemoPntrArr[np], gUnsymm,'Unsymmetrical Loads');
    end;
    if (BusBut.down) then begin      {voltages of buses}
      WriteBusVoltages(MemoPntrArr[np]);
    end;
    if (CTBut.down) then begin       {Current transformers}
      WriteCurrTrafos(MemoPntrArr[np], gCurrT,'Current Transformers');
      WriteCurrTrafos(MemoPntrArr[np], gSpecCT,'Special Current Transformers');
    end;
    if (NumberBut.down) then begin   {numbers of components}
      WriteNumbersOfComponents(MemoPntrArr[np]);
    end;
  end;
end;


procedure TParamForm.FormClick(Sender: TObject);
begin
  TabEdit.visible := false;   {hide the eventual tab edit box}
end;

procedure TParamForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Imagoo.ParamView.checked := false;
end;

procedure TParamForm.FormDestroy(Sender: TObject);
{free the memos and clear the items in the list}
{ONKO tm tarpeen ?}
var
  ii  : integer;  {index}
  ip  : integer;  {page index}
  npo : integer;  {number of pages}
begin
  npo := Params.Pages.Count;        {number of pages}
  if (npo > 1) then begin           {is there any pages}
    for ii := 1 to npo-1 do begin
      ip := npo-ii;                 {proceed from the last one to the first one}
      MemoPntrArr[ip+1]^.free;      {free (delete) the memo}
      Dispose(MemoPntrArr[ip+1]);
      MemoPntrArr[ip+1] := nil;
      Params.Pages.Delete(ip);      {delete the page}
    end;
  end;


end;

procedure TParamForm.FormResize(Sender: TObject);
var
  ii  : integer;  {index}
  np  : integer;  {number of pages}
begin
  {change the height of the reports to correspond to that of the form}
  Params.height := ClientHeight-ButPanel.height;
  {change the width also}
  Params.width := ParamForm.width-10;
  for ii := 1 to maxmem do begin     {clear pointers to memos initially}
    if (MemoPntrArr[ii] <> nil) then MemoPntrArr[ii]^.width := Params.width-24;
  end;
  np := Params.Pages.Count;                  {number of pages}
  for ii:=1 to np do begin
    MemoPntrArr[ii]^.height := ClientHeight-56;
  end;
  ii := Params.PageIndex;              {index of the active page, or tab}
  if (ii > 0) and (ii <= np) then MemoPntrArr[ii+1].refresh;
end;

procedure TParamForm.TabItemClick(Sender: TObject);
var
  ii  : integer;   {index}
begin
  ii := Params.PageIndex;                {index of the active page, or tab}
  if (ii >= 0) then begin                {is there any page ?}
    TabEdit.visible := true;             {show edit box for editing Tab caption}
    ParamForm.ActiveControl := TabEdit;  {put cursor there for editing}
    TabEdit.text := Params.Pages[ii];    {show the present tab caption}
  end else begin
    TabEdit.text := '';
  end;

end;

procedure TParamForm.TabEditExit(Sender: TObject);
{copy text to the caption of the active page (tab)}
var
  ii   : integer;  {index}
  len  : integer;  {length of text}
  np   : integer;  {no of pages}
  pi   : integer;  {page index}
  same : boolean;  {true, if found the same text on a tab}
begin
  pi := Params.PageIndex;            {index of active page (tab)}
  np := Params.Pages.Count;          {number of pages}
  same := false;                      {not yet found the same text}
  if (np > 0) then begin              {are there pages}
    for ii := 0 to np-1 do begin        {chek all pages}
      if (ii <> pi) then begin          {the active page is not checked}
        if (TabEdit.text = Params.Pages[ii]) then begin
          same := true;                 {same text found}
          break;                        {one is enough}
        end;
      end;
    end;
    {do not copy, if caption already in use}
    if (same) then begin
      showmessage('Caption "'+TabEdit.text+'"  already in use');
    end else begin                      {check still that not empty}
      len := length(TabEdit.text);        {no of characters}
      {accepted the new caption only if not empty, and does not exist in other tabs}
      if (len > 0) and (TabEdit.text[1] <> ' ') then begin
        Params.Pages[pi] := TabEdit.text;  {copy the text}
      end;
    end;
  end;
end;

procedure TParamForm.TabEditKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
{hide the Edit box, if key = Enter (=return)}
begin
  if (key = 13) then TabEdit.visible := false;
end;


procedure TParamForm.ParamMemoClick(Sender: TObject);
begin
  TabEdit.visible := false;  {hide the tab edit}
end;

procedure SaveParamReports(filename: string);
{save the reports to file}
var
  ii      : integer;    {index}
  ip      : integer;    {page index}
  np      : integer;    {number of pages}
  Outfile : TextFile;   {file where written}
begin
  np := ParamForm.Params.Pages.Count; {number of pages}
  if (np > 1) then begin                {are there pages}
    AssignFile(Outfile, filename);      {open the given file,BUT ERRORS ?}
    rewrite(outfile);
    {write first page separately, because it is a normal Memo component}
    if (ParamForm.ParamMemo.Lines.count > 0) then begin
      for ii := 0 to ParamForm.ParamMemo.Lines.Count - 1 do begin
        Writeln(outfile,ParamForm.ParamMemo.Lines[ii]);
      end;
    end;
    {then the other pages}
    for ip := 2 to np do begin          {all sheets}
      for ii := 0 to MemoPntrArr[ip]^.Lines.Count - 1 do begin
        Writeln(outfile,MemoPntrArr[ip]^.Lines[ii]);
      end;
    end;
    CloseFile(Outfile);
  end;
end;

procedure TParamForm.SaveItemClick(Sender: TObject);
var
  DirName : string;  {directory name to which saved}
begin
  if (SaveDi.execute) then begin
    SaveParamReports(SaveDi.filename);       {save the reports to file}
    DirName := '';                        {initialize}
    FindDir(DirName, SaveDi.filename);
    {if reasonable directory name found, save it for next time}
    if (length(DirName) >=2) then SaveDi.InitialDir := DirName;
  end;
end;


procedure TParamForm.DelItemClick(Sender: TObject);
{delete the active page, but ask for confirmation first}
var
  ii  : integer;  {index}
  ip  : integer;  {page index}
  npo : integer;  {old number of pages}
begin
  npo := Params.Pages.Count;    {old number of pages}
  if (npo >=1) then begin       {is there any pages}
    ip := Params.PageIndex;     {get the index of the page}
    if (ip > 0) then begin      {first page should not be deleted}
      if MessageDlg('Really delete the active page ?',
        mtWarning, [mbYes, mbNo], 0) = mrYes then begin
        MemoPntrArr[ip+1]^.free;    {free (delete) the memo}
        Dispose(MemoPntrArr[ip+1]);
        Params.Pages.Delete(ip);    {delete the page}
        {update the array of memos in the notebook}
        if (npo > 1) then begin      {more than one page}
          for ii := ip+1 to npo-1 do begin          {remember: ip goes from 0 to npo-1}
            MemoPntrArr[ii] := MemoPntrArr[ii+1]; {shoft downwards}
          end;
          MemoPntrArr[npo] := nil;  {clear the uppermost pointer}
        end else begin               {there was only one page}
          MemoPntrArr[1] := nil;
        end;
      end;
    end;
  end;
end;

procedure TParamForm.PrintItemClick(Sender: TObject);
{print one sheet}
var
  ip,ip1    : integer;   {page index, +1}
  Line      : integer;   {the number of lines of text}
  PrintText : TextFile;  {for printing the text}
begin
  ip := Params.PageIndex;              {get the index of the page, from 0}
  ip1 := ip+1;                         {page indes from 1}
  if (ip1 > 0) then begin              {are there pages}
    if PrintDi.Execute then
    begin
      AssignPrn(PrintText);	       {assign PrintText to the printer}
      Rewrite(PrintText);	       {create and open the output file}
      {write the contents of the Memo field to the printer object}
      {first page differently, because it is a Memo component}
      if (ip = 0) then begin
        {assign the current Font setting to the Printer object's canvas}
        Printer.Canvas.Font := ParamForm.ParamMemo.Font;
        {write the contents of the Memo field to the printer object}
        for Line := 0 to ParamForm.ParamMemo.Lines.Count - 1 do
          Writeln(PrintText,ParamForm.ParamMemo.Lines[Line]);
      end else begin                    {"normal report page}
        {assign the current Font setting to the Printer object's canvas}
        Printer.Canvas.Font := MemoPntrArr[ip1]^.Font;
        for Line := 0 to MemoPntrArr[ip1]^.Lines.Count - 1 do
          Writeln(PrintText,MemoPntrArr[ip1]^.Lines[Line]);
      end;
      System.Close(PrintText);
    end;
  end;

end;

procedure TParamForm.DelAllItemClick(Sender: TObject);
{delete the all pages, but ask for confirmation first}
var
  ii  : integer;  {index}
  ip  : integer;  {page index}
  npo : integer;  {old number of pages}
begin
  if MessageDlg('Really delete All pages ?',
                 mtWarning, [mbYes, mbNo], 0) = mrYes then begin
    npo := Params.Pages.Count;      {old number of pages}
    if (npo > 1) then begin          {is there any pages }
      for ii := 1 to npo-1 do begin  {the first page is not deleted}
        ip := npo-ii;                {from 1 to npo-1, first = 0}
        MemoPntrArr[ip+1]^.free;    {free (delete) the memo, index starts at 0}
        Dispose(MemoPntrArr[ip+1]);
        MemoPntrArr[ip+1] := nil;
        Params.Pages.Delete(ip);    {delete the page}
      end;
    end;
  end;

end;

procedure TParamForm.GroupButClick(Sender: TObject);
begin
  if (GroupBut.down) then begin
    GroupBut.font.color := clGreen;
    GroupBut.caption := 'All';
  end else begin
    GroupBut.font.color := clBlue;
    GroupBut.caption := 'Act';
  end;
end;

end.
