{tarkasta "error in row", ei hvi,   tarkasta az01.sld  ei Xend}
unit RXLines;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, ExtCtrls,Routines, Utildef, Buttons, StdCtrls, Skemadef, Marker,
  Distance,Polygon, Impmark;

type
  TRXLineForm = class(TForm)
    LineGrid: TStringGrid;
    ColorPanel: TPanel;
    ColorImage: TImage;
    AddBut: TButton;
    MsgBut: TBitBtn;
    LineList: TListBox;
    DeleteBut: TButton;
    CloseBut: TButton;
    ModifyBut: TButton;
    PhaseRadBut: TRadioButton;
    ResidualRadBut: TRadioButton;
    BothRadBut: TRadioButton;
    procedure FormCreate(Sender: TObject);
    procedure LineGridSelectCell(Sender: TObject; Col, Row: Longint;
      var CanSelect: Boolean);
    procedure ColorImageMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure LineGridDrawCell(Sender: TObject; Col, Row: Longint;
      Rect: TRect; State: TGridDrawState);
    procedure LineGridKeyPress(Sender: TObject; var Key: Char);
    procedure AddButClick(Sender: TObject);
    procedure DeleteButClick(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure FormShow(Sender: TObject);
    procedure CloseButClick(Sender: TObject);
    procedure LineListClick(Sender: TObject);
    procedure InitializeGrid;
    procedure ConstructMarkerLine(var line: string; var ertot: integer);
    procedure ModifyButClick(Sender: TObject);
    procedure MsgButClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  RXLineForm: TRXLineForm;

implementation

uses PQRelay, Skemproc, Imagopas;

{$R *.DFM}

const
  NameRow  = 0;
  ResistRow = 1;
  ReactRow = 2;
  ColorRow = 3;
  StartRow = 4;
  EndRow   = 5;
  ThickRow = 6;
  nLDit    = 10;       {number of data items for a line marker}
var
  ActRow   : integer;
  d_p      : char;     {decimal point: '.' or ','}
  CRwidth  : integer;  {width (and height) of a small color rectangle}
  CRspace  : integer;  {width of space between color rectangles}

procedure TRXLineForm.FormCreate(Sender: TObject);
var
  ii  : integer;
  ipu : integer; {temporary}
begin
  {determine the char.for the decimal point}
  DecimalPoint(d_p);  {in routines.pas}
  {captions}
  LineGrid.Cells[0,NameRow] := 'Name';
  LineGrid.Cells[0,ResistRow] := ' R (Ohm)';
  LineGrid.Cells[0,ReactRow] := ' X (Ohm)';
  LineGrid.Cells[0,ColorRow] := 'Color';
  LineGrid.Cells[0,StartRow] := 'Xstart';
  LineGrid.Cells[0,EndRow]   := 'Xend';
  LineGrid.Cells[0,ThickRow] := 'thickness';  
  {initialize the parameters for the lines}
  InitializeGrid;
{ LineGrid.Cells[1,NameRow] := 'A';
  LineGrid.Cells[1,ResistRow] := '0';
  LineGrid.Cells[1,ReactRow] := ' ';
  LineGrid.Cells[1,ColorRow] := '1';}
  {initialize the color selection image}
  {PQForm.}ColorInitialize(@ColorImage);
  {PQForm.}GetCRsize(CRwidth,CRspace);
  ColorPanel.width := ColorImage.width+2*CRspace;
  ColorPanel.height := ColorPanel.width;
  ipu := 0;
  for ii := 0 to ColorRow do  ipu := ipu+LineGrid.RowHeights[ii];
  ColorPanel.top := LineGrid.top+ipu+2*LineGrid.GridLineWidth;
  ColorPanel.left := LineGrid.left+LineGrid.ColWidths[0]+2*LineGrid.GridLineWidth;
  {add flag that form created}
  Imagoo.ReadyEdit.text := Imagoo.ReadyEdit.text+'x';
end;

procedure TRXLineForm.InitializeGrid;
begin
  {initialize the parameters for the lines}
  LineGrid.Cells[1,NameRow] := 'A';
  LineGrid.Cells[1,ResistRow] := '0';
  LineGrid.Cells[1,ReactRow] := ' ';
  LineGrid.Cells[1,ColorRow] := '1';
  LineGrid.Cells[1,StartRow] := '-1';
  LineGrid.Cells[1,EndRow]   := '1';
  LineGrid.Cells[1,ThickRow] := '2';  
end;

procedure TRXLineForm.LineGridSelectCell(Sender: TObject; Col,
  Row: Longint; var CanSelect: Boolean);
begin
  ActRow := row;
  if (row = ColorRow) and (col = 1) then begin  {row for selecting the color}
    {must not edit the color row}
    LineGrid.options := LineGrid.options-[goEditing,goAlwaysShowEditor];
    ColorPanel.visible := true;             {show the color palette}
    ColorPanel.bringtofront;
  end else begin
    ColorPanel.visible := false;
    {can edit}
    LineGrid.options := LineGrid.options+[goEditing,goAlwaysShowEditor];
  end;
end;

procedure TRXLineForm.ColorImageMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
{get color index from X and Y}
var
  ii,jj,kk : integer;
begin
  ii := (X div (CRwidth+CRspace))+1;
  jj := (Y div (CRwidth+CRspace))+1;
  kk := (ii-1)*4+jj;                 {color index}
  LineGrid.cells[1,ColorRow] := inttostr(kk);
  ColorPanel.visible := false;
  Repaint;  { ?? }
end;

procedure TRXLineForm.LineGridDrawCell(Sender: TObject; Col, Row: Longint;
  Rect: TRect; State: TGridDrawState);
var
  iclr : integer;   {color index}
  ipu  : integer;   {temporary}
  txt  : string;    {temporary}
begin
  {row for the selection of the color}
  if (row = ColorRow) and (col = 1) then begin
    txt := LineGrid.cells[col,row];
    if (txt <> '') then begin
      iclr := strtoint(txt);
      if (iclr < 1) then iclr := 1;
      if (iclr > 16) then iclr := 16;
      LineGrid.canvas.pen.color := gColor[iclr];
      LineGrid.canvas.brush.color := gColor[iclr];
      {a rectangle indicates the color}
      LineGrid.canvas.rectangle(rect.left+LineGrid.GridLineWidth,
                                rect.top +LineGrid.GridLineWidth,
                                rect.left+LineGrid.RowHeights[row]-LineGrid.GridLineWidth,
                                rect.top +LineGrid.RowHeights[row]-LineGrid.GridLineWidth);
    end;
  end;
end;

procedure TRXLineForm.LineGridKeyPress(Sender: TObject; var Key: Char);
begin
  {clear reactance, when entering resistance, and vice versa}
  if (ActRow = ResistRow) then begin  {editing resistance}
    LineGrid.Cells[1,ReactRow] := ' ';
    LineGrid.Cells[0,StartRow] := 'Xstart';
    LineGrid.Cells[0,EndRow] := 'Xend';
  end else if (ActRow = ReactRow) then begin
    LineGrid.Cells[1,ResistRow] := ' ';
    LineGrid.Cells[0,StartRow] := 'Rstart';
    LineGrid.Cells[0,EndRow] := 'Rend';
  end;
  {accept only numbers, '+', '-', '.' or ',', when entering data}
  if (ActRow > 0) then begin             {first row is for text}
    if ((key = ',') or (key = '.')) then key := d_p
    {only numbers and . or , accepted}
    else if not(((key >= '0') and (key <= '9')) or
                 (key = '+') or (key = '-') or
                 (key  = #8 ) or
                 (key =  #3 ) or (key = #22)) then   {"copy" and "paste"}
      key := #0;
  end else if (key = ';') or (key = gImpedSep) then begin   {row for the name of the marker}
    key := #0;                         {';' used as separator}
  end;
end;

procedure TRXLineForm.ConstructMarkerLine(var line: string; var ertot: integer);
{collect the parameters of a marker in the grid to one string
 line    the string of the parameters
 ertot   error flag}
var
  err     : integer;  {error flag}
  ii      : integer;  {index }
  txa     : string;   {temporary}
  txb,txc : string;   {temporary}
  txt     : string;   {temporary}
begin
  {check first that the numbers are correct}
  ertot := 0;
  for ii := 1 to LineGrid.RowCount-1 do begin
    line := LineGrid.cells[1,ii];
    chkfloat(line, err,txt);
    ertot := ertot+err;
    if (err <> 0) then begin
      display_message(RXLineForm,MsgBut,'error in row '+inttostr(ii+1)); {in marker.pas}
    end;
  end;
  {add only if no errors}
  if (ertot = 0) then begin
    {save the last modified: R or X }
    if (LineGrid.Cells[1,ReactRow] = ' ') then begin    {R given, X = ' '}
      txb := ' R = '+LineGrid.cells[1,ResistRow]+' Ohm'+gImpedSep+' '+gImpedSep;
      txa := 'Xstart = '+LineGrid.cells[1,StartRow]+gImpedSep+
             'Xend = '+LineGrid.cells[1,EndRow]+gImpedSep;
    end else begin
      txb := ' '+gImpedSep+' X = '+LineGrid.cells[1,ReactRow]+' Ohm'+gImpedSep;
      txa := 'Rstart = '+LineGrid.cells[1,StartRow]+gImpedSep+
             'Rend = '+LineGrid.cells[1,EndRow]+gImpedSep;
    end;
    {code the thickness of the line (pen.width) in number of spaces before the color index!?}
    txt := LineGrid.cells[1,ThickRow];
    if      (txt = '0') then txc := ''
    else if (txt = '1') then txc := ' '
    else if (txt = '2') then txc := '  '
    else if (txt = '3') then txc := '   '
    else if (txt = '4') then txc := '    '
    else if (txt = '5') then txc := '     '
    else  txc := '  ';   {two spaces = default}
    {construct the whole line}
    line :=         LineGrid.cells[1,NameRow]+gImpedSep+txb+
            {'   ( '}txc+' ('+LineGrid.cells[1,ColorRow]+' )'+gImpedSep;
    {add indicator where the marker is displayed: phase plane, or residual, or both}
    if (PhaseRadBut.checked) then line := line+'21'+gImpedSep
    else if (ResidualRadBut.checked) then line := line+'21N'+gImpedSep
    else line := line+'both'+gImpedSep;
    {add the start and end points}
    line := line+txa;
  end;
end;

procedure TRXLineForm.AddButClick(Sender: TObject);
{add a new marker to the list of markers}
var
  cnt     : integer;  {no of lines = no of markers}
  dp      : Char;     {decimal point: (,) or (.)}
  err     : integer;  {error flag}
  ertot   : integer;  {total error}
  IDx,IDy : string;   {position of identifier}
  ii,jj   : integer;
  ipu     : integer;  {temporary}
  line    : string;
  owidth  : integer;  {original width}
  pComp   : TpComp;   {pointer to the active relay}
  rlx     : single;   {relative size of image}
  txa,txb : string;   {temporary}
  txc,txt : string;   {temporary}
begin
  {construct the parameter line}
  ConstructMarkerLine(line, ertot);
  {continue, if no errors}
  if (ertot = 0) then begin
    {add the line to the grid}
    LineList.items.add(line);
    {determine location of the identifier}
    if (tag <> 0) then begin   {pointer to relay saved in tag}
      pComp := TpComp(tag);
      if (isMho(pComp)) then begin
        owidth := Dist.OrigWidth;
      end else begin
        owidth := Poly.OrigWidth;         {original width of the char.image}
        rlx := Poly.SizeScaling;
      end;
      {position of the identifier for the last modified: R or X }
      if (LineGrid.Cells[1,ReactRow] = ' ') then begin    {R given, X = ' '}
        IDx := '4';                     {distance from line (relative position)}
        IDy := inttostr(owidth-16);     {near bottom (abs.position)}
      end else begin
        IDx := inttostr(owidth-16);     {distance from right boundary (abs.position)}
        IDy := '4';                     {distance from line (relative position)}
      end;
      {save data as a description, but add position of identifier first}
      {save the data of the new marker = add to data line}
      pComp^.GetDescrQ(txa,txb,txc);            {data in first string}
      {add data for the new marker, default position for the identifier}
      txa := txa+line+'line'+gImpedSep+IDx+gImpedSep+IDy+gImpedSep;
      pComp^.PutDescrQ(1,txa,'','');            {save, as "description"}
      if (isMho(pComp)) then DistanceRelayShow  {Mho-distance relay}
      else PolygonRelayShow;                    {polygon-distance relay}
    end;
  end;
end;

procedure TRXLineForm.DeleteButClick(Sender: TObject);
{delete the selected marker}
var
  iMark       : integer;
  nMark       : integer;  {no of markers}
  pComp       : TpComp;   {pointer to the (last clicked) relay of the graph}
  txa,txb,txc : string;   {temporary}
begin
  iMark := LineList.ItemIndex;              {index of selected marker}
  if (iMark >= 0) then begin                  {some item selected}
    LineList.Items.delete(iMark);           {delete it from the marker list}
    {save data and redraw picture without the deleted marker}
    if (tag <> 0) then begin                    {pointer to relay saved in tag}
      pComp := TpComp(tag);
      {must also delete from the string of data}
      nMark := LineList.Items.count;            {no of markers left}
      pComp^.GetDescrQ(txa,txb,txc);            {data in third string}
      {update the line with the marker data}
      RemoveMarkerData(txa,iMark,nMark,txc);
      pComp^.PutDescrQ(1,txc,'','');            {put data back}
      if (isMho(pComp)) then DistanceRelayShow  {Mho-distance relay}
      else PolygonRelayShow;                    {polygon-distance relay}
    end;
  end;
end;

procedure ReplaceMarkerData(DescrOld,DataLine: string; iMark: integer; var DescrNew: string);
{replace (modified) data in the line of Line-marker data (saved as a description)
 DescrOld    old line of data = a line of desrcriptions of all markers
 DataLine    the new data replacing the old
             NOTE: the relative position of the identifier is not replaced (two last items)
 iMark       the number of the marker (first = 0)
 DescrNew    new line of data}
var
  ii    : integer;  {index}
  iRep  : integer;  {start of the data to be replaced}
  iSep  : integer;  {counts separators}
  iStrt : integer;  {start of the unchanged data}
  len   : integer;  {length of string}
begin
  len := length(DescrOld);
  if (len > 0) then begin               {there is some data (else error!)}
    if (iMark < 0) then begin           {not reasonable index}
      DescrNew := DescrOld;
    end else begin                      {reasonable index or marker}
      if (iMark > 0) then begin         {not the first marker}
        {copy the data for markers before this marker}
        DescrNew := '';
        iSep := 0;
        iRep := 1;
        for ii := 1 to len do begin
          DescrNew := DescrNew+DescrOld[ii];
          if (DescrOld[ii] = gImpedSep) then begin
            inc(iSep);
            if (iSep = iMark*nLDit) then begin  {end of data for markers before this}
              iRep := ii+1;                     {index of first char. for marker iMark}
              break;                            {copy only so far}
            end;
          end;
        end;
      end else begin                   {first marker}
        iRep := 1;                     {start from the first character}
        DescrNew := '';
      end;
      {search for the start of the unchanged data after marker iMark}
      if (iRep < len) then begin
        iSep := 0;
        iStrt := len;                   {initialize, to keep the compiler happy}
        for ii := iRep to len do begin
          if (DescrOld[ii] = gImpedSep) then begin  {separator found}
            inc(iSep);
            if (iSep = nLDit-3) then begin
              iStrt := ii+1;           {beginning of unchanged data found}
              break;
            end;
          end;
        end;
        {add the new part}
        DescrNew := DescrNew+DataLine;
        {copy the remaining part of the old data, if there is (should be) }
        if (iStrt < len) then begin
          for ii := iStrt to len do begin
            DescrNew := DescrNew+DescrOld[ii];
          end;
        end;
      end else begin                     {some error}
        DescrNew := DescrOld;            {just some value}
      end;

    end;
  end else begin
    DescrNew := '';           {error case??}
  end;

end;

procedure TRXLineForm.FormKeyPress(Sender: TObject; var Key: Char);
begin
  {accept only numbers, '+', '-', '.' or ',', when entering data}
  if (ActRow > 0) then begin             {first row is for text}
    if ((key = ',') or (key = '.')) then key := d_p
    {only numbers and . or , accepted}
    else if not(((key >= '0') and (key <= '9')) or
                 (key = '+') or (key = '-') or
                 (key  = #8 ) or
                 (key =  #3 ) or (key = #22)) then   {"copy" and "paste"}
      key := #0;
  end else if (key = ';') or (key = gImpedSep) then begin   {row for the name of the marker}
    key := #0;                         {';' used as separator}
  end;
end;

procedure TRXLineForm.FormShow(Sender: TObject);
begin
  {copy marker data from component}
  CopyMarkerData(tag,false, @LineList);
  InitializeGrid;                        {initial parameter values}
  ModifyBut.enabled := false;            {must be false, before a line is selected}
end;

procedure TRXLineForm.CloseButClick(Sender: TObject);
begin
  RXLineForm.visible := false;
end;

procedure TRXLineForm.LineListClick(Sender: TObject);
{copy the parameters of the markers to the grid}
var
  line    : string;  {the line with the parameters}
  nSpace  : integer; {number of spaces = codes line thickness}
  txa,txb : string;  {temporary}
  txc     : string;  {temporary}
  txz,txf : string;  {temporary}
begin
  ModifyBut.enabled := true;               {true, when a line selected}
  line := LineList.items[LineList.ItemIndex];
  {copy parameters one by one}
  ExtractParam(1,gImpedSep,line,txa);      {identifier}
  LineGrid.Cells[1,NameRow] := txa;        {identifier taken as such}
  ExtractParam(2,gImpedSep,line,txa);      {resistance}
  {must extract numerical value}
  GetNumericalString(txa, txb);            {in Impmark.pas}
  if (txb = '') then txb := ' ';           {space used as a flag, see AddButClick}
  LineGrid.Cells[1,ResistRow] := txb;
  ExtractParam(3,gImpedSep,line,txa);      {reactance}
  GetNumericalString(txa, txb);            {in Impmark.pas}
  if (txb = '') then txb := ' ';           {space used as a flag, see AddButClick}
  LineGrid.Cells[1,ReactRow] := txb;
  ExtractParam(4,gImpedSep,line,txa);      {color of marker}
  GetNumericalString(txa, txb);            {in Impmark.pas}
  LineGrid.cells[1,ColorRow] := txb;
  nSpace := NumberOfSpaces(txa);           {numer of spaces-1 = pen size, in distance.pas}
  if (nSpace > 1) then LineGrid.cells[1,ThickRow] := inttostr(nSpace-1)
  else LineGrid.cells[1,ThickRow] := '2';
  ExtractParam(5,gImpedSep,line,txa);      {plane on which displayed}
  if (txa = '21') then PhaseRadBut.checked := true
  else if (txa = '21N') then ResidualRadBut.checked := true
  else BothRadBut.checked := true;
  ExtractParam(6,gImpedSep,line,txa);      {starting value of the line}
  GetNumericalString(txa, txb);            {in Impmark.pas}
  LineGrid.cells[1,StartRow] := txb;
  ExtractParam(7,gImpedSep,line,txa);      {end value of the line}
  GetNumericalString(txa, txb);
  LineGrid.cells[1,EndRow] := txb;
end;

procedure TRXLineForm.ModifyButClick(Sender: TObject);
{modify the selected marker = replace parameters in the list and in the description
 with the parameters in the grid}
var
  ertot    : integer; {error flag}
  DataLine : string;  {line with the modified parameters of the marker (not ID-position)}
  DescrOld : string;  {old string (description) with the parameters of all markers}
  DescrNew : string;  {new string (description) with the parameters of all markers}
  iMark    : integer; {index of the marker, 0 = first}
  pComp    : TpComp;  {pointer to the relay}
  txa,txb  : string;  {temporary}
begin
  ertot := 0;                                  {initialize}
  ConstructMarkerLine(DataLine, ertot);        {collect the parameters to one line}
  iMark := LineList.ItemIndex;                 {index of selected marker}
  if (RXLineForm.tag <> 0) and (ertot = 0) and {pointer to relay saved in tag}
    (iMark >= 0) and (iMark < LineList.items.count) then begin  {reasonable index}
    {replace the data in the list visible on the lower part of the marker form}
    LineList.Items.Delete(iMark);             {delete the old line}
    LineList.Items.Insert(iMark,DataLine);    {add the new line}
    pComp := TpComp(RXLineForm.tag);
    {save the data of the new marker = add to data line}
    pComp^.GetDescrQ(DescrOld,txa,txb);                     {data in first string}
    ReplaceMarkerData(DescrOld, DataLine, iMark, DescrNew); {in "description" = data for all markers}
    {save the data as a description}
    pComp^.PutDescrQ(1,DescrNew,'','');       {save, as a "description"}
    {update the graph}
    if (isMho(pComp)) then DistanceRelayShow  {Mho-distance relay}
    else PolygonRelayShow;                    {polygon-distance relay}
  end;
  ModifyBut.enabled := false;                 {forces to select a row before modifying}
end;

procedure TRXLineForm.MsgButClick(Sender: TObject);
begin
  MsgBut.visible := false;
end;

end.
