unit chcolor;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls;

type
  TForm1 = class(TForm)
    Image1: TImage;
    Button1: TButton;
    Button2: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

type
  TpImage = ^TImage;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure ChangeIconColor(pFromImg,pToImg : TpImage; oldclr,clr : TColor);
{copy the icon of one image to another, and change the parts of the given color
 of the icon to another color
 The icons are assumed to be 32*32  (MUTTA jos ei ole? ?)
 pFromImg   pointer to the icon to be copied from
 pToImg     pointer to the icon to be copied to
 oldclr     the color to be replaced
 clr        the color that replaces oldclr }
var
  bmask    : TBitmap;     {transparency mask}
  CopyBmp  : TBitmap;     {the icon is first copied here, then modified}
  ico      : TIconInfo;   {information of the new icon}
  ii,jj    : integer;     {indices}
  TmpIcon  : TIcon;       {temporary icon}
begin
  {First, create the temporary icons and bitmaps}
  CopyBmp := TBitmap.Create;
  bmask := TBitmap.Create;
  TmpIcon := TIcon.Create;
  try
    {set the size of the temporaries}
    CopyBmp.width := pFromImg^.picture.icon.width;
    CopyBmp.height := pFromImg^.picture.icon.height;
    bmask.Width := pFromImg^.picture.icon.width;
    bmask.Height := pFromImg^.picture.icon.height;
    {copy the icon to the temporary bitmap}
    CopyBmp.canvas.draw(0,0,pFromImg^.picture.icon);     {draw = copy the icon}
    {define the transparent area = white area = everything else but the figure on the icon}
    bmask.monochrome := true;
    bmask.Canvas.Brush.Color := clWhite;                 {white for transparency}
    bmask.Canvas.FillRect(RECT(0,0,bmask.width,bmask.height));
    {change the color of the black pixels and the transparent = white pixels}
    for ii := 0 to CopyBmp.width-1 do begin
      for jj := 0 to CopyBmp.height-1 do begin
        if (CopyBmp.canvas.pixels[ii,jj] = oldclr) then begin {change from the old color...}
          CopyBmp.canvas.pixels[ii,jj] := clr;            {..to the given color}
          bmask.canvas.pixels[ii,jj] := clBlack;          {black = not transparent}
        end else if (CopyBmp.canvas.pixels[ii,jj] = clWhite) then begin
          CopyBmp.canvas.pixels[ii,jj] := clBlack;        {transparent}
        end else begin
          bmask.canvas.pixels[ii,jj] := clBlack;         {mask must be black where the figure is}
        end;
      end;
    end;
    {create the icon. Parameters are set to ico}
    ico.fIcon := true;              {it is an icon, not a cursor}
    ico.hbmColor := CopyBmp.handle; {transparency mask}
    ico.hbmMask := bmask.handle;    {figure on the icon}
    ico.xHotspot := 0;              {actually not needed, because an icon}
    ico.yHotspot := 0;
    TmpIcon.Handle := CreateIconIndirect(ico); {create the icon}
    {copy the icon to the image for display}
    pToImg^.picture.icon.assign(TmpIcon);{pToImg^.picture.icon := TmpIcon;   {copy to output}
  finally
    {free the temporary bitmaps and icons}
    CopyBmp.free;
    bmask.Free;
   {imagoo.invalidate;      {icon does not disapplear now, when changing the color !?}
    TmpIcon.Free;
  end;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  ChangeIconColor(@Image1,@Image1,clBlack, clAqua);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  ChangeIconColor(@Image1,@Image1,clAqua, clBlack);
end;

end.
 