{tag of reset button must be 0 (used as flag: "this is the reset button")}
unit drawmain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Buttons, StdCtrls;

type
  TDrawForm = class(TForm)
    ResetBut: TSpeedButton;
    RectBut: TSpeedButton;
    CloseBut: TButton;
    EllipBut: TSpeedButton;
    TestBut: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure FormDestroy(Sender: TObject);
    procedure CloseButClick(Sender: TObject);
    procedure TestButClick(Sender: TObject);
    procedure RectButClick(Sender: TObject);
    procedure ResetButClick(Sender: TObject);
    procedure EllipButClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

type
  TpForm = ^TForm;

type
  TdrawPhase = (wipe, move, up); {wiping, mousemove, mouseup}

{define procedure "pointer"}
type
  TpProc = ^TProc;
  TProc = procedure(ipComp : longint);
  TpSpeedBut = ^TSpeedButton;
  TpComponent = ^TComponent;

{define object for managing the shapes (graphs, figures,..}
type
  TGraphiq = class(TObject)
private
  g_drawing    : boolean;   {drawing a shape. Set in... reset in ...}
  g_first      : boolean;   {drawing first shape, when moving the mouse. Set in.., reset in..}
  g_grIndex    : integer;   {group index for the buttons for selecting the shape}
  g_List       : TList;     {list of pointers to the shapes}
  g_nBut       : integer;   {number of shape buttons}
  g_ButList    : TList;     {pointers to buttons for different shapes}
  g_pForm      : TpForm;    {pointer to the form, where shapes drawn}
  g_ResButDown : boolean;   {reset button down}
  g_shapeIndex : integer;   {index of the shape to be drawn, 0 = nothing, 1=rectangle, 2=ellips, etc}
  g_x          : integer;   {coordinates of the mouse (cursor)}
  g_y          : integer;
  g_x0         : integer;   {x of initial point when starting to draw}
  g_y0         : integer;   {y of initial point when starting to draw}
  g_x1         : integer;   {x of latest point when drawing}
  g_y1         : integer;   {y of latest point when drawing}
  g_xf         : integer;   {last (final) x when drawing}
  g_yf         : integer;   {last (final) y when drawing a shape}
  g_dproc      : integer;   {index for drawing procedure}
  DrawProc     : array[0..5] of TProc;   {procedures for drawing different shapes}

  constructor Create(pForm: TpForm; grIndex: integer);
  destructor Destroy; override;
  procedure ResButState(down: boolean);  {copy the state of the reset button}
  procedure TestButtons;
//procedure NoDraw(iflag: longint);
  procedure DrawRectangle(iflag : longint);
  procedure DrawEllipse(iflag : longint);
  procedure PutMouseXY(x,y: integer);
  procedure PutStartXY(x,y: integer);
  procedure PutLatestXY(x,y: integer);
  procedure PutFinalXY(x,y: integer);
  procedure PutShapeIndex(indx: integer);
  procedure RectCorners(iflag : Longint; var x1,y1,x2,y2 : integer; var draw: boolean);
  procedure StartDrawing(x,y : integer);
  procedure DrawWithMouse(x,y : integer);
  procedure FinishDrawingWithMouse(x,y : integer);
end;

var
  DrawForm  : TDrawForm;
  pDrawForm : TpForm;
  Graphic   : TGraphiq;

implementation
{$R *.DFM}

var
  shp_drawing : boolean;   {drawing a shape. Set in... reset in ...}
  shp_first   : boolean;   {drawing first shape, when moving the mouse. Set in.., reset in..}
  shp_x0      : integer;   {x of initial point when starting to draw}
  shp_y0      : integer;   {y of initial point when starting to draw}
  shp_x1      : integer;   {x of latest point when drawing}
  shp_y1      : integer;   {y of latest point when drawing}
  shp_xf      : integer;   {last (final) x when drawing}
  shp_yf      : integer;   {last (final) y when drawing a shape}

procedure NoDraw(iflag: longint);
begin
 { }
end;

procedure DrawRect(iflag: longint);
begin
  Graphic.DrawRectangle(iflag);
end;

procedure DrawEllip(iflag: longint);
begin
  Graphic.DrawEllipse(iflag);
end;

constructor TGraphiq.create(pForm :TpForm; grIndex: integer);
{pForm    pointer to the form, where shapes/graphs drawn
 grIndex  group index for the buttons for selecting the shape}
var
  pBut   : TpSpeedBut;
  But    : TSpeedButton;
  ii     : integer;  {index}
  nn     : integer;  {counter}
begin
  inherited Create;
  g_List := TList.create;         {create list for pointers to the shapes}
  g_ButList := TList.create;      {list for pointers to buttons for shapes}
  g_pForm := pForm;               {pointer to the form, where drawn} {CHANGE to another ("main") form}
  g_grIndex := grIndex;
  {procedures for drawing different shapes into an array}
  DrawProc[0] := NoDraw;
  DrawProc[1] := DrawRect;
  DrawProc[2] := DrawEllip;
  g_ShapeIndex := 0;
(*
  {find number of shape buttons = speed buttons with the given group index}
  nn := 0;
  g_ButList.clear;                {clear, just to be sure}
  for ii:=0 to pForm^.ComponentCount -1 do begin
    {is the component a speed button}
    if (pForm^.Components[ii] is TSpeedButton) then begin
      if ((pForm^.Components[ii] as TSpeedButton).GroupIndex = grIndex) then begin
        inc(nn);
        pBut := pointer(pForm^.Components[ii] as TSpeedButton);  {buttons to list}
//pBut^.left := pBut^.left-16;
        g_ButList.add(pBut);
//showmessage(inttostr(longint(pBut)));
      end;
    end;
  end;
  g_nBut := nn;
*)
end;

destructor TGraphiq.destroy;
var
  ll,kk,mm : longint;
begin
{just testing that this procedure is called... A long delay when closing..}
//kk := 0;
//for ll := 1 to 1000000000 do begin
//  for mm := 1 to 2 do begin
//    kk := kk+1;
//  end;
//end;
  {the shapes should be freed first...}
  g_List.free;  {free the list of pointers}
  g_ButList.free;
  inherited Destroy;
end;

procedure TGraphiq.RectCorners(iflag : Longint; var x1,y1,x2,y2 : integer;
                               var draw: boolean);
{determine the opposite corners of a rectangle defining the shape to be
 drawn (rectangle, ellipse,..), depending on the phase of drawing
 iflag  the phase of the drawing (moving mouse, wiping, drawing final,...)
 x1,y1,x2,y2  the coordinates of the opposite corners
 draw         flag to draw (no drawing, if some error)}
begin
  {wipe = draw with the opposite color}
  if (TdrawPhase(iflag) = wipe) then begin
    x1 := g_x0;                 {initial point}
    y1 := g_y0;
    x2 := g_x1;                 {opposite corner, when drawing last time}
    y2 := g_y1;
    draw := true;
  {draw when moving the mouse or drawing the final shape, when mouse up} {MORE later...}
  end else if (TdrawPhase(iflag) = move) or
              (TdrawPhase(iflag) = up) then begin
    x1 := g_x0;                 {initial point}
    y1 := g_y0;
    x2 := g_x;                  {mouse coordinates}
    y2 := g_y;
    draw := true;
  end else begin                {error case}
    x1 := 0; y1 := 0; x2 := 0; y2 := 0;  {just some values}
    draw := false;
  end;
end;

procedure TGraphiq.DrawRectangle(iflag : longint);
{draw a rectangle
 iflag  flag that tells where the parameters are taken from
        That is, which phase of drawing:
          drawing when moving the mouse
          wiping the previous
          drawing final when mouse up}
var
  draw  : boolean; {flag for drawing = no errors}
  x1,y1 : integer; {upper/lower left corner}
  x2,y2 : integer; {lower/upper right corner}
begin
  {find the opposite corners}
  RectCorners(iflag, x1,y1,x2,y2, draw);
  {then the actual drawing}
  if (draw) then g_pForm^.canvas.rectangle(x1,y1,x2,y2);
end;

procedure TGraphiq.DrawEllipse(iflag : longint);
{draw an ellipse
 iflag  flag that tells where the parameters are taken from
        That is, which phase of drawing:
          drawing when moving the mouse
          wiping the previous
          drawing final when mouse up}
var
  draw  : boolean; {flag for drawing = no errors}
  x1,y1 : integer; {upper/lower left corner}
  x2,y2 : integer; {lower/upper right corner}
begin
  {find the opposite corners of the rectangle confining the ellipse}
  RectCorners(iflag, x1,y1,x2,y2, draw);
  {then the actual drawing}
  if (draw) then g_pForm^.canvas.ellipse(x1,y1,x2,y2);
end;

procedure TGraphiq.PutMouseXY(x,y: integer);
begin
  g_x := x;
  g_y := y;
end;

procedure TGraphiq.PutStartXY(x,y: integer);
begin
  g_x0 := x;
  g_y0 := y;
end;

procedure TGraphiq.PutLatestXY(x,y: integer);
begin
  g_x1 := x;
  g_y1 := y;
end;

procedure TGraphiq.PutFinalXY(x,y: integer);
begin
  g_xf := x;
  g_yf := y;
end;

procedure TGraphiq.PutShapeIndex(indx: integer);
{save the index of the shape to be drawn, when clicking a shape button
 (rectangle, ellipse, ...}
begin
  if (indx >= 0) and (indx <= 2) then           {BETTER???}
    g_shapeIndex := indx;
end;

procedure TGraphiq.TestButtons;
var
  ii    : integer;
  But   : TSpeedButton;
  pComp : TpComponent;
begin
showmessage(inttostr(g_ButList.count));
  for ii := 0 to g_ButList.count-1 do begin
    pComp := g_ButList[ii];
//    But := (pComp^ as TSpeedButton);
//    But.left := But.left-8;
showmessage((pComp^ as TSpeedButton).name);
  end;
end;

procedure TGraphiq.ResButState(down: boolean);  {copy the state of the reset button}
begin
  g_ResButDown := down;  {copy the state}
end;

procedure TDrawForm.FormCreate(Sender: TObject);
begin
  pDrawForm := @DrawForm;           {use pointer, for compatibility (?)}
  {initialize parameters of shapes, just in case}
  shp_drawing := false;
  shp_first   := false;
  shp_x0      := 0;
  shp_y0      := 0;
  shp_x1      := 0;
  shp_y1      := 0;
  {create the object for managing the shapes}
  Graphic := TGraphiq.create(@DrawForm, 1);
end;

procedure TDrawForm.FormMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  Graphic.StartDrawing(x,y);
(*{if reset button is not down = some other button is down = starting to draw}
  if (not ResetBut.down) then begin
    {save initial point = clicking point}
    shp_x0 := x;
    shp_y0 := y;
    shp_drawing := true;     {starting to draw, reset at mouseup}
    shp_first := true;       {drawing first time (at this time..), reset in mousemove}
  end;
*)
end;

procedure TGraphiq.StartDrawing(x,y : integer);
{save coordinates etc. when starting drawing a shape at mouse down
 x,y  mouse coordinates}
begin
  if (g_ShapeIndex > 0) then begin  {some button for selecting shape is down}
    PutStartXY(x,y);                {save the coordinate of the initial point}
    g_drawing := true;              {set flag for drawing (NEEDED?)}
    g_first := true;                {drawing first time}
  end;
end;

procedure TDrawForm.FormMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  {draw the shape by floowing the mouse}
  Graphic.FinishDrawingWithMouse(x,y);
(*if (shp_drawing) then begin          {is drawing a shape}
    {draw the shape in the final form and size}
    {but first, wipe the previous shape}
    pDrawForm^.canvas.pen.mode := pmNot;
    if (RectBut.down) then begin
      pDrawForm^.canvas.rectangle(shp_x0,shp_y0,shp_x1,shp_y1);
    end else if (EllipBut.down) then begin
      pDrawForm^.canvas.ellipse(shp_x0,shp_y0,shp_x1,shp_y1);
    end;
    {next, draw the final shape}
    pDrawForm^.canvas.pen.mode := pmCopy;   {use the defined color of the pen}
    pDrawForm^.canvas.pen.color := clRed;   {red, so far. More colors later...}
    if (RectBut.down) then begin
      pDrawForm^.canvas.rectangle(shp_x0,shp_y0,x,y);
    end else if (EllipBut.down) then begin
      pDrawForm^.canvas.ellipse(shp_x0,shp_y0,x,y);
    end;
    {save the final coord. of the shape}
    shp_xf := x;
    shp_yf := y;
    shp_drawing := false;                   {stop drawing, was set in mousedown}
  end;
*)
  ResetButclick(sender);  {reset "drawing", button down}
end;

procedure TGraphiq.FinishDrawingWithMouse(x,y : integer);
{when mouse up, drahw the shape in the final form and color
 x,y  mouse coordinates}
begin
  if (g_drawing) then begin          {is drawing a shape}
    PutMouseXY(x,y);                 {save the present coordinates, for drawing}
    {draw the shape in the final form and size}
    {but first, wipe the previous shape}
    g_pForm^.canvas.pen.mode := pmNot;
    DrawProc[g_shapeIndex](longint(wipe));      {wipe = draw with opposite color}
    {next, draw the final shape}
    pDrawForm^.canvas.pen.mode := pmCopy;   {use the defined color of the pen}
    pDrawForm^.canvas.pen.color := clRed;   {red, so far. More colors later...}
    DrawProc[g_shapeIndex](longint(up));
    {save the final coord. of the shape}
    PutFinalXY(x,y);
    g_drawing := false;                   {stop drawing, was set in mousedown}
  end;
end;

procedure TDrawForm.FormMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  {draw the selected shape, if drawing}
  Graphic.DrawWithMouse(x,y);
(*  {draw the selected shape, if drawing}
  if (shp_drawing) then begin
    pDrawForm^.canvas.brush.style:=bsClear;  {do not (yet) fill the shape}
    pDrawForm^.canvas.pen.mode := pmNot;     {opposite of existing color, so that it can be wiped}
    {wipe previous shape, but not on the first time}
    if (shp_first) then begin
      shp_first := false;
    end else begin
      {wipe = draw with the opposite color}
      if (RectBut.down) then begin
        pDrawForm^.canvas.rectangle(shp_x0,shp_y0,shp_x1,shp_y1);
      end else if (EllipBut.down) then begin
        pDrawForm^.canvas.ellipse(shp_x0,shp_y0,shp_x1,shp_y1);
      end;
    end;
    {draw new shape}
    if (RectBut.down) then begin
      pDrawForm^.canvas.rectangle(shp_x0,shp_y0,x,y);
    end else if (EllipBut.down) then begin
      pDrawForm^.canvas.ellipse(shp_x0,shp_y0,x,y);
    end;
    {save the latest point}
    shp_x1 := x;
    shp_y1 := y;
  end;*)
end;

procedure TGraphiq.DrawWithMouse(x,y : integer);        {X,Y jossain vrin...!?}
{draw the given shape by dragging with the mouse
 x,y  mouse coordinates}
begin
  {draw the selected shape, if drawing}
  if (g_drawing) then begin
    PutMouseXY(x,y);                       {save the present mouse coordinates for drawing}
    g_pForm^.canvas.brush.style:=bsClear;  {do not (yet) fill the shape}
    g_pForm^.canvas.pen.mode := pmNot;     {opposite of existing color, so that it can be wiped}
    {wipe previous shape, but not on the first time}
    if (g_first) then begin
      g_first := false;                    {reset, no more first time}
    end else begin
      {wipe = draw with the opposite color}
      DrawProc[g_shapeIndex](longint(wipe));
      {draw new shape at the mouse position}
      DrawProc[g_shapeIndex](longint(move));
    end;
    {save the latest point}
    PutLatestXY(x,y);
  end;
end;

procedure TDrawForm.FormDestroy(Sender: TObject);
begin
//Graphic.destroy;
  Graphic.free;
end;

procedure TDrawForm.CloseButClick(Sender: TObject);
begin
  application.terminate;
end;

procedure TDrawForm.TestButClick(Sender: TObject);
begin
  Graphic.TestButtons;
end;

procedure TDrawForm.RectButClick(Sender: TObject);
begin
  Graphic.PutShapeIndex(1);
end;

procedure TDrawForm.ResetButClick(Sender: TObject);
begin
  ResetBut.down := true;
  Graphic.PutShapeIndex(0);
end;

procedure TDrawForm.EllipButClick(Sender: TObject);
begin
  Graphic.PutShapeIndex(2);
end;

end.
