unit graph;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Buttons, drawmenu, ExtCtrls, StdCtrls;

type
  TGraphForm = class(TForm)
    ShapeBut: TSpeedButton;
    TestImage: TImage;
    TestImage2: TImage;
    Edit1: TEdit;
    procedure ShapeButClick(Sender: TObject);
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure FormCreate(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

type
  TpForm = ^TForm;  

var
  GraphForm : TGraphForm;

implementation

{$R *.DFM}

procedure TGraphForm.ShapeButClick(Sender: TObject);
begin
  DrawMenuForm.visible := ShapeBut.down;
end;

procedure TGraphForm.FormMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  DrawMenuForm.StartDrawing(x,y);
end;

procedure TGraphForm.FormMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  {draw the shape by floowing the mouse}
  DrawMenuForm.FinishDrawingWithMouse(x,y);
end;

procedure TGraphForm.FormMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  DrawMenuForm.DrawWithMouse(x,y);
end;

procedure TGraphForm.FormCreate(Sender: TObject);
begin
  DrawMenuForm.PutpMainForm(longint(@GraphForm),longint(@ShapeBut));
end;

procedure TGraphForm.FormPaint(Sender: TObject);
begin
  DrawMenuForm.DrawAll;
end;

procedure TGraphForm.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
{move the graphical elements}
var
  dx,dy : integer;
begin
  dx := 0;
  dy := 0;
  if (key = 38) then dy := -16
  else if (key = 39) then dx := 16
  else if (key = 40) then dy := 16
  else if (key = 37) then dx := -16;
  if (dx <> 0) or (dy <> 0) then DrawMenuForm.MoveAll(dx,dy);
end;

end.
