{20.12.2002   some limits in LUbacksub, in order to avoid overflows
   Occurred, when a capacitor in fronot of an asynchronous motor}
unit Matmul;
interface
  uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, ExtCtrls, StdCtrls, Buttons{,
  matdef},utildef;

{ procedure ValuesFromLine(line: String; npar :Integer; var ipar: Integer;
                         var pa1,pa2,pa3,pa4 : Single); 26.3.2003}
(*
  procedure AlignText(line,value:String; var newlin:String);
*)
  procedure ReserveRealMat(nnod : integer; var pA,pW,pB : pSingle; var pI : pInteger);
  procedure FreeRealMat(nnod: integer;  var pA,pW,pB : pSingle; var pI : pInteger);
  procedure ClearREq(nnod : integer; var pA,pW,pB : pSingle; var pI : pInteger);
  procedure NumberOfWords(hintx :String; onlyspace:boolean; wno: Integer;
                    var npar,wlen: Integer; var oneword:String);
  procedure CopyUntilNumbers(line:string; var hintx: String);
(*function NearestGrid(Xin:Integer;Half:Boolean):Integer;*)
  procedure RemoveSpaces(rnum: Single; var Disp2:String);
  procedure chkfloat(line: String; var ercod:Integer);
  function Angle(x,y : single): single;
  procedure copyVecCol(pbb,paa : pSingle; jj,nn,mm : integer);
  procedure CopyMat(paa,pbb : pSingle; nrr,ncc : integer);
  procedure squmul(paa,pbb,pcc:pSingle;nn, nj: integer);
  procedure putmat(paa:pSingle;i,j,m,n:Integer;xx:Single);
  procedure showmat(paa: pSingle; m,n : integer);
  procedure getmat(paa:pSingle;i,j,m,n:Integer;var xx:Single);
  procedure putvec(paa:pSingle;i,m:Integer;xx:Single);
  procedure getvec(paa:pSingle;i,m:Integer;var xx:Single);
  procedure clearvec(pbb: pSingle; nn : integer);
  procedure clearmat(paa : psingle; nn:integer);
  procedure submat(paa,pbb,pcc : pSingle; nn,mm : integer);
  procedure CopyUpLeftMat(prr,paa : pSingle; nn, mm : integer; var erc : integer);
  procedure CopyLowLeftMat(prr,pcc : pSingle; nn, mm,ll : integer; var erc : integer);
  procedure CopyLowRightMat(prr,pdd : pSingle; nn, mm : integer; var erc : integer);
  procedure CopyVect(paa,pcc : pSingle; nn : integer);
  procedure CopyAndRearrange(prr,pdd : pSingle; nrr, nee, njj : integer;
                             var erc : integer);
  procedure PartialElimination(prr,pdd : pSingle; pIndx: pInteger;
                               nn ,mm  : integer; var erc : integer);
  procedure LUdecomp(paa ,pvv:pSingle;
                     Nn:Integer; pindx:pInteger;
                     var Dodd:Single; var Sngl: Integer;
                     var Tout:Single);
  procedure LUbacksub(paa:pSingle; Nn :Integer;
                      pindx: pInteger;
                      pbb: pSingle);
  procedure InvertMat(paa, pcc : pSIngle; nn : integer; var err : integer);
  procedure Dsqumul(paa,pbb,pcc: pDouble; nn, nj: integer);
  procedure Smatmul(paa,pbb,pcc: pSingle; ni,nn,nj: integer);
  procedure Dmatmul(paa,pbb,pcc: pDouble; ni,nn,nj: integer);
  procedure putDmat(paa:pDouble;i,j,m,n:Integer;xx:Double);
  procedure getDmat(paa:pDouble;i,j,m,n:Integer;var xx:Double);
  procedure putDvec(paa:pDouble;i,m:Integer;xx:Double);
  procedure getDvec(paa:pDouble;i,m:Integer;var xx:Double);
  procedure clearDvec(pbb: pDouble; nn : integer);
  procedure clearDmat(paa : pDouble; nn:integer);
  procedure DLUdecomp(paa ,pvv:pDouble;
                     Nn:Integer; pindx:pInteger;
                     var Dodd: Single; var Sngl: Integer;
                     var Tout: Double);
  procedure DLUbacksub(paa:pDouble; Nn :Integer;
                      pindx: pInteger;
                      pbb: pDouble);

  procedure putImat(paa:pInteger;i,j,m,n:Integer;xx:Integer);
  procedure getImat(paa:pInteger;i,j,m,n:Integer;var xx:Integer);
  procedure clearIvec(paa : pInteger;nn : integer);

const
  dec_pG : Char='.'; {global decimal point character, checked when form loaded}

implementation
(*
procedure ValuesFromLine(line: String; npar :Integer; var ipar: Integer;
                         var pa1,pa2,pa3,pa4 : Single);
{extracts (numeric) values of parameters from a text line of numbers
          values (words) separated by space(s)
          at most 4 parameters
 line     the text line with the numbers (in)
 npar     number of parameters (in)
 ipar     number of parameters found in the line (out)
 pa1,pa2,pa3,pa4    the numeric values (out)}
var
  apu   : Single;   {temporary}
  errc  : Integer;  {error code}
  j     : Integer;  {index, or counter}
  ll    : Integer;  {length of line}
  tx    : char;     {one character}
  word  : String;   {one word in the line}
  wfnd  : boolean;  {word found}
begin
  {extract the parameter values from the line, separated by spaces etc}
  ll := length(line);             {length of the line}
  ipar := 0;                      {initialize parameter count}
  wfnd := false;                  {initialize flag for finding a word}
  word := '';                     {clear the word}
  for j:=1 to ll do begin         {purpose is to read to end of line}
    tx := line[j];                {copy one character, study it}
    if (tx=' ') or (j=ll) then begin  {a space or end of line => end of word}
      if (j=ll) then begin        {last char. treated separately}
        if (tx <> ' ') then begin {last char. not a space}
          word := word+tx;        {append last character}
          wfnd := true;           {a non-space char. found (number?)}
        end;
      end;
      if (wfnd) then begin        {was constructing a word}
        ipar := ipar+1;           {increment parameter counter}
        wfnd := false;            {for next time}
        chkfloat(word,errc);      {check is the word a number}
        if (errc <> 0) then begin {not a number}
          showmessage('parameter '+inttostr(ipar)+' is not a number,'
                      +  ' error code '+inttostr(errc));
          word := '';
        end else begin            {is a number}
          apu := strtofloat(word);{change to number}
          if      (ipar = 1) then pa1 := apu   {copy to component}
          else if (ipar = 2) then pa2 := apu
          else if (ipar = 3) then pa3 := apu
          else if (ipar = 4) then pa4 := apu;  {at most 4 params.}
          word := '';             {reinitialize the word}
        end;
      end else begin              {not a word, spaces in a row}
        wfnd := false;
        {apu := 0;}
      end;
    end else begin                {not a space, assumed is part of a number}
      wfnd := true;               {found or constructing a word}
      {accept both . and , as decimal point, eventually must change in order
       to correspond to system default}
       if      (dec_pG = ',') and (tx = '.') then tx := ','
       else if (dec_pG = '.') and (tx = ',') then tx := '.';
       word := word+tx             {append this char. to word}
    end;
  end;
end;
*)
(*
procedure AlignText(line,value:String; var newlin:String);
{
 line     contains words (in)
 value    contains numbers, separated by spaces (out)
 newlin   line copied here, with spaces added (out)

 line is copied to newlin, and spaces are added between the words,
 so that the words in newlin are aligned with the numbers in value
 (a font with fixed length for each character assumed)

 That is: From this:

 aa  bb  cc  dd                    (line)
 123    4,56     70    8           (value)

 should become this

 aa     bb       cc    dd          (newlin)
 123    4,56     70    8           (value)
 }
var
  i,j   : Integer;       {index, or counter}
  iapu  : Integer;       {temporary}
  iapv  : Integer;       {temporary}
  nlin  : Integer;       {number of words in line}
  nval  : Integer;       {number of words in value}
  onewrd: String;        {one returned word}
  wlen  : Integer;       {length of the value (as string)}
  xxstr : String;        {temporary}
begin
 {adjust the length of the space between the words in the parameter list,
  so that the text and the values are aligned}
  onewrd := '';                         {initialize}

  NumberOfWords(line,false,-1,nlin,iapu,xxstr); {number of parameters}
  NumberOfWords(value,true,-1,nval,iapu,xxstr); {number of numeric values,
                                                 separated by spaces}
  newlin := '';                                 {initialize new line}
  {if different number of words => either error, or not complete,
   if one word (or less), no need to adjust}
  if (nlin=nval) and (nlin>1)then begin {more than one word => there is space}
    for i:=1 to nlin do begin         {scan all words}
      NumberOfWords(line,false,i,iapu,iapv,onewrd);  {pick word  i}
      onewrd := onewrd+' ';           {add one space, to separate words}
      NumberOfWords(value,true,i,iapu,wlen,xxstr); {length of parameter i,
                                                    WITH spaces}
      {adjust the length of the parameter text, if necessary and possible}
      iapu := length(onewrd);         {length of the parameter text}
      if (iapu < wlen) then begin     {shorter than the value}
        iapv := wlen-iapu;            {difference in length}
        for j:=1 to iapv do begin
          onewrd := onewrd+' ';       {add spaces}
        end;
      end;
      newlin := newlin+onewrd;        {new parameter list}
    end;
  end else begin
    newlin := line;                   {copy as such}
  end;
end;
*)

procedure ReserveRealMat(nnod : integer; var pA,pW,pB : pSingle; var pI : pInteger);
{reserve memory for a real set of equations, and initialize
 nnod   = number of nodes = dimension (will change later !!!)
 pA     = pointer to the coefficient matrix
 pW     = pointer to working space
 pB     = pointer to the right hand side
 pI     = pointer to index array, for exchange of rows }
begin
  getmem(pA,nnod*nnod*Sizeof(single));  {for admittance matrix}
  getmem(pW,nnod*Sizeof(single));       {for working space}
  getmem(pB,nnod*Sizeof(single));       {for right hand side}
  getmem(pI,nnod*Sizeof(integer));       {for index array}
  ClearREq(nnod, pA, pW, pB, pI)
end;

procedure FreeRealMat(nnod: integer;  var pA,pW,pB : pSingle; var pI : pInteger);
{free the memory reserved for the matrices, etc}
begin
  freemem(pA,nnod*nnod*Sizeof(single));  {for admittance matrix}
  freemem(pW,nnod*Sizeof(single));       {for working space}
  freemem(pB,nnod*sizeof(single));       {for right hand side}
  freemem(pI,nnod*sizeof(integer));      {for index vector}
end;

procedure ClearREq(nnod : integer; var pA,pW,pB : pSingle; var pI : pInteger);
{clear matrices etc for a real set of  equations}
var
  i,j  : integer ;  {indices}
  cc   : single;
  pInt : pInteger;  {temporary pointer to integers}
begin
  cc := 0;
  if (pA <> nil) and (pW <> nil) and (pB <> nil) and (pI <> nil)
      and (nnod > 0) then begin
    for i:=1 to nnod do begin
      for j := 1 to nnod do begin
        putmat(pA,i,j,nnod,nnod,cc);
      end;
      putvec(pW,i,nnod,cc);
      putvec(pB,i,nnod,cc);
    end;
    {initialize also index vector}
    pint := pI;
    for i:=1 to nnod do begin
      pint^:= 0;
      inc(pint);
    end;
  end;
end;

procedure NumberOfWords(hintx :String; onlyspace:boolean; wno: Integer;
                    var npar,wlen: Integer; var oneword:String);
{determines the number of words separated by commas or other non-letter chars.
 and returns the wno'th word (first, second, third, etc.)
 hintx      the text to be studied  (in)
 onlyspace  if true => only spaces accepted to separate words (in)
 wno        1 = first word is retuned, 2 = second word is returned etc (in)
 npar       number of words (out)
 wlen       length of the selected word WITH trailing spaces ! (out)
 oneword    the returned word  (out)}
var
  i     : Integer;   {index, or counter}
  iapu  : Integer;   {temporary}
  lngt  : Integer;   {word length}
  text  : String;    {local}
  wflag : boolean;   {flag for (eventual) start of a word}
begin
  iapu := length(hintx);                {length of the hint text}
  npar := 0;                            {initialize number of parameters}
  wflag := false;                       {initialize flag for a new word}
  text :='';                            {initialize (each) word}
  lngt := 0;                            {initialize}
  oneword := '';
  for i:=1 to iapu do begin             {scan the hint text}
                                        {some non-letter char. found ?}
    if ((hintx[i] >='0') and (hintx <= '9')) or    {number ?}
       ((hintx[i] >='A') and (hintx <= 'Z')) or    {capital letter ?}
       ((hintx[i] >='a') and (hintx <= 'z')) or
       {optionally only spaces considered as separators}
       ((hintx[i] <>' ') and (onlyspace))  then begin
       if (not wflag) then begin        {first character of a word}
         if (npar = wno) then begin     {output data for the previous word}
           wlen := lngt;
         end;
         npar := npar+1;                {increment word count}
         wflag := true;                 {set flag for first letter}
         text := hintx[i];              {copy first letter of the word}
         lngt := 1;                     {start to calculate length}
       end else begin                   {start of word already found}
         text := text+hintx[i];         {continue constructing the word}
         lngt := lngt+1;                {increment length}
       end;
       if (i=iapu) then begin           {special treatment at end of line}
         if (npar = wno) then oneword := text; {return the desired word}
       end;
    end else begin                      {not a letter or number}
      if (wflag) then begin             {end of a word}
        wflag := false;                 {reset flag}
        if (npar = wno) then oneword := text;  {return the desired word}
        text := '';                     {reinitialize text}
      end;
      if (lngt > 0) then lngt := lngt+1;{inclrement only if word found}
      if (i=iapu) then  begin           {end of line, special treatment}
        if (npar = wno) then wlen := lngt; {length of the word, WITH spaces}
      end;
    end;
  end;
end;

procedure CopyUntilNumbers(line:string; var hintx: String);
{copies from line to hintx, until a number is detected}
var
  i      : Integer;    {index, or counter}
  iapu   : Integer;    {temporary}
begin
  iapu := length(line);                 {length of the hint}
  hintx :='';                           {crear hint text}
  for i:=1 to iapu do begin             {pick only text, no numbers}
    if (line[i] < '0') or (line[i] > '9') then begin
      hintx := hintx+line[i];           {copy char.  for char, not numbers!}
    end else begin
      if (i > 1) then begin             {anything copied}
        if (hintx[i-1] < 'A') then begin
          hintx[i-1] := ' ';            {replace comma etc with space}
        end;
      end;
      break;                            {break at first number !}
    end;
  end;
end;

(*
function NearestGrid(Xin:Integer;Half:Boolean):Integer;
{Calculates the nearest grid point for a given integer
 If Half = true, use denser grid = half of default
 Xin      the integer for which the nearest grid point is calculated (in)
 Half     flag for denser grid}
  const
    Igrid = 16;   {the default grid spacing, in pixels}
  var
    iapu:Integer;
  begin
    {normal or denser grid ?}
    if (Half) then iapu := Igrid div 2
    else           iapu := Igrid;
    NearestGrid :=iapu*((Xin+(iapu div 2) ) div iapu);
  end;
*)
procedure RemoveSpaces(rnum: Single; var Disp2:String);
{copies the rnum as string to Disp2 in given format, removes (leading) spaces
 rnum    the number to be copied (in)
 Disp2   the number as text, without spaces (out)}
var
  i    : Integer;    {index, or counter}
  iapu : Integer;    {temporary}
  Disp1: String;     {temporary string}
begin
  Disp1 := Format('%12.6g',[rnum]);     {copy formatted to temporary}
  Disp2 := '';                          {clear text}
  iapu := length(Disp1);
  for i:=1 to iapu do begin             {length depends on format}
    if (Disp1[i] <> ' ') then begin     {skip all spaces}
      Disp2 := Disp2+Disp1[i];          {append "non-space" characters}
    end;
  end;
end;

  procedure chkfloat(line: String; var ercod: Integer);
  {checks, whether the line corresponds to a valid floating point
   (or integer) number
   line    the string that should be a number (in)
   ercod   error code = 0, if correct number}
  var
    dp   : Char;      {decimal point: (,) or (.)}
    i    : integer;   {index, or counter}
    nch  : integer;   {number of characters in the string to be studied}
    ph   : integer;   {phases, depending what has been found
                       0 = start
                       1 = only numbers found
                       2 = + or -  found
                       3 = , (or .) found
                       4 = , (r .) and numbers found
                       5 = e or E found
                       6 = + or - after e or E found
                       7 = one number found after e or E or e+,e-,E+E-
                       8 = two numbers found after e ...}
    tx   : char;      { a single character}
  begin
    dp := dec_pG;                 {get the (global) decimal point character}
    ph := 0;                      {initialize phase}
    ercod := 0;                   {initialize error code}
    nch := length(line);          {number of characters}
    for i:=1 to nch do begin      {scan the whole line}
      tx := line[i];              {copy to local}
      if (ph = 0) then begin      {just starting}
      {first character must be only + - , e E  a number  space}
        if      (tx = ' ')                 then ph := 0
        else if (tx >='0') and (tx <= '9') then ph := 1
        else if (tx ='+') or (tx = '-')    then ph := 2
        else if (tx = dp)                  then ph := 3
        else if (tx = 'e') or (tx = 'E')   then ph := 5
        else begin
          ercod := 1;             {set error code}
          break;                  {errror found, stop}
        end;
      end else if (ph = 1) then begin
      {after a number only  another number  ,  e E allowed}
        if      (tx>='0') and (tx <= '9')  then ph := 1
        else if (tx = dp)                  then ph := 3
        else if (tx = 'e') or (tx = 'E')   then ph := 5
        else  begin
          ercod := 2;
          break;
        end;
      end else if (ph = 2) then begin
      {after + or - only  a number   ,  e E allowed}
        if (tx >='0') and (tx <= '9')      then ph := 1
        else if (tx = dp)                  then ph := 3
        else if (tx = 'e') or (tx = 'E')   then ph := 5
        else begin
          ercod := 3;
          break;
        end;
      end else if (ph = 3) then begin
      {after a comma only a number allowed or e or E}
        if (tx >= '0') and (tx <='9')      then ph := 4
        else if (tx = 'e') or (tx = 'E')   then ph := 5
        else begin
          ercod := 5;
          break;
        end;
       end else if (ph = 4) then begin
       {after a comma and numbers only  nunbers  e   E allowed}
         if (tx >= '0') and (tx <='9')     then ph := 4
         else if (tx = 'e') or (tx = 'E')  then ph := 5
         else begin
           ercod := 5;
           break;
         end;
       end else if (ph = 5) then begin
       {after e or E only + -  numbers allowed}
         if (tx ='+') or (tx = '-')         then ph := 6
         else if (tx >='0') and (tx <= '9') then ph := 7
         else begin
           ercod := 6;
           break;
         end;
       end else if (ph = 6) then begin
       {after e+ etc only numbers allowed}
         if (tx >='0') and (tx <= '9')      then ph := 7
         else begin
           ercod := 7;
           break;
         end;
       end else if (ph = 7) then begin
       {after  e+ only two numbers allowed}
         if (tx >='0') and (tx <= '9')      then ph := 8
         else begin
           ercod := 8;
           break;
         end;
       end else if (ph = 8) then begin
       {after e+$$ only spaces allowed}
         if (tx = ' ')                      then ph := 8
         else begin
           ercod := 9;
           break;
         end;
       end else begin
       {there should not be any other phases}
         ercod := 10;
         break;
      end;
    end;
  end;

function Angle(x,y : single): single;
{calculate the polar angle when x (real) and y (imag) given}
const
  pi=3.14159265;
var
  apu : single;
begin
  if (x > 0) then begin
    angle := ArcTan(y/x);
  end else if (x < 0) then begin
    apu := ArcTan(abs(y/x));
    if (y > 0)      then angle := pi-apu
    else if (y < 0) then angle := apu-pi
    else                 angle := pi;
  end else begin
    if (y > 0)      then angle := 0.5*pi
    else if (y < 0) then angle := -0.5*pi
    else                 angle := 0;
  end;
end;

procedure CopyMat(paa,pbb : pSingle; nrr,ncc : integer);
{copy matrix A to matrix B
 paa   pointer to matrix A
 pbb   pointer to natrix B
 nrr   no of rows
 ncc   no of columns}
var
  ii    : integer;
  nt    : integer;
  pa,pb : pSingle;
begin
  nt := nrr*ncc;
  if (nt > 0) then begin
    pa := paa;
    pb := pbb;
    for ii := 1 to nt do begin
      pb^:= pa^;
      inc(pa);
      inc(pb);
    end;
  end;
end;


 procedure copyVecCol(pbb,paa : pSingle; jj,nn,mm : integer);
 {copy vector pbb^ to column jj of matrix paa^
 pbb     pointer to vector to be copied
 paa     pointer to matrix, where copied
 ii      index of row
 nn,mm   dim of paa (rows, columns)}
 var
   ii    : integer;
   pa,pb : pSingle;
 begin
   if (nn > 0) and (mm > 0) and (jj > 0) and (jj <= mm) then begin
     pa := paa;
     pb := pbb;
     inc (pa,jj-1);
     for ii := 1 to nn do begin
       pa^ := pb^;
       inc(pa,mm);
       inc(pb);
     end;
   end;
 end;



  procedure squmul(paa,pbb,pcc:pSingle; nn,nj: integer);
  {this procedure multiplies a matrix or vector by a square matrix
      cc = aa*bb, where aa(nn,nn) is the square matrix
                        bb(nn,nj) is a more general matrix or vector
                        cc(nn,nj) is the result matrix (or vector
   NOTE: no checks of the dimensions are done, be sure that
         the dimensions (especially ) of cc are correct !!!
   paa,pbb,pcc  pointers to square matrices aa,bb,cc (in)
                but actually aa, bb are inputs, result to cc
   nn           dimension of the matrices (in)
   NOTE: pSingle is a pointer to a real variable of type "single"
         it is defined in unit matdef.pas}
  var
    pai,pbj,paij,pbij,pcij: pSingle; {local pointers to rows, columns, elements}
    i,j,k: Integer; {indices}
    apu:   Single;  {temporary}
  begin
    {initialize local pointers to first element in the matrices}
    pai := paa;
    pbj := pbb;
    pcij := pcc;
    {loop over rows}
    for i:=1 to nn do begin
      {loop over columns}
      for j:=1 to nj do begin
        apu := 0;
        pbij := pbj;  {pointer to first element in column j of bb}
        paij := pai;  {pointer first element in row i of aa}
        for k := 1 to nn do begin
          apu := apu+paij^*pbij^; {apu := apu+aa(i,k)*bb(k,j)}
          inc(paij);              {next element in aa = next in row i}
          inc(pbij,nj);           {next element in bb = next in column j}
        end;
        pcij^:= apu; {cc[i,j] := apu}
        inc(pcij);   {next element in cc}
        inc(pbj);    {next column in bb}
      end;
      pbj := pbb;    {again first column in bb}
      inc(pai,nn);   {next row in aa}
    end;
  end;

procedure LUdecomp(paa  :pSingle;   {pointer to the matrix to be be decomposed
                                     original in, decomposed out}
                   pvv  :pSingle;   {pointer to working space,
                                     for implicit scaling of each row}
                   (*var vv: array of Single; {working space, for scaling}
                   {Note: here the index starts from zero !!!}*)
                   Nn   :Integer;   {dimension of the matrix, in}
                   pindx:pInteger;  {pointer to an array recording the
                                     row permutations}
                   (*var indx: array of integer; {records the row permutations}
                   {NOTE: here the index starts from zero !!!}*)
                   var Dodd:Single; { -1, if odd number of permutaions, else 1}
                   var Sngl:Integer; {flag for singular matrix}
                   var Tout:Single); {test-output}
{LUdecomp  decomposes (in place) a matrix into LU-form}
const
  tiny=1.0e-20;
var
  apu      : Single;   {temporary}
  big      : Single;   {max. element, temporary}
  i,j,k    : Integer;  {indices}
  imax     : Integer;  {max index}
  pi,pj,pij: pSingle;  {pointers to row i, column j, element i,j of matrix a}
  pjj      : pSingle;  {pointer to diagonal}
  pik,pkj  : pSingle;  {pointers to element ik, kj  in matrix a}
  pjk      : pSingle;  {pointer to element jk in matrix a}
  pindxj   : pInteger; {pointer to element j in indx}
  pimaxk   : pSingle;  {pointer to element  imax,k in matrix a}
  prj      : pSingle;  {pointer to row j}
  pvi      : pSingle;  {pointer to element i in vv}
  pvimax   : pSingle;  {pointer to element imax in vv}
  sum, dum : Single;   {temporary}

begin
  Dodd := 1;
  Sngl := 0;
  {initialize vector vv, just for clarity}
  pvi := pvv;
  for i:=1 to Nn do begin
    (*vv[i-1] := 0.0;*) pvi^:= 0.0;
    inc(pvi);
  end;
  {check for zero rows}
  pij := paa;  {initialize pointer to first element in matrix a}
  pvi := pvv;
  for i:=1 to Nn do begin
    big := 0.0;
    for j:=1 to Nn do begin
      apu := abs(pij^);
      if (apu > big) then big := apu;
      inc(pij);  {pointer to next element in matrix a}
    end; {end of loop over j,  = over elements in a row}
    {preliminary check of obvious singularity}
    if (big <= tiny{0.0}) then begin
      Sngl := Sngl+1;
    end else begin
      (*vv[i-1] := 1.0/big;*) pvi^:= 1.0/big;
    end;
    inc(pvi);
  end;   {end of loop over i,  = over rows}
  {proceed only in not obviously singlular matrix}
  if (Sngl = 0) then begin
    {start the decomposition}
    pj := paa;       {initialize column pointer to first column}
    pjj := paa;      {initialize pointer to diagonal element}
    prj := paa;      {initialize pointer to row j}
    pindxj := pindx; {initialize pointer to vector indx}
    for j:=1 to Nn do begin
      if (j > 1) then begin
        pi := paa;
        pij := pj;
        for i:=1 to j-1 do begin
          sum := pij^;
          pik := pi;
          pkj := pj;
          if (i > 1) then begin
            for k:=1 to i-1 do begin
              sum := sum-pik^*pkj^;  { a(i,k)*a(k,j) }
              inc(pik);
              inc(pkj,Nn);
            end;
            pij^:= sum;
          end;
          inc(pij,Nn);
          inc(pi,Nn); {next row}
        end;
      end;
      big := 0.0;
      pij := pjj; {alkaa (j,j)st}
      pi  := prj; {paa; inc(pi,(j-1)*Nn);} {alkaa (j,1):st}
      pvi := pvv; inc(pvi,(j-1));
      imax := j;  {initialize 11.1.2002}
      for i:=j to Nn do begin
        sum := pij^;
        if (j > 1) then begin
          pik :=  pi;  {alkaa (j,1).st}
          pkj :=  pj;  {alkaa (1,j):st}
          for k:= 1 to j-1 do begin
            sum := sum-pik^*pkj^;
            inc(pik);
            inc(pkj,Nn);
          end;
          pij^:= sum;
        end;
        dum := pvi^*abs(sum);
        if (dum > big) then begin
          big := dum;
          imax := i;
        end;
        inc(pvi);
        inc(pi,Nn);
        inc(pij,Nn);
      end;
      if (j <> imax) then begin
        pjk := paa;    inc(pjk,(j-1)*Nn);      {alkaa (j,1):st}
        pimaxk := paa; inc(pimaxk,(imax-1)*Nn); {alkaa (imax,1)st}
        for k:=1 to Nn do begin
          dum := pimaxk^;     {dum := a[imax,k] }
          pimaxk^ := pjk^;    {a[imax,k] := a[j,k] }
          pjk^ := dum;        {a[j,k] := dum  }
          inc(pimaxk);
          inc(pjk);
        end;
        Dodd := -Dodd;
        pvi := pvv; inc(pvi,j-1);
        pvimax := pvv; inc(pvimax,imax-1);
        (*vv[imax-1] := vv[j-1];*)pvimax^:= pvi^;
      end;
      pindxj^:= imax;  (*indx[j-1] := imax;*)
      if (j <> Nn) then begin
        if (abs(pjj^)< tiny) then pjj^:= tiny;
                                         {if a[j,j] = 0.0 then a[j,j] := tiny;}
        dum := 1.0/pjj^;                 {dum := 1.0/a[j,j];}
        pij := pjj; inc(pij,Nn);         {alkaa (j+1,j):st }
        for i:=j+1 to Nn do begin
          pij^ := pij^*dum; {a[i,j] := a[i,j]*dum;}
          inc(pij,Nn);
        end;
      end;
      inc(pindxj);   {pointer to next element in indx}
      inc(pjj,Nn+1); {pointer to next diagonal element (jj)}
      inc(pj);       {pointer to next column}
      inc(prj,Nn);    {pointer to next row j}
    end;
    pjj := paa;
    inc(pjj,Nn*Nn-1);
    if (abs(pjj^)<tiny) then pjj^ := tiny;  {if a[n,n] = 0 then a[n,n] := tiny}
  end;
end;

procedure LUbacksub(paa  : pSingle;   {pointer to the matrix aa in LU-form}
                    Nn   : Integer;   {dimension of the matrixes}
                    pindx: pInteger;  {pointer to the array storing
                                       the row exchanges}
                    pbb  : pSingle);  {pointer to the right hand side
                                             AND solution}
{LUbacksub solves the equation  AX = b, when A is given in the LU-form
 paa    is the pointer to the first element in A  (in)
 pbb    is the pointer to the right hand side b (in),
        and returns the solution X (out)
 pindx  is the pointer to the array storing the row exhanges,
        calculated in LUdecomp (in)}
 var
  apu      : Single;   {temporary}
{ dpu      : double;}
  j,ip,ii,i: Integer;  {indices}
  sum      : Single;   {temporary sum}
  pbi      : pSingle;  {pointer to bb[i]}
  pbid     : pSingle;  {pointer to bb[...]}
  pbj      : pSingle;  {pointer to bb[j]}
  pdi      : pInteger; {pointer to indx[i]}
  pij      : pSingle;  {pointer to element (ij) in array aa}
  pri      : pSingle;  {pointer to row i in array aa}
  pii      : pSingle;  {pointer to element ii in aa}
 begin
   ii := 0;
   pri := paa;
   pdi := pindx; {pointer to indx, starts from 1}
   pbi := pbb;   {pointer to bb[i], starts from 1}
   for i:=1 to Nn do begin
     ip := pdi^;                    {ip := indx[i];}
     pbid := pbb; if (ip > 0) then inc(pbid,ip-1);   {pointer to bb[indx[i]]}
     sum := pbid^;                  {sum := bb[ip1];}
     pbid^:= pbi^;                  {bb[ip] := bb[i];}
     if (ii <> 0) then begin
       pij := pri; inc(pij,ii-1);   {starts from i,ii}
       pbj := pbb; inc(pbj,ii-1);   {starts from ii}
       for j := ii to i-1 do begin
         sum := sum -pij^*pbj^;     {sum-bb[j]}
         inc(pij);
         inc(pbj);
       end;
     end else if (sum <> 0.0) then begin
       ii := i;
     end;
     pbi^ := sum;                   {bb[i] := sum}
     inc(pri,Nn);
     inc(pbi);
     inc(pdi);
   end;
   pii := paa; inc(pii,Nn*Nn-1); {pointer to last element in aa}
   pri := pii; dec(pri,Nn-1);    {pointer to last row in aa}
   pbi := pbb; inc(pbi,Nn-1);    {pointer to b[i], starts from Nn}
   for i:=Nn downto 1 do begin
     sum := pbi^;                {sum := bb[i];}
     if (sum > 1e9) then sum := 1e9
     else if (sum < -1e9) then sum := -1e9;
     if (i < Nn) then begin
       pij := pri; inc(pij,i);   {starts from i,i+1}
       pbj := pbb; inc(pbj,i);   {starts from i+1}
       for j:=i+1 to Nn do begin
         sum := sum-pij^*pbj^;   {sum := sum-pij^*bb[j];}
         if (abs(sum) > 1e9{1e20}) then begin      {20.12.2002}
           if (sum > 0) then sum := 1e9{1e20}
           else              sum := -1e9{-1e20;}
         end;
         inc(pij);
         inc(pbj);
       end;
     end;
     apu :=abs(pii^);
     if (apu > 0.9e-9{20}) then begin {avoid division by "zero"}
       pbi^:= sum/pii^;            {bb[i] := sum/pii^;}
     end else begin
       pbi^ := sum*1.e9{20};      {20.12.2002}
     end;
     dec(pbi);
     dec(pri,Nn);
     dec(pii,Nn+1);
   end;
 end;

 procedure putmat(paa: pSingle;  {pointer to the first element of the matrix}
                  i,j: Integer;  {indices of the element}
                  m,n: Integer;  {the dimensions of the matrix}
                  xx : Single);  {the value to be put into the matrix}
 {putmat copies the value of xx to the location i,j of tha matrix
         with dimensions (m rows * n columns)}
 var
   pij: pSingle;  {pointer to the element i,j}
 begin
   {some checks, just to be sure}
   if (i>0) and (i<=m) and (j>0) and (j<=n) then begin
     pij := paa;
     inc(pij,n*(i-1)+j-1);
     pij^:= xx;
   end;
 end;

 procedure putImat(paa: pInteger; {pointer to the first element of the matrix}
                   i,j: Integer;  {indices of the element}
                   m,n: Integer;  {the dimensions of the matrix}
                   xx : Integer); {the value to be put into the matrix}
 {putImat copies the value of the INTEGER xx to the location i,j of tha matrix
         with dimensions (m rows * n columns)}
 var
   pij: pInteger;  {pointer to the element i,j}
 begin
   {some checks, just to be sure}
   if (i>0) and (i<=m) and (j>0) and (j<=n) then begin
     pij := paa;
     inc(pij,n*(i-1)+j-1);
     pij^:= xx;
   end;
 end;

 procedure putvec(paa: pSingle; i,m:Integer;xx:Single);
 var
   pi: pSingle;
 begin
   if ((i>0) and (i<=m)) then begin
     pi := paa;
     inc(pi,i-1);
     pi^:= xx;
   end
 end;

 procedure getvec(paa: pSingle; i,m:Integer;var xx:Single);
 var
   pi: pSingle;
 begin
   if ((i>0) and (i<=m)) then begin
     pi := paa;
     inc(pi,i-1);
     xx := pi^;
   end
 end;

procedure clearvec(pbb: pSingle; nn : integer);
var
   ii : integer;
   pi : pSingle;
begin
  if (nn > 0) and (pbb <> nil) then begin
    pi := pbb;
    for ii:=1 to nn do begin
      pi^:= 0;
      inc(pi);
    end;
  end;
end;


 procedure getmat(paa: pSingle;  {pointer to the first element of the matrix}
                  i,j: Integer;  {indices of the element}
                  m,n: Integer;  {the dimensions of the matrix}
              var xx : Single);  {the value to get the value of aa(i,j)}
 {getmat copies the value of xx to the location i,j of tha matrix
         with dimensions (m rows * n columns)}
 var
   pij: pSingle;  {pointer to the element i,j}
 begin
   {some checks, just to be sure}
   if (i>0) and (i<=m) and (j>0) and (j<=n) then begin
     pij := paa;
     inc(pij,n*(i-1)+j-1);
     xx := pij^;
   end;
 end;

procedure showmat(paa: pSingle; m,n : integer);
{display the values of a matrix}
 var
   i,j : integer;
   pij : pSingle;  {pointer to the element i,j}
 begin
   {some checks, just to be sure}
   if (m > 0) and (n > 0) then begin
     pij := paa;
     for i := 1 to m do begin
       for j := 1 to n do begin
         showmessage('i,j,val   '+inttostr(i)+'  '+inttostr(j)+'  '+
                     floattostr(pij^));
         inc(pij);
       end;
     end;
   end;
 end;



 procedure getImat(paa: pInteger;{pointer to the first element of the matrix}
                  i,j: Integer;  {indices of the element}
                  m,n: Integer;  {the dimensions of the matrix}
              var xx : Integer); {the value to get the value of aa(i,j)}
 {getmat copies the value of the INTEGER xx to the location i,j of the matrix
         with dimensions (m rows * n columns)}
 var
   pij: pInteger;  {pointer to the element i,j}
 begin
   {some checks, just to be sure}
   if (i>0) and (i<=m) and (j>0) and (j<=n) then begin
     pij := paa;
     inc(pij,n*(i-1)+j-1);
     xx := pij^;
   end;
 end;

procedure clearmat(paa : psingle; nn:integer);
{clear a nn*nn matrix}
var
  pij : psingle;
  ii  : integer;
  n2  : integer;
begin
  if (nn > 0) and (paa <> nil) then begin
    n2 := nn*nn;
    pij := paa;
    for ii:=1 to n2 do begin
      pij^:= 0;
      inc(pij);
    end;
  end;
end;

procedure submat(paa,pbb,pcc : pSingle; nn,mm : integer);
{subtract matrix:  "pcc^:= paa^- pbb^"
 nn  no of rows
 mm no of columns}
var
  ii        : integer;
  nm        : integer;
  pa,pb,pc  : pSingle;
begin
  if (nn > 0) and (mm > 0) then begin
    nm := nn*mm;
    pa := paa;
    pb := pbb;
    pc := pcc;
    for ii := 1 to nm do begin
      pc^:= pa^-pb^;
      inc(pa);
      inc(pb);
      inc(pc);
    end;
  end;
end;




procedure clearIvec(paa : pInteger; nn: integer);
{clears an inteer vector at paa with dimension nn}
var
  ii  : integer;  {index}
  pa  : pInteger; {pointer to an element in paa}
begin
  if (paa <> nil) and (nn > 0) then begin
    pa := paa;
    for ii:=1 to nn do begin
      pa^:= 0;
      inc(pa);
    end;
  end;
end;

procedure InvertMat(paa, pcc : pSIngle; nn : integer; var err : integer);
{invert a matrix
 paa  pointer to the matrix to be inverted
 pcc  pointer to the inverted matrix
 NOTE  paa  must not be the same as pcc !
 NOTE  paa is destroyed !
 nn   dimension
 err  error flag}
var
  dodd : single;   {keeps track on odd / even permutations}
  ii   : integer;  {index}
  pci  : pSingle;  {pointer to working space}
  pind : pInteger; {pointer to row exchanges}
  pvv  : pSingle;  {pointer to working space}
  sngl : integer;  {flag for singular matrix}
  tout : single;   {test output}
begin
  if (nn > 0) then begin
    clearmat(pcc,nn);
    {pind := nil;}
    {pvv := nil;}
    getmem(pind, nn*SizeOf(integer));
    getmem(pvv , nn*SizeOf(single));
    try
      if (pind <> nil) and (pvv <> nil) and (paa <> pcc) then begin    {there was room}
        clearIvec(pind,nn);
        clearvec(pvv,nn);
        LUdecomp(paa, pvv, nn, pind, Dodd, Sngl, Tout);
        if (sngl <> 0) then err := 1 else err := 0;
        for ii := 1 to nn do begin
          Clearvec(pvv,nn);
          pci := pvv;
          inc(pci,ii-1);
          pci^ := 1.0;            {one to each row in turn}
          LUbacksub(paa,nn,pind,pvv);
          copyVecCol(pvv,pcc,ii,nn,nn);
        end
      end else begin       {not enough room}
        err := -1;
      end;
    finally
      {finally, clear working space}
      if (pind <> nil) then freemem(pind, nn*SizeOf(integer));
      if (pvv  <> nil) then freemem(pvv , nn*SizeOf(single));
    end;
  end else begin
    err := -2;
  end;
end;

procedure CopyUpLeftMat(prr,paa : pSingle; nn, mm : integer; var erc : integer);
{copy a square part of a square matrix
 prr  pointer to "from" matrix
 paa  pointer to "to" matrix
 nn   dim of "from" matrix
 mm   dim of "to" matrix
 erc  error code
 that is

 if  r = A B    where r, A, D are square matrices, then copy A to paa
         C D    }
var
  ii,jj  : integer;  {indices}
  nm     : integer;  {nn-mm}
  pa,pr  : pSingle;  {pointers to one element in rr, dd}
begin
  erc := 0;
  if (nn > 0) and (mm > 0) and (mm <= nn) then begin  {reasonable indices}
    nm := nn-mm;
    pa := paa;
    pr := prr;
    for ii := 1 to mm do begin
      for jj := 1 to mm do begin
        pa^:= pr^;
        inc(pa);
        inc(pr);
      end;
      inc(pr,nm);
    end;
  end else begin
    erc := 1;
  end;
end;

procedure CopyVect(paa,pcc : pSingle; nn : integer);
{copy vector paa to vector pcc
 paa  pointer to the vector  to be copied
 pcc  pointer to vector, where copiec
 nn   dimension of the vector}
var
  ii  : integer;
  pa  : pSingle;  {pointer to one element in paa}
  pc  : pSingle;  {pointer to one element in pcc}
begin
  pa := paa;
  pc := pcc;
  if (nn > 0) then begin
    for ii := 1 to nn do begin
      pc^:= pa^;
      inc(pa);
      inc(pc);
    end;
  end else begin
    ClearVec(pcc,nn);
  end;
end;

procedure CopyLowRightMat(prr,pdd : pSingle; nn, mm : integer; var erc : integer);
{copy a square part of a square matrix
 prr  pointer to "from" matrix
 pdd  pointer to "to" matrix
 nn   dim of "from" matrix
 mm   dim of "to" matrix
 erc  error code
 that is

 if  r = A B    where r, A, D are square matrices, then copy D to pdd
         C D    }
var
  ii,jj  : integer;  {indices}
  nm     : integer;  {nn-mm}
  pd,pr  : pSingle;  {pointers to one element in rr, dd}
begin
  erc := 0;
  nm := nn-mm;
  if (nn > 0) and (mm > 0) and (mm <= nn) then begin
    pr := prr;
    inc(pr,nn*nm+nm);
    pd := pdd;
    for ii := 1 to mm do begin
      for jj := 1 to mm do begin
        pd^:= pr^;
        inc(pd);
        inc(pr);
      end;
      inc(pr,nm);
    end;
  end else begin
    erc := -1;
  end;
end;

procedure CopyLowLeftMat(prr,pcc : pSingle; nn, mm,ll : integer; var erc : integer);
{copy a rectangular part of a square matrix
 prr    pointer to "from" matrix
 pcc    pointer to "to" matrix
 nn     dim of "from" matrix
 mm,ll  dim of "to" matrix
 erc    error code
 that is

 if  r = A B    where r, A, D are square matrices, then copy C to pcc
         C D    }
var
  ii,jj  : integer;  {indices}
  nl     : integer;  {nn-ll}
  nm     : integer;  {nn-mm}
  pc,pr  : pSingle;  {pointers to one element in rr, cc}
begin
  erc := 0;
  if (nn > 0  ) and (mm > 0  ) and (ll > 0) and
     (mm <= nn) and (ll <= nn) then begin
    nm := nn-mm;
    nl := nn-ll;
    pr := prr; inc(pr,nn*nm);  {pointer to first element to be copied}
    pc := pcc;
    for ii := 1 to mm do begin
      for jj := 1 to ll do begin
        pc^:= pr^;
        inc(pc);
        inc(pr);
      end;
      inc(pr,nl);
    end;
  end else begin
    erc := 1;
  end;
end;


procedure CopyRectPartMat(prr, pdd : pSingle;
                          nrr,rowr,colr,rowd,cold,mcc,ncc : integer;
                          var erc : integer);
{copy a rectangular part of square matrix rr to square matrix dd of same size as rr
 prr  pointer to matrix from which copied
 pdd  pointer to matrix to which copied
 nrr  dim of both matrices rr and dd
 rowr, colr  row and col in rr of the first element in the part to be copied
 rowd, cold  row and col in dd to where the first element is copied
 mcc, ncc  size of the part to be copied (no of rows, no of columns)
 erc  error code}
var
  ii, jj : integer;   {indices}
  pr, pd : pSingle;   {pointers to one element in rr, dd}
begin
  if (nrr  > 0) and
     (rowr > 0) and (rowr <= nrr) and
     (colr > 0) and (colr <= nrr) and
     (rowd > 0) and (cold <= nrr) and
     (mcc  > 0) and (mcc  <= nrr-rowr+1) and
     (ncc  > 0) and (ncc  <= nrr-colr+1) and
     (mcc  > 0) and (mcc  <= nrr-rowd+1) and
     (ncc  > 0) and (ncc  <= nrr-cold+1) then begin   {reasonable indices}
     pr := prr;
     inc(pr,(rowr-1)*nrr+colr-1);
     pd := pdd;
     inc(pd,(rowd-1)*nrr+cold-1);
     for ii := 1 to mcc do begin
       for jj := 1 to ncc do begin
         pd^:= pr^;
         inc(pr);
         inc(pd);
       end;
       inc(pr,nrr-ncc);
       inc(pd,nrr-ncc);
     end;
     erc := 0;
   end else begin
     erc := 1;             {cannot copy}
   end;
 end;


procedure CopyAndRearrange(prr,pdd : pSingle; nrr, nee, njj : integer;
                           var erc : integer);
{square matrix rr is copied to matrix dd, but in rearranged in the following way:
       A B C             A C B
 rr =  D E F    => dd =  G J H
       G H J             D F E

where rr,dd, A, E, J are square matrices.
That is, the matrix E is moved to the lower right corner, and the
other parts are rearranged correspondingly.
prr  pointer to matrix to be copied
pdd  pointer to matrix where copied
nrr  dim. of rr and dd
nee  index of first row of E, to be moved
njj  index of first row of J, presently in the lower right corner
erc  error code }
var
  ea,eb,ec    : integer;  {error codes}
  ed,ee,ef    : integer;
  eg,eh,ej    : integer;
  ii          : integer;  {indices}
  ma, me, mj  : integer;  {no of rows in A, E, J}
  pr, pd      : pSIngle;  {pointer to one element in rr, dd}
begin
  if (nrr > 0) and (nee > 0) and (njj > 0) and
     (nee <= nrr) then begin   {general check, reasonable indices}
    if (nee > 1  ) and (nee < nrr)  and
       (njj > nee) and (njj <= nrr) then begin {proper rearrange}
      ma := nee-1;     {dim of A}
      me := njj-nee;   {dim of E}
      mj := nrr-njj+1; {dim of J}
      {copy part matrices A, B, C, D, E, F, G, H, J }
      CopyRectPartMat(prr,pdd,nrr, 1       ,1       ,1       , 1       ,ma ,ma,ea); {A}
      CopyRectPartMat(prr,pdd,nrr, 1       ,ma+1    ,1       , ma+mj+1 ,ma ,me,eb); {B}
      CopyRectPartMat(prr,pdd,nrr, 1       ,ma+me+1 ,1       , ma+1    ,ma ,mj,ec); {C}
      CopyRectPartMat(prr,pdd,nrr, ma+1    ,1       ,ma+mj+1 , 1       ,me ,ma,ed); {D}
      CopyRectPartMat(prr,pdd,nrr, ma+1    ,ma+1    ,ma+mj+1 , ma+mj+1 ,me ,me,ee); {E}
      CopyRectPartMat(prr,pdd,nrr, ma+1    ,ma+me+1 ,ma+mj+1 , ma+1    ,me ,mj,ef); {F}
      CopyRectPartMat(prr,pdd,nrr, ma+me+1 ,1       ,ma+1    , 1       ,mj ,ma,eg); {G}
      CopyRectPartMat(prr,pdd,nrr, ma+me+1 ,ma+1    ,ma+1    , ma+mj+1 ,mj ,me,eh); {H}
      CopyRectPartMat(prr,pdd,nrr, ma+me+1 ,ma+me+1 ,ma+1    , ma+1    ,mj ,mj,ej); {J}
      erc := ea+eb+ec+ed+ee+ef+eg+eh+ej;
    end else if (nee = 1  ) and (nee <  nrr) and
                (njj > nee) and (njj <= nrr) then begin {A,B,C,D,G are missing}
      me := njj-1;
      mj := nrr-njj+1;
      CopyRectPartMat(prr,pdd,nrr, 1    ,1    ,mj+1 , mj+1 ,me ,me,ee); {E}
      CopyRectPartMat(prr,pdd,nrr, 1    ,me+1 ,mj+1 , 1    ,me ,mj,ef); {F}
      CopyRectPartMat(prr,pdd,nrr, me+1 ,1    ,1    , mj+1 ,mj ,me,eh); {H}
      CopyRectPartMat(prr,pdd,nrr, me+1 ,me+1 ,1    , 1    ,mj ,mj,ej); {J}
      erc := ee+ef+eh+ej;
    end else if (nee >= 1) and (nee <=nrr) and
                (njj > nrr) then begin {interpreted as J and C,F,G,H missing}
      {copy all, as such}
      pr := prr;
      pd := pdd;
      for ii := 1 to nrr*nrr do begin
        pd^:= pr^;
        inc(pd);
        inc(pr);
      end;
      erc := 0;
    end else begin  {not reasonable, do nothing}
      erc := -2;
    end;
  end else begin    {not reasonable indices, do nothing}
    erc := -1;
  end;
end;

procedure PartialEliminationOld(prr,pdd : pSingle; pIndx : pInteger;
                             nn ,mm  : integer; var erc : integer);
{carry out a partial elimination on a matrix
 prr   pointer to the matrix to be eliminated (in)
 pdd   pointer to the "uneliminated" part copied from partially elimiated matrix
 pindx pointer to vector keeping track on row exchanges
 nn   dim of aa
 mm   dim of dd
 erc  error code
 start with a square matrix. Partition it into:
     A B
     C D    where A and D are square matrices
 and eliminate (by Gaussian elimination) so much that
 A is decomposed into LU-form (C is replaces by part of the L of the whole matrix)
     LU B'
     L' D'
 finally, copy D' to output}
const
  petit = 1.e-6;       {a small number, for checks of singluarity}
var
  apu      : single;   {temporary}
  ii,jj,kk : integer;  {indices}
  ip       : integer;  {pivot row = row with largest entry in column to be eliminated}
  nm       : integer;  {nn-mm}
  pd       : pSingle;  {pointer to one element in pdd}
  pind     : pInteger; {pointer to array keeping track of row interchanges}
  pr       : pSingle;  {pointer to row to be subtracted from the rows below}
  ps       : pSingle;  {pointer to row where row pr is subtracted}
  prj,psj  : pSIngle;  {pointers to elements j on rows r and s}
  rmx      : single;   {largest entry in col. to be eliminated}
begin
  erc := 0;
  if (nn > 0) and (mm >= 0) and (mm < nn) then begin
    nm := nn-mm;
    pr := prr;
    pind := pindx;
    for ii := 1 to nm do begin       {eliminate up tp nm}
      {pivoting: find the largest element in col.im to be eliminated}
      ip := ii;
      if (ii < nm)  then begin       {more than one choice}
        prj := pr;
        inc(prj,ii-1);               {pointer to element [ii,ii]}
        rmx := abs(prj^);            {initialize max}
        for jj := ii+1 to nm do begin {scan rows below}
          inc(prj,nn);               {pointer to element [jj,ii]}
          apu := abs(prj^);
          if (apu > rmx) then begin  {larger element found}
            rmx := apu;
            ip := jj;                {larger element on row ip}
          end;
        end;
        {largest found, exchange rows, if not the row in turn}
        if (ip <> ii) then begin
          prj := pr;                 {first element on row r}
          psj := prr;
          inc(psj,(ip-1)*nn);        {first element on row s, with the largest element}
          for jj := 1 to nn do begin {all elements on these rows}
            apu := prj^;
            prj^:= psj^;
            psj^:= apu;
            inc(prj);
            inc(psj);
          end;
        end;
      end;
      pind^:= ip;
      {rows changed, now the elimination, if possible}
      prj := pr;
      inc(prj,ii-1);                  {diag.element on the row to be subtracted}
      if (abs(prj^) > petit) then begin  {not too small = not singular, BUT accuracy ???}
        ps := prj;
        inc(ps,nn);                   {pointer to element below prj^}
        for kk := ii+1 to nn do begin {all rows below}
          prj := pr;
          inc(prj,ii-1);
          psj := ps;
          apu := psj^/prj^;           {scaling}
          psj^:= apu{0};              {"L"-matrix}
          inc(prj);
          inc(psj);
          for jj := ii+1 to nn do begin
            psj^:= psj^-apu*prj^;     {subtract the scaled row}
            inc(psj);
            inc(prj);
          end;
          inc(ps,nn);
        end;
      end else begin
        erc := 1;                     {singular, do something !}
      end;
      inc(pr,nn);
      inc(pind);
    end;
    {ClearMat(pdd,mm);}                   {harmful, if copied on itself}
    if (erc = 0) and (mm > 0) then begin  {successfull elimination}
      CopyLowRightMat(prr,pdd,nn,mm,erc); {copy result to  output}
    end;
  end else begin
    if (nn > 0) and (mm = nn) then begin  {no elilmination needed}
      pr := prr;                          {copy as such}
      pd := pdd;
      for ii := 1 to nn do begin
        for jj := 1 to nn do begin
          pd^:= pr^;
          inc(pd);
          inc(pr);
        end;
      end;
    end else begin
      erc := -1;                        {not reasonable index}
    end;
  end;
end;

procedure PartialElimination{2}(prr,pdd : pSingle; pIndx : pInteger;
                             nn ,mm  : integer; var erc : integer);
{carry out a complete elimination on a matrix,
 but at desired point, save the "uneliminated" or "undecomposed" part
 prr   pointer to the matrix to be eliminated (in, and out in LU form)
 pdd   pointer to the "uneliminated" part copied from partially elimiated matrix

 pindx pointer to vector keeping track on row exchanges
 nn   dim of A  (see below)
 mm   dim of D
 erc  error code

 That is,
 start with a square matrix. Partition it into:
     A B
     C D    where A and D are square matrices
 First, eliminate (by Gaussian elimination) so much that
 A is decomposed into LU-form (C is replaces by part of the L of the whole matrix)
     LU B'
     L' D'
 At this phase, copy D' to output
 Note, keep D in place, i.e. do not include it in row exchanges, in this phase
 Then, continue, until the whole matrix has been partitioned in LU-form}
const
  petit = 1.e-6;       {a small number, for checks of singluarity}
var
  apu      : single;   {temporary}
  ii,jj,kk : integer;  {indices}
  ip       : integer;  {pivot row = row with largest entry in column to be eliminated}
  nm       : integer;  {nn-mm}
  nsc      : integer;  {scanning limit}
  pind     : pInteger; {pointer to array keeping track of row interchanges}
  pr       : pSingle;  {pointer to row to be subtracted from the rows below}
  ps       : pSingle;  {pointer to row where row pr is subtracted}
  prj,psj  : pSIngle;  {pointers to elements j on rows r and s}
  rmx      : single;   {largest entry in col. to be eliminated}
begin
  erc := 0;
  if (nn > 0) and (mm = nn) then begin   {no elimination needed}
    CopyMat(prr,pdd,nn,nn);              {only copying and LU-decomposition}
  end else if (nn > 0) and (mm >= 0) and (mm <= nn) then begin
    nm := nn-mm;
    pr := prr;
    pind := pindx;
    for ii := 1 to nn{nm} do begin   {eliminate all the way down}
      {pivoting: find the largest element in col.im to be eliminated}
      ip := ii;
      {do not include the D matrix in row exchanges, before eliminating D}
      if (ii < nm) or ((ii > nm) and (ii < nn)) then begin  {more than one choice}
        prj := pr;
        inc(prj,ii-1);               {pointer to element [ii,ii]}
        rmx := abs(prj^);            {initialize max}
        if (ii < nm) then nsc := nm  {D not included in row exchanges}
        else              nsc := nn; {decomposing D}
        for jj := ii+1 to nsc{nm} do begin {scan rows below}
          inc(prj,nn);               {pointer to element [jj,ii]}
          apu := abs(prj^);
          if (apu > rmx) then begin  {larger element found}
            rmx := apu;
            ip := jj;                {larger element on row ip}
          end;
        end;
        {largest found, exchange rows, if not the row in turn}
        if (ip <> ii) then begin
          prj := pr;                 {first element on row r}
          psj := prr;
          inc(psj,(ip-1)*nn);        {first element on row s, with the largest element}
          for jj := 1 to nn do begin {all elements on these rows}
            apu := prj^;
            prj^:= psj^;
            psj^:= apu;
            inc(prj);
            inc(psj);
          end;
        end;
      end;
      pind^:= ip;
      {rows changed, now the elimination, if possible}
      prj := pr;
      inc(prj,ii-1);                  {diag.element on the row to be subtracted}
      if (abs(prj^) > petit) then begin  {not too small = not singular, BUT accuracy ???}
        ps := prj;
        inc(ps,nn);                   {pointer to element below prj^}
        for kk := ii+1 to nn do begin {all rows below}
          prj := pr;
          inc(prj,ii-1);
          psj := ps;
          apu := psj^/prj^;           {scaling}
          psj^:= apu{0};              {"L"-matrix}
          inc(prj);
          inc(psj);
          for jj := ii+1 to nn do begin
            psj^:= psj^-apu*prj^;     {subtract the scaled row}
            inc(psj);
            inc(prj);
          end;
          inc(ps,nn);
        end;
      end else begin
        erc := 1;                     {singular, do something !}
      end;
      inc(pr,nn);
      inc(pind);
      if (ii = nm) then begin         {copy D before decomposing it}
        if (erc = 0) and (mm > 0) then begin  {successfull elimination}
          CopyLowRightMat(prr,pdd,nn,mm,erc); {copy result to  output}
        end;
      end;
    end;
  end else begin                      {erroneous indices}
    erc := -1;                        {not reasonable index}
  end;
end;
{nm}

procedure Dsqumul(paa,pbb,pcc: pDouble; nn,nj: integer);
  {this procedure multiplies a matrix or vector by a square matrix
      cc = aa*bb, where aa(nn,nn) is the square matrix
                        bb(nn,nj) is a more general matrix or vector
                        cc(nn,nj) is the result matrix (or vector
   NOTE: no checks of the dimensions are done, be sure that
         the dimensions (especially ) of cc are correct !!!
   paa,pbb,pcc  pointers to square matrices aa,bb,cc (in)
                but actually aa, bb are inputs, result to cc
   nn           dimension of the matrices (in)
   NOTE: pDouble is a pointer to a real variable of type "double"
         it is defined in unit matdef.pas}
  var
    pai,pbj,paij,pbij,pcij: pDouble; {local pointers to rows, columns, elements}
    i,j,k: Integer; {indices}
    apu:   Double;  {temporary}
  begin
    {initialize local pointers to first element in the matrices}
    pai := paa;
    pbj := pbb;
    pcij := pcc;
    {loop over rows}
    for i:=1 to nn do begin
      {loop over columns}
      for j:=1 to nj do begin
        apu := 0;
        pbij := pbj;  {pointer to first element in column j of bb}
        paij := pai;  {pointer first element in row i of aa}
        for k := 1 to nn do begin
          apu := apu+paij^*pbij^; {apu := apu+aa(i,k)*bb(k,j)}
          inc(paij);              {next element in aa = next in row i}
          inc(pbij,nj);           {next element in bb = next in column j}
        end;
        pcij^:= apu; {cc[i,j] := apu}
        inc(pcij);   {next element in cc}
        inc(pbj);    {next column in bb}
      end;
      pbj := pbb;    {again first column in bb}
      inc(pai,nn);   {next row in aa}
    end;
  end;

procedure Dmatmul(paa,pbb,pcc: pDouble; ni,nn,nj: integer);
  {this procedure multiplies a matrix or vector by a another matrix
      cc = aa*bb, where aa(ni,nn) is the square matrix
                        bb(nn,nj) is a more general matrix or vector
                        cc(ni,nj) is the result matrix (or vector
   NOTE: no checks of the dimensions are done, be sure that
         the dimensions (especially ) of cc are correct !!!
   paa,pbb,pcc  pointers to matrices aa,bb,cc (in)
                but actually aa, bb are inputs, result to cc
   nn,ni,nj     dimension of the matrices (in)
   NOTE: pDouble is a pointer to a real variable of type "double"
         it is defined in unit matdef.pas}
  var
    pai,pbj,paij,pbij,pcij: pDouble; {local pointers to rows, columns, elements}
    i,j,k: Integer; {indices}
    apu:   Double;  {temporary}
  begin
    {initialize local pointers to first element in the matrices}
    pai := paa;
    pbj := pbb;
    pcij := pcc;
    {loop over rows}
    for i:=1 to ni do begin
      {loop over columns}
      for j:=1 to nj do begin
        apu := 0;
        pbij := pbj;  {pointer to first element in column j of bb}
        paij := pai;  {pointer first element in row i of aa}
        for k := 1 to nn do begin
          apu := apu+paij^*pbij^; {apu := apu+aa(i,k)*bb(k,j)}
          inc(paij);              {next element in aa = next in row i}
          inc(pbij,nj);           {next element in bb = next in column j}
        end;
        pcij^:= apu; {cc[i,j] := apu}
        inc(pcij);   {next element in cc}
        inc(pbj);    {next column in bb}
      end;
      pbj := pbb;    {again first column in bb}
      inc(pai,nn);   {next row in aa}
    end;
  end;

procedure Smatmul(paa,pbb,pcc: pSingle; ni,nn,nj: integer);
  {this procedure multiplies a matrix or vector by a another matrix of single's
      cc = aa*bb, where aa(ni,nn) is a general matrix
                        bb(nn,nj) is a matrix or vector
                        cc(ni,nj) is the result matrix (or vector
   NOTE: no checks of the dimensions are done, be sure that
         the dimensions (especially ) of cc are correct !!!
   paa,pbb,pcc  pointers to matrices aa,bb,cc (in)
                but actually aa, bb are inputs, result to cc
   nn,ni,nj     dimension of the matrices (in)
   NOTE: pDouble is a pointer to a real variable of type "double"
         it is defined in unit matdef.pas}
  var
    pai,pbj,paij,pbij,pcij: pSingle; {local pointers to rows, columns, elements}
    i,j,k: Integer; {indices}
    apu:   Single;  {temporary}
  begin
    {initialize local pointers to first element in the matrices}
    pai := paa;
    pbj := pbb;
    pcij := pcc;
    {loop over rows}
    for i:=1 to ni do begin
      {loop over columns}
      for j:=1 to nj do begin
        apu := 0;
        pbij := pbj;  {pointer to first element in column j of bb}
        paij := pai;  {pointer first element in row i of aa}
        for k := 1 to nn do begin
          apu := apu+paij^*pbij^; {apu := apu+aa(i,k)*bb(k,j)}
          inc(paij);              {next element in aa = next in row i}
          inc(pbij,nj);           {next element in bb = next in column j}
        end;
        pcij^:= apu; {cc[i,j] := apu}
        inc(pcij);   {next element in cc}
        inc(pbj);    {next column in bb}
      end;
      pbj := pbb;    {again first column in bb}
      inc(pai,nn);   {next row in aa}
    end;
  end;

procedure DLUdecomp(paa  : pDouble;   {pointer to the matrix to be be decomposed
                                     original in, decomposed out}
                    pvv  : pDouble;   {pointer to working space,
                                      for implicit scaling of each row}
                    Nn   : Integer;   {dimension of the matrix, in}
                    pindx: pInteger;  {pointer to an array recording the
                                      row permutations}
                var Dodd : Single; { -1, if odd number of permutaions, else 1}
                var Sngl : Integer; {flag for singular matrix}
                var Tout : Double); {test-output}
{LUdecomp  decomposes (in place) a matrix into LU-form}
const
  tiny=1.0e-20;
var
  apu      : Double;   {temporary}
  big      : Double;   {max. element, temporary}
  i,j,k    : Integer;  {indices}
  imax     : Integer;  {max index}
  pi,pj,pij: pDouble;  {pointers to row i, column j, element i,j of matrix a}
  pjj      : pDouble;  {pointer to diagonal}
  pik,pkj  : pDouble;  {pointers to element ik, kj  in matrix a}
  pjk      : pDouble;  {pointer to element jk in matrix a}
  pindxj   : pInteger; {pointer to element j in indx}
  pimaxk   : pDouble;  {pointer to element  imax,k in matrix a}
  prj      : pDouble;  {pointer to row j}
  pvi      : pDouble;  {pointer to element i in vv}
  pvimax   : pDouble;  {pointer to element imax in vv}
  sum, dum : Double;   {temporary}

begin
  Dodd := 1;
  Sngl := 0;
  {initialize vector vv, just for clarity}
  pvi := pvv;
  for i:=1 to Nn do begin
    (*vv[i-1] := 0.0;*) pvi^:= 0.0;
    inc(pvi);
  end;
  {check for zero rows}
  pij := paa;  {initialize pointer to first element in matrix a}
  pvi := pvv;
  for i:=1 to Nn do begin
    big := 0.0;
    for j:=1 to Nn do begin
      apu := abs(pij^);
      if (apu > big) then big := apu;
      inc(pij);  {pointer to next element in matrix a}
    end; {end of loop over j,  = over elements in a row}
    {preliminary check of obvious singularity}
    if (big <= tiny{0.0}) then begin
      Sngl := Sngl+1;
    end else begin
      (*vv[i-1] := 1.0/big;*) pvi^:= 1.0/big;
    end;
    inc(pvi);
  end;   {end of loop over i,  = over rows}
  {proceed only in not obviously singlular matrix}
  if (Sngl = 0) then begin
    {start the decomposition}
    pj := paa;       {initialize column pointer to first column}
    pjj := paa;      {initialize pointer to diagonal element}
    prj := paa;      {initialize pointer to row j}
    pindxj := pindx; {initialize pointer to vector indx}
    for j:=1 to Nn do begin
      if (j > 1) then begin
        pi := paa;
        pij := pj;
        for i:=1 to j-1 do begin
          sum := pij^;
          pik := pi;
          pkj := pj;
          if (i > 1) then begin
            for k:=1 to i-1 do begin
              sum := sum-pik^*pkj^;  { a(i,k)*a(k,j) }
              inc(pik);
              inc(pkj,Nn);
            end;
            pij^:= sum;
          end;
          inc(pij,Nn);
          inc(pi,Nn); {next row}
        end;
      end;
      big := 0.0;
      pij := pjj; {alkaa (j,j)st}
      pi  := prj; {paa; inc(pi,(j-1)*Nn);} {alkaa (j,1):st}
      pvi := pvv; inc(pvi,(j-1));
      imax := j;  {initialize 11.1.2002 tai oikeastaan 1.10.2002}      
      for i:=j to Nn do begin
        sum := pij^;
        if (j > 1) then begin
          pik :=  pi;  {alkaa (j,1).st}
          pkj :=  pj;  {alkaa (1,j):st}
          for k:= 1 to j-1 do begin
            sum := sum-pik^*pkj^;
            inc(pik);
            inc(pkj,Nn);
          end;
          pij^:= sum;
        end;
        dum := pvi^*abs(sum);
        if (dum > big) then begin
          big := dum;
          imax := i;
        end;
        inc(pvi);
        inc(pi,Nn);
        inc(pij,Nn);
      end;
      if (j <> imax) then begin
        pjk := paa;    inc(pjk,(j-1)*Nn);      {alkaa (j,1):st}
        pimaxk := paa; inc(pimaxk,(imax-1)*Nn); {alkaa (imax,1)st}
        for k:=1 to Nn do begin
          dum := pimaxk^;     {dum := a[imax,k] }
          pimaxk^ := pjk^;    {a[imax,k] := a[j,k] }
          pjk^ := dum;        {a[j,k] := dum  }
          inc(pimaxk);
          inc(pjk);
        end;
        Dodd := -Dodd;
        pvi := pvv; inc(pvi,j-1);
        pvimax := pvv; inc(pvimax,imax-1);
        (*vv[imax-1] := vv[j-1];*)pvimax^:= pvi^;
      end;
      pindxj^:= imax;  (*indx[j-1] := imax;*)
      if (j <> Nn) then begin
        if (abs(pjj^)< tiny) then pjj^:= tiny;
                                         {if a[j,j] = 0.0 then a[j,j] := tiny;}
        dum := 1.0/pjj^;                 {dum := 1.0/a[j,j];}
        pij := pjj; inc(pij,Nn);         {alkaa (j+1,j):st }
        for i:=j+1 to Nn do begin
          pij^ := pij^*dum; {a[i,j] := a[i,j]*dum;}
          inc(pij,Nn);
        end;
      end;
      inc(pindxj);   {pointer to next element in indx}
      inc(pjj,Nn+1); {pointer to next diagonal element (jj)}
      inc(pj);       {pointer to next column}
      inc(prj,Nn);    {pointer to next row j}
    end;
    pjj := paa;
    inc(pjj,Nn*Nn-1);
    if (abs(pjj^)<tiny) then pjj^ := tiny;  {if a[n,n] = 0 then a[n,n] := tiny}
  end;
end;

procedure DLUbacksub(paa  : pDouble;   {pointer to the matrix aa in LU-form}
                     Nn   : Integer;   {dimension of the matrixes}
                     pindx: pInteger;  {pointer to the array storing
                                       the row exchanges}
                     pbb  : pDouble);  {pointer to the right hand side
                                             AND solution}
{LUbacksub solves the equation  AX = b, when A is given in the LU-form
 paa    is the pointer to the first element in A  (in)
 pbb    is the pointer to the right hand side b (in),
        and returns the solution X (out)
 pindx  is the pointer to the array storing the row exhanges,
        calculated in LUdecomp (in)}
 var
  apu      : Double;   {temporary}
  j,ip,ii,i: Integer;  {indices}
  sum      : Double;   {temporary sum}
  pbi      : pDouble;  {pointer to bb[i]}
  pbid     : pDouble;  {pointer to bb[...]}
  pbj      : pDouble;  {pointer to bb[j]}
  pdi      : pInteger; {pointer to indx[i]}
  pij      : pDouble;  {pointer to element (ij) in array aa}
  pri      : pDouble;  {pointer to row i in array aa}
  pii      : pDouble;  {pointer to element ii in aa}
 begin
   ii := 0;
   pri := paa;
   pdi := pindx; {pointer to indx, starts from 1}
   pbi := pbb;   {pointer to bb[i], starts from 1}
   for i:=1 to Nn do begin
     ip := pdi^;                    {ip := indx[i];}
     pbid := pbb; if (ip > 0) then inc(pbid,ip-1);   {pointer to bb[indx[i]]}
     sum := pbid^;                  {sum := bb[ip1];}
     pbid^:= pbi^;                  {bb[ip] := bb[i];}
     if (ii <> 0) then begin
       pij := pri; inc(pij,ii-1);   {starts from i,ii}
       pbj := pbb; inc(pbj,ii-1);   {starts from ii}
       for j := ii to i-1 do begin
         sum := sum -pij^*pbj^;     {sum-bb[j]}
         inc(pij);
         inc(pbj);
       end;
     end else if (sum <> 0.0) then begin
       ii := i;
     end;
     pbi^ := sum;                   {bb[i] := sum}
     inc(pri,Nn);
     inc(pbi);
     inc(pdi);
   end;
   pii := paa; inc(pii,Nn*Nn-1); {pointer to last element in aa}
   pri := pii; dec(pri,Nn-1);    {pointer to last row in aa}
   pbi := pbb; inc(pbi,Nn-1);    {pointer to b[i], starts from Nn}
   for i:=Nn downto 1 do begin
     sum := pbi^;                {sum := bb[i];}
     if (i < Nn) then begin
       pij := pri; inc(pij,i);   {starts from i,i+1}
       pbj := pbb; inc(pbj,i);   {starts from i+1}
       for j:=i+1 to Nn do begin
         sum := sum-pij^*pbj^;   {sum := sum-pij^*bb[j];}
         inc(pij);
         inc(pbj);
       end;
     end;
     apu :=abs(pii^);
     if (apu > 0.9e-20) then begin {avoid division by "zero"}
       pbi^:= sum/pii^;            {bb[i] := sum/pii^;}
     end else begin
       pbi^ := sum*1.e20;
     end;
     dec(pbi);
     dec(pri,Nn);
     dec(pii,Nn+1);
   end;
 end;

 procedure putDmat(paa: pDouble;  {pointer to the first element of the matrix}
                   i,j: Integer;  {indices of the element}
                   m,n: Integer;  {the dimensions of the matrix}
                   xx : Double);  {the value to be put into the matrix}
 {putmat copies the value of xx to the location i,j of tha matrix
         with dimensions (m rows * n columns)}
 var
   pij: pDouble;  {pointer to the element i,j}
 begin
   {some checks, just to be sure}
   if (i>0) and (i<=m) and (j>0) and (j<=n) then begin
     pij := paa;
     inc(pij,n*(i-1)+j-1);
     pij^:= xx;
   end;
 end;

 procedure putDvec(paa: pDouble; i,m:Integer;xx:Double);
 var
   pi: pDouble;
 begin
   if ((i>0) and (i<=m)) then begin
     pi := paa;
     inc(pi,i-1);
     pi^:= xx;
   end
 end;

 procedure getDvec(paa: pDouble; i,m:Integer;var xx:Double);
 var
   pi: pDouble;
 begin
   if ((i>0) and (i<=m)) then begin
     pi := paa;
     inc(pi,i-1);
     xx := pi^;
   end
 end;

procedure clearDvec(pbb: pDouble; nn : integer);
var
   ii : integer;
   pi : pDouble;
begin
  if (nn > 0) and (pbb <> nil) then begin
    pi := pbb;
    for ii:=1 to nn do begin
      pi^:= 0;
      inc(pi);
    end;
  end;
end;


procedure getDmat(paa: pDouble;  {pointer to the first element of the matrix}
                  i,j: Integer;  {indices of the element}
                  m,n: Integer;  {the dimensions of the matrix}
              var xx : Double);  {the value to get the value of aa(i,j)}
 {getmat copies the value of xx to the location i,j of tha matrix
         with dimensions (m rows * n columns)}
 var
   pij: pDouble;  {pointer to the element i,j}
 begin
   {some checks, just to be sure}
   if (i>0) and (i<=m) and (j>0) and (j<=n) then begin
     pij := paa;
     inc(pij,n*(i-1)+j-1);
     xx := pij^;
   end;
 end;

procedure clearDmat(paa : pDouble; nn:integer);
{clear a nn*nn matrix}
var
  pij : pDouble;
  ii  : integer;
  n2  : integer;
begin
  if (nn > 0) and (paa <> nil) then begin
    n2 := nn*nn;
    pij := paa;
    for ii:=1 to n2 do begin
      pij^:= 0;
      inc(pij);
    end;
  end;
end;


end.
