unit mutupar;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, ExtCtrls, StdCtrls, skemadef, utildef, routines;

type
  TLineDataForm = class(TForm)
    Line1Grid: TStringGrid;
    Line2Grid: TStringGrid;
    Line3Grid: TStringGrid;
    Line4Grid: TStringGrid;
    Line5Grid: TStringGrid;
    Line6Grid: TStringGrid;
    Line7Grid: TStringGrid;
    Line8Grid: TStringGrid;
    DataPanel: TPanel;
    Label7: TLabel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label8: TLabel;
    NumberLabel: TLabel;
    LinesLabel: TLabel;
    NumberEdit: TEdit;
    MutualBut: TButton;
    CancelBut: TButton;
    OKBut: TButton;
    MiddleEdit: TEdit;
    Label6: TLabel;
    Label9: TLabel;
    HelpBut: TButton;
    procedure FormCreate(Sender: TObject);
    procedure NumberEditKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure MutualButClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormHide(Sender: TObject);
    procedure FormDeactivate(Sender: TObject);
    procedure CancelButClick(Sender: TObject);
    procedure OKButClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormActivate(Sender: TObject);
    procedure HelpButClick(Sender: TObject);
  private
    { Private declarations }
    cancel : boolean;          {cancel-button clicked}
    nline  : integer;          {number of lines}
    pComp  : TpComp;           {pointer to the component}
    pSet   : TpCompSet;        {pointer to the common}
    pGrid  : array[1..gMutuLine] of TpGrid;  {pointers to param.grids}
  public
    { Public declarations }
    procedure ParametersToGrid(ipComp: longint);
    procedure SetFormSize{(nline: integer)};
  end;

var
  LineDataForm: TLineDataForm;

implementation

uses Mutual, imagopas;

{$R *.DFM}
const
  pHelp       : TpMemo = nil;      {pointer to the help-memo}

procedure TLineDataForm.FormCreate(Sender: TObject);
{initialize the grids}
var
  ii : integer;
begin
  cancel := false;
  {initialize (useful?)}
  for ii := 1 to high(pGrid) do begin
    pGrid[ii] := nil;
  end;
  cancel := false;
  {pointers to gris into array}
  pGrid[ 1] := @Line1Grid;
  pGrid[ 2] := @Line2Grid;
  pGrid[ 3] := @Line3Grid;
  pGrid[ 4] := @Line4Grid;
  pGrid[ 5] := @Line5Grid;
  pGrid[ 6] := @Line6Grid;
  pGrid[ 7] := @Line7Grid;
  pGrid[ 8] := @Line8Grid;
  {captions}
  Line1Grid.cells[0,0] := ' line 1 ';
  Line2Grid.cells[0,0] := ' line 2 ';
  Line3Grid.cells[0,0] := ' line 3 ';
  Line4Grid.cells[0,0] := ' line 4 ';
  Line5Grid.cells[0,0] := ' line 5 ';
  Line6Grid.cells[0,0] := ' line 6 ';
  Line7Grid.cells[0,0] := ' line 7 ';
  Line8Grid.cells[0,0] := ' line 8 ';
  {add flag that form created}
  Imagoo.ReadyEdit.text := Imagoo.ReadyEdit.text+'m';  
end;

procedure TLineDataForm.ParametersToGrid(ipComp: longint);
{read parameters from component, put to grid(s)
 ipComp  pointer to the component as integer}
const
  nmin = 2;            {min.number of lines}
  nmax = gMutualMax;   {max.number of lines}
var
  ii,jj   : integer; {indices}
  ip      : integer; {index of the parameter}
  ipu     : integer; {temporary}
  kk      : integer; {index}
  ll      : longint; {temporary}
  mm      : integer; {index}
  ngrids  : integer; {number of visible grids}
  par     : single;  {parameter}
  txt,txx : string;  {temporary}
begin
  pComp := TpComp(ipComp);
  pComp^.Getipset(ll);
  pSet := TpCompSet(ll);
  pComp^.GetPar(1,par);    {first parameter = number of tr.lines}
  ipu := round(par);
  {number of lines must be between nmin and nmax}
  if (ipu < nmin) then nline := nmin
  else if (ipu <= nmax) then nline := ipu
  else nline := nmax;
  MutualDataForm.SetNline(nline);        {copy no of lines to other data form}
  NumberEdit.text := inttostr(nline);    {display number of lines}
  {relative position of middle node}
  pComp^.GetPar(gMutuStrt-1,par);
  txt := ManyChars(par,true);
  txx := spaceless(txt);
  MiddleEdit.text := txx;
  {the "proper" parameters: length, resistance, reactance etc for each line}
  kk := 0;                               {index for the line pair = for the grid}
  ip := gMutuStrt;                       {first line parameter at this index}
  for ii := 1 to gMutuLine do begin      {all lines}
    inc(kk);                             {index of grid}
    for mm := 1 to gMutuNpar{7} do begin {seven parameters}
      pComp^.GetPar(ip,par);             {parameter from the component}
      txt := ManyChars(par,true);        {parameter to string, in routines.pas}
      txx := spaceless(txt);             {remove spaces}
      pGrid[kk]^.cells[0,mm] := txx;     {parameter to grid}
      inc(ip);                           {index of next parameter}
    end;
  end;
  {show data grids only for the given number of connected lines}
  SetFormSize{(nline)};
end;

procedure TLineDataForm.SetFormSize{(nline: integer)};
{show data grids only for the given number of connected lines
 and set the form size accordingly
 nline  number of mutually connected lines}
var
  ii     : integer; {index}
begin
  for ii := 1 to high(pGrid) do pGrid[ii]^.visible := false;  {hide initially}
  for ii := 1 to nline do pGrid[ii]^.visible := true;
  {set form width accordingly}
  width := pGrid[nline]^.left+pGrid[nline]^.width+16;
end;


procedure TLineDataForm.NumberEditKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
{show the data grids (etc) only for the given number of connected lines}
{size changed also in FormHide}
var
  errc  : integer;   {error code (defined in chckfloat), = 0, if no errors}
  ipu   : integer;   {temporary}
  kstrt : integer;   {start studying of the parameters at character number kstrt of line}
  kend  : integer;   {last studied character}
  line  : string;    {the text line with the numbers (in)}
  par   : single;    {the numeric value (out)}
  str   : string;    {the parameter as text (out), as it is on the line}
begin
  line := NumberEdit.text;                              {number of lines as string}
  kstrt := 1;
  NextValueFromLine(line, kstrt, kend, par, str, errc); {convert to number}
  if (errc = 0) then begin                              {continue only if no errors}
    ipu := round(par);        {to integer}
    if (ipu < 2) then begin
      NumberEdit.color := clYellow;
    end else if (ipu <= gMutualMax) then begin            {= gMutuLine, in Utildef.pas}
      nline := ipu;
      SetFormSize{(nline)};
      MutualDataForm.SetNline(nline);           {copy no of lines to other data form}
      MutualDataForm.SetFormSize;
      {horizontal or vertical component?}
      if (pComp^.width = 32) then
        pComp^.height := (nline-1)*32+8         {set the size of the component}
      else
        pComp^.width := (nline-1)*32+8;
      NumberEdit.color := clWhite;
    end else begin
      NumberEdit.color := clYellow;
    end;
  end else begin
    NumberEdit.color := clYellow;
  end;
end;

procedure TLineDataForm.MutualButClick(Sender: TObject);
begin
  MutualDataForm.visible := true;
end;

procedure TLineDataForm.FormShow(Sender: TObject);
begin
  ActiveControl := nil;        {focus to main form, for the case of delete-key pressed}
  NumberEdit.color := clWhite; {may be yellow, if there was an error}
end;

procedure TLineDataForm.FormHide(Sender: TObject);
{copy parameters to component, unless (for some reason)}
var
  errc  : integer;   {error code (defined in chckfloat), = 0, if no errors}
  ii    : integer;   {index}
  ip    : integer;   {index of parameter}
  kend  : integer;   {last studied character}
  kstrt : integer;   {start studying of the parameters at character number kstrt of line}
  kk    : integer;   {index}
  line  : string;    {text with data to be converted}
  mm    : integer;   {index}
  par   : single;    {the numeric value (out)}
  RePro : TCompProc; {procedure for operations after readings}
  str   : string;    {the parameter as text (out), as it is on the line}
begin
  if (not appl_close) and (not cancel) then begin
    {number of lines first}
    line := NumberEdit.text;                              {number of lines as string}
    kstrt := 1;
    NextValueFromLine(line, kstrt, kend, par, str, errc); {convert to number, in Routines.pas}
    if (errc = 0) then pComp^.putPar(1,par);              {save to component}
    {relative position of the middle node}
    line := MiddleEdit.text;
    kstrt := 1;
    NextValueFromLine(line, kstrt, kend, par, str, errc); {convert to number, in Routines.pas}
    if (errc = 0) then pComp^.putPar(gMutuStrt-1,par);    {save to component}
    {the "proper" parameters: length, resistance, reactance etc for each line}
    kk := 0;                               {index for the line pair = for the grid}
    ip := gMutuStrt;                       {first line parameter at this index}
    for ii := 1 to gMutuLine do begin      {all lines}
      inc(kk);                             {index of grid}
      for mm := 1 to gMutuNpar{7} do begin {seven parameters}
        line := pGrid[kk]^.cells[0,mm];
        kstrt := 1;
        NextValueFromLine(line, kstrt, kend, par, str, errc); {convert to number, in Routines.pas}
        if (errc = 0) then pComp^.PutPar(ip,par);             {save, if no errors (some Warning??)}
        inc(ip);                           {index of next parameter}
      end;
    end;
    unmark(longint(pSet));
    {some operation when parameters read}
    pComp^.GetRePro(RePro);              {get the procedure}
    RePro(longint(pComp));               {the operation after reading = set height :=}
  end;
  cancel := false;
end;






procedure TLineDataForm.FormDeactivate(Sender: TObject);
{hide the form, unless help visible or copying
 Parameters saved to component in FormHide}
var
  bpu : boolean;  {temporary}
begin
  if (not MutualDataForm.visible) then begin     {line data can be displayed at the same time}
    {hide the form, but not when Hint-button clicked}
   if (pHelp <> nil) then bpu := (not pHelp^.visible)
    else bpu := true;
    if (bpu and (not pSet^.Copy_Click)) then   {not hide, when copying}
      LineDataForm.visible := false;
  end;

end;

procedure TLineDataForm.CancelButClick(Sender: TObject);
begin
  cancel := true;
  LineDataForm.visible := false;
  unmark(longint(pSet));       {must do also here, else does not unmark?}
end;

procedure TLineDataForm.OKButClick(Sender: TObject);
begin
  LineDataForm.visible := false;
  unmark(longint(pSet));       {must do also here, else does not unmark?}
end;

procedure TLineDataForm.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
{a possible "delete component" must be handled here, because form (?) has focus}
  {see more in FormShow of LineParam.pas}
  if (pComp <> nil) then begin
    if (pSet^.pActComp <> nil) then begin     {some component active}
      if (key = 46) then begin                {delete-key}
        pSet^.FormKeyDown(Key, Shift);        {delete the component}
      end;
    end;
  end;
end;

procedure TLineDataForm.FormActivate(Sender: TObject);
begin
  ActiveControl := nil;    {delete-key must delete the component initially}
end;

procedure TLineDataForm.HelpButClick(Sender: TObject);
{display the help-memo (hint-memo)}
var
  pMod  : TpElComp;   {pointer to the model component}
begin
  if (pComp <> nil) then begin
    pComp^.GetpMod(pMod);
    pMod^.GetpHelp(pHelp);
    if (pHelp <> nil) then begin
      pHelp.top := 200;
      pHelp.left := 100;
      pHelp.width := 380;
      pHelp.height := 430;
      pHelp.visible := true;
    end;
  end;
end;

end.
