{tarkista procedure TWireSet.ConnectedToWires for stretch / not 31.10.03}
{crossed wires are not connected pitisi nytt vain kerran}
{determine nodes kutsutaan uudelleen, jos jotain relett klikataan ???? EI en
 (kutsu Skemproc'ssa}{TrLinesOfComp,  onko tarkistettava ylraja ?}
{the local NumberOfWires not used ? }
{hint = componentin tyyppi, siis hint olisi otettava suoraan alkuperisest
        mritelmst !}
{vaihesiirron laskuun listtv tarkastus, ettei ristiriitaisia vaiheita}
{determine nodes kutsutaan uudelleen, jos jotain relett klikataan ????  Ei en
 (kutsu Skemproc'ssa}
{kyttk NodeSet'in initialisointi oikeaa wire-list'i, pitisik olla kaikki langat ?}
unit Nodes;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, ExtCtrls, StdCtrls, Routines,Utildef,Buttons,Skemadef,
  Imagodef;

{define enum: really determine nodes, or check connections of current trafos}
type
  NodePurpose  = (determining, checking);

procedure DetermineNodes(ipSet : longint;
                         pWireList, pExtWireList,pRelayTypes,pWireTypes : TpListBox;
                         GroundName : String; purpose : NodePurpose);

{define function type for checking component type}
type
  TBoolCompFunc = function(pComp: TpComp): boolean;
{function for checking, is the component a transformator, transmission line, source}
function IsTrafo(pComp : TpComp): boolean; far;
function IsTLineOrTrafo(pComp : TpComp): boolean; far;
function IsSource(pComp : TpComp): boolean; far;
function IsSourceOrTrafo(pComp : TpComp): boolean; far;
function IsGenerator(pComp : TpComp): boolean; far;

implementation
uses
  Imagopas;

{define enum-type for counting or filling arrays}
type
  NodeOper = (count, fill);

{define a variable type for two singles}
type
  Tpduo = ^Tduo;
  Tduo = record
    x : single;
    y : single;
end;

{define type for number of comp, and pointer, etc}
type
  TpNrPtr = ^TNrPtr;
  TNrPtr = record
    new      : boolean; {new node, when determining voltage levels}
    No       : integer;
    ppC      : TppComp; {pointer to arrays with component pointers}
    ready    : boolean; {search is ready for this node, for voltage levels}
    RelPhase : single;  {relative phase shift of this node}
    Sourcenr : integer; {number referencing to source voltage}
    SourceLev: Tduo;    {source voltage level of this node}
    voltnr   : integer; {number referencing to voltage}
    VoltLev  : Tduo;    {voltage level of this node}
end;

type
{define an object using when deducing the nominal voltage level of each
 component, i.e. the voltage of the transformator the component is connected
 to, either directly or indirectly. The component mainly contains arrays}
  TpVoltComp = ^TVoltComp;       {pointer to the set}
  TVoltComp  = class(TObject)
  constructor Create(ipNodeSet : longint); {override;}
  destructor  destroy; override;
  procedure ClearNumberAndPointer; {crear array for numbers and pointers}
  {procedure for counting of nodes or filling of arrays of comp. in nodes}
  procedure NodesAndComp(oper: NodeOper);
  procedure ConnectionsOfNodes(IsSpecial: TBoolCompFunc);
           {finds connections for voltage levels etc.}
  procedure VoltagesOfComponents; {copy the voltage levels from nodes to comp}
  procedure TrLinesOfComponents;  {copy the tr.line node to comp.}
  procedure GetMemoryForPointerArrays; {..to components connected to nodes}
  procedure FreeMemoryForPointerArrays;
  procedure CheckArrays;
  {next finds nodes connected to given node through one component}
  procedure FindConnections(Ncomp : integer; ppComp : TppComp;
                            var new : boolean; IsSpecial: TBoolCompFunc);
  procedure Trafo(pComp: TpComp); {handle trafo}
  procedure Source(pComp: TpComp); {handle generator or feeder}
  procedure TLine(pComp: TpComp); {handle transmission line}
  procedure MarkOtherTrafoNodes(pComp: TpComp);
  procedure DetermineRelativePhase;
  procedure SetTrafoPhases(pTrafo : TpComp; pNR1,pNR2 : TpNrPtr);
  function  IsReady(node: integer): boolean;
  function  IsNew(node: integer): boolean;
  procedure SetNew(node: integer);
  procedure SetPhase(node: integer; RelPhase : single);
  procedure SetRelativePhaseOfComponents;
  procedure BusVoltages;
  private
    LineFound_v : boolean;   {flag that the first tr.line found, for this node}
    nNode_v     : integer;   {number of nodes}
    nodeID_v    : integer;   {the ID (number) of a node}
    nTrafos_v   : integer;   {no of transformators}
    pSet_v      : TpCompSet; {pointer to the set of comp. etc.}
    pWiLi_v     : TpListBox; {pointer to list of wire types}
    pNrPtr_v    : TpNrPtr;   {pointer to array for no of comp, comp.ptrs etc}
    pSourceLev_v: TpDuo;     {pointer to source voltage levels}
    pVoltLev_v  : TpDuo;     {pointer to voltage levels}
    pLineNod_v  : pInteger;  {pointer to node of tr.line to which is connected}
    pNodeVolt_v : TpDuo;     {voltages of nodes}
    ppTrafos_v  : TppComp;   {pointer to pointers to all transformators}
    sourcenr_v  : integer;   {counter for ID of nodes connected to same source}
    unreal_v    : single;    {unreasonable phase shift, as a flag}
    voltnr_v    : integer;   {counter for ID of nodes connected to same trafo}
  end;

type
{define an object for the set of (electrical) nodes in the net, for
 which the voltages are calculated}
  TpNodeSet = ^TNodeSet;                {pointer to the set of nodes}
  TNodeSet  = class(TObject)            {the set of nodes}
  procedure Initialize(ipSet: longint; pWiLi : TpListBox); {initializes the variables}
  procedure ExtendListOfWires(pWiLi, pExtWiLi, pWiTy : TpListBox);
  procedure NodesMaxAndComp(var nComp : integer);  {get the max. no of nodes, no of comp}
(*procedure NumberOfWires(ID :String);
            {determines the number of components of given type (.hint = ID)}*)
  procedure CompoNode(ipWires: longint; Grnd  : string; pWiLi : TpListBox;
                      ppComp: TppComp; nComp: integer);
(*procedure CurrTrafoNodes(pWiTy : TpListBox); {find current node of current trafos}*)
(*procedure ParalRelayNodes(pReTy : TpListBox); {nodes of relays in "parallel" list}*)
(*procedure ParalCurrTNodes(pCurTy : TpListBox); {nodes of current trafos in "parallel" list}*)
  procedure IncCompCount(nodenr : integer); {increment component count connected}
  procedure ShowNoOfConnComp;
  procedure CountConnectedComp(pComp : TpComp; var nConComp, nodeflg : integer);
  procedure FillListOfConnectedComp(pCurrT : TpComp; pWiTyp : TpListBox;
                                    ppComp: TppComp; nComp: integer);
  procedure CheckListOfConnectedComp(pCurrT: TpComp);
  procedure GetNodMem;                  {get memory for the node array}
  procedure FreeNodMem;                 {free the memory for the node array}
  procedure GetTableMem;                {get memory for nodes-components table}
  procedure FreeTableMem;
  procedure FillNodeCompTable(pSet : TpCompSet; pWiLi : TpListBox);
  procedure NumberConnectedTo(pComp : TpComp; var nConn : integer);
  procedure NumberConnectedToGround(var ncGround : integer);
  procedure NumberConnectedToNode(node: integer; var nCnode : integer);
  procedure ConnectedToCurrTr(pCurT: TpComp; ppConCurT: TppComp; nConCurT,nnReal : integer);
  procedure ShowConnected(pCurrT: TpComp; ppConCurT : TppComp; nConCurT : integer);
  function  nWires(node, nnReal : integer): integer; {get no of wires connected to node}
  procedure FindPowerStations(ipSet : longint; pWireTypes : TpListBox);
  private
    mNode_n     : Integer;     {the max nop of nodes =  sum of
                                no of conn.points of all comps.}
    nComp_n     : integer;     {no of components}
    nNode_n     : Integer;     {the correct number of nodes}
    nWire_n     : Integer;     {number of connecting wires}
    nWrd_n      : integer;     {no of words in one row of node-comp.table}
    pNode_n     : TpIntri;     {pointer to the array for node id and coordinates}
    pNodCod_n   : pInteger;    {for cross ref. list of 3-nodes of current trafos}
    pNodeComp_n : pWord;       {pointer to Nodes - Components table}
    pNodeWire_n : pInteger;    {pointer to no of wires connected to nodes}
    pSet_n      : TpCompSet;   {pointer to the set of components etc}
    pVoltComp_n : TpVoltComp;  {pointer to object for voltage levels}
    pWiLi_n     : TpListBox;   {ptr to list of components taken as wires}
    ppComp_n    : TppComp;     {pointer to list of components}
 end;

type
  TppWidat = ^TpWidat;
  TpWidat = ^TWidat;               {pointer to wire data}
  TWidat = record                  {collection of pointer to wires+coord.}
  pWiCo : TpComp;                  {pointer to wire-component}
  x1    : Integer;                 {x-coord. of first end}
  y1    : Integer;                 {y-coord. of first end}
  x2    : Integer;                 {x-coord. of other end}
  y2    : Integer;                 {y-coord. of other end}
  indx  : Integer;                 {some index}
end;

type
{define an object for the set of connecting wires (Z=0) in the net}
  TpWireSet = ^TWireSet;                  {pointer to the set of nodes}
  TWireSet  = class(TObject)              {the set of nodes}
  procedure Initialize(ipCSet : Longint{; pWiLi : TpListBox});{initialize}
  procedure SetWireList(pWiLi : TpListBox);
  procedure GetWireMemory;
  procedure SetMaxNumberOfWires(maxnw :Integer);{set the max.number of wires}
  procedure SetNumberOfWires(nowi :Integer);{set the number of wires}
  procedure ShowNoOfWires;                {display a message}
  procedure ListOfWires(ppComp: TppComp; nComp: integer); {reserve+construct array for wires}
  procedure FreeListOfWires;              {free the array wires}
  procedure ConnectWires;                 {deduce the connections of
                                           wires to wires}
  procedure FreeConnectWires;             {release memory from array needed for
                                           deducing the connection of wires}
  procedure ConnectedToWires(xx,yy: Integer;var WireNo, NodeNo: Integer);
                                          {checks, is the point xx,yy on a wire}
  procedure WiresAsNodes(WireNo, NodeNo: Integer);{saves the node to
                                           wires connected to that node}
  private
    nExtw_w : integer;                    {number of wires, when curr.trafos are wires}
    nMaxw_w : integer;                    {max.no of wires}
    nWire_w : Integer;                    {number of wires}
    pWire_w : TpWidat;                    {pointer to the array of wires}
    pCSet_w : TpCompSet;                  {pointer to the set of components}
    pConw_w : pInteger;                   {pointer to array for connections}
    pWiLi_w : TpListBox;                  {pointer to the list of wire-names}
end;

const
  w16 : array[1..16] of word = (1,2,4,8,16,32,64,128,256,512,1024,2048,4096,
  8192,16384,32768);

procedure ConnectCurrTrafosAndRelays(nCurrTr,nRelays : integer;
               ppCurrTr,ppRelays : TppComp; pConDat : TpWidat);
{find the relays connected to each current trafo:
 When found, set the same value to the third node of the current trafo and
 to both nodes of the relay
 nCurrTr   no of current trafos
 nRelays   no of relays
 ppCurrTr  list of pointers to current trafos
 ppRelays  list of pointers to relays
 pConData working space for pointers + coordinates}
var
  changed : boolean;  {true, when a ned relay connected}
  err     : integer;  {error flag}
  iCT     : integer;  {index}
  ii      : integer;  {index}
  iRel    : integer;  {index}
  ix,iy   : integer;  {coordinates of a node}
  ix1,iy1 : integer;  {coordinates of first node}
  ix2,iy2 : integer;  {coordinates of second node}
  ll      : longint;  {temporary}
  mRel    : integer;  {counter}
  pCD     : TpWidat;  {pointer to the data}
  pCT     : TpComp;   {pointer to a current trafo}
  pRel    : TpComp;   {pointer to a relay}
  ppCT    : TppComp;  {local pointer to list of curr.trafos}
  ppRel   : TppComp;  {local pointer to the relays}
begin
  {everything exists ?}
  if (nCurrTr > 0) and (nRelays > 0) and
     (ppCurrTr <> nil) and (ppRelays <> nil) and (pConDat <> nil) then begin
    {copy data from current trafos}
    ppCT := ppCurrTr;
    pCD := pConDat;
    for iCT := 1 to nCurrTr do begin
      pCT := ppCT^;
      pCT^.GetNxy(3,ix,iy);       {coordinates of the third node}
      pCD^.x1 := ix;              {copy coordinates}
      pCD^.y1 := iy;
      pCD^.x2 := ix;              {initialize coordinates of "other end"}
      pCD^.y2 := iy;
      pCD^.indx := -iCT-1;        {node}
      pCD^.pWiCo := pCT;          {pointer to the current trafo}
      pCT^.PutNode(3,-iCT-1,err); {node also to current trafo }
      inc(ppCT);                  {next current trafo}
      inc(pCD);                   {next data}
    end;
    {initialize flags on relays}
    ppRel := ppRelays;
    for ii := 1 to nRelays do begin
      ppRel^^.var1_s := 0;
      inc(ppRel);
    end;
    {scan curr.trafos and relays}
    changed := true;           {initialize}
    mRel := 0;
    while (changed and (mrel < nRelays)) do begin   {repeat until no changes}
      changed := false;
      pCD := pConDat;
      for iCT := 1 to nCurrTr do begin
        ppRel := ppRelays;
        for iRel := 1 to nRelays do begin
          pRel := ppRel^;         {pointer to a relay}
          if (pRel^.var1_s = 0) then begin {relay not yet connected}
            pRel^.GetNxy(1,ix1,iy1);  {coordinates of first node}
            if (ix1 = pCD^.x1) and (iy1 = pCD^.y1) then begin  {connected}
              pRel^.putNode(1,pCD^.indx,err);   {node number to both nodes of the relay}
              pRel^.putNode(2,pCD^.indx,err);
              pRel^.GetNxy(2,ix,iy);  {coordinates of second node}
              pRel^.var1_s := 1;      {set flag: connected}
              pCD^.x1 := ix;          {other end to working space}
              pCD^.y1 := iy;
              ll := longint(pCD^.pWiCo); {pointer to the current trafo}
              pRel^.PutipComp(ll);       {save as integer}
              inc(mRel);
              changed := true;
              break;                    {only one connected immediately}
            end else begin              {if this end not connected, check the other end}
              pRel^.GetNxy(2,ix2,iy2);  {coordinates of second node}
              if (ix2 = pCD^.x2) and (iy2 = pCD^.y2) then begin  {connected}

                pRel^.putNode(1,pCD^.indx,err);   {node number to both nodes of the relay}
                pRel^.putNode(2,pCD^.indx,err);
                pRel^.GetNxy(1,ix,iy);  {coordinates of second node}
                pRel^.var1_s := 1;      {set flag: connected}
                pCD^.x2 := ix;          {other end to working space}
                pCD^.y2 := iy;
                ll := longint(pCD^.pWiCo); {pointer to the current trafo}
                pRel^.PutipComp(ll);       {save as integer}
                inc(mRel);
                changed := true;
                break;                  {only one connected immediately}
              end;
            end;
          end;
          inc(ppRel);                {next relay}
        end;
        inc(pCD);                    {next data}
      end;
    end;
  end;
end;

procedure ParallelFaults(nFaults : integer; ppFaults : TppComp);
{check, are  there parallel faults
 nFaults   no of faults
 ppFaults  pointer to list of faults}
var
  err     : integer;   {error flag}
  ii,jj   : integer;   {indices}
  nodeflt : integer;   {node of the fault}
  nodefltj: integer;   {node of another fault}
  ppF     : TppComp;   {local pointer to list of faults}
  ppFj    : TppComp;   {local pointer to another fault}
begin
  if (nFaults > 1) then begin
    ppF := ppFaults;
    for ii := 1 to nFaults do begin
      ppF^^.GetNode(1,nodeflt,err);        {fault node}
      ppFj := ppFaults;
      inc(ppFj,ii);
      for jj := ii+1 to nFaults do begin
        ppFj^^.PutParal(nil);               {initialize, no parallel, so far}
        ppFj^^.GetNode(1,nodefltj,err);     {fault node}
        if (nodeflt = nodefltj) then begin  {parallel faults ?}
          ppFj^^.PutParal(ppF^);            {save pointer to the parallel fault}
          break;
        end;
        inc(ppFj);
      end;
      inc(ppF);
    end;
  end;
end;


procedure DetermineNodes( ipSet: longint;
                          pWireList, pExtWireList,pRelayTypes,pWireTypes : TpListBox;
                          GroundName : String; purpose: NodePurpose);
{determine the nodes
 ipSet        pointer to the set of components etc, as integer
 pWireList    pointer to box containing the names of components taken as wires
 pExtWireList pointer to box containing the names of additional components
              taken as wires, when checking connections of current trafos
 pRelayTypes  pointer to a box containing the names of relays, considered as wires
              when calculating
 pWireTypes   pointer to box filled here with contents of pWireList and pExtWireList
              ( = all types consodered as wires, when checking connections of curr.trafos)
 GroundName name of ground (earth) = node 0 = not a real node
 purpose      really determining nodes, or checking the connections of current trafos
 Called also when clicking a relay ?? (called in Skemproc) NO more
}
var
  cmpnod   : integer;     {node of component}
  err,errc : integer;     {error flag}
  faultpos : string;      {position of the fault}
  fltnode  : integer;     {node of the fault}
  faultlbl : string;      {label of first component connected to the fault}
  iCurrTr  : integer;     {index}
  ii,jj,kk : integer;
  ll,mm    : integer;
  ix,iy    : integer;     {coordinates of the label}
  lbl      : string;      {label of the comp}
  maxComp  : integer;     {max.no of components connected to one current trafo}
  ModNam   : string;      {name (type) of the component}
name : string;
  nch      : integer;     {no of checked nodes}
  nComp    : integer;     {no of components}
  nConComp : integer;     {no of connected components}
  nConCurT : integer;     {no of all components connected to a current trafo}
  nConGr   : integer;     {number of components connected to ground}
  nCurrTr  : integer;     {no of current trafos}
  nFaults  : integer;     {no of faults}
  nFltComp : integer;     {counts components connected to fault}
  nnod     : integer;     {no of nodes}
  nMeasZ   : integer;     {no of impedance measurements}
  nPQrel   : integer;     {no of PGQ-overcurrent relays}
  nRelays  : integer;     {no of relays}
  node     : integer;     {node (general)}
  nodeflg  : integer;     {1 = upstream node, 2 = downstream node of curr.trafo}
  nnReal   : integer;     {real number of nodes}
  nWr      : integer;     {no of wires}
  pComp    : TpComp;      {pointer to a component}
  pConDat  : TpWidat;     {data for checking connections of curr.trafos and relays}
ppComp : TppComp;
  ppConCurT: TppComp;     {pointer to list of components connected to a current trafo}
  ppCurrTr : TppComp;     {pointer to array of current trafos}
  ppCT     : TppComp;     {temp.pointer to array of current trafos}
  ppF      : TppComp;     {temp pointer to array of faults}
  ppFaults : TppComp;     {pointer to list of faults}
  ppRelays : TppComp;     {pointer to list of relays}
  pNodes   : TpNodeSet;   {pointer to the set of nodes}
  pSet     : TpCompSet;   {pointer to the set of components etc}
  pWires   : TpWireSet;   {pointer to the set of connecting wires}
  ipWires  : longint;     {pointer to the set of wires, as integer}
  CThint   : string;      {proper hint of a current trafo}
begin
  pSet := TpCompSet(ipSet);              {pointer to the set from integer}
  pSet^.ResetNodes;                      {reset the node ID in components}
  pSet^.GroundFirst(GroundName);         {Grounds become the first ones}
  new(pNodes);                           {new pointer into use WHY is this needed ?}
  pNodes^:= TNodeSet.Create;             {create the node set}
  pNodes^.Initialize(ipSet,pWireList);   {initialize the variables}
  pNodes^.NodesMaxAndComp(nComp);        {determine max.no of nodes,count components}
  pSet^.PutNComp(nComp);                 {save no of all components}
  pNodes^.GetNodMem;                     {reserve memory for nodes}
  {construct list of all wire types (inc.curr.trafos) to pWireTypes}
  pNodes^.ExtendListOfWires(pWireList, pExtWireList,pWireTypes);
  {First, find which components are connected to current trafos- - - - - - - - - - - - - }
  pSet^.NumberOfWiresRelaysAndFaults(pExtWireList,pRelayTypes,
                                     nCurrTr,nRelays,nFaults,nMeasZ,nPQrel); {no of ...}
  pSet^.PutNCurrTr(nCurrTr);             {save no of current trafos}
  pSet^.PutNRelays(nRelays);
  pSet^.PutNMeasZ(nMeasZ);
  pSet^.PutNPQrel(nPQrel);
  {memory for list pointers to current trafors, if there are any}
  if (nCurrTr > 0) then begin
    getmem(ppCurrTr,nCurrTr*Sizeof(TpComp));
    getmem(pConDat,nCurrTr*Sizeof(TWidat));
  end else begin
    ppCurrTr := nil;
    pConDat := nil;
  end;
  {create the wire-object }
  new(pWires);                           {pointer to wires into use}
  pWires^:=TWireSet.Create;              {create the wire set}
  pWires^.Initialize(ipset);             {initialize the set of all wires}
  pSet^.NumberOfWiresRelaysAndFaults(pWireTypes,pRelayTypes,kk,ii,jj,ll,mm);{no of ALL wires}
  pWires^.SetMaxNumberOfWires(kk);       {all types of wires (also relays ?)}
  pWires^.GetWireMemory;
  ipWires := longint(pWires);            {change to integer}
  {memory for list pointers to relays, if there are any}
  if (nRelays > 0) then getmem(ppRelays,nRelays*Sizeof(TpComp))
  else  ppRelays := nil;
  if (nFaults > 0) then getmem(ppFaults,nFaults*Sizeof(TpComp)) {array for faults}
  else                         ppFaults := nil;
  {fill the lists of pointers to curr.trafos, relays and faults}
  pSet^.FillListOfWiresRelaysAndFaults(ppCurrTr,ppRelays,ppFaults,
                                       pExtWireList,pRelayTypes);
(**)
  {determine nodes in order to define the locations of faults. Only buses and
   wires considered as wires - - - - - - - - - - - - - - - - - - - - - - - - - }
  pSet^.NumberOfWiresRelaysAndFaults(pWireList,pRelayTypes,kk,ii,jj,ll,mm);{no of proper wires}
  pWires^.SetNumberOfWires(kk);               {proper wires = wires+buses}
  pWires^.SetWireList(pWireList);             {list of names of proper wires}
  pWires^.ListOfWires(nil,0);                 {construct list of wires}
  pWires^.ConnectWires;                       {deduce connections between wires}
  {determine the nodes, check wires, and grounds}
  pNodes^.CompoNode(ipWires,GroundName,pWireList,nil,0);
  {find the locations of fault(s)}
  pSet^.Fault_pos := '';               {no faults yet}
  if (nFaults > 0) then begin
    ppF := ppFaults;                     {temp pointer to list of faults}
    for ii := 1 to nFaults do begin      {all faults}
      faultpos := 'Fault at ';           {initialize}
      faultlbl := '';
      nFltComp := 0;                     {initialize}
      ppF^^.GetNode(1,fltnode,err);      {node of the fault}
      {scan all components, check, which are connected to the node of the fault}
      pComp := nil;                      {initialize pointer to components}
      errc := 0;                         {initialize error flag}
      while (errc = 0) do begin          {to last component, or first error}
        ModNam := '';                    {initialize}
        pSet^.NextComp(pComp, errc);     {pointer to next component}
        if (errc = 0) then begin         {not error, but maybe last comp.}
          pComp^.GetNnod(nnod);          {get the number of nodes in this compon.}
          if (nnod > 0) then begin       {component has nodes}
            if (nnod < 3) then nch := nnod else nch := 3;  {check at most 3 nodes}
            for jj := 1 to nch do begin
              pComp^.GetNode(jj,cmpnod,err);
              if (cmpnod = fltnode) then begin  {same node as the fault}
                pComp^.GetLabel(lbl,ix,iy);     {label of the comp}
                pComp^.GetModName(ModNam);      {name of the component}
                if (ModNam = gBus) then begin   {one bus defines the location}
                  faultpos := 'Fault at bus  '+lbl;
                  nFltComp := 0;                {reset, acts as a flag}
                end else begin
                  if (length(lbl) > 0) then begin {wires, faults etc not counted}
                    inc(nFltComp);                {one more comp. connected to the fault}
                    if (nFltComp = 1) then begin  {first comp. connected to fault}
                      Faultlbl := lbl;            {save, write later}
                    end else if (nFltComp = 2) then begin {second, write first and second comp.}
                      faultpos := faultpos+' the common point of '+Faultlbl+' '+lbl+' ';
                    end else begin
                      faultpos := faultpos+lbl+' ';
                    end;
                  end;
                end;
                break;                          {each comp. only once}
              end;
            end;
          end;
          if (ModNam = gBus) then break;        {one bus defines the location}
        end;
      end;
      {save the fault position}
      if (nFltComp = 1) then faultpos := faultpos+' '+Faultlbl; {only one comp. at fault}
      pSet^.Fault_pos := pSet^.Fault_pos+faultpos+';';   {the ';' ends data of one fault}
      inc(ppF);
    end;
  end;
(**)
(**)
  {determine connections of current trafos  - - - - - - - - - - - - - - - - - - - - }
  if (nCurrTr > 0) then begin
    {first, determine nodes in a normal way, all wires included}
    pWires^.SetNumberOfWires(pWires^.nMaxw_w); {all wires and relays}
    pWires^.SetWireList(pWireTypes);           {list of names of all wires}
    pWires^.ListOfWires(nil,0);                {construct list of wires}
    pWires^.ConnectWires;                      {deduce connections between wires}
    pNodes^.CompoNode(ipWires,GroundName,pWireTypes, nil,0); {nodes, temporarily}
    nnReal := pNodes^.nNode_n;                 {real number of nodes}
    {determine connections of current trafos}
    pNodes^.GetTableMem;                       {memory for node - comp.table}
    pNodes^.FillNodeCompTable(pSet,pWireTypes);{fill the table}
    {find max no of components connected to one current trafo (both ends)}
    ppCT := ppCurrTr;                          {pointer to list of current trafos}
    maxComp := 0;
    for iCurrTr := 1 to nCurrTr do begin
      ppCT^^.GetNode(1,node,err);
      ppCT^^.int1_s := node;                   {save node}
      {find, how many components connected to up- or downstream node}
      pNodes^.NumberConnectedToNode(node, kk);
      ppCT^^.int2_s := kk;                     {save no of connected comp}
      if (kk > maxComp) then maxComp := kk;
      inc(ppCT);
    end;
    {check still connections to ground (some curr.trafo may be connected to gr.}
    pNodes^.NumberConnectedToGround(nConGr);
    if (nConGr > maxComp) then maxComp := nConGr;
    {get memory for list of components connected to a current trafo}
    getmem(ppConCurT,(maxComp)*SizeOf(TpComp));
    {scan all current trafos for connections}
    ppCT := ppCurrTr;                       {pointer to list of current trafos}
    for iCurrTr := 1 to nCurrTr do begin
      node := ppCT^^.int1_s;
      if (node = 0) then nConCurT := nConGr                {connected to ground}
      else nConCurT := ppCT^.int2_s;                       {how many connected}
      pNodes^.ConnectedToCurrTr(ppCT^,ppConCurT,nConCurT,nnReal); {fill with connected}
      nWr :=  pNodes^.nWires(node,nnReal);                 {get no of wires connected to node}
      pWires^.SetNumberOfWires(nWr-1);                     {minus itself, not taken as wire}

{      pNodes^.ShowConnected(ppCT^, ppConCurT, nConCurT);}
      {this current trafo not considered as wire, here}
      CThint := ppCT^^.hint;                               {save hint, replace later}
      ppCT^^.hint := 'under test';
      pWires^.ListOfWires(ppConCurT,nConCurT);             {construct (small) list of wires}
      pWires^.ConnectWires;                                {deduce connections between wires}
      pNodes^.CompoNode(ipWires,GroundName,pWireTypes,ppConCurT,nConCurT);{part of nodes}
      ppCT^^.hint := CThint; {return the hint}
      pNodes^.CountConnectedComp(ppCT^, nConComp, nodeflg);
      {check, is memory needed, get if it is. Eventually release old memory}
      ppCT^^.CheckAndGetMemForConComp(nConComp,nodeflg);   {in skemadef.pas}
      pNodes^.FillListOfConnectedComp(ppCT^,pWireTypes,ppConCurT,nConCurT);
{     pNodes^.CheckListOfConnectedComp(ppCT^);}
      inc(ppCT);
    end;
    pNodes^.FreeTableMem;
    freemem(ppConCurT,maxComp*SizeOf(TpComp));
  end;
(**)
(**)
  {start again. Now, really determine the nodes - - - - - - - - - - - - - - - }
  pWires^.SetNumberOfWires(pWires^.nMaxw_w);  {all wires}
  pWires^.SetWireList(pWireTypes);            {list of names of all wires}
  pWires^.ListOfWires(nil,0);                 {construct list of wires}
  pWires^.ConnectWires;                       {deduce connections between wires}
  {determine the nodes, check wires, and grounds}
  pNodes^.CompoNode(ipWires,GroundName,pWireTypes,nil,0);
  {determine connections between current trafos and relays}
  ConnectCurrTrafosAndRelays(nCurrTr,nRelays,ppCurrTr,ppRelays,pConDat);
  {check eventual parallel faults}
  ParallelFaults(nFaults, ppFaults);
  pNodes^.FindPowerStations(ipSet,pWireTypes);
(*
{fill node-component table }
pNodes^.GetTableMem;                       {memory for node - comp.table}
pNodes^.FillNodeCompTable(pSet,pWireTypes);{fill the table}
ppComp := pNodes^.ppComp_n;
{
for ii := 1 to pNodes^.nComp_n do begin
  pComp := ppComp^;
  pComp^.GetName(name);
  showmessage(name);
  inc(ppComp);
end;
}
{showmessage(inttostr(pNodes^.nComp_n));}
showWmat1(pNodes^.pNodeComp_n,pNodes^.nNode_n+1,pNodes^.nWrd_n);
pNodes^.FreeTableMem;
*)
  {create object for determining voltage level of components - - - - - - - - - -}
  new(pNodes^.pVoltComp_n);
  pNodes^.pVoltComp_n^ := TVoltComp.Create(longint(pNodes));
  pNodes^.pVoltComp_n^.NodesAndComp(fill);  {fill the arrays with comp. pointers}
  pNodes^.pVoltComp_n^.ConnectionsOfNodes(IsSourceOrTrafo);  {determine nominal voltage levels}
  pNodes^.pVoltComp_n^.VoltagesOfComponents;{copy the voltages to components}
  pNodes^.pVoltComp_n^.ConnectionsOfNodes(IsTLineOrTrafo); {determine tr.line nodes...}
  pNodes^.pVoltComp_n^.TrLinesOfComponents; {copy the tr.line nodes to components}
  pNodes^.pVoltComp_n^.BusVoltages;         {must be determined separately}
  {find the (relative) phase of (nodes and) components}
  pNodes^.pVoltComp_n^.DetermineRelativePhase;
  pNodes^.pVoltComp_n^.free;
  dispose(pNodes^.pVoltComp_n);
  pNodes^.pVoltComp_n := nil;
(**)
  {free, release wires and memory - - - - - - - - - - - - - - - - - - - - - - - -}
  if (pWires <> nil) then begin
    pWires^.FreeConnectWires;              {free memory reserced for connections}
    pWires^.FreeListOfWires; {MOVE !!}     {free space reserved for wire-table}
    pWires^.free;                          {free the memory for wires}
    dispose(pWires);
    pWires := nil;
  end;
  {finally, free nodes...}
  if (pNodes <> nil) then begin
    pNodes^.FreeNodMem;                    {free the memory for nodes}
    pNodes^.free;
    dispose(pNodes);
    pNodes := nil;
  end;
  {release other arrays}
  if (nCurrTr > 0) then begin
    freemem(ppCurrTr,nCurrTr*Sizeof(TpComp));
    freemem(pConDat,nCurrTr*Sizeof(TWidat));
  end;
  if (nRelays > 0) then freemem(ppRelays,nRelays*Sizeof(TpComp));
  if (nFaults > 0) then freemem(ppFaults,nFaults*Sizeof(TpComp));
{showmessage('end nodes');} {Gpp4 : 14 sec, Gpp2 : 3-4 sec in p200 Mhz}
end;

procedure TNodeSet.Initialize(ipSet : longint; pWiLi : TpListBox);
{initializes the variables of this class
 ipSet pointer to the set of components etc, as integer
 ipSet  pointer to the "common" as an integer
 pWiLi  pointer to the list of components considered as wires
 pExtWiLi pointer to additional components, considered as wires when checking
 purpose  really deteremine nodes, or check connections of current trafos
 }
begin
  nNode_n := 0;
  mNode_n := 0;
  pNode_n := nil;
  nWire_n := 0;
  pSet_n := TpCompSet(ipSet);
  pWiLi_n := pWiLi;
end;

procedure TNodeSet.ExtendListOfWires(pWiLi, pExtWiLi, pWiTy : TpListBox);
{construct a lis of all wire types: the "normal" wires and the extended list of wires
 pExtWiLi pointer to list of names of current trafos.
 pWiLi    pointer to list of "normal" wire types
 WiTy     combined list of wire types}
var
  ii     : integer;  {index}
  nWiLi  : integer;  {no of items in wire list}
begin
  {first, the normal wire types}
  nWiLi := pWiLi^.Items.count;        {number of words}
  pWiTy^.items.clear;                 {clear initially}
  if (nWiLi > 0) then begin
    for ii := 1 to nWiLi do begin
      pWiTy^.items.add(pWiLi^.items[ii-1]);
    end;
  end;
  {then add the contents of the extended list = current trafos}
  nWiLi := pExtWiLi^.Items.count;     {number of words}
  if (nWiLi > 0) then begin
    for ii := 1 to nWiLi do begin
      pWiTy^.items.add(pExtWiLi^.items[ii-1]);
    end;
  end;
end;

procedure TNodeSet.NodesMaxAndComp(var nComp : integer);
{calculate the max. number of nodes, or the upper bound for number of nodes,
 as sum of (no of connection points of all components
 Also count components
}
var
  c_err : Integer;               {error flag, for next component}
  nmax  : Integer;               {max no of nodes}
  nn    : Integer;               {no of nodes in this component}
  pComp : TpComp;                {pointer to a component}
begin
  nComp := 0;
  pComp := nil;                    {initialize pointer to components}
  nmax  := 0;                      {initialize max. number of nodes}
  c_err := 0;                      {initialize error flag}
  while (c_err = 0) do begin       {to last component, or first error}
    pSet_n^.NextComp(pComp, c_err);{pointer to next component}
    if (c_err = 0) then begin      {not error, but maybe last comp.}
      inc(nComp);
      pComp^.Getnnod(nn);          {get the number of nodes in this compon.}
      nmax := nmax+nn;             {add nodes of this component}
    end;
  end;
  mNode_n := nmax;                 {copy no of nodes to node set}
  nComp_n := nComp;                {save also no of components}
end;
(*
procedure TNodeSet.NumberOfWires({ipCSet : longint;} ID :String);
{determines the number of components of given type, ie. with .hint =
 the string given as ID ('wire', mostly)
 ipCSet:  pointer to the set of components, as integer
 ID    : the identifier of the component type
 }
 var
  c_err : Integer;               {error flag, or indicates last component}
  nw    : Integer;               {number of components with given ID}
  pCSet : TpCompSet;             {pointer to the component set in the schema}
  pComp : TpComp;                {pointer to a component}
begin
  pComp := nil;                    {initialize pointer to components}
  c_err := 0;                      {initialize error flag}
  nw    := 0;                      {initialize counter}
  while (c_err = 0) do begin       {to last component, or first error}
    pSet_n^.NextComp(pComp, c_err); {pointer to next component}
    if (c_err = 0) then begin      {not error, but maybe last comp.}
      if (pComp^.hint = ID) then   {the hint contains the type}
        nw := nw+1;                {increment counter}
    end;
  end;
  nWire_n := nw;                   {copy from local}
end;
*)
(*procedure TNodeSet.GroundNode(ipCSet: longint; Grnd :String; NodeNo:Integer);
{defines the node ID for components "Ground"
 ipCSet   the pointer to the component set, as integer
 Grnd     the identifier, or name of the "Ground" component
 NodeNo   the number given to the nodes corresponding to ground
          (mostly zero, I guess}
 var
  c_err : Integer;               {error flag, or indicates last component}
  ix,iy : Integer;               {the coordinates of the node}
  n_err : Integer;               {error flag for nodes}
  pCSet : TpCompSet;             {pointer to the component set in the schema}
  pComp : TpComp;                {pointer to a component}
  pNode : TpIntri;               {pointer to array of nodes}
begin
  pCSet := TpCompSet(ipCSet);      {pointer to the component set}
  pComp := nil;                    {initialize pointer to components}
  pNode := pNode_n;                {initialize pointer to node-array}
  c_err := 0;                      {initialize error flag}
  while (c_err = 0) do begin       {to last component, or first error}
    pCSet^.NextComp(pComp, c_err); {pointer to next component}
    if (c_err = 0) then begin      {not error, but maybe last comp.}
      if (pComp^.hint = Grnd) then {the hint contains the type}
      pComp^.PutNode(1,NodeNo,n_err); {set the node number, only one node}
      pComp^.GetNxy(1,ix,iy);      {get the coordinates}
      if (pNode <> nil) then begin
        pNode^.indx := NodeNo;     {node identifier, = 0, I guess}
        pNode^.ix := ix;           {x-coordinate}
        pNode^.iy := iy;           {y-coordinate}
        inc(pNode);                {pointer to next node}
      end;
    end;
  end;
end; *)

procedure TNodeSet.IncCompCount(nodenr : integer);
{increment the counter of components connected to node number nodenr}
var
  pNtmp  : TpIntri;  {temporary pointer}
begin
  if (nodenr > 0) and (nodenr <= mNode_n) then begin  {reasonable number}
    pNtmp := pNode_n;
    inc(pNtmp,nodenr-1);
    inc(pNtmp^.no);       {increment count of components connected to this node}
  end;
end;

procedure TNodeSet.CountConnectedComp(pComp : TpComp; var nConComp,nodeflg : integer);
{count,   how many components connected to this comp
 pComp     pointer to the component under consideration
 nConComp  no of connected components
 nodeflg   1 = upstream node, 2 = downstream}
var
  ctNode  : integer;   {count connections to this node }
  err     : integer;   {error flag}
  nodedwn : integer;   {downstream node}
  nodeup  : integer;   {upstream node}
  pNodat  : TpIntri;   {pointer to node data}
begin
  {find, how many components connected to up- or downstream node}
  pComp^.GetNode(1,nodeup,err);        {upstream node}
  if (nodeup > 0) then begin           {not ground}
    ctNode := nodeup;
    nodeflg := 1;
  end else begin
    pComp^.GetNode(2,nodedwn,err);     {downstream node}
    if (nodedwn > 0) then begin        {not ground}
      ctNode := nodedwn;
      nodeflg := 2;
    end else begin
      ctNode := 0;                     {both nodes connected to ground}
      nodeflg := 1;                    {some value}
    end;
  end;
  if (ctNode > 0) then begin           {not both connected to ground}
    pNodat := pNode_n;
    inc(pNodat,ctNode-1);              {pointer to data of this node}
    nConComp := pNodat^.no-1;          {number of connected components}
  end else begin
    nConComp := 0;                     {earth = no connections}
  end;

end;

procedure TNodeSet.NumberConnectedTo(pComp : TpComp; var nConn : integer);
{count,   how many components connected to this comp
          to node 1 (used for current trafos, taken as wires)
 pComp     pointer to the component under consideration
 nConn     no of connected components}
var
  err     : integer;   {error flag}
  nodeup  : integer;   {first node}
  pNodat  : TpIntri;   {pointer to node data}
begin
  {find, how many components connected to node 1}
  pComp^.GetNode(1,nodeup,err);        {upstream node}
  if (nodeup > 0) then begin           {ground not in the table}
    pNodat := pNode_n;
    inc(pNodat,nodeup-1);              {pointer to data of this node}
    nConn := pNodat^.no;               {number of connected components}
  end else begin
    nConn := 0;                        {ground calculated separately}
  end;
{  showmessage(inttostr(nodeup)+'  '+inttostr(nConn));}
end;

procedure TNodeSet.ShowConnected(pCurrT: TpComp; ppConCurT : TppComp; nConCurT : integer);
{show components connected to this current trafo
 pCurrT     pointer to the current trafo
 ppConCurT  pointer to list of connected components
 sConCurT   number of connected comp.}
var
  CTlbl,lbl  : string;    {labels of components}
  ii         : integer;   {index}
  ix,iy      : integer;   {coordinates}
  ppCCT      : TppComp;   {local pointer to list}
begin
  if (pCurrT <> nil) and (ppConCurT <> nil) and (nConCurT > 0) then begin
    pCurrT^.GetLabel(CTlbl,ix,iy);
    ppCCT := ppConCurT;
    for ii := 1 to nConCurT do begin
      ppCCT^^.getLabel(lbl,ix,iy);
      showmessage(CTlbl+'  '+inttostr(ii)+'  '+lbl);
      inc(ppCCT);
    end;
  end;
end;

procedure TNodeSet.CheckListOfConnectedComp(pCurrT : TpComp);
{show the components connected to a current trafo
 pCurrT   pointer to the current trafo}
var
  ii      : integer;
  ix,iy   : integer;   {coordinates}
  comlab  : string;    {label of the component}
  ctlab   : string;    {label of curr.trafo}
  nConCom : integer;   {no of connected components}
  nodeflg : integer;   {flag for upstream (1) or downstream (2) node}
  pComp   : TpComp;    {pointer to a component}
  pList   : TpConList; {local pointer to the list of comp.}
begin
  if (pCurrT <> nil) then begin
    pCurrT^.GetLabel(ctlab,ix,iy);
    pCurrT^.GetConData(pList,nConCom,nodeflg);
    if (nConCom > 0) and (pList <> nil) then begin
      for ii := 1 to nConCom do begin
        pComp := TpComp(pList^.ipComp);
        if (pComp <> nil) then pComp^.GetLabel(comlab,ix,iy)
        else comlab := 'tyhj';
        showmessage(ctlab+'   '+comlab);
        inc(pList);
      end;
    end;
  end;
end;

procedure TNodeSet.FillListOfConnectedComp(pCurrT : TpComp; pWiTyp : TpListBox;
                                           ppComp: TppComp; nComp: integer);
{fill the list of components connected to the given current trafo
 wires are not counted
 pCurrT   pointer to the current trafo
 pWiTyp    pointer to names of components considered as wires
 ppComp   pointer to an alternative list of components
 nComp    no of components in the alternative list of comp.
 ---
 If ppComp <> nil and nComp > 0, use the alternative list of components,
 else check all components}
var
  alter    : boolean;   {if true, use alternative list}
  c_err    : integer;   {error flag}
  ConCount : integer;   {counts connected components}
  ctNode   : integer;   {node of current trafo under study, 1 or 2}
  err      : integer;   {error flag}
  ii       : integer;   {index}
  nCmp     : integer;   {counter of comp}
  nConComp : integer;   {no of connected components}
  nnmax    : integer;   {max no no of nodes studied}
  nn       : integer;   {number of nodes}
  node     : integer;   {node}
  nodeflg  : integer;   {1 = connected to upstream node, 2 = downstream}
  pComp    : TpComp;    {pointer to other components}
  pConn    : TpConList; {local pointer to list of connected comp.}
  pConList : TpConList; {pointer to list of connected components}
  ppCmp    : TppComp;   {pointer to alternative list of comp}
begin
  if (pCurrT <> nil) then begin
    alter := (ppComp <> nil) and (nComp > 0);         {alternative list ?}
    pCurrT^.GetConData(pConList,nConComp,nodeflg);    {get data for connections}
    if (pConList <> nil) and (nConComp > 0) and
       ((nodeflg = 1) or (nodeflg = 2))then begin {connections ?}
      pConn := pConList;
      pCurrT^.GetNode(nodeflg,ctNode,err);  {node, where connected}
      ConCount := 0;
      {scal all components, look for connections to given node}
      pComp := nil;                    {initialize pointer to components}
      c_err := 0;                      {initialize error flag}
      ppCmp := ppComp;                          {pointer to alternative list}
      nCmp := 0;
      while (c_err = 0) do begin
        if (not alter) then begin             {scan all components}
          pSet_n^.NextComp(pComp,c_err);
        end else begin                        {use alternative list}
          pComp := ppCmp^;                    {get component}
          inc(nCmp);
          inc(ppCmp);                         {pointer to next}
          if (nCmp > nComp) then c_err := 1;  {done}
        end;
        if (c_err = 0) then begin      {not error, but maybe last comp.}
          if (pComp <> pCurrT) then begin {not itself}
            pComp^.Getnnod(nn);          {get the number of nodes in this compon.}
            if (not(IsWire(pComp^.hint,pWiTyp))) and (nn > 0) then begin
              if (nn > 3) then nnmax := 3 else nnmax := nn; {study at most 3 nodes !}
              for ii := 1 to nnmax do begin
                pComp^.GetNode(ii,node,err);  {node ii of this component}
                if (node = ctNode) then begin {connected to the cur.trafo?}
                  pConn^.ipComp:= longint(pComp); {add to list}
                  pConn^.indx := ii;             {up-, downstream, or other node}
                  inc(pConn);
                  inc(ConCount);                 {count, just to be sure}
                  break;                         {no need to study more nodes}
                end;
              end;
            end;
          end;
        end;
        if (ConCount >= nConComp) then break; {list full}
      end;
    end;
  end;
end;

function  TNodeSet.nWires(node, nnReal : integer): integer;
{get no of wires connected to node
 node    the node under study
 nnReal  the real number of nodes (in the whole network)}
var
  pInt : pInteger;
begin
  if (node >= 0) and (node <= nnReal) and (pNodeWire_n <> nil) then begin
    pInt := pNodeWire_n;
    inc(pInt,node);
    nWires := pInt^;
  end else begin
    nWires := 0;
  end;
end;

procedure TNodeSet.CompoNode(ipWires: longint; Grnd : string;
                              pWiLi : TpListBox; ppComp: TppComp; nComp: integer);
{define nodes for components
 ipWires= pointer to the wire set, as integer
 Grnd   = the identifier for the "ground" component ('ground', I guess)
 pWiLi  = pointer to the list of wire-names
 ppComp   pointer to alternative list of components
 nComp    no of components in the alternative list
 ---
 If ppComp <> nil and nComp > 0, use the alternative list of components,
 else check all components}
var
  alter : boolean;               {if true, use alternative list}
  c_err : Integer;               {error flag, or indicates last component}
  i,j   : integer;               {indices, or counters}
  ID    : string;                {identification of the component}
  ix,iy : Integer;               {the coordinates of the node}
  n_err : Integer;               {error flag for nodes}
  nCmp  : integer;               {counts components}
  nn    : Integer;               {number of nodes in a component}
  nCount: Integer;               {counts all nodes}
  NodeExists: boolean;           {true, if node in ix,iy already exists}
  NodeNo: Integer;               {node to which a wire is connected}
  nNode : Integer;               {counts nodes, excluding ground}
  pComp : TpComp;                {pointer to a component}
  pNode : TpIntri;               {pointer to array of nodes}
  pNodsc: TpIntri;               {pointer to the arrray of nodes, for scanning}
  pWires: TpWireSet;             {pointer to the set of wires}
  ppCmp : TppComp;               {local pointer to alternative set of comp.}
  WireNo: Integer;               {id of the wire a component is connected to}
begin
  alter := (ppComp <> nil) and (nComp > 0); {alternative list ?}
  pSet_n^.ResetNodes;              {initialize all nodes to -1}
  pWires:= TpWireSet(ipWires);     {pointer to the set of wires}
  pComp := nil;                    {initialize pointer to components}
  pNode := pNode_n;
  for i := 1 to mNode_n do begin
    ClearIntri(pNode);             {clear initially}
    inc(pNode);
  end;
  pNode := pNode_n;                {initialize pointer to node-array}
  pNodsc := nil;                   {initialize 2.10.2002}
  NodeExists := false;             {initialize 2.10.2002}
  c_err := 0;                      {initialize error flag}
  nNode := 0;                      {counts nodes, excluding ground}
  nCount:= 0;                      {counts all nodes}
  nCmp := 0;
  ppCmp := ppComp;
  while (c_err = 0) do begin       {to last component, or first error}
    if (not alter) then begin        {scan all components}
      pSet_n^.NextComp(pComp, c_err);{pointer to next component}
    end else begin                   {use alternative list}
      pComp := ppCmp^;               {get component}
      inc(nCmp);
      inc(ppCmp);                         {pointer to next}
      if (nCmp > nComp) then c_err := 1;  {done}
    end;
    if (c_err = 0) then begin      {not error, but maybe last comp.}
      pComp^.GetNnod(nn);          {get the number of nodes in this comp.}
      ID := pComp^.hint;           {get the identification of the component}
      {are there nodes ? Skip wires, they are nodes !}
      if (nn > 0) and not(IsWire(ID,pWiLi)) then begin
        for i:=1 to nn do begin    {scan all nodes}
          pComp^.GetNxy(i,ix,iy);  {get the coordinates of node i}
          {check first, is the node connected to a wire}
          pWires^.ConnectedToWires(ix,iy,WireNo,NodeNo);
          if (nCount <= 0) then begin {first node}
            NodeExists := false;   {node does not exist, of course}
{           nindx := 1;            {first node (needed ??)}
          end else begin           {not first node}
            pNodsc := pNode_n;     {initialize pointer to nodes}
            for j:=1 to nCount do begin  {scan all defined nodes}
              {is the node already in the list ?}
              if (ix = pNodsc^.ix) and (iy = pNodsc^.iy) then begin
                NodeExists := true;{set flag, node already exists}
{               Nindx := pNodsc^.indx; {node id to temporary}
                break;             {stop search}
              end else begin
                NodeExists := false; {node not yet found, maybe does not exist}
{               Nindx := -1;         {node index still not known}
              end;
              inc(pNodsc);           {next node}
            end;
          end;
          {if node did not exist, it must be added to the list}
          if not(NodeExists) then begin
          {check first, is it connected to some node through wires}
            if (NodeNo >= 0) then begin
              pComp^.PutNode(i,NodeNo,n_err); {node id to component}
              IncCompCount(NodeNo); {increment comp.count connected to this node}
            end else begin         {a genuinely new node}
             {add the node to the list, etc}
              pNode^.ix := ix;       {save node x-coordinate}
              pNode^.iy := iy;       {save node y-coordinate}
              if pComp^.hint = Grnd then begin {ground ?}
                pNode^.indx := 0;    {index of the node into the list}
              end else begin         {not a ground, proper node}
                inc(nNode);          {increment count of real nodes}
                pNode^.indx := nNode;{node id}
              end;

              pComp^.PutNode(i,pNode^.indx,n_err); {index to the component}
              IncCompCount(pNode^.indx); {increment comp.count connected to this node}
              {if connected to wires, update also node id of wires}
              if (WireNo > 0) then begin
                pWires^.WiresAsNodes(WireNo, nNode);
              end;
              inc(pNode);            {pointer to next node}
              inc(nCount);           {increment count of all nodes}
            end;
          end else begin           {node exists, put node id to component}
            if (pNodsc <> nil) then begin
              pComp^.PutNode(i,pNodsc^.indx,n_err);
              IncCompCount(pNodsc^.indx); {increment comp.count connected to this node}
            end;
          end;
        end;
      end;
    end;
  end;
  pSet_n^.appl_nn := nnode;         {save number of nodes to comp. set}
  nNode_n := nnode;                 {...and to local }

(*  ShowNoOfConnComp; {temporary}*)
end;
(*
procedure TNodeSet.CurrTrafoNodes(pWiTy : TpListBox);
{find the current node of current trafos and fill the cross reference list
 pWiTy  list of names of current trafos}
var
  err,err1 : integer;   {error flag}
  ctNode   : integer;   {counter node of current trafo}
  hint     : string;    {the hint = type of the component}
  node     : integer;
  pComp    : TpComp;    {pointer to a component}
  pNodCod  : pInteger;  {pointer to the cross reference table}
begin
  ctNode := 0;
  pComp := nil;                    {initialize pointer to components}
  err := 0;                        {initialize error flag}
  while (err = 0) do begin         {to last component, or first error}
    pSet_n^.NextComp(pComp, err);  {pointer to next component}
    if (err = 0) then begin        {not error, but maybe last comp.}
      hint := pComp^.hint;         {pick the type}
      if (IsWire(hint,pWiTy)) then begin  {is it a current trafo}
        pComp^.GetNode(3,node,err1); {current node of the trafo}
        inc(ctNode);               {update counter}
        pNodCod := pNodCod_n;
        if (node > 0) then begin
          inc(pNodCod,node-1);
          pNodCod^:= ctNode;       {new entry to the cross reference table}
        end;
      end;
    end;
  end;
end;
*)
(*
procedure TNodeSet.ParalRelayNodes(pReTy : TpListBox);
{copy the nodes of relays in "parallel" list from the cross reference list
 pReTy  lit of relay names}
var
  err,err1 : integer;   {error flag}
  ctNode   : integer;   {counter node of current trafo}
  hint     : string;    {the hint = type of the component}
  node     : integer;
  pComp    : TpComp;    {pointer to a component}
  pNodCod  : pInteger;  {pointer to the cross reference table}
begin
  pComp := nil;                    {initialize pointer to components}
  err := 0;                        {initialize error flag}
  while (err = 0) do begin         {to last component, or first error}
    pSet_n^.NextComp(pComp, err);  {pointer to next component}
    if (err = 0) then begin        {not error, but maybe last comp.}
      hint := pComp^.hint;         {pick the type}
      if (IsWire(hint,pReTy)) then begin  {is it a relay}
        pComp^.GetNode(1,node,err1); {first node of the relay (second is the same)}
        pNodCod := pNodCod_n;
        if (node > 0) then begin
          inc(pNodCod,node-1);
          ctNode := pNodCod^;       {node in the "parallel" list, from the cross ref.list}
          pComp^.PutNode(1,ctNode,err); {node to relay}
          pComp^.PutNode(2,ctNode,err);
        end;
      end;
    end;
  end;
end;
*)
(*
procedure TNodeSet.ParalCurrTNodes(pCurTy : TpListBox);
{copy the index of the third node in current trafos from the cross reference list
 pCurTy  list of current trafo names}
var
  err,err1 : integer;   {error flag}
  ctNode   : integer;   {counter node of current trafo}
  hint     : string;    {the hint = type of the component}
  node     : integer;
  pComp    : TpComp;    {pointer to a component}
  pNodCod  : pInteger;  {pointer to the cross reference table}
begin
  pComp := nil;                    {initialize pointer to components}
  err := 0;                        {initialize error flag}
  while (err = 0) do begin         {to last component, or first error}
    pSet_n^.NextComp(pComp, err);  {pointer to next component}
    if (err = 0) then begin        {not error, but maybe last comp.}
      hint := pComp^.hint;         {pick the type}
      if (IsWire(hint,pCurTy)) then begin  {is it a current trafo}
        pComp^.GetNode(3,node,err1); {third node of the current trafo}
        pNodCod := pNodCod_n;
        if (node > 0) then begin
          inc(pNodCod,node-1);
          ctNode := pNodCod^;           {node in the "parallel" list, from the cross ref.list}
          pComp^.PutNode(3,ctNode,err); {node to relay}
        end;
      end;
    end;
  end;
end;
*)

procedure TNodeSet.ShowNoOfConnComp;
{display the number of components connected to each node}
var
  ii    : integer;
  pNC   : pInteger;
  pNode : TpIntri;
begin
  pNC := pNodCod_n;   {(mis)use this array for display}
  pNode := pNode_n;
  for ii:= 1 to mNode_n do begin  {copy to integer array}
    pNC^:= pNode^.no;
    inc(pNC);
    inc(pNode);
  end;
  showImat1(pNodCod_n,mNode_n,1);
end;


procedure TNodeSet.GetNodMem;
{get memory for the node array}
var
  ii      : integer;
  pNodCod : pInteger;
begin
  if (mNode_n >0) then begin
    getmem(pNode_n,mNode_n*Sizeof(Intri));     {get the memory, if needed}
    getmem(pNodCod_n,mNode_n*Sizeof(Integer)); {for node "codes"}
  end else begin
    pNode_n := nil;
    pNodCod_n := nil;
  end;
  {initialize the cross reference table}
  if (pNodCod_n <> nil) and (mNode_n > 0) then begin
    pNodCod := pNodCod_n;
    for ii := 1 to mNode_n do begin
      pNodCod^:= 1;                    {some value.....?}
      inc(pNodCod);
    end;
  end;
end;

procedure TNodeSet.FreeNodMem;
{get memory for the node array}
begin
  if (mNode_n >0) and (pNode_n <> nil) then begin
    freemem(pNode_n,mNode_n*Sizeof(Intri));     {free the memory}
    freemem(pNodCod_n,mNode_n*Sizeof(Integer)); {for node "codes"}
  end;
end;

procedure TNodeSet.FillNodeCompTable(pSet : TpCompSet; pWiLi : TpListBox);
{fill the table defining the connections of nodes and components
 pSet   pointer to the set of ...
 pWiLi  pointer to names of components considered as wires
 fill also list of components
 ---
 table has one row for each node
 the rows contain a number of 16-bit integers (words)
   if the bit i of word w is set on a row,
   then component number 16*(w-1)+i is connected to the node corresponding
   to this row}
var
  err    : integer;  {error flag}
  iComp  : integer;  {component index (number)}
  ii     : integer;  {index}
  ipu    : integer;  {temporary}
  ner    : integer;  {error flag}
  node   : integer;  {node index}
  nn     : integer;  {number of nodes}
  pComp  : TpComp;   {pointer to a component}
  pnW    : pInteger; {pointer to no of wires}
  pTable : pWord;    {pointer to the table}
  ppComp : TppComp;  {pointer to list of components}
begin
  if (pNodeComp_n <> nil) then begin
    ppComp := ppComp_n;
    pComp := nil;                    {initialize pointer to components}
    err := 0;                        {initialize error flag}
    iComp := 0;
    while (err = 0) do begin         {to last component, or first error}
      pSet_n^.NextComp(pComp, err);  {pointer to next component}
      if (err = 0) then begin        {not error, but maybe last comp.}
        ppComp^:= pComp;             {fill also list of components}
        inc(ppComp);
        inc(iComp);
(*      if (not IsWire(pComp^.hint,pWiLi)) then begin {wires not counted}*)
        pComp^.GetNnod(nn);          {get the number of nodes in this compon.}
        if (nn > 0) then begin
          for ii := 1 to nn do begin
            pComp^.GetNode(ii,node,ner);  {get node}
            if (node >= 0) and (node <= nNode_n) then begin
              pTable := pNodeComp_n;           {pointer to beginning of table}
              inc(pTable,node*nWrd_n);         {pointer to row of this node}
              ipu := iComp div 16;
              if (ipu * 16) = iComp then begin {comp.no 16, 32, 48 etc}
                inc(pTable,(ipu-1));           {pointer to the word of this comp}
                pTable^:= pTable^ or w16[16];  {set last bit}
              end else begin
                inc(pTable, ipu);
                pTable^ := pTable^ or w16[iComp-ipu*16]; {set bit}
              end;
            end;
          end;
        end;
(*      end else begin                  {is wire, count no of wires in nodes}*)
        if (IsWire(pComp^.hint,pWiLi)) then begin {count wires}
          pComp^.GetNode(1,node,ner);   {node to which wire connected}
          if (node >= 0) and (node <= nNode_n) then begin
            pnW := pNodeWire_n;         {pointer to list of no of wires}
            inc(pnW,node);
            inc(pnW^);                  {one more wire found}
          end;
        end;
      end;
    end;
  end;
end;

procedure TNodeSet.NumberConnectedToNode(node: integer; var nCnode : integer);
{calculate no of components connected to given node
 node   node under study
 nCnode no of components connected (including wires)}
var
  ii,iw     : integer;  {index}
  pTable    : pWord;    {pointer to the table}
begin
  nCnode := 0;                                     {initialize}
  if (pNodeComp_n <> nil) and                      {table exists}
     (node >= 0) and (node <= nNode_n)then begin   {reasonable node}
    pTable := pNodeComp_n;
    inc(pTable,node*nWrd_n);                       {row of this node}
    for iw := 1 to nWrd_n do begin                 {all words in this row}
      if (pTable^ <> 0) then begin                 {connections}
        for ii := 1 to 16 do begin
          if ((pTable^ and w16[ii]) <> 0) then inc(nCnode);
        end;
      end;
      inc(pTable);
    end;
  end;
end;

procedure TNodeSet.NumberConnectedToGround(var ncGround : integer);
{calculate no of components connected to ground}
var
  ii,iw     : integer;  {index}
  pTable : pWord;    {pointer to the table}
begin
  ncGround := 0;                       {initialize}
  if (pNodeComp_n <> nil) then begin   {table exists}
    pTable := pNodeComp_n;
    for iw := 1 to nWrd_n do begin     {all words in first (zeroth) row}
      if (pTable^ <> 0) then begin     {connections}
        for ii := 1 to 16 do begin
          if ((pTable^ and w16[ii]) <> 0) then inc(ncGround);
        end;
      end;
      inc(pTable);
    end;
  end;
end;

procedure TNodeSet.ConnectedToCurrTr(pCurT : TpComp; ppConCurT : TppComp;
                                  nConCurT, nnReal : integer);
{fill the list of all components connected to this current trafo
 pCurT      pointer to the current trafo
 ppConCurT  pointer to the list
 nConCurT   number of connected comp.
 nnReal     real number of nodes (in the whole network)}
var
  ii,iw  : integer;   {indices}
  nCCT   : integer;   {counts connected components}
  node   : integer;   {node nmber}
  ppCCT  : TppComp;   {local pointer to the list}
  ppComp : TppComp;   {pointer to list of components}
  pTable : pWord;     {table of connections}
begin
  node := pCurT^.int1_s;                 {node of current trafo}
  if (node >= 0) and (node <= nnReal) then begin
    ppComp := ppComp_n;                  {pointer to list of components}
    nCCT := 0;                           {initialize counter}
    ppCCT := ppConCurT;
    if (pNodeComp_n <> nil) then begin   {table exists}
      pTable := pNodeComp_n;             {pointer to the table}
      inc(pTable,node*nWrd_n);           {pointer to the row of this node}
      for iw := 1 to nWrd_n do begin     {all words in the row of this node}
        if (pTable^ <> 0) then begin     {connections}
          for ii := 1 to 16 do begin
            if ((pTable^ and w16[ii]) <> 0) then begin
              ppCCT^:= ppComp^;          {pointer to connected component}
              inc(ppCCT);
              inc(nCCT);
              if (nCCt >= nConCurT) then break;  {all found}
            end;
            inc(ppComp);
          end;
        end else begin
          inc(ppComp,16);                   {comp. of next word}
        end;
        inc(pTable);
        if (nCCT >= nConCurT) then break;   {all found}
      end;
    end;
  end;
end;

procedure TNodeSet.FindPowerStations(ipSet : longint; pWireTypes : TpListBox);
{find power stations = generator-transformer combinations, with no other
 components connected
 ipSet       pointer to the common, as integer
 pWireTypes  pointer to list of components taken as wires}
var
  err      : integer;     {error flag}
  GenList  : TList;       {list of pointers to generators}
  iConn    : integer;     {index of connected component}
  iGen     : integer;     {index of generator}
  ii,jj    : integer;     {index}
  ipComp   : longint;     {pointer to a component as integer}
  iw       : integer;     {index of words}
  ix,iy    : integer;     {coordinates}
  lbl      : string;      {label}
  name     : string;      {name (type) of a component}
  nConComp : integer;     {no of gen.connected to a trafo (not needed?)}
  nConn    : integer;     {no of other connected components}
  node     : integer;     {node index}
  nodeflg  : integer;     {flag for connected node (not needed ?)}
  pComp    : TpComp;      {pointer to a component}
  pConList : TpConList;   {list of generators connected to a trafo}
  pConL    : TpConList;   {local pointer to list of connected comp.}
  pConn    : TpComp;      {pointer to a connected component}
  ppComp   : TppComp;     {pointer to a list of component pointers}
  ppConn   : TppComp;     {pointer to a list of component pointers}
  pShort   : TpComp;      {pointer to a short circuit}
  pTrafo   : TpComp;      {pointer to a trafo}
  pSet     : TpCompSet;   {pointer to the common}
  pTable   : pWord;       {pointer to the "connection table"}
begin
if (ppComp_n <> nil) then begin
  pSet := TpCompSet(ipSet);              {pointer to the set from integer}
  {fill table : which components connecte to which nodes}
  GetTableMem;                           {memory for node - comp.table}
  GenList := TList.create;
  FillNodeCompTable(pSet,pWireTypes);    {fill the table}
  {initialize flag for power station}
  ppComp := ppComp_n;
  for ii := 1 to nComp_n do begin
    pComp := ppComp^;
    pComp^.SetPWR(false);
    inc(ppComp);
  end;
  {find generators, study if connected to only a trafo}
  ppComp := ppComp_n;
  for ii := 1 to nComp_n do begin
    GenList.clear;                 {initialize list of generators connected to the same node}
    pComp := ppComp^;
    {is it a generator, and not (yet) part of a power station}
    if IsGenerator(pComp) and not(pComp^.GetPWR) then begin
      pTrafo := nil;                                  {initialize}
      pShort := nil;
      nConn := 0;                                     {initialize}
      iGen := ii;                                     {save index}
      pComp^.GetNode(1,node,err);                     {output node}
      {find components connected to this node}
      if (node > 0) and (node <= nNode_n)then begin   {reasonable node}
        pTable := pNodeComp_n;
        inc(pTable,node*nWrd_n);                      {row of this node}
        for iw := 1 to nWrd_n do begin                {all words in this row}
          if (pTable^ <> 0) then begin                {connections}
            for jj := 1 to 16 do begin                {all bits in this word}
              if ((pTable^ and w16[jj]) <> 0) then begin  {a component connected}
                iConn := (iw-1)*16+jj;                {index of connected component}
                ppConn := ppComp_n;                   {pointer list}
                inc(ppConn,iConn-1);                  {pointer to connected component}
                pConn := ppConn^;
                pConn^.GetName(name);
                if (IsWire(pConn^.hint,pWireTypes)) then begin {wires not counted}
                  {do nothing}
                end else if (isGenerator(pConn)) then begin    {all generators saved}
                  GenList.add(pConn);
                end else if (isTrafo(pConn)) then begin  {transformer}
                  if (pTrafo = nil) then pTrafo := pConn {save first trafo}
                  else inc(nConn);                       {counted as "other"}
                end else if (name = gShort) then begin   {short circuit}
                  pShort := pConn;
                end else begin                           {check other components}
                  pConn^.GetName(name);
                  if (name = gPQRel) or (name = gBrkr) or
                     (name = gMeasZ) or (name = gIsolImp) or (name = gPolyg)  then begin
                    {do nothing}
                  end else begin                         {some other component}
                    inc(nConn);
{                   pConn^.GetLabel(lbl,ix,iy);}
{                   showmessage(name+'  '+lbl);}
                  end;
                end;
              end;
            end;
          end;
          inc(pTable);
        end;
      end;
      {is the generator part of of a power station}
      if (nConn = 0) and (pTrafo <> nil) and
         (GenList.count > 0) then begin   {one trafo, some generator(s), no other comp.}
        pTrafo^.SetPWR(true);             {trafo in power station}
        {several generators may be connected to one trafo, save them all}
        pTrafo^.CheckAndGetMemForConComp(GenList.count, 1);   {1 = guessed, not needed}
        pTrafo^.GetConData(pConList,nConComp,nodeflg);        {get data for connections}
        pConL := pConList;                                    {copy to local}
        {all generators in the list = parallel generators}
        for jj := 0 to GenList.count-1 do begin
          pComp := GenList[jj];
          pComp^.SetPWR(true);            {generator in power station}
          pComp^.PutParal(pTrafo);        {save pointer to the trafo}
          {add to list for the trafo}
          ipComp := longint(pComp);
          pConL^.ipComp:= longint(pComp); {add to list}
          pConL^.indx := 1;               {index of node: output (or downstream)}
          inc(pConL);
        end;
        if (pShort <> nil) then pShort^.SetPWR(true);  {short at the generator}
      end;
    end;
    inc(ppComp);
  end;
  GenList.free;
  FreeTableMem;
end;
end;

procedure TNodeSet.GetTableMem;
{get memory for table that shows wich components are connected to which node
 The table uses 16-bit words, where each bit corresponds to one component
 Get also memory for list of components
 and no of wires in each node}
var
  ii     : integer;
  ipu    : integer;
  nc     : integer;
  ppComp : TppComp;
  pInt   : pInteger;
  pW     : pWord;
begin
  if (nComp_n > 0) and (nNode_n > 0) then begin
    ipu := nComp_n div 16;
    if (ipu*16 = nComp_n) then nWrd_n := ipu
    else nWrd_n := ipu + 1;
    getmem(pNodeComp_n,nWrd_n*(nNode_n+1)*SizeOf(Word)); {ground included}
    getmem(pNodeWire_n,(nNode_n+1)*SizeOf(integer));
    {clear initially}
    pW := pNodeComp_n;
    nc := (nNode_n+1)*nWrd_n;
    for ii := 1 to nc do begin
      pW^ := 0;
      inc(pW);
    end;
    pInt := pNodeWire_n;
    for ii := 1 to nNode_n+1 do begin
      pInt^:= 0;
      inc(pInt);
    end;
    getmem(ppComp_n,nComp_n*sizeOf(TpComp));  {for list of components}
    ppComp := ppComp_n;
    for ii := 1 to nComp_n do begin
      ppComp^ := nil;
      inc(ppComp);
    end;
  end else begin
    pNodeComp_n := nil;
    ppComp_n := nil;
    pNodeWire_n := nil;
  end;
end;

procedure TNodeSet.FreeTableMem;

begin
  if (nNode_n > 0) and (nWrd_n > 0) and (pNodeComp_n <> nil) then begin
    freemem(pNodeComp_n,(nNode_n+1)*nWrd_n*SizeOf(Word));
    freemem(ppComp_n,nComp_n*sizeOf(TpComp));       {for list of components}
    freemem(pNodeWire_n,(nNode_n+1)*SizeOf(integer));
  end;
  pNodeComp_n := nil;
  ppComp_n := nil;
  pNodeWire_n := nil;
end;

procedure TWireSet.Initialize(ipCSet : Longint{; pWiLi : TpListBox});
{initialize
 ipCSet = pointer to the set of components, as integer,
( pWiLi  = text in .hint definign wire ) }
begin
  pCSet_w := TpCompSet(ipCset);
  pWire_w := nil;
  pConw_w := nil;
{ pWiLi_w := pWiLi;}
end;

procedure TWireSet.SetWireList(pWiLi : TpListBox);
{set pointer to the list of wire types used}
begin
  pWiLi_w := pWiLi;
end;

procedure TWireSet.GetWireMemory;
{reserve memory for arrays and matrices needed for wires}
begin
(*pConw_w := nil;
  pWire_w := nil;*)
  if (nMaxw_w > 0) then begin
    getmem(pWire_w,nMaxw_w*Sizeof(TWidat));          {reserve space for the array}
    getmem(pConw_w,nMaxw_w*nMaxw_w*Sizeof(Integer));
  end;
end;

procedure TWireSet.SetMaxNumberOfWires(maxnw :Integer);
{sets the max number of wires
 maxnw = max.no of wires, determines the size of memory reserved}
begin
  if (maxnw > 0) then nMaxw_w := maxnw
  else                nMaxw_w := 0;
end;

procedure TWireSet.SetNumberOfWires(nowi :Integer);
{sets the present number of wires
 nowi = no of wires (may be smaller than max number }
begin
  if (nowi > 0) then nWire_w := nowi
  else               nWire_w := 0;
end;



procedure TWireSet.ShowNoOfWires;
begin
  showmessage(inttostr(nWire_w));
end;

procedure TWireSet.ListOfWires(ppComp: TppComp; nComp: integer);
{ Fills an array of records for wire-components.
 Each record contains a pointer to the wire component, and
 the coordinates of its endpoints
 ppComp   pointer to an alternative list of components
 nComp    no of components in the alternative list of comp.
 ---
 If ppComp <> nil and nComp > 0, use the alternative list of components,
 else check all components}
var
  alter : boolean;   {if true, use alternative list}
  i     : Integer;   {index, or counter}
  ix,iy : Integer;   {coordinates of endpoints}
  iw    : integer;   {counts wires}
  n_err : Integer;   {error flag}
  nCmp  : integer;   {counter for components}
  nnod  : Integer;   {number of nodes = connecting points}
  pComp : TpComp;    {pointer to the components}
  pWire : TpWidat;   {pointer to wires}
  ppCmp : TppComp;   {local pointer to list of comp}
begin
  if (nWire_w > 0) then begin               {are there wires ?}
    alter := (ppComp <> nil) and (nComp > 0); {alternative list ?}
    pWire := pWire_w;                       {pointer to first wire record}
    for i:= 1 to nWire_w do begin           {initialize record for wires}
      pWire^.pWiCo := nil;
      pWire^.x1 := 0;
      pWire^.y1 := 0;
      pWire^.x2 := 0;
      pWire^.y2 := 0;
      inc(pWire);
    end;
    {start to check components}
    pComp := nil;                           {initialize pointer to components}
    pWire := pWire_w;                       {initialize pointer to wires}
    n_err := 0;                             {initialize error flag}
    iw := 0;                                {initialize wire counter}
    ppCmp := ppComp;                          {pointer to alternative list}
    nCmp := 0;
    while (n_err = 0) do begin
      if (not alter) then begin             {scan all components}
        pCSet_w^.NextComp(pComp,n_err);
      end else begin                        {use alternative list}
        pComp := ppCmp^;                    {get component}
        inc(nCmp);
        inc(ppCmp);                         {pointer to next}
        if (nCmp > nComp) then n_err := 1;  {done}
      end;
      if (pComp <> nil) and (n_err = 0) then begin
          pComp^.GetNnod(nnod);               {get number of nodes}
        if (IsWire(pComp^.hint,pWiLi_w)) and (nnod >= 2) then begin
                                              {is it a wire with two ends (at least)}
          pWire^.pWiCo := pComp;              {pointer to the wire}
          pComp^.GetNxy(1,ix,iy);             {get coordinates of first node}
          pWire^.x1 := ix;
          pWire^.y1 := iy;
          pComp^.GetNxy(2,ix,iy);             {get coordinates of second end}
          pWire^.x2 := ix;
          pWire^.y2 := iy;
          iw := iw+1;                         {increment wire counter}
          if (iw < nwire_w) then inc(pWire)   {pointer to next wire}
          else              break;            {no more wires}
        end else begin
          {do nothing with normal components}
        end;
      end;
    end;
  end else begin
    {do nothing, if no wires}
  end;
end;

procedure TWireSet.FreeListOfWires;
{free the memory reserved for the list of wires}
begin
  if (pWire_w <> nil) and (nWire_w > 0) then begin
    freemem(pWire_w,nMaxw_w*Sizeof(TWidat));  {free the space for the array}
  end;
end;

procedure TWireSet.ConnectWires;
{Constructs an Nwire*Nwire array showing the connections
 of wires to other wires.
 An one (or nozero) in location i,j indicates that wires i and j are connected
 pWire_w     a pointer to the array of wires + coordinates (in)
 nWire_w     number of wires (in)
 pConw_w     pointer to the array with the connections}
 {}
 var
   conn  : boolean;   {true, if wires connected}
   i,j,k : Integer;   {indices}
   iapu  : Integer;   {temporary}
   ij    : Integer;   {element i,j}
   ki,kj : Integer;   {element k,i; k,j}
   pij   : pInteger;  {pointer to element i,j in the connection array}
   pWire : TpWidat;   {pointer to a wire in the record of wires and coords.}
   pnWire: TpWidat;   {pointer to other wires}
   m1,n1 : Integer;   {coordinates of one end of the other wire}
   m2,n2 : Integer;   {coordinates of the other end of the other wire}
   x1,y1 : Integer;   {coordinates of one end of the wire}
   x2,y2 : Integer;   {coordinates of the other end of the wire}
 begin
 {reserve space for the array.
 {release it ...later...}
(* pConw_w := nil;*)
  if (nWire_w > 0) then begin             {reserve only if there are wires}
(*  getmem(pConw_w,nWire_w*nWire_w*Sizeof(Integer)); *)
    pij := pConw_w;                       {initialize pointer}
    for i:=1 to nWire_w do begin
      for j:=1 to nWire_w do begin
        pij^ := 0;                        {clear the array initially}
        inc(pij);                         {pointer to next location}
      end;
    end;
    {connections of each wire to other wires}
    pWire := pWire_w;                     {pointer to first wire}
    for i:=1 to nWire_w do begin          {scan all wires}
      x1 := pWire^.x1; y1 := pWire^.y1;   {coordinates of the}
      x2 := pWire^.x2; y2 := pWire^.y2;   {..the endpoints of the wire}
      pnWire := pWire;                    {initialize pointer to other wires}
      for j:= i to nWire_w do begin       {scan other wires, start at itself !}
        m1 := pnWire^.x1; n1:=pnWire^.y1; {coords. of one end}
        m2 := pnWire^.x2; n2:=pnWire^.y2; {coords. of the other end}
        {are the wires connected ?}
        if (y1 = y2) then begin                      {horizontal wire}
          if (pWire^.pWiCo^.StretchHoriz) then begin {not "broken" wire or curr.trafo}
            if (m1 = m2) then begin                  {the other is vertical}
              if (pnWire^.pWiCo^.StretchVertic) then begin {the other not "broken" or curr.trafo}
                if ((((x1 <= m1) and (x2 >= m1)) or ((x2 <= m1) and (x1 >= m1))) and
                     ((n1 <= y1) and (n2 >= y1)) or ((n2 <= y1) and (n1 >= y1)))
                then conn := true
                else conn := false;
              end else begin                         {the other is broken or trafo}
                if ((((x1 <= m1) and (x2 >= m1)) or ((x2 <= m1) and (x1 >= m1))) and
                     ((n1 = y1) or (n2 = y1)))
                then conn := true
                else conn := false;
              end
            end else begin                           {the other is horizontal}
              if (pnWire^.pWiCo^.StretchHoriz) then begin {the other not "broken" or curr.trafo}
                if  ((y1 = n1) and not
                   (((x1 < m1) and (x1 < m2) and (x2 < m1) and (x2 < m2)) or
                    ((x1 > m1) and (x1 > m2) and (x2 > m1) and (x2 > m2))))
                then conn := true
                else conn := false;
              end else begin                         {the other is broken or trafo}
                if ((y1 = n1) and not
                   (((x1 < m1) and (x1 < m2) and (x2 < m1) and (x2 < m2)) or
                    ((x1 > m1) and (x1 > m2) and (x2 > m1) and (x2 > m2))))
                then conn := true
                else conn := false;
              end
            end;
          end else begin                             {broken wire or curr.trafo}
            if (m1 = m2) then begin                  {the other is vertical}
              if (pnWire^.pWiCo^.StretchVertic) then begin {the other not "broken" or curr.trafo}
                if (((x1 = m1) or (x2 = m1)) and
                    (((y1 >= n1) and (y1 <= n2)) or ((y1 <= n1) and (y1 >= n2))))
                then conn := true
                else conn := false;
              end else begin                         {also the other is broken or trafo}
                if (((x1 = m1) or (x2 = m1)) and
                    ((y1 = n1) or (y1 = n2)))
                then conn := true
                else conn := false;
              end
            end else begin                           {the other is horizontal}
              if (pnWire^.pWiCo^.StretchHoriz) then begin {the other not "broken" or curr.trafo}
                if ((y1 = n1) and not
                    (((x1 < m1) and (x1 < m2) and (x2 < m1) and (x2 < m2)) or
                     ((x1 > m1) and (x1 > m2) and (x2 > m1) and (x2 > m2))))
{                   ( (((x1 >= m1) and (x1 <=m2)) or ((x1 <= m1) and (x1 >=m2))) or
                     (((x2 >= m1) and (x2 <=m2)) or ((x2 <= m1) and (x2 >=m2))))) }
                then conn := true
                else conn := false;
              end else begin                         {the other is broken or trafo}
                if ((y1 = n1) and
                    ((x1 = m1) or (x1 = m2) or (x2 = m1) or (x2 = m2)))
                then conn := true
                else conn := false;
              end
            end;
          end
        end else begin                               {vertical wire}
          if (pWire^.pWiCo^.StretchVertic) then begin {not "broken" wire or curr.trafo}
            if (n1 = n2) then begin                  {the other is horizontal}
              if (pnWire^.pWiCo^.StretchHoriz) then begin {the other not "broken" or curr.trafo}
                if ((((m1 <= x1) and (m2 >= x1)) or ((m2 <= x1) and (m1 >= x1))) and
                     ((y1 <= n1) and (y2 >= n1)) or ((y2 <= n1) and (y1 >= n1)))
                then conn := true
                else conn := false;
              end else begin                         {the other is broken or trafo}
                if (((x1 = m1) or (x1 = m2)) and
                    (((n1 >= y1) and (n1 <= y2)) or ((n1 <= y1) and (n1 >= y2))))
                then conn := true
                else conn := false;
              end
            end else begin                           {the other is vertical}
              if (pnWire^.pWiCo^.StretchVertic) then begin {the other not "broken" or curr.trafo}
                if ((x1 = m1) and not
                    (((y1 < n1) and (y1 < n2) and (y2 < n1) and (y2 < n2)) or
                     ((y1 > n1) and (y1 > n2) and (y2 > n1) and (y2 > n2))))
                then conn := true
                else conn := false;
              end else begin                         {the other is broken or trafo}
                if ((x1 = m1) and not
                    (((y1 < n1) and (y1 < n2) and (y2 < n1) and (y2 < n2)) or
                     ((y1 > n1) and (y1 > n2) and (y2 > n1) and (y2 > n2))))
                then conn := true
                else conn := false;
              end
            end;
          end else begin                             {broken wire or curr.trafo}
            if (n1 = n2) then begin                  {the other is horizontal}
              if (pnWire^.pWiCo^.StretchHoriz) then begin {the other not "broken" or curr.trafo}
                if (((y1 = n1) or (y2 = n1)) and
                    (((x1 >= m1) and (x1 <= m2)) or ((x1 <= m1) and (x1 >= m2))))
                then conn := true
                else conn := false;
              end else begin                         {also the other is broken or trafo}
                if (((y1 = n1) or (y2 = n1)) and
                    ((x1 = m1) or (x1 = m2)))
                then conn := true
                else conn := false;
              end
            end else begin                           {also the other is vertical}
              if (pnWire^.pWiCo^.StretchVertic) then begin {the other not "broken" or curr.trafo}
                if ((x1 = m1) and not
                   (((y1 < n1) and (y1 < n2) and (y2 < n1) and (y2 < n2)) or
                    ((y1 > n1) and (y1 > n2) and (y2 > n1) and (y2 > n2))))
                then conn := true
                else conn := false;
              end else begin                         {als the other is broken or trafo}
                if ((x1 = m1) and
                    ((y1 = n1) or (y1 = n2) or (y2 = n1) or (y2 = n2)))
                then conn := true
                else conn := false;
              end
            end;
          end;
        end;
(**)
(*
        {just to be sure, check crossed wires}
        if ((y1=y2) and (m1=m2)) and
           (pWire^.pWiCo^.StretchHoriz)  then begin  {not "broken" wire}
          if (((x1<m1) and (m1<x2)) or ((x2<m1) and (m1<x1))) and
             (((n1<y1) and (y1<n2)) or ((n2<y1) and (y1<n1))) then begin
             conn := true;
          end;
        end else if ((x1=x2) and (n1=n2)) and
          (pnWire^.pWiCo^.StretchHoriz)  then begin  {not "broken" wire}
          if (((y1<n1) and (n1<y2)) or ((y2<n1) and (n1<y1))) and
             (((m1<x1) and (x1<m2)) or ((m2<x1) and (x1<m1))) then begin
             conn := true;
          end;
        end;
*)
        {add contribution to the connection matrix}
        if (conn) then begin
          putImat(pConw_w,i,j,Nwire_w,Nwire_w,1);  {to location i,j}
          putImat(pConw_w,j,i,Nwire_w,Nwire_w,1);  {symmetric matrix}
        end;
        inc(pnWire);                     {next "other" wire}
      end;
      inc(pWire);                        {next wire}
    end;
    {complete the connection matrix by filling in the indirect connections}
    for i:=1 to nWire_w do begin          {line for line}
      for k:=1 to nWire_w do begin        {check other wires, also itself ?}
        getImat(pConw_w,k,i,nWire_w,nWire_w,ki);{element i on row k}
        if (ki <> 0) then begin         {connected}
          for j:=1 to nWire_w do begin    {connections on row}
            getImat(pConw_w,i,j,nWire_w,nWire_w,ij); {element i,j}
            getImat(pConw_w,k,j,nWire_w,nWire_w,kj); {element k,j}
            if (ij<>0) or (kj<>0) then iapu := 1
            else                       iapu := 0; {logical or = connection}
            putImat(pConw_w,k,j,nWire_w,nWire_w,iapu); {add connection}
          end;
        end;
      end;
    end;
  end;
(*
  for i:=1 to nWire_w do begin
    for j:=1 to nWire_w do begin
      getImat(pConw_w,i,j,nWire_w,nWire_w,ki);
      showmessage(inttostr(i)+' '+inttostr(j)+'    '+inttostr(ki));
    end;
  end;
*)
end;

procedure TWireSet.FreeConnectWires;
{releases the memory reserved for the array used in deducing the connections
 between wires}
begin
  if (pConw_w <> nil) then
    freemem(pConw_w,{nWire_w*nWire_w}nMaxw_w*nMaxw_w*Sizeof(Integer));
end;


procedure TWireSet.ConnectedToWires(xx,yy: Integer;
                                    var WireNo, NodeNo: Integer);
{finds out, is the point with coordinates xx,yy connected to some wire.
 If it is, WireNo gets the Id-number of the wire
 xx,yy   the coordinates of the node (in)
 WireNo  the Id-number of the wire to which the compopnent is connected to
         (WireNo = i, if the wire is the i:th wire in array pWire_w
 NodeNo  the id number of the node the wire is connected to
 }
 var
   err   : Integer; {error flag}
   i     : Integer; {index, or counter}
   pWire : TpWidat; {pointer to a wire}
   x1,y1 : Integer; {coordinates of one end of the wire}
   x2,y2 : Integer; {coordinates of the other end of the wire}
 begin
   if (nWire_w > 0) then begin           {are there wires}
     pWire := pWire_w;                   {pointer to first wire}
     for i:=1 to nWire_w do begin        {scan all wires}
       x1 := pWire^.x1; y1 := pWire^.y1; {cooridnates of one end of the wire}
       x2 := pWire^.x2; y2 := pWire^.y2; {coordinates of the other end}
       {check is the wire connected to the node}
       if  ((y1 =y2) and (yy = y1) and (pWire^.pWiCo^.StretchHoriz) and  {"normal" wire}
          (((x1<=xx) and (xx<=x2)) or ((x1>=xx) and (xx>=x2)))) {horizontal wire}
       or
           ((y1 =y2) and (yy = y1) and not(pWire^.pWiCo^.StretchHoriz) and {"broken" wire}
           ((x1=xx) or (xx=x2)))                                {horizontal wire}
       or
           ((x1 =x2) and (xx = x1) and (pWire^.pWiCo^.StretchVertic) and  {"normal" wire}
          (((y1<=yy) and (yy<=y2)) or ((y1>=yy) and (yy>=y2)))) {vertical line}
       or
           ((x1 =x2) and (xx = x1) and not(pWire^.pWiCo^.StretchVertic) and  {"broken" wire}
           ((y1=yy) or (yy=y2)))
       then begin
         WireNo := i;              {wire to which connected}
         pWire^.pWico^.GetNode(1,NodeNo,err); {get node number, if any}
         if (err <> 0) then NodeNo := -1;
         break;                    {one is enough}
       end else begin
         WireNo := 0;
         NodeNo := -1;
       end;
      inc(pWire);                   {pointer to next wire}
     end;
   end else begin
     WireNo := 0;                {no wires, no connection}
     NodeNo := -1;               {no nodes either}
   end;
 end;

procedure TWireSet.WiresAsNodes(WireNo, NodeNo: Integer);
{gives the node number to the nodes of wires connected to the given node
 WireNo    wire number to which the node is connected
 NodeNo    number of the node that is connected to the wire
 }
 var
   i      : Integer;  {index, or counter}
   iapu   : Integer;  {temporary}
   n_err  : Integer;  {error flag}
   pWire  : TpWidat;   {pointer to wire}
 begin
   if (nWire_w > 0) then begin      {are there wires ?}
     pWire := pWire_w;              {pointer to first wire}
     for i:=1 to nWire_w do begin   {scan all connections to other wires}
       getImat(pConw_w,WireNo,i,nWire_w,nWire_w,iapu);{get connection indicator}
       if (iapu > 0) then begin     {nonzero indicates connection}
         pWire^.pWiCo^.PutNode(1,NodeNo,n_err); {node id to first conn.point}
         pWire^.pWiCo^.PutNode(2,NodeNo,n_err); {node id to second conn.point}
       end;
       inc(pWire);                  {pointer to next wire}
     end;
   end;
 end;

{***************** procedures for TVoltNode ****************************}

constructor TVoltComp.Create(ipNodeSet: longint);
{ipNodeSet   pointer to the set of nodes, etc, as integer}
var
  ii        : integer;    {index}
  pLineNod  : pInteger;   {pointer to elements in array for nodes}
  pNodeSet  : TpNodeSet;  {pointer to the set of nodes etc.}
  pSourceLev: TpDuo;      {pointer to source voltage levels}
  pVoltLev  : TpDuo;      {pointer to voltage levels}
begin
  inherited Create;     {create the object, do the basic operations}
  pNodeSet := TpNodeSet(ipNodeSet);  {pointer to set of nodes}
  nNode_v := pNodeSet^.nNode_n;
  pSet_v := pNodeSet^.pSet_n;
  pWiLi_v := pNodeSet^.pWiLi_n;    {list of wire types}
  nTrafos_v := 0;                  {initialize = clear initially}
  unreal_v := 1.e4;                {unreasonable phase shift, for flag}
  {get memory for array for counting no of components connected
   to a given node}
  if (nNode_v > 0) then begin
    getmem(pNrPtr_v,nNode_v*Sizeof(TNrPtr));
    ClearNumberAndPointer;   {clear the array initially}
    NodesAndComp(count);  {count no of components connected to nodes, save}
    GetMemoryForPointerArrays;
    getmem(pVoltLev_v,nNode_v*SizeOf(Tduo));     {for voltage levels}
    getmem(pSourceLev_v,nNode_v*SizeOf(Tduo));   {for source voltage levels}
    getmem(pLineNod_v,nNode_v*SizeOf(integer));  {for tr.line nodes}
    getmem(pNodeVolt_v,nNode_v*SizeOf(Tduo));    {for voltages of nodes}
    pSourceLev := pSourceLev_v;
    pVoltLev := pVoltLev_v;
    pLineNod := pLineNod_v;
    for ii := 1 to nNode_v do begin
      pVoltLev^.x := 0;
      pVoltLev^.y := 0;
      inc(pVoltLev);
      pLineNod^ := 0;
      inc(pLineNod);
      pSourceLev^.x:= 0;
      pSourceLev^.y := 0;
      inc(pSourceLev);
    end;
  end else begin
    pNrPtr_v := nil;
  end;
  {get memory for arrays of trafos. Needed for the determination of relative phase}
  if (nTrafos_v > 0) then begin                  {are there trafos}
    getmem(ppTrafos_v,nTrafos_v*sizeof(TpComp));
  end else begin
    ppTrafos_v := nil;
  end;

end;

destructor  TVoltComp.destroy;
begin
  if (nNode_v > 0) then begin
    FreeMemoryForPointerArrays;
    freemem(pNrPtr_v,nNode_v*Sizeof(TNrPtr));
    freemem(pSourceLev_v,nNode_v*SizeOf(Tduo));
    freemem(pVoltLev_v,nNode_v*SizeOf(Tduo));
    freemem(pLineNod_v,nNode_v*SizeOf(integer));
    freemem(pNodeVolt_v,nNode_v*SizeOf(Tduo));
  end;
  if (nTrafos_v > 0) then begin                  {are there trafos}
    freemem(ppTrafos_v,nTrafos_v*sizeof(TpComp));
  end;
  inherited Destroy;
end;

procedure TVoltComp.ClearNumberAndPointer;
{clear array for number of components connected to nodes}
var
  ii     : integer;
  pNrPtr : TpNrPtr;
begin
  if (pNrPtr_v <> nil) and (nNode_v > 0) then begin
    pNrPtr := pNrPtr_v;
    for ii := 1 to nNode_v do begin
      pNrPtr^.No := 0;
      pNrPtr^.ppC := nil;
      pNrPtr^.new := false;
      pNrPtr^.ready := false;
      pNrPtr^.voltnr := 0;
      pNrPtr^.VoltLev.x := 0;
      pNrPtr^.VoltLev.y := 0;
      inc(pNrPtr);
    end;
  end;
end;

procedure TVoltComp.NodesAndComp(oper: NodeOper);
{for each node, count components connected to the node
 and count no of transformators}
var
  c_err      : integer;  {error flag}
  ii,jj      : integer;  {index}
  nn         : integer;  {number of nodes in one component}
  node       : integer;  {node number, or ID}
  n_err      : integer;  {error flag}
  pComp      : TpComp;   {pointer to a component}
  ppComp,ppC : TppComp;  {pointer to component pointer}
  ppTrafo    : TppComp;  {pointer to array of pointers to trafos}
  pNrPtr     : TpNrPtr;  {pointer nr and to pointer to pointer of comp}

begin
  {scan all components, count no of components connected to nodes}
  c_err := 0;                      {initialize error flag}
  pComp := nil;
  ppTrafo := ppTrafos_v;
  while (c_err = 0) do begin       {to last component, or first error}
    pSet_v^.NextComp(pComp, c_err);{pointer to next component}
    if (c_err = 0) then begin      {not error, but maybe last comp.}
      pComp^.GetNnod(nn);          {get the number of nodes in this comp.}
      pComp^.PutVoltLev(0);        {initialize the voltage level}
      pComp^.PutSystLev(0);
      pComp^.var1_s := 0;          {initialize temp. variables, used as flags}
      pComp^.var2_s := 0;
      {has the component nodes, and is the component a proper comp., not a wire}
      if ((nn > 0) and not(IsWire(pComp^.hint,pWiLi_v))) then begin
        for ii:=1 to nn do begin   {scan all nodes}
          pComp^.GetNode(ii,node,n_err);  {get the number (ID) of node ii}
          if ((node > 0) and (node <= nNode_v)) then begin {reasonable node}
            pNrPtr := pNrPtr_v;           {initialize pointer}
            inc(pNrPtr,node-1);
            {action depends on phase of work}
            if (oper = count) then begin  {count components}
              inc(pNrPtr^.No);            {increment count of nodes}
            end else begin                {fill arrays for components}
              ppComp := pNrPtr^.ppC;      {pointer to first element in array}
              if (pNrPtr^.No > 1) then begin
                ppC := pNrPtr^.ppC; inc(ppC); {pointer to second element}
                for jj := 1 to pNrPtr^.No-1 do begin  {pull array down}
                  ppComp^:= ppC^;
                  inc(ppComp);
                  inc(ppC);
                end;
              end;
              ppComp^:= pComp;            {new component as last entry}
            end;
          end;
        end;
      end;
      {count no of transformators or fill the array with pointers}
      if (IsTrafo(pComp)) then begin
        if (oper = count) then begin
          inc(nTrafos_v);
        end else if (oper = fill) then begin {fill the array with pointers to trafos}
          ppTrafo^:= pComp;
          inc(ppTrafo);
        end;
      end;
    end;
  end;

(*
  {test...show the number of components in a given node}
  showmessage(inttostr(nNode_v)+'  nodes');
  pNrPtr := pNrPtr_v;
  for ii:= 1 to nNode_v do begin
    nn := pNrPtr^.No;
    inc(pNrPtr);
    showmessage(inttostr(ii)+'  '+inttostr(nn));
  end;
*)
end;

procedure TVoltComp.CheckArrays;
{check the arrays of the component pointers}
var
  ii,jj  : integer;
  ix,iy  : integer;
  line   : string;
  name   : string;
  pNrPtr : TpNrPtr;
  pComp  : TpComp;
  ppComp : TppComp;
begin
  pNrPtr := pNrPtr_v;
  for ii:=1 to nNode_v do begin
    line := '';
    ppComp := pNrPtr^.ppC;
    for jj:=1 to pNrPtr^.No do begin
      pComp := ppComp^;
      pComp^.GetLabel(name,ix,iy);
      line := line+name+'  ';
      inc(ppComp);
    end;
    showmessage(line);
    inc(pNrPtr);
  end;
end;

procedure TVoltComp.GetMemoryForPointerArrays;
{get memory for the small arrays containing pointers to the components
 connected to  the same node}
var
  ii     : integer;  {indices}
  pNrPtr : TpNrPtr;  {pointer numbers and to array of pointer arrays}
begin
  if (pNrPtr_v <> nil) and (nNode_v > 0) then begin
    pNrPtr := pNrPtr_v;
    for ii :=1 to nNode_v do begin        {all nodes}
      if (pNrPtr^.No > 0) then begin      {any components connected ? should be}
        getmem(pNrPtr^.ppC,pNrPtr^.No*SizeOf(TpComp));
        inc(pNrPtr);
      end else begin
        pNrPtr^.ppC := nil;
      end;
    end;
  end;
end;

procedure TVoltComp.FreeMemoryForPointerArrays;
{get memory for the small arrays containing pointers to the components
 connected to  the same node}
var
  ii     : integer;  {indices}
  pNrPtr : TpNrPtr;  {pointer numbers and to array of pointer arrays}
begin
  if (pNrPtr_v <> nil) and (nNode_v > 0) then begin
    pNrPtr := pNrPtr_v;
    for ii :=1 to nNode_v do begin        {all nodes}
      if (pNrPtr^.No > 0) then begin      {any components connected ? should be}
        freemem(pNrPtr^.ppC,pNrPtr^.No*SizeOf(TpComp));
        inc(pNrPtr);
      end;
    end;
  end;
end;

procedure TVoltComp.MarkOtherTrafoNodes(pComp: TpComp);
{mark the "current nodes" of a trafo unless already marked (?)
 TpComp  pointer to the trafo}
var
  n_err : integer;  {error flag}
  kk    : integer;  {index}
  node  : integer;  {the ID (number) of the node}
  nn    : integer;  {no of nodes}
  pNP   : TpNrPtr;  {pointer to array for...}
begin
  pComp^.GetNnod(nn);              {get the number of nodes in this comp.}
  for kk := 3 to nn do begin
    pComp^.GetNode(kk,node,n_err);   {find node ID}
    if (node > 0) and (node <= nNode_v) then begin
      pNP := pNrPtr_v;
      inc(pNP,node-1);
      if (not pNP^.ready) then begin
        pNP^.ready := true;            {"current node" ready,not connected}
        pNP^.voltnr := voltnr_v;       {voltage identification}
      end;
    end;
  end;
end;

procedure VoltageIndices(hint : string; var nV1,nV2 : integer);
{get the indices for the system voltages of a trafo
 hint     the hint text = type of the component
 nV1,nV2  indices for prim. and sec. voltages}
begin
  if          (hint = 'Transformator'    ) then begin
    nV1 := gYY_Vs1;
    nV2 := gYY_Vs2;
  end else if (hint = 'Transformator Y D') then begin
    nV1 := gYD_Vs1;
    nV2 := gYD_Vs2;
  end else if (hint = 'Transformator D Y') then begin
    nV1 := gDY_Vs1;
    nV2 := gDY_Vs2;
  end else if (hint = 'Transformator D D') then begin
    nV1 := gDD_Vs1;
    nV2 := gDD_Vs2;
  end else begin
    nV1 := 0;
    nV2 := 0;
  end;
end;

procedure TVoltComp.Trafo(pComp: TpComp);
{handle the trafo when checking voltage levels:
  save the voltage, mark "current" nodes ready
  pComp   pointer to the trafo
}
var
  apu     : single;   {temporary}
  node    : integer;  {node of the trafo}
  nV1,nV2 : integer;  {index for voltages}
  n_err   : integer;  {error flag}
  pVoltLev: TpDuo;    {pointer to voltage levels}
  VoltLev : Tduo;     {the voltage of the trafo winding}
begin
  pVoltLev := pVoltLev_v;
  inc(pVoltLev,voltnr_v-1);        {pointer to the voltage level of this node}
  {indices for reading system voltages }
  VoltageIndices(pComp^.hint, nV1,nV2);
  {must check which node, prim. or sec ! for the voltage}
  pComp^.GetNode(1,node,n_err);       {first node}
  if (node = nodeID_v) then begin     {this node is the first trafo node}
    pComp^.GetPar(gTrafo_V1,VoltLev.x);       {prim.voltage}
    {read also system voltage}
    if (nV1 > 0) then begin
      pComp^.GetPar(nV1,apu);
      if (apu > 0) then VoltLev.y := apu
      else              VoltLev.y := VoltLev.x;  {if not defined, use trafo voltage}
    end else begin     {error case}
      VoltLev.y := VoltLev.x;  {if not defined, use trafo voltage}
    end;
  end else begin
    pComp^.GetPar(gTrafo_V2,VoltLev.x);       {secondary voltage}
    {read also system voltage}
    if (nV2 > 0) then begin
      pComp^.GetPar(nV2,apu);
      if (apu > 0) then VoltLev.y := apu
      else              VoltLev.y := VoltLev.x;  {if not defined, use trafo voltage}
    end else begin     {error case}
      VoltLev.y := VoltLev.x;  {if not defined, use trafo voltage}
    end;
  end;
  {save the voltage as voltage of the volt.levels, copied later to comp}
  if (pVoltLev^.x <= 0) then begin
    pVoltLev^ := VoltLev;
  end else begin
    {if already defined, check, are the voltages the same}
    apu := (pVoltLev^.x - VoltLev.x)/pVoltLev^.x;
    if (abs(apu) > 0.01) and not(Imagoo.IECbut.down) then
      show_message('inconsistent voltages in node  '+inttostr(nodeID_v));
  end;
  {mark only the "current nodes" unless already marked (?)}
  MarkOtherTrafoNodes(pComp);
end;

procedure TVoltComp.Source(pComp: TpComp);
{handle the generator or feeder when checking source voltage levels:
  save the voltage
  pComp   pointer to the gen. or feeder
}
var
  apu        : single;
  pSourceLev : TpDuo;  {pointer to source voltage level}
  SourceLev  : Tduo;   {the voltage of source}
begin
  pSourceLev := pSourceLev_v;
  inc(pSourceLev,sourcenr_v-1);
  {get voltage, generator or feeder}
  if (IsGenerator(pComp)) then begin
    pComp^.GetPar(gGen_Vn,SourceLev.x);     {generator}
    pComp^.GetPar(gGen_Vs,apu);             {network voltage}
    if (apu > 0) then SourceLev.y := apu
    else SourceLev.y := SourceLev.x;
  end else begin
    pComp^.GetPar(gFeed_V,SourceLev.x);     {feeder}
    if (SourceLev.x < 1) then SourceLev.x := 1;
    SourceLev.y := SourceLev.x;             {same voltage in network}
  end;
  {save the voltage as voltage of the volt.levels, copied later to comp}
  if (pSourceLev^.x <= 0) then begin
    pSourceLev^:= SourceLev;
  end else begin
    {if already defined, check, are the voltages the same}
{   apu := (pVoltLev^ - VoltLev)/pVoltLev^;
    if (abs(apu) > 0.01) then
      show_message('inconsistent voltages in node  '+inttostr(nodeID_v));}
  end;
  {mark only the "current nodes" unless already marked (?)}
{  MarkOtherTrafoNodes(pComp);}
end;

procedure TVoltComp.TLine(pComp: TpComp);
{handle the transmission line when checking which line the component is
  connected to:
  save a reference to the node
  pComp   pointer to the line
}
var
  pLineNod: pInteger; {pointer to tr.line node}
begin
  pLineNod := pLineNod_v;
  inc(pLineNod,voltnr_v-1);               {pointer to the line node of this node}
  if (not LineFound_v) then begin         {is this first tr. line for this node}
    pLineNod^ := nodeID_v;                {save the node ID}
    LineFound_v := true;                  {set flag that line found}
  end;
end;

function IsGenerator(pComp : TpComp): boolean;
{true, if the component is a generator or a feeder}
begin
  IsGenerator := (pComp^.hint = 'Generator');
end;

function IsSource(pComp : TpComp): boolean;
{true, if the component is a generator or a feeder}
begin
  IsSource := (pComp^.hint = 'Generator') or
              (pComp^.hint = 'Feeder');
end;

function IsTrafo(pComp : TpComp): boolean;
{true, if the component is a transformator}
begin
  IsTrafo := (pComp^.hint = 'Transformator'    ) or
             (pComp^.hint = 'Transformator Y D') or
             (pComp^.hint = 'Transformator D Y') or
             (pComp^.hint = 'Transformator D D');
end;

function IsTLine(pComp : TpComp): boolean;
{true, if the component is a transmission line, or a trafo}
begin
  IsTLine := (pComp^.hint = 'Transmission line/km');
end;

function IsTLineOrTrafo(pComp : TpComp): boolean;
{true, if the component is a transmission line, or a trafo}
begin
  IsTLineOrTrafo := IsTLine(pComp) or IsTrafo(pComp);
end;

function IsSourceOrTrafo(pComp : TpComp): boolean;
{true, if the component is a generator, feeder, or a trafo}
begin
  IsSourceOrTrafo := IsSource(pComp) or IsTrafo(pComp);
end;

procedure TVoltComp.FindConnections(Ncomp : integer; ppComp : TppComp;
                                    var new : boolean; IsSpecial: TBoolCompFunc);
{find nodes that are connected to the given node through one component
 mark the nodes, and give then the corresponding "voltage index"
 Ncomp   no of components connected to the node
 ppComp  pointer to the array of component pointers, connected to this node
 new     indicates that a new connected node was found
 IsSpecial function for checking, is the component of a given, special type
}
var
  jj,kk   : integer;  {index}
  node    : integer;  {node ID (number)}
  nn      : integer;  {number of nodes}
  n_err   : integer;  {error flag}
  pComp   : TpComp;   {pointer to a component}
  ppC     : TppComp;  {pointer to array of component pointers}
  pNP     : TpNrPtr;  {pointer to array for...}
begin
  ppC := ppComp;
  if (Ncomp > 0) then begin
    for jj := 1 to Ncomp do begin    {scan all components in this node}
      pComp := ppC^;                 {pointer to a component in this node}
      {check, is the component already known}
      if (pComp^.var1_s <= 0) then begin       {var1_s used as a flag}
        {comp. of given types handled differently (trafo, tr.line)}
        if (IsSpecial(pComp)) then begin
          {actions depend on the "special" component type}
          if (@IsSpecial = @IsSourceOrTrafo) then begin
            if (IsTrafo(pComp)) then Trafo(pComp) {save voltage levels, etc}
            else                     Source(pComp);
          end else if (@IsSpecial = @IsTLineOrTrafo) then begin
            if (IsTLine(pComp)) then TLine(pComp)  {save node, eventually}
            else if (IsTrafo(pComp)) then MarkOtherTrafoNodes(pComp);
          end;
          {mark the component, but only after both ends are treated}
          if (pComp^.var2_s <= 0) then begin
            pComp^.var2_s := voltnr_v;
            pComp^.var4_s := nodeID_v;     {save also the node}
          end else begin
            pComp^.var1_s := voltnr_v;
            pComp^.var3_s := nodeID_v;
            pComp^.var5_s := sourcenr_v;
          end;
        end else begin                     {"normal" component, not a trafo, or..}
          pComp^.GetNnod(nn);              {get the number of nodes in this comp.}
          for kk:=1 to nn do begin         {scan all nodes}
            pComp^.GetNode(kk,node,n_err); {get the number (ID) of node}
            pNP := pNrPtr_v;
            if (node > 0) and (node <= nNode_v) then begin
              inc(pNP,node-1);               {this node in the array}
              if ((not pNP^.ready) and (not pNP^.new)) then begin
                pNp^.new := true;            {mark this node as new}
                pNP^.voltnr := voltnr_v;     {ID for voltage level}
                pNP^.sourcenr := sourcenr_v;
                new := true;                 {a new connected node found}
              end;
            end;
          end;
          pComp^.var1_s := voltnr_v;       { mark the component}
          pComp^.var5_s := sourcenr_v;     { mark the component}
        end;
      end;
      inc(ppC);
    end;
  end;
end;

procedure TVoltComp.ConnectionsOfNodes(IsSpecial: TBoolCompFunc);
{ search the components of given type, to which the nodes are connected
  either directly, or through other components.
  This is needed for the determination of nominal voltage levels
  defined by transformators to which the nodes are connected,
  or for the determination of the transmission line ends, to
  which the components (and nodes) are connected
  and maybe for more..?
  IsSpecial   function for looking for the components of the given type
              that determine the voltage level, or ...}
var
  c_err    : integer;  {error flag}
  ii,jj    : integer;
  nComp    : integer;  {no of components connected to a node}
  new      : boolean;  {indicates that a new connected node was found}
  ppComp   : TppComp;  {pointer to array of component pointers}
  pComp    : TpComp;   {pointer to a component}
  pNrPtr   : TpNrPtr;  {pointer no of comp, comp.pointers, etc}
  pNP      : TpNrPtr;  {another similar pointer}

begin
  {initialize}
  pComp := nil;
  c_err := 0;
  while (c_err = 0) do begin       {to last component, or first error}
    pSet_v^.NextComp(pComp, c_err);{pointer to next component}
    if (c_err = 0) then begin      {not error, but maybe last comp.}
      pComp^.var1_s := 0;          {initialize temp. variables, used as flags}
      pComp^.var2_s := 0;
      pComp^.var3_s := 0;
      pComp^.var4_s := 0;
      pComp^.var5_s := 0;
    end;
  end;
  {clear flags etc}
  if (pNrPtr_v <> nil) and (nNode_v > 0) then begin
    pNrPtr := pNrPtr_v;
    for ii := 1 to nNode_v do begin
      pNrPtr^.new := false;
      pNrPtr^.ready := false;
      pNrPtr^.voltnr := 0;
      inc(pNrPtr);
    end;
  end;
  {start to check the nodes}
  if (nNode_v > 0) and (pNrPtr_v <> nil) then begin  {there are nodes etc}
    pNrPtr := pNrPtr_v;
    voltnr_v := 0;
    sourcenr_v := 0;
    LineFound_v := false;            {Line not yet found, repeat later}
    {scan all nodes, several times}
    for ii:=1 to nNode_v do begin
      {scan all components connected to this node, unless already ready}
      if (not pNrPtr^.ready) then begin
        inc(voltnr_v);               {next voltage ID}
        inc(sourcenr_v);
        LineFound_v := false;        {initialize}
        pNrPtr^.voltnr := voltnr_v;  {this node takes the voltage ID}
        pNrPtr^.sourcenr := sourcenr_v; {this node takes the source voltage ID}
        ppComp := pNrPtr^.ppC;       {pointer to first comp. pointer}
        nComp := pNrPtr^.No;         {number of components}
        pNrPtr^.ready := true;       {mark this node ready = comp's scanned}
        if (nComp > 0) then begin
          {find nodes connected to this node through one component}
          nodeID_v := ii;            {pass the nodeID to the proc. (see below)}
          FindConnections(Ncomp, ppComp, new, IsSpecial);
          {repeatedly, find nodes connected to "new" nodes through one component}
          while(new) do begin
            new := false;                 {initialize}
            if (ii < nNode_v) then begin  {not the last node}
              pNP := pNrPtr_v;
              inc(pNP,ii);
              for jj := ii+1 to nNode_v do begin
                if ((pNP^.new) and (not pNP^.ready)) then begin
                  pNP^.voltnr := voltnr_v;{this node takes the voltage ID}
                  ppComp := pNP^.ppC;     {pointer to first comp. pointer}
                  nComp := pNP^.No;       {number of components}
                  nodeID_v := jj;         {pass the nodeID to the procedure}
                  FindConnections(Ncomp, ppComp,new,IsSpecial);
                  pNP^.ready := true;     {mark this node ready = comp's scanned}
                end;
                inc(pNP);
              end;
            end;
          end;
        end else begin
          pNrPtr^.ready := true;     {mark this node ready}
        end;
      end;
      inc(pNrPtr);  {next node}
    end;
  end;
end;

procedure TVoltComp.VoltagesOfComponents;
{copy the voltage levels from nodes to components}
var
  c_err      : integer;  {error flag}
  pComp      : TpComp;   {pointer to a component}
  pSourceLev : TpDuo;    {pointer to array of source voltage levels}
  pVoltLev   : TpDuo;    {pointer to array of voltage levels}
  SourceNod  : integer;  {the ID of source voltage level}
  VoltNod    : integer;  {the ID of the voltage level }
begin
  {scan all components, count no of components connected to nodes}
  c_err := 0;                         {initialize error flag}
  pComp := nil;
  while (c_err = 0) do begin          {to last component, or first error}
    pSet_v^.NextComp(pComp, c_err);   {pointer to next component}
    if (c_err = 0) then begin         {not error, but maybe last comp.}
      VoltNod := round(pComp^.var1_s);
      pVoltLev := pVoltLev_v;         {pointer to array of voltages}
      SourceNod := round(pComp^.var5_s);
      pSourceLev := pSourceLev_v;
      if (VoltNod > 0) and (VoltNod <= nNode_v) then begin
        inc(pVoltLev,VoltNod-1);        {pointer to voltage of this node}
        if (pVoltLev^.x <> 0) then begin
          pComp^.PutVoltLev(pVoltLev^.x); {put the voltage level to the component}
          pComp^.PutSystLev(pVoltLev^.y); {put the system voltage level to the component}
        end else begin                  {not reasonable, try source voltage}
          if (SourceNod > 0) and (SourceNod <= nNode_v) then begin
            inc(pSourceLev,SourceNod-1);
            pComp^.putVoltLev(pSourceLev^.x); {source level to component}
            pComp^.putSystLev(pSourceLev^.y); {source (system)level to component}
          end;
        end;
      end else begin                  {voltage level not known, try source level}
        if (SourceNod > 0) and (SourceNod <= nNode_v) then begin
          inc(pSourceLev,SourceNod-1);
          pComp^.putVoltLev(pSourceLev^.x); {source level to component}
          pComp^.putSystLev(pSourceLev^.y); {ssystem level to component}
        end;
      end;
    end;
  end;
end;

procedure TVoltComp.BusVoltages;
{determine the voltages of buses}
var
  apu     : single;     {temporary}
  err     : integer;    {eror flag}
  errc    : integer;    {error flag}
  jj      : integer;    {index}
  name    : string;     {name (type) of the component}
  nch     : integer;    {no of nodes to ceck}
  node    : integer;    {node of a component}
  nnod    : integer;    {no of nodes}
  nV1,nV2 : integer;    {indices for system voltages}
  pComp   : TpComp;     {pointer to a component}
  pVolt   : TpDuo;      {pointer to voltage of node}
  sVolt   : single;     {system voltage level}
  Volt    : single;     {the voltage of a component}
  Vs1,Vs2 : single;     {prim.sec. system voltages}
  V1,V2   : single;     {prim,sec.voltage}
begin
  {clear the voltage array}
  pVolt := pNodeVolt_v;
  for jj := 1 to nNode_v do begin
    pVolt^.x:= 0;
    pVolt^.y:= 0;
    inc(pVolt);
  end;
  {scan all components and collect voltages to an array}
  errc := 0;                         {initialize error flag}
  pComp := nil;
  {first, fill the pNodeVolt array with voltages}
  while (errc = 0) do begin          {to last component, or first error}
    pSet_v^.NextComp(pComp, errc);   {pointer to next component}
    if (errc = 0) then begin         {not error, but maybe last comp.}
      if (isTrafo(pComp)) then begin {trafos differently} {but 3-winding?}
        VoltageIndices(pComp^.hint, nV1,nV2);    {indices for the system voltages}
        {prim.voltage}
        pComp^.GetNode(1,node,err);  {prim.node}
        pComp^.GetPar(gTrafo_V1,V1); {prim.voltage}
        {prim.system voltage}
        if (nV1 > 0) then begin
          pComp^.GetPar(nV1,apu);
          if (apu > 0) then Vs1 := apu else Vs1 := V1;
        end else begin
          Vs1 := V1;
        end;
        {put to voltage array}
        if (node > 0) and (node <= nnode_v) and (V1 > 0) then begin
          pVolt := pNodeVolt_v;
          inc(pVolt,node-1);
          pVolt^.x := V1;             {add voltage to the list (but if aready done?)}
          pVolt^.y := Vs1;            {system voltage}
        end;
        {sec. voltage}
        pComp^.GetNode(2,node,err);    {sec.node}
        pComp^.GetPar(gTrafo_V2,V2);   {sec.voltage}
        {sec.system voltage}
        if (nV2 > 0) then begin
          pComp^.GetPar(nV2,apu);
          if (apu > 0) then Vs2 := apu else Vs2 := V2;
        end else begin
          Vs2 := V2;
        end;
        {put to voltage array}
        if (node > 0) and (node <= nnode_v) and (V2 > 0) then begin
          pVolt := pNodeVolt_v;
          inc(pVolt,node-1);
          pVolt^.x := V2;             {add voltage to the list (but if aready done?)}
          pVolt^.y := Vs2;            {add voltage to the list (but if aready done?)}
        end;
      end else begin                   {not trafo, an ordinary component}
        pComp^.GetVoltLev(Volt);       {voltage level of the component}
        pComp^.GetSystLev(sVolt);      {system voltage level}
        if (Volt > 0) then begin       {voltage level defined}
          pComp^.GetNnod(nnod);          {get the number of nodes in this compon.}
          if (nnod > 0) then begin       {component has nodes}
            if (nnod < 3) then nch := nnod else nch := 3;  {check at most 3 nodes}
            for jj := 1 to nch do begin
              pComp^.GetNode(jj,node,err);
              if (node > 0) and (node <= nnode_v) then begin
                pVolt := pNodeVolt_v;
                inc(pVolt,node-1);
                pVolt^.x := Volt;          {add voltage to the list (if aready done?)}
                pVolt^.y := sVolt;
              end;
            end;
          end;
        end;
      end;
    end;
  end;
  {then, pick the voltages of the buses. Scan, find all buses}
  errc := 0;                         {initialize error flag}
  pComp := nil;
  while (errc = 0) do begin          {to last component, or first error}
    pSet_v^.NextComp(pComp, errc);   {pointer to next component}
    if (errc = 0) then begin         {not error, but maybe last comp.}
      pComp^.GetName(name);          {name = type of the component}
      if (name = gBus) then begin    {is it a bus}
        pComp^.GetNode(1,node,err);
        if (node > 0) then begin
          pVolt := pNodeVolt_v;
          inc(pVolt,node-1);
          Volt := pVolt^.x;          {voltage of this node}
          sVolt := pVolt^.y;         {system voltage level}
          pComp^.PutVoltLev(Volt);   {save voltage to the bus}
          pComp^.PutSystLev(sVolt);  {save voltage to the bus}
        end;
      end;
    end;
  end;
end;


procedure TVoltComp.TrLinesOfComponents;
{For all components, copy the node ID of the transmission line node,
 to which the component is connected to (either directly, or indirectly}
var
  c_err    : integer;  {error flag}
  n1       : integer;  {nodes of the comp.}
  nd1,nd2  : integer;  {nodes of the comp.}
  pComp    : TpComp;   {pointer to a component}
  pLineNod : pInteger; {pointer to array of nodes}
  LineNod  : integer;  {the index of the tr.line node  }
begin
  {scan all components, attach nodes of tr.lines to which comp. is connected}
  c_err := 0;                         {initialize error flag}
  pComp := nil;
  while (c_err = 0) do begin          {to last component, or first error}
    pSet_v^.NextComp(pComp, c_err);   {pointer to next component}
    if (c_err = 0) then begin         {not error, but maybe last comp.}
      {both ends for tr.lines and trafos   }
      if (IsTLineOrTrafo(pComp)) then begin
        n1 := round(pComp^.var3_s);     {node corresponding to var1_s}
        pComp^.GetNode(1,nd1,c_err);    {first node}
        pComp^.GetNode(2,nd2,c_err);    {second node}
        LineNod := round(pComp^.var1_s);
        pLineNod := pLineNod_v;         {pointer to array of nodes}
        if (LineNod > 0) and (LineNod <= nNode_v) then begin
          inc(pLineNod,LineNod-1);      {pointer to voltage of this node}
          {save nodes so that the first corresponds to the first}
          if (n1 = nd1) then pComp^.var3_s := pLineNod^   {save the line node (CHANGE)}
          else               pComp^.var4_s := pLineNod^;
        end;
        LineNod := round(pComp^.var2_s);{the other end}
        pLineNod := pLineNod_v;         {pointer to array of nodes}
        if (LineNod > 0) and (LineNod <= nNode_v) then begin
          inc(pLineNod,LineNod-1);      {pointer to voltage of this node}
          if (n1 = nd1) then pComp^.var4_s := pLineNod^   {save the line node (CHANGE)}
          else               pComp^.var3_s := pLineNod^;
        end;
      end else begin
        LineNod := round(pComp^.var1_s);
        pLineNod := pLineNod_v;         {pointer to array of nodes}
        if (LineNod > 0) and (LineNod <= nNode_v) then begin
          inc(pLineNod,LineNod-1);      {pointer to voltage of this node}
          pComp^.var3_s := pLineNod^;   {save the line node (CHANGE)}
          pComp^.var4_s := pLineNod^;   {same node, actually not needed}
        end;
      end;
    end;
  end;
end;

procedure TVoltComp.SetTrafoPhases(pTrafo : TpComp; pNR1,pNR2 : TpNrPtr);
{set the (relative) phase shifts of the prim. and sec. trafo nodes
 pTrafo      pointer to the transformator
 pNR1, pNR2  pointer to the node records of the prim. and sec. nodes}
var
  ix,iy : integer;
  lbl   : string;
begin
  pTrafo^.GetLabel(lbl,ix,iy);
  if (pNR1 <> nil) and (pNR2 <> nil) then begin
    if (pNR1^.RelPhase = unreal_v) and
       (pNR2^.RelPhase = unreal_v) then begin  {completely new}
      pNR1^.RelPhase := 0;           {prim. becomes reference phase}
      if      (pTrafo^.hint = 'Transformator Y D') then pNR2^.RelPhase := -30
      else if (pTrafo^.hint = 'Transformator D Y') then pNR2^.RelPhase := -30{+30}
      else                                              pNR2^.RelPhase := 0;
    end else if (pNR1^.RelPhase <> unreal_v) and
                (pNR2^.RelPhase =  unreal_v) then begin
      {phase of prim.side known, must set sec.side}
      if      (pTrafo^.hint = 'Transformator Y D') then
        pNR2^.RelPhase := pNR1^.RelPhase-30
      else if (pTrafo^.hint = 'Transformator D Y') then
        pNR2^.RelPhase := pNR1^.RelPhase-30{+30}     {changed 3.11.2002}
      else
        pNR2^.RelPhase := pNR1^.RelPhase;
    end else if (pNR1^.RelPhase =  unreal_v) and
                (pNR2^.RelPhase <> unreal_v) then begin
      {phase of sec.side known, must set prim.side}
      if      (pTrafo^.hint = 'Transformator Y D') then
        pNR1^.RelPhase := pNR2^.RelPhase+30
      else if (pTrafo^.hint = 'Transformator D Y') then
        pNR1^.RelPhase := pNR2^.RelPhase+30{-30}
      else
        pNR1^.RelPhase := pNR2^.RelPhase;
    end else begin
      {phase of both sides known, do nothing}
    end;
  end else if (pNR1 <> nil) and (pNR2 = nil) then begin
    if (pNR1^.RelPhase = unreal_v) then pNR1^.RelPhase := 0;
  end else if (pNR1 = nil) and (pNR2 <> nil) then begin
    if (pNR2^.RelPhase = unreal_v) then pNR2^.RelPhase := 0;
  end else begin
    {}
  end;
end;

procedure TVoltComp.SetPhase(node: integer; RelPhase : single);
{set the relative phase of the node to the given value
 node     the ID (index) of the node
 RelPhase the phase to be set}
var
  pNP : TpNrPtr; {pointer to node-record, with properties}
begin
  if (node > 0) and (node <= nnode_v) then begin
    pNP := pNrPtr_v;
    inc(pNP,node-1);
    pNP^.RelPhase := RelPhase;
  end else begin
    {unreasonable index, no nothing}
  end;
end;

procedure TVoltComp.SetNew(node: integer);
{flag the node as "new", i.e. it has just been detected
 that the phase of the node has not yet been set
 node   the ID (index) of the node}
var
  pNP : TpNrPtr; {pointer to node-record, with properties}
begin
  if (node > 0) and (node <= nnode_v) then begin
    pNP := pNrPtr_v;
    inc(pNP,node-1);
    pNP^.new := true;
  end else begin
    {unreasonable index, no nothing}
  end;
end;

function TVoltComp.IsNew(node: integer): boolean;
{checks, is the node flagged as "new", i.e. has it already been detected
 that the phase of the node has not yet been set
 node   the ID (index) of the node}
var
  pNP : TpNrPtr; {pointer to node-record, with properties}
begin
  if (node > 0) and (node <= nnode_v) then begin
    pNP := pNrPtr_v;
    inc(pNP,node-1);
    IsNew := pNP^.new;
  end else begin
    IsNew := false;
  end;
end;

function TVoltComp.IsReady(node: integer): boolean;
{checks, is the node handled, i.e. is the "ready" flag set
 node   the ID (index) of the node}
var
  pNP : TpNrPtr; {pointer to node-record, with properties}
begin
  if (node > 0) and (node <= nnode_v) then begin
    pNP := pNrPtr_v;
    inc(pNP,node-1);
    IsReady := pNP^.ready;
  end else begin
    IsReady := false;
  end;
end;

procedure TVoltComp.SetRelativePhaseOfComponents;
{copy the relative phase from nodes to components}
var
  c_err    : integer; {error flag}
  err      : integer; {error flag}
  node     : integer; {idex of a node}
  pComp    : TpComp;  {pointer to a component}
  pNodRec  : TpNrPtr; {pointer to node record, with data}
begin
  pComp := nil;                       {initialize pointer to components}
  c_err := 0;
  while (c_err = 0) do begin          {to last component, or first error}
    pSet_v^.NextComp(pComp, c_err);   {pointer to next component}
    if (c_err = 0) then begin         {not error, but maybe last comp.}
      pComp^.GetNode(1,node,err);
      if (node > 0) and (node <= nNode_v) then begin        {earth not included}
        pNodRec := pNrPtr_v;            {initialize pointer to node record (data)}
        inc(pNodRec,node-1);            {pointer to node data of this node}
        pComp^.SetRelativePhase(pNodRec^.RelPhase);
      end;
    end;
  end;
end;

procedure TVoltComp.DetermineRelativePhase;
{determine the relative phase shift of the components.
 The phase shift is caused by Y-D and D-Y transformators.
 "Relative" is relative to the primary side of the first
 transformator. That is, it is a rather arbitrary reference !}
var
  bothnew   : boolean;  {true, when both nodes new = phase unknown}
  c_err     : integer;  {error flag}
  changed   : boolean;  {phase of node (probably) changed}
  err       : integer;  {error flag}
  ii,jj,kk  : integer;  {indices}
  itr       : integer;  {index for trafors}
  nnod      : integer;  {no of nodes in a component}
  node      : integer;  {some node}
  npri,nsec : integer;  {prim. and sec. node of a trafo}
  RelPhase  : single;   {rel. phase of some node}
  ppComp    : TppComp;  {pointer to array of component pointers}
  pComp     : TpComp;   {some component}
  pNodRec   : TpNrPtr;  {pointer to array of node records}
  pNR1,pNR2 : TpNrPtr;  {pointers to arrays of node records}
{ pNR1ready : boolean;  {primary node ready}
{ pNR2ready : boolean;  {secondary node ready}
  pTrafo    : TpComp;   {pointer to a trafo}
  ppTrafo   : TppComp;  {pointer to array of trafo pointers}
  scanning  : boolean;  {scanning, as long true}
  start     : boolean;  {start checking the phases}
begin
  if (nTrafos_v > 0) then begin         {are there trafos (just to be sure)}
    pNodRec := pNrPtr_v;                {pointer to array of node data}
    {initialize flags, and phase shift to some unphysical value}
    for ii := 1 to nNode_v do begin
      pNodRec^.ready := false;
      pNodRec^.new := false;
      pNodRec^.RelPhase := unreal_v;    {HUOM, voi jd roikkumaan, must check finally  ?}
      inc(pNodRec);
    end;
    {initialize temp.variable, used as flag for handled component}
    pComp := nil;                       {initialize pointer to components}
    c_err := 0;
    while (c_err = 0) do begin          {to last component, or first error}
      pSet_v^.NextComp(pComp, c_err);   {pointer to next component}
      if (c_err = 0) then begin         {not error, but maybe last comp.}
        pComp^.var1_s := 0;             {initialize temp. variables, used as flags}
      end;
    end;
    {scan all trafos }
    scanning := false;                   {initialize 2.10.2002}
    start := true;
    changed := true;                     {initialize}
    bothnew := true;
    while (changed or (bothnew and not changed)) do begin
      bothnew := false;
      changed := false;                  {change later, if changes}
      ppTrafo := ppTrafos_v;             {pointer to pointer for first trafo}
      for itr := 1 to nTrafos_v do begin
        pTrafo := ppTrafo^;                {pointer to the trafo itself}
        inc(ppTrafo);                      {pointer to next trafo}
        pTrafo^.GetNode(1,npri,err);       {ID of voltage node of primary side}
        pTrafo^.GetNode(2,nsec,err);       {ID of voltage node of secondary side}
        if (npri > 0) then begin
          pNR1 := pNrPtr_v; inc(pNR1,npri-1);{pointer to record of this node}
        end else pNR1 := nil;
        if (nsec > 0) then begin
          pNR2 := pNrPtr_v; inc(pNR2,nsec-1);
        end else pNR2 := nil;
        {scan components only when the phase of one winding is known,
         except for the first time}
        if (pNR1 <> nil) and (pNR2 <> nil) then begin  {reasonable nodes, not earth}
          if (not pNR1^.ready and not pNR2^.ready) then begin
            if (start) then begin       {both nodes new, when starting}
              pNR1^.new := true;
              pNR2^.new := true;
              scanning := true;
              changed := true;
              start := false;           {may be changed in the end}
            end else begin              {not necessarily start, but set flag}
              scanning := false;        {both new = phase unknown}
              bothnew := true;
            end;
          end else if (not pNR1^.ready and pNR2^.ready) then begin
            pNR1^.new := true;
            scanning := true;
            changed := true;
          end else if (not pNR2^.ready and pNR1^.ready) then begin
            pNR2^.new := true;
            scanning := true;
            changed := true;
          end else begin
            scanning := false;
          end;
        end else if (pNR1 <> nil) and (pNR2 = nil) then begin
          if (not pNR1^.ready) then begin
            pNR1^.new := true;
            scanning := true;
            changed := true;
          end;
        end else if (pNR1 = nil) and (pNR2 = nil) then begin
          if (not pNR1^.ready) then begin
            pNR2^.new := true;
            scanning := true;
            changed := true;
          end;
        end else begin     {both ends grounded (or not reasonable)}
          {do nothing}
        end;
        if (scanning) then begin            {start scanning connected components}
          SetTrafoPhases(pTrafo,pNR1,pNR2); {set the relative phases of trafo nodes}
          pTrafo^.var1_s := 1;              {component handled, (set already now)}
          {scan the nodes and components}
          while(scanning) do begin
            scanning := false;              {initialize, change later, if}
            pNodRec := pNrPtr_v;
            for ii := 1 to nNode_v do begin {scan all nodes}
              if (pNodRec^.new) then begin  {must handle this node}
                RelPhase := pNodRec^.RelPhase; {copy relative phase to local}
                pNodRec^.new := false;      {reset flag}
                pNodRec^.ready := true;     {node handled (will be soon..)}
                ppComp := pNodRec^.ppC;     {pointer to first element in array}
                if (pNodRec^.No > 1) then begin        {components connected to this node}
                  for jj := 1 to pNodRec^.No do begin  {all components connected to this node}
                    pComp := ppComp^;           {pointer to first component}
                    inc(ppComp);                {next, ready for the next turn}
                    if (pComp^.var1_s <> 1) then begin  {component not yet handled}
                      if (IsTrafo(pComp)) then begin {trafos treated differently}
                        {trafos handled above, do nothing here}
                      end else begin              {"normal" component}
                        pComp^.var1_s := 1;       {is (soon) handled}
                        pComp^.GetNnod(nnod);     {get the number of nodes in this compon.}
                        for kk := 1 to nnod do begin   {check all nodes of this comp}
                          pComp^.GetNode(kk,node,err); {ID of one node}
                          {node not yet handled and not yet detected as unhandled}
                          if (not IsReady(node)) and (not IsNew(node)) and
                             (node > 0) then begin
                            SetNew(node);
                            if (node < ii) then begin
                              scanning := true; {check this on next round}
                            end;
                            SetPhase(node,RelPhase);  {set the relative phase of the node}
                          end;
                        end;
                      end;
                    end else begin
                     {is handled, do nothing }
                    end;
                  end;
                end;
              end;
              inc(pNodRec);                 {next node}
            end;
          end;
        end;
      end;
      if (bothnew and not changed) then start := true;  {flag to start again}
    end;
  end else begin
    pNodRec := pNrPtr_v;                {pointer to array of node data}
    {phase shift is same everywhere}
    for ii := 1 to nNode_v do begin
      pNodRec^.RelPhase := 0;
      inc(pNodRec);
    end;
  end;
  SetRelativePhaseOfComponents;
(*
{show results}
pNodRec := pNrPtr_v;                {pointer to array of node data}
for ii := 1 to nNode_v do begin
  showmessage(inttostr(ii)+'  '+floattostr(pNodRec^.RelPhase));
  inc(pNodRec);
end;
{end of showing results}
*)
{             pComp^.hint = 'Transformator Y D' }
{             pComp^.hint = 'Transformator D Y' }
end;

{ - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - }

end.
