unit phasor;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, ExtCtrls, Compdef, Utildef, StdCtrls, Cmatmul,
  Menus, JpgImg, nodes, imagodef, Clipbrd;

type
  TReadOrCopy = (cRead,cCopy,vRead,vCopy); {read or copy current or voltage}
type
  TPhaseOrSeq = (phase,seq,both);
type
  TVoltMode = (PhasePhase,PhaseNeutral);

type
  TCurrPhasorForm = class(TForm)
    CurrPhasorImg: TImage;
    OnOffPanel: TPanel;
    OnOffBox: TCheckBox;
    DeleteBut: TButton;
    ColorPanel: TPanel;
    ColorImage: TImage;
    IDimage: TImage;
    PointEdit: TEdit;
    IncBut: TButton;
    DecBut: TButton;
    ResetBut: TButton;
    TopMenu: TMainMenu;
    FileItem: TMenuItem;
    ExitItem: TMenuItem;
    ViewItem: TMenuItem;
    ButItem: TMenuItem;
    PhasorDialog: TSaveDialog;
    BitmapItem: TMenuItem;
    CurrentLabel: TLabel;
    CurrSeqImage: TImage;
    SeqEdit: TEdit;
    SeqLabel: TLabel;
    ResetSeqBut: TButton;
    DecSeqBut: TButton;
    IncSeqBut: TButton;
    PhaseItem: TMenuItem;
    SequenceItem: TMenuItem;
    BothItem: TMenuItem;
    OptionsMenu: TMenuItem;
    NoMultItem: TMenuItem;
    MultItem: TMenuItem;
    N1: TMenuItem;
    PrimaryItem: TMenuItem;
    SecondaryItem: TMenuItem;
    CopyItem: TMenuItem;
    ClipPopMenu: TPopupMenu;
    BmpItem: TMenuItem;
    WmfItem: TMenuItem;
    CancelItem: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure OnOffBoxMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure OnOffBoxMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure DeleteButClick(Sender: TObject);
    procedure FormHide(Sender: TObject);
    procedure ColorImageMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormDeactivate(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure CurrPhasorImgMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure CurrPhasorImgMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure CurrPhasorImgMouseMove(Sender: TObject; Shift: TShiftState;
      X, Y: Integer);
    procedure IncButClick(Sender: TObject);
    procedure DecButClick(Sender: TObject);
    procedure ResetButClick(Sender: TObject);
    procedure ExitItemClick(Sender: TObject);
    procedure ButItemClick(Sender: TObject);
    procedure BitmapItemClick(Sender: TObject);
    procedure CurrSeqImageMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure CurrSeqImageMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure CurrSeqImageMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ResetSeqButClick(Sender: TObject);
    procedure DecSeqButClick(Sender: TObject);
    procedure IncSeqButClick(Sender: TObject);
    procedure PhaseItemClick(Sender: TObject);
    procedure SequenceItemClick(Sender: TObject);
    procedure BothItemClick(Sender: TObject);
    procedure NoMultItemClick(Sender: TObject);
    procedure MultItemClick(Sender: TObject);
    procedure PrimaryItemClick(Sender: TObject);
    procedure SecondaryItemClick(Sender: TObject);
    procedure CopyItemClick(Sender: TObject);
    procedure BmpItemClick(Sender: TObject);
    procedure WmfItemClick(Sender: TObject);

  private
    { Private declarations }
{   procedure CreateParams(var Params: TCreateParams); override;}

  public
    { Public declarations }
  end;

const
  maxCT = 6;                   {max. no of current trafos}
  CTrows = 4;                  {no of rows for one current trafo}
  FilterBoth = 'bitmaps (*.bmp)|*.bmp|Jpeg file (*.jpg)|*.jpg|Windows metafile (*.wmf)|*.wmf';
  FilterBmp = 'bitmaps (*.bmp)|*.bmp|Jpeg file (*.jpg)|*.jpg';

var
  CurrPhasorForm: TCurrPhasorForm;

type
  Tscale = array[1..11] of single;  {the array for the scales}

type
  TppPhasorGrid = ^TpPhasorGrid;
  TpPhasorGrid = ^TPhasorGrid;
  TPhasorGrid = class(TStringGrid)
  procedure InitializeBasics;
  procedure InitializeMore(pOOPanel,pColPanel : TpPanel; pBox :TpCheckBox;
                           pBut : TpButton; pImage, pIDrec : TpImage; pPedit : TpEdit;
                           pCaption : TpLabel; pForm: TpForm; pSaveDlg: TpSaveDlg;
                           p3Item,p1Item: TpMenuItem);
  procedure SetGridHeight;
  procedure SetSize;
  function  isThere(ipComp : longint; var row : integer; info: string) : boolean;
  procedure CurrentsToGrid(CurrA,AngleA,CurrB,AngleB,CurrC,AngleC : single; iCT : integer);
  function  ShowPhasors(ipComp : longint; how : TReadOrCopy; pCurr: TpMultix; lbl,info: string):boolean;
  procedure Select_Cell(Sender: TObject; Col, Row: Longint; var CanSelect: Boolean);
  procedure DeleteCTphasor(row : integer);
  procedure DelButClick(row: integer);
  procedure RemoveAllPhasors;
  procedure ColorImageMouseUp( X, Y: Integer);
//procedure DeltaImageMouseUp(x,y: integer);
  procedure Draw_Cell(Sender: TObject; Col,Row: Longint; Rect: TRect; State: TGridDrawState);
  procedure UpdatePhasors(how : TReadOrCopy; pCurr : TpMultix; ii: integer);
  procedure CurrentsFromGrid;
  procedure DetermineScale;
  procedure DrawCircles(Toile: TCanvas);
  procedure PhasorLines(Toile: TCanvas);
  procedure DrawPhasors;
  procedure MoveIdentifier(x,y : integer);
  procedure CursorCurrent(x,y : integer);
  procedure StartIdentifierIf(x,y : integer);
  procedure CopyToSequence(ipComp : longint; info: string; var Cp,Ap,Cn,An,Cz,Az : single);
  procedure UpdateSeqIdentifiers;
  procedure FormResizeUpper(pForm : TpForm);
  procedure FormResizeLower(pForm : TpForm);
{  procedure GetVoltages(ipComp : longint; var VoltA,AngleA,VoltB,AngleB,VoltC,AngleC : single);}
  procedure PhasePhaseID;
  procedure PhaseNeutralID;
  procedure TextToImage(txt : string; x,y : integer);
  function  NoOfItems : integer;
  function  GetIp(ii: integer): longint;   {get pointer to current trafo ii}
  function  PhasePhaseVolt: boolean;       {phase to phase voltages used }
  procedure DrawWmfDiagram(Fname : string);
  procedure PutpResEdit(pResEdit: TpEdit); {set pointer to the "reset" edit in the main form}
  procedure GetInitDir( var dir0,dir1: string);
  procedure PutInitDir(dir1: string);
  procedure GetColorIndex(ii: integer; var ia,ib,ic: integer);
  procedure PutColorIndex(ii, ia,ib,ic: integer);
  procedure GetIDRelPos(ii: integer; var x1,y1,x2,y2,x3,y3: integer);
  procedure PutIDRelPos(ii,x1,y1,x2,y2,x3,y3: integer);
  procedure GetScaleIndex(var ind : integer);
  procedure PutScaleIndex(ind : integer);
  procedure GetCaption(ii: integer; var txt: string);
  procedure MultiplierForUnit(var multi: single; var multiunit: string);
  procedure GetCompPointer(ii: integer; var ipComp: longint);
  function  GetMaxCT: integer;
  procedure WindingCurrentID;
//procedure GetDelt(ipComp: longint; var delt: single);

private
  {private declarations}
  diamax_p     : integer;           {diameter of the lagest circle}
  downx0_p     : integer;           {x of mouse down}
  downy0_p     : integer;           {y of mouse down}
  downkk_p     : integer;           {row index of identifier at which mouse down}
  iclr_p       : integer;           {color index}
  Initdir0_p   : string;            {initial initial directory}
  iscale_p     : integer;           {index of scale}
  jscale_p     : integer;           {modified index of scale}
  nCurrTrafo_p : integer;           {no of current trafos in grid}
  Scales_p     : TScale;            {scale factors to select from}
  Steps_p      : TScale;            {steps between the markings (scales)}
  scalfact_p   : single;            {multiplies scales[.] to get proper scale}
  CTpoint_p    : array[1..maxCT] of longint;          {pointers to current trafos, as integers}
  CTident_p    : array[1..maxCT] of integer;          {keeps track of the identifiers for the phasors}
  IDxx_p       : array[0..maxCT*CTrows-1] of integer; {unmodified x-coord. of the identifier}
  IDyy_p       : array[0..maxCT*CTrows-1] of integer; {unmodified y-coord. of the identifier}
  Relxx_p      : array[0..maxCT*CTrows-1] of integer; {relative x-coord. of the identifier}
  Relyy_p      : array[0..maxCT*CTrows-1] of integer; {relative y-coord. of the identifier}
  Angle_p      : array[0..maxCT*CTrows-1] of single;  {array of the angle of the currents}
  Curr_p       : array[0..maxCT*CTrows-1] of single;  {array of the magnitude of the currents}
  pCimage_p    : TpImage;           {pointer to the phasor image}
  pDelBut_p    : TpButton;          {pointer to the delete button}
  pForm_p      : TpForm;            {pointer to the form}
  pOOPanel_p   : TpPanel;           {pointer to the on-off panel}
  pOOBox_p     : TpCheckBox;        {pointer to the on-off check box}
  pColPanel_p  : TpPanel;           {pointer to the color panel}
  pPEdit_p     : TpEdit;            {pointer to the edit for the cursor position}
  pIDrec_p     : TpImage;           {pointer to the rectangle for moving the identifier}
  pCaption_p   : TpLabel;           {pointer to the caption of the phasor (image +grid)}
  pResEdit_p   : TpEdit;            {pointer to the edit in the main form for resetting the PWR-flag}
  p3Item_p     : TpMenuItem;        {pointer to menu item for multip. by 3 of seq.components}
  p1Item_p     : TpMenuItem;        {pointer to menu item for no multip. of seq.components}
public
  {public declarations}
  actcol_p     : integer;           {selected column}
  actrow_p     : integer;           {selected row}
  filename_p   : string;            {the name of the program file (*.exe-file)}
  ipSet_p      : longint;           {pointer to the common as integer}
  maxScale_p   : single;            {current corresponding the largest circle}
  modScale_p   : integer;           {modification index for scale}
  unit_p       : string;            {volts or amperes}
  multi_p      : string;            {multiplier for the unit, '', or k}
  view_p       : TPhaseOrSeq;       {flag for which phasor shown}
  VoltMode_p   : TVoltMode;         {flag for phase-phase or phase-neutral voltage}
  writeID_p    : boolean;           {write/not the identifiers in the graph}
  ppActGrid_p  : TppPhasorGrid;     {pointer to pointer to active grid}
  pSelf_p      : TpPhasorGrid;      {pointer to itself}
  pOther_p     : TpPhasorGrid;      {pointer to the other grid}
end;

var
  CurrGrid : TPhasorGrid;     {table for the current values, etc}
  SeqGrid   : TPhasorGrid;     {table for the symm.component values of currents}

implementation
uses
  skemadef, CurrPhas, Imagopas, skemproc;

{$R *.DFM}

const
  {indices of columns}
  ColorCol  = 0;   {column for colors}
  OnOffCol  = 1;   {column for on/off (display/not) switch}
  IdentCol  = 2;   {column for phasor identifier}
  TrafoCol  = 3;   {column for the data of the current trafo (current, phase)}
  DataCol   = 4;   {column for data in the original form}
  {widths of columns}
  ColorWidth = 16;
  OnOffWidth = 24;
  IdentWidth = 32;
  TrafoWidth = 128;
  ln10 = 2.302585;
  Imarg = 12;                   {image margins}
  editmarg = 2;  {margin under and above of the edit box showing cursor position}
  botmarg = 44;  {bottom margin on form (includes menu bar height ?)}
  CgridMarg : integer = 16;    {right margin of current grid}
  CimagMarg : integer = 4;     {margin for the image}
  pActGrid : TpPhasorGrid = nil;

var
  CRwidth  : integer;         {width (and height) of a small color rectangle}
  CRspace  : integer;         {width of space between color rectangles}
{ CurrGrid : TPhasorGrid;     {table for the current values, etc}
{ SeqGrid  : TPhasorGrid;     {table for the symm.component values of currents}
(*
procedure TCurrPhasorForm.CreateParams(var Params: TCreateParams);
{this is needed in order to keep forms always on top
 (fsStayOnTop does not work, when two forms)}
begin
  inherited CreateParams(Params);
  with Params do begin
    ExStyle := ExStyle or WS_EX_TOPMOST;
    WndParent := GetDesktopwindow;
  end;
end;
*)

{THIS is copied from Imagopas.pas, as such (??)}
function GetNameOfThisFile : string;
{get the name of this *.exe file, without the extension}
var
  ExeFile : string; {the name with the extension}
  ii      : integer;
  len     : integer;  {length of a string}
  line    : string;   {for copying the file name}
begin
  ExeFile := ExtractFileName(paramStr(0));
  line := '';
  len := length(ExeFile);
  if (len > 1) then begin
    for ii := 1 to len do begin
      if (ExeFile[ii] <> '.') then begin
        line := line+ExeFile[ii];
      end else begin
        break;                   {do not include the . and the extension}
      end;
    end;
  end;
  GetNameOfThisFile := line;
end;

procedure SaveJpegImag(pForm: TpForm; pictbit: Tbitmap; FileName: string);
{save a bitmap in the Jpeg form to a file
 SAME as SaveJpegImage in routines.pas. Repeated here => no need to include routines.pas
 pForm     pointer to the form where the bitmap is defined (needed as owner and parent)
 pictbit   the bitmap to be saved
 FileName  name of the file where saved}
var
  FormJpeg    : TJpegImage; {for saving the bitmap as a jpeg-image}
begin
  FormJpeg := TJpegImage.create(pForm^);
  FormJpeg.parent := pForm^;
  FormJpeg.quality := 100;                   {default = 75, but now the file is larger}
  FormJpeg.picture.bitmap.assign(pictbit);   {copy in jpeg-format}
  FormJpeg.savetofile(FileName);
  FormJpeg.free;
end;

procedure TPhasorGrid.SetGridHeight;
{set the heigth of the grid according to the no of lines}
var
  ii,ipu : integer;
begin
{the total height}
  ipu := 0;
  for ii := 0 to rowCount-1 do begin
    ipu := ipu+RowHeights[ii];
  end;
  ipu := ipu+(RowCount+2)*GridLineWidth;
  height := ipu;
end;

procedure TPhasorGrid.InitializeBasics;
{set all basic parameters, initialize some other parameters}
begin
  align := alNone;
  BorderStyle := bsSingle;
  ColCount := {4}5;
  color := clWindow;
  Ctl3D := false;
  Cursor := crDefault;
  DefaultColWidth := 64;
  DefaultDrawing := true;
  DefaultRowHeight := 14;
  ColWidths[4] := 2;         {data stored here, but not visible}
  DragCursor := crDrag;
  DragMode := dmManual;
  Enabled := true;
  FixedColor := clBtnFace;
  FixedCols := 0;
  FixedRows := 0;
  Font.name := 'Times New Roman';
  Font.style := [];
  Font.size := 8;
  GridLineWidth := 1;
  Height := 90;         {will be changed later }
  HelpContext := 0;
  Hint := '';
{  Left := 232;  later}
{  Name :=       not needed ?}
  Options := [goFixedVertLine,goFixedHorzLine,goVertLine,goHorzLine,
              goTabs,goAlwaysShowEditor];
  ParentColor := false;
  ParentCtl3D := false;
  ParentFont := false;
  ParentShowHint := true; {?}
  PopupMenu := nil;
  RowCount := 4;
  ScrollBars := ssNone;
  ShowHint := false;
{ TabOrder :=     Not needed ? }
  TabStop := true;
  Tag := 0;
{  Top := 24;                  {may be changed later}
  Visible := false;            {set "true" later}
  width := 273;                {will be changed later}
  pResEdit_p := nil;
{ pSet_p := @SetComp;   {pointer to the common}
  writeID_p := true;
end;

procedure TPhasorGrid.InitializeMore(pOOPanel,pColPanel : TpPanel; pBox :TpCheckBox;
          pBut : TpButton; pImage, pIDrec : TpImage; pPedit : TpEdit; pCaption :TpLabel;
          pForm: TpForm; pSaveDlg: TpSaveDlg; p3Item, p1Item: TpMenuItem);
{initialize pointers, arrays etc
 pOOPanel   pointer to the on-off panel
 pColPanel  pointer to the color panel
 pDeltPanel pointer to the panel for secondary of CT (Y or delta)
 pOOBox     pointer to the on-off tick-box
 pImage     pointer to the phasor image
 pIDrec     pointer to the rectangle for moving the indentifiers }
const
  {the normalized max.scales to be selected from}
  scales : TScale= (10.0,12.0,15.0,20.0,25.0,30.0,40.0,50.0,60.0,80.0,100.0);
  {markers = differences between "ticks"}
  steps  : Tscale = ( 2.0, 2.0, 5.0, 5.0, 5.0, 5.0, 5.0,10.0,10.0,20.0, 20.0);
var
  ii  : integer;
  ipu : integer;
begin
  {set the dimensions of the grid for current trafos}
  ColWidths[ColorCol] := ColorWidth;
  ColWidths[OnOffCol] := OnOffWidth;
  ColWidths[IdentCol] := IdentWidth;
  ColWidths[TrafoCol] := TrafoWidth;
  {the total width of the grid}
  ipu := 0;
  for ii := 0 to ColCount-1 do begin
    ipu := ipu+ColWidths[ii];
  end;
  width := ipu+(ColCount+2)*GridLineWidth;
  SetGridHeight;                   {the total height of the grid}

  diamax_p   := 100;               {initialize diameter of the lagest circle}
  maxScale_p := 100;               {current corresponding the largest circle}
  {attach procedures}
  OnDrawCell := Draw_Cell;
  OnSelectCell := Select_Cell;
  {initialize some other variables and arrays}
  for ii := 1 to maxCT do CTpoint_p[ii] := 0;
  for ii := 1 to maxCT do CTident_p[ii] := ii;
  {initialize = clear the position-arrays of the identifier}
  ipu := high(IDxx_p);     {dimension, same for all}
  for ii := 0 to ipu do begin
    IDxx_p[ii] := 0;
    IDyy_p[ii] := 0;
    Relxx_p[ii] := 0;
    Relxx_p[ii] := 0;
  end;
  {pointers}
  pForm_p := pForm;
  pOOPanel_p := pOOPanel;
  pColPanel_p := pColPanel;
  pOOBox_p := pBox;
  pDelBut_p :=  pBut;
  pCimage_p := pImage;
  pPEdit_p := pPedit;
  pIDrec_p := pIDrec;
  pCaption_p := pCaption;
  {others}
  scales_p := scales;
  steps_p := steps;
  iclr_p := 1;      {color index}
  view_p := phase;  {initially phasor of phase comp. shown}
  InitDir0_p := pSaveDlg^.InitialDir;
  p3Item_p := p3Item;
  p1Item_p := p1Item;
end;

procedure TPhasorGrid.SetSize;
{set the size (dimensions) of the grid for current trafos}
var
  ii,ipu : integer;
begin
  ColWidths[ColorCol] := ColorWidth;
  ColWidths[OnOffCol] := OnOffWidth;
  ColWidths[IdentCol] := IdentWidth;
  ColWidths[TrafoCol] := TrafoWidth;
  {the total width of the grid}
  ipu := 0;
  for ii := 0 to ColCount-1 do begin
    ipu := ipu+ColWidths[ii];
  end;
  width := ipu+(ColCount+2)*GridLineWidth;
end;

procedure TCurrPhasorForm.FormCreate(Sender: TObject);
{set the size etc of the grind and image}
var
  ii      : integer;   {index}
  ipu,ipv : integer;   {temporary}
begin
{CreateParams(CurrPhasorForm.Params); not needed}

  {create the grid for the values of the currents (etc)}
  CurrGrid := TPhasorGrid.create(CurrPhasorForm);
  CurrGrid.parent := CurrPhasorForm;
  CurrGrid.InitializeBasics;
  CurrGrid.InitializeMore(@OnOffPanel,@ColorPanel,@OnOffBox,@DeleteBut,@CurrPhasorImg,
                          @IDImage,@PointEdit,@CurrentLabel,@CurrPhasorForm,@PhasorDialog,
                          nil,nil);
  CurrGrid.VoltMode_p := PhaseNeutral; {29.11.10 because of transformer winding currents...}
  CurrGrid.pSelf_p := @CurrGrid;
  CurrGrid.Left := 232;
  CurrGrid.Top := 24;
  CurrGrid.name := 'CurrGrid';
//CurrGrid.visible := true;
  {create the grid for the values of the sequence currents (etc)}
  SeqGrid := TPhasorGrid.create(CurrPhasorForm);
  SeqGrid.parent := CurrPhasorForm;
  SeqGrid.InitializeBasics;
  SeqGrid.InitializeMore(@OnOffPanel,@ColorPanel,@OnOffBox,@DeleteBut,@CurrSeqImage,
                          @IDImage,@SeqEdit, @SeqLabel,@CurrPhasorForm,@PhasorDialog,
                          @MultItem,@NoMultItem);
  SeqGrid.pSelf_p := @SeqGrid;
  SeqGrid.pOther_p := @CurrGrid;
  CurrGrid.pOther_p := @SeqGrid;
  SeqGrid.Left := 232;
  SeqGrid.Top := 288;
  SeqGrid.name := 'SeqGrid';
  {show cur grid, but hide sequence grid and image, etc}
  CurrGrid.visible := true;
  SeqGrid.visible := false;
  CurrSeqImage.visible := false;
  SeqLabel.visible := false;
  SeqEdit.visible := false;
  ResetSeqBut.visible := false;
  IncSeqBut.visible := false;
  DecSeqBut.visible := false;
  left := {Imagoo.width}Screen.width-width-8;   {position of the form wrt the main form}
(*
  {a rectangle around the phasor image}
  CurrPhasorImg.canvas.pen.color := clBlack;
  CurrPhasorImg.canvas.pen.width := 1;
  CurrPhasorImg.canvas.brush.style := bsClear;
  CurrPhasorImg.canvas.rectangle(0,0,CurrPhasorImg.width,CurrPhasorImg.height);
*)
  {set the (original) size of the form}
  {set the original size of the form}
  CurrPhasorForm.width := CurrGrid.left+CurrGrid.width+24;
  ipu := CurrGrid.top+CurrGrid.height+32;
  ipv := PointEdit.top+PointEdit.height+botmarg+2*editmarg;
  if (ipu > ipv) then  CurrPhasorForm.height := ipu
  else  CurrPhasorForm.height := ipv;
  {initialize the color selection image}
  {PQForm.}ColorInitialize(@ColorImage);     {in utildef}
  {PQForm.}GetCRsize(CRwidth,CRspace);
  ColorPanel.width := ColorImage.width+2*CRspace;
  ColorPanel.height := ColorPanel.width;
  ipu := CurrGrid.RowHeights[0]+CurrGrid.RowHeights[1];
  ColorPanel.top := CurrGrid.top+ipu+2*CurrGrid.GridLineWidth;
  ColorPanel.left := CurrGrid.left+CurrGrid.ColWidths[0]+2*CurrGrid.GridLineWidth;
  CurrGrid.unit_p := 'A';
  SeqGrid.unit_p := 'A';
  CurrGrid.ppActGrid_p := @pActGrid;
  SeqGrid.ppActGrid_p := @pActGrid;
{  if (SetComp.Phasor_dir <> '') then
    PhasorDialog.InitialDir := SetComp.Phasor_dir;}
  PointEdit.text := ' Click a current transformer';
  {add flag that form created}
  {cannot do, because matrix uses this unit, and does not run if a reference to Imagoo}
//  Imagoo.ReadyEdit.text := Imagoo.ReadyEdit.text+'P';
  {get name of the program, needed to distinguish between elplek/imagopro and matrixpr}
  CurrGrid.filename_p := GetNameOfThisFile;
  SeqGrid.filename_p := CurrGrid.filename_p;
end;

function TPhasorGrid.isThere(ipComp : longint; var row : integer; info: string) : boolean;
{check that current trafo is in the grid
ipComp  pointer to the trafo, as integer
row     the row where the identifier is
info    additional info (where called from, or..)}
var
  ii     : integer;  {index}
  name   : string;
  nTrafo : integer;  {number of a given trafo}
  pComp  : TpComp;
begin
  {the program matrixpr uses this routine, but does not use pointers to components}
  if (filename_p <> 'matrixpr') then begin
    pComp := TpComp(ipComp);
    pComp^.GetName(name);
  end else begin
    pComp := nil;
    name := '';
  end;
  if (nCurrTrafo_p = 0) then begin            {no trafos yet}
    isThere := false;
    row := 0;
  end else begin
    {transformers not considered in the program matrixpr}
    if (filename_p <> 'matrixpr') and ((isTrafo(pComp)) or (isIdealYDTrafo(pComp)) {in nodes.pas}
      or (name = gAtrafo)) then begin
      {a transformer can be two (or three?) times, once for each winding}
      isThere := false;                         {initialize}
      row := 0;
      nTrafo := 0;
      for ii := 1 to nCurrTrafo_p do begin      {check all}
        if (ipComp = CTpoint_p[ii]) then begin  {identical pointers (as integers)}
          inc(nTrafo);
          if (nTrafo >= 2) and (not (name = gTrafo3w)) and (not (name = gAtrafo)) or  {2-winding trafo}
             (ntrafo >= 3) then begin                      {3-winding trafo}
            isThere := true;
            row := (ii-1)*CTrows;               {the row for the identifier}
            break;
          end;
        end;
      end;
    end else begin
      isThere := false;                         {initialize}
      row := 0;
      for ii := 1 to nCurrTrafo_p do begin      {check all}
        if (ipComp = CTpoint_p[ii]) then begin  {identical pointers (as integers)}
          isThere := true;
          row := (ii-1)*CTrows;                 {the row for the identifier}
          break;
        end;
      end;
    end;
  end;
end;

procedure TPhasorGrid.CurrentsToGrid(CurrA,AngleA,CurrB,AngleB,CurrC,AngleC : single;
                                     iCT : integer);
{write the currents (magnitude and angle) to the grid
 CurrA, AngleA   magnitude and current of phase a (phase in degrees)
 CurrB, AngleB   magnitude and current of phase b (phase in degrees)
 CurrC, AngleC   magnitude and current of phase c (phase in degrees)
 iCt             index of the current trafo 1..CTmax}
var
  lblRow    : integer; {row of the label etc}
  mult      : single;  {multiplier for units}
  munit     : string;  {k or nothing}
//pSet      : TpCompSet;
  txta,txtb : string;  {temporary}
begin
  {determine the multiplier for the unit: nothing, or kilo (k)}
  MultiplierForUnit(mult,munit);
  multi_p := munit;
  {current magnitude and phase angle}
  if (iCT > 0) and (iCT <= maxCT) then begin
    lblRow := (iCT-1)*CTrows;            {row for the labes of this trafo}
    txta := Format('%8.1f',[CurrA*mult]);
    if (CurrA*mult >= 0.05) then
      txtb := Format('%5.1f',[AngleA])
    else txtb := '0.0';                  {no phase for zero current}
    Cells[TrafoCol,lblRow+1] := txta+' '+multi_p+unit_p+'  < '+txtb+' ';
    txta := Format('%8.1f',[CurrB*mult]);
    if (CurrB*mult >= 0.05) then
      txtb := Format('%5.1f',[AngleB])
    else txtb := '0.0';
    Cells[TrafoCol,lblRow+2] := txta+' '+multi_p+unit_p+'  < '+txtb+' ';
    txta := Format('%8.1f',[CurrC*mult]);
    if (CurrC*mult >= 0.05) then
      txtb := Format('%5.1f',[AngleC])
    else txtb := '0.0';
    Cells[TrafoCol,lblRow+3] := txta+' '+multi_p+unit_p+'  < '+txtb+' ';
    {save data as such in the "unvisible" column}
    Cells[DataCol,lblRow+1] := floattostr(CurrA)+unit_p+'  < '+floattostr(AngleA);
    Cells[DataCol,lblRow+2] := floattostr(CurrB)+unit_p+'  < '+floattostr(AngleB);
    Cells[DataCol,lblRow+3] := floattostr(CurrC)+unit_p+'  < '+floattostr(AngleC);
  end;
end;

procedure TPhasorGrid.UpdateSeqIdentifiers;
{update the identifiers for the sequence phasors to correspond the
 option "neg, zero currents as such" or "multiplied by three}
var
  ii          : integer;    {index}
  ipu         : integer;    {temporary}
  lblRow      : integer;    {rod index of the label}
  txa,txb,txc : string;  {temporary}
begin
  if (nCurrTrafo_p > 0) then begin
    for ii := 1 to nCurrTrafo_p do begin
      lblRow := (ii-1)*CTrows;      {row for the labes of this trafo}
      ipu := CTident_p[ii];
      if ({CurrPhasorForm.NoMultItem.checked}p1Item_p.checked) then begin  {shown as such}
        txa := '-(I1)';
        txb := '-(I2)';
        txc := '-(I0)';
      end else begin            {3*Ineg, 3*Izero}
        txa := '-(I1)';
        txb := '-(3I2)';
        txc := '-(3I0)';
      end;
      Cells[IdentCol,lblRow+1] := inttostr(ipu)+txa;
      Cells[IdentCol,lblRow+2] := inttostr(ipu)+txb;
      Cells[IdentCol,lblRow+3] := inttostr(ipu)+txc;
    end;
  end;
end;

function TPhasorGrid.ShowPhasors(ipComp : longint; how : TReadOrCopy; pCurr: TpMultix;
                                  lbl,info : string): boolean;
{add and show the current(s) using phasors, if allowed (button down)
 ipComp  pointer to the current trafo as integer
 how     flag to accept input or copy from the other phasor display
 pCurr   pointer to a record with the currents or voltages (magnitude+phase, in degrees)
 lbl     label of the component
 Returns true, if current trafo added}
var
  Aa,Ab,Ac : single;   {phase angle of currents}
  Ca,Cb,Cc : single;   {magnitudes of currents}
  ipu       : integer;  {temporary}
  ii        : integer;  {index}
  lblRow    : integer;  {row for the label}
{ pComp     : TpComp;   {pointer to the current trafo}
  pSet      : TpCompSet;{pointer to the common}
  txta,txtb : string;   {temporary text}
  txtc      : string;   {temporary text}
begin
{ if ((Imagoo.CurrPhasorBut.down) and ((how = cRead) or (how = cCopy))) or  {currents}
{    ((Imagoo.VoltPhasorBut.down) and ((how = vRead) or (how = vCopy))) then begin   {display of phasors allowed}
    {add curr.trafo, if there is room, and the trafo is not yet there}
    if (nCurrTrafo_p < maxCT) and not(isThere(ipComp,ipu,info)) then begin {room & not there}
      inc(nCurrTrafo_p);                      {one more}
      rowcount := nCurrTrafo_p*CTrows;        {add rows for this trafo}
      if (how = cRead) or (how = vRead) then begin   {currents or voltages from input}
        Ca := pCurr^.u;                       {magnitude of phase a}
        Aa := pCurr^.v;                       {phase angle of phase a}
        Cb := pCurr^.w;
        Ab := pCurr^.x;
        Cc := pCurr^.y;
        Ac := pCurr^.z;
      end else begin
        CopyToSequence(ipComp,info, Ca,Aa,Cb,Ab,Cc,Ac); {copy from sequence phasors}
      end;
      {add to the grid}
      lblRow := (nCurrTrafo_p-1)*CTrows;      {row for the labes of this trafo}
      Cells[TrafoCol,lblRow] := lbl;          {label to the grid}
      cells[IdentCol,lblRow] := info;         {display some additional info}
      {default colors, as a first guess}
      for ii := 1 to 3 do begin
        Cells[ColorCol,lblRow+ii] := inttostr(iclr_p);
        inc(iclr_p);
        if (iclr_p > high(gColor)) then iclr_p := low(gColor);
      end;
      {flag for the display of phasor}
      for ii := 1 to 3 do Cells[OnOffCol,lblRow+ii] := '1';
      {identifiers for the phasors}
      ipu := CTident_p[nCurrTrafo_p];
      if (how = cRead) then begin                  {read currents}
//        if (VoltMode_p = PhaseNeutral) then begin  {actually only for transformers..}
          txta := 'A';
          txtb := 'B';
          txtc := 'C';
//        end else begin
//          txta := 'AB';                    {...winding currents for transformers}
//          txtb := 'BC';
//          txtc := 'CA';
//        end;
      end else if (how = vRead) then begin {read voltages}
        {different identifiers for phase-neutral and phase-phase voltages}
        if (VoltMode_p = PhaseNeutral) then begin
          txta := 'a';
          txtb := 'b';
          txtc := 'c';
        end else begin
          txta := 'ab';
          txtb := 'bc';
          txtc := 'ca';
        end;
      end else begin                  {sequence components}
        if (how = cCopy) then begin   {copy (sequence) currents}
//        if (CurrPhasorForm.NoMultItem.checked) then begin  {shown as such}
          if (p1Item_p.checked) then begin  {show as such}
            txta := '-(I1)';
            txtb := '-(I2)';
            txtc := '-(I0)';
          end else begin            {3*Ineg, 3*Izero}
            txta := '-(3I1)';
            txtb := '-(3I2)';
            txtc := '-(3I0)';
          end;
        end else begin              {copy (sequence) voltages}
          txta := '-(V1)';
          txtb := '-(V2)';
          txtc := '-(V0)';
        end;
      end;
      Cells[IdentCol,lblRow+1] := inttostr(ipu)+txta;
      Cells[IdentCol,lblRow+2] := inttostr(ipu)+txtb;
      Cells[IdentCol,lblRow+3] := inttostr(ipu)+txtc;
      {magnitude and angle to the grid}
      CurrentsToGrid(Ca,Aa,Cb,Ab,Cc,Ac,nCurrTrafo_p);
      { "X" for delete}
      Cells[OnOffCol,lblRow] := '(X)';
      {pointer, as integer}
      CTpoint_p[nCurrTrafo_p] := ipComp;           {save pointer, as integer}
{     pComp^.SetPWR(true);                         {set flag}
      DrawPhasors;
      ShowPhasors := true;
      SetGridHeight;
    end else begin
      ShowPhasors := false;
    end;
{   SetGridHeight;}
{ end;}
end;

procedure ExtractCurrent(line : string; var Curr, angle : single);
{extract the magnitude and angle (in degrees) of current from text in line
 assumed line is written in CurrentsToGrid, and the line is like  3,456 A < 12,3 
 line   the text with the values
 Curr   the magnitude
 angle  the phase angle}
var
  ii    : integer;
  istop : integer;
  len   : integer;  {length of text}
  txt   : string;   {temporary}
begin
  len := length(line);
  {first, extract the magnitude}
  txt := '';
  istop := 1;
  for ii := 1 to len do begin
    if (line[ii] <> 'A') and (line[ii] <> 'V') and (line[ii] <> 'k') then begin
      txt := txt+line[ii];           {copy up to the 'A'}
    end else begin
      istop := ii;
      break;
    end;
  end;
  Curr := strtofloat(txt);          {the magnitude}
  {next, extract the angle}
  if (istop < len-1) then begin
    txt := '';
    for ii := istop+1 to len do begin
      if (line[ii] <> '<') and (line[ii] <> '') and
         (line[ii] <> 'A') and (line[ii] <> 'V') then txt := txt+line[ii];
    end;
    angle := strtofloat(txt);
  end else begin
    angle := 0;
  end;
end;

procedure TPhasorGrid.Select_Cell(Sender: TObject; Col,
  Row: Longint; var CanSelect: Boolean);
var
  apu,apv : single;
  ii     : integer;
  ipu    : integer;  {temporary}
  bpLeft : integer;  {left coordinate of additional panel or button}
  bpTop  : integer;  {top coord. of additional panel or button}
  line   : string;
begin
  ppActGrid_p^ := pSelf_p;
  {if on/off column, display button for selecting show current or not}
  actrow_p := row;                  {save so that other procedures can use}
  actcol_p := col;
  pForm_p^.tag := row;              {save latest active row (same for phase and seq.grid)}
  if (col = OnOffCol) then begin
    {coordinates of "command" components}
    ipu := 0;
    for ii := 0 to row do ipu := ipu+RowHeights[ii];
    bpTop := ipu+(row+2)*GridLineWidth+top;
    ipu := 0;
    for ii := 0 to col do ipu := ipu+ColWidths[ii];
    bpLeft := ipu+(col+2)*GridLineWidth+left;
    {not label row}
    if (row <> CTrows*(row div CTrows)) then begin
      pOOPanel_p^.top := bpTop;                     {put panel below the selected cell..}
      pOOPanel_p^.left := bpLeft;                   {..on the OnOff-column}
      pOOBox_p^.checked := (Cells[col,row] <> '0'); {copy "show" status"}
      pOOPanel_p^.visible := true;
      pOOPanel_p^.BringToFront;
      pDelBut_p^.visible := false;
    end else begin                       {label row, show delete button}
      pDelBut_p^.top := bpTop;
      pDelBut_p^.left := bpLeft;
      pDelBut_p^.visible := true;
      pDelBut_p^.BringToFront;
      pOOPanel_p^.visible := false;
    end;
    pColPanel_p.visible := false;
  end else if (col = ColorCol) then begin
    ipu := (row div CTrows)*CTrows;      {rows of the labels}
    if (row <> ipu) then begin           {not label row}
      {y-coordinate of the color panel}
      ipu := 0;
      for ii := 0 to row do ipu := ipu+RowHeights[ii]+GridLineWidth;
      pColPanel_p^.top := top+ipu+GridLineWidth;
      pColPanel_p^.BringToFront;
      pColPanel_p^.visible := true;
    end else begin
      pColPanel_p^.visible := false;
    end;
    pOOPanel_p^.visible := false;
    pDelBut_p^.visible := false;
  end else if (col = IdentCol) then begin
    pOOPanel_p.visible := false;
    pDelBut_p.visible := false;
    pColPanel_p.visible := false;
    {connection of the current trafo}
  end else begin
    pOOPanel_p.visible := false;
    pDelBut_p.visible := false;
    pColPanel_p.visible := false;
  end;
end;

procedure TCurrPhasorForm.OnOffBoxMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
{complete the change of the status of the show/not flag of the selected variable}
begin
  OnOffPanel.visible := false;
  if (pActGrid <> nil) then begin
    pActGrid^.SetFocus;
    pActGrid^.DrawPhasors;
  end;  
end;

procedure TCurrPhasorForm.OnOffBoxMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
{change the status of the show/not flag of the selected variable}
begin
  OnOffBox.checked := not OnOffBox.checked;
  if (OnOffBox.checked) and (pActGrid <> nil) then
    pActGrid^.Cells[pActGrid^.actcol_p,pActGrid^.actrow_p] := '1'
  else pActGrid^.Cells[pActGrid^.actcol_p,pActGrid^.actrow_p] := '0';
end;

procedure TPhasorGrid.DeleteCTphasor(row : integer);
{delete the current trafo + data in the grid for curr.trafos, update the graph
 row  the row of the label}
var
  ii,jj  : integer;  {index}
  ipComp : longint;  {pointer to the trafo as integer}
  ipu    : integer;  {temporary}
  irow   : integer;  {index of row}
  mTrafo : integer;  {index of the trafo, in the list, 1..CTmax}
  mident : integer;  {identifier of the deleted trafo}
{ pComp  : TpComp;   {pointer to the trafo}
begin
  if (row < CTrows*nCurrTrafo_p) then begin
    mTrafo := row div CTrows+1;                 {index of trafo}
    ipComp := CTpoint_p[mTrafo];
    if (ipComp <> 0) then begin
{     pComp := TpComp(ipComp);                  {pointer to the trafo}
{     pComp^.setPWR(false);                     {clear flag }
      {send pointer of curr trafo to main program, for resetting pwr flag}
      if (pResEdit_p <> nil) then begin
        pResEdit_p^.tag := ipComp;
        pResEdit_p^.text := '1';                {causes an OnChange-event, see imagopas}
      end;
      mident := CTident_p[mTrafo];              {save the idenifier, needed = released later}
      if (nCurrTrafo_p > 0) then begin          {there are trafos}
        if (nCurrTrafo_p > 1 ) and              {more than one, must drop, but...}
           (mTrafo < nCurrTrafo_p) then begin   {no dropping for the last one}
          for ii := mTrafo to nCurrTrafo_p-1 do begin
            irow := (ii-1)*CTrows;              {index of the label row = first row of this trafo}
            for jj := 0 to CTrows-1 do begin    {copy the next = "drop"}
              Cells[ColorCol,irow+jj] := Cells[ColorCol,irow+jj+CTrows];
              Cells[OnOffCol,irow+jj] := Cells[OnOffCol,irow+jj+CTrows];
              Cells[IdentCol,irow+jj] := Cells[IdentCol,irow+jj+CTrows];
              Cells[TrafoCol,irow+jj] := Cells[TrafoCol,irow+jj+CTrows];
              Cells[DataCol ,irow+jj] := Cells[DataCol ,irow+jj+CTrows];
              IDxx_p[irow+jj] := IDxx_p[irow+jj+CTrows];  {coordinates of the identifiers}
              IDyy_p[irow+jj] := IDyy_p[irow+jj+CTrows];
              Relxx_p[irow+jj] := Relxx_p[irow+jj+CTrows];
              Relyy_p[irow+jj] := Relyy_p[irow+jj+CTrows];
            end;
            CTpoint_p[ii] := CTpoint_p[ii+1];     {copy also the pointer}
            CTident_p[ii] := CTident_p[ii+1];     {update identifiers}
          end;
        end;
        {clear the last entry}
        CTpoint_p[nCurrTrafo_p] := 0;       {clear pointer}
        CTident_p[nCurrTrafo_p] := mident;  {identifier of deleted trafo can be reused}
        {clear the grid}
        ipu := (nCurrTrafo_p-1)*CTrows;
        for ii := 0 to CTrows-1 do begin
          Cells[ColorCol,ipu+ii] := '';
          Cells[OnOffCol,ipu+ii] := '';
          Cells[IdentCol,ipu+ii] := '';
          Cells[TrafoCol,ipu+ii] := '';
          Cells[DataCol ,ipu+ii] := '';
          IDxx_p[ipu+ii] := 0;              {coordinates of the identifiers}
          IDyy_p[ipu+ii] := 0;
          Relxx_p[ipu+ii] := 0;
          Relyy_p[ipu+ii] := 0;
        end;
        dec(nCurrTrafo_p);
        if (nCurrTrafo_p <= 0) then begin   {reset the identifiers}
          for ii := 1 to maxCT do CTident_p[ii] := ii;
        end;
      end;
    end;
  end;
  {remove rows that are not needed}
  if (nCurrTrafo_p > 0) then rowcount := nCurrTrafo_p*CTrows
  else RowCount := CTrows;
  SetGridHeight;
  DrawPhasors;
end;

procedure TCurrPhasorForm.DeleteButClick(Sender: TObject);
{delete the "active" current trafo in the list, update phasor graph}
const
  row : integer = 1;
begin
  row := tag;
  CurrGrid.DelButClick(row);
  SeqGrid.DelButClick(row);
end;

procedure TPhasorGrid.DelButClick(row: integer);
{delete the "active" current trafo in the list, update phasor graph
 row   the last clicked row = row of the (X) of the  current trafo}
begin
  DeleteCTphasor(row{pForm_p^.tag});  {row saved in tag}
  pDelBut_p^.visible := false;
  pOOPanel_p^.visible := false;
  pColPanel_p^.visible := false;
  if (visible) then SetFocus;
  DrawPhasors;
end;

procedure TPhasorGrid.RemoveAllPhasors;
{clear the grid, tables and phasor picture}
var
  ii,jj : integer;
  ipu   : integer;
begin
  {the grid itself}
  for ii := 0 to rowcount-1 do begin
    for jj := 0 to colcount-1 do begin
      Cells[jj,ii] := '';
    end;
  end;
  {array of pointers and identifiers}
  for ii := 1 to maxCT do begin
    CTpoint_p[ii] := 0;      {pointers to current trafos, as integers}
    CTident_p[ii] := ii;     {keeps track of the identifiers for the phasors}
  end;
  {coordinates of identifiers}
  ipu := high(IDxx_p);       {dimension, same for all}
  for ii := 0 to ipu do begin
    IDxx_p[ii] := 0;
    IDyy_p[ii] := 0;
    Relxx_p[ii] := 0;
    Relxx_p[ii] := 0;
  end;
  nCurrTrafo_p := 0;
  rowcount := CTrows;
  SetGridHeight;
  DrawPhasors;
end;

procedure TCurrPhasorForm.FormHide(Sender: TObject);
begin
  {Imagoo.CurrPhasorBut.down := false;} {moved to imagopas.pas}
  {call an OnChange-event, see imagopas}
  if (CurrGrid.pResEdit_p <> nil) then CurrGrid.pResEdit_p.text := '2';
end;

procedure TCurrPhasorForm.ColorImageMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
{get color index from X and Y}
begin
  if (pActGrid <> nil) then pActGrid^.ColorImageMouseUp(X,Y);
end;

procedure TPhasorGrid.ColorImageMouseUp( X, Y: Integer);
{get color index from X and Y}
var
  ii,jj,kk : integer;
begin
  ii := (X div (CRwidth+CRspace))+1;
  jj := (Y div (CRwidth+CRspace))+1;
  kk := (ii-1)*4+jj;                 {color index}
  Cells[ColorCol,actrow_p] := inttostr(kk);
  pColPanel_p^.visible := false;
  Repaint;
  DrawPhasors;
end;

//procedure TPhasorGrid.DeltaImageMouseUp(x,y: integer);
//{set the mode of the displayed current; Y or delta}
//var
//  ipu : integer;
//begin
//  ipu := (pDeltaPanel_p^.height-8) div 3;
//  if (y < ipu+4) then begin             {connection is Y}
//    Cells[IdentCol,actrow_p] := 'Y';
//    pOther_p^.Cells[IdentCol,actrow_p] := 'Y'; {text also to the other grid (seq. or phase}
//  end else if (y < 2*ipu+4) then begin  {connection is delta a-b}
//    Cells[IdentCol,actrow_p] := 'Dab';
//    pOther_p^.Cells[IdentCol,actrow_p] := 'Dab';
//  end else begin                        {connection is delta a-c}
//    Cells[IdentCol,actrow_p] := 'Dac';
//    pOther_p^.Cells[IdentCol,actrow_p] := 'Dac';
//  end;
//  pDeltaPanel_p^.visible := false;
//  UpdateCurrPhasors;   {in CurrPhas.pas}
//end;

procedure TPhasorGrid.Draw_Cell(Sender: TObject; Col,
             Row: Longint; Rect: TRect; State: TGridDrawState);
var
  iclr : integer;   {color index}
  ipu  : integer;   {temporary}
  txt  : string;    {temporary}
  txta : string;    {temporary}
begin
  {column for the selection of the color}
  if (col = ColorCol) then begin
    ipu := (row div CTrows)*CTrows;              {label row}
    if (row <> ipu) then begin                   {not label row}
      txt := cells[col,row];
      if (txt <> '') then begin
        iclr := strtoint(txt);
        if (iclr < 1) then iclr := 1;
        if (iclr > 16) then iclr := 16;
        canvas.pen.color := gColor[iclr];
        canvas.brush.color := gColor[iclr];
        {a rectangle indicates the color}
        canvas.rectangle(rect.left+GridLineWidth,
                                 rect.top +GridLineWidth,
                       rect.left+ColWidths[col]-GridLineWidth,
                       rect.top+RowHeights[row]-GridLineWidth);
      end;
    end;
  {column for the identifier of the phasor}
  end else if (col = IdentCol) then begin
    ipu := (row div CTrows)*CTrows;              {label row}
    if (row <> ipu) then begin                   {not label row}
      txta := cells[col,row];                    {identifier}
      txt := cells[ColorCol,row];                {color index}
      if (txt <> '') and (txta <> '') then begin {color and identifier specified}
        iclr := strtoint(txt);
        if (iclr < 1) then iclr := 1;
        if (iclr > 16) then iclr := 16;
        {write the identifier in colors}
        canvas.font.style := [fsBold];
        canvas.font.name := 'Arial';
        canvas.font.size := 8;
        canvas.font.color := gColor[iclr];
        canvas.brush.style := bsSolid;
        canvas.TextOut(2+rect.left,rect.top,txta);
      end;
    end;
  end;
end;

procedure TCurrPhasorForm.FormDeactivate(Sender: TObject);
begin
  OnOffPanel.visible := false;
  DeleteBut.visible := false;
  ColorPanel.visible := false;
end;
(*
procedure UpdatePhasors;
{update the phasors (after some new calculation)}
var
  curr   : Tmultix;   {currents = magnitude and phase (in degrees)}
  ii     : integer;   {index}
  ipComp : longint;   {pointer to the current trafos, as integer}
  nCT    : integer;   {number of current trafos}
begin
  {read the currents from the current trafos in the grid of the graph}
  nCT := CurrGrid.NoOfItems;                   {number of current trafos}
  if (nCT > 0) then begin
    for ii := 1 to nCT do begin                {all current trafos}
      ipComp := CurrGrid.GetIp(ii);
      GetCurrents(ipComp,curr.u,curr.v,curr.w,curr.x,curr.y,curr.z); {read currents}
      CurrGrid.UpdatePhasors(cRead,@curr,ii);  {update the phasor graphs}
    end;
    SeqGrid.UpdatePhasors(cCopy,nil,0);        {update also the sequence currents}
  end;
end;
*)
procedure TPhasorGrid.UpdatePhasors(how : TReadOrCopy; pCurr: TpMultix; ii: integer);
{update the phasors (after some new calculation
 how    use data from input, or copy from the other phasor display
 pCurr  pointer to the currents or voltages (not needed when copying)
 ii     index of the current trafo (not needed when copying)}
var
  Aa,Ab,Ac : single;   {phase of currents, in degrees}
  Ca,Cb,Cc : single;   {magnitude of currents}
  info     : string;   {additional info of the comp or winding or  ('prim', 'sec')}
  jj       : integer;    {index}
  ipComp   : longint;    {pointer to a current trafo as integer}
begin
  if (nCurrTrafo_p > 0) then begin
    if (how = cRead) or (how = vRead) then begin {use data from input}
      Ca := pCurr^.u;                            {magnitude of phase a}
      Aa := pCurr^.v;                            {angle of phase a}
      Cb := pCurr^.w;
      Ab := pCurr^.x;
      Cc := pCurr^.y;
      Ac := pCurr^.z;
      CurrentsToGrid(Ca,Aa,Cb,Ab,Cc,Ac,ii);       {write currents or voltages to the grid}
    end else begin                                {copy from the other phasor display}
      for jj := 1 to nCurrTrafo_p do begin
        ipComp := CTpoint_p[jj];                  {pointers to the current trafos}
        info := cells[IdentCol,(jj-1)*CTrows];
        CopyToSequence(ipComp,info,Ca,Aa,Cb,Ab,Cc,Ac); {seq.comp in polar form}
        CurrentsToGrid(Ca,Aa,Cb,Ab,Cc,Ac,jj);     {write currents or voltages to the grid}
      end;
    end;
    DrawPhasors;
  end;
end;

procedure TPhasorGrid.CurrentsFromGrid;
{extract the current (phase and magnitude) from the values as text in the grid
 Curr_p   the magnitude of the current
 Angle_p  the phase of the current in radians (text in degrees)}
var
  apu,apv : single;    {temporary}
  ii,jj   : integer;   {index}
  irow    : integer;   {row index}
  line    : string;    {one line of text}
  multi   : single;    {multiplier for units}
begin
  for ii := 0 to high(Curr_p) do begin
    Curr_p[ii] := 0;                   {initialize}
    Angle_p[ii] := 0;
  end;
  for ii := 1 to nCurrTrafo_p do begin
    irow := (ii-1)*CTrows;             {index of the first row of this current trafo}
    for jj := 1 to 3 do begin
      line := Cells[{TrafoCol}DataCol,irow+jj];
      ExtractCurrent(line,apu,apv);
      Angle_p[(ii-1)*CTrows+jj] := apv*pi/180;    {save angle in radians}
      Curr_p[(ii-1)*CTrows+jj] := apu;            {save magnitude}
    end;
  end;
end;

procedure TPhasorGrid.CopyToSequence(ipComp : longint; info: string; var Cp,Ap,Cn,An,Cz,Az : single);
{extract the current (phase and magnitude) from the values as text in the other grid
 for  the given current trafo,
 convert to sequence variables, and save as text in this grid
 ipComp  pointer to the current trafo, as integer
 info    info displayed in the grid, used also as identifier of winding
 Cp,Ap etc,  magnitude (or 3*magnitude) and phase (degrees) of +,-,0 seq. currents}
var
  angle    : single;    {phase angle in radians}
  apu,apv  : single;    {temporary}
  curr     : single;    {magnitude of the current}
  ii,jj    : integer;   {index}
  Ip,Im,Iz : complex;  {symmetrcial components of the currents}
  irow     : integer;   {row index}
  line     : string;    {one line of text}
  Icx      : array[1..3] of complex;    {real and imag.parts of the currents}

begin
  for ii := 1 to pOther_p^.nCurrTrafo_p do begin
    {scan the comp., look for the corresponding comp. in the other grid}
    if (pOther_p^.CTpoint_p[ii] = ipComp) and
       (pOther_p^.cells[IdentCol,(ii-1)*CTRows] = info)  then begin
      irow := (ii-1)*CTrows;             {index of the first row of this current trafo}
      for jj := 1 to 3 do begin
        line := pOther_p^.Cells[DataCol,irow+jj];
        ExtractCurrent(line,curr,apv);
        angle := apv*pi/180;             {angle in radians}
        apu := curr*cos(angle);          {to real and imag.parts}
        apv := curr*sin(angle);
        Icx[jj] := cplx(apu,apv);
      end;
      PhaseToSeq(Icx[1],Icx[2],Icx[3],Ip,Im,Iz); {to sequence comp, in Twoshort.pas}
      {get magnitude or 3*magnitude and phase}  {but transformers??, voltages??}
//    if (CurrPhasorForm.NoMultItem.checked) then apu := 1 else apu := 3;
      if (p1Item_p <> nil) and (p3Item_p <> nil) then begin
        if (p1Item_p.checked) then apu := 1 else apu := 3;
      end else begin
        apu := 1;
      end;
      Cp  := Cabs(Ip);
      Ap := Cangle(Ip)*180/pi;
      Cn  := apu*Cabs(Im);
      An := Cangle(Im)*180/pi;
      Cz  := apu*Cabs(Iz);
      Az := Cangle(Iz)*180/pi;
      break;
    end else begin
      Cp := 0; Ap := 0;
      Cn := 0; An := 0;
      Cz := 0; Az := 0;
    end;
  end;
end;

procedure TPhasorGrid.MultiplierForUnit(var multi: single; var multiunit: string);
{determine the multiplier for kilo or basic unit}
var
  pSet : TpCompSet;
begin
  {the matrix calculator does not know the "common" CompSet}
  if (filename_p <> 'matrixpr') then begin
    pSet := TpCompSet(ipSet_p);
    if ((Unit_p = 'A') and (pSet^.unit_A = 1)) or
       ((Unit_p = 'V') and (pSet^.unit_V = 1)) then begin
      multi := 0.001;  {kA or kV}
      multiunit := 'k';
    end else begin
      multi := 1;      { A or V }
      multiunit := '';
    end;
  end else begin
    multi := 1;      { A or V }
    multiunit := '';
  end;
end;

procedure TPhasorGrid.GetCompPointer(ii: integer; var ipComp: longint);
{get pointer of component ii, as longint}
begin
  if (ii > 0) and (ii <= maxCT) then begin
    ipComp := CTPoint_p[ii];
  end else begin
    ipComp := 0;
  end;
end;

function TPhasorGrid.GetMaxCT: integer;
{get the max.number of components (current trafos) = dimension of arrays}
begin
  GetMaxCT := maxCT;
end;  


//procedure TPhasorGrid.GetDelt(ipComp: longint; var delt: single);
//{get flag for selecting Y, Delta a-b, or Delta a-c (for current)
//ipComp   pointer to the current trafo
//delt     flag for the connection 0 = Y, 1= Da-b, 2= Da-c}
//var
//  ii  : integer;  {index}
//  ll  : longint;  {temporary}
//  row : integer;  {row where the ID of the ct is}
//  txt : string;   {temporary}
//begin
//  if (ipComp <> 0) and (isThere(ipComp, row)) then begin  {search for the row of the CT}
//    txt := cells[IdentCol,row];       {connection type}
//    if (txt = 'Y') then delt := 0
//    else if (txt = 'Dab') then delt := 1
//    else if (txt = 'Dac') then delt := 2
//    else delt := 0;
//  end else begin
//    delt := 0;         {default value}
//  end;
//end;

procedure TPhasorGrid.DetermineScale;
{determine the scale for the phasor diagram
 scales_p    the array for the normalized currents to be used for the largest circle
 Curr_p      the magnitudes  of the currents in the grid
 iscale_p    index for the for the (normalized) current of the largest circle
             (index for the array "scales")
 scalfact_p  multiplier to get the abs. current of the largest circle
             (multiplies the value scales[iscale])}
var
  apu      : single;    {temporary}
  decad    : integer;   {the decade of the max.current}
  dimscale : integer;   {dimension of the scales-array}
  ii,jj    : integer;   {indices}
  lgmax    : single;    {log(10) of the max.current}
  maxCur   : single;    {maximum current}
  multi    : single;    {multiplier due to units kilo or basic}
  munit    : string;    {k or nothing}
  normcur  : single;    {normalized max.current}
begin
  MultiplierForUnit(multi,munit);
  dimscale := high(scales_p);
{showmessage(inttostr(low(scales))+'  '+inttostr(dimscale));}
  {find max.current}
  maxCur := 0;
  for ii := 1 to CTrows*nCurrTrafo_p do begin
    if (Curr_p[ii] > maxCur) then maxCur := Curr_p[ii];
  end;
  maxCur := maxCur*multi;             {take units into account}
  {determine scale}
  if (maxCur > 0) then begin
    lgmax := ln(maxCur)/ln10;         {lg(max current)}
    {the decade: 0.1 .. 1 = decade 0, 1..10 = decade 1, etc}
    if (lgmax > 0) then decad := trunc(lgmax)+1
    else decad := trunc(lgmax);       {decade of current}
    {normalize between 10 and 100}
    apu := exp(decad*ln10);           {ten to decade = 1, 10, 100, etc}
    normcur := maxCur*100/apu;        {normalized max current}
    scalfact_p := 0.01*apu;           {multiplier for scale[.]}
    {find scale, a simple search}
    iscale_p := 1;                    {initialize, just in case}
    for ii := 1 to dimscale-1 do begin
      jj := dimscale-ii;              {downwards}
      if (normcur > scales_p[jj]) then begin
        iscale_p := jj+1;
        break;
      end;
    end;
  end else begin
    iscale_p := 1;
    scalfact_p := 0.1;
  end;
end;

procedure TPhasorGrid.DrawCircles(Toile: TCanvas);
{draw the circles and the lines at 15 deg. intervals for the phasor display
 scales_p    the array for the possible (nromalized) max.scales
 steps_p     the array for the steps between the circles (in terms of currents)
 scalfact_p  multiplier for the abs.scale from the normalized scale
 iscale_p    index of the largest circle (in array "scales")
 jscale_p    modified index (if the arrow keys have been used)
 Toile       canvas, on which drawn}
var
  alpha       : single;           {angle}
  apu,apv     : single;           {temporary}
  coleur      : Tcolor;
  diami       : integer;          {diameter of circle i}
  dimSc       : integer;          {dimension of the scales and steps arrays}
  ii          : integer;          {index}
  ipu,ipv     : integer;          {temporary}
  ixp,iyp     : integer;          {coordinates}
  ixm,iym     : integer;          {coordinates}
  ix180,iy180 : integer;          {text position for 180 deg.}
  ll          : longint;          {temporary}
  ncirc       : integer;          {no of circles}
  n15         : integer;          {multiply of 15, for marking the angles}
  txh,txw     : integer;          {height, width of text}
  txt         : string;           {temporary}
  tx180       : string;           {text for 180 deg.}

begin
  {clear old image first}
  {white or light gray background, depending on the display time}
{ if (pSet_p^.displ_time <= 0) then coleur := clWhite else coleur := $00F0F0F0;}
  Toile.pen.color := clWhite;
  Toile.brush.color := clWhite;
  Toile.brush.style := bsSolid;
  Toile.rectangle(0,0,pCimage_p^.width,pCimage_p^.height);
  Toile.pen.width := 1;
  Toile.pen.color := clSilver;
  Toile.brush.color := clWhite;
  Toile.brush.style := bsClear;
  {set font for markings}
  Toile.font.name := 'arial';
  Toile.font.size := 8;
  Toile.font.color := clBlack;
  Toile.font.style := [];
  {draw the circles, if image large enough}
  dimSc := high(scales_p);
  if (pCimage_p^.width > 2*Imarg) then begin
    diamax_p := pCimage_p^.width-2*Imarg;    {diameter of the largest circle}
    ix180 := 0;                             {initialize, to keep...}
    iy180 := 0;                             {..the compiler happy}
    tx180 := '';
    {draw angled lines, every 15 degrees}
    for ii := 0 to 11 do begin
      alpha := ii*0.2617994;                     {ii* 15 degrees}
      ipu := round((diamax_p div 2)*cos(alpha));
      ipv := round((diamax_p div 2)*sin(alpha));
      ixp := (pCimage_p^.width div 2)+ipu;
      iym := (pCimage_p^.width div 2)-ipv;
      ixm := ixp-2*ipu;
      iyp := iym+2*ipv;
      Toile.moveto(ixp,iym);
      Toile.lineto(ixm,iyp);
      {write the angles, 0, 45, 90,.. etc}
      if (ii div 3 = ii/3.0) then begin
        n15 := ii*15;                                   {the angle}
        txt := inttostr(n15)+'';
        txh := Toile.textheight(txt);       {height of text}
        txw := Toile.textwidth(txt);        {width of text}
        ipv := round(0.5*txh*( 1+sin(alpha)));
        ipu := round(-0.5*txw+(0.5*txw+2)*cos(alpha));  {shift of text in x-direction}
        Toile.textout(ixp+ipu,iym-ipv,txt);
        {texts to the other side}
        txt := inttostr(n15+180)+'';
        txh := Toile.textheight(txt);       {height of text}
        txw := Toile.textwidth(txt);        {width of text}
        ipv := round(0.5*txh*( 1+sin(alpha+pi)));
        ipu := round(-0.5*txw+(0.5*txw+2)*cos(alpha+pi));  {shift of text in x-direction}
        {180 differently, later, in order to save drawing area. Save parameters}
        if (ii = 0) then begin
          ix180 := ixm+ipu+txw;
          iy180 := iyp-ipv;
          tx180 := txt;
          {draw later}
        end else begin
          Toile.textout(ixm+ipu,iyp-ipv,txt);
        end;
      end;
    end;
    {check the eventual change in scales}
    if (modScale_p <> 0) then begin
      if (iscale_p+modScale_p > 1) then begin
        ipu := (iscale_p+modScale_p) div (dimSc-1);      {decades}
        jscale_p := iscale_p+modScale_p-ipu*(dimSc-1);   {modified scale}
        if (jscale_p = 0) then begin
          jscale_p := dimSc-1;
          ipu := ipu-1;
        end;
        apu := exp(ipu*ln10);                            {decade as number}
        maxScale_p := apu*scalfact_p*scales_p[jscale_p];
      end else if (iscale_p+modScale_p = 1) then begin
        jscale_p := 1;
        maxScale_p := scalfact_p*scales_p[jscale_p];
      end else begin   {downwards, below default decade}
        ipu := ((iscale_p+modScale_p) div (dimSc-1))-1;  {decades}
        jscale_p := iscale_p+modScale_p-ipu*(dimSc-1);   {modified scale}
        if (jscale_p = 0) then begin
          jscale_p := dimSc-1;
          ipu := ipu-1;
        end;
        apu := exp(ipu*ln10);                            {decade as number}
        maxScale_p := apu*scalfact_p*scales_p[jscale_p];
        if (maxScale_p < 0.1) then maxScale_p := 0.1;
      end;
    end else begin
      maxScale_p := scalfact_p*scales_p[iscale_p];       {current of the max.circle}
      jscale_p := iscale_p;
    end;
    {draw the circles}
    apu := scales_p[jscale_p]/steps_p[jscale_p];
    ncirc := round(apu);                                 {no of circles}
    for ii := 1 to ncirc do begin                        {draw ncirc circles}
      {clear the inside of the smallest circle, because it is getting crowded}
      if (ii = 1) then {pCimage_p^.canvas}Toile.brush.style := bsSolid
      else Toile.brush.style := bsClear;
      diami := round(ii*diamax_p/ncirc);
      ipu := ((pCimage_p^.width-diami)div 2);            {upper left corner}
      Toile.ellipse(ipu,ipu,ipu+diami,ipu+diami); {the circle}
    end;
    {mark 180 degrees}
    Toile.brush.style := bsSolid;
    Toile.font.style := [];
    Toile.textout(ix180,iy180,tx180);
    {first, mark the scale (max.value) (when maxScale calculated)}
    if (maxScale_p >= 10) then begin
      ll := round(maxScale_p);
      txt := inttostr(ll)+' '+multi_p+unit_p;
    end else begin
      apu := int(maxScale_p);
      apv := 10*frac(maxScale_p);
      ipv := round(apv);
      if (ipv < 10) then begin
        ipu := round(apu);
        txt := inttostr(ipu)+','+inttostr(ipv)+' '+multi_p+unit_p;;
      end else begin
        ipu := round(apu)+1;
        txt := inttostr(ipu)+' '+multi_p+unit_p;;
      end;
    end;
    txh := Toile.textheight(txt);         {height of text}
    txw := Toile.textwidth(txt);          {width of text}
    ipu := (pCimage_p^.width-txw) div 2;
    ipv := (pCimage_p^.height-diamax_p) div 2;
    Toile.textout(ipu,ipv,txt);
  end;
end;

procedure TphasorGrid.PhasorLines(Toile: TCanvas);
{draw the phasor lines to the phasor diagram
 Curr_p  the magnitude of the currents
 Angle_p the phase angle (in radians)
 Toile   canvas on which drawn}
var
  apu         : single;   {temporary}
  cx,cy       : integer;  {cooridnates of origo = center of the image}
  ii,jj,kk    : integer;  {indices}
  ix,iy       : integer;  {coordinates}
  ipu,ipv     : integer;  {temporary}
  multi       : single;   {multiplier for kilo or basic units}
  munit       : string;   {k or nothing}
  txh,txw     : integer;  {height, width of text}
  txt         : string;   {temporary}
begin
  MultiplierForUnit(multi,munit);                    {kilo or basic units}
  for ii := 1 to nCurrTrafo_p do begin               {all currents}
    for jj := 1 to 3 do begin
      kk := (ii-1)*CTrows+jj;
      if (Cells[OnOffCol,kk] <> '0') then begin      {allowed to draw}
        txt := cells[ColorCol,kk];
        ipu := strtoint(txt);
        Toile.pen.color := gColor[ipu];  {color}
        Toile.pen.width := 2;
        apu := multi*0.5*diamax_p*Curr_p[kk]/maxScale_p;   {magnitude in graph}
        ix := round(apu*cos(Angle_p[kk]));           {relative x of endpoint}
        iy := round(apu*sin(Angle_p[kk]));           {relative y of endpoint}
        cx := pCimage_p^.width div 2;
        cy := pCimage_p^.height div 2;
        {pCimage_p^.canvas}Toile.moveto(cx,cy);             {start from origo}
        {must be within the image}
        if (cy-iy < 0) then ipv := 0
        else if (cy-iy < pCimage_p^.height) then ipv := cy-iy
        else ipv := pCimage_p^.height;
        {then y-coordinate}
        if (cx+ix < 0) then ipu := 0
        else if (cx+ix < pCimage_p^.width) then ipu := cx+ix
        else ipu := pCimage_p^.width;
        {pCimage_p^.canvas}Toile.lineto(cx+ix,cy-iy);       {draw phasor}
        {identifier of the current}
        txt := Cells[identCol,kk];                   {identifier}
        txh := Toile.textheight(txt);                {height of text}
        txw := Toile.textwidth(txt);                 {width of text}
        ipv := round(0.5*txh*( 1+sin(Angle_p[kk])));
        ipu := round(-0.5*txw+(0.5*txw+2)*cos(Angle_p[kk]));  {shift of text in x-direction}
        Toile.font.color := Toile.pen.color; {color of text = color of line}
        Toile.font.style := [fsBold];
        if (writeID_p) then
          Toile.textout(cx+ix+ipu+Relxx_p[kk],cy-iy-ipv+Relyy_p[kk],txt);   {write the identifier}
        {save the basic position of the identifier}
        IDxx_p[kk] := cx+ix+ipu;
        IDyy_p[kk] := cy-iy-ipv;
      end;
    end;
  end;
end;

procedure TPhasorGrid.DrawPhasors;
{determine the scale and draw the phasors}
//var
//conn    : single;   {connection of the CT, wye or delta}
//ii      : integer;
//Ipr,Isc : single;   {nominal prim., sec.currents of the CT}
//ix,iy   : integer;
//lbl     : string;
//irow    : integer;  {row index}
//mode    : single;   {output mode of the CT, prim or sec, or relative sec}
//pComp   : TpComp;   {pointer to the current trafo}
//ratio   : single;   {transformation ratio of the CT}
begin
  if (nCurrTrafo_p > 0) then begin     {there are currents to be drawn}
    {extract the currents from the text in the grid}
    CurrentsFromGrid;
    {determine scale = index and scaling fact. for the largest circle}
    DetermineScale;
    {draw the circles and lines for the angles}
    DrawCircles(pCImage_p^.canvas);
    {draw the phasors}
    if (pCimage_p^.width > 2*Imarg) then begin
      PhasorLines(pCImage_p^.canvas);
    end;
  end else begin    {no trafos selected, clear the image}
    pCimage_p^.canvas.pen.color := clWhite;
    pCimage_p^.canvas.brush.color := clWhite;
    pCimage_p^.canvas.brush.style := bsSolid;
    pCimage_p^.canvas.rectangle(0,0,pCimage_p^.width,pCimage_p^.height);
  end;
end;

procedure TPhasorGrid.MoveIdentifier(x,y : integer);
{move the identifier on the phasor image to the point given by x,y}
var
  ipu : integer;
begin
  if (downkk_p >= 0) and (downkk_p <= maxCT*CTrows-1) then begin {reasonable index}
    {check that not too far to the left or right}
    ipu := Relxx_p[downkk_p]+x-downx0_p;              {shift in x-direction}
    if (ipu+IDxx_p[downkk_p] > 0) and                 {not too far to the left..}
       (ipu+IDxx_p[downkk_p] < pCimage_p^.width-12) then begin  {..or right}
      Relxx_p[downkk_p] := ipu;                       {move with the mouse}
    end else begin
      if (ipu+IDxx_p[downkk_p] <= 0) then
        Relxx_p[downkk_p] := -IDxx_p[downkk_p]        {left}
      else Relxx_p[downkk_p] :=
        width-12-IDxx_p[downkk_p];
    end;
    {check that not too far up or down}
    ipu := Relyy_p[downkk_p]+y-downy0_p;              {shift in y-direction}
    if (ipu+IDyy_p[downkk_p] > 0) and                 {not too far up..}
       (ipu+IDyy_p[downkk_p] < pCimage_p^.height-12) then begin  {..or down}
      Relyy_p[downkk_p] := ipu;                       {move with the mouse}
    end else begin
      if (ipu+IDyy_p[downkk_p] <= 0) then
        Relyy_p[downkk_p] := -IDyy_p[downkk_p] {up}
      else Relyy_p[downkk_p] :=
        pCImage_p^.height-12-IDyy_p[downkk_p];
    end;
    DrawPhasors;                                      {update phasors with the new ID position}
  end;
end;

procedure TPhasorGrid.CursorCurrent(x,y : integer);
{show the current corresponding to the cursor position}
var
  apu       : single;     {temporary}
  curx,cury : single;     {the values of current at the cursor position}
  deg       : single;     {phase of current in degrees}
  ii        : integer;
  ix,iy     : integer;    {coordinates in the phasor diagram}
  kAorA     : string;     {unit of current or voltage}
  len       : integer;    {length of string}
  magn      : single;     {magnitude of current}
  multi     : single;     {multiplier for untis}
  munit     : string;     { k or nothing}
//pSet      : TpCompSet;  {pointer to the common}
  txta,txtb : string;     {temporary text}
  txtc      : string;
begin
//  pSet := TpCompSet(ipSet_p);
//  if (pSet^.unit_A = 1) then kAorA := 'kA' else kAorA := 'A';
  MultiplierForUnit(multi,munit);
  kAorA := munit+unit_p;               {A or kA, or V or kV}
  {show the current corresponding to the cursor position}
  if (nCurrTrafo_p > 0) then begin     {but only, if there are phasors}
    ix := x-(pCimage_p^.width div 2);
    iy := (pCimage_p^.height div 2)-y;
    apu := 2*sqrt(ix*ix+iy*iy);
    if (diamax_p > 0) and (apu < diamax_p+16) then begin
      pCImage_p^.cursor := crCross;
      curx := 2*maxScale_p*ix/diamax_p;       {real current}
      cury := 2*maxScale_p*iy/diamax_p;       {imag.current}
      txta := format('%9.4g',[curx])+' ';
      if (cury >= 0) then txtb := '+' else txtb := '';
      txtb := txtb+format('%9.4g',[cury]);
      len := length(txtb);
      {remove spaces}
      txtc := '';
      for ii := 1 to len do begin
        if (txtb[ii] <> ' ') then txtc := txtc+txtb[ii];
      end;
      txta := txta+txtc+'j '+kAorA+' ';                 {current in rect.form}
      {display also in polar form}
      magn := sqrt(curx*curx+cury*cury);        {magnitude}
      deg := 180*Cangle(cplx(curx,cury))/pi;    {phase angle}
      pPEdit_p^.text := txta+                   {real + imag.}
        ' = '+format('%9.4g',[magn])+' '+kAorA+'  < '+format('%6.1f',[deg])+' '; {magnitude + angle}
    end else begin
      pCImage_p^.cursor := crDefault;
      pPEdit_p.text := '';
    end;
  end else begin
    pCImage_p^.cursor := crDefault;
    pPEdit_p.text := '';
  end;
end;

procedure TPhasorGrid.StartIdentifierIf(x,y : integer);
{start the moving of an identifier, if cursor on the identifier
 x,y   cursor position}
var
  ii,jj : integer; {indices}
  ix,iy : integer; {coordinates of the identifiers}
  kk    : integer;
begin
  {is the cursor at an identifier?}
  if (nCurrTrafo_p > 0) then begin
    for ii := 1 to nCurrTrafo_p do begin
      for jj := 1 to 3 do begin
        kk := (ii-1)*CTrows+jj;                   {"row" = index of the current}
        if (Cells[IdentCol,kk] <> '0') then begin {phasor visible}
          ix := IDxx_p[kk]+Relxx_p[kk];           {x of the identifier}
          iy := IDyy_p[kk]+Relyy_p[kk];           {y of the ID}
          if (x > ix-2) and (x < ix+14) and       {mouse at identifier}
             (y > iy-2) and (y < iy+14) then begin
            pIDrec_p^.left := pCImage_p^.left+ix;
            pIDrec_p^.top := pCImage_p^.top+iy;
            pIDrec_p^.BringToFront;
            pIDrec_p^.visible := true;
            downx0_p := x;                        {save down-coordinates}
            downy0_p := y;
            downkk_p := kk;                       {save index}
            break;
          end;
        end;
      end;
    end;
  end;
end;

procedure TPhasorGrid.FormResizeUpper(pForm : TpForm);
{resize the upper image and move the upper grid correspondingly
 when resizing the form
 pForm   pointer to the form}
var
  ipu,ipv,ipw : integer; {temporary}
begin
  left := pForm^.width-CgridMarg-width;           {move the grid}
  {must clear first, else cannot change size}
  pCimage_p^.picture := nil;                      {clear image first}
  {the positions of items depends on what is shown}
  if (view_p = both) then begin                  {phase and sequence shown}
    {the size of the image}
    ipu := left-CimagMarg;
    ipv := (pForm^.height-4*editmarg-2*pPEdit_p^.height-botmarg) div 2;
    if (ipu < ipv) then ipw := ipu else ipw := ipv;
    if (ipw > 64) then pCimage_p^.width := ipw
    else pCimage_p^.width := 64;
    pCimage_p^.height := pCimage_p^.width;        {square image}
    pPEdit_p.top := pCimage_p^.top+pCimage_p^.height+editmarg;
    pCaption_p^.left := pCimage_p^.width-(pCimage_p^.width div 3);
{    pCaption_p^.left := pForm^.width div 2;       {the label (or caption) in the middle}
  end else if (view_p = phase) then begin         {only phase components shown}
    {the height of the image}
    ipu := left-CimagMarg;
    ipv := pForm^.height-2*editmarg-pPEdit_p^.height-botmarg;
    if (ipu < ipv) then ipw := ipu else ipw := ipv;
    if (ipw > 64) then pCimage_p^.width := ipw
    else pCimage_p^.width := 64;
    pCimage_p^.height := pCimage_p^.width;         {square image}
    pPEdit_p^.top := pCimage_p^.top+pCimage_p^.height+editmarg;
{   pCaption_p^.left := width div 2;               {the label (or caption) in the middle}
    pCaption_p^.left := pCimage_p^.width-(pCimage_p^.width div 3);
    {same size to seq. image, needed, if switched to other image}
    pOther_p^.pCimage_p^.width := pCimage_p^.width;
    pOther_p^.pCimage_p^.height := pOther_p^.pCimage_p^.width;
  end else if (view_p = seq) then begin    {only sequence components shown}
    {do nothing here, values are set in theFormResizeLower-procedure}
  end else begin
    {error case ??}
  end;
  DrawPhasors;                          {update phasors}
end;

procedure TPhasorGrid.FormResizeLower(pForm : TpForm);
{resize the lower image and move the lower grid correspondingly,
 when the form is resized
 pForm  pointer to the form}
var
  ipu,ipv,ipw : integer; {temporary}
begin
  pCimage_p^.picture := nil;                     {clear image first}
  left := pOther_p^.left;
  {the positions of items depends on what is shown}
  if (view_p = both) then begin                {phase and sequence shown}
    pCimage_p^.width := pOther_p^.pCimage_p^.width;
    pCimage_p^.height := pCimage_p^.width;
    ipu := (pForm^.height-botmarg) div 2;
    ipv := pOther_p^.pCaption_p^.top+pOther_p^.pCaption_p^.height+editmarg;
    if (ipu > ipv) then pCimage_p^.top := ipu
    else pCimage_p^.top := ipv;
    pPedit_p^.top := pCimage_p^.top+pCimage_p^.height+editmarg;
    pCaption_p^.left := pCimage_p^.width-(pCimage_p^.width div 3);
    pCaption_p^.top := pCimage_p^.top;
    top := pCimage_p^.top+24;
  end else if (view_p = phase) then begin       {only phase components shown}
    {values set in FormResizeUpper}
  end else if (view_p = seq) then begin    {only sequence components shown}
    {the height of the image}
    ipu := left-CimagMarg;
    ipv := pForm^.height-2*editmarg-pCaption_p^.height-botmarg;
    if (ipu < ipv) then ipw := ipu else ipw := ipv;
    if (ipw > 64) then pCimage_p^.width := ipw
    else pCimage_p^.width := 64;
    pCimage_p^.height := pCimage_p^.width;   {square image}
    pPEdit_p^.top := pCimage_p^.top+pCimage_p^.height+editmarg;
    pCaption_p^.left := pCimage_p^.width-(pCimage_p^.width div 2);
    {same size to seq. image, needed, if switched to other image}
    pOther_p^.pCimage_p^.width := pCimage_p^.width;
    pOther_p^.pCimage_p^.height := pOther_p^.pCimage_p^.width;
  end else begin
    {error case ??}
  end;
  DrawPhasors;                           {update phasors}
end;

procedure TPhasorGrid.PhasePhaseID;
{change the end of a voltage identifier (in the grid) from
a to ab, b to bc, c to ca}
var
  ii,jj,kk : integer;
  irow     : integer;  {row index}
  lblrow   : integer;  {row indexof the label row}
  len      : integer;  {length of text}
  txa,txb  : string;   {temporary}
begin
  if (nCurrTrafo_p > 0) then begin
    for ii := 1 to nCurrTrafo_p do begin
      lblrow := (ii-1)*CTrows;               {row of the label}
      for jj := 1 to 3 do begin
        irow := lblrow+jj;
        txa := Cells[IdentCol,irow];         {present identifier}
        len := length(txa);                  {length of identifier}
        txb := '';
        for kk := 1 to len do begin
          if (txa[kk] = 'a') then begin
            txb := txb+'ab';
            break;
          end else if (txa[kk] = 'b') then begin
            txb := txb+'bc';
            break;
          end else if (txa[kk] = 'c') then begin
            txb := txb+'ca';
            break;
          end else begin
            txb := txb+txa[kk];
          end;
        end;
        Cells[IdentCol,irow] := txb;          {new identifier}
      end;
    end;
  end;
end;

procedure TPhasorGrid.PhaseNeutralID;
{change the end of a voltage identifier (in the grid) from
ab to a, bc to b, ca to c}
var
  ii,jj,kk : integer;
  irow     : integer;  {row index}
  lblrow   : integer;  {row indexof the label row}
  len      : integer;  {length of text}
  txa,txb  : string;   {temporary}
begin
  if (nCurrTrafo_p > 0) then begin
    for ii := 1 to nCurrTrafo_p do begin
      lblrow := (ii-1)*CTrows;               {row of the label}
      for jj := 1 to 3 do begin
        irow := lblrow+jj;
        txa := Cells[IdentCol,irow];         {present identifier}
        len := length(txa);                  {length of identifier}
        txb := '';
        for kk := 1 to len do begin
          if (txa[kk] = 'a') then begin
            txb := txb+'a';
            break;
          end else if (txa[kk] = 'b') then begin
            txb := txb+'b';
            break;
          end else if (txa[kk] = 'c') then begin
            txb := txb+'c';
            break;
          {the same with capitals}
          end else if (txa[kk] = 'A') then begin
            txb := txb+'A';
            break;
          end else if (txa[kk] = 'B') then begin
            txb := txb+'B';
            break;
          end else if (txa[kk] = 'C') then begin
            txb := txb+'C';
            break;
          end else begin
            txb := txb+txa[kk];
          end;
        end;
        Cells[IdentCol,irow] := txb;          {new identifier}
      end;
    end;
  end;
end;

procedure TPhasorGrid.WindingCurrentID;
{change the end of a current identifier (in the grid) from
A to AB, B to BC, C to CA for the delta windings of transformers}
var
  Dflag    : single;   {flag for delta winding}
  ii,jj,kk : integer;
  irow     : integer;  {row index}
  lblrow   : integer;  {row indexof the label row}
  len      : integer;  {length of text}
  ll       : longint;  {temporary}
  name     : string;   {name = type of the component}
  pComp    : TpComp;   {pointer to the trafo}
  side     : string;   {side or winding (prim, sec. tert) of the trafo}
  txa,txb  : string;   {temporary}
  yyd      : single;   {flag for yyd-trafo}
begin
  if (nCurrTrafo_p > 0) then begin
    for ii := 1 to nCurrTrafo_p do begin
      ll := CTpoint_p[ii];
      pComp := TpComp(ll);                   {pointer to the trafo}
      pComp^.GetName(name);                  {name = type of the component}
      if (name = gTrafo3W) then pComp^.GetPar(g3w_type,yyd) {flag for YYY or YYD-trafo}
      else yyd := 0;
      if (name = gAtrafo) then pComp.GetPar(gAtrafo_D,Dflag)
      else Dflag := 0;
      lblrow := (ii-1)*CTrows;               {row of the label}
      side := cells[IdentCol,lblrow];        {winding, or trafo side}
      {change identifiers, but only for D-windings}
      if ((name = gTrafoYD) and (side = 'sec.')) or
         ((name = gTrafoDY) and (side = 'prim')) or
          (name = gTrafoDD) or
         ((name = gTrafo3W) and (side = 'tert') and (yyd = 2)) or
         ((name = gAtrafo ) and (side = 'tert') and (Dflag <> 0)) then begin
        for jj := 1 to 3 do begin
          irow := lblrow+jj;
          txa := Cells[IdentCol,irow];         {present identifier}
          len := length(txa);                  {length of identifier}
          txb := '';
          for kk := 1 to len do begin
            if (txa[kk] = 'A') then begin
              txb := txb+'AB';
              break;
            end else if (txa[kk] = 'B') then begin
              txb := txb+'BC';
              break;
            end else if (txa[kk] = 'C') then begin
              txb := txb+'CA';
              break;
            end else begin
              txb := txb+txa[kk];
            end;
          end;
          Cells[IdentCol,irow] := txb;          {new identifier}
        end;
      end;
    end;
  end;
end;

procedure TPhasorGrid.TextToImage(txt : string; x,y : integer);
{write text txt to position x,y on the phasor image}
begin
  if (x >= 0) and (x < pCimage_p.width-8) and
     (y >= 0) and (y < pCimage_p.height-8) then
     pCimage_p.canvas.TextOut(x,y,txt);
end;

function TPhasorGrid.NoOfItems : integer;
begin
  NoOfItems := nCurrTrafo_p;
end;

function  TPhasorGrid.GetIp(ii: integer): longint;
{get pointer to current trafo ii}
begin
  if (ii > 0) and (ii <= nCurrTrafo_p) then GetIp := CTpoint_p[ii]
  else GetIp := 0;
end;

function  TphasorGrid.PhasePhaseVolt: boolean;
{phase to phase voltages used }
begin
  PhasePhaseVolt := (VoltMode_p = PhasePhase);
end;

procedure TPhasorGrid.PutpResEdit(pResEdit: TpEdit);
{set pointer to the "reset" edit in the main form}
begin
  pResEdit_p := pResEdit;
end;

procedure TPhasorGrid.GetInitDir( var dir0,dir1: string);
{get the original initial directory, and the present initial directory
 dir0  the original initial directory
 dir1  the present init.dir.}
begin
  dir0 := InitDir0_p;
  dir1 := CurrPhasorForm.PhasorDialog.InitialDir;
end;

procedure TPhasorGrid.PutInitDir(dir1: string);
{put the given directory as the initial dir. for the save-dialog
 dir1  the new init.dir.}
begin
  CurrPhasorForm.PhasorDialog.InitialDir := dir1;
end;

procedure  TPhasorGrid.GetColorIndex(ii: integer; var ia,ib,ic: integer);
{get the color indices of phasor number ii
 ii        index of the phasor
 ia,ib,ic  the color indices of phases a,b,c}
var
  kk  : integer;
  row : integer;   {first row of this phasor}
begin
  if (ii > 0) and (ii <= nCurrTrafo_p) then begin  {reasonable index}
    row := (ii-1)*CTrows;         {index of first row of this phasor}
    ia := strtoint(Cells[ColorCol,row+1]);
    ib := strtoint(Cells[ColorCol,row+2]);
    ic := strtoint(Cells[ColorCol,row+3]);
  end else begin
    ia := 1;
    ib := 2;
    ic := 3;
  end;
end;

procedure  TPhasorGrid.PutColorIndex(ii, ia,ib,ic: integer);
{put the color indices of the phases of the given phasor
 and redraw the phasors
 ii        index of the phasor
 ia,ib,ic  color indices}
var
  row  : integer;  {first fow of this phasor}
begin
  if (ii > 0) and (ii <= nCurrTrafo_p) then begin  {reasonable index}
    row := (ii-1)*CTrows;         {index of first row of this phasor}
    Cells[ColorCol,row+1] := inttostr(ia);
    Cells[ColorCol,row+2] := inttostr(ib);
    Cells[ColorCol,row+3] := inttostr(ic);
{   Repaint; }
{   DrawPhasors; }
  end;
end;

procedure TPhasorGrid.GetIDRelPos(ii: integer; var x1,y1,x2,y2,x3,y3: integer);
{get the relative positions of the identifiers of the given phasor
 ii      index of the phasor
 x1,y1.. the relative positions}
var
  jj : integer;   {index}
  kk : integer;   {index = row of the current}
begin
  kk := (ii-1)*CTrows+1;      {"row" = index of the current}
  x1 := Relxx_p[kk];
  y1 := Relyy_p[kk];
  inc(kk);
  x2 := Relxx_p[kk];
  y2 := Relyy_p[kk];
  inc(kk);
  x3 := Relxx_p[kk];
  y3 := Relyy_p[kk];
end;

procedure TPhasorGrid.PutIDRelPos(ii,x1,y1,x2,y2,x3,y3: integer);
{put the relative positions of the identifiers of the given phasor
 ii      index of the phasor
 x1,y1.. the relative positions}
var
  jj : integer;   {index}
  kk : integer;   {index = row of the current}
begin
  kk := (ii-1)*CTrows+1;      {"row" = index of the current}
  Relxx_p[kk] := x1;
  Relyy_p[kk] := y1;
  inc(kk);
  Relxx_p[kk] := x2;
  Relyy_p[kk] := y2;
  inc(kk);
  Relxx_p[kk] := x3;
  Relyy_p[kk] := y3;
end;

procedure TPhasorGrid.GetScaleIndex(var ind : integer);
{get the index for scaling of the graph}
begin
  ind := modScale_p;
end;

procedure TPhasorGrid.PutScaleIndex(ind : integer);
{put the index for scaling of the graph}
begin
  modScale_p := ind;
end;

procedure TPhasorGrid.GetCaption(ii: integer; var txt: string);
{get the caption (title) of phasor ii}
var
  row: integer;  {the row of the caption}
begin
  if (ii > 0) and (ii <= nCurrTrafo_p) then begin  {reasonable index}
    row := (ii-1)*CTrows;         {index of first row of this phasor}
    txt := Cells[TrafoCol,row];   {the caption}
  end else begin
    txt := '';
  end;
end;


procedure TPhasorGrid.DrawWmfDiagram(Fname : string);
{draw the phasor diagram on a file in Windows metafile format
 Fname   the name (as 'C:\dir1\dir2\filename.wmf')of the file where saved}
var
  bpu            : boolean;        {dummy}
  ix,iy          : integer;        {coordinates of the comp.}
  CompMetafile   : TMetafile;
  MetaCanvas     : TMetafileCanvas;
begin
  {size of the image}
  ix := pCImage_p^.width;
  iy := pCImage_p^.height;
  CompMetafile := TMetafile.Create;    {create the metafile}
  CompMetafile.width := ix;
  CompMetafile.height := iy;
  MetaCanvas := TMetafileCanvas.Create(CompMetafile,0); {create it's canvas}
  try
    {draw the components on the canvas of the metafile}
    DrawCircles(MetaCanvas);
    PhasorLines(MetaCanvas);
    MetaCanvas.free;
    CompMetafile.SaveToFile(Fname);
  finally
    CompMetafile.Free;
  end;
end;

{ - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -}

procedure TCurrPhasorForm.FormResize(Sender: TObject);
{resize the images and move the grids etc. correspondingly}
begin
  if not(appl_close) then begin         {not when closing the application (quitting)}
    CurrGrid.FormResizeUpper(@CurrPhasorForm);
    SeqGrid.FormResizeLower(@CurrPhasorForm);
    ResetSeqBut.top := CurrSeqImage.top;
    IncSeqBut.top := ResetSeqBut.top;
    DecSeqBut.top := ResetSeqBut.top;
  end;
end;

procedure TCurrPhasorForm.CurrPhasorImgMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
{prepare to move an identifier, if cursor on the identifier}
begin
  {save position etc. for moving the identifier, if cursor on an identifier}
  if (Button = mbLeft) then
    CurrGrid.StartIdentifierIf(x,y);
end;

procedure TCurrPhasorForm.CurrPhasorImgMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
{move the identifier to the mouse-up-point}
begin
  if IDimage.visible then begin
    {move the identifier}
    CurrGrid.MoveIdentifier(x,y);
    IDimage.visible := false;
  end;
end;

procedure TCurrPhasorForm.CurrPhasorImgMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
  {show the current corresponding to the cursor position}
  if (CurrGrid.nCurrTrafo_p > 0) then
    CurrGrid.CursorCurrent(x,y)
  else
    PointEdit.text := ' Click a current transformer';
  {show a rectangle around ID-number, if moving}
  if (IDimage.visible) then begin
    IDimage.left := CurrPhasorImg.left+x-6;
    IDimage.top := CurrPhasorImg.top+y-6;
  end;
end;

procedure TCurrPhasorForm.IncButClick(Sender: TObject);
{increase the scale by one step}
begin
  inc(CurrGrid.modScale_p);
  CurrGrid.DrawPhasors;
end;

procedure TCurrPhasorForm.DecButClick(Sender: TObject);
{decrease the scale by one step}
begin
  if (CurrGrid.maxScale_p > {1.5}0.2) then dec(CurrGrid.modScale_p);
  CurrGrid.DrawPhasors;
end;

procedure TCurrPhasorForm.ResetButClick(Sender: TObject);
{reset the scale}
begin
  CurrGrid.modScale_p := 0;
  CurrGrid.DrawPhasors;
end;

procedure TCurrPhasorForm.ExitItemClick(Sender: TObject);
begin
  visible := false;
end;

procedure TCurrPhasorForm.ButItemClick(Sender: TObject);
begin
  ButItem.checked := not ButItem.checked;
  IncBut.visible := ButItem.checked;
  DecBut.visible := ButItem.checked;
  ResetBut.visible := ButItem.checked;
  IncSeqBut.visible := ButItem.checked;
  DecSeqBut.visible := ButItem.checked;
  ResetSeqBut.visible := ButItem.checked;
  PointEdit.visible := ButItem.checked;
  SeqEdit.visible := ButItem.checked;
end;

procedure TCurrPhasorForm.BitmapItemClick(Sender: TObject);
{save diagram as bitmap}
var
  DirName     : string;
  FormImage   : TBitmap;    {for saving the whole form as a bitmap}
begin
{SendToBack;                 {otherwise may hide the dialog}

  if (PhasorDialog.execute) then begin
    if (PhasorDialog.FilterIndex = 3) then begin  {save as a wmf-file}
      if (PhaseItem.checked) then begin           {draw phasors of phase variables}
        CurrGrid.DrawWmfDiagram(PhasorDialog.Filename);
      end else if (SequenceItem.checked) then begin {draw sequence variables}
        SeqGrid.DrawWmfDiagram(PhasorDialog.Filename);
      end;
    end else begin                                {save as a bitmap or a jpeg-file}
      FormImage := CurrPhasorForm.getFormImage;
      if (PhasorDialog.FilterIndex = 1) then begin {save as a bitmap}
        FormImage.savetofile(PhasorDialog.Filename);
      end else begin                               {save as a jpeg-file}
        SaveJpegImag{e}(@CurrPhasorForm, FormImage, PhasorDialog.FileName);  {..in routines.pas}
      end;
      FormImage.free;
    end;
    {save the directory for next time}
    DirName := ExtractFilePath(PhasorDialog.FileName);
    PhasorDialog.InitialDir := DirName;    {save the directory}

end else begin

  end;
end;

procedure TCurrPhasorForm.CurrSeqImageMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
{prepare to move an identifier, if cursor on the identifier}
begin
  {save position etc. for moving the identifier, if cursor on an identifier}
  SeqGrid.StartIdentifierIf(x,y);
end;



procedure TCurrPhasorForm.CurrSeqImageMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
  {show the current corresponding to the cursor position}
  SeqGrid.CursorCurrent(x,y);
  {show a rectangle around ID-number, if moving}
  if (IDimage.visible) then begin
    IDimage.left := CurrSeqImage.left+x-6;
    IDimage.top := CurrSeqImage.top+y-6;
  end;
end;

procedure TCurrPhasorForm.CurrSeqImageMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
{move the identifier to the mouse-up-point}
begin
  if IDimage.visible then begin
    {move the identifier}
    SeqGrid.MoveIdentifier(x,y);
    IDimage.visible := false;
  end;
end;

procedure TCurrPhasorForm.ResetSeqButClick(Sender: TObject);
{reset the scale to default value}
begin
  SeqGrid.modScale_p := 0;
  SeqGrid.DrawPhasors;
end;

procedure TCurrPhasorForm.DecSeqButClick(Sender: TObject);
begin
  if (SeqGrid.maxScale_p > 0.1{1.5}) then dec(SeqGrid.modScale_p);
  SeqGrid.DrawPhasors;
end;

procedure TCurrPhasorForm.IncSeqButClick(Sender: TObject);
begin
  inc(SeqGrid.modScale_p);
  SeqGrid.DrawPhasors;
end;

procedure TCurrPhasorForm.PhaseItemClick(Sender: TObject);
begin
  PhasorDialog.filter := FilterBoth; {can save as .bmp and as *.wmf}
  PhaseItem.checked := true;
  CurrGrid.view_p := phase;
  SeqGrid.view_p := phase;
  {show all items connected to phase components}
  CurrGrid.visible := true;
  CurrPhasorImg.visible := true;
  CurrentLabel.visible := true;
  If (ButItem.checked) then begin
    PointEdit.visible := true;
    ResetBut.visible := true;
    IncBut.visible := true;
    DecBut.visible := true;
  end;
  {hide all connected to sequence components}
  SeqGrid.visible := false;
  CurrSeqImage.visible := false;
  SeqLabel.visible := false;
  SeqEdit.visible := false;
  ResetSeqBut.visible := false;
  IncSeqBut.visible := false;
  DecSeqBut.visible := false;
  {set the height of the form (change, eventually)}
  height := CurrPhasorImg.height+PointEdit.height+botmarg+2*editmarg;
end;

procedure TCurrPhasorForm.SequenceItemClick(Sender: TObject);
begin
  PhasorDialog.filter := FilterBoth; {can save as .bmp and as *.wmf}
  SequenceItem.checked := true;
  CurrGrid.view_p := seq;
  SeqGrid.view_p := seq;
  {move the sequence items to top}
  CurrSeqImage.top := 0;
  SeqLabel.top := CurrSeqImage.top;
  SeqGrid.top := CurrSeqImage.top+24;
  SeqEdit.top := CurrSeqImage.top+CurrSeqImage.height+editmarg;
  ResetSeqBut.top := CurrSeqImage.top;
  IncSeqBut.top := ResetSeqBut.top;
  DecSeqBut.top := ResetSeqBut.top;
  {show all items connected to sequence components}
  SeqGrid.visible := true;
  CurrSeqImage.visible := true;
  SeqLabel.visible := true;
  If (ButItem.checked) then begin
    SeqEdit.visible := true;
    ResetSeqBut.visible := true;
    IncSeqBut.visible := true;
    DecSeqBut.visible := true;
  end;
  {hide all connected to sequence components}
  CurrGrid.visible := false;
  CurrPhasorImg.visible := false;
  CurrentLabel.visible := false;
  PointEdit.visible := false;
  ResetBut.visible := false;
  IncBut.visible := false;
  DecBut.visible := false;
  {set the height of the form (change, eventually)}
  height := CurrSeqImage.height+SeqEdit.height+botmarg+2*editmarg;
end;

procedure TCurrPhasorForm.BothItemClick(Sender: TObject);
begin
  PhasorDialog.filter := FilterBmp  ; {can save only as .bmp}
  BothItem.checked := true;
  CurrGrid.view_p := both;
  SeqGrid.view_p := both;
  {set the form height, if not already set}
  if not(CurrPhasorImg.visible and CurrSeqImage.visible) then begin
    if (height < (screen.height-32) div 2) then height := 2*height-botmarg
    else height := screen.height-32;
  end;
  {show all items connected to phase components}
  CurrGrid.visible := true;
  CurrPhasorImg.visible := true;
  CurrentLabel.visible := true;
  If (ButItem.checked) then begin
    PointEdit.visible := true;
    ResetBut.visible := true;
    IncBut.visible := true;
    DecBut.visible := true;
  end;
  {show all items connected to sequence components}
  SeqGrid.visible := true;
  CurrSeqImage.visible := true;
  SeqLabel.visible := true;
  If (ButItem.checked) then begin
    SeqEdit.visible := true;
    ResetSeqBut.visible := true;
    IncSeqBut.visible := true;
    DecSeqBut.visible := true;
  end;

end;

procedure TCurrPhasorForm.NoMultItemClick(Sender: TObject);
begin
  NoMultItem.checked := true;
  SeqGrid.UpdateSeqIdentifiers;
  SeqGrid.UpdatePhasors(cCopy,nil,0);
  SeqLabel.caption := 'Current Sequence components (I1, I2, I0)';
end;

procedure TCurrPhasorForm.MultItemClick(Sender: TObject);
begin
  MultItem.checked := true;
  SeqGrid.UpdateSeqIdentifiers;
  SeqGrid.UpdatePhasors(cCopy,nil,0);
  SeqLabel.caption := 'Current Sequence components (I1, 3I2, 3I0)';
end;

procedure TCurrPhasorForm.PrimaryItemClick(Sender: TObject);
begin
  PrimaryItem.checked := true;
  UpdateCurrPhasors;               {in CurrPhas.pas}
  CurrentLabel.Caption := 'Current phase components';
  SeqLabel.Caption := 'Current sequence components';
end;

procedure TCurrPhasorForm.SecondaryItemClick(Sender: TObject);
begin
  SecondaryItem.checked := true;
  UpdateCurrPhasors;               {in CurrPhas.pas}
  CurrentLabel.Caption := 'Phase components, in Amp-sec';
  SeqLabel.Caption := 'Sequence components, in Amp-sec';  
end;

procedure TCurrPhasorForm.CopyItemClick(Sender: TObject);
{copy phasors to clipboard as windows metafile}
begin
  ClipPopMenu.popup(left,top);
end;

procedure TCurrPhasorForm.BmpItemClick(Sender: TObject);
{copy phasors to clipboard as bitmap}
var
  FormImage   : TBitmap;         {for saving the form as a bitmap}
begin
  FormImage := CurrPhasorForm.getFormImage;          {picture of the form (as bitmap?)}
  Clipboard.assign(FormImage);                       {copy to clipboard}
  FormImage.free;
end;

procedure TCurrPhasorForm.WmfItemClick(Sender: TObject);
{copy phasors to clipboard as windows metafile}
var
  FormImage   : TBitmap;         {for saving the form as a bitmap}
  MetaCanvas  : TMetafileCanvas; {canvas for saving graph as*.wmf}
  PhasMetaf   : TMetafile;       {for *.wmf}
begin
  FormImage := CurrPhasorForm.getFormImage;          {picture of the form (as bitmap?)}
  PhasMetaf := TMetafile.Create;
  PhasMetaf.width := ClientWidth;                    {size = form size}
  PhasMetaf.height := ClientHeight;
  MetaCanvas := TMetafileCanvas.Create(PhasMetaf,0); {create it's canvas}
  MetaCanvas.draw(0,0,FormImage);                    {copy the image of the form}
  MetaCanvas.free;                                   {free, and move image to metafile}
  Clipboard.assign(PhasMetaf);                       {copy to clipboard}
  FormImage.free;
  PhasMetaf.free;
end;

end.
