unit scenarios;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Grids, ExtCtrls, Buttons, Utildef, Skemadef, Routines,Imagodef,
  Parametr, LoadMultip;

type
  TScenarioForm = class(TForm)
    AltPanel: TPanel;
    LoadGrid: TStringGrid;
    SPQPanel: TPanel;
    PQBut: TRadioButton;
    PcosfBut: TRadioButton;
    IcosfBut: TRadioButton;
    QcosfBut: TRadioButton;
    IPBut: TRadioButton;
    SPBut: TRadioButton;
    SQBut: TRadioButton;
    OtherLabel: TLabel;
    ParamGrid: TStringGrid;
    AVOBut: TSpeedButton;
    PUBut: TSpeedButton;
    ScenABut: TSpeedButton;
    ScenBBut: TSpeedButton;
    ScenCBut: TSpeedButton;
    OKBut: TButton;
    CancelBut: TButton;
    ScenALabel: TLabel;
    ScenBLabel: TLabel;
    ScenCLabel: TLabel;
    HelpBut: TSpeedButton;
    HelpMemo: TMemo;
    procedure FormShow(Sender: TObject);
    procedure AVOButClick(Sender: TObject);
    procedure PUButClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure OKButClick(Sender: TObject);
    procedure CancelButClick(Sender: TObject);
    procedure ScenAButClick(Sender: TObject);
    procedure ScenBButClick(Sender: TObject);
    procedure ScenCButClick(Sender: TObject);
    procedure ParamGridKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure PQButClick(Sender: TObject);
    procedure PcosfButClick(Sender: TObject);
    procedure IcosfButClick(Sender: TObject);
    procedure QcosfButClick(Sender: TObject);
    procedure IPButClick(Sender: TObject);
    procedure SPButClick(Sender: TObject);
    procedure SQButClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure LoadGridKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure LoadGridSelectCell(Sender: TObject; Col, Row: Longint;
      var CanSelect: Boolean);
    procedure HelpButClick(Sender: TObject);
  private
    { Private declarations }
    lcol      : integer;        {selected column in load grid}
    Def_width : integer;        {default width of form, without help-memo}
  public
    { Public declarations }
    LoadParam : TLoadParam;
    pComp     : TpComp;         {pointer to the load component}
    pSet      : TpCompSet;
    procedure ScenarioParToFromPU(acol, arow : integer);
    procedure ShowScenario;
  end;

var
  ScenarioForm: TScenarioForm;

implementation

uses Imagopas;

{$R *.DFM}

procedure TScenarioForm.FormShow(Sender: TObject);
var
  col   : integer;
  ix,iy : integer;
  lbl   : string;
begin
  {show the parameters in other way(s)}
  lcol := LoadGrid.col;
  for col := 1 to gLoadScen do begin
    LoadParam.LoadInOtherWays(col);
  end;
  LoadParam.OtherLoadTexts(LoadGrid.rowcount);      {the other texts}
  pComp^.GetLabel(lbl,ix,iy);
  Caption := lbl;
  ShowScenario;
end;

procedure TScenarioForm.AVOButClick(Sender: TObject);
var
  ii : integer;
begin
  {set the widths so that AVOhm columns are visible}
  for ii := 1 to gLoadScen do begin
    ParamGrid.ColWidths[ii] := 64;
    ParamGrid.ColWidths[ii+gLoadScen] := 0;
    LoadGrid.ColWidths[ii] := 64;
    LoadGrid.ColWidths[ii+gLoadScen] := 0;
  end;
  ParamGrid.FixedColor := clBtnFace;
  LoadGrid.FixedColor := clBtnFace;
end;

procedure TScenarioForm.PUButClick(Sender: TObject);
var
  ii : integer;
begin
  {set the widths so that AVOhm columns are visible}
  for ii := 1 to gLoadScen do begin
    ParamGrid.ColWidths[ii] := 0;
    ParamGrid.ColWidths[ii+gLoadScen] := 64;
    LoadGrid.ColWidths[ii] := 0;
    LoadGrid.ColWidths[ii+gLoadScen] := 64;
  end;
  ParamGrid.FixedColor := clSilver;
  LoadGrid.FixedColor := clSilver;
end;

procedure TScenarioForm.FormCreate(Sender: TObject);
var
  ii,jj : integer;
begin
  Def_width := ParamGrid.width+10;
  width := Def_width;                  {width without the help-memo}
  {captions for the parametes, in phys. units, and per unit}
  for ii := 1 to gLoadScen do begin
    ParamGrid.cells[ii,0] := 'units: VA, V';
    ParamGrid.cells[ii+gLoadScen,0] := 'per unit';
  end;
  {create object for procedures of "other parameters"}
  LoadParam :=TLoadParam.create;
  LoadParam.initialize(@ParamGrid, @LoadGrid, gLoadScen,
            @PQBut,@PCosfBut,@ICosfBut,@QcosfBut,nil,@IPBut,@SPBut,@SQBut,nil,nil,nil);
  pSet := nil;                      {some better way ??!!}
  {add flag that form created}
  Imagoo.ReadyEdit.text := Imagoo.ReadyEdit.text+'S';  
end;

procedure TScenarioForm.OKButClick(Sender: TObject);
{save parameters, close form}
var
  ii,jj : integer;    {index}
  line  : string;     {temporary}
  npar  : integer;    {number of parameters}
begin
  pComp^.Getnpar(npar);              {number of parameters}
  for ii := 1 to gLoadScen do begin  {all scenarios = columns}
    line := '';
    for jj := 1 to npar do begin     {all parameters}
      line := line+ParamGrid.cells[ii,jj]+' ';
    end;
    pComp^.putDescrP1(ii,line);     {save as description (?!)}
  end;
  ScenarioForm.visible := false;
  ShowScenarioAndScalingFactors;
end;

procedure TScenarioForm.CancelButClick(Sender: TObject);
{hide the form, do not save parameters}
begin
  ScenarioForm.visible := false;
end;

procedure TScenarioForm.ScenAButClick(Sender: TObject);
{copy the parameters from the component to scenario }
var
  ii   : integer;
  npar : integer;
begin
  pComp^.Getnpar(npar);              {number of parameters}
  for ii := 1 to npar do begin
    ParamGrid.cells[1,ii] := GridForm.ParamGrid.cells[1,ii];
    ParamGrid.cells[1+gLoadScen,ii] := GridForm.ParamGrid.cells[2,ii];  {per unit}
  end;
end;

procedure TScenarioForm.ScenBButClick(Sender: TObject);
{copy the parameters from the component to scenario }
var
  ii   : integer;
  npar : integer;
begin
  pComp^.Getnpar(npar);              {number of parameters}
  for ii := 1 to npar do begin
    ParamGrid.cells[2,ii] := GridForm.ParamGrid.cells[1,ii];
    ParamGrid.cells[2+gLoadScen,ii] := GridForm.ParamGrid.cells[2,ii];  {per unit}
  end;
end;

procedure TScenarioForm.ScenCButClick(Sender: TObject);
{copy the parameters from the component to scenario }
var
  ii   : integer;
  npar : integer;
begin
  pComp^.Getnpar(npar);              {number of parameters}
  for ii := 1 to npar do begin
    ParamGrid.cells[3,ii] := GridForm.ParamGrid.cells[1,ii];
    ParamGrid.cells[3+gLoadScen,ii] := GridForm.ParamGrid.cells[2,ii];  {per unit}
  end;

end;

procedure TScenarioForm.ScenarioParToFromPU(acol, arow : integer);
{convert the scenario parameters of the load component from phys.units to per unit,
 or vice versa, depending on the column index
 line  the parameter as text
 acol  column index from where parameter read,
       is phys unit, if acol <= number of scenarios, else pu
 arow  row index}
var
  apu    : single;   {temporary}
  bkV    : single;   {base voltage, in kV}
  bMVA   : single;   {base power, in MVA}
  err    : integer;  {error flag}
  kend   : integer;  {first non-read char}
  line   : string;   {parameter as text}
  st1    : string;   {temporary}
  txt    : string;   {temporary}
  val    : single;   {value of a parameter}
begin
  GridForm.GetBaseVar(bMVA, bkV);                        {get base variables}
  line := ParamGrid.cells[acol,arow];                    {parameter being edited}
  NextValueFromLine(line, 1, kend,val, st1, err);        {convert to numerical, in routines.pas}
  if (err = 0) then begin                                {continue only if no errors}
    if (acol <= gLoadScen) then begin                    {param. in phys units}
      if (arow = gLoad_Vn) then begin                    {editing voltage}
        apu := val/(bkV*1000);                           {per unit voltage}
        EngFormat(apu,txt);
      end else if (arow = gLoad_VA) then begin           {editing power}
        apu := val/(bMVA*1e6);                           {per unit power}
        EngFormat(apu,txt);
      end else begin                                     {power factor or multiplier}
        txt := line;                                     {no conversion}
      end;
      ParamGrid.cells[acol+gLoadScen,arow] := txt;       {write to the per-unit column}
    end else begin                                       {per unit param}
      if (arow = gLoad_Vn) then begin                    {editing voltage}
        apu := val*(bkV*1000);                           {per unit voltage}
        EngFormat(apu,txt);
      end else if (arow = gLoad_VA) then begin           {editing power}
        apu := val*(bMVA*1e6);                           {per unit power}
        EngFormat(apu,txt);
      end else begin                                     {power factor or multiplier}
        txt := line;                                     {no conversion}
      end;
      ParamGrid.cells[acol-gLoadScen,arow] := txt;       {write to the phys.unit column}
    end;
    ParamGrid.color := clWhite;
  end else begin
    ParamGrid.color := clYellow;
  end;
end;

procedure TScenarioForm.ShowScenario;
{indicate, which scenario in use}
begin
  if (pSet <> nil) then begin
    if (pSet^.Load_Scen = 'A') then begin
      ScenALabel.font.style := [fsBold];
      ScenBLabel.font.style := [];
      ScenCLabel.font.style := [];
      GridForm.ScenarioLabel.caption := 'A';
    end else if (pSet^.Load_Scen = 'B') then begin
      ScenALabel.font.style := [];
      ScenBLabel.font.style := [fsBold];
      ScenCLabel.font.style := [];
      GridForm.ScenarioLabel.caption := 'B';
    end else if (pSet^.Load_Scen = 'C') then begin
      ScenALabel.font.style := [];
      ScenBLabel.font.style := [];
      ScenCLabel.font.style := [fsBold];
      GridForm.ScenarioLabel.caption := 'C';
    end else begin
      ScenALabel.font.style := [];
      ScenBLabel.font.style := [];
      ScenCLabel.font.style := [];
      GridForm.ScenarioLabel.caption := 'N';
    end;
  end;  
end;

procedure TScenarioForm.ParamGridKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
{convert from V or VA to per unit, or the opposite}
var
  acol   : integer;  {active column}
  arow   : integer;  {active row}
  col    : integer;  {column}
  line   : string;   {one line of text}
begin
  {copy column and row to locals}
  acol := ParamGrid.col;
  arow := ParamGrid.row;
  {convert between  phys.units and per unit}
  ScenarioParToFromPU(acol, arow);
  {copy/convert to grid for other ways. Column = column of phys units}
  if (acol <= gLoadScen) then col := acol else col := acol-LoadParam.coldiff_p;
  LoadParam.LoadInOtherWays(col);
end;

procedure TScenarioForm.PQButClick(Sender: TObject);
var
  col : integer;
begin
  {show the parameters in other way(s)}
  for col := 1 to gLoadScen do begin
    LoadParam.LoadInOtherWays(col);
  end;
  LoadParam.OtherLoadTexts(LoadGrid.rowcount);
end;

procedure TScenarioForm.PcosfButClick(Sender: TObject);
var
  col : integer;
begin
  {show the parameters in other way(s)}
  for col := 1 to gLoadScen do begin
    LoadParam.LoadInOtherWays(col);
  end;
  LoadParam.OtherLoadTexts(LoadGrid.rowcount);
end;

procedure TScenarioForm.IcosfButClick(Sender: TObject);
var
  col : integer;
begin
  {show the parameters in other way(s)}
  for col := 1 to gLoadScen do begin
    LoadParam.LoadInOtherWays(col);
  end;
  LoadParam.OtherLoadTexts(LoadGrid.rowcount);
end;

procedure TScenarioForm.QcosfButClick(Sender: TObject);
var
  col : integer;
begin
  {show the parameters in other way(s)}
  for col := 1 to gLoadScen do begin
    LoadParam.LoadInOtherWays(col);
  end;
  LoadParam.OtherLoadTexts(LoadGrid.rowcount);
end;

procedure TScenarioForm.IPButClick(Sender: TObject);
var
  col : integer;
begin
  {show the parameters in other way(s)}
  for col := 1 to gLoadScen do begin
    LoadParam.LoadInOtherWays(col);
  end;
  LoadParam.OtherLoadTexts(LoadGrid.rowcount);
end;

procedure TScenarioForm.SPButClick(Sender: TObject);
var
  col : integer;
begin
  {show the parameters in other way(s)}
  for col := 1 to gLoadScen do begin
    LoadParam.LoadInOtherWays(col);
  end;
  LoadParam.OtherLoadTexts(LoadGrid.rowcount);
end;

procedure TScenarioForm.SQButClick(Sender: TObject);
var
  col : integer;
begin
  {show the parameters in other way(s)}
  for col := 1 to gLoadScen do begin
    LoadParam.LoadInOtherWays(col);
  end;
  LoadParam.OtherLoadTexts(LoadGrid.rowcount);
end;

procedure TScenarioForm.FormDestroy(Sender: TObject);
begin
  LoadParam.free;
end;

procedure TScenarioForm.LoadGridKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  {calculate the "proper" parameters of the load component, write to grid}
  if (lcol <= gLoadScen ) then begin                {editing parameters in physical units}
    LoadParam.LoadFromOtherWays(lcol);              {phys par in LoadGrid -> phys and pu par in main grid}
    LoadParam.PerUnitParamFromOtherLoadParam(lcol,0); {phys.par in LoadGrid -> pu par in LoadGrid}
  end else if (lcol <= 2*gLoadScen) then begin      {editing per unit parameters}
    LoadParam.OtherLoadParamFromPerUnit(lcol,0);    {pu -> phys.param. in LoadGrid}
    LoadParam.LoadFromOtherWays(lcol);              {phys param in LoadGrid -> phys and pu param in main grid}
  end;
end;

procedure TScenarioForm.LoadGridSelectCell(Sender: TObject; Col,
  Row: Longint; var CanSelect: Boolean);
begin
  lcol := col;
end;

procedure TScenarioForm.HelpButClick(Sender: TObject);
{show/not the help memo}
begin
  if (HelpBut.down) then begin
    width := HelpMemo.left+HelpMemo.width+10;
    HelpMemo.visible := true;
  end else begin
    width := def_width;
    HelpMemo.visible := false;
  end;  
end;

end.
