{22.12.2002  the location of fault(s) using pSet^.Fault_pos}
unit Tab;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, TabNotBk, StdCtrls, Menus, Mask, Printers, {ComCtrls,}
  Imagodef, Skemproc, Skemadef, ComCtrls, ExtCtrls, Buttons, Utildef,
  Routines,compdef,Emtp ;

type
  TReportForm = class(TForm)
    File1: TMenuItem;
    TabExit: TMenuItem;
    TopMenu: TMainMenu;
    Reports: TTabbedNotebook;
    FirstMemo: TMemo;
    TabNew: TMenuItem;
    N1: TMenuItem;
    TabEdit: TEdit;
    Edit1: TMenuItem;
    EditTab: TMenuItem;
    DelMenu: TMenuItem;
    DummyBut: TButton;
    PrintDi: TPrintDialog;
    PrintItem: TMenuItem;
    SaveDi: TSaveDialog;
    SafeFileItem: TMenuItem;
    ToolPanel: TPanel;
    AmpBut: TSpeedButton;
    VoltBut: TSpeedButton;
    OhmBut: TSpeedButton;
    WattBut: TSpeedButton;
    CTWattBut: TSpeedButton;
    ActimeBut: TSpeedButton;
    ImpedanceBut: TSpeedButton;
    TapBut: TSpeedButton;
    FilterBut: TSpeedButton;
    AmpSeqBut: TSpeedButton;
    VoltSeqBut: TSpeedButton;
    OhmGroundBut: TSpeedButton;
    TimeBut: TSpeedButton;
    ZoneTimeBut: TSpeedButton;
    FaultBut: TSpeedButton;
    NotesBut: TSpeedButton;
    ShortCurrBut: TSpeedButton;
    TitleBut: TSpeedButton;
    AbcBut: TSpeedButton;
    ZeroBut: TSpeedButton;
    N2: TMenuItem;
    DelAllItem: TMenuItem;
    ShortBut: TSpeedButton;
    TwoShortBut: TSpeedButton;
    EarthFaultBut: TSpeedButton;
    LLEarthBut: TSpeedButton;
    BusBut: TSpeedButton;
    VoltMetBut: TSpeedButton;
    Z012But: TSpeedButton;
    OptionsMenu: TMenuItem;
    DecimalsItem: TMenuItem;
    TrLineBut: TSpeedButton;
    TrafoBut: TSpeedButton;
    OKBut: TButton;
    PuBut: TSpeedButton;
    procedure FormResize(Sender: TObject);
    procedure ReportsClick(Sender: TObject);
    procedure FormClick(Sender: TObject);
    procedure TabExitClick(Sender: TObject);
    procedure ReportsChange(Sender: TObject; NewTab: Integer;
      var AllowChange: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure TabNewClick(Sender: TObject);
    procedure EditTabClick(Sender: TObject);
    procedure TabEditKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure TabEditExit(Sender: TObject);
    procedure DelMenuClick(Sender: TObject);
    procedure DummyButClick(Sender: TObject);
    procedure PrintItemClick(Sender: TObject);
    procedure SafeFileItemClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormDestroy(Sender: TObject);
    procedure FirstMemoEnter(Sender: TObject);
    procedure DelAllItemClick(Sender: TObject);
    procedure DecimalsItemClick(Sender: TObject);
    procedure OKButClick(Sender: TObject);
    procedure VoltButClick(Sender: TObject);
  private
    { Private declarations }
    Amp_dec  : integer;
    Ohm_dec  : integer;
    Volt_dec : integer;
    Watt_dec : integer;
    Man_dec  : boolean;
    procedure SeqCaption(pSet: TpCompSet; var line: string);
  public
    { Public declarations }
    procedure GetDecimals(var Ad,Vd,Wd,Zd: integer; var man: boolean);
    procedure PutDecimals(Ad,Vd,Wd,Zd: integer; man: boolean);
  end;

procedure FindDir(var DirName: string; FileName: string);
procedure RemoveFilterFlag(Clab : string; var ChLab : string; var isFilt: boolean);
{type
  TpMemo = ^Tmemo;         {pointer to a memo}
const
  clicked : boolean = false;
  maxmem     = 20;          {max number of  memo' on the tabbed notebook}
  FormLeft   = 10;          {position of form}
  FormTop    = 10;
  FormWidth  = 860{840};    {the width of the form}
  spaces     = '                    ';  {empty space on some lines}
  TabsOnForm = 10;          {no of tabs visible simultaneously}
  TabWidth   = FormWidth div TabsOnForm; {width of one tab, approximately}
var
  ReportForm: TReportForm;
  Mem  : TMemo;
  MemoPointArr : array[1..maxmem] of {TpMemo}TpRichEdit;

implementation
uses
  imagopas, Decimals;
{$R *.DFM}

procedure TReportForm.FormResize(Sender: TObject);
var
  ii  : integer;  {index}
  np  : integer;  {number of pages}
begin
  {change the height of the reports to correspond to that of the form}
  Reports.height := ClientHeight-ToolPanel.height;
  np := Reports.Pages.Count;                  {number of pages}
  for ii := 1 to np do begin
    MemoPointArr[ii]^.height := ClientHeight-56;
  end;
  Reports.width := ReportForm.width-10;
  for ii := 1 to np do begin
    MemoPointArr[ii]^.width := Reports.width-20;
  end;
  ii := Reports.PageIndex;              {index of the active page, or tab}
  if (ii > 0) and (ii <= np) then MemoPointArr[ii+1].refresh;

{  FirstMemo.height := ClientHeight-32;}
end;

procedure TReportForm.ReportsClick(Sender: TObject);
var
  ii   : integer;    {index}
  np   : integer;    {no of pages}
begin
  {move the memo on this side, so that left boundary visible}
  np := Reports.Pages.Count;                  {number of pages}
  for ii:=1 to np do begin
    MemoPointArr[ii]^.left := -Reports.left;  {left boundary visible}
  end;
  TabEdit.visible := false;                   {hide the eventual edit box}
  (*  showmessage(inttostr(ReportForm.HorzScrollBar.range)); *)
  (*FirstMemo.left := -Reports.left;*)
  (*
  line := TabbedNotebook1.Pages.GetText;
  showmessage(StrPas(line));
  *)
  (*
  TabbedNotebook1.Pages.Add('Test');
  *)
(*  if (TabbedNotebook1.ActivePage = 'Test') then Mem.BringToFront;*)
end;

procedure TReportForm.FormClick(Sender: TObject);
begin
  TabEdit.visible := false;    {hide the eventual TabEdit box}
end;

procedure TReportForm.TabExitClick(Sender: TObject);
begin
  {Application.Terminate;}
  ReportForm.visible := false;
  Imagoo.ReportMenu.checked := false;
end;

procedure TReportForm.ReportsChange(Sender: TObject; NewTab: Integer;
  var AllowChange: Boolean);
begin
(*  FirstMemo.Left := -Reports.left;*)
end;


procedure TReportForm.FormCreate(Sender: TObject);
{initialize the form position etc.}
var
  ii : integer;  {index}
begin
  {initialize the memos}
  for ii := 1 to maxmem do begin   {clear pointers to memos initially}
    MemoPointArr[ii] := nil;
  end;
  MemoPointArr[1] := @FirstMemo;   {the first memo must be there}
  MemoPointArr[1]^.width := FormWidth-20; {width of (all) memos}
  ReportForm.left := FormLeft;     {put the form to the upper left corner}
  ReportForm.top := FormTop;
  ReportForm.width := FormWidth;
  Reports.width := FormWidth-10;   {initial width of the notebook}
  SaveDi.InitialDir := Imagoo.TabIniDir;  {saved in imagoo.create}
  {initialize number of decimals, when under manual control}
  Amp_dec  := 1;
  Ohm_dec  := 1;
  Volt_dec := 1;
  Watt_dec := 1;
  Man_dec := false;
  {add flag that form created}
  Imagoo.ReadyEdit.text := Imagoo.ReadyEdit.text+'t';
end;

procedure TReportForm.GetDecimals(var Ad,Vd,Wd,Zd: integer; var man: boolean);
{get the number of decimals used in the report for current, voltage, power (etc), impedance
 Ad,Vd,Wd,Zd  number of decimals
 man          auto/man flag, true when manual}
begin
  Ad := Amp_dec;
  Vd := Volt_dec;
  Wd := Watt_dec;
  Zd := Ohm_dec;
  man := Man_dec;
end;

procedure TReportForm.PutDecimals(Ad,Vd,Wd,Zd: integer; man: boolean);
{put the number of decimals used in the report for current, voltage, power (etc), impedance
 Ad,Vd,Wd,Zd  number of decimals
 man          auto/man flag, true when manual}
begin
  Amp_dec := Ad;
  Volt_dec := Vd;
  Watt_dec := Wd;
  Ohm_dec := Zd;
  Man_dec := man;
end;

function TrLabel(Clab : string; mxlen : integer): string;
{truncate a text (label) to given length
 Clab   the label
 mxlen  max.length}
var
  ii    : integer;    {index}
  ll    : integer;    {length of label}
  TrLab : string;  {label under construction}
begin
  {cut too long labels}
  ll := length(Clab);
  TrLab := '';
  if (ll > mxlen) then begin           {copy only mxlen char.}
    for ii := 1 to mxlen do TrLab := TrLab+Clab[ii];
  end else begin
    TrLab := '';
    for ii := 1 to ll do TrLab := TrLab+Clab[ii]; {copy the whole label}
    if (ll < mxlen) then begin
      for ii := ll+1 to mxlen do TrLab := TrLab+' ';
    end;
  end;
  TrLabel := TrLab;
end;

procedure ListOpenBreakers(pSet : TpCompSet; var line,line2 : string);
{write the labels of open breakers to line
 pSet  pointer to the common
 line  the line where labels are written}
var
  bpu    : boolean;   {temporary}
  errc   : integer;   {error flag}
  ix,iy  : integer;   {coordinates of the label}
  jcomp  : integer;   {counts components}
  lbl    : string;    {label of the component}
  ModNam : string;    {name (type) of the component}
  pComp  : TpComp;    {pointer to a component}
  txt    : string;    {temporary}
begin
  line := '';         {initialize}
  line2 := '';
  {check all components, look for switches}
  errc := 0;
  pComp := nil;
  jcomp := 0;
  while (errc = 0) do begin                {scan all components}
    pSet^.NextComp(pComp,errc,jcomp,true); {get pointer to next component}
    if (errc = 0) then begin               {component found}
      pComp^.GetModName(ModNam);           {get the name (type) of the component}
      if (ModNam = gBrkr) then begin
        if (pComp^.hint <> 'wire') then begin {open breaker}
          pComp^.GetLabel(txt,ix,iy);   {label of the component}
          RemoveFilterFlag(txt,lbl,bpu);{remove the eventual filter-flag}
          line := line+lbl+'  ';        {add label to list}
        end;
      end else if (ModNam = gSymbol) then begin  {second breaker type}
        if (pComp^.hint = 'open') then begin     {open breaker}
          pComp^.GetLabel(txt,ix,iy);            {label of the component}
          RemoveFilterFlag(txt,lbl,bpu);         {remove the eventual filter-flag}
          line2 := line2+lbl+'  ';               {add label to list}
        end;
      end;
    end;
  end;
end;

procedure RemoveFilterFlag(Clab : string; var ChLab : string; var isFilt: boolean);
{remove first the eventual "selected" ("filtered") flag from the label,
 that is, a special last character
 Clab    the label
 ChLab   the checked label
 isFilt  true, if the filtering char. found}
var
  ii  : integer; {index}
  len : integer; {length of label}
begin
  len := length(Clab);
  if (len > 0) then begin
    if (Clab[len] = gFiltChar) then begin  {there is a filter character}
      isFilt := true;
      ChLab := '';
      for ii := 1 to len-1 do ChLab := ChLab+Clab[ii]; {copy, but not the filtering flag}
    end else begin
      isFilt := false;
      ChLab := Clab;           {no filter flag, copy as such}
    end;
  end else begin               {no label, copy as such (?)}
    isFilt := false;
    ChLab := Clab;
  end;
end;

procedure LineAddIf(pMemo: TpRichEdit; Clab: string; mxlen: integer; line : string;
                    filter: boolean);
{add label and text to the memo
 If filter = true, add only for the selected ones, with a special character as the
 last character of the tab
 pMemo   pointer to the memo where written
 Clab    label (ID) of the component
 mxlen   max.length of label written to the memo
 line    the text to be written
 filter  flag for filtering}
var
  ChLab : string;   {checked label}
  ii    : integer;  {index}
  isFilt: boolean;  {there is a filtering char}
  len   : integer;  {length of the label}
begin
  if (not filter) then begin     {no filtering, write all components..}
    {..but remove first the eventual selected (filtered) flag from the label}
    RemoveFilterFlag(Clab,ChLab,isFilt);
    {write to the memo}
    pMemo^.Lines.Add(TrLabel(ChLab,mxlen)+line);
  end else begin                 {filtered, only selected components}
    {check is component "filtered" = selected}
    len := length(Clab);
    if (len > 0) then begin      {there is a label}
      if (Clab[len] = gFiltChar) then begin {component is selected = filtered}
        RemoveFilterFlag(Clab,ChLab,isFilt);
        {write to the memo}
        pMemo^.Lines.Add(TrLabel(ChLab,mxlen)+line);
      end else begin
       ;                         {not selected, not written}
      end;
    end else begin
     ;                           {no label, cannot be selected, no writing}
    end;
  end;
end;

procedure TReportForm.SeqCaption(pSet: TpCompSet; var line: string);
{generate the caption for sequence currents, depending on the displayed variables
 pSet  pointer to the common
 line  the caption}
begin
  if (pSet^.RealImag) then begin  {show real and imag, if RealImag button is up}
    if (ZeroBut.down) then        {all sequences}
      line := (spaces+
                     '  '+'  Re(I+)'+'  '+'  Im(I+)'+
                     '  '+'  Re(I-)'+'  '+'  Im(I-)'+
                     '  '+'  Re(I0)'+'  '+'  Im(I0)')
    else                          {only zero sequence}
      line := (spaces+
                     '  '+'  Re(I0)'+'  '+'  Im(I0)');
  end else begin
    if (SetComp.pb_mode <> 1) then begin       {phase button mode: 3*I- and 3*I0}
      if (ZeroBut.down) then                     {all sequences}
      line := (spaces+'   '+
                      '       I+   phase   '+
                      '     3*I-   phase   '+
                      '     3*I0   phase   ')
      else
      line := (spaces+'   '+
                      '     3*I0   phase   ');
    end else begin
      if (ZeroBut.down) then                     {all sequences}
      line := (spaces+'   '+
                      '       I+   phase   '+
                      '       I-   phase   '+
                      '       I0   phase   ')
      else
        line := (spaces+'   '+
                      '       I0   phase   ');
    end;
  end;
end;

function SortActivationTimes(pC1,pC2: pointer): integer;
{compares activation times saved in components
 return < 0 if act.time of pComp1 is less than act.time of pComp2
 return 0 if they are equal
 return > 0 if act.time of pComp1 is greater than act.time of pComp2
 pC1, pC2  pointers to current trafos. The activation times are
         saved as var1_s. If not activated, act.time is < 0
         The pointers are saved in SortList}
var
  act1,act2     : single;  {activation times}
  pComp1,pComp2 : TpComp;  {pointers to the current trafos}
begin
  pComp1 := pC1;
  pComp2 := pC2;
  act1 := pComp1^.var1_s;
  act2 := pComp2^.var1_s;
  if (act1 > 0) and (act2 > 0) then begin
    if (act1 < act2) then SortActivationTimes := -1
    else if (act1 > act2) then SortActivationTimes := 1
    else SortActivationTimes := 0;
  end else if (act1 <= 0) and (act2 > 0) then begin
    SortActivationTimes := 1;
  end else if (act1 > 0) and (act2 <= 0) then begin
    SortActivationTimes := -1;
  end else begin        {both less than zero = not activated}
    SortActivationTimes := 0;
  end;
end;

procedure TReportForm.TabNewClick(Sender: TObject);
{create new page and the memo to the tabbed notebuuk}
const
//spaces = '                    ';   {moved..}
  mxlen = length(spaces);            {max printed length of label}
  fltxt     : array[1..4] of string = ('Three phase fault',
                                       'Line to line fault',
                                       'Line to earth fault',
                                       'Line to line to earth fault');
var
  act         : single;    {activation time}
  apu,apv     : single;    {temporary}
  aZ0,aZ1,aZ2 : single;    {abs.value of secuence impedances}
  bpu         : boolean;   {temporary}
  Clab        : string;    {label of a component}
  Clbl        : string;    {label of a component}
  cpu,cpv,cpw : complex;   {temporary}
  currents    : string;    {text with values of current}
  CalcType    : string;    {name (type) of the calculation (solve, fault..)}
  form6       : string;    {formatting string}
  form8       : string;    {formatting string}
  fZ0,fZ1,fZ2 : single;    {phase of secuence impedances}
  iBV         : integer;   {index for buses and voltmeters}
  iflt        : integer;   {index for faults}
  ii          : integer;
  ix,iy       : integer;   {coordinates of the label}
  impedance   : string;    {line with the impedance values}
  iphaseq     : integer;   {index}
  ipu         : integer;   {temporary}
  len         : integer;   {length of fault pos. text}
  line,line2  : string;    {one line of text}
  many        : boolean;   {one phse (seq) or many}
  name        : string;    {name = type}
  Adec,Vdec   : integer;   {number of decimals for current, voltage}
  nochar      : longint;   {total no of characters}
  np, npo     : integer;   {no of pages, old no of pages}
  pComp       : TpComp;    {pointer to a component}
  pCT         : TpComp;    {pointer to a current trafo}
  pSet        : TpCompSet; {pointer to the "common"}
  pShort      : TpComp;    {pointer to a short circuit}
  phase       : Tphase;    {phase of the search for faults}
  powers      : string;    {powers as text}
  powersetc   : string;    {power, current, etc of tr.lines as text}
  puVtxt      : string;    {text for per unit voltages}
  seq         : TSeq;      {flag for sequence to be displayed}
  Short       : boolean;   {true, if short circuit calculation}
  SortList    : TList;     {list for sorting currents+activation times}
  text        : string;    {explanation of voltages}
  txt         : string;    {temporary text}
  TimeCurr    : string;    {activation times and currents}
  TC2         : string;    {second row of activation times and currents, for a recloser relay}
  TrafoTaps   : string;    {transformer tap-positions as text}
  voltages    : string;    {text with values of bus voltages}
  Wdec,Zdec   : integer;   {number of decimals for power, impedance}
  LLLE        : array[1..5] of boolean;  {flag for writing for different faults, based on buttons}
begin
  pSet := TpCompSet(ipSetG);                   {pointer to the "common"}
  SortList := TList.Create;
  npo := Reports.Pages.Count;                  {old number of pages}
  if (not man_dec) then begin
    Adec := -1;
    Vdec := -1;
    Wdec := -1;
    Zdec := -1;
  end else begin
    Adec := Amp_dec;  {number of decimals; < 0 => automatic}
    Vdec := Volt_dec;
    Wdec := Watt_dec;
    Zdec := Ohm_dec;
  end;
  if (Reports.Pages.Count < maxmem) then begin {not full yet}
    np := npo+1;                               {one more page}
    new(MemoPointArr[np]);                     {start creating new memo}
    MemoPointArr[np]^ := {TMemo}TRichEdit.Create(Reports); {create the new memo}
    {ii :=} Reports.Pages.AddObject(inttostr(np),MemoPointArr[np]^); {new page to notebook}

    MemoPointArr[np]^.Parent := (Reports.Pages.Objects
                  [Reports.Pages.IndexOf(inttostr(np))]) as TTabPage;
    MemoPointArr[np]^.Align := alNone;
    MemoPointArr[np]^.Alignment := taLeftJustify;
    MemoPointArr[np]^.BorderStyle := bsNone;
    MemoPointArr[np]^.color := clWhite;
    MemoPointArr[np]^.Ctl3D := false;
    MemoPointArr[np]^.width := Reports.width-20;
    MemoPointArr[np]^.height := ClientHeight-56;
    MemoPointArr[np]^.font.name := 'Courier';
    MemoPointArr[np]^.font.size := 10;
    MemoPointArr[np]^.MaxLength := 1000000;
    MemoPointArr[np]^.Name := 'A'+inttostr(np);
    MemoPointArr[np]^.Lines.clear;
    MemoPointArr[np]^.ScrollBars := ssVertical;
    MemoPointArr[np]^.visible := true;
    MemoPointArr[np]^.enabled := true;
    MemoPointArr[np]^.WordWrap := false;
(*  MemoPointArr[np]^.OnClick := DummyBut.OnClick;  {same click as others} *)
    MemoPointArr[np]^.OnEnter := DummyBut.OnClick;
    {indicate units}
    txt := '     Units: ';
    if (pSet^.unit_A = 1) then txt := txt+'[kA]' else txt := txt+'[A]';
    txt := txt+', ';
    if (pSet^.unit_V = 1) then txt := txt+'[kV]' else txt := txt+'[V]';
    txt := txt+', ';
    if (pSet^.unit_W = 2) then txt := txt+'[MW]' else
    if (pSet^.unit_W = 1) then txt := txt+'[kW]'
    else txt := txt+'[W]';
    txt := txt+', [Ohm], [s]';
    {add date and time to the memo and the units}
    MemoPointArr[np]^.Lines.add(' ');  {one empty line}
    ShortDateFormat := 'd.m.yyyy';     {set the format for the date}
    MemoPointArr[np]^.Lines.Add('      '+DateToStr(Date)+'   '+TimeToStr(Time)+'  '+txt);
    MemoPointArr[np]^.Lines.Add('      Title: '+Imagoo.NetTitle.text);
    MemoPointArr[np]^.Lines.Add('      Comments: ');
    MemoPointArr[np]^.Lines.Add('      No of components: '+inttostr(SetComp.NoOfComp));
    {write currents of all current trafos, if currents calculated}
    CalcType :='';
    if      (SetComp.appl_op = 2)  then CalcType := 'Solved network (with given internal voltages)'
    else if (SetComp.appl_op = 6)  then CalcType := 'Three phase fault'
    else if (SetComp.appl_op = 7)  then CalcType := 'Line to line fault'
    else if (SetComp.appl_op = 8)  then CalcType := 'Line to earth fault'
    else if (SetComp.appl_op = 9)  then CalcType := 'Load flow calculation'
    else if (SetComp.appl_op = 10) then CalcType := 'Solved network (with defined output voltages)'
    else if (SetComp.appl_op = 11) then CalcType := 'Line to line to earth fault'
    else if (SetComp.appl_op = 12) then CalcType := 'Load Flow with Tap changers'
    else if (SetComp.appl_op = 13) then CalcType := 'Solved network with tap changers (with defined output volt.)'
    else if (SetComp.appl_op = 14) then CalcType := 'Fault at all buses/voltmeters'
    else if (SetComp.appl_op = 15) then CalcType := 'Solved network (with given internal voltages)'
    else if (SetComp.appl_op = 16) then CalcType := 'Open line (broken line) fault'
    else if (SetComp.appl_op = 17) then CalcType := 'Two open lines (broken lines) fault'
    else                                CalcType := '';
    {short circuit calculation, or solve network}
    short := (SetComp.appl_op = 6) or (SetComp.appl_op = 7) or
             (SetComp.appl_op = 8) or (SetComp.appl_op = 11);
    if (CalcType <> '') then begin
      MemoPointArr[np]^.Lines.Add('      '+CalcType);   {write the fault type}
      {check open breakers, add to report, if any}
      ListOpenBreakers(pSet, line,line2);
      if (line <> '') or (line2 <> '') then begin
        MemoPointArr[np]^.Lines.Add(' ');
        MemoPointArr[np]^.Lines.Add('OPEN BREAKERS:  '+line);
        MemoPointArr[np]^.Lines.Add('OPEN BREAKER-2: '+line2);
        MemoPointArr[np]^.Lines.Add(' ');
      end;
      {write the loaction(s) of fault(s) - - - - - - -}
      if (short and FaultBut.down) then begin      {fault_pos in Nodes.pas}
        len := length(SetComp.Fault_pos);          {length of text telling the position(s) of fault(s)}
        if (len > 0) then begin
          line := '';
          for ii := 1 to len do begin
            if SetComp.Fault_Pos[ii] <> ';' then begin    {';' separates faults. See nodes.pas}
              line := line + SetComp.Fault_Pos[ii];
            end else begin
              MemoPointArr[np]^.Lines.Add('      '+line); {add fault position to report}
              line := '';
            end;
          end;
        end;
      end;
      {write fault impedance and currents, if fault at all buses/voltmeters . . . . . . . . . . .}
      if (SetComp.appl_op = 14) then begin
        {flags for writing currents of different faults, from button positions}
        LLLE[1] := ShortBut.down;
        LLLE[2] := TwoShortBut.down;
        LLLE[3] := EarthFaultBut.down;
        LLLE[4] := LLEarthBut.down;
        LLLE[5] := Z012But.down;
        {write fault impedance, but only if short circuit}
        if (not LLLE[5]) then begin
          line := 'fault impedance = '+pSet^.fault_z+' Ohm';
          MemoPointArr[np]^.Lines.Add('      '+line);      {add fault impedance}
        end;
        if (SetComp.appl_type = Allstd) then
          line := 'Calculated with the IEC-method'
        else if (SetComp.appl_type = AllSup) then
          line := 'Calculated using the superposition method'
        else if (SetComp.appl_type = AllZ012) then
          line := 'Sequence impedances'
        else line := ' ';
        MemoPointArr[np]^.Lines.Add('      '+line);
        MemoPointArr[np]^.Lines.Add('  ');
        {write the impedances, if calculated, two times: for buses and voltmeters}
        if (LLLE[5]) then begin               {impedances}
          for iBV := 1 to 2 do begin
            if ((iBV = 1) and (BusBut.down)) or             {fault at buses}
               ((iBV = 2) and (VoltMetBut.down)) then begin {fault at voltmeters}
               {some texts etc. differently for buses and voltmeters}
               if (iBV = 1) then begin                      {buses}
                 name := gBus;
                 txt := 'buses';
               end else begin                               {voltmeters}
                 name := gVolt;
                 txt := 'voltmeters';
               end;
               MemoPointArr[np]^.Lines.Add(' ');
               MemoPointArr[np]^.Lines.Add('      The sequence impedances at the '+txt);
               {the caption}
               if (pSet^.RealImag) then begin     {real and imag.components}
                 line := spaces+'    '+'   Re(Z1)   Im(Z1)  '+
                                       '   Re(Z2)   Im(Z2)  '+
                                       '   Re(Z0)   Im(Z0)  ';
               end else begin
                 line := spaces+'    '+'   |Z1|     angle  '+
                                       '   |Z2|     angle  '+
                                       '   |Z0|     angle  ';
               end;
               {caption for the voltage level}
               line := line+'  nom.Voltage';
               MemoPointArr[np]^.Lines.Add(line);
               {generate impedance-text for one bus/voltmeter}
               phase := start;
               while (phase <> ready) do begin
                 {one line,  in unit skemproc.pas}
                 OutputBusImpedances(ipSetG, name , Clab, currents,phase,Zdec);
                 if (phase <> ready) then begin
                   LineAddIf(MemoPointArr[np], Clab, mxlen, '  '+currents, FilterBut.down);
                 end;
               end;

            end;
          end;
        end else begin                       {fault currents}
          {write the values of the currents, two times: for buses and voltmeters}
          for iBV := 1 to 2 do begin
            if ((iBV = 1) and (BusBut.down)) or             {fault at buses}
               ((iBV = 2) and (VoltMetBut.down)) then begin {fault at voltmeters}
               {some texts etc. differently for buses and voltmeters}
               if (iBV = 1) then begin                      {buses}
                 name := gBus;
                 txt := 'buses';
               end else begin                               {voltmeters}
                 name := gVolt;
                 txt := 'voltmeters';
               end;
              {two times: for phase currents, and for seq. currents, if desired}
              for iphaseq := 1 to 2 do begin
                if ((iphaseq = 1) and ((AmpBut.down) or (pSet^.appl_type = Allstd))) or             {phase currents}
                   ((iphaseq = 2) and (AmpSeqBut.down) and (pSet^.appl_type = Allsup)) then begin  {sequence currents}
                  {set some flags, differently for phase and seq. currents}
                  if (iphaseq = 1) then begin                    {phase currents}
                    many := abcBut.down;
                    seq := none;
                  end else begin                                 {seq.currents}
                    many := ZeroBut.down;
                    seq := Zero;
                  end;
                  {scan all fault types, write for those with buttons down}
                  for iflt := 1 to 4 do begin
                    if (LLLE[iflt]) then begin                   {write results for this type of a fault}
                      MemoPointArr[np]^.Lines.Add(' ');          {one empty line}
                      MemoPointArr[np]^.Lines.Add(fltxt[iflt]);  {write fault type}
                      {caption for the currents}
                      if (iphaseq = 1) then begin                {phase currents}
                        MemoPointArr[np]^.Lines.Add('      The initial short circuit currents  Ik" at the '+txt);
                        if (pSet^.Appl_type = Allstd) then begin {calculation according to the IEC standard}
                          line := spaces+'       Ia   ';
                          if (abcBut.down) then line := line+    {show all phases}
                                         '       Ib   '+
                                         '       Ic   ';
                        end else begin                           {superposition method}
                          {caption according to display mode: real+imag, or magnitude and phase}
                          if (not pSet^.RealImag) then begin
                            line := spaces+'   '+'       Ia   phase   ';
                            if (abcBut.down) then line := line+            {show all phases}
                                                 '       Ib   phase   '+
                                                 '       Ic   phase   ';
                          end else begin
                            line := spaces+'   '+' Real(Ia)  Imag(Ia) ';
                            if (abcBut.down) then line := line+           {all phases}
                                                 ' Real(Ib)  Imag(Ib) '+
                                                 ' Real(Ic)  Imag(Ic) ';
                          end;
                        end;
                      end else begin                             {sequence currents}
                        MemoPointArr[np]^.Lines.Add('      The initial sequence currents  Iseq" at the '+txt);
                        SeqCaption(pSet, line);     {generate caption for the sequence currents}
                      end;
                      MemoPointArr[np]^.Lines.Add(line);
                      phase := start;
                      while (phase <> ready) do begin
                        {one line,  in unit skemproc.pas}
                        OutputBusCurrents(ipSetG, name , Clab, currents,phase,iflt,many,seq,Adec);
                        if (phase <> ready) then begin
                          LineAddIf(MemoPointArr[np], Clab, mxlen, '  '+currents, FilterBut.down);
                        end;
                      end;
                    end;
                  end;
                end;
              end;
            end;
          end;
        end;
      end else begin     {one explicit fault (or a few) - - - - - - - - - - - - - - - - - - - - -}
      {note of the format, real+imag or magnitude + phase}
      if (VoltBut.down or AmpBut.down or VoltSeqBut.down or AmpSeqBut.down) and
         (NotesBut.down) then begin           {show only when allowed}
        MemoPointArr[np]^.Lines.Add(' ');
        if (pSet^.RealImag) then begin
          MemoPointArr[np]^.Lines.Add(
          'NOTE: real and imag parts shown, because the  / r+i button is not down');
        end else begin
          MemoPointArr[np]^.Lines.Add(
          'NOTE: abs.value and phase shown, because the /i button is down');
        end;
      end;
      {note on the format of voltage, if notes allower}
      if (NotesBut.down) then begin
        if (VoltBut.down or VoltSeqBut.down) then begin
          if (pSet^.Volt_Form = PhaseNeutral_g) then MemoPointArr[np]^.Lines.Add(
            'NOTE: phase to ground voltages, see the sqrt(3), n, -button')
          else if (pSet^.Volt_Form = PhasePhase_g) then MemoPointArr[np]^.Lines.Add(
            'NOTE: phase to phase voltages, see the sqrt(3), n, -button')
          else  MemoPointArr[np]^.Lines.Add(
            'NOTE: sqrt(3)*phase to ground voltages, see the sqrt(3), n, -button');
        end;
        if (short and not(SetComp.appl_op = 6) and (AmpBut.down)) then begin
          {3*I- and 3*I0 shown, if a special phase button mode}
          if (SetComp.pb_mode = 3) then  MemoPointArr[np]^.Lines.Add(
              'NOTE: 3*I- and 3*I0 shown because of the mode of the "a b c + - 0"-button');
        end;
      end;
      {currents of the short circuit(s) - - - - - - - - - - - - - - - - - - - }
      if (short) and (ShortCurrBut.down) then begin    {..and dislpay allowed}
        {initial currents shown only, if display time  = 0}
        if (pSet^.displ_time <= 0) then begin
          MemoPointArr[np]^.Lines.Add(' ');
          MemoPointArr[np]^.Lines.Add(' Initial currents Ik" of the short circuit(s)');
          if (not pSet^.RealImag) then begin
            {add caption, for one phase or all phases, depending on AbcBut}
            txt := spaces+'   '+             '       Ia   phase   ';
            if (AbcBut.down) then txt := txt+'       Ib   phase   '+ {all phases?}
                                             '       Ic   phase   ';
            MemoPointArr[np]^.Lines.Add(txt);
          end else begin
            txt :=spaces+'   '+              ' Real(Ia)  Imag(Ia) ';
            if (AbcBut.down) then txt := txt+' Real(Ib)  Imag(Ib) '+
                                             ' Real(Ic)  Imag(Ic) ';
            MemoPointArr[np]^.Lines.Add(txt);
          end;
          pShort := nil;
          phase := start;
          while (phase <> ready) do begin
            OutputCurrents(ipSetG, gShort, Clab, currents, phase,Pos,abcBut.down,Adec,act,pComp);   {in unit skemproc.pas}
            if (pComp <> nil) then pShort := pComp;
            if (phase <> ready) then begin
              MemoPointArr[np]^.Lines.Add(TrLabel(Clab,mxlen)+'  '+currents);
              {LineAddIf(MemoPointArr[np], Clab, mxlen, '  '+currents, FilterBut.down);}
            end;
          end;
          {peak and breaking currents, if IEC-calculation}
          if (pSet^.appl_type = std) and (pShort <> nil) then begin
            pShort^.GetVar(gShort_Ip,apu);                {peak current}
            pShort^.GetVar(gShort_Ib,apv);                {breaking current}
            if (abs(apu) < 0.1) then apu := 0;
            if (abs(apv) < 0.1) then apv := 0;
            if (pSet^.unit_A = 1) then apu := 0.001*apu;  {for kA or A}
            if (pSet^.unit_A = 1) then apv := 0.001*apv;  {for kA or A}
            form8 := form8str(Adec);
            MemoPointArr[np]^.Lines.Add(' ');
            MemoPointArr[np]^.Lines.Add(' Peak current     Ip = '+format(form8,[apu]));
            MemoPointArr[np]^.Lines.Add(' Breaking current Ib = '+format(form8,[apv]));
          end;
          MemoPointArr[np]^.Lines.Add(' - - - - - - - - - - - - - -');
        end;
      end;
      {if unsymmetrical fault, add sequence currents of the short circuit}
      if ({AmpSeqBut.down}ShortCurrBut.down) then begin  {sequence currents reported}
        if (SetComp.appl_op = 7) or (SetComp.appl_op = 8) or
           (SetComp.appl_op = 11) then begin
          {add sequence currents of current transformers}
          MemoPointArr[np]^.Lines.Add(' ');
          if (pSet^.displ_time <= 0) then begin
            MemoPointArr[np]^.Lines.Add(' The initial sequence currents of the short circuit');
            SeqCaption(pSet, line);    {generate caption for the sequence currents}
            MemoPointArr[np]^.Lines.Add(line);
            {write the currents}
            phase := start;
            while (phase <> ready) do begin
              OutputCurrents(ipSetG, gShort, Clab, currents, phase,Zero,ZeroBut.down,Adec,act,pComp);   {in unit skemproc.pas}
              if (phase <> ready) then begin
                MemoPointArr[np]^.Lines.Add(TrLabel(Clab,mxlen)+'  '+currents);
                {LineAddIf(MemoPointArr[np], Clab, mxlen, '  '+currents, FilterBut.down);}
              end;
            end;
            MemoPointArr[np]^.Lines.Add(' - - - - - - - - - - - - - -');
          end;
        end;
      end;
      { - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -}
      if (AmpBut.down) then begin               {report currents}
        {titles for the currents}
        MemoPointArr[np]^.Lines.Add(' ');       {one empty line}
        {initial currents or "normal" currents}
        if (short) then begin
          if (pSet^.displ_time <= 0) then begin
            if (TitleBut.down) then
              MemoPointArr[np]^.Lines.Add('      Currents (A - primary)')
            else
              MemoPointArr[np]^.Lines.Add('      The initial currents  Ik" in the current transformers');
          end else begin
            MemoPointArr[np]^.Lines.Add('      The currents at time = '+imagoo.TimeEdit.text+' s');
          end;
        end else begin
          MemoPointArr[np]^.Lines.Add('      The phase currents Ia, Ib, Ic in the current transformers');
        end;
        {abs.value and phase shown, if the RIBut is down, else real and imag.parts}
        if (TimeBut.down) then txt := ' act.time' else txt := '';
        if (not pSet^.RealImag) then begin
          line := spaces+'   '+'       Ia   phase   ';
          if (abcBut.down) then line := line+            {show all phases}
                               '       Ib   phase   '+
                               '       Ic   phase   ';
          line := line+txt;                            {optionally, show activation time}
          MemoPointArr[np]^.Lines.Add(line);
        end else begin
          line := spaces+'   '+' Real(Ia)  Imag(Ia) ';
          if (abcBut.down) then line := line+           {all phases}
                               ' Real(Ib)  Imag(Ib) '+
                               ' Real(Ic)  Imag(Ic) ';
          line := line+txt;                   {optionally, show activation time}
          MemoPointArr[np]^.Lines.Add(line);
        end;
        {then, write the values of the currents}
        phase := start;
{srt}   SortList.clear;
        while (phase <> ready) do begin
          if (TimeBut.down) then Seq := Pos else Seq := None;   {flags activation times (!?)}
          OutputCurrents(ipSetG, gCurrT , Clab, currents, phase,Seq, abcBut.down,Adec,act,pComp);   {in unit skemproc.pas}
          if (phase <> ready) then begin
            {if activation times included, sort according to the times}
            if (TimeBut.down) then begin
              pComp^.Str_s := currents;       {save text temporarily}
              pComp^.var1_s := act;           {save activation time for sorting}
              SortList.add(pComp);            {save component pointer for sorting}
            end else begin                    {no sorting, write texts as such}
              LineAddIf(MemoPointArr[np], Clab, mxlen, '  '+currents, FilterBut.down);
            end;
          end;
        end;
        {sort, if activation times included, and write sorted}
        if (TimeBut.down) then begin
          if (SortList.count > 0) then begin
            SortList.Sort(SortActivationTimes);       {sort the list}
            for ii := 0 to SortList.count-1 do begin  {write the sorted list}
              pComp := SortList[ii];
              pComp^.GetLabel(Clbl,ix,iy);            {get (again) the label of the comp.}
              LineAddIf(MemoPointArr[np], Clbl, mxlen, '  '+pComp^.str_s, FilterBut.down);
            end;
          end;
        end;
        {special current transformers, similarly}
        phase := start;
        while (phase <> ready) do begin
          if (TimeBut.down) then Seq := Pos else Seq := None;   {flags activation times (!?)}
          OutputCurrents(ipSetG, gSpecCT , Clab, currents, phase,Seq, abcBut.down,Adec,act,pComp);   {in unit skemproc.pas}
          if (phase <> ready) then begin
            LineAddIf(MemoPointArr[np], Clab, mxlen, '  '+currents, FilterBut.down);
          end;
        end;
        {sum currents, only after earth faults}
        if (SetComp.appl_op = 8) or (SetComp.appl_op = 11) then begin
          MemoPointArr[np]^.Lines.Add(' ');
          bpu := true;                       {flag for first sum CT}
          phase := start;
          while (phase <> ready) do begin
            {activation time shown? where ?}
            if (timeBut.down) then begin
              if (abcBut.down) then ipu := 1 else ipu := 2; {time shown after currents}
            end else ipu := 0;            {time not shown}
            OutputSumCurrents(ipSetG, gSumCT, Clab, currents, phase,ipu,Adec); {in unit skemproc.pas}
            if (phase <> ready) then begin
              if (bpu) then begin            {first sum current trafo}
                MemoPointArr[np]^.Lines.Add('Sum current transformers');
                bpu := false;
              end;
              LineAddIf(MemoPointArr[np], Clab, mxlen, '  '+currents, FilterBut.down);
            end;
          end;
        end;
      end;
      { - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -}
      {sequence currents for open-line fault}
      if (AmpSeqBut.down) and ((SetComp.appl_op = 16) or (SetComp.appl_op = 17))then begin
        MemoPointArr[np]^.Lines.Add(' ');
        MemoPointArr[np]^.Lines.Add(' The sequence currents when an open-line-fault');
        SeqCaption(pSet, line);    {generate caption for the sequence currents}
        MemoPointArr[np]^.Lines.Add(line);
        {write the currents}
        phase := start;
        while (phase <> ready) do begin
          OutputCurrents(ipSetG, gCurrT, Clab, currents, phase,Zero,ZeroBut.down,Adec,act,pComp);
           {....in unit skemproc.pas}
          if (phase <> ready) then begin
            MemoPointArr[np]^.Lines.Add(TrLabel(Clab,mxlen)+'  '+currents);
          end;
        end;
        MemoPointArr[np]^.Lines.Add(' - - - - - - - - - - - - - -');
      end;
      { - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -}
      if (VoltBut.down) then begin
        {add voltages of buses and voltage measurement points}
        MemoPointArr[np]^.Lines.Add(' ');
        if (pSet^.Volt_Form = PhaseNeutral_g) then text := ' (phase to ground voltages)'
        else if (pSet^.Volt_Form = PhasePhase_g) then text := ' (phase to phase voltages)'
        else  text := ' (sqrt(3) times phase to ground voltages )';
        if (short) then begin
          if (TitleBut.down) then
            MemoPointArr[np]^.Lines.Add('      Voltages (V - primary)')
          else
            MemoPointArr[np]^.Lines.Add('      The initial bus voltages  V" '+text);
        end else begin
          MemoPointArr[np]^.Lines.Add('      The bus voltages '+text);
        end;
        {text for per-unit voltages.
         Displayed only when selected, and not a fault calculation}
        if (ReportForm.PuBut.down) and NoFaultCalculation(pSet) then
          puVtxt := '  per unit  pu-min  pu-max'
        else
          puVtxt := '';
        {captions for the voltages}
        if (not pSet^.RealImag) then begin  {show phase + abs.value, RIBut is down}
          if (pSet^.Volt_Form = PhaseNeutral_g) then begin  {phase-neutral voltages}
          txt := spaces+'   '+'      Van   phase   ';
          if (abcBut.down) then txt := txt+
                              '      Vbn   phase   '+
                              '      Vcn   phase   ';
          MemoPointArr[np]^.Lines.Add(txt+puVtxt);
          end else if (pSet^.Volt_Form = PhasePhase_g) then begin  {phase-phase voltages}
            txt := spaces+'   '+'      Vab   phase   ';
            if (abcBut.down) then txt := txt+
                                '      Vbc   phase   '+
                                '      Vca   phase   ';
            MemoPointArr[np]^.Lines.Add(txt+puVtxt);

          end else begin   {sqrt(3)*phase-neutral voltages shown}
            txt := spaces+'   '+' sqrt(3)Va  phase   ';
            if (abcBut.down) then txt := txt+
                                ' sqrt(3)Vb  phase   '+
                                ' sqrt(3)Vc  phase   ';
            MemoPointArr[np]^.Lines.Add(txt+puVtxt);
          end;
        end else begin                   {show real and imag. parts}
          if (pSet^.Volt_Form = PhaseNeutral_g) then begin  {phase-neutral voltages}
            txt := spaces+'   '+' Real(Van) Imag(Van)';
            if (abcBut.down) then txt := txt+
                                ' Real(Vbn) Imag(Vbn)'+
                                ' Real(Vcn) Imag(Vcn)';
            MemoPointArr[np]^.Lines.Add(txt+puVtxt);
          end else if (pSet^.Volt_Form = PhasePhase_g) then begin  {phase-phase voltages}
            txt := spaces+'   '+' Real(Vab) Imag(Vab)';
            if (abcBut.down) then txt := txt+
                                ' Real(Vbc) Imag(Vbc)'+
                                ' Real(Vca) Imag(Vca)';
            MemoPointArr[np]^.Lines.Add(txt+puVtxt);

          end else begin   {sqrt(3)*phase-neutral voltages shown}
            txt := spaces+'   '+' Real(Va)  Imag(Va) ';
            if (abcBut.down) then txt := txt+
                                ' Real(Vb)  Imag(Vb) '+
                                ' Real(Vc)  Imag(Vc) ';
            MemoPointArr[np]^.Lines.Add(txt+puVtxt);
          end;
        end;
        phase := start;
        while (phase <> ready) do begin
          OutputVoltages(ipSetG, Clab, voltages, phase,Pos,abcBut.down,Vdec); {in unit skemproc.pas}
          if (phase <> ready) then begin
            {MemoPointArr[np]^.Lines.Add(TrLabel(Clab,mxlen)+'  '+voltages);}
            LineAddIf(MemoPointArr[np], Clab, mxlen, '  '+voltages, FilterBut.down);
          end;
        end;
      end;
      { - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -}
      {impedances of distance relays. First the ground impedance. But only after a short}
      if (OhmBut.down) or (OhmGroundBut.down) then begin
        if (short) and (pSet^.nMeasZ > 0) then begin
          if (OhmGroundBut.down) then begin
            {first, ground distance relays}
            MemoPointArr[np]^.Lines.Add(' ');
            if (pSet^.displ_time <= 0) then begin
              if (TitleBut.down) then
                MemoPointArr[np]^.Lines.Add(' Ground impedance (Ohm - primary)')
              else
                MemoPointArr[np]^.Lines.Add(' initial Ground impedance of distance relays');
            end else begin
              MemoPointArr[np]^.Lines.Add(' Ground impedance of distance relays at time '+
                                          Imagoo.TimeEdit.text+' s');
            end;
            MemoPointArr[np]^.Lines.Add(' ');
            if (ZoneTimeBut.down) then txt :=  ' zone time' else txt := '';
            line := spaces+' dir '+'     Zag   phase   ';
            if (abcBut.down) then line := line+
                                   '     Zbg   phase   '+
                                   '     Zcg   phase';
            line := line+txt;
            MemoPointArr[np]^.Lines.Add(line);
            phase := start;
            while (phase <> ready) do begin                       { }
              {one line of impedances, 1 = ground impedances}
              OutputImpedances(ipSetG, 1, ZoneTimeBut.down, Clab,impedance, phase, abcBut.down,Zdec);
              if (phase <> ready) then begin
                {MemoPointArr[np]^.Lines.Add(TrLabel(Clab,mxlen)+'  '+impedance);}
                LineAddIf(MemoPointArr[np], Clab, mxlen, '  '+impedance, FilterBut.down);
              end;
            end;
          end;
          {then phase distance relays}
          if (OhmBut.down) then begin
            MemoPointArr[np]^.Lines.Add(' ');
            if (pSet^.displ_time <= 0) then begin
              if (TitleBut.down) then
                MemoPointArr[np]^.Lines.Add(' Phase impedance (Ohm - primary)')
              else
                MemoPointArr[np]^.Lines.Add(' initial Phase impedance of distance relays');
            end else begin
              MemoPointArr[np]^.Lines.Add(' Phase impedance of distance relays at time '+
                                          Imagoo.TimeEdit.text+' s');
            end;
            MemoPointArr[np]^.Lines.Add(' ');
            if (ZoneTimeBut.down) then txt :=  ' zone time' else txt := '';
            line := spaces+' dir '+'     Zab   phase   ';
            if (abcBut.down) then line := line+
                                   '     Zbc   phase   '+
                                   '     Zca   phase';
            line := line+txt;
            MemoPointArr[np]^.Lines.Add(line);
(*
            MemoPointArr[np]^.Lines.Add(spaces+' dir '+          {caption}
                                        '     Zab   phase   '+
                                        '     Zbc   phase   '+
                                        '     Zca   phase'+txt);
*)
            phase := start;
            while (phase <> ready) do begin                       { }
              {one line of impedances, 2 = phase impedances}
              OutputImpedances(ipSetG, 2, ZoneTimeBut.down, Clab,impedance, phase,abcBut.down,Zdec);
              if (phase <> ready) then begin
                {MemoPointArr[np]^.Lines.Add(TrLabel(Clab,mxlen)+'  '+impedance);}
                LineAddIf(MemoPointArr[np], Clab, mxlen, '  '+impedance, FilterBut.down);
              end;
            end;
          end;
        end;
      end;
      {activation times of overcurrent relays, if fault calculation - - - - - - - - - -}
      if (ActimeBut.down) and (short) then begin
        {first, PGQ-relays}
        MemoPointArr[np]^.Lines.Add(' ');
        MemoPointArr[np]^.Lines.Add(' Activation times and currents of overcurrent relays');
        MemoPointArr[np]^.Lines.Add(' ');
        line := '   time    phase-     time    sum-       time  3*neg.seq.';
        MemoPointArr[np]^.Lines.Add(TrLabel('Label',mxlen)+'  '+line);
        line := '           current            current            current';
        MemoPointArr[np]^.Lines.Add(TrLabel('..',mxlen)+'  '+line);
        SortList.clear;
        phase := start;
        {only  PQ-relays: second parameter = "true"}
        while (phase <> ready) do begin                       { }
          {time+current in one string, in skemproc.pas}
          OutputTimeCurr(ipSetG, true, Clab,TimeCurr,TC2, phase,Adec,act,pCT);
          if (phase <> ready) then begin
            {save for sorting, do not output yet}
            if (pCT <> nil) then begin
              pCT^.Str_s := TimeCurr;       {save text temporarily}
              pCT^.Stg_s := TC2;            {more text, for reclosers}
              pCT^.var1_s := act;           {save activation time for sorting}
              SortList.add(pCT);            {save component pointer for sorting}
            end;
//          LineAddIf(MemoPointArr[np], Clab, mxlen, '  '+TimeCurr, FilterBut.down);
//          if (TC2 <> '') then     {recloser relay, two units}
//            LineAddIf(MemoPointArr[np], Clab, mxlen, '  '+TC2, FilterBut.down);
          end;
        end;
        {output the activation times}
        if (SortList.count > 0) then begin
          SortList.Sort(SortActivationTimes);       {sort the list}
          for ii := 0 to SortList.count-1 do begin  {write the sorted list}
            pCT := SortList[ii];
            pCT^.GetLabel(Clbl,ix,iy);              {get (again) the label of the comp.}
            LineAddIf(MemoPointArr[np], Clbl, mxlen, '  '+pCT^.str_s, FilterBut.down);
            {a second line for reclosers, maybe}
            if (pCT^.stg_s <> '') then
              LineAddIf(MemoPointArr[np], Clbl, mxlen, '  '+pCT^.stg_s, FilterBut.down);
          end;
        end;

        {next, the other relays}
        MemoPointArr[np]^.Lines.Add(' ');
        MemoPointArr[np]^.Lines.Add(' Activation times and currents of  overcurrent relays');
        MemoPointArr[np]^.Lines.Add(' ');
        line := '   time    current';
{check!}
        MemoPointArr[np]^.Lines.Add(TrLabel('Label',mxlen)+'  '+line);
{srt}   SortList.clear;              {for sorting the times}
        phase := start;
        while (phase <> ready) do begin                       { }
          {other relays, second parameter = "false"}
          {time+current in one string, in Skemproc.pas}
          OutputTimeCurr(ipSetG, false, Clab,TimeCurr,TC2, phase,Adec,act,pCT);
          {save for sorting, do not output yet}
          if (pCT <> nil) then begin
            pCT^.Str_s := TimeCurr;       {save text temporarily}
            pCT^.var1_s := act;           {save activation time for sorting}
            SortList.add(pCT);            {save component pointer for sorting}
          end;
//        if (phase <> ready) then begin
//          {MemoPointArr[np]^.Lines.Add(TrLabel(Clab,mxlen)+'  '+TimeCurr);}
//          LineAddIf(MemoPointArr[np], Clab, mxlen, '  '+TimeCurr, FilterBut.down);
//        end;
        end;
        {output the activation times}
        if (SortList.count > 0) then begin
          SortList.Sort(SortActivationTimes);       {sort the list}
          for ii := 0 to SortList.count-1 do begin  {write the sorted list}
            pCT := SortList[ii];
            pCT^.GetLabel(Clbl,ix,iy);              {get (again) the label of the comp.}
            LineAddIf(MemoPointArr[np], Clbl, mxlen, '  '+pCT^.str_s, FilterBut.down);
          end;
        end;
      end;
      if (ImpedanceBut.down) then begin  {sequence impedances}
        MemoPointArr[np]^.Lines.Add(' ');
        {Thevenin impedance calculated with "normal" reactances}
        MemoPointArr[np]^.Lines.add(' '+Imagoo.OutMemo.lines[1]);
        MemoPointArr[np]^.Lines.add(' '+Imagoo.OutMemo.lines[2]);
        MemoPointArr[np]^.Lines.add(' '+Imagoo.OutMemo.lines[3]);
        MemoPointArr[np]^.Lines.add(' '+Imagoo.OutMemo.lines[4]);
        {impedances calculated with transient reactances}
        MemoPointArr[np]^.Lines.add(' '+Imagoo.OutMemo.lines[5]);
        MemoPointArr[np]^.Lines.add(' '+Imagoo.OutMemo.lines[6]);
        MemoPointArr[np]^.Lines.add(' '+Imagoo.OutMemo.lines[7]);
        MemoPointArr[np]^.Lines.add(' '+Imagoo.OutMemo.lines[8]);
        MemoPointArr[np]^.Lines.add(' '+Imagoo.OutMemo.lines[9]);
        {impedances calculated with subtransient reactances}
        MemoPointArr[np]^.Lines.add(' Sequence (subtransient) impedances, ohms');
        MemoPointArr[np]^.Lines.add(' '+Imagoo.OutMemo.lines[11{6{1}]);
        if (Zdec < 0) then begin         {automatic formatting = copy from display}
          MemoPointArr[np]^.Lines.add(' '+Imagoo.OutMemo.lines[12{7{2}]);
          MemoPointArr[np]^.Lines.add(' '+Imagoo.OutMemo.lines[13{8{3}]);
          MemoPointArr[np]^.Lines.add(' '+Imagoo.OutMemo.lines[14{9{4}]);
        end else begin                   {determine number of decimals}
          form6 := form6str(Zdec);       {formatting string}
          {move to locals}
          cpw := pSet^.Seq_Z0;
          cpv := pSet^.Seq_Z2;
          cpu := pSet^.Seq_Z1;
          {calculate magnitude and phase}
          aZ0 := Cabs(cpw);
          aZ1 := Cabs(cpu);
          aZ2 := Cabs(cpv);
          fZ0 := Cangle(cpw)*180/pi;
          fZ1 := Cangle(cpu)*180/pi;
          fZ2 := Cangle(cpv)*180/pi;
          {write to the report}
          MemoPointArr[np]^.lines.add('  Z1 = ' +format(form6,[cpu.x])+'  '+format(form6,[cpu.y])+'i ;'+
                                      ' |Z1| = '+format(form6,[aZ1])+'    = '+sixcharonedecimal(fZ1)+'');
          MemoPointArr[np]^.lines.add('  Z2 = ' +format(form6,[cpv.x])+'  '+format(form6,[cpv.y])+'i ;'+
                                      ' |Z2| = '+format(form6,[aZ2])+'    = '+sixcharonedecimal(fZ2)+'');
          MemoPointArr[np]^.lines.add('  Z0 = ' +format(form6,[cpw.x])+'  '+format(form6,[cpw.y])+'i ;'+
                                      ' |Z0| = '+format(form6,[aZ0])+'    = '+sixcharonedecimal(fZ0)+'');
        end;
      end;
      { - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - }
      {transmission lines: power and flag, if ampacity limit exceeded, but only
       after "normal" calculations and open-line faults}
      if  (SetComp.appl_op =  2) or (SetComp.appl_op =  9) or
          (SetComp.appl_op = 10) or (SetComp.appl_op = 12) or
          (SetComp.appl_op = 13) or (SetComp.appl_op = 16) or
          (SetComp.appl_op = 17) then begin
        if (TrLineBut.down) then begin          {transmission lines in the report}
          MemoPointArr[np]^.Lines.Add('       ');
          MemoPointArr[np]^.Lines.Add('       POWER through transmission lines and limits ');
          MemoPointArr[np]^.Lines.Add('       ');
          MemoPointArr[np]^.Lines.Add(spaces+
          'real power   react. power  max current    ampacity limit');
          phase := start;                     { <             <  }
          while (phase <> ready) do begin
            OutputLinePowers(ipSetG,gTrLiS,gTrLiS,gTrLiS,gTrLiS,Clab,
                             powersetc, phase, Wdec, Adec); {in unit skemproc.pas}
            if (phase <> ready) then begin
              LineAddIf(MemoPointArr[np], Clab, mxlen, '  '+powersetc, FilterBut.down);
            end;
          end;
        end;
        {power and ampacity limits of 2w-transformers}
        if (TrafoBut.down) then begin          {transformers in the report}
          MemoPointArr[np]^.Lines.Add('       ');
          MemoPointArr[np]^.Lines.Add('       POWER through transformers and limits ');
          MemoPointArr[np]^.Lines.Add('       ');
          MemoPointArr[np]^.Lines.Add(spaces+
          'real power   react. power  max current    ampacity limit');
          phase := start;                     { <             <  }
          while (phase <> ready) do begin     {YY trafos only, so far}
            OutputLinePowers(ipSetG,gTrafoYY,gTrafoYD,gTrafoDY,gTrafoDD,Clab,
                             powersetc, phase, Wdec, Adec); {in unit skemproc.pas}
            if (phase <> ready) then begin
              LineAddIf(MemoPointArr[np], Clab, mxlen, '  '+powersetc, FilterBut.down);
            end;
          end;
        end;
      end;
      { - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -}
      {when no short circuit calculation, add powers of generators, loads etc.}
      if  (SetComp.appl_op =  2) or (SetComp.appl_op =  9) or
          (SetComp.appl_op = 10) or (SetComp.appl_op = 12) or
          (SetComp.appl_op = 13) then begin
        if (WattBut.down) then begin
          MemoPointArr[np]^.Lines.Add('       ');
          MemoPointArr[np]^.Lines.Add('       P O W E R  of generators, feeders, motors, loads ');
          MemoPointArr[np]^.Lines.Add('       ');
          MemoPointArr[np]^.Lines.Add(spaces+'  real power    reactive power');
          phase := start;
          while (phase <> ready) do begin
            OutputPowers(ipSetG, Clab, powers, phase,Wdec);      {in unit skemproc.pas}
            if (phase <> ready) then begin
              {MemoPointArr[np]^.Lines.Add(TrLabel(Clab,mxlen)+'  '+powers);}
              LineAddIf(MemoPointArr[np], Clab, mxlen, '  '+powers, FilterBut.down);
            end;
          end;
        end;
        {report powers through current trafos, if}
        if (CTWattBut.down) then begin
          MemoPointArr[np]^.Lines.Add('       ');
          MemoPointArr[np]^.Lines.Add('       P O W E R  through current transformers ');
          MemoPointArr[np]^.Lines.Add('       ');
          MemoPointArr[np]^.Lines.Add(spaces+'  real power   reactive power');
          phase := start;
          while (phase <> ready) do begin
            OutputCTPowers(ipSetG, Clab, powers, phase,Wdec);      {in unit skemproc.pas}
            if (phase <> ready) then begin
              {MemoPointArr[np]^.Lines.Add(TrLabel(Clab,mxlen)+'  '+powers);}
              LineAddIf(MemoPointArr[np], Clab, mxlen, '  '+powers, FilterBut.down);
            end;
          end;
        end;
        {transformer tap, but only if calculated}
        if ((SetComp.appl_op = 12) or (SetComp.appl_op = 13)) and
           (TapBut.down) then begin
          MemoPointArr[np]^.Lines.Add('       ');
          MemoPointArr[np]^.Lines.Add('       TAP positions of transformers ');
          MemoPointArr[np]^.Lines.Add('       ');
          MemoPointArr[np]^.Lines.Add(spaces+'  relative nomi-   Change in nominal');
          MemoPointArr[np]^.Lines.Add(spaces+'  nal prim. Volt.  secondary Voltage');
          phase := start;                     { <             <  }
          while (phase <> ready) do begin
            OutputTrafoTaps(ipSetG, Clab, Trafotaps, phase);      {in unit skemproc.pas}
            if (phase <> ready) then begin
              {MemoPointArr[np]^.Lines.Add(TrLabel(Clab,mxlen)+'  '+trafotaps);}
              LineAddIf(MemoPointArr[np], Clab, mxlen, '  '+trafotaps, FilterBut.down);
            end;
          end;
        end;
      {unsymmetrical fault calculation, or unsymm.load (appl_op=15), add sequence currents}
      end else if (SetComp.appl_op = 7) or (SetComp.appl_op = 8) or
                  (SetComp.appl_op = 11) or (SetComp.appl_op = 15) then begin
        if (AmpSeqBut.down) then begin
(* - - - - - - sum current trafos after "normal" trafos
          {sum currents, only after earth faults}
          if (SetComp.appl_op = 8) or (SetComp.appl_op = 11) then begin
            MemoPointArr[np]^.Lines.Add(' ');
            phase := start;
            while (phase <> ready) do begin
              OutputSumCurrents(ipSetG, gSumCT, Clab, currents, phase); {in unit skemproc.pas}
              if (phase <> ready) then begin
                {MemoPointArr[np]^.Lines.Add(TrLabel(Clab,mxlen)+'  '+currents);}
                LineAddIf(MemoPointArr[np], Clab, mxlen, '  '+currents, FilterBut.down);
              end;
            end;
          end;
*)
          {add sequence currents of current transformers}
          MemoPointArr[np]^.Lines.Add(' ');
          if (pSet^.displ_time <= 0) then begin
            if (TitleBut.down) then begin
              MemoPointArr[np]^.Lines.Add('      Sequence currents (A - primary)');
            end else begin
              if (SetComp.appl_op = 15) then       {unsymm.load}
                MemoPointArr[np]^.Lines.Add('      The sequence currents')
              else
                MemoPointArr[np]^.Lines.Add('      The initial sequence currents');
            end;
          end else begin
              MemoPointArr[np]^.Lines.Add('      The sequence currents at time '+imagoo.TimeEdit.text+' s');
          end;
          if (pSet^.RealImag) then begin  {show real and imag, if RealImag button is up}
            if (SetComp.pb_mode <> 1) then begin {phase button mode: 3*I- and 3*I0}
              if (ZeroBut.down) then             {all sequences}
                MemoPointArr[np]^.Lines.Add(spaces+
                                            '  '+'  Re(I+)'+'  '+'  Im(I+)'+
                                            '  '+'3*Re(I-)'+'  '+'3*Im(I-)'+
                                            '  '+'3*Re(I0)'+'  '+'3*Im(I0)')
                else                               {only zero sequence}
                MemoPointArr[np]^.Lines.Add(spaces+
                                            '  '+'3*Re(I0)'+'  '+'3*Im(I0)');
            end else begin
              if (ZeroBut.down) then             {all sequences}
                MemoPointArr[np]^.Lines.Add(spaces+
                                            '  '+'  Re(I+)'+'  '+'  Im(I+)'+
                                            '  '+'  Re(I-)'+'  '+'  Im(I-)'+
                                            '  '+'  Re(I0)'+'  '+'  Im(I0)')
              else                               {only zero sequence}
                MemoPointArr[np]^.Lines.Add(spaces+
                                            '  '+'  Re(I0)'+'  '+'  Im(I0)');
            end;
          end else begin
            if (SetComp.pb_mode <> 1) then begin    {phase button mode: 3*I- and 3*I0}
              if (ZeroBut.down) then             {all sequences}
                MemoPointArr[np]^.Lines.Add(spaces+'   '+          {caption}
                                            '       I+   phase   '+
                                            '     3*I-   phase   '+
                                            '     3*I0   phase   ')
              else                               {only zero sequence}
                MemoPointArr[np]^.Lines.Add(spaces+'   '+          {caption}
                                            '     3*I0   phase   ');
            end else begin
              if (ZeroBut.down) then             {all sequences}
                MemoPointArr[np]^.Lines.Add(spaces+'   '+          {caption}
                                            '       I+   phase   '+
                                            '       I-   phase   '+
                                            '       I0   phase   ')
              else                               {only zero sequence}
                MemoPointArr[np]^.Lines.Add(spaces+'   '+          {caption}
                                            '       I0   phase   ');
            end;
          end;
          phase := start;
          while (phase <> ready) do begin
            OutputCurrents(ipSetG, gCurrT, Clab, currents, phase,Zero,ZeroBut.down,Adec,act,pComp);   {in unit skemproc.pas}
            if (phase <> ready) then begin
              LineAddIf(MemoPointArr[np], Clab, mxlen, '  '+currents, FilterBut.down);
            end;
          end;
          {special current transformers similarly}
          phase := start;
          while (phase <> ready) do begin
            OutputCurrents(ipSetG, gSpecCT, Clab, currents, phase,Zero,ZeroBut.down,Adec,act,pComp);   {in unit skemproc.pas}
            if (phase <> ready) then begin
              LineAddIf(MemoPointArr[np], Clab, mxlen, '  '+currents, FilterBut.down);
            end;
          end;
        end;
        {add sequence voltages of buses}
        if (VoltSeqBut.down) then begin
          MemoPointArr[np]^.Lines.Add(' ');
          if (TitleBut.down) then
            MemoPointArr[np]^.Lines.Add('      Sequences voltages (V - primary)')
          else
            MemoPointArr[np]^.Lines.Add('      The initial sequence bus voltages'+text);
          if (pSet^.RealImag) then begin  {show real and imag, if RealImag button is up}
            if (pSet^.Volt_Form = PhaseNeutral_g) then begin  {phase-neutral voltages}
              if (zeroBut.down) then            {all sequences}
                MemoPointArr[np]^.Lines.Add(spaces+
                                            '  '+'Re(Vn+)'+'  '+'Im(Vn+)'+
                                            '  '+'Re(Vn-)'+'  '+'Im(Vn-)'+
                                            '  '+'Re(Vn0)'+'  '+'Im(Vn0)')
              else                              {only zero sequence}
                MemoPointArr[np]^.Lines.Add(spaces+
                                            '  '+'Re(Vn0)'+'  '+'Im(Vn0)');
            end else if (pSet^.Volt_Form = PhasePhase_g) then begin  {phase-neutral voltages}
              if (zeroBut.down) then            {all sequences}
                MemoPointArr[np]^.Lines.Add(spaces{'          '}+
                                            '  '+'Re(V+)'+'  '+'Im(V+)'+
                                            '  '+'Re(V-)'+'  '+'Im(V-)'+
                                            '  '+'Re(V0)'+'  '+'Im(V0)')
              else
                MemoPointArr[np]^.Lines.Add(spaces{'          '}+
                                            '  '+'Re(V0)'+'  '+'Im(V0)');
            end else begin   {sqrt(3)*phase-neutral voltages}
              if (zeroBut.down) then            {all sequences}
                MemoPointArr[np]^.Lines.Add(spaces{'          '}+
                                            ' 1.73*ReV+'+' 1.73*ImV+'+
                                            ' 1.73*ReV-'+' 1.73*ImV-'+
                                            ' 1.73*ReV0'+' 1.73*ImV0')
              else
                MemoPointArr[np]^.Lines.Add(spaces{'          '}+
                                            ' 1.73*ReV0'+' 1.73*ImV0');
            end;
          end else begin
            if (pSet^.Volt_Form = PhaseNeutral_g) then begin  {phase-neutral voltages}
              if (zeroBut.down) then            {all sequences}
                MemoPointArr[np]^.Lines.Add(spaces+'   '+          {caption}
                                            '     Vn+   phase   '+
                                            '     Vn-   phase   '+
                                            '     Vn0   phase   ')
              else
                MemoPointArr[np]^.Lines.Add(spaces+'   '+          {caption}
                                            '     Vn0   phase   ');
            end else if (pSet^.Volt_Form = PhasePhase_g) then begin  {phase-neutral voltages}
              if (zeroBut.down) then            {all sequences}
                MemoPointArr[np]^.Lines.Add(spaces+'   '+          {caption}
                                            '     V+   phase   '+
                                            '     V-   phase   '+
                                            '     V0   phase   ')
              else
                MemoPointArr[np]^.Lines.Add(spaces+'   '+          {caption}
                                            '     V0   phase   ');
            end else begin   {sqrt(3)*phase-neutral voltages}
              if (zeroBut.down) then            {all sequences}
                MemoPointArr[np]^.Lines.Add(spaces+'   '+          {caption}
                                            'sqrt(3)V+   phase   '+
                                            'sqrt(3)V-   phase   '+
                                            'sqrt(3)V0   phase   ')
              else
                MemoPointArr[np]^.Lines.Add(spaces+'   '+          {caption}
                                            'sqrt(3)V0   phase   ');
            end;
          end;
          phase := start;
          while (phase <> ready) do begin
            OutputVoltages(ipSetG, Clab, voltages, phase,Zero,zeroBut.down,Vdec);   {in unit skemproc.pas}
            if (phase <> ready) then begin
              {MemoPointArr[np]^.Lines.Add(TrLabel(Clab,mxlen)+'  '+voltages);}
              LineAddIf(MemoPointArr[np], Clab, mxlen, '  '+voltages, FilterBut.down);
            end;
          end;
        end;
      end;
      end;
    end;
{showmessage(inttostr(MemoPointArr[np]^.Lines.count));}
(*{count no of characters}
nochar := 0;
for ii := 0 to MemoPointArr[np]^.Lines.count-1 do begin
  len := length(MemoPointArr[np]^.Lines[ii]);
  nochar := nochar+len;
end;
showmessage(inttostr(nochar)); *)
   { - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -}
    {change the width of the report (tabbed notebook), if many pages}
    if (np > TabsOnForm) then begin
(*  This is not useful / necessary / needed   6.12.2005, I think
      Reports.width := np*TabWidth;               {increase width...}
      Reports.TabsPerRow := np;                   {... and no of tabs per row}
      {move also the scroll bar and memo so that the memo becomes visible}
      HorzScrollBar.position :=  HorzScrollBar.Range;  {sroll bar to the right}
      MemoPointArr[np]^.left := -Reports.left;    {new memo also visible}
*)
    end;
    {add two hints }
(*
    if (phase = ready) then begin
      MemoPointArr[np]^.Lines.Add(' ');
      if (pSet^.RealImag) then begin
        MemoPointArr[np]^.Lines.Add(
        'NOTE: real and imag parts shown, because the /i button is not down');
      end else begin
        MemoPointArr[np]^.Lines.Add(
        'NOTE: abs.value and phase shown, because the /i button is down');
      end;

      if (VoltBut.down) then begin
        if (pSet^.Volt_Form = PhaseNeutral_g) then MemoPointArr[np]^.Lines.Add(
          'NOTE: phase to neutral voltages, see the sqrt(3), n, -button')
        else if (pSet^.Volt_Form = PhasePhase_g) then MemoPointArr[np]^.Lines.Add(
          'NOTE: phase to phase voltages, see the sqrt(3), n, -button')
        else  MemoPointArr[np]^.Lines.Add(
          'NOTE: sqrt(3)*phase to neutral voltages, see the sqrt(3), n, -button');
      end;

      {3*I- and 3*I0 shown, if a special phase button mode}
      if (SetComp.pb_mode = 3) then  MemoPointArr[np]^.Lines.Add(
          'NOTE: 3*I- and 3*I0 shown because of the mode of the "a b c + - 0"-button');
    end;
*)
  end;
  SortList.free;
end;

procedure TReportForm.EditTabClick(Sender: TObject);
var
  ii  : integer;   {index}
begin
  ii := Reports.PageIndex;              {index of the active page, or tab}
  if (ii >= 0) then begin               {is there any page ?}
    TabEdit.visible := true;              {show edit box for editing Tab caption}
    ReportForm.ActiveControl := TabEdit;  {put cursor there for editing}
    TabEdit.text := Reports.Pages[ii];    {show the present tab caption}
  end else begin
    TabEdit.text := '';
  end;
end;

procedure TReportForm.TabEditKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
{hide the Edit box, if key = Enter (=return)}
begin
  if (key = 13) then TabEdit.visible := false;
end;

procedure TReportForm.TabEditExit(Sender: TObject);
{copy text to the caption of the active page (tab)}
var
  ii   : integer;  {index}
  len  : integer;  {length of text}
  np   : integer;  {no of pages}
  pi   : integer;  {page index}
  same : boolean;  {true, if found the same text on a tab}
begin
  pi := Reports.PageIndex;            {index of active page (tab)}
  np := Reports.Pages.Count;          {number of pages}
  same := false;                      {not yet found the same text}
  if (np > 0) then begin              {are there pages}
    for ii := 0 to np-1 do begin        {chek all pages}
      if (ii <> pi) then begin          {the active page is not checked}
        if (TabEdit.text = Reports.Pages[ii]) then begin
          same := true;                 {same text found}
          break;                        {one is enough}
        end;
      end;
    end;
    {do not copy, if caption already in use}
    if (same) then begin
      showmessage('Caption "'+TabEdit.text+'"  already in use');
    end else begin                      {check still that not empty}
      len := length(TabEdit.text);        {no of characters}
      {accepted the new caption only if not empty, and does not exist in other tabs}
      if (len > 0) and (TabEdit.text[1] <> ' ') then begin
        Reports.Pages[pi] := TabEdit.text;  {copy the text}
      end;
    end;
  end;
end;

procedure TReportForm.DelMenuClick(Sender: TObject);
{delete the active page, but ask for confirmation first}
var
  ii  : integer;  {index}
  ip  : integer;  {page index}
  npo : integer;  {old number of pages}
begin
  npo := Reports.Pages.Count;    {old number of pages}
  if (npo >=1) then begin        {is there any pages}
    ip := Reports.PageIndex;     {get the index of the page}
    if (ip > 0) then begin       {first page should not be deleted}
      if MessageDlg('Really delete the active page ?',
        mtWarning, [mbYes, mbNo], 0) = mrYes then begin
        MemoPointArr[ip+1]^.free;    {free (delete) the memo}
        Dispose(MemoPointArr[ip+1]);
        Reports.Pages.Delete(ip);    {delete the page}
        {update the array of memos in the notebook}
        if (npo > 1) then begin      {more than one page}
          for ii := ip+1 to npo-1 do begin          {remember: ip goes from 0 to npo-1}
            MemoPointArr[ii] := MemoPointArr[ii+1]; {shoft downwards}
          end;
          MemoPointArr[npo] := nil;  {clear the uppermost pointer}
        end else begin               {there was only one page}
          MemoPointArr[1] := nil;
        end;
      end;
    end;
  end;
end;




procedure TReportForm.DummyButClick(Sender: TObject);
{note, this is used as a "click-model"}
begin
    TabEdit.visible := false;  {hide the tab edit}
end;

procedure TReportForm.PrintItemClick(Sender: TObject);
{print one sheet}
var
  ip,ip1    : integer;   {page index, +1}
  Line      : integer;   {the number of lines of text}
  PrintText : TextFile;  {for printing the text}
begin
  ip := Reports.PageIndex;             {get the index of the page, from 0}
  ip1 := ip+1;                         {page indes from 1}
  if (ip1 > 0) then begin              {are there pages}
    if PrintDi.Execute then
    begin
      AssignPrn(PrintText);	       {assign PrintText to the printer}
      Rewrite(PrintText);	       {create and open the output file}
      {assign the current Font setting to the Printer object's canvas}
      {first page differently, because it is a Memo component}
      if (ip = 0) then begin
        Printer.Canvas.Font := ReportForm.FirstMemo.Font;
        {write the contents of the Memo field to the printer object}
        for Line := 0 to ReportForm.FirstMemo.Lines.Count - 1 do
          Writeln(PrintText,ReportForm.FirstMemo.Lines[Line]);
      end else begin                    {"normal report page}
        Printer.Canvas.Font := MemoPointArr[ip1]^.Font;
        {write the contents of the Memo field to the printer object}
        for Line := 0 to MemoPointArr[ip1]^.Lines.Count - 1 do
          Writeln(PrintText,MemoPointArr[ip1]^.Lines[Line]);
      end;
      System.Close(PrintText);
    end;
  end;
end;

procedure FindDir(var DirName: string; FileName: string);
{TM on imagopas.pas 'ista otettu}
{extract the directory name of given file name
  If no reasonable directory name found, return  emtpy string
  DirName   the directory name
  FileName  the given file name}
var
  ii,jj  : integer;   {index}
  NamLen : integer;   {length of the filename}
begin
  NamLen := length(FileName);   {number of characters in the file name}
  jj := 0;                      {1.10.2002}
  if (NamLen > 2) then begin
    {scan the name from end, search for \ }
    for ii:=1 to NamLen do begin
      jj := NamLen-ii+1;
      if (FileName[jj] = '\') then break;  {first \ found}
    end;
    {copy the file name up to the found '\'}
    if (jj > 2) then begin
      DirName := '';                 {initialize}
      for ii := 1 to jj-1 do DirName := DirName+FileName[ii];
    end else begin
      DirName := '';
    end;
  end else begin    {too short filename, not reasonable}
    DirName := '';
  end;
end;


procedure SaveReports(filename: string);
{save the reports to file}
var
  ii      : integer;    {index}
  ip      : integer;    {page index}
  np      : integer;    {number of pages}
  Outfile : TextFile;   {file where written}
begin
  np := ReportForm.Reports.Pages.Count; {number of pages}
  if (np > 1) then begin                {are there pages}
    AssignFile(Outfile, filename);      {open the given file,BUT ERRORS ?}
    rewrite(outfile);
    {write first page separately, because it is a normal Memo component}
    if (ReportForm.FirstMemo.Lines.count > 0) then begin
      for ii := 0 to ReportForm.FirstMemo.Lines.Count - 1 do begin
        Writeln(outfile,ReportForm.FirstMemo.Lines[ii]);
      end;
    end;
    {then the other pages, they are RichEdit-components}
    for ip := 2 to np do begin          {all sheets}
      if (MemoPointArr[ip]^.Lines.Count > 0) then begin
        for ii := 0 to MemoPointArr[ip]^.Lines.Count - 1 do begin
          Writeln(outfile,MemoPointArr[ip]^.Lines[ii]);
        end;
      end;
    end;
    CloseFile(Outfile);
  end;
end;

procedure TReportForm.SafeFileItemClick(Sender: TObject);
var
  DirName : string;  {directory name to which saved}
begin
  if (SaveDi.execute) then begin
    SaveReports(SaveDi.filename);       {save the reports to file}
    DirName := '';                        {initialize}
    FindDir(DirName, SaveDi.filename);
    {if reasonable directory name found, save it for next time}
    if (length(DirName) >=2) then SaveDi.InitialDir := DirName;
  end;
end;

procedure TReportForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Imagoo.ReportMenu.checked := false;
end;

procedure TReportForm.FormDestroy(Sender: TObject);
{free the memos and clear the items in the list}
{ONKO tm tarpeen ?}
var
  ii  : integer;  {index}
  ip  : integer;  {page index}
  npo : integer;  {number of pages}
begin
  npo := Reports.Pages.Count;        {number of pages}
  if (npo > 1) then begin            {is there any pages}
    for ii := 1 to npo-1 do begin
      ip := npo-ii;                  {proceed from the last one to the first one}
      MemoPointArr[ip+1]^.free;      {free (delete) the memo}
      Dispose(MemoPointArr[ip+1]);
      MemoPointArr[ip+1] := nil;
      Reports.Pages.Delete(ip);      {delete the page}
    end;
  end;
end;

procedure TReportForm.FirstMemoEnter(Sender: TObject);
begin
  TabEdit.visible := false;  {hide the tab edit}
end;

procedure TReportForm.DelAllItemClick(Sender: TObject);
{delete the all pages, but ask for confirmation first}
var
  ii  : integer;  {index}
  ip  : integer;  {page index}
  npo : integer;  {old number of pages}
begin
  if MessageDlg('Really delete All pages ?',
                 mtWarning, [mbYes, mbNo], 0) = mrYes then begin
    npo := Reports.Pages.Count;      {old number of pages}
    if (npo > 1) then begin          {is there any pages }
      for ii := 1 to npo-1 do begin  {the first page is not deleted}
        ip := npo-ii;                {from 1 to npo-1, first = 0}
        MemoPointArr[ip+1]^.free;    {free (delete) the memo, index starts at 0}
        Dispose(MemoPointArr[ip+1]);
        MemoPointArr[ip+1] := nil;
        Reports.Pages.Delete(ip);    {delete the page}
      end;
    end;
  end;
end;

procedure TReportForm.DecimalsItemClick(Sender: TObject);
begin
  DecimalsDlg.visible := true;
  DecimalsDlg.BringToFront;
end;

procedure TReportForm.OKButClick(Sender: TObject);
{write a new page to the report, including the items selected with the buttons}
begin
  TabNewClick(Sender);
end;

procedure TReportForm.VoltButClick(Sender: TObject);
begin
  PuBut.visible := VoltBut.down and NoFaultCalculation(@SetComp);
end;

end.
