unit userdef;
{form and grid for entering the user defined characteristics of a recloser relay}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, Skemadef, Imagodef, Routines, StdCtrls, PQRelay, Menus, Buttons,
  ExtCtrls, utildef, fusedata;

type
  TCharForm = class(TForm)
    CharGrid: TStringGrid;
    OKButton: TButton;
    ApplyBut: TButton;
    CancelButton: TButton;
    FirstMenu: TMainMenu;
    FileMenu: TMenuItem;
    OpenItem: TMenuItem;
    OpenDlg: TOpenDialog;
    DownBut: TSpeedButton;
    SwapBut: TSpeedButton;
    SaveItem: TMenuItem;
    SaveDlg: TSaveDialog;
    UpBut: TSpeedButton;
    FlipBut: TSpeedButton;
    ClearBut: TSpeedButton;
    CopyBut: TSpeedButton;
    PasteBut: TSpeedButton;
    HelpMemo: TMemo;
    HelpBut: TSpeedButton;
    ViewMenu: TMenuItem;
    FuseBut: TSpeedButton;
    FusePanel: TPanel;
    FuseImg: TImage;
    SlowFastPanel: TPanel;
    SlowFastImg: TImage;
    FuseGroupPanel: TPanel;
    ChanceBut: TButton;
    SlowFastBut: TButton;
    CancelBut: TButton;
    FuseGroupLabel: TLabel;
    KfuseBut: TButton;
    KfusePanel: TPanel;
    KfuseImg: TImage;
    StdBut: TButton;
    SfusePanel: TPanel;
    SfuseImg: TImage;
    MoreBut: TButton;
    InfoMemo: TMemo;
    InfoItem: TMenuItem;
    IDMenu: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure CharGridDrawCell(Sender: TObject; Col, Row: Longint;
      Rect: TRect; State: TGridDrawState);
    procedure CharGridSelectCell(Sender: TObject; Col, Row: Longint;
      var CanSelect: Boolean);
    procedure CharGridKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure OKButtonClick(Sender: TObject);
    procedure ApplyButClick(Sender: TObject);
    procedure CancelButtonClick(Sender: TObject);
    procedure OpenItemClick(Sender: TObject);
    procedure DownButClick(Sender: TObject);
    procedure SwapButClick(Sender: TObject);
    procedure SaveItemClick(Sender: TObject);
    procedure UpButClick(Sender: TObject);
    procedure FlipButClick(Sender: TObject);
    procedure ClearButClick(Sender: TObject);
    procedure CopyButClick(Sender: TObject);
    procedure PasteButClick(Sender: TObject);
    procedure HelpButClick(Sender: TObject);
    procedure HelpMemoMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FuseButClick(Sender: TObject);
    procedure FuseImgMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure FuseImage(pImg : TpImage; nrow,ncol,fw,fh: integer; capt: array of string);
    procedure ChanceButClick(Sender: TObject);
    procedure CancelButClick(Sender: TObject);
    procedure SlowFastButClick(Sender: TObject);
    procedure SlowFastImgMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SelectImgMouseDown(fw,fh,ncol, nfuze, X, Y: Integer;
              pCour,pTemps : array of pString; mfuze : array of integer; var icurve: integer);
    procedure KfuseButClick(Sender: TObject);
    procedure KfuseImgMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    function  FuseCode(UDcode: string): string;
    procedure StdButClick(Sender: TObject);
    procedure SfuseImgMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure MoreButClick(Sender: TObject);
    procedure FormHide(Sender: TObject);
    procedure InfoItemClick(Sender: TObject);
    procedure InfoMemoMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure FormShow(Sender: TObject);
    procedure InfoMemoKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    curve_u : integer;  {index of fuse curve}
    { Private declarations }
  public
    { Public declarations }
    procedure CurveFromMoreFuses(var icurve: integer);
    procedure ReplaceInfoLine(line: string);
    procedure ClearCharGrid;
    procedure SetCurveIndex(ci: integer);
  end;

procedure ParamToCharGrid(pComp : TpComp; rr : integer);
procedure StoreUDParam(pComp: TpComp; rr: integer);
procedure RecallUDParam(pComp: TpComp; rr: integer);
procedure GetUDInterval(pComp: TpComp; rr: integer; find: string; xx: single;
                        var kLow, kHigh, kFirst: integer);
procedure GetUDCurrOrTime(pComp: TpComp; rr : integer; Iss, Tmult, Tadd : single;
                          find : string; var temps, curr : single);
procedure GetUDFirst(pComp: TpComp; rr : integer; var iFirst: integer;
                     var cFirst, tFirst: single);
procedure FindUDLast(pComp: TpComp; rr : integer; var iLast: integer;
                     var cLast, tLast: single);
procedure GetUDLast(pComp: TpComp; rr : integer; var iLast: integer;
                     var cLast, tLast: single);
function UDCurr(pComp: TpComp; rr : integer; Iss : single; ii : integer): single;
function UDTime(pComp: TpComp; rr : integer; tmult,tadd : single; ii : integer): single;
function IsUserDef(pComp: TpComp): boolean;
function CheckedTimeAdder(pComp : TpComp; rr: integer; Tmult, Tadd: single): single;
function GetpActComp: TpComp;
procedure InsertRow(pGrid: TpGrid; arow, acol: integer);
procedure RemoveRow(pGrid: TpGrid; acol, arow: integer);
procedure FlipData(pGrid: TpGrid);
procedure SwapData(pGrid: TpGrid);
procedure ClearData(pGrid: TpGrid; var cleared: boolean);
procedure ReadData(pOpenDlg: TpOpenDlg; pGrid: TpGrid; var hasRead: boolean);
procedure SaveData(pSaveDlg: TpSaveDlg; pGrid: TpGrid);

var
  CharForm: TCharForm;

implementation
{$R *.DFM}
uses
  Recloser, morefuses, imagopas;

{number of data points for fuse curves A B Chance K-fast 1...200 A}
const
  n001 = 11;
  n002 = 12;
  n003 = 13;
  n006 = 11;
  n008 = 14;
  n010 = 13;
  n012 = 13;
  n015 = 13;
  n020 = 15;
  n025 = 15;
  n030 = 14;
  n040 = 13;
  n050 = 13;
  n065 = 15;
  n080 = 13;
  n100 = 15;
  n140 = 12;
  n200 = 12;
  nfuse = 18;   {number of fuse curves}
{number of curves packed in an array}
mfuse : array[1..nfuse] of integer =
(n001, n002, n003, n006, n008, n010, n012, n015, n020, n025,
 n030, n040, n050, n065, n080, n100, n140, n200);
{captions for the curves}
fcapt : array[1..20] of string =
('  1','  2','  3','  6','  8',' 10',' 12',' 15',
 ' 20',' 25',' 30',' 40',' 50',' 65',' 80','100','140','200','','close');
{data for the fuse curves AB Chance. First current, then time}
C001 : array[1..n001] of string =
('2.038', '2.04', '2.16', '2.26', '2.55', '2.79', '3.2', '3.7', '4.79', '6.69', '40.06');
T001 : array[1..n001] of string =
('998.96', '70.43', '16.08', '8.02', '4.31', '2.79', '1.75', '1.25', '0.73', '0.39', '0.01');
C002 : array[1..n002] of string =
('4.1'  , '4.11', '4.52', '4.91', '5.34', '5.99', '6.75', '7.68', '9.21', '11.59',
 '15.01', '84.8');
T002 : array[1..n002] of string =
('963.25', '38.41', '12.01', '6.41', '4.17', '2.57', '1.76', '1.25', '0.88',
 '0.56'  , '0.35' , '0.01' );
C003 : array[1..n003] of string =
('6.119', '6.12' , '6.55' , '7.04' , '7.63', '8.31', '9.28', '10.82', '12.34',
 '15.03', '18.16', '22.75', '117.43');
T003 : array[1..n003] of string =
('964.25', '45.46', '20.77', '10.32', '6.13', '3.82', '2.44', '1.53', '1.13',
 '0.76'  , '0.51' , '0.34' , '0.01' );
C006 : array[1..n006] of string =
('12.228', '12.23', '13.42', '14.61', '16.06', '17.99', '20.48', '23.79',
 '29.88' , '37.99', '194.06');
T006 : array[1..n006] of string =
('957.26', '33.66', '11.52', '6.05', '3.54', '2.12', '1.38', '0.93',
 '0.57'  , '0.35' , '0.01');
C008 : array[1..n008] of string =
('15.088', '15.09', '15.58', '16.9' , '18.42', '19.27', '20.87', '23.23',
 '25.86' , '30.1' , '36.83', '46.88', '59.54', '249.86');
T008 : array[1..n008] of string =
('951.31', '73.2', '48.84', '19.24', '8.89', '6.03', '4.21', '2.63',
 '1.76'  , '1.14', '0.73' , '0.44' , '0.26', '0.01');
C010 : array[1..n010] of string =
('19.918', '19.92', '21.18', '23.23', '25.25', '27.75', '30.8', '33.89',
 '38.19' , '44.27', '53.83', '68.59', '332.59');
T010 : array[1..n010] of string =
('950.32', '143.01', '51.08', '16.98', '8.7', '4.79', '2.94', '1.92',
 '1.29'  , '0.87'  , '0.56' , '0.34' , '0.01');
C012 : array[1..n012] of string =
('24.958', '24.96', '26.37', '28.72' , '30.99' , '34.46', '39.08', '44.69',
 '49.74' , '58.32', '76.67', '101.52', '422.46');
T012 : array[1..n012] of string =
('953.29', '121.34', '55.68', '18.68', '9.6', '4.84', '2.74', '1.69',
 '1.21'  , '0.83'  , '0.47' , '0.26' , '0.01');
C015 : array[1..n015] of string =
('31.8' , '32.0' , '33.92' , '36.98' , '41.9'  , '47.96', '53.83', '60.48',
 '72.55', '86.95', '106.16', '137.26', '557.68');
T015 : array[1..n015] of string =
('949.33', '150.18', '52.15', '20.28', '7.21', '3.56', '2.17', '1.45',
 '0.87'  , '0.59'  , '0.4'  , '0.23' , '0.01');
C020 : array[1..n020] of string =
('40.058', '40.06' , '42.38' , '46.59' , '52.89' , '59.17' , '64.11', '73.77',
 '84.01' , '100.89', '119.65', '149.32', '189.28', '225.88', '703.98');
T020 : array[1..n020] of string =
('949.33', '150.02', '59.64', '17.3', '7.38', '4.0' , '2.74', '1.69',
 '1.13'  , '0.74'  , '0.52' ,'0.33' , '0.2' , '0.14', '0.01');
C025 : array[1..n025] of string =
('50.9'  , '51.0'  , '53.55' , '56.88', '62.53' , '71.65' , '80.67', '89.8',
 '101.41', '113.94', '132.49', '155.5', '189.67', '255.64', '942.93');
T025 : array[1..n025] of string =
('936.58', '278.26', '105.78', '39.3', '15.27', '6.35', '3.45', '2.22',
 '1.52'  , '1.05'  , '0.74'  , '0.53', '0.35' , '0.19', '0.01');
C030 : array[1..n030] of string =
('64.508', '64.51' , '67.88' , '73.24' , '82.11', '92.54'  , '109.07', '125.38',
 '153.09', '195.48', '233.28', '284.84', '354.0', '1132.33');
T030 : array[1..n030] of string =
('946.37', '209.043', '82.07', '25.47', '10.59', '5.039', '2.37', '1.497',
 '0.8663', '0.5319', '0.359', '0.2354', '0.1488', '0.0135');
C040 : array[1..n040] of string =
('81.855', '81.857', '84.979', '90.545', '101.84', '117.92', '135.41', '158.28',
 '187.13', '230.39', '294.79', '398.56', '1480.8');
T040 : array[1..n040] of string =
('930.75', '215.44', '95.925', '34.046', '12.376', '5.275', '2.7913', '1.627',
 '1.0221', '0.6289', '0.359' , '0.196' , '0.0133');
C050 : array[1..n050] of string =
('102.46', '102.47', '109.41', '117.80', '131.12', '147.47', '169.70', '191.26',
 '223.55', '286.93', '352.53', '480.62', '1857.7');
T050 : array[1..n050] of string =
('932.69', '211.23', '73.350', '30.588', '12.808', '5.8837', '3.0334', '1.9096',
 '1.1365', '0.6269', '0.4084', '0.2121', '0.0133');
C065 : array[1..n065] of string =
('131,93', '131,94', '141,31', '151,20', '170,40', '192,65', '225,88', '272,67',
 '322,04', '394,44', '477,13', '607,33', '712,83', '813,47', '2522,1');
T065 : array[1..n065] of string =
('935.61', '179.03', '75.126', '31.953', '12.702', '6.1272', '2.8977', '1.4924',
 '0.9337', '0.5829', '0.3959', '0.2431', '0.1732', '0.1360', '0.0135');
C080 : array[1..n080] of string =
('160.59', '160.60', '177.46', '200.42', '225.18', '278.98', '348.16', '406.94',
 '495.33', '596.69', '716.54', '868.56', '2966.3');
T080 : array[1..n080] of string =
('932.69', '198.45', '60.828', '19.316', '8.5912', '2.9159', '1.3790', '0.8379',
 '0.5499', '0.3735', '0.2579', '0.1728', '0.0136');
C100 : array[1..n100] of string =
('203.99', '204.00', '220.32', '239.43', '262.92', '296.02', '344.56', '392.39',
 '474.16', '553.06', '671.10', '823.69', '1133.5', '1477.8', '3867.2');
T100 : array[1..n100] of string =
('928.82', '228.60', '84.231', '36.617', '16.664', '8.6811', '4.2755', '2.6306',
 '1.3562', '0.8467', '0.5302', '0.3179', '0.1675', '0.0950', '0.0135');
C140 : array[1..n140] of string =
('305.30', '305.40', '335.02', '378.76', '478.62', '597.93', '827.98', '991.20',
 '1154.9', '1432.4', '1928.5', '6471.1');
T140 : array[1..n140] of string =
('918.25', '567.33', '206.45', '64.208', '11.412', '3.9711', '1.2046', '0.7088',
 '0.4869', '0.3088', '0.1632', '0.0137');
C200 : array[1..n200] of string =
('497.39', '497.40', '561.76', '624.62', '714.31', '935.12', '1272.2', '1619.4',
 '2166.8', '3167.2', '7547.8', '9819.6');
T200 : array[1..n200] of string =
('918.25', '483.37', '179.59', '66.727', '27.140', '6.5557', '1.9017', '0.8458',
 '0.3766', '0.1580', '0.0271', '0.0160');
{pointers to these currents and times}
pCurr : array[1..nfuse] of pString =
(@C001, @C002, @C003, @C006, @C008, @C010, @C012, @C015, @C020, @C025,
 @C030, @C040, @C050, @C065, @C080, @C100, @C140, @C200);
pTime : array[1..nfuse] of pString =
(@T001, @T002, @T003, @T006, @T008, @T010, @T012, @T015, @T020, @T025,
 @T030, @T040, @T050, @T065, @T080, @T100, @T140, @T200);
const
  ActCol : integer = 1;   {column of active cell}
  ActRow : integer = 1;   {row of active cell}
  ActChar : integer = 1;  {index for the characteristics: 1,2 = phase, 3,4 = ground, 5,6 = seq.}
  pActComp : TpComp = nil; {pointer to the active relay}
  d_p    : char = #190;    {decimal point, correct value set in FormCreate}
  datwidth = 64;  {width of column with data}
  fheight = 18;   {height of one rectangle for selecting a fuse}
  fwidth = {28}36;    {width of one rectangle for selecting a fuse}
  fmarg = 4;      {margin between the image and the panel for selecting a fuse}
  fcol = 4;       {number of columns for selecting the fuse}
  frow = 5;       {number of rows for selecting the fuse}
  indwidth = 32;  {width of column of indices}
  curcol1 = 1;    {first column for values of current}
  curcol2 = 4;    {second column for values of current}
  indcol  = 3;    {column for indices}
  RowCount = 61;  {number of rows in the grid}
  timcol1 = 2;    {first column for values of time}
  timcol2 = 5;    {second column for values of time}
  sfcol = 6;      {number of columns for the slowfast fuses}
  sfrow = 8;      {number of rows for the slowfast fuses}
  sfheight = 18;  {height of one rectangle for selecting the fuse}
  sfwidth = 48;   {width of one rectangle for selecting the fuse}
  kcol = 6;       {columns for the K-fuses}
  krow = 6;       {rows for the K-fuses}
  kheight = 18;   {height of one rectangle for selecting the fuse}
  kwidth = 56;    {width of one rectangle for selecting the fuse}
  scol = 6;       {columns for the stadard fuses}
  srow = 7;       {rows for the standard fuses}
  sheight = 18;   {height of one rectangle for selecting the fuse}
  swidth = 56;    {width of one rectangle for selecting the fuse}
{captions for the SlowFast fuses (data and dimension are  in Fusedata.pas)}
  SFcapt : array[1..sfcol*sfrow] of String = (
  '0,2Amax', '0,2Amin', '0,3Amax', '0,3Amin', '0,4Amax' , '0,4Amin' ,
  '0,6Amax', '0,6Amin', '0,7Amax', '0,7Amin', '1Amax'   , '1Amin'   ,
  '1,3Amax', '1,3Amin', '1,4Amax', '1,4Amin', '1,6Amax' , '1,6Amin',
  '2,1Amax', '2,1Amin', '3,1Amax', '3,1Amin', '3,5Amax' , '3,5Amin' ,
  '4,2Amax', '4,2Amin', '5,2Amax', '5,2Amin', '6,3Amax' , '6,3Amin' ,
  ' 7Amax' , ' 7Amin' , '7,8Amax', '7,8Amin', '10,4Amax', '10,4Amin',
  '14Amax' , '14Amin' , '21Amax' , '21Amin' , '32Amax'  , '32Amin'  ,
  '46Amax' , '46Amin','','','','close');
{captions for the K-fuses (data and dimension are  in Fusedata.pas)}
  Kcapt : array[1..kcol*krow] of String = (
  '  6Amax', '  6Amin', '  8Amax', '  8Amin', ' 10Amax', ' 10Amin', ' 12Amax', ' 12Amin',
  ' 15Amax', ' 15Amin', ' 20Amax', ' 20Amin', ' 25Amax', ' 25Amin', ' 30Amax', ' 30Amin',
  ' 40Amax', ' 40Amin', ' 50Amax', ' 50Amin', ' 65Amax', ' 65Amin', ' 80Amax', ' 80Amin',
  '100Amax', '100Amin', '140Amax', '140Amin', '200Amax', '200Amin',
  '','','','','','close');
{captions for the std-fuses (data and dimension are  in Fusedata.pas)}
  Scapt : array[1..scol*srow] of String = (
  '  1Amax', '  1Amin', '  2Amax', '  2Amin', '  3Amax', '  3Amin',
  '  5Amax', '  5Amin', '  7Amax', '  7Amin', ' 10Amax', ' 10Amin',
  ' 15Amax', ' 15Amin', ' 20Amax', ' 20Amin', ' 25Amax', ' 25Amin',
  ' 30Amax', ' 30Amin', ' 40Amax', ' 40Amin', ' 50Amax', ' 50Amin',
  ' 65Amax', ' 65Amin', ' 80Amax', ' 80Amin', '100Amax', '100Amin',
  '125Amax', '125Amin', '150Amax', '150Amin', '200Amax', '200Amin',
  '','','','','','close');

var
  UDParamBack : array[1..gUD_2-gUD_1] of single; {for saving the user defined curve
                                                for a "Cancel"}
  UDCopy1 : array[1..RowCount-1] of string;   {for copying user defined data}
  UDCopy2 : array[1..RowCount-1] of string;
  UDCopy4 : array[1..RowCount-1] of string;
  UDCopy5 : array[1..RowCount-1] of string;

function GetpActComp: TpComp;
begin
  GetpActComp := pActComp;
end;

procedure TCharForm.FuseImage(pImg : TpImage; nrow,ncol,fw,fh: integer;
                              capt: array of string);
{prepare the image for selecting a fuse
 pImg   pointer to the image
 nrow,  ncol  number of rows, columns
 fw,fh  width, height of a cell
 capt   array for the texts (captions) in the cells}
var
  ii,jj,kk : integer; {indices}
  ipu      : integer; {temporary}
  ix,iy    : integer; {coordinates}
begin
  pImg^.width := ncol*fw;
  pImg^.height := nrow*fh;
  pImg^.left := fmarg;
  pImg^.top := fmarg;
//FusePanel.width := FuseImg.width+2*fmarg;
//FusePanel.height := FuseImg.height+2*fmarg;
  pImg^.canvas.pen.width := 1;
  pImg^.canvas.pen.color := clBlue;
  {horizontal lines}
  for ii := 1 to nrow-1 do begin
    ipu := ii*fh;
    pImg^.canvas.MoveTo(0,ipu);
    pImg^.canvas.LineTo(pImg^.width,ipu);
  end;
  {vertical lines}
  for ii := 1 to ncol-1 do begin
    ipu := ii*fw;
    pImg^.canvas.MoveTo(ipu,0);
    pImg^.canvas.LineTo(ipu,pImg^.height);
  end;
  {texts = nominal currents}
  pImg^.canvas.font.name := 'arial';
  pImg^.canvas.font.size := 8;
  for ii := 1 to nrow do begin
    for jj := 1 to ncol do begin
      kk := (ii-1)*ncol+jj;
      ix := (jj-1)*fw+2;
      iy := (ii-1)*fh+2;
      pImg^.canvas.textout(ix,iy,capt[kk-1]);  {index starts from 0}
    end;
  end;
end;

procedure TCharForm.FormCreate(Sender: TObject);
var
  ii,jj : integer;  {index}
  ipu   : integer;  {temporary}
  ix,iy : integer;  {coordinates}
  kk    : integer;
begin
  CharGrid.RowCount := RowCount;          {NOTE....}
  DecimalPoint(d_p);                      {define the decimal point ' or .}
  {set the size of the grid for the data}
  CharGrid.ColWidths[0] := indwidth;      {column wth indices}
  CharGrid.ColWidths[1] := datwidth;      {column with data}
  CharGrid.ColWidths[2] := datwidth;
  CharGrid.ColWidths[3] := indwidth;
  CharGrid.ColWidths[4] := datwidth;
  CharGrid.ColWidths[5] := datwidth;
  {width and height of the grid}
  ipu := CharGrid.GridLineWidth;
  for ii := 0 to 5 do ipu := ipu+CharGrid.ColWidths[ii]+CharGrid.GridLineWidth;
  CharGrid.width := ipu+16;
  CharGrid.height := {CharGrid.RowCount}21*(CharGrid.DefaultRowHeight+
                                       CharGrid.GridLineWidth)+1;
  {captions}
  CharGrid.Cells[1,0] := '  Current';
  CharGrid.Cells[2,0] := '  Time';
  CharGrid.Cells[4,0] := '  Current';
  CharGrid.Cells[5,0] := '  Time';
  for ii := 1 to CharGrid.RowCount do CharGrid.Cells[0,ii] := '   '+inttostr(ii);
  {position(s) of the button(s)}
  OKButton.top := CharGrid.top+CharGrid.height+8;
  ApplyBut.top := OKButton.top;
  CancelButton.top := OKButton.top;
  CharForm.height := OKButton.top+OKButton.height+48;
  CharForm.width := CharGrid.left+CharGrid.width+8;
  {initialize copy/paste strings}
  for ii := 1 to high(UDCopy1) do begin
    UDCopy1[ii] := '0';
    UDCopy2[ii] := '0';
    UDCopy4[ii] := '0';
    UDCopy5[ii] := '0';
  end;
  {prepare the image and the panel for selecting a "A B Chance K-fast 1...200 A"-fuse}
  FuseImage(@FuseImg, frow,fcol,fwidth,fheight, fcapt);
  FusePanel.width := FuseImg.width+2*fmarg;
  FusePanel.height := FuseImg.height+2*fmarg;
  FusePanel.left := 200;
  FusePanel.top := 100;
  {prepare the image and the panel for selecting a SlowFast-fuse}
  FuseImage(@SlowFastImg, sfrow,sfcol,sfwidth,sfheight, sfcapt);
  SlowFastPanel.width := SlowFastImg.width+2*fmarg;
  SlowFastPanel.height := SlowFastImg.height+2*fmarg;
  SlowFastPanel.left := 40;
  SlowFastPanel.top := 100;
  {prepare the image and the panel for selecting a K-fuse}
  FuseImage(@KfuseImg, krow,kcol,kwidth,kheight, kcapt);
  KfusePanel.width := KfuseImg.width+2*fmarg;
  KfusePanel.height := KfuseImg.height+2*fmarg;
  KfusePanel.left := 40;
  KfusePanel.top := 100;
  {prepare the image and the panel for selecting a standard fuse}
  FuseImage(@SfuseImg, srow,scol,swidth,sheight, scapt);
  SfusePanel.width := SfuseImg.width+2*fmarg;
  SfusePanel.height := SfuseImg.height+2*fmarg;
  SfusePanel.left := 40;
  SfusePanel.top := 100;
  {prepare the panel and buttons for selecting the fuse group (or type}
  FuseGroupPanel.left := 150;
  FuseGroupPanel.top := 50;
  FuseGroupPanel.width := 120;
  ChanceBut.left := 8;
  ChanceBut.top := FuseGroupLabel.top+FuseGroupLabel.height+8;
  ChanceBut.width := 70;
  ChanceBut.height := 20;
  SlowFastBut.left := ChanceBut.left;
  SlowFastBut.top := ChanceBut.top+ChanceBut.height+8;
  SlowFastBut.width := ChanceBut.width;
  SlowFastBut.height := ChanceBut.height;
  KfuseBut.left := ChanceBut.left;
  KfuseBut.top := SlowFastBut.top+SlowFastBut.height+8;
  KfuseBut.width := ChanceBut.width;
  KfuseBut.height := ChanceBut.height;
  StdBut.left := ChanceBut.left;
  StdBut.top := KfuseBut.top+KfuseBut.height+8;
  StdBut.width := ChanceBut.width;
  StdBut.height := ChanceBut.height;
  CancelBut.left := ChanceBut.left;
  CancelBut.top := StdBut.top+StdBut.height+8;
  CancelBut.width := ChanceBut.width;
  CancelBut.height := ChanceBut.height;
  FuseGroupPanel.height := CancelBut.top+CancelBut.height+8;
  {copy fuse data from const to var, so that it can be used here}
  CopyFuseDataToVar;   {in fusedata}
  curve_u := -1;       {no curve selected}
  {initialize the memo for additional info}
  InfoMemo.top := 0;
  InfoMemo.left := 0;
  InfoMemo.width := CharForm.width-8;
  InfoMemo.height := 50;
  {add flag that form created}
  Imagoo.ReadyEdit.text := Imagoo.ReadyEdit.text+'u';
end;

procedure TCharForm.CharGridDrawCell(Sender: TObject; Col, Row: Longint;
  Rect: TRect; State: TGridDrawState);
begin
  {the column for indices in the middle must be of different color}
  if (col = indcol) and (row > 0) then begin
    CharGrid.canvas.pen.width := 1;
    CharGrid.canvas.pen.color := clBlack{clBtnFace};
    CharGrid.canvas.brush.color := clBtnFace;
    CharGrid.canvas.rectangle(rect.left-1,rect.top-1,rect.left+
                 CharGrid.ColWidths[3]+1,rect.top+CharGrid.DefaultRowHeight+1);
    {write the indices}
    CharGrid.canvas.textout(rect.left+12,rect.top+2,inttostr(row+CharGrid.RowCount-1));
  end;
end;

procedure TCharForm.CharGridSelectCell(Sender: TObject; Col, Row: Longint;
  var CanSelect: Boolean);
begin
  ActCol := col;     {save the column and row of the active cell}
  ActRow := row;
  {cannot write to the column for the indices}
  if (col = indcol) then begin
    CharGrid.options := CharGrid.options-[goEditing,goAlwaysShowEditor];
  end else begin
    CharGrid.options := CharGrid.options+[goEditing,goAlwaysShowEditor];
  end;
end;
(**)
procedure ParamToCharGrid(pComp : TpComp; rr : integer);
{move the parameter values (current-time points) for the user defined
 characteristics to the grid
 Called in ValueGridSelectCell of PQRelay.pas
 The parameters are stored pointwise = as current-time pairs, as
         current1, time1, current2, time2,..
 pComp   pointer to the relay
 rr      index for the curve: 1 = first phase curve,   2 = second phase curve
                              3 = first ground curve,  4 = second ground curve
                              5 = first neg.seq curve, 6 = second sequence curve}
var
  apu,apv   : single;   {temporary}
  colc,colt : integer;  {column for current, time}
  ii,jj     : integer;  {indices}
  ipu       : integer;  {temporary}
  mpar      : integer;  {max.number of parameter pairs = 2*no of rows}
  npar      : integer;  {no of parameters}
  row       : integer;  {the row where the data is written}
  txt       : string;   {temporary}
begin
  pActComp := pComp;                     {save the pointer to the component}
  pComp^.Getnpar(npar);                  {get number of parameters}
  if (rr >= 1) and (rr <= 6) then begin  {reasonable index for the char.}
    ActChar := rr;                       {save index for characteristic}
    mpar := 2*(CharForm.CharGrid.RowCount-1);     {no of parameter pairs, first = zeroth row not included}
    for ii := 1 to mpar do begin
      if (ii <= mpar div 2) then begin   {data in two sets of columns}
        row := ii;
        colc := curcol1;
        colt := timcol1;
      end else begin
        row := ii-(mpar div 2);
        colc := curcol2;
        colt := timcol2;
      end;
      jj := gUD_char[rr]+2*ii-2;         {index of the first parameter in the pair}
      if (jj+1 > npar) then break;       {unreasonable index}
      pComp^.GetPar(jj,apu);             {current}
      RemoveSpaces(apu,txt);             {format the current, in routines.pas}
      CharForm.CharGrid.Cells[colc,row] := txt;   {value of current to grid}
      pComp^.GetPar(jj+1,apv);           {time}
      RemoveSpaces(apv,txt);             {format the time}
      CharForm.CharGrid.Cells[colt,row] := txt;   {value of time to grid}
    end;
  end;
end;



procedure ParamFromCharGrid(pComp : TpComp; rr : integer);
{move the parameter values (current-time points) for the user defined
 characteristics from the grid to the parameters
 The parameters are stored pointwise = as current-time pairs, as
         current1, time1, current2, time2,..
 pComp   pointer to the relay
 rr      index for the curve: 1 = first phase curve,   2 = second phase curve
                              3 = first ground curve,  4 = second ground curve
                              5 = first neg.seq curve, 6 = second sequence curve}
var
  apu,apv   : single;   {temporary}
  curr      : single;   {current}
  colc,colt : integer;  {column for current, time}
  e1,e2     : integer;  {error flags}
  ii,jj     : integer;  {indices}
  igrp      : integer;  {index of the parameter set (or group)}
  ipu       : integer;  {temporary}
  len       : integer;  {length of text}
  line      : string;   {line with the points as a string}
  mpar      : integer;  {max.number of parameter pairs = 2*no of rows}
  npar      : integer;  {no of parameters}
  row       : integer;  {the row where the data is written}
  temps     : single;   {time}
  txt       : string;   {temporary}
  txc       : string;   {checked current as text}
  txz       : string;   {checked time as text}
begin
  if (pComp <> nil) then begin
    pComp^.Getnpar(npar);                  {get number of parameters}
    if (rr >= 1) and (rr <= 6) then begin  {reasonable index for the char.}
      mpar := 2*(CharForm.CharGrid.RowCount-1);     {no of parameter pairs, first = zeroth row not included}
      igrp := Recloser.RCGridCalc.ParamGroupIndex;  {get the index of the parameter group}
      line := '';
      for ii := 1 to mpar do begin
        if (ii <= mpar div 2) then begin   {data in two sets of columns}
          row := ii;
          colc := curcol1;
          colt := timcol1;
        end else begin
          row := ii-(mpar div 2);
          colc := curcol2;
          colt := timcol2;
        end;
        jj := gUD_char[rr]+2*ii-2;         {index of the first parameter in the pair}
        if (jj+1 > npar) then break;       {unreasonable index}
        {first, the value of current}
        txt := CharForm.CharGrid.Cells[colc,row];   {value of current}
        len := length(txt);
        if (len > 0) then begin            {not empty}
          chkfloat(txt,e1,txc);            {check, is it a proper floating point value}
          if (e1 = 0) then begin
            curr := strtofloat(txc);
            pComp^.PutPar(jj,curr);  {value of current to parameter}
          end else begin
            curr := 0;
          end;
        end else begin                     {empty string, put zero parameter}
          pComp^.PutPar(jj,0);
          curr := 0;
        end;
        {next, the value of the corresponding time}
        txt := CharForm.CharGrid.Cells[colt,row];   {value of current}
        len := length(txt);
        if (len > 0) then begin            {not empty}
          chkfloat(txt,e2,txz);            {check, is it a proper floating point value}
          if (e2 = 0) then begin
            temps := strtofloat(txz);
            pComp^.PutPar(jj+1,temps);  {value of current to parameter}
          end else begin
            temps := 0;
          end;
        end else begin                     {empty string, put zero parameter}
          pComp^.PutPar(jj+1,0);
          temps := 0;
        end;
        {save only positive times and currents to parameter groups}
        if (temps > 0) and (curr > 0) then line := line+txc+' '+txz+' ';
      end;
      {save user defined points to param.group as strings}
      pComp^.pParStr_s^[igrp][rr] := line;
    end;
  end;
end;

procedure StoreUDParam(pComp: TpComp; rr : integer);
{save the parameters of the user defined characteristics temporarily to an array,
 to be recalled in the case of an eventual "cancel"
 pComp   pointer to the relay
 rr      index for the curve: 1 = first phase curve,   2 = second phase curve
                              3 = first ground curve,  4 = second ground curve
                              5 = first neg.seq curve, 6 = second sequence curve}
var
  apu   : single;   {temporary}
  ii,jj : integer;  {index}
  npar  : integer;  {no of parameters = dimension of the back-up array}
begin
  if (rr >= 1) and (rr <= 6) and (pComp <> nil) then begin
    npar := high(UDParamBack);      {number of parameters = no of times and currents}
    for ii := 1 to npar do begin  {parameters of this curve}
      jj := ii+gUD_char[rr]-1;    {parameters for this curve start at gRC_char[rr]}
      pComp^.GetPar(jj,apu);
      UDParamBack[ii] := apu;       {save to the array}
    end;
  end;
end;

procedure RecallUDParam(pComp: TpComp; rr : integer);
{recall the parameters of the user defined characteristics from the temporary array,
 pComp   pointer to the relay
 rr      index for the curve: 1 = first phase curve,   2 = second phase curve
                              3 = first ground curve,  4 = second ground curve
                              5 = first neg.seq curve, 6 = second sequence curve}
var
  apu   : single;   {temporary}
  ii,jj : integer;  {index}
  npar  : integer;  {no of parameters = dimension of the back-up array}
begin
  if (rr >= 1) and (rr <= 6) and (pComp <> nil) then begin
    npar := high(UDParamBack);           {number of parameters = no of times and currents}
    for ii := 1 to npar do begin         {parameters of this curve}
      jj := ii+gUD_char[rr]-1;           {parameters for this curve start at gRC_char[rr]}
      pComp^.PutPar(jj,UDParamBack[ii]); {recall the param}
    end;
  end;
end;

procedure TCharForm.CharGridKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
  idp  : word;     {decimal point as word (integer)}
  ii   : integer;  {index}
  len  : integer;  {length of text}
  line : string;   {checked text of one cell}
  text : string;   {text of one cell}
begin
  {check decimal point}
  if (key = 190) or (key = 188) then begin   {'.' or ',' assumed to be decimal point}
    if (d_p = #190) then idp := 190 else idp := 188;   {decimal point as word (integer)}
      if (key <> idp) then begin
      text := CharGrid.cells[ActCol,ActRow];
      len := length(text);
      line := '';
      if (len > 1) then begin
        for ii := 1 to len do begin
          if (text[ii] = '.') or (text[ii] = ',') then line := line+d_p
          else line := line+text[ii];
        end;
      end;
      CharGrid.cells[ActCol,ActRow] := line;
      {send an "enter"-key press, to select the cell (remove the color)}
      keybd_event(VK_SHIFT, 0, 0, 0);
      keybd_event(13, 0, 0, 0);
      keybd_event(VK_SHIFT, 0, KEYEVENTF_KEYUP, 0);
    end;  
  end;
end;

procedure TCharForm.OKButtonClick(Sender: TObject);
{copy the parameters defining the curve from the grid to the parameter array}
var
  cLast  : single;  {last nonzero current}
  iLast  : integer; {index of last nonzero current and time}
  tLast  : single;  {last nonzero time}
begin
  ParamFromCharGrid(pActComp, ActChar);
  FindUDLast(pActComp, GetActCol, iLast, cLast, tLast); {find last nonzero current and time}
  pActComp^.PutPar(gUD_last+GetActCol-1,iLast);          {save index as extra parameter}
  {index of the curve to grid, if curve defined}
  if (curve_u > 0) then RecloserForm.ValueGrid.cells[GetActCol,GetCurveRow] := inttostr(curve_u);
  RecloserForm.ApplyButClick(sender);
  CharForm.visible := false;
  FuseForm.visible := false;
end;

procedure FindUDLast(pComp: TpComp; rr : integer; var iLast: integer;
                     var cLast, tLast: single);
{Find the index, (normalized) current and time of the last nonzero data in a user defined curve
 pComp   pointer to the relay
 rr      index for the char (or relay) type. rr = 1,2 = phase, 3,4 = ground, 4,5 = seq.
 iLast  the index of last nonzero data
 cLast  normalized current at iLast
 tLast  normalized time at iLast
 USED  in  OKButonClick and ApplyButlick}
var
  apu,apv : single;   {temporary}
  iChar   : integer;  {parameter index of first data point on char rr}
  iFirst  : integer;  {index of first nozero data point}
  ii      : integer;  {index}
  ipu     : integer;  {temporary}
  nPoint  : integer;  {(max.) number of data points}
begin
  iFirst := 0;
  iLast := 0;                    {initialize}
  tLast := 0;                    {initialize}
  cLast := 0;
  if (rr >= 1) and (rr <= 6) and (pComp <> nil) then begin
    nPoint:= 2*(CharForm.CharGrid.RowCount-1);   {no of parameter pairs}
    {find first data point}
    iChar := gUD_char[rr];          {index of first data point of this char}
   {search for the first nonzero data point (should be the first one !}
    for ii := 1 to nPoint do begin
      ipu := 2*ii+iChar-2;
      pComp^.GetPar(ipu,apu);       {first current}
      pComp^.GetPar(ipu+1,apv);     {first time}
      if (apu > 0) and (apv > 0) then begin  {current > 0 and time > 0}
        if (iFirst <= 0) then iFirst := ii;  {index of first data point found}
        iLast := ii;
        tLast := apv;               {so far last time, may change}
        cLast := apu;               {so far last current, may change}
      end else begin                {current or time not positive}
        if (iFirst > 0) then begin  {there has been positive data}
          break;                    {first zero data after nonzero data found}
        end;
      end;
    end;
  end;
end;

procedure GetUDFirst(pComp: TpComp; rr : integer; var iFirst: integer;
                     var cFirst, tFirst: single);
{get the index, current and time of the first nonzero data in a user defined curve
 pComp   pointer to the relay
 rr      index for the char (or relay) type. rr = 1,2 = phase, 3,4 = ground, 4,5 = seq.
 iFirst  the index of first nonzero data
 cFirst  normalized current at iFirst
 tFirst  normalized time at iFirst}
var
  apu,apv : single;   {temporary}
  iChar   : integer;  {parameter index of first data point on char rr}
  ii      : integer;  {index}
  ipu     : integer;  {temporary}
  nPoint  : integer;  {(max.) number of data points}
begin
  iFirst := 0;                    {initialize}
  tFirst := 0;                    {initialize}
  cFirst := 0;
  if (rr >= 1) and (rr <= 6) and (pComp <> nil) then begin
    nPoint:= 2*(CharForm.CharGrid.RowCount-1);   {no of parameter pairs}
    {find first data point}
    iChar := gUD_char[rr];          {index of first data point of this char}
   {search for the first nonzero data point (should be the first one !}
    for ii := 1 to nPoint do begin
      ipu := 2*ii+iChar-2;
      pComp^.GetPar(ipu,apu);       {first current}
      pComp^.GetPar(ipu+1,apv);     {first time}
      if (apu > 0) and (apv > 0) then begin  {current > 0 and time > 0}
        iFirst := ii;               {index of first data point found}
        tFirst := apv;
        cFirst := apu;              {first current}
        break;
      end;
    end;
  end;
end;

procedure GetUDInterval(pComp: TpComp; rr: integer; find: string; xx: single;
                        var kLow, kHigh, kFirst: integer);
{find the  interval corresponding to the given normalized current or time in the
 user defined characteristics
 It is assumed the that data is arranged so that the time of the first point
 is the largest one, and the current is the smallest one.
 pComp  pointer to the relay
 rr     index for the char. (or relay) type 1,2 = phase, 3,4 = ground, 5,6 = sequence
 find   if 'time', find interval for time, if 'curr', find interval for current
        NOTE: this is opposite to the definition in GetUDCurrOrTime, because there
              the task is to find a value for time (or current) corresponding to the
              given current (or time)
 xx     current or time, for which the interval must be found
 kLow   the lower index of the interval (the interval is normally kLow, kLow+1...)
 kHigh  the upper index of the interval (.. but can be different in error cases)
 kFirst index of first (smallest index) with nonzero data
 If a proper interval has been found  0 < kHigh = kLow+1
 If time is too large, or current is too small, kLow = kHigh = 0
 if time is too small, or current is too large, kLow = highest index with nonzero data
                                                kHigh := -2
 If the time-current table does not contain reasonable data, kLow := 0, kHigh = -1
 If error in input data (pComp = nil, or rr not reasonable) kLow = kHigh = -1
 If kLow = kHigh > 0, some unknown error has occurred}
const
  niter = 20;  {max.number of iterations (too large?!)}
var
  apu,apv    : single;   {temporary}
  cFirst     : single;   {first current}
  cHigh,cLow : single;   {current at iHigh,iLow}
  getdel     : boolean;  {true, when interval for the time delay to be found}
  ii         : integer;  {index}
  iChar      : integer;  {index of first data point}
  iFirst     : integer;  {index of the first positive data point}
  iHigh,iLow : integer;  {upper, lower index (brackets) for the interval}
  iiter      : integer;  {iteration idex}
  iNew       : integer;  {new index}
  ipu        : integer;  {temporary}
  iZero      : integer;  {highest (so far) index with undefined current or time (=0)}
  nPoint     : integer;  {(max) number of data points}
  tFirst     : single;   {first nonzero time}
  tHigh,tLow : single;   {time at iHigh, iLow}
begin
  getdel := (find = 'time');       {flag for finding time or current}
  {check reasonable data}
  if (rr >= 1) and (rr <= 6) and (pComp <> nil) then begin
    nPoint:= 2*(CharForm.CharGrid.RowCount-1);   {no of parameter pairs}
    {find first data point}
    iChar := gUD_char[rr];          {index of first data point of this char}
    GetUDFirst(pComp, rr, iFirst, cFirst, tFirst);   {get first point with nonzero data}
    kFirst := iFirst;               {to output}
    {find interval}
    if (iFirst > 0) then begin                       {reasonable, nozero data available}
      if (    getdel and (xx > tFirst)) or           {too large time}
         (not getdel and (xx < cFirst)) then  begin  {too small current}
        kLow := 0;
        kHigh := 0;
      end else begin
        {find interval where the root is}
        iLow := iFirst;
        tLow := tFirst;
        cLow := cFirst;
        iNew := nPoint;             {first guess for the new index}
        iZero := nPoint;            {initialize, not necessarily zero value!?}
        iHigh := 0;                 {zero as a flag: not defined yet}
        tHigh := 1;                 {to keep the compoler quiet, actually not known yet}
        cHigh := 1;                 {..similarly}
        for iiter := 1 to niter do begin {iterate}
          ipu := 2*iNew+iChar-1;
          pComp^.GetPar(ipu,apv);        {time}
          pComp^.GetPar(ipu-1,apu);      {current}
          {value defined}
          if (getdel and (apv > 0)) or (not getdel and (apu > 0)) then begin
            if (getdel) then begin         {find interval for time}
              if (apv <= xx) then begin
                iHigh := iNew;             {new upper index}
                tHigh := apv;
              end else begin               {temps > new value in table}
                iLow := iNew;
                tLow := apv;
              end;
            end else begin                 {time to be solved, get interval for current}
              if (apu >= xx) then begin
                iHigh := iNew;             {new upper index}
                cHigh := apu;
              end else begin               {temps > new value in table}
                iLow := iNew;
                cLow := apu;
              end;
            end;
            {new guess}
            if (iHigh = 0) then iNew := (iLow + iZero) div 2 {upper index not yet defined}
            else iNew := (iLow+iHigh) div 2;
          end else begin                  {value at iNew not defined, get a new guess}
            iZero := iNew;                {new highest index of zero value}
            iNew := (iLow + iZero) div 2; {upper index not yet defined}
            { onko aina uusi, siis eri kuin iLow tai iHigh ??}
          end;
          {interval found?, or error, or continue}
          if (iHigh > 0) then begin                {brackets found}
            if (iHigh = iLow+1) then begin         {interval found}
              kLow := iLow;
              kHigh := iHigh;
              break;                               {break, interval found}
            end else if (iHigh = iLow) then begin  {something wrong}
              kLow := iLow;                        {both are the same, but <> 0}
              kHigh := iHigh;
              break;                               {some solution found}
            end;                                   {continue to search}
          end else begin
            if (iZero = iLow+1) or (iZero = iLow) then begin         {no solution}
              kLow := iLow;
              kHigh := -2;                         {a flag (?)}
              break;
            end;
          end;
        end;
      end;
    end else begin   {no reasonable, nonzero data found}
      kLow := 0;
      kHigh := -1;   {as a flag}
    end;
  end else begin
    kLow := -1;      {error in input data}
    kHigh := -1;
  end;
end;

function CheckedTimeAdder(pComp : TpComp; rr: integer; Tmult, Tadd: single): single;
{check the time adder
 pComp  pointer to the relay
 rr     index of the relay module: phase, ground etc
 Tmult  time multiplier (preferably checked!)
 Tadd   the "raw", unchecked time adder}
var
  addmin : single;  {smallest allowed time adder}
  apu    : single;  {temporary}
  ipu    : integer; {temporary}
  tac    : single;  {checked time adder}
  tmc    : single;  {checked time multiplier}
  tLast  : single;  {last nonzero time in the user defined table}
begin
  if (Tadd > 0) then tmc := Tmult else tmc := 1; {checked time multiplier}
  GetUDLast(pComp, rr, ipu, apu, tLast); {get last (smallest) time in the user def.table}
  if (tLast > 0) then                    {defined}
    addmin := 0.011-tmc*tLast            {smallest time adder}
  else addmin := 0;
  if (Tadd < addmin) then tac := addmin  {not too small, time must be positive}
  else if (Tadd < 1000) then tac := Tadd {just some upper limit}
  else tac := 1000;
  CheckedTimeAdder := tac;
end;

procedure GetUDCurrOrTime(pComp: TpComp; rr : integer; Iss, Tmult,Tadd : single;
                          find : string; var temps, curr : single);
{find the  current corresponding to the given time in the
 user defined characteristics, or
 the time corresponding to the given current, depending on find = 'curr' or 'time'
 It is assumed that data is arranged so that the time of the first point
 is the largest one, and the current is the smallest one.
 pComp  pointer to the relay
 rr     index for the char. (or relay) type 1,2 = phase, 3,4 = ground, 5,6 = sequence
 Iss    multiplier for current (shifts char. horizontally)
 Tmult  multiplier for time (shifts char. vertically)
 Tadd   adder for the time
 find   if 'time', find time, if 'curr', find current
 temps  the given time (in), or the time to be solved (out)
 curr   the (normalized) current at given time (in our out)}
const
  niter = 20;  {max.number of iterations (too large?!)}
var
  addmin     : single;   {smallest allowed time adder}
  apu        : single;   {temporary}
  cHigh,cLow : single;   {current at iHigh,iLow}
  findint    : string;   {flag for finding interval for current or time}
  getcur     : boolean;  {true, when current to be solved, false, when time to be solved}
  iChar      : integer;  {index of first data point}
  iFirst     : integer;  {index of the first positive data point}
  iHigh,iLow : integer;  {upper, lower index (brackets) for the interval}
  ipu        : integer;  {temporary}
  Issc       : single;   {checked current multiplier}
  Ncurr      : single;   {normalized current}
  nTemps     : single;   {normalized time}
  tHigh,tLow : single;   {time at iHigh, iLow}
  tac        : single;   {checked time adder}
  tLast      : single;   {last (smallest) time in the table}
  tmc        : single;   {checked time multiplier}
  xx         : single;   {the interval sought for xx: time or current}
begin
  {flag for interval different from flag for value}
  if (find = 'curr') then findint := 'time' else findint := 'curr';
  {check parameters}
  if (Tmult > 0) then tmc := Tmult else tmc := 1;
  if (Iss > 0) then Issc := Iss else Issc := 1;
  {check time adder}
  tac := CheckedTimeAdder(pComp, rr, tmc, Tadd);

{  GetUDLast(pComp, rr, ipu, apu, tLast); {get last (smallest) time in the user def.table}
{  if (tLast > 0) then                    {defined}
{    addmin := 0.011-tmc*tLast            {smallest time adder}
{  else addmin := 0;
{  if (Tadd < addmin) then tac := addmin  {not too small, time must be positive}
{  else if (Tadd < 1000) then tac := Tadd {just some upper limit}
{  else tac := 1000;}

  getcur := (find = 'curr');             {flag for finding current or time}
  {use normalized current or normalized time}
  {"Normalized" = directly from the array, without any multiplications or additions}
  if (getcur) then begin
    Ntemps := (temps-tac)/tmc;
    xx := Ntemps;
  end else begin
    Ncurr := curr/Issc;
    xx := nCurr;
  end;
  {check reasonable data}
  if (rr >= 1) and (rr <= 6) and (pComp <> nil) then begin
    {find interval where the data is. Use normalized values}
    GetUDInterval(pComp, rr, findint, xx, iLow, iHigh, iFirst);
//showmessage(inttostr(ilow)+'  '+inttostr(ihigh)+'  '+inttostr(ifirst));
    {find value, if interval found, else use some reasonable (?) value}
    iChar := gUD_char[rr];          {index of first data point of this char}
    if (iHigh > 0) then begin                {brackets found}
      if (iHigh = iLow+1) then begin         {interval found}
        {get values at the end points of the interval}
        ipu := 2*iLow+iChar-2;
        pComp^.GetPar(ipu,cLow);             {current at iLow}
        pComp^.GetPar(ipu+2,cHigh);          {current at iHigh}
        pComp^.GetPar(ipu+1,tLow);           {time at iLow}
        pComp^.GetPar(ipu+3,tHigh);          {time at iHigh}
        {interpolate logarithmically}
        if (getcur) then begin               {current to be solved}
          if (tHigh > 0) and (tLow > 0) and (cHigh > 0) and (cLow > 0) then begin
            if (tHigh <> tLow) then begin
              apu := ln(cLow)+(ln(Ntemps)-ln(tLow))*(ln(cHigh)-ln(cLow))/(ln(tHigh)-ln(tLow));
              Ncurr := exp(apu);      {interpolate logarithmically}
            end else begin
              Ncurr := 0.5*(cLow+cHigh);
            end;
          end else begin                       {not reasonable times or currents}
            Ncurr := 1;                         {just some value}
          end;
        end else begin                         {time to be solved}
          if (tHigh > 0) and (tLow > 0) and (cHigh > 0) and (cLow > 0) then begin
            if (cHigh <> cLow) then begin
              apu := ln(tLow)+(ln(Ncurr)-ln(cLow))*(ln(tHigh)-ln(tLow))/(ln(cHigh)-ln(cLow));
              Ntemps := exp(apu);      {interpolate logarithmically}
            end else begin
              Ntemps := {0.5*(tLow+tHigh)}tLow; {else vertical part may be chopped 4.3.06}
            end;
          end else begin                       {not reasonable times or currents}
            Ntemps := 1;                        {just some value}
          end;
        end;
      end else if (iHigh = iLow) then begin  {something wrong}
        if (getcur) then begin               {current to be solved}
          ipu := 2*iLow+iChar-2;
          pComp^.GetPar(ipu,Ncurr);          {current at iLow}
        end else begin                       {time to be solved}
          ipu := 2*iLow+iChar-1;
          pComp^.GetPar(ipu,Ntemps);         {time at iLow}
        end;
      end;
    end else begin  {iHigh <= 0, no proper solution}
      if (iHigh = -2) then begin             {current too large, or time too small}
        if (getcur) then begin               {current to be solved}
          ipu := 2*iLow+iChar-2;
          pComp^.GetPar(ipu,Ncurr);          {current at iLow}
        end else begin                       {time to be solved}
          ipu := 2*iLow+iChar-1;
          pComp^.GetPar(ipu,Ntemps);         {time at iLow}
        end;
      end else if (iHigh = -1) then begin
        if (getcur) then Ncurr := 1 else Ntemps := {1}-1;  {error case, not reasonable data}
      end else begin                         {time too large, or current too small}
        if (iFirst > 0) then begin           {there is data in the table}
          if (getcur) then begin             {current to be solved}
            ipu := 2*iFirst+iChar-2;
            pComp^.GetPar(ipu,Ncurr);        {current at iFirst}
          end else begin                     {time to be solved}
            ipu := 2*iFirst+iChar-1;
            Ntemps := -1;{pComp^.GetPar(ipu,Ntemps);       {time at iFirst}
          end;
        end else begin                       {no data in the table (?)}
          if (getcur) then Ncurr := 1 else Ntemps := {1}-1;  {error case, not reasonable data}
        end;
      end;
    end;
  end else begin    {not reasonable indices or pointer}
    if (getcur) then Ncurr := -1{1} else Ntemps := -1{1};  {error case, not reasonable data}
  end;
  {output using "real" current or time. Internally used normalized current and time}
  if (getcur) then begin
    curr := Issc*Ncurr;
  end else begin
    if (Ntemps > 0) then temps := Ntemps*tmc+tac else temps := Ntemps;
  end;
end;

procedure UDTable(pComp: TpComp; rr : integer; ii : integer; var curr,temps: single);
{get the normalized current and time with the given index in the user defined curve
 pComp   pointer to the relay
 rr      index for the relay module (1,2 = phase, 3,4 = ground, 5,6 = sequence)
 ii      index
 curr    normalized current
 temps   normalized time}
var
  iChar : integer;  {index of the first data point}
  ipu   : integer;  {temporary}
begin
  if (pComp <> nil) and (ii >= 1) and (ii <= 2*(CharForm.CharGrid.RowCount-1)) and
     (rr >= 1) and (rr <= 6) then begin
    iChar := gUD_char[rr];        {index of first data point of this char}
    ipu := 2*ii+iChar-2;          {local index for current}
    pComp^.GetPar(ipu,curr);      {current with index ii}
    pComp^.GetPar(ipu+1,temps);   {time with index ii}
  end else begin                  {error case}
    curr := 0;
    temps := 0;
  end;
end;

function UDCurr(pComp: TpComp; rr : integer; Iss : single; ii : integer): single;
{get the current with the given index in the user defined curve
 pComp   pointer to the relay
 rr      index for the relay module (1,2 = phase, 3,4 = ground, 5,6 = sequence)
 Iss     current multiplier
 ii      index}
var
  apu   : single;   {temporary}
  apv   : single;   {temporary}
begin
  UDTable(pComp, rr, ii, apu,apv);  {get current and time at ii}
  UDCurr := Iss*apu;
end;

function UDTime(pComp: TpComp; rr : integer; tmult,tadd : single; ii : integer): single;
{get the time with the given index i in the user defined curve
 pComp   pointer to the relay
 rr      index for the relay module (1,2 = phase, 3,4 = ground, 5,6 = sequence)
 tmult   time multiplier
 tadd    time adder (must be checked!)
 ii      index}
var
  apu   : single;   {temporary}
  apv   : single;   {temporary}
begin
  UDTable(pComp, rr, ii, apu,apv);  {get current and time at ii}
  UDTime := tmult*apv+tadd;
end;

procedure GetUDLast(pComp: TpComp; rr : integer; var iLast: integer;
                     var cLast, tLast: single);
{get the last nonzero, normalized current and time in the user defined table.
 They are saved as extra parameters
 in OKButtonClick and ApplyButClick
 pComp   pointer to the relay
 rr      relay module (phase,ground etc)
 iLast   index of the last current and time
 cLast   last current
 tLast   last time}
var
  apu  : single;   {temporary}
  ipu  : integer;  {temporary}
begin
  if (pComp <> nil) and (rr >= 1) and (rr<= 6) then begin
    pComp^.GetPar(gUD_last+rr-1,apu);              {get index as extra parameter}
    ipu := round(apu);
    if (ipu > 0) and (ipu <= 2*(CharForm.CharGrid.RowCount-1)) then begin
      iLast := ipu;
      UDTable(pComp, rr, iLast, cLast,tLast);      {get last current and time}
    end else begin
      iLast := 0;
      cLast := 0;
      tLast := 0;
    end;
  end;
end;

procedure TCharForm.ApplyButClick(Sender: TObject);
var
  cLast  : single;  {last nonzero current}
  iLast  : integer; {index of last nonzero current and time}
  tLast  : single;  {last nonzero time}
begin
  ParamFromCharGrid(pActComp, ActChar); {curve parameters from grid to the relay}
  FindUDLast(pActComp, GetActCol, iLast, cLast, tLast); {find last nonzero current and time}
  pActComp^.PutPar(gUD_last+GetActCol-1,iLast);          {save index as extra parameter}
  {index of the curve to grid, if curve defined}
  if (curve_u > 0) then RecloserForm.ValueGrid.cells[GetActCol,GetCurveRow] := inttostr(curve_u);
  RecloserForm.ApplyButClick(sender);   {show the effect of the new parameters}
end;

procedure TCharForm.CancelButtonClick(Sender: TObject);
{restore the parameters to the state at opening the CharForm}
var
  cLast  : single;  {last nonzero current}
  iLast  : integer; {index of last nonzero current and time}
  tLast  : single;  {last nonzero time}
begin
  RecallUDParam(pActComp,GetActCol);    {recall the parameters}
  FindUDLast(pActComp, GetActCol, iLast, cLast, tLast);  {find last nonzero current and time}
  pActComp^.PutPar(gUD_last+GetActCol-1,iLast);          {save index as extra parameter}
  RecloserForm.RestoreCurveCell;        {restore the contents of the curve cell and info}
  RecloserForm.ApplyButClick(sender);   {show the effect of the new parameters}
  if (sender <> nil) then               {not cancel in fuseform}
    CharForm.visible := false;          {hide the form}
  FuseForm.visible := false;
end;

function IsUserDef(pComp: TpComp): boolean;
var
  name : string;
begin
  if (pComp <> nil) then begin
    pComp^.GetName(name);
    IsUserDef := (name = gUDRel);
  end else begin
    IsUserDef := false;
  end;
end;

procedure  ClearGrid(pGrid: TpGrid);
var
  ii : integer;
begin
  for ii := 1 to pGrid^.RowCount do begin
    pGrid^.cells[1,ii] := '0';
    pGrid^.cells[2,ii] := '0';
    pGrid^.cells[4,ii] := '0';
    pGrid^.cells[5,ii] := '0';
  end;
end;

procedure TCharForm.ClearCharGrid;
begin
  ClearGrid(@CharGrid);
  ApplyButClick(nil);
end;

procedure TCharForm.SetCurveIndex(ci: integer);
begin
  curve_u := ci;
end;

procedure ReadData(pOpenDlg: TpOpenDlg; pGrid: TpGrid; var hasRead: boolean);
{read characteristics from a text file. The data must be arranged ...
 It is assumed there is data in columns 1,2,4,5
 pOpenDlg   pointer to the opening dialog
 pGrid      pointer to the string grid where data written
 hasRead    true, when data read to the grid}
var
  DirName   : string;    {name of directory from which file was read}
  ccol,tcol : integer;   {column for current and time}
  cgFirst   : single;    {first good current}
  cgLast    : single;    {last good current}
  errc      : integer;   {error flag}
  InFile    : TextFile;  {file from which read}
  idat      : integer;   {index of data}
  igFirst   : integer;   {index of first good data}
  igLast    : integer;   {index of last good data}
  ii,jj     : integer;   {indices}
  ipar      : integer;   {counts parameters}
  line      : string;    {one line from the file}
  ndat2     : integer;   {number of data points divided by 2}
  pa1,pa2   : single;    {parameters from file}
  pa3,pa4   : single;    {parameters from file}
  row       : integer;   {row where data written}
  st1,st2   : string;    {parameters from file, as text}
  st3,st4   : string;    {parameters from file, as text}
  txc,txt   : string;    {temporary}
begin
  if (pOpenDlg.execute) then begin
    DirName := '';                            {initialize}
    DirName := ExtractFileDir(pOpenDlg^.filename);  {get directory}
    {if reasonable directory name found, save it for next time}
    if (length(DirName) >=2) then pOpenDlg^.InitialDir := DirName;
    {read the data from the file}
    try
      {first, clear old data}
      ClearGrid(pGrid);
      AssignFile(InFile,pOpenDlg^.filename);        {open the file}
      Reset(InFile);
      idat := 0;                                  {initialize counter}
      igFirst := 0;
      igLast := 0;
      cgFirst := 0;
      cgLast := 0;
      while not(EOF(InFile)) do begin
        readln(Infile,line);
        if (length(line) > 0) then begin           {there is data on the line}
          inc(idat);                               {count data}
          if (idat < pGrid^.RowCount) then begin   {first part of the grid}
            row := idat;
            ccol := 1;
            tcol := 2;
          end else if (idat < 2*pGrid^.RowCount-1) then begin {second part of the grid}
            row := idat-pGrid^.RowCount+1;
            ccol := 4;
            tcol := 5;
          end else begin                            {too large}
            row := 0;
            ccol := 0;
            tcol := 0;
          end;
          if (row > 0) and (row < pGrid^.RowCount) then begin {within the grid}
            {get the values of current and time from the line}
            ValuesFromLine(line,1,false,ipar,pa1,pa2,pa3,pa4,st1,st2,st3,st4, errc);
            if (ipar >= 1) then begin
              pGrid^.cells[ccol,row] := st1;   {current to current column}
              {time to time column}
              if (ipar >= 2) then pGrid^.cells[tcol,row] := st2;
            end;
            {update indices of first and last good data}
            if (errc = 0) and (pa1 > 0) then begin
              if (igFirst = 0) then begin
                igFirst := idat;           {index of first good data}
                cgFirst := pa1;            {first good current}
              end;
              igLast := idat;
              cgLast := pa1;               {so far last good current}
            end;
          end;
        end else begin
          break;
        end;
      end;
      {check order of data points: must be decreasing time, increasing current}
      if (igFirst > 0) and (igLast > igFirst) then begin  {reasonable data found}
        {change the order of the data, if smallest current not the first one}
        if (cgLast < cgFirst) then begin     {last good current smaller than first}
          ndat2 := idat div 2;               {number of data points / 2}
          for ii := 1 to ndat2 do begin
            jj := idat-ii+1;                 {index of data in the opposite end}
            if (jj < pGrid^.RowCount) then begin  {first part of the grid}
              row := jj;
              ccol := 1;
              tcol := 2;
            end else begin                          {second part of the grid}
              row := jj-pGrid^.RowCount+1;
              ccol := 4;
              tcol := 5;
            end;
            {swap}
            txc := pGrid^.cells[1,ii];            {current}
            txt := pGrid^.cells[2,ii];            {time}
            pGrid^.cells[1,ii] := pGrid^.cells[ccol,row];
            pGrid^.cells[2,ii] := pGrid^.cells[tcol,row];
            pGrid^.cells[ccol,row] := txc;
            pGrid^.cells[tcol,row] := txt;
          end;
        end;
      end;
    finally
      CloseFile(Infile);
    end;
    hasRead := true;
  end else begin
    hasRead := false;
  end;
end;


procedure TCharForm.OpenItemClick(Sender: TObject);
{read characteristics from a text file. The data must be arranged ...}
var
  hasRead   : boolean;   {true, when data read from file}
(*
  DirName   : string;    {name of directory from which file was read}
  ccol,tcol : integer;   {column for current and time}
  cgFirst   : single;    {first good current}
  cgLast    : single;    {last good current}
  errc      : integer;   {error flag}
  InFile    : TextFile;  {file from which read}
  idat      : integer;   {index of data}
  igFirst   : integer;   {index of first good data}
  igLast    : integer;   {index of last good data}
  ii,jj     : integer;   {indices}
  ipar      : integer;   {counts parameters}
  line      : string;    {one line from the file}
  ndat2     : integer;   {number of data points divided by 2}
  pa1,pa2   : single;    {parameters from file}
  pa3,pa4   : single;    {parameters from file}
  row       : integer;   {row where data written}
  st1,st2   : string;    {parameters from file, as text}
  st3,st4   : string;    {parameters from file, as text}
  txc,txt   : string;    {temporary}
*)
begin
  ReadData(@OpenDlg, @CharGrid, hasRead);
  if (hasRead) then begin
    curve_u := 0;
    RecloserForm.ValueGrid.cells[GetActCol,GetCurveRow] := '0';
    {add info: filename from where read}
    ReplaceInfoLine(OpenDlg.filename);
    RecloserForm.InfoMemo.text := OpenDlg.filename;
  end;
end;

procedure InsertRow(pGrid: TpGrid; arow, acol: integer);
{"insert" a row above the selected cell. That is, move cells down starting with
 the selected cell
 It is assumed that the grid has six columns, with data in columns 1,2 and 4,5
 (when the first column = 0)
 pGrid pointer to the string grid
 row, col the "active" row and column = row and col. of the selected cell}
var
  broken  : boolean;   {true, when loop breaked}
  ii,jj   : integer;   {indices}
  ndatr   : integer;   {number of data rows in the grid}
begin
  if (arow >= 1) and (arow < pGrid^.RowCount) and  {reasonable row}
     ((acol = 1) or (acol = 2) or (acol = 4) or (acol = 5)) then begin
    ndatr := pGrid^.RowCount-1;                    {number of data rows}
    broken := false;                               {initialize}
    for ii := 2 to ndatr do begin                  {all data may be shifted}
      jj := ndatr-ii+1;                            {start from the end}
      pGrid^.cells[4,jj+1] := pGrid^.cells[4,jj];  {shift current downwards}
      pGrid^.cells[5,jj+1] := pGrid^.cells[5,jj];  {shift time downwards}
      {check, moved up to active cell}
      if (jj = arow) and ((acol = 4) or (acol = 5)) then begin
        pGrid^.cells[4,jj] := '0';                 {"empty" row}
        pGrid^.cells[5,jj] := '0';
        broken := true;
        break;
      end;
    end;
    {copy the last row of first part to first row of the second part, if not broken}
    if (not broken) then begin
      pGrid^.cells[4,1] := pGrid^.cells[1,ndatr];  {shift current downwards}
      pGrid^.cells[5,1] := pGrid^.cells[2,ndatr];  {shift time downwards}
      {break, if this was the active row}
      if (arow = ndatr) then begin
        pGrid^.cells[1,ndatr] := '0';              {"empty" row}
        pGrid^.cells[2,ndatr] := '0';
        broken := true;
      end;
    end;
    {continue to the first half, if not broken}
    if (not broken) then begin
      for ii := 2 to ndatr do begin                 {all data may be shifted}
        jj := ndatr-ii+1;                           {start from the end}
        pGrid^.cells[1,jj+1] := pGrid^.cells[1,jj]; {shift current downwards}
        pGrid^.cells[2,jj+1] := pGrid^.cells[2,jj]; {shift time downwards}
        {check, moved up to active cell}
        if (jj = arow)  then begin
          pGrid^.cells[1,jj] := '0';                {"empty" row}
          pGrid^.cells[2,jj] := '0';
          broken := true;
          break;
        end;
      end;
    end;
  end;
end;

procedure TCharForm.DownButClick(Sender: TObject);
{"insert" a row above the selected cell. That is, move cells down starting with
 the selected cell}
//var
//  broken  : boolean;   {true, when loop breaked}
//  ii,jj   : integer;   {indices}
//  ndatr   : integer;   {number of data rows in the grid}
begin
  InsertRow(@CharGrid, actrow, actcol);
end;

procedure SwapData(pGrid: TpGrid);
{swap the current and time columns
 It is assumed that currents are in columns 1 and 4, and data in col. 2 and 5
 (or vice versa)
 pGrid   pointer to the string grid}
var
  ii      : integer;   {index}
  ndatr   : integer;   {number of data rows in the grid}
  txt     : string;    {temporary string}
begin
  ndatr := pGrid^.RowCount-1;       {number of data rows}
  for ii := 1 to ndatr do begin
    txt := pGrid^.cells[1,ii];
    pGrid^.cells[1,ii] := pGrid^.cells[2,ii];
    pGrid^.cells[2,ii] := txt;
    txt := pGrid^.cells[4,ii];
    pGrid^.cells[4,ii] := pGrid^.cells[5,ii];
    pGrid^.cells[5,ii] := txt;
  end;
end;

procedure TCharForm.SwapButClick(Sender: TObject);
{swap the current and time columns}
begin
  SwapData(@CharGrid);
end;

procedure SaveData(pSaveDlg: TpSaveDlg; pGrid: TpGrid);
{save the current - time data to a file
 It is assumed that there is data in columns 1,2,4,5
 pSaveDlg   pointer to the save dialog
 pGrid      pointer to the string grid with the data}
var
  DirName : string;    {name of the saving directory}
  ii      : integer;   {index}
  ndatr   : integer;   {number of data rows in the grid}
  Outfile : TextFile;  {file where written}
begin
  if (pSaveDlg^.execute) then begin
    DirName := '';                                {initialize}
    DirName := ExtractFileDir(pSaveDlg^.filename);  {get directory}
    {if reasonable directory name found, save it for next time}
    if (length(DirName) >=2) then pSaveDlg^.InitialDir := DirName;
    try
      AssignFile(Outfile, pSaveDlg^.filename);        {open the given file,BUT ERRORS ?}
      rewrite(outfile);
      ndatr := pGrid^.RowCount-1;                 {number of data rows}
      {write first part to file}
      for ii := 1 to ndatr do begin
        writeln(outfile,pGrid^.cells[1,ii]+'  '+pGrid^.cells[2,ii]);
      end;
      {write second part to file}
      for ii := 1 to ndatr do begin
        writeln(outfile,pGrid^.cells[4,ii]+'  '+pGrid^.cells[5,ii]);
      end;
    finally
      closefile(outfile);
    end;
  end;
end;

procedure TCharForm.SaveItemClick(Sender: TObject);
{save the current - time data to a file}
//var
//  DirName : string;    {name of the saving directory}
//  ii      : integer;   {index}
//  ndatr   : integer;   {number of data rows in the grid}
//  Outfile : TextFile;  {file where written}
begin
  SaveData(@SaveDlg, @CharGrid);
(*
  if (SaveDlg.execute) then begin
    DirName := '';                                {initialize}
    DirName := ExtractFileDir(SaveDlg.filename);  {get directory}
    {if reasonable directory name found, save it for next time}
    if (length(DirName) >=2) then SaveDlg.InitialDir := DirName;
    try
      AssignFile(Outfile, SaveDlg.filename);        {open the given file,BUT ERRORS ?}
      rewrite(outfile);
      ndatr := CharGrid.RowCount-1;                 {number of data rows}
      {write first part to file}
      for ii := 1 to ndatr do begin
        writeln(outfile,CharGrid.cells[1,ii]+'  '+CharGrid.cells[2,ii]);
      end;
      {write second part to file}
      for ii := 1 to ndatr do begin
        writeln(outfile,CharGrid.cells[4,ii]+'  '+CharGrid.cells[5,ii]);
      end;
    finally
      closefile(outfile);
    end;
  end;
*)
end;

procedure RemoveRow(pGrid: TpGrid; acol, arow: integer);
{delte the selected row. That is, move cells up starting with the cell below
 the selected cell
  It is assumed that the grid has six columns, with data in columns 1,2 and 4,5
 (when the first column = 0)
 pGrid pointer to the string grid
 row, col the "active" row and column = row and col. of the selected cell}
var
  ii,jj   : integer;   {indices}
  ndatr   : integer;   {number of data rows in the grid}
begin
  ndatr := pGrid^.RowCount-1;                       {number of data rows}
  if (arow >= 1) and (arow < pGrid^.RowCount) then begin {reasonable row}
    {cells to be deleted are in the second part}
    if (acol = 4) or (acol = 5) then begin
      if (arow < ndatr) then begin                       {not the last row}
        for ii := arow to ndatr-1 do begin
          pGrid^.cells[4,ii] := pGrid^.cells[4,ii+1];    {shift current up}
          pGrid^.cells[5,ii] := pGrid^.cells[5,ii+1];    {shift time up}
        end;
      end;
      pGrid^.cells[4,ndatr] := '0';                      {clear the last row}
      pGrid^.cells[5,ndatr] := '0';
    {cells to be deleted are in the first part}
    end else if (acol = 1) or (acol = 2) then begin
      if (arow < ndatr) then begin                       {not the last row}
        for ii := arow to ndatr-1 do begin
          pGrid^.cells[1,ii] := pGrid^.cells[1,ii+1];    {shift current up}
          pGrid^.cells[2,ii] := pGrid^.cells[2,ii+1];    {shift time up}
        end;
      end;
      {handle the last row of the first part}
      pGrid^.cells[1,ndatr] := pGrid^.cells[4,1];        {shift current up}
      pGrid^.cells[2,ndatr] := pGrid^.cells[5,1];        {shift time up}
      {shift also the second part up}
      for ii := 1 to ndatr-1 do begin
        pGrid^.cells[4,ii] := pGrid^.cells[4,ii+1];      {shift current up}
        pGrid^.cells[5,ii] := pGrid^.cells[5,ii+1];      {shift time up}
      end;
      pGrid^.cells[4,ndatr] := '0';                      {clear the last row}
      pGrid^.cells[5,ndatr] := '0';
    end;
  end;
end;

procedure TCharForm.UpButClick(Sender: TObject);
{delte the selected row. That is, move cells up starting with the cell below
 the selected cell}
//var
//  ii,jj   : integer;   {indices}
//  ndatr   : integer;   {number of data rows in the grid}
begin
  RemoveRow(@CharGrid, actcol, actrow);
end;

procedure ProperRowAndColumn(ndatr, jj : integer; var row, cc,ct : integer);
{find the row and columns in the grid corresponding to the index that goes from
 1 to 2*number of rows = max. number of data pairs
 ndatr  number of data rows
 jj     index of data pair
 row    row in the grid
 cc,ct  columns in the grid}
begin
  {corresponding row and column in the grid}
  if (jj > ndatr) then begin
    row := jj-ndatr;
    cc := 4;                      {column}
    ct := 5;
  end else begin
    row := jj;
    cc := 1;
    ct := 2;
  end;
end;

procedure FlipData(pGrid: TpGrid);
{flip the data: first to last and last to first, etc
 It is assumed that data is in columns 1,2 and 4,5
 pGrid pointer to the string grid}
var
  cc,ct    : integer;   {column for current and time}
  cc2,ct2  : integer;   {column for current and time}
  flip     : boolean;   {can flip}
  ii,jj    : integer;   {indices}
  lastnz   : integer;   {index of last nonzero data}
  lastnz2  : integer;   {lastnz div 2}
  ndatr    : integer;   {number of data rows in the grid}
  row,row2 : integer;   {the (proper) row }
  txc,txt  : string;    {temporary}
begin
  ndatr := pGrid^.RowCount-1;               {number of data rows}
//  for ii := 1 to ndatr do begin
//    jj := ndatr-ii+1;
//    txc := pGrid^.cells[4,jj];
//    txt := pGrid^.cells[5,jj];
//    pGrid^.cells[4,jj] := pGrid^.cells[1,ii];
//    pGrid^.cells[5,jj] := pGrid^.cells[2,ii];
//    pGrid^.cells[1,ii] := txc;
//    pGrid^.cells[2,ii] := txt;
//  end;
{ - - - - - - - - - - - - - - }
  {find last nonzero entry}
  flip := false;
  lastnz := 1;
  for ii := 1 to 2*ndatr do begin   {all data pairs as if in two columns, not four}
    jj := 2*ndatr-ii+1;             {from end}
    {corresponding row and column in the grid}
    ProperRowAndColumn(ndatr, jj, row, cc,ct);
    {nonzero ?}
    if ((pGrid^.cells[cc,row] <> '0') and (pGrid^.cells[cc,row] <> '')) and
       ((pGrid^.cells[ct,row] <> '0') and (pGrid^.cells[ct,row] <> '')) then begin
      flip := true;           {there is some data, can flip}
      lastnz := jj;
      break;
    end;
  end;
  {flip data, if there is data}
  if (flip) then begin
    lastnz2 := lastnz div 2;      {index of last data to be flipped}
    for ii := 1 to lastnz2 do begin
      jj := lastnz-ii+1;          {index of data to be flipped with}
      {coresponding rows and columns}
      ProperRowAndColumn(ndatr,ii, row, cc,ct);
      ProperRowAndColumn(ndatr,jj, row2, cc2,ct2);
      {flip this pair of data}
      txc := pGrid^.cells[cc,row];
      txt := pGrid^.cells[ct,row];
      pGrid^.cells[cc,row] := pGrid^.cells[cc2,row2];
      pGrid^.cells[ct,row] := pGrid^.cells[ct2,row2];
      pGrid^.cells[cc2,row2] := txc;
      pGrid^.cells[ct2,row2] := txt;
    end;
  end;
end;

procedure TCharForm.FlipButClick(Sender: TObject);
{flip the data: first to last and last to first, etc}
begin
  FlipData(@CharGrid);
end;

procedure ClearData(pGrid: TpGrid; var cleared: boolean);
{clear the curve = set all values to 0
 It is assumed that there is data in columns 1,2,4,5
 pGrid    pointer to the string grid
 cleared  true, if data cleared}
var
  ii : integer;
begin
  if MessageDlg('Really clear the data?',
                 mtConfirmation, [mbYes, mbNo], 0) = mrYes then begin
    ClearGrid(pGrid);
    cleared := true;
  end else begin
    cleared := false;
  end;
end;

procedure TCharForm.ClearButClick(Sender: TObject);
{clear the curve = set all values to 0}
var
  cleared : boolean;  {true, when data cleared}
begin
  ClearData(@CharGrid, cleared);
  if (cleared) then begin
    curve_u := 0;
    RecloserForm.ValueGrid.cells[GetActCol,GetCurveRow] := '0';
  end;
end;

procedure TCharForm.CopyButClick(Sender: TObject);
{copy data to local "clipboard" = arrays}
var
  ii : integer;
begin
  for ii := 1 to high(UDCopy1) do begin
    UDCopy1[ii] := CharGrid.cells[1,ii];
    UDCopy2[ii] := CharGrid.cells[2,ii];
    UDCopy4[ii] := CharGrid.cells[4,ii];
    UDCopy5[ii] := CharGrid.cells[5,ii];
  end;
end;

procedure TCharForm.PasteButClick(Sender: TObject);
{paste data from local "clipboard" = arrays}
var
  ii : integer;
begin
  for ii := 1 to high(UDCopy1) do begin
    CharGrid.cells[1,ii] := UDCopy1[ii];
    CharGrid.cells[2,ii] := UDCopy2[ii];
    CharGrid.cells[4,ii] := UDCopy4[ii];
    CharGrid.cells[5,ii] := UDCopy5[ii];
  end;
end;

procedure TCharForm.HelpButClick(Sender: TObject);
{show the help-memo}
begin
  if (not HelpMemo.visible) then begin
    HelpMemo.top := CharGrid.top+32;
    HelpMemo.left := CharGrid.left+32;
    HelpMemo.width := CharGrid.width-32;
    HelpMemo.height := 300;
    HelpMemo.BringToFront;
    HelpMemo.visible := true;
  end else begin
    HelpMemo.visible := false;
  end;    
end;

procedure TCharForm.HelpMemoMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if (x < 32) and (y < 24) then HelpMemo.visible := false;
end;

procedure TCharForm.FuseButClick(Sender: TObject);
begin
//FusePanel.visible := true;
  FuseGroupPanel.visible := true;
end;

procedure TCharForm.SelectImgMouseDown(fw,fh,ncol, nfuze, X, Y: Integer;
          pCour,pTemps : array of pString; mfuze : array of integer; var icurve: integer);
{select the fuse curve, copy points to grid
fw, fh   width, height of a single cell (rectangle) in the selection image
ncol     number of colums in the selection image
nfuze    number of curves
x,y      mouse coordinates
pCour, pTemps  pointers to the arrays for current, time data of the fuse
mfuze    number of data points = dim. of the arrays
icurve   index of the curve, if -1 : no curve selected}
var
  apu   : single;
  ii,jj : integer;
  kk    : integer;   {index of the curve}
  mf    : integer;   {number of points in one column}
  nf    : integer;   {number of points}
  pC,pT : pString;   {pointers to the currents and times as strings}
begin
  {determine index from coordinates}
  ii := (x div fw);
  jj := (y div fh);
  kk := jj*ncol+ii+1;
  {copy curve if reasonable index}
  if (kk >= 1) and (kk <= nfuze) then begin
    {first, clear old data}
    ClearGrid(@CharGrid);
    curve_u := 0;
    RecloserForm.ValueGrid.cells[GetActCol,GetCurveRow] := '0';
    {pointers to the data}
    pC := pCour[kk-1];    {pointer to array for currents}
    pT := pTemps[kk-1];   {pointer to array for times}
    nf := mfuze[kk-1];    {number of data points}
    {copy to the grid. Check first, does the data fit in one column  }
    if (nf < CharGrid.rowcount) then mf := nf else mf := CharGrid.rowcount-1;
    for ii := 1 to mf do begin
      CharGrid.cells[1,ii] := pC^;
      inc(pC);
      CharGrid.cells[2,ii] := pT^;
      inc(pT);
    end;
    {second column needed?}
    if (nf >= CharGrid.rowcount) then begin
      for ii := 1 to nf-CharGrid.rowcount+1 do begin
        CharGrid.cells[4,ii] := pC^;
        inc(pC);
        CharGrid.cells[5,ii] := pT^;
        inc(pT);
      end;
    end;
    icurve := kk;   {index of curve out}
  end else begin
    icurve := -1;   {no curve selected}
  end;
end;

procedure TCharForm.CurveFromMoreFuses(var icurve: integer);
{copy the fuse curve from the Curr and Time lists of MoreFuses
icurve   index of the curve, if -1 : no curve selected CHECK!!!}
var
//  apu   : single;
  ii{,jj} : integer;
//  kk    : integer;   {index of the curve}
  mf    : integer;   {number of points in one column}
  nf    : integer;   {number of points}
  cc,tt : String;    {the currents and times as strings}
begin
  nf := FuseForm.CurrListCount;                  {number of points}
//FuseForm.testedit.text := FuseForm.FullCurveName {inttostr(nf)};
  {copy curve if reasonable index}
  if (nf >1) then begin
    {first, clear old data}
    ClearGrid(@CharGrid);
    curve_u := 0;
    RecloserForm.ValueGrid.cells[GetActCol,GetCurveRow] := '0';
    {copy to the grid. Check first, does the data fit in one column  }
    if (nf < CharGrid.rowcount) then mf := nf else mf := CharGrid.rowcount-1;
    for ii := 1 to mf do begin
      FuseForm.GetInvCurrTime(ii, cc, tt);  {get current and time}
      CharGrid.cells[1,ii] := cc;
      CharGrid.cells[2,ii] := tt;
    end;
    {second column needed?}
    if (nf >= CharGrid.rowcount) then begin
      for ii := 1 to nf-CharGrid.rowcount{+1} do begin
        FuseForm.GetInvCurrTime(ii+CharGrid.rowcount, cc, tt);  {get current and time}
        CharGrid.cells[4,ii] := cc;
        CharGrid.cells[5,ii] := tt;
      end;
    end;
//    icurve := kk;   {index of curve out}
  end else begin
    icurve := -1;   {no curve selected}
  end;
  FuseGroupPanel.visible := false;
  ApplyButClick(nil);
end;

procedure TCharForm.ReplaceInfoLine(line: string);
{replace the info line corresponding to the present group and relay module with
 the given line}
var
  col   : integer;   {(active) column in the grid of parameters}
  igrp  : integer;   {index of the parameter group in use}
  pComp : TpComp;    {pointer to the relay}
begin
  igrp := Recloser.RCGridCalc.ParamGroupIndex;  {get the index of the parameter group}
  col := Recloser.RCGridCalc.GetActCol;         {get the index of the column}
  {replace the line}
  pComp := RCGridCalc.GetpAct;                  {user def. and recloser in RCGridCalc}
  if (pComp <> nil )then begin
    pComp^.ReplaceInfoLine((igrp-1)*gParSet+col-1,line);
  end;
end;

procedure TCharForm.FuseImgMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
{select the fuse curve, copy points to grid}
var
  icrv  : integer;
  line  : string;
begin
  SelectImgMouseDown(fwidth,fheight,fcol, nfuse, X, Y, pCurr,pTime, mfuse,icrv);
  if (icrv <= 0) then FusePanel.visible := false
  else curve_u := 1000+icrv;   {save index of curve}
  {save information on the curve}
  if (icrv > 0) then begin
    if (fcapt[icrv] <> '') and (fcapt[icrv] <> 'close') then begin
      line := 'A B Chance Fuse '+fcapt[icrv];
      ReplaceInfoLine(line);
      {if (RecloserForm.InfoMemo.visible) then} RecloserForm.InfoMemo.text := line;
      ApplyButClick(nil);
    end;
  end;
end;

procedure TCharForm.FormKeyPress(Sender: TObject; var Key: Char);
{accept only reasonable keys (not a complete check)}
begin
  if (ActiveControl <> InfoMemo) then begin  {..but memo accepts all keys}
    if (((key >= 'a') and (key <= 'z')) or ((key >= 'A') and (key <= 'Z'))) and
       not(key = 'e') and not(key = 'E') then key := #0
    else if (key = '-') then key := #0;
  end;
end;

procedure TCharForm.ChanceButClick(Sender: TObject);
begin
  FuseGroupPanel.visible := false;
  FusePanel.visible := true;
end;

procedure TCharForm.CancelButClick(Sender: TObject);
begin
  FuseGroupPanel.visible := false;
end;

procedure TCharForm.SlowFastButClick(Sender: TObject);
begin
  SlowFastPanel.visible := true;
  FuseGroupPanel.visible := false;
end;

procedure TCharForm.SlowFastImgMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  icrv : integer;
  line : string;
begin
  SelectImgMouseDown(sfwidth,sfheight,sfcol, nslowfast, X, Y, pSFcurr, pSFtime, mSFfuse,icrv);
  if (icrv <= 0) then SlowFastPanel.visible := false
  else curve_u := 2000+icrv;   {save index of curve}
  {save information on the curve}
  if (icrv > 0) then begin
    if (sfcapt[icrv] <> '') and (sfcapt[icrv] <> 'close') then begin
      line := 'Slow Fast Fuse '+sfcapt[icrv];
      ReplaceInfoLine(line);
      {if (RecloserForm.InfoMemo.visible) then} RecloserForm.InfoMemo.text := line;
      ApplyButClick(nil);
    end;
  end;
end;

procedure TCharForm.KfuseButClick(Sender: TObject);
begin
  KfusePanel.visible := true;
  FuseGroupPanel.visible := false;
end;

procedure TCharForm.KfuseImgMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  icrv : integer;
  line : string;
begin
  SelectImgMouseDown(kwidth,kheight,kcol, nKfuses, X, Y, pKcurr, pKtime, mKfuse,icrv);
  if (icrv <= 0) then KfusePanel.visible := false
  else curve_u := 3000+icrv;   {save index of curve}
  {save information on the curve}
  if (icrv > 0) then begin
    if (kcapt[icrv] <> '') and (kcapt[icrv] <> 'close') then begin
      line := 'K Fuse '+kcapt[icrv];
      ReplaceInfoLine(line);
      {if (RecloserForm.InfoMemo.visible) then} RecloserForm.InfoMemo.text := line;
      ApplyButClick(nil);
    end;
  end;
end;

function TCharForm.FuseCode(UDcode: string): string;
{get the code of the selected fuse. The index for the code is given in
 which is of form n*1000+kk,
 where n: 1 = A B Chance fuses
          2 = SlowFast fuses
          3 = K-fuses
          4 = standard fuses
          5 = from file, using morefuses
 and kk is the index of the code
 UDcode  complete code of the relay as}
var
  ipu  : integer;
  fc   : string;
  fgrp : integer; {fuse group}
  kk   : integer; {index of the code}
begin
  ipu := strtoint(UDcode);
  fgrp := ipu div 1000;
  kk := ipu-fgrp*1000;
  if (fgrp = 1) then fc := fcapt[kk]
  else if (fgrp = 2) then fc := 'sf'+sfcapt[kk]
  else if (fgrp = 3) then fc := 'K'+kcapt[kk]
  else if (fgrp = 4) then fc := 'S'+scapt[kk]
  else if (fgrp = 5) then fc := 'view|info'
  else fc := 'userdef';
  FuseCode := fc;
end;

procedure TCharForm.StdButClick(Sender: TObject);
begin
  SfusePanel.visible := true;
  FuseGroupPanel.visible := false;
end;

procedure TCharForm.SfuseImgMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  icrv : integer;
  line : string;
begin
  SelectImgMouseDown(swidth,sheight,scol, nSfuses, X, Y, pScurr, pStime, mSfuse,icrv);
  if (icrv <= 0) then SfusePanel.visible := false
  else curve_u := 4000+icrv;   {save index of curve}
  {save information on the curve}
  if (icrv > 0) then begin
    if (scapt[icrv] <> '') and (scapt[icrv] <> 'close') then begin
      line := 'Standard Fuse '+scapt[icrv];
      ReplaceInfoLine(line);
      {if (RecloserForm.InfoMemo.visible) then} RecloserForm.InfoMemo.text := line;
      ApplyButClick(nil);
    end;
  end;
end;


procedure TCharForm.MoreButClick(Sender: TObject);
begin
  FuseForm.visible := true;
  FuseGroupPanel.visible := false;
end;

procedure TCharForm.FormHide(Sender: TObject);
begin
if (not appl_close) then begin
  FuseForm.visible := false;
  SfusePanel.visible := false;
  KfusePanel.visible := false;
  SlowFastPanel.visible := false;
  FusePanel.visible := false;
  InfoItem.checked := false;
  InfoMemo.visible := false;
end;
end;

procedure TCharForm.InfoItemClick(Sender: TObject);
begin
  InfoItem.checked := not InfoItem.checked;
  InfoMemo.visible := InfoItem.checked;
  {update the info text}
  if (InfoMemo.visible) then
    RecloserForm.GetInfoText(Recloser.GetActCol);
end;

procedure TCharForm.InfoMemoMouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
{move the memo}
const
  x0  : integer = 0;    {old coordinates}
  y0  : integer = 0;
begin
  if (ssLeft in Shift) then begin        {left button pressed}
    InfoMemo.left := InfoMemo.left+X-x0;
    InfoMemo.top  := InfoMemo.top +Y-y0;
  end else begin
    x0 := X;
    y0 := Y;
  end;
end;

procedure TCharForm.FormShow(Sender: TObject);
begin
  if (InfoMemo.top < 0) then InfoMemo.top := 0;
end;

procedure TCharForm.InfoMemoKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  {copy to the component}
  ReplaceInfoLine(InfoMemo.text);
  {copy to the info of the recloser form (but if it is copied back, due to OnChange??}
  RecloserForm.InfoMemo.text := InfoMemo.text;
end;



end.
