unit Utildef;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, ExtCtrls, ComCtrls, StdCtrls, Grids, Buttons,Menus,Spin,
  Ualnedit;

type
  pInteger  = ^Integer;
  pSingle   = ^Single;
  ppSingle  = ^pSingle;
  pWord     = ^Word;
  pBoolean  = ^boolean;
  pDouble   = ^Double;
  TpObject  = ^TObject;
  TpImage   = ^TImage;
  TpForm    = ^TForm;
  TpString  = ^String;
  TpEdit    = ^TEdit;
  TpAlEdit  = ^TAlignEdit;
  TpMemo    = ^TMemo;
  TpListBox  = ^TListBox;
  TpTextFile = ^TextFile;
  TpStringList = ^TStringList;
  TpGrid    = ^TStringGrid;
  TpSpeedBut  = ^TSpeedButton;
  TpBitBut   = ^TBitBtn;
  TpList     = ^TList;
  TpRichEdit = ^TRichEdit;
  TpPopUpMenu = ^TPopupMenu;
  TpPanel     = ^TPanel;
  TColArr = array [1..16] of TColor;
  TpCheckBox = ^TCheckBox;
  TpButton   = ^TButton;
  TpLabel    = ^TLabel;
  TpCanvas   = ^TCanvas;
  TpTimer    = ^TTimer;
  TpMenuItem = ^TMenuItem;
  TpRadioBut = ^TRadioButton;
  TpSpinBut  = ^TSpinButton;
  TpOpenDlg  = ^TOpenDialog;
  TpSaveDlg  = ^TSaveDialog;
  TpPicture  = ^TPicture;
  TpComboBox = ^TComboBox;
  TpGroupBox = ^TGroupBox;
  TpTreeNode = ^TTreeNode;   {pointer to a tree-node}
type
  TpPoint = ^TPoint;

type
  TpIntri = ^Intri;                {pointer to the four integers}
  Intri = Record                   {collection of three integers}
  indx  : integer;                 {index or identifier}
  ix    : integer;                 {first integer (x-coord.)}
  iy    : integer;                 {second integer(y-coord.)}
  no    : integer;                 {fouth integer (number of smth)}
end;

type
  TpTrois = ^Ttrois;
  Ttrois = Record
  x      : single;
  y      : single;
  z      : single;
  r      : single;
  q      : single;
end;

type
  TpMultix = ^Tmultix;
  Tmultix = Record
  u : single;
  v : single;
  w : single;
  x : single;
  y : single;
  z : single;
end;

type
  TpIntSing = ^TIntSing;
  TIntSing = Record
  i  : integer;
  j  : integer;
  x  : single;
  y  : single;
  z  : single;
end;

{for saving data of relays in a list. Needed in Relcurr.pas}
type
  TpRelData = ^TRelData;
  TRelData = Record
  ipComp : longint;  {pointer to the relay, as integer}
  rr     : integer;  {type, or index of the module}
end;

{for font-properties, without using the font-object}
type
  TFontProp = Record
  color  : Tcolor;
  size   : integer;
  name   : string;
  bstyle : TBrushStyle;
  bcolor : Tcolor;
end;

{record for collection of data needed in writing to a bitmap}
type
  TpWriteBmp = ^TWriteBmp;
  TWriteBmp = Record
  txt : string;      {the text to be written}
  ix  : integer;     {x-coordinate of the text}
  iy  : integer;     {y-coordinate of the text}
  fp  : TFontProp;   {properties of the font}
end;

{define a type ("enum") for the procedure MarkerPosition in Diagram.pas. A variable of
 this type tells, which procedure calls the procedure MarkerPosition}
type
  TCaller = (draw,arrow,mouse,MainArrow,UndoMoveAll);

{define a type ("enum") for different operations that can be undone}
  TUndoType = (MoveGroup, MoveAll, MoveComp, AddGroup, AddComp,
               Delete, param, no_op);

const
  scroll_width = 24;   {widht of scroll-bars}
  Zone1Color = clRed;  {colors for the zones of distance relays}
  Zone2Color = clGreen;
  Zone3Color = clFuchsia;
  Zone4Color = clBlack;
  Zone5Color = clAqua;
  gAuto      = 'auto'; {for the state of the distance relay button}
  gFiltChar  = '';    {flag-character for "filtering" = selecting for reports}
  gGround    = 'grnd';
  {gMaxTime must be defined in the follwing way. Otherwise gMaxTime is not recognized
   in TimeDiff and Relcurr!!?? But only if they are compiled afther the other units:
   That is, Project|Build All, a small change in TimeDiff, Run|Run => gMaxTime
   is in error !?  15.5.2007}
  gMaxTime : single = {1000.5}5000.5; {max.activation time of inv.time rel (relcurr, TimeDiff) }
  gPhase     = 'phase';
  gForward   = 1;      {mask for distance relays, to set/read forward/reverse flag in adpar_s }
  gImpedSep  = '\';    {separator for data of impedance separators, in distance relays}
  Improbg    = 1.015625;  {a very improbable number ...?...}
  ImprobTg   ='1.015625'; {..the same as a string}
  gLoadScen  = 3;      {number of load scenarios}
  gParSet    = 6;      {number of sets of parameters}
  gBreGrup   = 4;      {max.no of breakers for the change of relay parameter group}
  gReCurv    = 6;      {number of char.curves in a recloser or user def. relay}
  gMutuLine  = 8;      {number of lines connected by mutual inductance, needed in Mutual.pas}
  gMutuNode  = 5;      {number of nodes for one line}
  gMutuNpar  = 7;      {number of (self-)parameters of one line (length, R, X, etc}
  gMutuStrt  = 91;     {line parameters of mutual impedances start at this index}
  { }                  {gMutuStrt-1 is reserved for ss = relative position of middle node}
  gColor : TColArr
             = ($0000FF{red}      , $00FF00{lt green}    , $FF0000{blue}  , $000000{black},
                $FF00FF{violet}   , $F0F000{lt blue}     , $20A0FF{orange}, $C0C0C0{grey},
                $D00000{dk blue}  , $00D000{green}       , $0000D0{brown} , $F0D000{blue-grey},
                $C000C0{dk violet}, $C0C000{dk blue-grey}, $00FFFF{yellow}, $50A050{dk green});
  TextFontName = 'arial';   {font of the text-component}
  TextFontSize = 8;
  TextFontColor = clBlue;
  gImpedSumText = 'Solved voltages for impedance sum'; {hint text of SolvedProb for impedance sum}
  gMutualMax = gMutuLine;  {max number of mutually connected transmission lines}
type
  TReCurv = array[1..gReCurv] of string;  {points for user def. curves as a string}
type
  TParStr = array[1..gParSet] of TReCurv; {user def. curves for all parameter sets, as strings}
type
  TpParStr = ^TParStr;

procedure ClearIntri(pIntri : TpIntri);
procedure GetCRsize(var CRw,CRs : integer);
procedure ColorInitialize(pImage : TpImage);

type
{class for an array of reals (or single:s)}
  TpRearr = ^TRearr;               {define pointer first !}
  TRearr  = Class(TObject)         {define class for reals}
  procedure CreArr(nArr:Integer);  {create the array}
  procedure DelArr;                {destroy the array}
  procedure Putval(i:Integer; xyz:Single);{put xyz to array as entry number i}
  procedure Getval(i:Integer; var xyz:Single);{get xyz as entry i of the array}
  procedure MaxMin(var  rmax, rmin : single); {find max and min in the array}
  function  NumberOfElements: integer;        {get the number of elements}
  procedure CopyFromArray(pFrom : TpRearr);   {copy from another array}
  procedure GetPtr(var pArr: pSingle);        {get pointer to the array}
  procedure Clear;
  private
    pArr_r : pSingle;   {pointer to the array}
    nArr_r : Integer;   {number of elements}
  end;

type
  {a general function for function evaluations}
  TgFunc = function(pPar : TpRearr; xx : single) : single;
          {pPar is a pointer to an array of parameters
           the function value is calculated at xx}
type
  {function for drawing on a bitmap (canvas)}
  TEditBmp = procedure(Toile: TCanvas; ippar,ippi : longint);
  {Toile = canvas, where drawn (edited), ippar, ippi  pointer to parameters as integer}

function tan(angle : single): single;

procedure putImat(paa: pInteger; {pointer to the first element of the matrix}
                  i,j: Integer;   {indices of the element}
                  m,n: Integer;   {the dimensions of the matrix}
                  xx : Integer);  {the value to be put into the matrix}

procedure getImat(paa: pInteger;{pointer to the first element of the matrix}
                 i,j: Integer;  {indices of the element}
                 m,n: Integer;  {the dimensions of the matrix}
             var xx : Integer); {the value to get the value of aa(i,j)}

procedure putIvec(paa: pInteger; {pointer to the first element of the matrix}
                  i  : Integer;  {indices of the element}
                  n  : Integer;  {the dimensions of the matrix}
                  xx : Integer); {the value to be put into the matrix}

procedure getIvec(paa: pInteger; {pointer to the first element of the vector}
                  i  : Integer;  {indices of the element}
                  n  : Integer;  {the dimension of the vector}
              var xx : Integer); {the value of element  i}

procedure negIvec(paa: pInteger; {pointer to the first element of the matrix}
                  n  : Integer); {the dimensions of the matrix}

procedure maxIvec(paa  : pInteger; {pointer to the first element of the matrix}
                  n    : Integer;  {the dimensions of the matrix}
              var xmax : integer); {largest element}

procedure incIvec(paa: pInteger;  {pointer to the first element of the matrix}
                  ii : integer;   {index of the element to be incremented}
                  n  : Integer);  {the dimensions of the matrix}

{procedure for solving a nonlinear equation with the (modified)regula falsi-method}
procedure RegFa(pPar      : TpReArr;    Func : TgFunc; a0,b0 : single;
                epsx,epsy : single;     nmax : integer;
                var xn    : single; var errc : integer);
procedure CheckDecimalPointInGrid(pGrid: TpGrid; key: word; col,row: integer; dp: char);

implementation

const
 CRwidth = 16;     {width (and height) of a small color rectangle}
 CRspace = 4;      {width of space between color rectangles}

procedure ClearIntri(pIntri : TpIntri);
begin
  pIntri^.indx := 0;
  pIntri^.ix := 0;
  pIntri^.iy := 0;
  pIntri^.no := 0;
end;

function tan(angle : single): single;
{calculate the tan of an angle}
var
  sina : single;
  cosa : single;
begin
  sina := sin(angle);
  cosa := cos(angle);
  if (abs(cosa) > 1.e-30) then begin
    tan := sina/cosa;
  end else begin
    if (sina > 0) then tan :=  1.e30
    else               tan := -1.e30
  end;
end;

procedure TRearr.CreArr(nArr : Integer);
{creates the array = reserves space}
var
  pArr : pSingle;       {pointer to the array (=itself)}
begin
{ pArr := nil;}
  if (nArr > 0) then begin
    getmem(pArr,nArr*Sizeof(Single));
    pArr_r := pArr;      {save pointer to itself}
    nArr_r := nArr;      {save number of elements}
  end else begin
    pArr_r := nil;       {no array}
    nArr_r := 0;         {no elements}
  end;
end;

procedure TRearr.DelArr;
{free the space reserved for the array}
begin
  if (pArr_r <> nil) then
    freemem(pArr_r,nArr_r*Sizeof(Single));
end;

procedure TRearr.Putval(i: Integer; xyz:Single);
{put xyz to array as entry number i}
var
  pArr   : pSingle;   {pointer to elements in the array}
begin
  {put in the array only if array exists, and i is within dimensions}
  if (pArr_r <> nil) and (i>0) and (i<= nArr_r) then begin
    pArr := pArr_r;                  {copy pointer to to local}
    if (i > 1) then inc(pArr,i-1);   {pointer to element i}
    pArr^ := xyz;                    {put xyz to array}
  end else begin
    {do nothing, if error}
  end;
end;

procedure TRearr.Getval(i: Integer; var xyz:Single);
{get xyz from array as entry number i}
var
  pArr   : pSingle;   {pointer to elements in the array}
begin
  {put in the array only if array exists, and i is within dimensions}
  if (pArr_r <> nil) and (i>0) and (i<= nArr_r) then begin
    pArr := pArr_r;                  {copy pointer to to local}
    if (i > 1) then inc(pArr,i-1);   {pointer to element i}
    xyz := pArr^;                    {put xyz to array}
  end else begin
    xyz := 0;                        {zero, if error (?)}
  end;
end;

procedure TRearr.Clear;
{clear the array}
var
  ii     : integer;   {index}
  pArr   : pSingle;   {pointer to elements in the array}
begin
  {put in the array only if array exists, and i is within dimensions}
  if (pArr_r <> nil) then begin
    pArr := pArr_r;                  {copy pointer to to local}
    for ii := 1 to nArr_r do begin
      pArr^ := 0;                    {put xyz to array}
      inc(pArr);
    end;
  end else begin
    {do nothing, if error}
  end;
end;

procedure TReArr.MaxMin(var  rmax, rmin : single);
{find the largest and smallest entries in the array
 rmax   the largest entry
 rmin   the smallest entry
 }
 var
   i    : integer;   {index, counter}
   pArr : pSingle;   {pointer to an element in the array}
 begin
   if (pArr_r <> nil) and (nArr_r > 0) then begin   {there is an array (well...)}
     pArr := pArr_r;      {copy pointer to local}
     rmax := pArr^;       {initialize max}
     rmin := pArr^;       {initialize min}
     if (nArr_r > 1) then begin
       for i:=1 to nArr_r-1 do begin
         inc(pArr);         {pointer to next element}
         if (pArr^ > rmax) then rmax := pArr^;
         if (pArr^ < rmin) then rmin := pArr^;
       end;
     end;
   end else begin
     rmax := 0;
     rmin := 0;
   end;
 end;

function  TRearr.NumberOfElements: integer;
{get the number of elements}
begin
  NumberOfElements := nArr_r;
end;

procedure TRearr.CopyFromArray(pFrom : TpRearr);
{copy from another array as many as can be copied}
var
  apu     : single;   {temporary}
  ii      : integer;  {index}
  nFrom   : integer;  {no of elements in array from which is copied}
  nCopied : integer;  {no of elements copied = min}
  pArr    : pSingle;  {pointer to an element in the array}
begin
  nFrom := pFrom^.NumberOfElements;  {get no of elements in another array}
  if (nFrom < nArr_r) then nCopied := nFrom
  else                     nCopied := nArr_r;
  if (nCopied > 0) then begin
    pArr := pArr_r;                  {pointer to first element}
    for ii:=1 to nCopied do begin
      pFrom^.GetVal(ii,apu);
      pArr^ := apu;
      inc(pArr);
    end;
  end;
end;

procedure TRearr.GetPtr(var pArr: pSingle);
{get pointer to the array}
begin
  pArr := pArr_r;
end;

procedure putImat(paa: pInteger; {pointer to the first element of the matrix}
                  i,j: Integer;  {indices of the element}
                  m,n: Integer;  {the dimensions of the matrix}
                  xx : Integer); {the value to be put into the matrix}
{putImat copies the value of the INTEGER xx to the location i,j of tha matrix
        with dimensions (m rows * n columns)}
var
  pij: pInteger;  {pointer to the element i,j}
begin
  {some checks, just to be sure}
  if (i>0) and (i<=m) and (j>0) and (j<=n) then begin
    pij := paa;
    inc(pij,n*(i-1)+j-1);
    pij^:= xx;
  end;
end;

procedure getImat(paa: pInteger;{pointer to the first element of the matrix}
                 i,j: Integer;  {indices of the element}
                 m,n: Integer;  {the dimensions of the matrix}
             var xx : Integer); {the value to get the value of aa(i,j)}
{getmat copies the value of the variable in the location i,j of the matrix
        to the INTEGER xx
        The dimensions of the matrix are (m rows * n columns)}
var
  pij: pInteger;  {pointer to the element i,j}
begin
  {some checks, just to be sure}
  if (i>0) and (i<=m) and (j>0) and (j<=n) then begin
    pij := paa;
    inc(pij,n*(i-1)+j-1);
    xx := pij^;
  end;
end;

procedure putIvec(paa: pInteger; {pointer to the first element of the matrix}
                  i  : Integer;  {indices of the element}
                  n  : Integer;  {the dimensions of the matrix}
                  xx : Integer); {the value to be put into the matrix}
{putIvec copies the value of the INTEGER xx to the location i of the vector
        with dimension n }
var
  pij: pInteger;  {pointer to the element i,j}
begin
  {some checks, just to be sure}
  if (i>0) and (i<=n) then begin
    pij := paa;
    inc(pij,i-1);
    pij^:= xx;
  end;
end;

procedure negIvec(paa: pInteger; {pointer to the first element of the matrix}
                  n  : Integer);  {the dimensions of the matrix}
{negIvec negates the values in the integer array with dimension n }
var
  i  : Integer;   {index}
  pij: pInteger;  {pointer to the element i,j}
begin
  pij := paa;     {pointer to first element}
  if (n > 0) then begin
    for i:=1 to n do begin
      pij^ := -pij^;
      inc(pij);
    end;
  end;
end;

procedure maxIvec(paa  : pInteger; {pointer to the first element of the matrix}
                  n    : Integer;  {the dimensions of the matrix}
              var xmax : integer); {largest element}
{maxIvec finds the largest element in the array}
var
  i  : Integer;   {index}
  pij: pInteger;  {pointer to the element i,j}
begin
  pij := paa;                {pointer to first element}
  if (n > 0) then  begin
    xmax := pij^;            {initialize with the first element}
    if (n > 1) then begin    {more than one element}
      for i:=2 to n do begin
        inc(pij);            {pointer to next element}
        if (pij^ > xmax) then xmax := pij^;
      end;
    end;
  end else begin
    xmax := 0;               {just some value}
  end;
end;


procedure getIvec(paa: pInteger;{pointer to the first element of the vector}
                  i  : Integer;  {indices of the element}
                  n  : Integer;  {the dimension of the vector}
              var xx : Integer); {the value of element  i}
{getvec copies the value of the element i to xx}
var
  pij: pInteger;  {pointer to the element i}
begin
  {some checks, just to be sure}
  if (i>0) and (i<=n) then begin
    pij := paa;
    inc(pij,i-1);
    xx := pij^;
  end;
end;

procedure incIvec(paa: pInteger;  {pointer to the first element of the matrix}
                  ii : integer;   {index of the element to be incremented}
                  n  : Integer);  {the dimensions of the matrix}
{ increments the value of element ii in the integer array with dimension n }
var
  pij: pInteger;  {pointer to the element i,j}
begin
  {some checks, just to be sure}
   if (ii>0) and (ii<=n) then begin
   pij := paa;
   inc(pij,ii-1);
   inc(pij^);
  end;
end;

procedure RegFa(pPar      : TpReArr;    Func : TgFunc; a0,b0 : single;
                epsx,epsy : single;     nmax : integer;
                var xn    : single; var errc : integer);
 {solves a nonlinear equation with the modified regula falsi,
  when the brackets of the roots are given
  pPar    pointer to the array of parameters
  FuncO   object containing the function to be solved
  a0,b0   the bracket
  epsx    accepted error in x (max bracket)
  epsy    accepted error in y (max function abs value)
  xn      the solution
  errc    error flag
  }
  var
    fa,fb  : single;   {function value at brackets}
    fn     : single;   {new function value}
    fo     : single;   {old function value}
    it     : integer;  {iteration counter}
    xa,xb  : single;   {new brackets}
  begin
    {function value at brackets}
    fa := Func(pPar,a0);
    fb := Func(pPar,b0);
    fo := fa;                        {initialize old value}
    {check that brackets are really brackets}
    if (fa*fb <= 0) then begin
      xa := a0; xb := b0;            {copy brackets to locals}
      for it:=1 to nmax do begin     {at most nmax iterations}
        xn := (fb*xa-fa*xb)/(fb-fa); {new x}
        fn := Func(pPar,xn);         {function value at new x}
        if (fn*fa <= 0) then begin   {could xn,xa be new brackets}
          xb := xn;
          fb := fn;
          if (fo*fn > 0) then fa := 0.5*fa;
        end else begin
          xa := xn;
          fa := fn;
          if (fo*fn > 0) then fb := 0.5*fb;
        end;
        fo := fn;                    {save old function value}
        {converged ?}
(*        showmessage(floattostr(xn)+'  '+floattostr(fa)+'  '+floattostr(fb));*)
        if (abs(xb-xa) < epsx) or (abs(fn) < epsy) then begin
          errc := 0;                 {no error}
          break;                     {ready, quit}
        end else begin
          errc := 2;                 {satisfactory solution not found,yet}
        end;
      end
    end else begin  {not brackets}
     {select the end with smaller function abs value}
     if (abs(fa) < abs(fb)) then xn := a0
     else                        xn := b0;
     errc := 1;           {set error flag}
    end;
  end;

procedure CheckDecimalPointInGrid(pGrid: TpGrid; key: word; col,row: integer; dp: char);
{check (and correct) the decimal point, when entering text into a strig grid
pGrid    pointer to the string grid
key      the key pressed, may be a decimal point
col,row  column and row in the grid
dp       the correct decimal point character ( . or , }
var
  idp     : word;     {decimal point as word (integer)}
  ii      : integer;  {index}
  len     : integer;  {length of text}
  line    : string;   {temporary}
  text    : string;   {temporary}
begin
  {check decimal point}
  if (key = 190) or (key = 188) then begin   {'.' or ',' assumed to be decimal point}
    if (dp = #190) then idp := 190 else idp := 188;   {decimal point as word (integer)}
    if (key <> idp) then begin                         {not correct decimal point}
      text := pGrid^.cells[col,row];
      len := length(text);
      line := '';
      if (len > 1) then begin
        for ii := 1 to len do begin
          if (text[ii] = '.') or (text[ii] = ',') then line := line+dp
          else line := line+text[ii];
        end;
      end;
      pGrid^.cells[col,row] := line;
      {send an "enter"-key press, to select the cell (remove the color)}
      keybd_event(VK_SHIFT, 0, 0, 0);
      keybd_event(13, 0, 0, 0);
      keybd_event(VK_SHIFT, 0, KEYEVENTF_KEYUP, 0);
    end;
  end;
end;

procedure GetCRsize(var CRw,CRs : integer);
{needed in phasor.pas}
begin
  CRw := CRwidth;
  CRs := CRspace;
end;

procedure ColorInitialize(pImage : TpImage);
{draw colors in the image for selecting the colors, etc
 pImage  pointer to the image}
var
  ii,jj,kk : integer;
  ix,iy    : integer;
begin
  pImage^.width := 4*CRwidth+5*CRspace;
  pImage^.height := pImage^.width;
  pImage^.top := CRspace;
  pImage^.left := CRspace;
  {a rectangle around the whole image}
  pImage^.canvas.pen.color := clBlack;
  pImage^.canvas.brush.style := bsClear;
  pImage^.canvas.rectangle(0,0,pImage^.width,pImage^.height);
  {the color rectangles}
  pImage^.canvas.brush.style := bsSolid;
  for ii := 1 to 4 do begin
    for jj := 1 to 4 do begin
      kk := (ii-1)*4+jj;        {color index}
      ix := CRspace+(ii-1)*(CRwidth+CRspace);
      iy := CRspace+(jj-1)*(CRwidth+CRspace);
      pImage^.canvas.pen.color := gColor[kk];
      pImage^.canvas.brush.color := gColor[kk];
      pImage^.canvas.rectangle(ix,iy,ix+CRwidth,iy+CRwidth);
    end;
  end;
end;

end.
