unit voltphas;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Phasor, Menus, routines, skemadef, utildef, CurrPhas,
  Clipbrd;

procedure ShowVoltPhasors(ipComp : longint); far;  {show currents using phasors}
procedure RemoveBusphasor (ipComp : longint); far; {remove phasor of a bus (when bus removed)}
procedure RemoveVoltPhasors;                       {used in skemadef.pas}
procedure UpdateVoltPhasors;                       {used in skemadef.pas}

type
  TVoltPhasorForm = class(TForm)
    VoltPhasorImg: TImage;
    VoltageLabel: TLabel;
    ResetBut: TButton;
    DecBut: TButton;
    IncBut: TButton;
    OnOffPanel: TPanel;
    OnOffBox: TCheckBox;
    DeleteBut: TButton;
    ColorPanel: TPanel;
    ColorImage: TImage;
    IDImage: TImage;
    VoltEdit: TEdit;
    VoltSeqImage: TImage;
    ResetSeqBut: TButton;
    DecSeqBut: TButton;
    IncSeqBut: TButton;
    VoltSeqLabel: TLabel;
    VoltSeqEdit: TEdit;
    VoltMenu: TMainMenu;
    FileItem: TMenuItem;
    ExitItem: TMenuItem;
    ViewItem: TMenuItem;
    ButItem: TMenuItem;
    PhaseItem: TMenuItem;
    SequenceItem: TMenuItem;
    BothItem: TMenuItem;
    OptionItem: TMenuItem;
    PNitem: TMenuItem;
    PPItem: TMenuItem;
    PhasorDialog: TSaveDialog;
    BitmapItem: TMenuItem;
    CopyItem: TMenuItem;
    ClipPopMenu: TPopupMenu;
    BmpItem: TMenuItem;
    WmfItem: TMenuItem;
    CancelItem: TMenuItem;
    procedure FormHide(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ExitItemClick(Sender: TObject);
    procedure ButItemClick(Sender: TObject);
    procedure PhaseItemClick(Sender: TObject);
    procedure SequenceItemClick(Sender: TObject);
    procedure BothItemClick(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure OnOffBoxMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure OnOffBoxMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure DeleteButClick(Sender: TObject);
    procedure ColorImageMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormDeactivate(Sender: TObject);
    procedure VoltPhasorImgMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure VoltPhasorImgMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure VoltPhasorImgMouseMove(Sender: TObject; Shift: TShiftState;
      X, Y: Integer);
    procedure IncButClick(Sender: TObject);
    procedure DecButClick(Sender: TObject);
    procedure ResetButClick(Sender: TObject);
    procedure IncSeqButClick(Sender: TObject);
    procedure DecSeqButClick(Sender: TObject);
    procedure ResetSeqButClick(Sender: TObject);
    procedure VoltSeqImageMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure VoltSeqImageMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure VoltSeqImageMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PNitemClick(Sender: TObject);
    procedure PPItemClick(Sender: TObject);
    procedure BitmapItemClick(Sender: TObject);
    procedure BmpItemClick(Sender: TObject);
    procedure CopyItemClick(Sender: TObject);
    procedure WmfItemClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  VoltPhasorForm: TVoltPhasorForm;
  VoltGrid      : TPhasorGrid;     {table for the voltage values, etc}

implementation

uses Imagopas, PQRelay, RelCalc;

{$R *.DFM}
const
  editmarg = 2;  {margin under and above of the edit box showing cursor position}
  botmarg = 44;  {bottom margin on form (includes menu bar height ?)}
  pActGrid : TpPhasorGrid = nil;

var
  CRwidth  : integer;         {width (and height) of a small color rectangle}
  CRspace  : integer;         {width of space between color rectangles}
{ VoltGrid : TPhasorGrid;     {table for the current values, etc}
  SeqGrid  : TPhasorGrid;     {table for the symm.component values of currents}

procedure TVoltPhasorForm.FormHide(Sender: TObject);
begin
  Imagoo.VoltPhasorBut.down := false;
end;

procedure TVoltPhasorForm.FormCreate(Sender: TObject);
{set the size etc of the grind and image}
var
  ii      : integer;   {index}
  ipu,ipv : integer;   {temporary}
begin
  {create the grid for the values of the currents (etc)}
  VoltGrid := TPhasorGrid.create(VoltPhasorForm);
  VoltGrid.parent := VoltPhasorForm;
  VoltGrid.InitializeBasics;
  VoltGrid.InitializeMore(@OnOffPanel,@ColorPanel,@OnOffBox,@DeleteBut,@VoltPhasorImg,
                          @IDImage,@VoltEdit,@VoltageLabel,@VoltPhasorForm,@PhasorDialog,nil,nil);
  VoltGrid.pSelf_p := @VoltGrid;
  VoltGrid.Left := 232;
  VoltGrid.Top := 24;
  VoltGrid.name := 'VoltGrid';
//VoltGrid.visible := true;    {later..}
  {create the grid for the values of the sequence currents (etc)}
  SeqGrid := TPhasorGrid.create(VoltPhasorForm);
  SeqGrid.parent := VoltPhasorForm;
  SeqGrid.InitializeBasics;
  SeqGrid.InitializeMore(@OnOffPanel,@ColorPanel,@OnOffBox,@DeleteBut,@VoltSeqImage,
                          @IDImage,@VoltSeqEdit, @VoltSeqLabel,@VoltPhasorForm,@PhasorDialog,nil,nil);
  SeqGrid.pSelf_p := @SeqGrid;
  SeqGrid.pOther_p := @VoltGrid;
  VoltGrid.pOther_p := @SeqGrid;
  SeqGrid.Left := 232;
  SeqGrid.Top := 288;
  SeqGrid.name := 'SeqGrid';
  {show volt grid, but hide sequence grid and image, etc}
  VoltGrid.visible := true;
  SeqGrid.visible := false;
  VoltSeqImage.visible := false;
  VoltSeqLabel.visible := false;
  VoltSeqEdit.visible := false;
  ResetSeqBut.visible := false;
  IncSeqBut.visible := false;
  DecSeqBut.visible := false;
  left := Imagoo.width-width-8;   {position of the form wrt the main form}
  {set the (original) size of the form}
  {set the original size of the form}
  VoltPhasorForm.width := VoltGrid.left+VoltGrid.width+24;
  ipu := VoltGrid.top+VoltGrid.height+32;
  ipv := VoltEdit.top+VoltEdit.height+botmarg+2*editmarg;
  if (ipu > ipv) then  VoltPhasorForm.height := ipu
  else  VoltPhasorForm.height := ipv;
  {initialize the color selection image}
  {PQForm.}ColorInitialize(@ColorImage);  {in utildef}
  {PQForm.}GetCRsize(CRwidth,CRspace);
  ColorPanel.width := ColorImage.width+2*CRspace;
  ColorPanel.height := ColorPanel.width;
  ipu := VoltGrid.RowHeights[0]+VoltGrid.RowHeights[1];
  ColorPanel.top := VoltGrid.top+ipu+2*VoltGrid.GridLineWidth;
  ColorPanel.left := VoltGrid.left+VoltGrid.ColWidths[0]+2*VoltGrid.GridLineWidth;
  VoltGrid.unit_p := 'V';
  SeqGrid.unit_p := 'V';
  VoltGrid.ppActGrid_p := @pActGrid;
  SeqGrid.ppActGrid_p := @pActGrid;
  VoltGrid.VoltMode_p := PhaseNeutral;
  SeqGrid.VoltMode_p := PhaseNeutral;
  if (SetComp.VPhasor_dir <>'') then
    PhasorDialog.InitialDir := SetComp.VPhasor_dir;
  VoltEdit.text := '  Click a Bus';
  {add flag that form created}
  Imagoo.ReadyEdit.text := Imagoo.ReadyEdit.text+'V';
end;

procedure ShowVoltPhasors(ipComp : longint);
{show the voltage(s) of bus(es)using phasors, if allowed (button down)
 ipComp  pointer to the bus as integer}
var
  added  : boolean;
  ix,iy  : integer; {temporary (coordinates)}
  lbl    : string;  {label of the component}
  pComp  : TpComp;
  phphV  : boolean;  {phase-phase voltages in use}
  volts  : Tmultix;
begin
  if (Imagoo.VoltPhasorBut.down) then begin
    pComp := TpComp(ipComp);
    pComp^.GetLabel(lbl,ix,iy);
    phphV := VoltGrid.PhasePhaseVolt;
    {read voltages, in CurrPhas.pas}
    GetVoltages(ipComp,phphV,volts.u,volts.v,volts.w,volts.x,volts.y,volts.z);
    added := VoltGrid.ShowPhasors(ipComp, vRead, @volts, lbl,'');  {read from buses}
    if (added) then begin
      SeqGrid.ShowPhasors(ipComp, vCopy,nil,lbl,'');   {copy from VoltGrid}
      pComp^.SetPWR(true);                          {set flag}
    end;  
    VoltPhasorForm.VoltEdit.text := '';
  end;
  {put bus (upstr. or downstr) to relay calculator, if asked for}
  if (RelayCalcForm.UpstreamBusBut.down) then begin
    RelayCalcForm.SetUpstreamBus(ipComp);
  end else if (RelayCalcForm.DownstreamBusBut.down) then begin
    RelayCalcForm.SetDownstreamBus(ipComp);
  end;
  {add to list of forbidden buses of relay calculator = bus that must not be between up- and downstr. buses}
  if (RelayCalcForm.ForbiddenBusBut.down) then begin
    RelayCalcForm.AddForbiddenBus(ipComp);
  end;
end;

procedure RemoveBusphasor(ipComp : longint);
{remove (delete) a bus from the grid of CT:s for phasor display
 ipComp  pointer to the current trafo, as integer}
var
  row : integer;  {the row of the identifier in the grid}
begin
  if (VoltGrid.isThere(ipComp,row,'RemoveBusphasor')) then begin
    VoltGrid.DeleteCTphasor(row);
    SeqGrid.DeleteCTphasor(row);
    VoltGrid.DrawPhasors;
  end;
end;

procedure RemoveVoltPhasors;
{clear the grid, tables and phasor picture}
begin
  VoltGrid.RemoveAllPhasors;
  SeqGrid.RemoveAllPhasors;
  VoltPhasorForm.visible := false;  
end;

procedure UpdateVoltPhasors;
{update the phasors (after some new calculation), needed in Skemadef.pas}
var
  volts  : Tmultix;   {voltages = magnitude and phase (in degrees)}
  ii     : integer;   {index}
  ipComp : longint;   {pointer to the current trafos, as integer}
  nVT    : integer;   {number of voltage trafos (buses)}
  phphV  : boolean;   {phase-phase voltages used}
begin
  {read the currents from the current trafos in the grid of the graph}
  nVT := VoltGrid.NoOfItems;         {number of current trafos}
  if (nVT > 0) then begin
    for ii := 1 to nVT do begin      {all current trafos}
      ipComp := VoltGrid.GetIp(ii);
      phphV := VoltGrid.PhasePhaseVolt;
      {read voltages}
      GetVoltages(ipComp,phphV,volts.u,volts.v,volts.w,volts.x,volts.y,volts.z);
      VoltGrid.UpdatePhasors(vRead,@volts,ii);     {update the phasor graphs}
    end;
    SeqGrid.UpdatePhasors(vCopy,nil,0);            {update also the seq. graph}
  end;
(*
  VoltGrid.UpdatePhasors(vRead);
  SeqGrid.UpdatePhasors(vCopy);
*)
end;

procedure TVoltPhasorForm.ExitItemClick(Sender: TObject);
begin
  visible := false;
end;

procedure TVoltPhasorForm.ButItemClick(Sender: TObject);
begin
  ButItem.checked := not ButItem.checked;
  IncBut.visible := ButItem.checked;
  DecBut.visible := ButItem.checked;
  ResetBut.visible := ButItem.checked;
  IncSeqBut.visible := ButItem.checked;
  DecSeqBut.visible := ButItem.checked;
  ResetSeqBut.visible := ButItem.checked;
  VoltEdit.visible := ButItem.checked;
  VoltSeqEdit.visible := ButItem.checked;
end;

procedure TVoltPhasorForm.PhaseItemClick(Sender: TObject);
begin
  PhasorDialog.filter := FilterBoth; {can save as .bmp and as *.wmf}
  PhaseItem.checked := true;
  VoltGrid.view_p := phase;
  SeqGrid.view_p := phase;
  {show all items connected to phase components}
  VoltGrid.visible := true;
  VoltPhasorImg.visible := true;
  VoltageLabel.visible := true;
  If (ButItem.checked) then begin
    VoltEdit.visible := true;
    ResetBut.visible := true;
    IncBut.visible := true;
    DecBut.visible := true;
  end;
  {hide all connected to sequence components}
  SeqGrid.visible := false;
  VoltSeqImage.visible := false;
  VoltSeqLabel.visible := false;
  VoltSeqEdit.visible := false;
  ResetSeqBut.visible := false;
  IncSeqBut.visible := false;
  DecSeqBut.visible := false;
  {set the height of the form (change, eventually)}
  height := VoltPhasorImg.height+VoltEdit.height+botmarg+2*editmarg;
end;

procedure TVoltPhasorForm.SequenceItemClick(Sender: TObject);
begin
  PhasorDialog.filter := FilterBoth; {can save as .bmp and as *.wmf}
  SequenceItem.checked := true;
  VoltGrid.view_p := seq;
  SeqGrid.view_p := seq;
  {move the sequence items to top}
  VoltSeqImage.top := 0;
  VoltSeqLabel.top := VoltSeqImage.top;
  SeqGrid.top := VoltSeqImage.top+24;
  VoltSeqEdit.top := VoltSeqImage.top+VoltSeqImage.height+editmarg;
  ResetSeqBut.top := VoltSeqImage.top;
  IncSeqBut.top := ResetSeqBut.top;
  DecSeqBut.top := ResetSeqBut.top;
  {show all items connected to sequence components}
  SeqGrid.visible := true;
  VoltSeqImage.visible := true;
  VoltSeqLabel.visible := true;
  If (ButItem.checked) then begin
    VoltSeqEdit.visible := true;
    ResetSeqBut.visible := true;
    IncSeqBut.visible := true;
    DecSeqBut.visible := true;
  end;
  {hide all connected to sequence components}
  VoltGrid.visible := false;
  VoltPhasorImg.visible := false;
  VoltageLabel.visible := false;
  VoltEdit.visible := false;
  ResetBut.visible := false;
  IncBut.visible := false;
  DecBut.visible := false;
  {set the height of the form (change, eventually)}
  height := VoltSeqImage.height+VoltSeqEdit.height+botmarg+2*editmarg;
end;

procedure TVoltPhasorForm.BothItemClick(Sender: TObject);
begin
  PhasorDialog.filter := FilterBmp; {can save only as .bmp}
  BothItem.checked := true;
  VoltGrid.view_p := both;
  SeqGrid.view_p := both;
  {set the form height, if not already set}
  if not(VoltPhasorImg.visible and VoltSeqImage.visible) then begin
    if (height < Imagoo.height div 2) then height := 2*height-botmarg
    else height := Imagoo.height;
  end;
  {show all items connected to phase components}
  VoltGrid.visible := true;
  VoltPhasorImg.visible := true;
  VoltageLabel.visible := true;
  If (ButItem.checked) then begin
    VoltEdit.visible := true;
    ResetBut.visible := true;
    IncBut.visible := true;
    DecBut.visible := true;
  end;
  {show all items connected to sequence components}
  SeqGrid.visible := true;
  VoltSeqImage.visible := true;
  VoltSeqLabel.visible := true;
  If (ButItem.checked) then begin
    VoltSeqEdit.visible := true;
    ResetSeqBut.visible := true;
    IncSeqBut.visible := true;
    DecSeqBut.visible := true;
  end;
end;

procedure TVoltPhasorForm.FormResize(Sender: TObject);
{resize the images and move the grids etc. correspondingly}
begin
  VoltGrid.FormResizeUpper(@VoltPhasorForm);
  SeqGrid.FormResizeLower(@VoltPhasorForm);
  ResetSeqBut.top := VoltSeqImage.top;
  IncSeqBut.top := ResetSeqBut.top;
  DecSeqBut.top := ResetSeqBut.top;

end;

procedure TVoltPhasorForm.OnOffBoxMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
{complete the change of the status of the show/not flag of the selected variable}
begin
  OnOffPanel.visible := false;
  if (pActGrid <> nil) then begin
    pActGrid^.SetFocus;
    pActGrid^.DrawPhasors;
  end;
end;

procedure TVoltPhasorForm.OnOffBoxMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
{change the status of the show/not flag of the selected variable}
begin
  OnOffBox.checked := not OnOffBox.checked;
  if (OnOffBox.checked) and (pActGrid <> nil) then
    pActGrid^.Cells[pActGrid^.actcol_p,pActGrid^.actrow_p] := '1'
  else pActGrid^.Cells[pActGrid^.actcol_p,pActGrid^.actrow_p] := '0';
end;

procedure TVoltPhasorForm.DeleteButClick(Sender: TObject);
{delete the "active" current trafo in the list, update phasor graph}
const
  row : integer = 1;
begin
  row := tag;
  VoltGrid.DelButClick(row);
  SeqGrid.DelButClick(row);
end;

procedure TVoltPhasorForm.ColorImageMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
{get color index from X and Y}
begin
  if (pActGrid <> nil) then pActGrid^.ColorImageMouseUp(X,Y);
end;

procedure TVoltPhasorForm.FormDeactivate(Sender: TObject);
begin
  OnOffPanel.visible := false;
  DeleteBut.visible := false;
  ColorPanel.visible := false;
end;

procedure TVoltPhasorForm.VoltPhasorImgMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
{prepare to move an identifier, if cursor on the identifier}
begin
  {save position etc. for moving the identifier, if cursor on an identifier}
  if (Button = mbLeft) then
    VoltGrid.StartIdentifierIf(x,y);
end;

procedure TVoltPhasorForm.VoltPhasorImgMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
{move the identifier to the mouse-up-point}
begin
  if IDimage.visible then begin
    {move the identifier}
    VoltGrid.MoveIdentifier(x,y);
    IDimage.visible := false;
  end;

end;

procedure TVoltPhasorForm.VoltPhasorImgMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
  {show the Voltage corresponding to the cursor position}
  if (VoltGrid.NoOfItems > 0) then
    VoltGrid.CursorCurrent(x,y)
  else
    VoltEdit.text := '  Click a Bus';
  {show a rectangle around ID-number, if moving}
  if (IDimage.visible) then begin
    IDimage.left := VoltPhasorImg.left+x-6;
    IDimage.top := VoltPhasorImg.top+y-6;
  end;

end;

procedure TVoltPhasorForm.IncButClick(Sender: TObject);
{increase the scale by one step}
begin
  inc(VoltGrid.modScale_p);
  VoltGrid.DrawPhasors;
end;

procedure TVoltPhasorForm.DecButClick(Sender: TObject);
{decrease the scale by one step}
begin
  if (VoltGrid.maxScale_p > 1.5) then dec(VoltGrid.modScale_p);
  VoltGrid.DrawPhasors;
end;

procedure TVoltPhasorForm.ResetButClick(Sender: TObject);
{reset the scale}
begin
  VoltGrid.modScale_p := 0;
  VoltGrid.DrawPhasors;
end;

procedure TVoltPhasorForm.IncSeqButClick(Sender: TObject);
{increase the scale by one step}
begin
  inc(SeqGrid.modScale_p);
  SeqGrid.DrawPhasors;
end;

procedure TVoltPhasorForm.DecSeqButClick(Sender: TObject);
{decrease the scale by one step}
begin
  if (SeqGrid.maxScale_p > 1.5) then dec(SeqGrid.modScale_p);
  SeqGrid.DrawPhasors;
end;

procedure TVoltPhasorForm.ResetSeqButClick(Sender: TObject);
{reset the scale}
begin
  SeqGrid.modScale_p := 0;
  SeqGrid.DrawPhasors;
end;

procedure TVoltPhasorForm.VoltSeqImageMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
{prepare to move an identifier, if cursor on the identifier}
begin
  {save position etc. for moving the identifier, if cursor on an identifier}
  if (Button = mbLeft) then
    SeqGrid.StartIdentifierIf(x,y);
end;

procedure TVoltPhasorForm.VoltSeqImageMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
  {show the current corresponding to the cursor position}
  SeqGrid.CursorCurrent(x,y);
  {show a rectangle around ID-number, if moving}
  if (IDimage.visible) then begin
    IDimage.left := VoltSeqImage.left+x-6;
    IDimage.top := VoltSeqImage.top+y-6;
  end;

end;

procedure TVoltPhasorForm.VoltSeqImageMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
{move the identifier to the mouse-up-point}
begin
  if IDimage.visible then begin
    {move the identifier}
    SeqGrid.MoveIdentifier(x,y);
    IDimage.visible := false;
  end;
end;

procedure TVoltPhasorForm.PNitemClick(Sender: TObject);
begin
  {show phase-ground voltages}
  PNitem.checked := true;
  VoltGrid.VoltMode_p := PhaseNeutral;
  SeqGrid.VoltMode_p := PhaseNeutral;
  VoltGrid.PhaseNeutralID;
  UpdateVoltPhasors;
  VoltageLabel.caption := ' - n  Voltage phase components';
  VoltSeqLabel.caption := ' - n  Voltage sequence components';
end;

procedure TVoltPhasorForm.PPItemClick(Sender: TObject);
begin
  {show phase-phase voltages}
  PPitem.checked := true;
  VoltGrid.VoltMode_p := PhasePhase;
  SeqGrid.VoltMode_p := PhasePhase;
  VoltGrid.PhasePhaseID;
  UpdateVoltPhasors;
  VoltageLabel.caption := ' -   Voltage phase components';
  VoltSeqLabel.caption := ' -   Voltage sequence components';
end;

procedure TVoltPhasorForm.BitmapItemClick(Sender: TObject);
{save diagram as bitmap}
var
  DirName     : string;
  FormImage   : TBitmap;    {for saving the whole form as a bitmap}
begin
  if (PhasorDialog.execute) then begin
    if (PhasorDialog.FilterIndex = 3) then begin  {save as a wmf-file}
      if (PhaseItem.checked) then begin           {draw phasors of phase variables}
        VoltGrid.DrawWmfDiagram(PhasorDialog.Filename);
      end else if (SequenceItem.checked) then begin {draw sequence variables}
        SeqGrid.DrawWmfDiagram(PhasorDialog.Filename);
      end;
    end else begin                                {save as a bitmap or as a Jpeg}
      FormImage := VoltPhasorForm.getFormImage;
      if (PhasorDialog.FilterIndex = 1) then begin {save as a bitmap}
        FormImage.savetofile(PhasorDialog.Filename);
      end else begin                               {save as a jpeg-file}
        SaveJpegImage(@VoltPhasorForm, FormImage, PhasorDialog.FileName);  {..in routines.pas}
      end;
      FormImage.free;
    end;
    {save the directory for next time}
    DirName := ExtractFilePath(PhasorDialog.FileName);
    PhasorDialog.InitialDir := DirName;    {save the directory}
  end;
end;

procedure TVoltPhasorForm.BmpItemClick(Sender: TObject);
{copy phasors to clipboard as bitmap}
var
  FormImage   : TBitmap;         {for saving the form as a bitmap}
begin
  FormImage := VoltPhasorForm.getFormImage;          {picture of the form (as bitmap?)}
  Clipboard.assign(FormImage);                       {copy to clipboard}
  FormImage.free;
end;


procedure TVoltPhasorForm.CopyItemClick(Sender: TObject);
{copy phasors to clipboard as windows metafile}
begin
  ClipPopMenu.popup(left,top);
end;

procedure TVoltPhasorForm.WmfItemClick(Sender: TObject);
{copy phasors to clipboard as windows metafile}
var
  FormImage   : TBitmap;         {for saving the form as a bitmap}
  MetaCanvas  : TMetafileCanvas; {canvas for saving graph as*.wmf}
  PhasMetaf   : TMetafile;       {for *.wmf}
begin
  FormImage := VoltPhasorForm.getFormImage;          {picture of the form (as bitmap?)}
  PhasMetaf := TMetafile.Create;
  PhasMetaf.width := ClientWidth;                    {size = form size}
  PhasMetaf.height := ClientHeight;
  MetaCanvas := TMetafileCanvas.Create(PhasMetaf,0); {create it's canvas}
  MetaCanvas.draw(0,0,FormImage);                    {copy the image of the form}
  MetaCanvas.free;                                   {free, and move image to metafile}
  Clipboard.assign(PhasMetaf);                       {copy to clipboard}
  FormImage.free;
  PhasMetaf.free;

end;

end.
